# Introduction #

Welcome to PSyclone. PSyclone is a code generation and transformation
system that generates appropriate code for the PSyKAl code structure
developed in the GungHo project. It is also capable of working with
existing Fortran code.

Please see [psyclone.pdf](psyclone.pdf) in this directory (or on
[ReadTheDocs](http://psyclone.readthedocs.io)) for
more information. If you would prefer to build the documentation,
please see the [README](doc/README.md) file in the "doc" directory.

# Try it on Binder #

Some of the examples are available as Jupyter notebooks. These may
be launched using Binder from the links below. (Note that the first time
this is done, Binder has to construct a Container and install the necessary
software. This can  take several minutes. You can track its progress
by clicking the 'show' link next to the 'Build logs' heading.)

 * [![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/stfc/psyclone/master?filepath=examples%2Fnemo%2Feg4%2Fcopy_stencil.ipynb) Uses PSyclone's NEMO API to process some simple Fortran code, display the resulting PSyIR and then re-generate Fortran.

 * [![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/stfc/psyclone/master?filepath=examples%2Fgocean%2Feg1%2Fopenmp.ipynb) Uses PSyclone's GOcean API to process example code that conforms to the PSyKAl separation of concerns. Transformations are applied in order to fuse various loops before parallelising the result with OpenMP.
 
 * [![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/stfc/psyclone/master?filepath=examples%2Fgocean%2Feg1%2Fdag.ipynb) demonstrates the generation of a DAG for the PSy layer of the previous example.

# Tutorial #

The PSyclone tutorial may be found in the tutorial directory. Since part of
this takes the form of a series of Jupyter notebooks, it too may be launched on
[![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/stfc/psyclone/master?filepath=tutorial%2Fnotebooks%2Fintroduction.ipynb).

# Installation #

If you are reading this then you have presumably not already installed
PSyclone from the Python Package Index (https://pypi.python.org/pypi).
That being so, you can install this copy of PSyclone by doing:

    $ python setup.py install

or, if you do not have root access:

    $ python setup.py install --prefix /my/install/path

Alternatively, if you have pip:

    $ pip install .

For a user-local installation simply add the --user flag:

    $ pip install --user .

This installs the PSyclone modules in
~/.local/lib/pythonX.Y/site-packages (where X.Y is the version of
Python that you are using) and the 'psyclone' script in
~/.local/bin. Depending on your linux distribution, you may need to
add the latter location to your PATH.

# Structure #

Path                | Description
------------------- | -----------
bin/                | Top-level driver scripts for PSyclone and the PSyclone kernel tool
changelog      	    | Information on changes between releases
doc/           	    | Documentation source using Sphinx
examples/      	    | Simple examples
psyclone.pdf   	    | Generated documentation
README.md      	    | This file
README.gource  	    | Information on how to generate a gource video from the repository
README.uml     	    | Information on how to create UML class diagrams from the source using pyreverse
src/psyclone   	    | The Python source code
src/psyclone/tests/ | Unit and functional tests using pytest
tutorial/notebooks  | Tutorial using Jupyter notebooks
tutorial/practicals | Hands-on exercises using a local installation of PSyclone

# Status #

![Build Status](https://github.com/stfc/PSyclone/workflows/PSyclone%20tests%20and%20examples/badge.svg)

[![codecov](https://codecov.io/gh/stfc/PSyclone/branch/master/graph/badge.svg)](https://codecov.io/gh/stfc/PSyclone)

# Wrapper Libraries for Use with PSyclone

This directory contains [PSyData-API-based](
https://psyclone.readthedocs.io/en/stable/psy_data.html) wrapper libraries.
They enable PSyclone to provide transformations that will insert callbacks
to an external library at runtime. These callbacks allow third-party libraries
to access data structures at specified locations in the code for different
purposes, such as profiling, verification and extraction of argument values.
The wrapper libraries for the supported use cases are listed
[below](#structure).

## Installation

Wrapper libraries can be accessed from a clone of PSyclone repository
or a PSyclone [installation](
https://psyclone.readthedocs.io/en/stable/getting_going.html). In a
PSyclone installation the libraries may be found in ``share/psyclone/lib``
under your Python (or PSyclone, depending on the ``pip install`` options)
installation, see ["Getting Going"](
https://psyclone.readthedocs.io/en/stable/getting_going.html)
for possible locations.

If working with wrapper libraries from a PSyclone installation, it
is advisable to copy the entire ``lib`` directory to some convenient
location before building and using them. The provided ``Makefile``s
support the options to specify paths to the libraries and their
dependencies, see [below](#compilation) for more information.

## Structure

### PSyData base class

The file ``psy_data_base.jinja`` contains a Jinja template that can be used
by the [PSyData-API-based](
https://psyclone.readthedocs.io/en/stable/psy_data.html) wrapper libraries.
Full documentation on using this template is provided in the PSyclone
[Developer Guide](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#jinja). The
script ``process.py`` is used by the derived classes to process this
template. This script is processed with the help of the Shell script
``get_python.sh`` that finds an executable Python command.

There is a simple ``Makefile`` for compilation tests, but any
PSyData-API-based wrapper library (in any of the subdirectories here) will
process this template and compile it in its own directory. This allows each
library to exactly specify which data types are required. No library should
rely on a file compiled in this directory.

### [``extract``](./extract) directory

Contains code for extracting kernel data - i.e. all input and output
parameters of a kernel invocation.

### [``nan_test``](./nan_test) directory

Contains PSyData-API-based libraries for checking that input and output
parameters of kernels are valid numbers (i.e. not ``NaN`` or infinity).

### [``profiling``](./profiling) directory

Contains PSyData-API-based wrapper libraries for various profiling libraries
and stand-alone timing libraries.

### [``read_only``](./read_only) directory

Contains PSyData-API-based libraries for verifying at run time that
parameters declared as read-only in the PSyclone metadata are indeed not
changed in a subroutine.

## Compilation

Every PSyData-API-based wrapper library in the relevant subdirectory can
be compiled individually. Compilation requires a Fortran compiler and
Gnu Make. Individual libraries have other dependencies that are specified
in the relevant ``README.md`` documents.

All ``Makefile``s support the variables ``F90`` and ``F90FLAGS`` to specify
the compiler and compilation flags to use. ``F90`` defaults to the Gnu
Fortran compiler (``gfortran``), i.e. simply running ``make`` will build a
wrapper library with the version of ``gfortran`` available in a user's
environment. The compilation flags vary from one library to another (they
are usually set to debugging). As for the compilation of the [API examples](
https://psyclone.readthedocs.io/en/latest/examples.html#compilation), these
flags can be set to a different compiler. For instance,

```shell
F90=ifort F90FLAGS="-g -check bounds" make
```

Similar to compilation of the [examples](
https://psyclone.readthedocs.io/en/latest/examples.html#compilation), the
compiled library can be removed by running ``make clean``. There is also
the ``allclean`` target that removes the compiled wrapper library as well
as the compiled infrastructure library that the wrapper may
[depend on](#dependencies).

The compilation of wrapper libraries was tested with the Gnu and Intel
Fortran compilers, see [here](
https://psyclone.readthedocs.io/en/latest/examples.html#supported-compilers)
for the full list. Please let the PSyclone developers know if you have
problems using a compiler that has been tested or if you are working
with a different compiler.

### Dependencies

The majority of wrapper libraries use the [PSyData base class](
#psydata-base-class) Jinja templates and Python processing scripts. Their
location is set by the configurable variable ``PSYDATA_LIB_DIR``, which
is by default set to the relative path to the top-level `lib` directory.

**Note**, ``PSYDATA_LIB_DIR`` differs depending on whether the wrapper
libraries are compiled in a clone of PSyclone repository or in a PSyclone
[installation](#installation).

Compilation of ``extract``, ``nan_test``, ``read_only`` and some of the
profiling wrapper libraries depends on infrastructure libraries relevant
to the API they are used for. [GOcean API](
https://psyclone.readthedocs.io/en/stable/gocean1p0.html) uses the
[``dl_esm_inf`` library](https://github.com/stfc/dl_esm_inf) and
[LFRic (Dynamo 0.3) API](
https://psyclone.readthedocs.io/en/stable/dynamo0p3.html)
uses the LFRic infrastructure (see the linked documentation on how to
access and use the LFRic code). The locations of the respective
infrastructure libraries can be configured with the variables
``GOCEAN_INF_DIR`` and ``LFRIC_INF_DIR``, respectively (as said above,
to remove the compiled infrastructure libraries it is necessary to
run ``make allclean``). In addition, these wrapper libraries use
specific Jinja templates whose default location is set to the relative
path to the respective library directory but can also be configured with
the variable ``LIB_TMPLT_DIR``.

Some libraries require NetCDF for compilation. Installation of NetCDF is
described in details in the [hands-on practicals documentation](
https://github.com/stfc/PSyclone/tree/master/tutorial/practicals#netcdf-library-lfric-examples).

Profiling wrapper libraries that depend on external tools (for instance,
[dl_timer](./profiling/dl_timer/README.md) have specific variables that
configure paths to where these libraries are located in a user environment.

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2020-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# ``NaN``-Test Verification Libraries

This directory contains files related to testing all input and output
parameters of a kernel to make sure they are not [``NaN`` or infinite](
https://psyclone.readthedocs.io/en/latest/psy_data.html#nan-test),
i.e. checks at runtime that a read-only parameter of a subroutine is indeed
not changed in a kernel. There is a [PSyData base class](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#psydata-base-class)
as a Jinja template that can be used to simplify the creation of API-specific
wrapper libraries.

## NANTest base class

The file ``nan_test_base.jinja`` contains a Jinja template that is used
by the [GOcean ``dl_esm_inf``-](./dl_esm_inf/README.md) and [LFRic-specific](
./lfric/README.md) wrapper libraries. It implements the required [PSyData API](
https://psyclone.readthedocs.io/en/stable/psy_data.html) calls for
Fortran base types (scalar and arrays).
Full documentation to the Jinja implementation of a PSyData base class is
in the PSyclone [Developer Guide](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#jinja).
The script [``process.py``](./../README.md#psydata-base-class) is used by the
derived classes to process this template. There is a simple ``Makefile``
contained here for compilation tests, but each API-specific implementation (in
any of the subdirectories here) will process this template and compile it in
their own directory (to allow for the required data types to be supported).
The API-specific implementations do not link with the compiled version from
this directory.

## [``dl_esm_inf``](./dl_esm_inf) directory

Contains the ``NaN``-test, PSyData-API-based, wrapper library for the
``dl_esm_inf`` [GOcean API](
https://psyclone.readthedocs.io/en/latest/gocean1p0.html).

## [``lfric``](./lfric) directory

Contains the ``NaN``-test, PSyData-API-based, wrapper library for the
[LFRic (Dynamo 0.3) API](
https://psyclone.readthedocs.io/en/stable/dynamo0p3.html).

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2020-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# Libraries for Use with PSyclone Profiling

This directory contains wrapper libraries that can be used with [PSyclone
profiling API](
https://psyclone.readthedocs.io/en/stable/profiling.html#profiling). All
profiling-library interfaces use the the [PSyData API](
https://psyclone.readthedocs.io/en/stable/psy_data.html). The profiling
wrappers included in PSyclone are: ``template``,
``simple_timing``, ``dl_timer``, ``drhook``, ``nvidia`` and
``lfric_timer``. the overview is given below (for more information please
refer to the linked individual ``README.md`` documents).

## Profiling Wrappers

### [``template``](./template)

This is a very simple example library that just prints the name of the
subroutines used (e.g. ``ProfileStart``) and name of the module and region.
It uses the ``ProfileData`` variables to make the module and region name
available in the ``ProfileEnd`` call.

Detailed building and linking instructions are in
[``template/README.md``](./template/README.md).

### [``simple_timing``](./simple_timing)

This is a simple, stand-alone library that measures the real time of
a region, and prints a summary at the end. It is **NOT thread-safe**.
The ``ProfileData`` type is used to store module name and region,
and time accumulators.

Detailed building and linking instructions are in
[``simple_timing/README.md``](./simple_timing/README.md).

Example output:

```
    ===========================================
     module::region                                         count           sum                     min             average                 max
     psy_inputoutput::eliminate_one_node_islands_code           1     0.128906250             0.128906250             0.128906250             0.128906250    
     psy_time_step_mod::swlon_adjust_code                      11      1.19921875             0.105468750             0.109019883             0.113281250    
     psy_time_step_mod::swlon_code                             11      4.38281250             0.394531250             0.398437500             0.406250000    
     psy_time_step_mod::swlon_update_code                      11      1.86718750             0.167968750             0.169744313             0.171875000    
     psy_time_step_mod::swlat_adjust_code                      11      1.23828125             0.109375000             0.112571023             0.117187500    
     psy_time_step_mod::swlat_code                             11      4.87890625             0.437500000             0.443536937             0.445312500    
     psy_time_step_mod::swlat_update_code                      11      1.87500000             0.167968750             0.170454547             0.179687500    
     ===========================================
```

### [``dl_timer``](./dl_timer)

This is a wrapper library that maps the [PSyclone profiling API](
https://psyclone.readthedocs.io/en/stable/profiling.html#profiling) to the
dl_timer API. A copy of dl_timer can be downloaded from
https://bitbucket.org/apeg/dl_timer.

The PSyclone dl_timer wrapper library uses the ``ProfileData`` type and
dl_timer's timer_register function to store the module/region name and
the index used by dl_timer. This library is **thread-safe**.

Detailed building and linking instructions are in [``dl_timer/README.md``](
./dl_timer/README.md).

Example output:

```
    =============================== Timing report ===============================
    Timed using POSIX timer. Units are seconds.
    Reported resolution =  0.1000E-08 (s)
    Effective clock granularity =  0.25997E-07 (s)
    Measured systematic error in dl_timer API =  0.37790E-07 +/- 0.789E-09 (s)
    Measured overhead in calling start/stop =  0.9411E-07 (s)
    Measured overhead in calling start/stop for registered timer =  0.4725E-07 (s)
    -----------------------------------------------------------------------------
    Region                          Counts     Total       Average*     Std Err
    -----------------------------------------------------------------------------
    psy_inputoutput:eliminate_one_no     1  0.12603E+00   0.12603E+00  0.00E+00
    psy_time_step_mod:swlon_adjust_c    11  0.12201E+01   0.11092E+00  0.28E-02
    psy_time_step_mod:swlon_code        11  0.44050E+01   0.40046E+00  0.25E-02
    psy_time_step_mod:swlon_update_c    11  0.18761E+01   0.17056E+00  0.45E-03
    psy_time_step_mod:swlat_adjust_c    11  0.12325E+01   0.11204E+00  0.53E-03
    psy_time_step_mod:swlat_code        11  0.50031E+01   0.45483E+00  0.26E-02
    psy_time_step_mod:swlat_update_c    11  0.19000E+01   0.17272E+00  0.24E-02
    -----------------------------------------------------------------------------
    * corrected for systematic error
    =============================================================================
```

### [Dr Hook](./drhook)

This wrapper library interfaces with the ECMWF Dr Hook library. This
library appears not to be available as open source on a public
server. It provides more functionality than just profiling, see the Dr
Hook documentation for details. The version tested here is 1.0.0.

Detailed building and linking instructions are in [``drhook/README.md``](
./drhook/README.md).

Example profiling output (some spaces removed to shorten the lines):

```
    No. of instrumented routines called : 9
    Instrumentation started : 20190124 191207
    Instrumentation   ended : 20190124 191319
    Instrumentation overhead: 0.00%
    Memory usage : 20 MBytes (heap), 20 MBytes (rss), 0 MBytes (stack), 0 (paging)
    Wall-time is 29.17 sec on proc#1 (1 procs, 1 threads)
    Thread#1:       29.17 sec (100.00%)
    
    # % Time   Cumul     Self   Total  # of calls   Self       Total    Routine@<thread-id>
                                                     (Size; Size/sec; Size/call; MinSize; MaxSize)
       (self)  (sec)    (sec)   (sec)            ms/call     ms/call

    1  31.69    9.243   9.243    9.243    11   840.27    840.27   swlat_mod:swlat_code@1
    2  28.50   17.554   8.312    8.312    11   755.59    755.59   swlon_mod:swlon_code@1
    3  12.47   21.191   3.636    3.636    11   330.58    330.59   swlat_update_mod:swlat_update_code@1
    4  11.73   24.612   3.421    3.421    11   311.01    311.02   swlon_update_mod:swlon_update_code@1
    5   7.74   26.869   2.257    2.257    11   205.15    205.15   swlat_adjust_mod:swlat_adjust_code@1
    6   7.59   29.083   2.214    2.214    11   201.27    201.27   swlon_adjust_mod:swlon_adjust_code_1@1
    7   0.28   29.165   0.082    0.082     1    82.32     82.32   eliminate_one_node_islands_mod:eliminate_one_node_islands_code_1@1
    8   0.00   29.165   0.000   29.083    11     0.01   2643.90   swlon_adjust_mod:swlon_adjust_code@1
    9   0.00   29.165   0.000    0.082     1     0.01     82.33   eliminate_one_node_islands_mod:eliminate_one_node_islands_code@1
```

### [NVIDIA](./nvidia)

This wrapper library uses the NVIDIA Tools Extension (NVTX) to mark-up
profiling regions so that they appear in the NVIDIA profiling tools
(``nvprof`` or the visual profiler, ``nvvp``).  This is then very useful for
identifying regions of an application that are not running on the GPU.

Detailed building and linking instructions are in
[``nvidia/README.md``](./nvidia/README.md).

Example output (from ``nvprof``):

```
    ==1678== NVTX result:
    ==1678==   Thread "<unnamed>" (id = 66653056)
    ==1678==     Domain "<unnamed>"
    ==1678==       Range "inc_field_mod:inc_field_code"
                Type  Time(%)      Time  Calls       Avg       Min       Max  Name
              Range:  100.00%  758.78us     10  75.878us  43.322us  348.23us  inc_field_mod:inc_field_code
     GPU activities:   72.71%  58.911us     34  1.7320us  1.3760us  8.3520us  [CUDA memcpy HtoD]
                       22.12%  17.920us     10  1.7920us  1.6320us  3.0080us  invoke_0_inc_field_36_gpu
                        5.17%  4.1920us      3  1.3970us  1.3760us  1.4080us  [CUDA memset]
          API calls:   59.10%  122.02us     34  3.5880us  2.4540us  14.057us  cuMemcpyHtoDAsync
                       34.73%  71.711us     10  7.1710us  4.6830us  25.625us  cuLaunchKernel
                        6.17%  12.729us      3  4.2430us  2.3700us  7.7330us  cuMemsetD32Async
```

### [LFRic timer](./lfric_timer)

This wrapper library uses the LFRic timer object. It can not only be
used with LFRic, but also with any other program - detailed linking
instructions are in [``lfric_timer/README.md``](./lfric_timer/README.md).

The output is written to the file ``timer.txt``, which will be overwritten if
it should already exist. For example:

```
    ||=           Routine            =||=   min time(s)     =||=   mean time(s)    =||=   max time(s)     =||=     No. calls     =||=       %time       =||= time per call(s)  =||
    ||            psy_test:invoke_0:r0||                 0.00||                 0.00||                 0.00||                    1||               100.00||                 0.00||
    ||psy_test:invoke_1_update_field:u||                 0.00||                 0.00||                 0.00||                    1||                44.47||                 0.00||
```

## Compilation

The top level ``Makefile`` can be used to compile the profiling-library
interfaces included in PSyclone. The command ``make TARGET`` where ``TARGET``
is one of ``template``, ``simple_timing``, ``dl_timer``, ``drhook``, ``nvidia``
or ``lfric_timer`` will only compile the corresponding library interface.

**Note** that compilation currently does not include ``dl_timer``, ``drhook``
and ``nvidia`` profiling-library interfaces since they require external
libraries to be available. For the same reason, the ``all`` target

```shell
make all
```

will only compile ``template``, ``simple_timing`` and ``lfric_timer``
libraries.

The following ``Makefile`` variables are used and can be overwritten on the
command line (e.g. ``F90=mpif90 make``):

 Variable   |  Default         | Description
 ---------- | ---------------- | -----------------------------
F90         |  gfortran        | Name of the compiler.
F90FLAGS    |  -g              | Flags to use when compiling.

Using ``make clean`` will clean all compiled library interfaces. Each
profiling library interface can be compiled individually by changing into
the corresponding directory and invoking ``make`` with the library-specific
flags (see the individual ``README.md`` documents for reference).

Since any source code instrumented for profiling will now contain ``use
profile_mod`` statements, the location of the ``profile_mod.mod`` file
must be provided as an ``include`` path when compiling the application
source.

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2020-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# NVTX Wrapper

This is a wrapper library that maps the [PSyclone profiling API](
https://psyclone.readthedocs.io/en/stable/profiling.html#profiling) to the
NVIDIA Tools Extension library (NVTX). Unlike some of the other
profiling tools, the use of this library does *not* require that calls
to ``profile_PSyDataInit()`` and ``profile_PSyDataShutdown()`` be inserted
into the application.

This wrapper supports the ``profile_PSyDataStart()`` and
``profile_PSyDataStop()`` API calls that may be used in order to limit
the region of code that is profiled at runtime. If so, the application
must be linked against CUDA (``-Mcuda`` flag to the PGI compiler). This
functionality is often used in combination with disabling profiling at
application startup (e.g. flag ``'--profile-from-start off'`` to ``nvprof``).

## Dependencies

NVTX is a part of the CUDA toolkit which may be freely downloaded from
https://developer.nvidia.com/cuda-toolkit. However, it is not required
to build this wrapper - it is only needed when doing the final linking
of the application to be profiled. Since the NVTX library is in C,
this wrapper uses the Fortran ISO C Binding and is heavily based on
the example module provided by Massimiliano Fatica at
https://devblogs.nvidia.com/customize-cuda-fortran-profiling-nvtx/.

## Compilation

A ``Makefile`` is provided and just executing `make` should build the wrapper
library. By default the ``gfortran`` compiler is used but you will probably
want to use PGI if working with OpenACC, i.e. ``make F90=pgf90``. This will
produce ``libnvtx_prof.a`` and ``profile_mod.mod``.

When compiling the application that has been instrumented for
profiling, the location of the ``profile_mod.mod`` file must be provided
as an include/module path, e.g. ``-I/path/to/psyclone/lib/profiling/nvidia``.

### Linking the wrapper library

Finally, at the link stage the location of the wrapper *and* NVTX
libraries must be provided, e.g.:

```shell
pgf90 <my object files> -Mcuda -L<PATH-TO-PSYCLONE>/lib/profiling/nvidia -lnvtx_prof -L<CUDA_LIB_DIR> -lnvToolsExt
```

where ``<CUDA_LIB_DIR>`` will depend upon your system but is likely to be
something like ``/apps/packages/cuda/10.0/lib64``.

**Note**, The ``<PATH-TO-PSYCLONE>`` differs depending on whether the
wrapper library is compiled in a clone of PSyclone repository or in a
PSyclone [installation](./../../README.md#installation).

Once the application has been built, it may be profiled using ``nvvp``,
[NVIDIA's Visual Profiler](
https://developer.nvidia.com/nvidia-visual-profiler) (see the
[User's Guide](https://docs.nvidia.com/cuda/profiler-users-guide/index.html)
for more information).

## Notes

Currently the wrapper library is configured with seven distinct
colours and assigns these to profile regions in a "round-robin" fashion.
That is, each new region that is created by a call to ``ProfileStart()``
causes a new colour to be chosen from the list.  This colour and the
name of the region are stored in the persistent ``ProfileData`` structure
associated with that region for use in subsequent profiling calls. Once the
end of the list of available colours is reached, the library simply goes
back to the first entry in the list.

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2019-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: A. R. Porter, STFC Daresbury Lab,
         I. Kavcic, Met Office
-->

# PSyclone Wrapper Library for LFRic

This is a wrapper library that maps PSyclone's [PSyData](
https://psyclone.readthedocs.io/en/stable/psy_data.html) [profiling API](
https://psyclone.readthedocs.io/en/stable/profiling.html#profiling) to the
timer functionality provided in LFRic (see the [LFRic (Dynamo 0.3) API](
https://psyclone.readthedocs.io/en/stable/dynamo0p3.html) documentation
on how to access and use the LFRic code).

## Dependencies

While this wrapper library uses LFRic infrastructure code for the timer,
``timer_mod.F90``, the library itself can be used independent of LFRic for
any code. The ``Makefile`` will create two different versions of the library:

- ``libpsy_lfric_timer.a``
  This version just contains the PSyData wrapper, but not the actual
  timer code. Hence, it needs to be linked with the LFRic infrastructure
  library, which provides the actual timer code, ``timer_mod.F90``, and
  dependencies for the timer. This version is meant to be used for LFRic,
  since the corresponding objects files are already included in the
  LFRic build.

- ``libpsy_lfric_timer_standalone.a``

  This version of the library contains all dependencies to use the
  LFRic timer and can be used with any application. This library uses
  the timer available in the pared-down LFRic infrastructure available
  in PSyclone. A runnable example using a GOcean code is included in
  [``examples/gocean/eg5/profile``](
  https://github.com/stfc/PSyclone/tree/master/examples/gocean/eg5/profile).

## Compilation

The library is compiled with ``make`` using the provided ``Makefile``. The
environment variables ``$F90`` and ``$F90FLAGS`` can be set to point to the
[Fortran compiler](./../../README.md#compilation) and flags to use.

In order to compile the ``libpsy_lfric_timer.a`` library using already
compiled LFRic code, the following command can be used:

```shell
LFRIC_INF_DIR=$<path/to/LFRic/compiled/code> make libpsy_lfric_timer.a
```
This will pick up the module file for the LFRic timer from the specified
directory. As can be seen from the above command, the location of the LFRic
infrastructure code is specified using the environment variable
``LFRIC_INF_DIR``. For demonstration purposes, it defaults to the relative
path to location of the pared-down LFRic infrastructure located in a clone
of PSyclone repository,
``<PSYCLONEHOME>/src/psyclone/tests/test_files/dynamo0p3/infrastructure``.
This is not available in the PSyclone [installation](
./../../README.md#installation) so the exact path
**must be specified** during the compilation process.

For an LFRic application, it is the responsibility of the user to make sure
that the module files used when compiling the LFRic timer library are
identical to the ones used when running an LFRic application.

As mentioned [above](#dependencies), the ``libpsy_lfric_timer_standalone.a``
library uses the pared-down LFRic infrastructure available in PSyclone.
As this is not available in the PSyclone [installation](
./../../README.md#installation), it is recommended to clone the PSyclone
repository and specify the exact path during the compilation process.
For instance,

```shell
LFRIC_INF_DIR=<PSYCLONEHOME>/src/psyclone/tests/test_files/dynamo0p3/infrastructure make \
	libpsy_lfric_timer_standalone.a
```

The ``Makefile`` will compile the LFRic infrastructure library,
``liblfric.a``, if required, with the previously selected compiler flags.

### Linking the wrapper library

In order to link this timer library with your application, the location of
this library must be provided as an ``include`` path (so that the module
file is found). Also, the library name must be specified at link time.

For instance, linking the standalone library may look something like:

```shell
$(F90) -c  -I <PATH-TO-PSYCLONE>/lib/profiling/lfric_timer some_file.f90
$(F90) some_file.o -L <PATH-TO-PSYCLONE>/lib/profiling/lfric_timer -lpsy_lfric_timer_standalone
```
The application of the ``libpsy_lfric_timer.a`` needs to provide the path
to the LFRic compiled code as well, e.g. by adding ``-L$(LFRIC_INF_DIR) -llfric``.

**Note**, The ``<PATH-TO-PSYCLONE>`` differs depending on whether the
wrapper library is compiled in a clone of PSyclone repository or in a
PSyclone [installation](./../../README.md#installation).

## Output

The output is written to the file ``timer.txt``, which will be overwritten
if it already exists. An example output is below:

```
$ less timer.txt
||=           Routine            =||=   min time(s)     =||=   mean time(s)    =||=   max time(s)     =||=     No. calls     =||=       %time       =||= time per call(s)  =||
||            psy_test:invoke_0:r0||                 0.00||                 0.00||                 0.00||                    1||               100.00||                 0.00||
||psy_test:invoke_1_update_field:u||                 0.00||                 0.00||                 0.00||                    1||                37.11||                 0.00||

```

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2020-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# Simple Stand-alone Timer Library

This library is a simple stand-alone timer library (see the ["Profiling"](
https://psyclone.readthedocs.io/en/stable/profiling.html#profiling) section
in the PSyclone [User Guide](https://psyclone.readthedocs.io/en/stable/) for
more details). It counts the number of calls for each region, and reports
minumum, maximum and average times. This library is **not thread-safe**, and
**not MPI-aware** (e.g. maximum reported is per process, not across all
processes).

## Dependencies

This stand-alone profiling library uses the [PSyData API](
https://psyclone.readthedocs.io/en/stable/psy_data.html) to interface with
the application. The library is based on the [PSyData base class](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#psydata-base-class),
which is included in PSyclone as a Jinja template, ``psy_data_base.jinja``.
Full documentation on using this template is provided in the PSyclone
[Developer Guide](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#jinja). The
script [``process.py``](./../../README.md#psydata-base-class) is used to
process this template.

Since the profiling API does not need access to any fields or variables,
only the static subroutines and ``PreStart`` and ``PostEnd`` are implemented;
the ``PreDeclare`` and ``ProvideVariable`` methods are not created at all.

The library uses the ``ProfileData`` type to store the module/region name
(done by the base class) and then stores timing and counting information in
this derived type.

## Compilation

The library is compiled with ``make`` using the provided ``Makefile``. The
environment variables ``$F90`` and ``$F90FLAGS`` can be set to point to the
[Fortran compiler](./../../README.md#compilation) and flags to use, e.g.

```shell
F90=gfortran F90FLAGS=-g make
```

The compiler flags default to ``gfortran`` and the empty string.

The location of the PSyData base class Jinja template,
``psy_data_base.jinja`` is specified using the environment variable
``$PSYDATA_LIB_DIR``. It defaults to the relative path to the
top-level [``lib``](./../../) directory.

The compilation process will create the wrapper library ``libsimple_timing.a``.

### Linking the wrapper library

In order to link this timer library with your application, the location of
this library must be provided as an ``include`` path (so that the module
file is found). Also, the library name, ``simple_timing``, must be specified
at link time:

```shell
$(F90) -c  -I $(PSYDATA_LIB_DIR)/profiling/simple_timing some_file.f90
$(F90) some_file.o -L $(PSYDATA_LIB_DIR)/profiling/simple_timing -lsimple_timing
```

## Output

The output is written to the command line. A sample output is below:

```
===========================================
module::region                                         count           sum                     min             average                 max
psy_inputoutput::eliminate_one_node_islands_code           1     0.128906250             0.128906250             0.128906250             0.128906250    
psy_time_step_mod::swlon_adjust_code                      11      1.19921875             0.105468750             0.109019883             0.113281250    
psy_time_step_mod::swlon_code                             11      4.38281250             0.394531250             0.398437500             0.406250000    
psy_time_step_mod::swlon_update_code                      11      1.86718750             0.167968750             0.169744313             0.171875000    
psy_time_step_mod::swlat_adjust_code                      11      1.23828125             0.109375000             0.112571023             0.117187500    
psy_time_step_mod::swlat_code                             11      4.87890625             0.437500000             0.443536937             0.445312500    
psy_time_step_mod::swlat_update_code                      11      1.87500000             0.167968750             0.170454547             0.179687500    
===========================================
```

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2019-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# PSyclone Wrapper Library for Dr Hook

This is a wrapper library that maps the [PSyclone profiling API](
https://psyclone.readthedocs.io/en/stable/profiling.html#profiling)
to the Dr Hook API.

## Dependencies

The Dr Hook library  must be installed. Note that this is currently
not available on any public repository and the prospective user needs
to contact ECMWF to obtain a copy of Dr Hook.

This profiling library uses the [PSyData API](
https://psyclone.readthedocs.io/en/stable/psy_data.html) to interface with
the application. The library is based on the [PSyData base class](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#psydata-base-class),
which is included in PSyclone as a Jinja template, ``psy_data_base.jinja``.
Full documentation on using this template is provided in the PSyclone
[Developer Guide](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#jinja).

The library uses the ``ProfileData`` type to store Dr Hook's handle for each
region.

## Compilation

The library is compiled with ``make`` using the provided ``Makefile``. The
environment variables ``$F90`` and ``$F90FLAGS`` can be set to point to the
[Fortran compiler](./../../README.md#compilation) and flags to use. They
default to ``gfortran`` and the empty string.

In the version tested here, 1.0.0, it appears that the installation target
in the Dr Hook distribution is broken, so the following instructions and
the default values assume that Dr Hook is compiled in a ``drhook``
subdirectory called ``build`` and not installed.

To compile the PSyclone wrapper library for Dr Hook, one of the following
two ``Makefile`` variables must be set to specify the path to the Dr Hook
installation:

- ``DRHOOK_ROOT``, the path to the Dr Hook root directory in which
  Dr Hook is compiled. It defaults to ``./../../../../drhook`` in the
  ``Makefile`` (i.e., it assumes Dr Hook is installed next to a PSyclone
  repository clone). This will set ``DRHOOK_INCLUDE`` to
  ``.../drhook/include`` and ``DRHOOK_MODULES`` to
  ``.../drhook/build/module``, so that the ``*.mod`` files created in the
  build processes are found.

- ``DRHOOK_INCLUDE`` and ``DRHOOK_MODULES``: Setting these environment
  variables explicitly will allow to flexibly point to an existing
  Dr Hook installation.

**Note**, it is not known whether a proper Dr Hook installation will
install ``include`` and ``*.mod`` files in separate directories.

For instance, compiling the wrapper library with the default compiler
flags may look something like:

```shell
DRHOOK_ROOT=<path_to_drhook> make
```

The compilation process will create the wrapper library ``libdrhook_psy.a``.

### Linking the wrapper library

In order to use the wrapper with your application, you must provide the
location of the wrapper as an ``include`` path (so that the module file is found),
and link first with the wrapper library, then the DrHook library:

In order to use the wrapper with your application, the location of this
library must be provided as an ``include`` path (so that the module file
is found), and linked first with the wrapper library, ``drhook_psy``,
and then with the Dr Hook library:

```shell
$(F90) -c  ... -I <PATH-TO-PSYCLONE>/lib/profiling/drhook somefile.f90
$(F90) -o a.out ... -L <PATH-TO-PSYCLONE>/lib/profiling/drhook -ldrhook_psy \
       -L <PATH-TO-DRHOOK> -ldrhook
```

**Note:**

- The name of the Dr Hook library might depend on the way it is compiled.

- The ``<PATH-TO-PSYCLONE>`` differs depending on whether the wrapper
  library is compiled in a clone of PSyclone repository or in a PSyclone
  [installation](./../../README.md#installation).

## Output

An example output of the profiling report is below:

```
Profiling information for program='./profile_test.drhook', proc#1:
        No. of instrumented routines called : 2
        Instrumentation started : 20200929 161905
        Instrumentation   ended : 20200929 161905
        Instrumentation overhead: 12.12%
        Memory usage : 70 MBytes (heap), 70 MBytes (rss), 0 MBytes (stack), 0 (paging)
        Wall-time is 0.00 sec on proc#1 (1 procs, 4 threads)
        Thread#1:        0.00 sec (100.00%)
        Thread#2:        0.00 sec (0.00%)
        Thread#3:        0.00 sec (0.00%)
        Thread#4:        0.00 sec (0.00%)

    #  % Time         Cumul         Self        Total     # of calls        Self       Total    Routine@<thread-id>
                                                                             (Size; Size/sec; Size/call; MinSize; MaxSize)
        (self)        (sec)        (sec)        (sec)                    ms/call     ms/call

    1    78.38        0.000        0.000        0.000              1        0.01        0.01    psy_test:invoke_0:r0@1
    2    21.62        0.000        0.000        0.000              1        0.00        0.00    psy_test:invoke_1_update_field:update_field_code:r0@1

```

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2019-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# Read-only Verification Library for LFRic

This library implements the [PSyData API](
https://psyclone.readthedocs.io/en/latest/psy_data.html#read-only-verification-library-for-lfric)
to verify that variables declared read-only are not modified (overwritten) in
a kernel call for an application using the LFRic infrastructure library.

## Dependencies

This library uses the [PSyData API](
https://psyclone.readthedocs.io/en/stable/psy_data.html) to interface with
the application. The following dependencies must be available:

- The LFRic infrastructure library. A pared-down version of LFRic
  infrastructure is located in the PSyclone repository (see e.g.
  [LFRic Example 17](
  https://github.com/stfc/PSyclone/tree/master/examples/lfric/eg17), however
  it is not included in the PSyclone [installation](
  ./../../README.md#installation). See the [LFRic API](
  https://psyclone.readthedocs.io/en/stable/dynamo0p3.html) documentation
  for information on how to obtain access to the LFRic code.

- The ReadOnly (``read_only_base.jinja``) and PSyData
  (``psy_data_base.jinja``) base classes, which are included in PSyclone
  installation. These Jinja templates are processed to create the
  read-only verification code for ``integer``, 32- and 64-bit ``real``
  scalars, and 1, 2, 3, and 4-dimensional ``real`` and ``integer`` arrays.
  The generated Fortran modules, ``read_only_base.f90`` and
  ``psy_data_base.f90``, are then used by the supplied ``read_only.f90``
  module to create the wrapper library.

## Compilation

The library is compiled with ``make`` using the provided ``Makefile``. The
environment variables ``$F90`` and ``$F90FLAGS`` can be set to point to the
[Fortran compiler](./../../README.md#compilation) and flags to use. They
default to ``gfortran`` and the empty string.

The location of the LFRic infrastructure library is specified using the
environment variable ``LFRIC_INF_DIR``. It defaults to the relative path
to location of the pared-down LFRic infrastructure located in a clone of
PSyclone repository,
``<PSYCLONEHOME>/src/psyclone/tests/test_files/dynamo0p3/infrastructure``.
This is not available in the PSyclone [installation](
./../../README.md#installation) so the exact path
**must be specified** during the compilation process, e.g.

```shell
F90=ifort F90FLAGS="-g -check bounds" LFRIC_INF_DIR=<path/to/LFRic/code> make
```

It is the responsibility of the user to make sure that the module files
used when compiling the LFRic read-only library are identical to the ones
used when running an LFRic application.

The locations of the ReadOnly and PSyData base classes are specified
using the environment variables ``$LIB_TMPLT_DIR`` and ``$PSYDATA_LIB_DIR``,
respectively. They default to the relative paths to the
[``lib/read_only``](./../) and top-level [``lib``](./../../) directories.

The compilation process will create the wrapper library ``lib_read_only.a``.
The ``Makefile`` will compile the LFRic infrastructure library,
``liblfric.a``, if required, with the previously selected compiler flags.

Similar to compilation of the [examples](
https://psyclone.readthedocs.io/en/latest/examples.html#compilation), the
compiled wrapper library can be removed by running ``make clean``. To also
remove the compiled infrastructure library it is necessary to run
``make allclean`` (this is especially important if changing compilers
or compiler flags).

### Linking the wrapper library

The application needs to provide the parameters to link in this read-only
library, ``_read_only``,  and the LFRic infrastructure library, ``lfric``.
For instance:

```shell
$(F90)  ... -L$(PSYDATA_LIB_DIR)/read_only/lfric -l_read_only \
        -L$(LFRIC_INF_DIR) -llfric $(LFRIC_SPECIFIC_LINKING_PARAMETERS)
```

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2020-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# PSyclone Wrapper Library for ``dl_timer``

This is a wrapper library that maps the [PSyclone profiling API](
https://psyclone.readthedocs.io/en/stable/profiling.html#profiling) to the
dl_timer API. This library is **thread-safe**.

## Dependencies

The library dl_timer must be installed, which can be downloaded from
https://bitbucket.org/apeg/dl_timer.

This profiling library uses the [PSyData API](
https://psyclone.readthedocs.io/en/stable/psy_data.html) to interface with
the application. The library is based on the [PSyData base class](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#psydata-base-class),
which is included in PSyclone as a Jinja template, ``psy_data_base.jinja``.
Full documentation on using this template is provided in the PSyclone
[Developer Guide](
https://psyclone-dev.readthedocs.io/en/latest/psy_data.html#jinja).

Since the profiling API does not need access to any fields or variables,
only the static subroutines and ``PreStart`` and ``PostEnd`` are implemented,
the ``PreDeclare`` and ``ProvideVariable`` methods are not created at all.

The library uses the ``ProfileData`` type and dl_timer's
timer_register function to store the module/region name (done by the base
class) and the index used by dl_timer.

## Compilation

The library is compiled with ``make`` using the provided ``Makefile``. The
environment variables ``$F90`` and ``$F90FLAGS`` can be set to point to the
[Fortran compiler](./../../README.md#compilation) and flags to use. They
default to ``gfortran`` and the empty string.

To compile the PSyclone wrapper library for dl_timer, one of the
following two ``Makefile`` variables must be set to specify the path to
the dl_timer installation:

- ``DL_TIMER_ROOT``, the path to the ``apeg-dl_timer`` directory in which
  dl_timer is compiled. It defaults to ``./../../../../dl_timer`` in
  the ``Makefile`` (i.e., it assumes dl_timer is installed next to a
  PSyclone clone).

- ``DL_TIMER_INCLUDE``, the path to the dl_timer ``include`` directory
  (i.e. ``src`` directory). This defaults to ``$DL_TIMER_ROOT/src``.

For instance, compiling the wrapper library with the default compiler
flags may look something like:

```shell
DL_TIMER_ROOT=<path_to_dl_timer> make
```

The location of the PSyData base class Jinja template,
``psy_data_base.jinja`` is specified using the environment variable
``$PSYDATA_LIB_DIR``. It defaults to the relative path to the
top-level [``lib``](./../../) directory.

The compilation process will create the wrapper library ``libdl_timer_psy.a``.

### Linking the wrapper library

In order to use the wrapper with your application, the location of this
library must be provided as an ``include`` path (so that the module file
is found), and linked first with the wrapper library, ``dl_timer_psy``,
and then with the dl_timer library:

```shell
$(F90) -c ... -I $(PSYDATA_LIB_DIR)/profiling/dl_timer somefile.f90
$(F90) -o a.out ... -L $(PSYDATA_LIB_DIR)/profiling/dl_timer -ldl_timer_psy \
       -L PATH-TO-DLTIMER -ldltimer
```
The name of the dl_timer library will depend on the way it is compiled
(shared-memory or distributed-memory parallel).

## Output

An example output of the profiling report is below:

```
=============================== Timing report ===============================
Timed using POSIX timer. Units are seconds.
Reported resolution =  0.1000E-08 (s)
Effective clock granularity =  0.25997E-07 (s)
Measured systematic error in dl_timer API =  0.37790E-07 +/- 0.789E-09 (s)
Measured overhead in calling start/stop =  0.9411E-07 (s)
Measured overhead in calling start/stop for registered timer =  0.4725E-07 (s)
-----------------------------------------------------------------------------
Region                          Counts     Total       Average*     Std Err
-----------------------------------------------------------------------------
psy_inputoutput:eliminate_one_no     1  0.12603E+00   0.12603E+00  0.00E+00
psy_time_step_mod:swlon_adjust_c    11  0.12201E+01   0.11092E+00  0.28E-02
psy_time_step_mod:swlon_code        11  0.44050E+01   0.40046E+00  0.25E-02
psy_time_step_mod:swlon_update_c    11  0.18761E+01   0.17056E+00  0.45E-03
psy_time_step_mod:swlat_adjust_c    11  0.12325E+01   0.11204E+00  0.53E-03
psy_time_step_mod:swlat_code        11  0.50031E+01   0.45483E+00  0.26E-02
psy_time_step_mod:swlat_update_c    11  0.19000E+01   0.17272E+00  0.24E-02
-----------------------------------------------------------------------------
* corrected for systematic error
=============================================================================
```

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2019-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# Kernel Extraction Library Using NetCDF for GOcean

This wrapper library is used to [write (extract)](
https://psyclone.readthedocs.io/en/stable/psyke.html)
input and output parameters of instrumented code regions to a [NetCDF file](
https://psyclone.readthedocs.io/en/stable/psyke.html#netcdf-extraction-example)
using the [``dl_esm_inf`` library](https://github.com/stfc/dl_esm_inf).
A stand-alone driver can then be used to rerun this specific code region and
verify the results (or compare performance).

A full, stand-alone and runnable example can be found in
[``examples/gocean/eg5/extract``](
https://github.com/stfc/PSyclone/tree/master/examples/gocean/eg5/extract).

## Dependencies

This library uses the [PSyData API](
https://psyclone.readthedocs.io/en/stable/psy_data.html) to interface with
the application. The following dependencies must be available:

- The [GOcean](https://psyclone.readthedocs.io/en/latest/gocean1p0.html)
  infrastructure library ``dl_esm_inf``. A stable version of this is included
  in the PSyclone repository as a Git submodule (see ["Installation"](
  https://psyclone-dev.readthedocs.io/en/stable/working_practises.html#dev-installation)
  in the PSyclone [Developer Guide](
  https://psyclone-dev.readthedocs.io/en/stable) for details on working with
  submodules). However, it is not included in the PSyclone [installation](
  ./../../../README.md#installation) and has to be cloned separately.

- This library uses NetCDF to store the data, so NetCDF must
  be available on the system. NetCDF development packages are available via
  the Linux package manager. Otherwise they can be built from source that
  can be downloaded from the [UCAR NetCDF website](
  https://www.unidata.ucar.edu/software/netcdf). For more information please
  refer to the [hands-on practicals documentation](
  https://github.com/stfc/PSyclone/tree/master/tutorial/practicals#netcdf-library-lfric-examples).

- The ExtractNetcdf (``extract_netcdf_base.jinja``) and PSyData
  (``psy_data_base.jinja``) base classes, which are included in PSyclone
  installation. These Jinja templates are processed to create the
  code to write ``integer``, 32- and 64-bit ``real`` scalars, and
  2-dimensional ``real`` and ``integer`` arrays. The generated Fortran
  modules, ``extract_netcdf_base.f90`` and ``psy_data_base.f90``, are
  then used by the supplied NetCDF-kernel-extraction module,
  ``kernel_data_netcdf.f90``, to create the wrapper library.

## Compilation

The library is compiled with ``make`` using the provided ``Makefile``. The
environment variables ``$F90`` and ``$F90FLAGS`` can be set to point to the
[Fortran compiler](./../../../README.md#compilation) and flags to use. They
default to ``gfortran`` and the empty string.

The NetCDF helper program ``nf-config`` is used to get the NetCDF-specific
include paths. By default it is set to the relative path to location of
the version included in PSyclone repository
(``<PSYCLONEHOME>/external/dl_esm_inf/finite_difference``). This is not
available in the PSyclone [installation](./../../../README.md#installation)
so the exact path **must be specified** using the environment variable
``GOCEAN_INF_DIR``, e.g.

```shell
GOCEAN_INF_DIR=<path/to/dl_esm_inf/finite_difference> make
```

The locations of the ExtractNetcdf and PSyData base classes are
specified using the environment variables ``$LIB_TMPLT_DIR`` and
``$PSYDATA_LIB_DIR``, respectively. They default to the relative paths to
the [``lib/extract/netcdf``](./../) and top-level [``lib``](./../../../)
directories.

The compilation process will create the wrapper library
``lib_kernel_data_netcdf.a``. The ``Makefile`` will compile the
``dl_esm_inf`` infrastructure library, ``lib_fd.a``, if required, with the
previously selected compiler flags.

Similar to compilation of the [examples](
https://psyclone.readthedocs.io/en/latest/examples.html#compilation), the
compiled wrapper library can be removed by running ``make clean``. To also
remove the compiled infrastructure library it is necessary to run
``make allclean`` (this is especially important if changing compilers
or compiler flags).

### Linking the wrapper library

The application needs to provide the parameters to link in this
NetCDF-kernel-extraction library, ``_kernel_data_netcdf``, the ``dl_esm_inf``
infrastructure library, ``_fd``,  and the required NetCDF parameters when
compiling and linking. For instance:

```shell
$(F90)  ... -L$(PSYDATA_LIB_DIR)/extract/netcdf/dl_esm_inf -l_kernel_data_netcdf \
        -L$(GOCEAN_INF_DIR) -l_fd $(nf-config --flibs)
```

### Note

Certain versions of Fedora have a broken ``nf-config`` script. In
this case the ``Makefile`` has to be modified to provide the required
information (you can try to see if ``nc-config`` can be used,
or you have to explicitly provide the required paths and options).

<!--
## Licence

-------------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2020-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-------------------------------------------------------------------------------
Authors: J. Henrichs, Bureau of Meteorology,
         I. Kavcic, Met Office
-->

# PSyclone Examples

**Author:** J. Henrichs, Bureau of Meteorology
**Modifications:** A. R. Porter, STFC Daresbury Laboratory

# Introduction

This directory contains examples for the various APIs that PSyclone
supports, and data structures. In detail:

## [gocean](./gocean)
Various examples related to the GOCean API.

## [nemo](./nemo)
Various examples related to the NEMO API.

## [lfric](./lfric)
Various examples related to the LFRic API.

## [line_length](./line_length)
This example demonstrates the use of the line length option.

## [psyir](./psyir)
This directory contains examples on how to use PSyIR to create
Fortran and C code as output.

## [stub_generation](./stub_generation)
This directory shows the usage of the stub-generation functionality
of the psyclone-kern utility. This helps with generating a Kernel's
argument list and associated datatypes from the Kernel metadata.

## transformations
This directory shows how to use the inline transformation.

# Compiler Settings
By default, all examples are using ``gfortran`` as compiler.
If you want to change the compiler, use the environment
variables ``F90`` and ``F90FLAGS``, e.g.:

```shell
    F90=ifort F90FLAGS="-g -check bounds" make
```

<!--
BSD 3-Clause License

Copyright (c) 2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

Author: R. W. Ford, STFC Daresbury Lab
-->

# PSyAD Examples

This directory contains various examples of the use of PSyAD to
transform tangent linear code to its adjoint. See the READMEs in the
individual example directories for further details.

## Example 1

Simple generic tangent linear example which is translated to its
adjoint form and tested with the harness generation.

## Example 2

An LFRic tangent-linear kernel example which shows how much of this
code PSyAD can currently translate. The kernel computes the
tangent-linear of the hydrostatic balance term. It was taken from the
LFRic repository and has any unsupported code commented out.

The harness generation does not currently support this example as it
assumes all arguments are real arrays which can be filled with random
real data, whereas LFRic arguments can include integer arrays and
these integer arrays may act as lookups into other arrays and
therefore require non-random integer values.

<!--
BSD 3-Clause License

Copyright (c) 2018-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

Author A. R. Porter, STFC Daresbury Lab
Modified by R. W. Ford, STFC Daresbury Lab
-->

# PSyclone NEMO Examples

This directory contains various examples of the use of PSyclone
to transform source code from the NEMO ocean model. See the READMEs
in the individual example directories for further details.

## Code

Contains:

1. the Tracer advection benchmark routine (tra_adv), as provided by
   Silvia Mocavero of CMCC and
2. an unmodified NEMO subroutine computing the horizontal component of
   the lateral tracer mixing trend (traldf_iso).

## Scripts

Contains two scripts used to process the NEMO code base and to add profiling
instrumentation (https://psyclone.readthedocs.io/en/stable/profiling.html)
and OpenACC directives:

1. `process_nemo.py` is a driver script that allows the user to specify
   which files to process with PSyclone, the transformation script to use
   and where to put the outputs:

       $ ./process_nemo.py -h
       usage: process_nemo.py [-h] [-o OUT_DIR] [-s SCRIPT_FILE] [-x]
                              input_file [input_file ...]

       Process the specified NEMO source files using PSyclone

       positional arguments:
         input_file      One or more NEMO pre-processed source files

       optional arguments:
         -h, --help      show this help message and exit
         -o OUT_DIR      Destination directory for processed source files
         -s SCRIPT_FILE  PSyclone transformation script
         -x              exit immediately if PSyclone fails

   In addition to the command-line flags, the script itself contains two
   variables that may be used to control its behaviour:

   - `EXCLUDED_FILES`: list of filenames that will not have OpenACC directives
     added.
   - `PROFILE_ALL`: whether or not to add profiling instrumentation to every
     file, irrespective of whether the file is listed in `EXCLUDED_FILES`.

   Finally, the precise invocation to use when running PSyclone may be
   specified by setting the `PSYCLONE` environment variable. If this is not set
   then `psyclone` must be in the user's PATH.

2. `kernels_trans.py` is a PSyclone transformation script that adds
   OpenACC directives and places fine-grained profiling instrumentation around
   any regions that haven't had OpenACC added.

These scripts are a *work in progress* and are being developed to work on the
MO_GO8 configuration of NEMO supplied by the Met Office. This configuration is
based on version 4.0.2 of NEMO and is compiled using:

    ./makenemo -n MO_GO8_GPU -r SPITZ12 -m linux_pgf90_gpu \
        del_key "key_iomput key_mpp_mpi" add_key "key_nosignedzero"

(where you will need an `arch/arch-linux_pgf90_gpu.fcm` FCM configuration
file specifying how to use the NVIDIA compiler).

If you are applying PSyclone to any other version or configuration of NEMO then
these scripts should serve as a useful starting point.

## Example 1

OpenMP parallelisation (for CPU and GPU) of tra_adv over levels.

## Example 2

OpenMP parallelisation of traldf_iso over levels.

## Example 3

OpenACC parallelisation of tra_adv. Contains a local transformation
script that adds both 'data' and 'kernels' directives to the
code. Also demonstrates the use of the `kernels_trans.py` script from
the `scripts` directory which adds 'kernels' and 'loop' directives as
well as profiling instrumentation. This script is designed for use
with NVIDIA's managed memory technology and therefore does not insert
data regions.

## Example 4

SIR generation and transformation to CUDA using Dawn with simple
examples and a cut down version of the tracer advection (tra_adv)
benchmark.

# PSyclone LFRic Examples

These examples assume that you have PSyclone installed. The easiest
way to do this is via pip, e.g. `pip install psyclone`. See the user
manual for more details (`../../psyclone.pdf` or
http://psyclone.readthedocs.io/en/stable/). After doing this `psyclone`
should be on your PATH.

The first two examples are primarily provided to illustrate the use of
the PSyclone code-generation system. No guarantee is made as to their
functional correctness or usefulness (i.e. the calculations that they
perform may often be nonsensical - it is the use of PSyclone that is
being illustrated).

## Example 1: Basic Operation

The first example simply illustrates the use of PSyclone to generate
the necessary sequential PSy-layer code for a single invoke() that
specifies one Built-in kernel and one user-supplied kernel:
```sh
cd eg1/
psyclone -nodm -d ../code ./single_invoke.x90
```

(The `-d ../code` argument tells PSyclone where it should search for any
user-supplied kernels.)

PSyclone will output two lots of Fortran code to `stdout` when run in
this way: the first is the transformed Algorithm layer (the code from
`single_invoke.x90`) and the second is the generated PSy-layer code.

The `transform` target in the Makefile will also run this command. It
also repeats it without the `-nodm` flag so that PSyclone generates
the necessary code for running with distributed memory.

## Example 2: Applying Transformations

The second example provides an introduction to the use of
transformations to:

1. display the PSyclone Internal Representation of the PSy-layer code:
   ```sh
   cd eg2/
   psyclone -nodm -d ../code -s ./print_psyir_trans.py ./multi_invoke_mod.x90
   ```

2. module-inline a user-supplied kernel into the PSy layer:
   ```sh
   psyclone -nodm -d ../code -s ./module_inline_trans.py ./multi_invoke_mod.x90
   ```

3. perform loop fusion:
   ```sh
   psyclone -nodm -d ../code -s ./loop_fuse_trans.py ./multi_invoke_mod.x90
   ```

Please see the individual transformation scripts for more details.

## Example 3: Distributed and Shared Memory

The third example can be used to demonstrate PSyclone:

1. generating distributed memory parallel code
   ```sh
   cd eg3/
   psyclone solver_mod.x90
   # look for %set_dirty and %halo_exchange in the generated code
   ```

2. using a transformation script to perform loop colouring and OpenMP
   parallelisation, either with distributed memory parallel code:
   ```sh
   cd eg3/
   psyclone -s ./colouring_and_omp.py solver_mod.x90
   ```

   or without distributed memory parallel code:
   ```sh
   cd eg3/
   psyclone -s ./colouring_and_omp.py -nodm solver_mod.x90
   ```

This example also demonstrates the use of `Wchi` function space metadata
for coordinate fields and the use of `integer`-valued fields in LFRic.

## Example 4: Multiple Built-in Calls and Named Invokes

The fourth example illustrates the use of (multiple) calls to built-in
operations within an invoke as well as the use of the name="..." argument.
It also includes the use of the enforce_bc_kernel_type kernel to apply
boundary conditions.
```sh
cd eg4/
psyclone solver_mod.x90
```
It also has the `backends` Makefile target to inform the development of
PSy-layer code generation using the PSyIR backends.

## Example 5: Stencils

The fifth example illustrates the use of stencils in kernels and the associated
passing of extent and direction information (where appropriate) from the
algorithm layer.
```sh
cd eg5/
psyclone alg.f90
```

## Example 6: Reductions

The sixth example illustrates the use and implementation of
reductions. It also demonstrates the generation of a schedule's
dependence graph in svg format (see dag.svg). Note, that if graphviz
and its Python bindings are not installed then no dag image will be
generated and the dag method will silently return. The example may be
run sequentially:
```sh
cd eg6/
psyclone -nodm alg.x90
```

code parallelised with MPI:
```sh
cd eg6/
psyclone alg.x90
```

code parallelised with OpenMP (and loop fused)
```sh
cd eg6/
psyclone -nodm -s ./omp_script.py alg.x90
```

or code parallelised with both MPI and OpenMP (and loop fused)
```sh
cd eg6/
psyclone -s ./omp_script.py alg.x90
```

By default the OpenMP implementations make use of the OpenMP reduction
support. OpenMP reductions do not guarantee the same results from one
run to the next for runs with the same number of OpenMP
threads. Therefore a "reprod" option has been added to the OpenMP do
loop transformation which implements a manual reduction that provides
the same results from one run to the next when using the same number
of threads
```sh
cd eg6/
psyclone -s ./omp_reprod_script.py alg.x90
```

## Example 7: Column-Matrix Assembly Operators

The seventh example illustrates the use of PSyclone with kernels that
perform operations with column-wise (Column-Matrix Assembly) operators:
```sh
cd eg7/
psyclone alg.x90
```

## Example 8: Redundant Computation

The eighth example illustrates the use of redundant computation to
remove and/or change the location and depth of halo exchanges:
```sh
cd eg8/
psyclone helmholtz_solver_alg_mod.x90 -s ./redundant_script.py
```

## Example 9: Writing to Discontinuous Fields

The ninth example illustrates the behaviour of discontinuous field writers
and readwriters:
```sh
cd eg9/
psyclone advective_inc_alg_mod.x90
```

This example also demonstrates how to write a PSyclone transformation
script that only colours loops over continuous spaces:
```sh
cd eg9/
psyclone -s ./colouring_and_omp.py -nodm advective_inc_alg_mod.x90
```

## Example 10: Inter-grid Kernels

PSyclone supports so-called 'inter-grid' kernels that map a field (or field
vector) from a coarse mesh onto a fine mesh (prolongation) or from a fine
mesh onto a coarse mesh (restriction). eg10 contains an example algorithm
that takes a field on a fine mesh and restricts it twice before undoing
that by prolonging it twice:
```sh
cd eg10/
psyclone intergrid_3levels.x90
```

This example also demonstrates the use of `ANY_DISCONTINUOUS_SPACE`
function space metadata.

## Example 11: Asynchronous Halo Exchanges

This example shows how asynchronous halo exchange calls can be created
and manipulated:
```sh
cd eg11/
psyclone -s ./async_script.py helmholtz_solver_alg_mod.x90
```

## Example 12: Code Extraction

The twelfth example demonstrates how to apply code extraction to Nodes in
an Invoke Schedule or to a Kernel in an Invoke. For now it only inserts an
`ExtractNode` in appropriate locations. The full support for code
extraction is being developed (please note that distributed memory will not
be supported). This example can extract a list of Nodes:
```sh
cd eg12/
${PSYCLONE} -nodm -s ./extract_nodes.py \
  gw_mixed_schur_preconditioner_alg_mod.x90
```

or the specific Kernel from one Invoke which contains the Kernel
call after applying transformations (here colouring and OpenMP):
```sh
cd eg12/
${PSYCLONE} -nodm -s ./extract_kernel_with_transformations.py \
  gw_mixed_schur_preconditioner_alg_mod.x90
```

This example also contains a Python helper script which displays
useful information for Kernel extraction: names and Schedules of
one or more Invokes which contain call to the specified Kernel:
```sh
cd eg12/
python find_kernel.py
```

For example, looking for `matrix_vector_kernel_code` call in
`gw_mixed_schur_preconditioner_alg_mod.x90` returns:
```python
Kernel call 'matrix_vector_code' was found in

- Invoke 'invoke_0' with the Schedule:
InvokeSchedule[invoke='invoke_0', dm=False]
    ...
    Loop[type='', field_space='any_space_1', it_space='cells', upper_bound='ncells']
        Literal[value:'NOT_INITIALISED']
        Literal[value:'NOT_INITIALISED']
        Literal[value:'1']
        Schedule[]
            CodedKern matrix_vector_kernel_code(m_lumped,ones,mb) [module_inline=False]
    Loop[type='dofs', field_space='any_space_1', it_space='dofs', upper_bound='ndofs']
        Literal[value:'NOT_INITIALISED']
        Literal[value:'NOT_INITIALISED']
        Literal[value:'1']
        Schedule[]
            BuiltIn x_divideby_y(self_mb_lumped_inv,ones,m_lumped)

- Invoke 'invoke_1' with the Schedule:
InvokeSchedule[invoke='invoke_1', dm=False]
    ...
```

## Example 13: Kernel Constants

This example shows how LFRic kernels can be modified so that the
values for the number of degrees of freedom, the number of quadrature
points and the number of layers can be made constant (as they are
passed in by argument by default). To run:
```sh
cd eg13/
psyclone -s ./kernel_constants.py \
../code/gw_mixed_schur_preconditioner_alg_mod.x90 \
-oalg alg.f90 -opsy psy.f90
```

## Example 14: OpenACC

This example shows how OpenACC directives can be added to the LFRic
PSy-layer. This is work in progress so the resultant code is not
expected to run correctly but it gives a starting point for
evaluation.

1. Adding OpenACC kernels directives. -nodm is used as an exception is
   raised if Halo Exchange nodes are found within an OpenACC kernels
   region.
   ```sh
   cd eg14/
   psyclone -s ./acc_kernels.py -nodm main.x90
   ```

2. Adding OpenACC enter data, parallel and loop directives. -nodm is
   used as an exception is raised if Halo Exchange nodes are found within
   an OpenACC parallel region.
   ```sh
   cd eg14/
   psyclone -s ./acc_parallel.py -nodm main.x90
   ```

3. Adding OpenACC enter data, parallel and loop directives in the
   presence of halo exchanges. This does not currently produce compilable code
   because calls to set_clean()/dirty() end up within parallel regions - TODO
   #450.
   ```sh
   cd eg14/
   psyclone -s ./acc_parallel_dm.py main.x90
   ```

## Example 15: Optimise matvec Kernel for CPU

This example shows how the LFRic matvec kernel can be optimised by
PSyclone in the same way as it was hand optimised to run efficiently
on a multi-core CPU. This is work in progress. To run:
```sh
cd eg15/
psyclone -s ./matvec_opt.py \
../code/gw_mixed_schur_preconditioner_alg_mod.x90 \
-oalg /dev/null -opsy /dev/null
```

## Example 16: Generate LFRic Code Using LFRic PSyIR

This example shows how LFRic-specific PSyIR can be used to create
LFRic code. To run:
```sh
cd eg16/
python create.py
```

## Example 17: Runnable Examples

This subdirectory contains three stand-alone and runnable examples of
the LFRic code. For more details please refer to the relevant
[eg17/README.md](./eg17) document.


## Example 18: Special Accesses of Continuous Fields - Incrementing After Reading and Writing Before (Potentially) Reading.

This example shows the use of kernel with a ``GH_READINC`` access and
a kernel with a ``GH_WRITE`` access, both for fields on continuous
function spaces. ``GH_READINC``
access indicates that a field is first read within a kernel and then
subsequently incremented. The field must, therefore, be on a
continuous function space. The only difference from a PSyclone code
generation point of view (for vanilla distributed memory code
generation) is that a ``GH_READINC`` access will produce a halo
exchange call before the associated kernel whereas a ``GH_INC`` access
will not. The example demonstrates the generation of such a halo
exchange, see the ``CALL mass_flux_i_proxy%halo_exchange(depth=1)``
line in the generated code. if you manually change the metadata to
``GH_INC`` in this example and ensure that the configuration file has
``COMPUTE_ANNEXED_DOFS`` set to ``true``, you will see that this halo
exchange is not generated (although the generated code would then be
invalid).

``GH_WRITE``, when used for a field on a continuous function space, means
that the kernel guarantees to write the same value to a given shared entity,
independent of which cell is currently being updated. This means that
annexed DoFs on owned cells will be correctly computed without the need to
iterate into the L1 halo and thus the outer loop limit is always
``last_edge_cell``, irrespective of whether distributed memory is turned on.

To run:

```sh
cd eg18/
psyclone advection_alg_mod.x90
# Optionally edit 'impose_min_flux_kernel_mod.f90' line 65 to replace
# 'GH_READINC' with 'GH_INC', change the value of 'COMPUTE_ANNEXED_DOFS' to
# 'true' in the config file and re-run psyclone.
```

## Example 19: Mixed precision

This example shows the use of the LFRic mixed-precision support to
call a kernel with scalars, fields and operators of different
precision.

## Code

Location of LFRic algorithm and kernel code that is used by two or
more examples.

## Scripts

A collection of example PSyclone scripts.

# PSyclone Line Length Option

This example demonstrates the use of the line length option. This
option limits the line length of the generated code to a maximum of
132 characters as this is the maximum line length supported by free
format fortran.

This option should be safe for generated code, however there is a
possibility that it will incorrectly line break long lines for
existing code. In particular it does not know about the rules for line
breaking strings. This could be a problem for algorithm code and
module inlined kernel code.

In the example in this directory the call to the `testkern_qr_code`
Kernel subroutine from the generated PSy layer is longer than 132
characters so is line wrapped.

To run from the command line simply type the following:

```sh
psyclone -l -d ../../src/psyclone/tests/test_files/dynamo0p3 longlines.f90
```

To see how to run interactively, look at (and run) the "runme.py"
script

```sh
python ./runme.py
```

pytest tests for the -l option can be found in
[../../src/psyclone/tests/line_length_test.py](../../src/psyclone/tests/line_length_test.py).

<!--
BSD 3-Clause License

Copyright (c) 2019-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

Authors: R. W. Ford, A. R. Porter and S. Siso STFC Daresbury Lab
-->

# PSyclone PSyIR Examples

This directory contains examples of how to create and/or modify
instances of PSyIR and how to use backends to transform them into
code.

All of these examples require PSyclone to be installed.

## Example 1:

Create an instance of PSyIR using many of the generic PSyIR nodes and
output the resultant tree as Fortran and C. Currently the C
backend does not support all of the node types so it only outputs a
subset of the tree. This example may be run by doing:

```sh
> python create.py
```

## Example 2:

Demonstrates how to create and manipulate structure types (a.k.a.
derived types in Fortran) within the PSyIR.
To run this example:

```sh
> python create_structure_types.py
```

## Example 3:

Demonstrates how to manipulate an existing PSyIR tree. This example
imports the PSyIR created in Example 1, applies some modifications
to it and then outputs the modified PSyIR as Fortran code. This example may
be run by doing:

```sh
> python modify.py
```

# PSyclone Kernel Stub Generation

PSyclone provides a utility, `psyclone-kern`, that is able to
take Kernel metadata and generate an appropriate Fortran subroutine
with the correct arguments and datatypes. This is useful for people
developing new Kernels or modifying existing ones to make sure their
implementation has the correct number and type of arguments.

This directory gives an example of the use of `psyclone-kern` for
Kernel stub generation. This particular example defines a Kernel with
four fields, 3 of which have a stencil access.

To run this example type:

```sh
psyclone-kern -gen stub ./testkern_stencil_multi_mod.f90
```

More Kernel examples can be found in the following directory, most of
which start wth the name `testkern`:

[../../src/psyclone/tests/test_files/dynamo0p3](../../src/psyclone/tests/test_files/dynamo0p3)

For example:

```sh
psyclone-kern -gen stub ../../src/psyclone/tests/test_files/dynamo0p3/testkern_qr.F90
```

# PSyclone GOCean Examples

**Authors:** A. R. Porter, S. Siso and R. W. Ford, STFC Daresbury Lab

The sub-directories present in the directory containing this README provide
examples of the use of PSyclone with the GOcean 1.0 API.

## Example 1

Contains a version of the Shallow benchmark with a subset of the kernels
called from within invoke()'s. Contains example scripts showing the use
of PSyclone for adding OpenMP or OpenACC and for performing loop fusion.

## Example 2

A single-kernel example demonstrating the use of PSyclone in generating
a compilable and executable OpenACC code. Note that compiling this
example requires that the dl_esm_inf library ([github.com/stfc/dl_esm_inf](https://github.com/stfc/dl_esm_inf))
be installed first.

## Example 3

Illustrates the use of PSyclone to generate an OpenCL driver layer for
a four-kernel invoke and matching OpenCL kernels. Some useful optimisations
for OpenCL are applied to each kernel.

## Example 4

Examples of the application of kernel transforms to kernels that access
data and/or routines from other Fortran modules. Note that this is not
yet fully supported and is the subject of Issue #342.

## Example 5a

Illustrates the use of the profiling support in PSyclone. The resulting
code may be compiled and executed.

## Example 5b

Illustrates the use of the kernel-data extraction support in PSyclone. The
resulting code may be compiled and executed (requires a netcdf installation).

## Example 5c

Illustrates the use of the read-only verification in PSyclone. The
resulting code may be compiled and executed to show warnings printed
by the read-only verification.

## Example 6

Informs the development of the code generation of PSy-layer code using the
PSyIR language backends.

## Example 7

Demonstrates the use of a script that can transform the algorithm layer.

## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2017-2022, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-----------------------------------------------------------------------------

# PSyclone GOcean Example 7

**Authors:** R. W. Ford and S. Siso, STFC Daresbury Lab

## Introduction

This example demonstrates the use of the trans_alg() script function
to access to algorithm layer.

## Running

The code generation is performed using the `make` command which will
call the necessary PSyclone command. The standard PSyclone code
generation is ignored with the flags `-oalg /dev/null -opsy /dev/null`
as we are interested in the algorithm information output from the
script.

# PSyclone GOcean Example 1

**Authors:** A. R. Porter, S. Siso and A. B. G. Chalk, STFC Daresbury Lab

These scripts and this version of PSyclone work with version 1.0 of GOcean.

In order to use PSyclone you must first install it, ideally with pip.
See `../../../README.md` for more details.

PSyclone can be run in the directory containing this file by 
executing, e.g.

```sh
python ./runme.py
``` 

Examine the runme*.py scripts themselves for further details or see the
Makefile.


## OpenMP tasking transformation script

The OpenMP tasking transformation is provided in the form of a PSyclone
transformation script (`openmp_taskloop_trans.py`). This can be run
using the PSyclone command:

```sh
psyclone -nodm -s ./openmp_taskloop_trans.py -api gocean1.0 shallow_alg.f90
```

## OpenCL PSyclone script

The OpenCL transformation is provided with a PSyclone transformation script
(`opencl_transformation.py`). This can be run using the PSyclone command:

```sh
psyclone -s ./opencl_transformation.py -api gocean1.0 shallow_alg.f90
```


## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2017-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------

# Stand-alone LFRic Kernel OpenACC Example

This directory contains a runnable example of an LFRic mini-app that
uses OpenACC. The framework for this stand-alone example is explained in
more details in the directory
``<PSYCLONEHOME>/examples/lfric/eg17/full_example``.

The script ``acc_parallel_dm.py`` applies the OpenACC transformation to all 
kernels. See the [OpenACC](https://psyclone.readthedocs.io/en/stable/transformations.html#openacc)
section of the PSyclone documentation for details about this transformation.

## Compilation

A simple makefile is provided to compile the example. It needs:
- the infrastructure library ``liblfric.a`` provided in
  ``<PSYCLONEHOME>/src/psyclone/tests/test_files/dynamo0p3/infrastructure``

The infrastructure library will be compiled if it is not available.

The following environment variables can be set to define the compiler
you want to use:
```shell
export F90=gfortran
export F90FLAGS="-Wall -g -fopenacc"
make
```

## Running

The binary can be executed using ``example_openacc`` without additional parameters:
```shell
./example_openacc
 Mesh has           5 layers.
20210318131720.135+1100:INFO : Min/max minmax of field1 =   0.10000000E+01  0.80000000E+01
```

If you are using NVIDIA hardware, you can specify NV_ACC_NOTIFY=3
when running in order to see GPU-related activity.

# PSyclone NEMO Example 2

**Authors:** A. R. Porter, STFC Daresbury Lab
**Modified by:** R. W. Ford, STFC Daresbury Lab
**Modified by:** S. Siso, STFC Daresbury Lab

This directory contains a python script demonstrating the use of
PSyclone to add OpenMP parallelism to the `traldf_iso.F90` code.  Once
you have installed PSyclone, the `omp_levels_trans.py` optimisation
script can be provided to PSyclone with the command:

```sh
psyclone -api "nemo" -s ./omp_levels_trans.py traldf_iso.F90
```

`traldf_iso.F90`, is an unmodified NEMO ocean model routine. This code
can be found in the `../code` directory. The PSyclone command will output
the generated Fortran code with the OpenMP directives added.


## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2018-2022, Science and Technology Facilities Council
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-----------------------------------------------------------------------------

.. -----------------------------------------------------------------------------
.. BSD 3-Clause License
..
.. Copyright (c) 2019-2021, Science and Technology Facilities Council.
.. All rights reserved.
..
.. Redistribution and use in source and binary forms, with or without
.. modification, are permitted provided that the following conditions are met:
..
.. * Redistributions of source code must retain the above copyright notice, this
..   list of conditions and the following disclaimer.
..
.. * Redistributions in binary form must reproduce the above copyright notice,
..   this list of conditions and the following disclaimer in the documentation
..   and/or other materials provided with the distribution.
..
.. * Neither the name of the copyright holder nor the names of its
..   contributors may be used to endorse or promote products derived from
..   this software without specific prior written permission.
..
.. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
.. "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
.. LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
.. FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
.. COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
.. INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
.. BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
.. LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
.. CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.. LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
.. ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.. POSSIBILITY OF SUCH DAMAGE.
.. -----------------------------------------------------------------------------
.. Written by: R. W. Ford, STFC Daresbury Lab

# PSyclone NEMO Example 4 - SIR

The SIR and its Dawn back-end include three simple (Python Interface)
examples. In this directory these three examples are provided in
Fortran and PSyclone scripts are provided which translate the Fortran
code back into SIR (DAWN Python interface code), which can then be run
through the Dawn back end.

We are also working towards supporting the translation of the NEMO
Dwarf (being implemented in the ESCAPE2 project) from Fortran to SIR
(DAWN Python interface code). As the NEMO Dwarf is not yet available
we are currently concentrating on the tracer advection benchmark
(tra_adv) as the codes are very similar. There are three examples
associated with this which are described below.

## PSyclone SIR generation

In order to test the SIR backend, the equivalent Fortran to the
examples provided in Dawn are available in this directory
(`copy_stencil.f90`, `hori_diff.f90` and
`tridiagonal_solve.f90`). When run through PSyclone they should
produce the same (or equivalent) SIR as is in the examples. This then
validates that the translation works correctly.

Two additional examples (`if_example.f90` and `intrinsic_example.f90`)
both extracted from a tracer advection benchmark (which itself was
extracted from the NEMO code base and will form the basis of the NEMO
Dwarf benchmark) test the ability of PSyclone to a) translate if
statements to SIR and b) translate Fortran `min`, `abs` and `sign`
intrinsics to equivalent PSyIR code before translating to SIR (as SIR
does not support intrinsics).

A third additional example (`tra_adv_compute.F90`) is the
computational part of the tracer advection benchmark and this shows
how much of the code can currently be translated (with the parts that
can't be translated being modified or commented out).

To test the `copy_stencil.f90`, `hori_diff.f90`,
`tridiagonal_solve.f90` and `if_example.f90` examples run:

```sh
> psyclone -s ./sir_trans.py -api nemo <filename> -opsy /dev/null
```

To test the `intrinsic_example.f90` and `tra_adv_compute.F90` examples run:

```sh
> psyclone -s ./sir_trans_all.py -api nemo <filename> -opsy /dev/null
```

## Building Dawn

PSyclone has been tested with Dawn master commit hash
568375f8bf3bdb064d006d958323b1b8e31b726e on Monday 9th September 2019.

This version contains a bug which causes the `if_example.f90` example to
fail. This is fixed in the latest version of Dawn master.

To build Dawn with Python support:

```sh
> git clone https://github.com/MeteoSwiss-APN/dawn.git
> cd dawn/bundle
> mkdir build
> cd build
> cmake -DDAWN_BUNDLE_PYTHON=ON -DDAWN_PYTHON_EXAMPLES=ON ..
> make -j8 install
> export PYTHONPATH=<path>/dawn/bundle/install/python
```

## Running existing Dawn examples

```sh
> export PYTHONPATH=<path>/dawn/bundle/install/python
> cd dawn/bundle/install/examples/python
> python3 [copy_stencil.py, hori_diff.py, tridiagonal_solve.py]
> ls data/[copy_stencil.cpp, hori_diff.cpp, tridiagonal_solve.cpp]
```

## Running PSyclone-generated code in Dawn

1. Add the generated code inbetween the "PSyclone code start" and
   "PSyclone code end" comments in the supplied `dawn_script.py` file
   (in the same directory as this README).
2. Run: `cp <path>/dawn/bundle/install/examples/python/config.py .`
3. Run: `export PYTHONPATH=<path>/dawn/bundle/install/python`
4. Run the script with python3: `python3 dawn_script.py`
5. Cuda code will be output in `data/psyclone.cpp`

## Issues/limitations

1. Loop bounds are not analysed yet so it is not possible to add in
   offset and loop ordering for the vertical.
2. There are no checks that the loops conform to the NEMO lat.lon.levs
   convention.
3. The only unary operator currently supported is '-'.
4. Loops must be triply nested.

# PSyclone GOcean Example 2

**Authors:** A. R. Porter, STFC Daresbury Lab

## Introduction

This is a very simple, single-kernel example of the use of PSyclone to
generate an application that will run on a GPU. A second
transformation script is also provided that will add profiling
instrumentation to the PSyclone-generated code. The kernel itself
simply increments a field by adding the current value of the
time-stepping loop index

The Makefile and this version of PSyclone work with version 1.0 of the GOcean
API.

In order to use PSyclone you must first install it, ideally with pip.
See `../../../README.md` for more details.

## Compilation

In order to compile and run this example you will need the dl_esm_inf
infrastructure library installed ([github.com/stfc/dl_esm_inf](https://github.com/stfc/dl_esm_inf)). The
directory containing the dl_esm_inf directory can be specified in the
Makefile (SHARED_DIR) but defaults to the location of the git submodle
(`../../../external/dl_esm_inf`). The compiler and flags to use are
picked up from environment variables (and must be the same as used for
the dl_esm_inf library). e.g. to use the PGI compiler for an NVIDIA
Volta:

```sh
export F90=pgf90
export F90FLAGS="-O3 -Minfo=all -acc -ta=tesla,cc70"
export LDFLAGS="-acc -ta=tesla,cc70"
```

## Profiling

Building the `profile` target causes PSyclone to use the `acc_prof_transform.py`
script. This uses `acc_transform.py` to do the same OpenACC transformations but
then adds a profiling region around the body of the whole PSy layer routine.
Compilation of this example requires that the CUDA toolkit be installed. The
location of this toolkit can be passed to the Makefile by setting the `NVTX_DIR`
variable, e.g.:

```sh
make NVTX_DIR=/usr/local/lib64/cuda10.0 profile
```

This should produce a `single_prof.exe` executable which may be run
with NVIDIA's profiling tools, either `nvprof` or `nvvp`.

## Notes

PSyclone transforms the kernel source and adds a
`!$acc routine` to it to instruct the compiler to build it for the
accelerator device. An alternative solution (at least, for this simple
example) would be to use the '-Mipa=inline:reshape' compiler flag.
(Currently PSyclone's module-inline transformation cannot be used on
a kernel that has been transformed for use with OpenACC -
[issue #229](https://github.com/stfc/PSyclone/issues/229).)

Also, the kernel currently has the extents of the field array
as explicit arguments. This is because PGI does not support
assumed-size arrays within compute regions. Once PSyclone has been
extended to automatically provide this information - [issue #230](https://github.com/stfc/PSyclone/issues/230),
these arguments can be removed from the kernel meta-data and algorithm
layer.

## Licence:

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2018-2019, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------

# Runnable Examples

**Author:** J. Henrichs, Bureau of Meteorology

This directory contains some standalone, runnable examples of LFRic code.
They are based on a subset of the LFRic infrastructure library
included in
``<PSYCLONEHOME>/src/psyclone/tests/test_files/dynamo0p3/infrastructure``.
Significant refactoring was required in order to only include a
small number of infrastructure files from the original LFRic source files.
In many case unnecessary dependencies were just removed. Some examples:
- XIOS was just removed (i.e. code that used XIOS was simply removed).
- YAXT/MPI was completely removed (code that used it was simply removed).
- Some dependencies were removed (for example the ``global_mesh`` module
  also provides functionality for managing collections/maps of 
  global meshes. This needlessly increases the number of files required).
- Other support was just removed (e.g. UGRID, ...), though NetCDF
  support is included.

As a result, the initialisation of LFRic is somewhat different from
the full LFRic model. For example, LFRic typically uses grid-IDs to pass
grids between subroutines (which requires global management objects to handle
the IDs), while the PSyclone LFRic infrastructure relies on passing pointers
to objects.

The examples in this subdirectory show:
- A [full_example](./full_example) of a stand-alone LFRic-based code. It
  shows the use of the reduced infrastructure library to create LFRic code.
  PSyclone is used to process two invoke statements.
- A stand-alone example using [NetCDF](./full_example_netcdf) to read
  in a mesh.
- [Extraction](./full_example_extract) of input and output parameters
  of a kernel to a NetCDF file.

Detailed instructions are in the ``README.md`` files in the corresponding
subdirectories.

<!--
## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------
-->

# PSyclone NEMO Example 3

**Authors:** R. W. Ford and A. R. Porter, STFC Daresbury Lab

This directory contains a relatively simple example transformation script,
`kernels_trans.py`.  This demonstrates the use of PSyclone to add OpenACC
Kernel and Data directives to NEMO code. Note, the transformations are
indicative of what could be done - no claim is made as to the performance of
the resulting code.

A more sophisticated `kernels_trans.py` script is provided in the
`../scripts` directory. This is designed to work with the NVIDIA (PGI)
compiler's 'managed memory' option (`-ta=tesla:managed`) and therefore makes
no attempt to control data movement to/from the GPU. It also adds
profiling instrumentation around those parts of the code that have
not been enclosed within an OpenACC KERNELS region.

Once you have installed PSyclone, either script may be supplied to
PSyclone via the -s option, e.g.:

```sh
psyclone -api nemo -s ./kernels_trans.py ../code/tra_adv.F90
```

Executing this will output 1) the PSyclone invokes found in the code,
2) PSyclone's Schedule view of the original code, 3) PSyclone's
Schedule view of the code after adding OpenACC Kernels directives, 4)
PSyclone's Schedule view of the code after adding OpenACC Kernels and
Data directives, and 5) the transformed Fortran code with the OpenACC
directives added. Note that some of the lines in this Fortran code will
exceed the 132-character limit. This may be remedied by supplying the
`-l all` flag to PSyclone (as is done in the Makefile).

Running PSyclone with the `../scripts/kernels_trans.py` script will
produce similar output but the Schedule will contain `Profile` nodes
and there will be no Data directives.

`tra_adv.F90` is a stand-alone version of one of the tracer-advection
routines from the NEMO ocean model. It was originally extracted by
Silvia Mocavero of CMCC. The code can be found in the `../code`
directory.

## Compiling and Execution

If desired this example may be compiled and executed on a GPU device
provided a suitable compiler with OpenACC support is available. Note
that this example is only provided to demonstrate how one adds OpenACC
directives using PSyclone with the NEMO API. It is not intended to
demonstrate how to obtain good performance.

Since `tra_adv.F90` is instrumented for use with the dl_timer library,
this library is also required. It is available from
[bitbucket.org/apeg/dl_timer](https://bitbucket.org/apeg/dl_timer).

Once dl_timer has been downloaded, the supplied Makefile must be
edited to supply the location of the library. The compiler and flags
must be specified via the F90 and F90FLAGS environment variables, e.g.
to use PGI and OpenACC:

```sh
export F90=pgf90
export F90FLAGS="-O1 -acc -ta=tesla,cc70 -Minfo=all"
export LDFLAGS="-acc -ta=tesla,cc70"
```

The size of domain and number of time-steps are also picked-up from
environment variables. Some example settings are provided in the
`domain_setup.sh` file.

## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2018-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-----------------------------------------------------------------------------

# PSyclone GOcean Example 3

**Authors:** A. R. Porter and S. Siso, STFC Daresbury Lab

The directory containing this file contains an example of the use of
PSyclone to generate OpenCL code with the GOcean 1.0 API.

In order to use PSyclone you must first install it, ideally with pip.
See `../../../README.md` for more details.

PSyclone can be run in the directory containing this file by 
executing, e.g.:

```sh
psyclone -api "gocean1.0" alg.f90
```

This will generate 'vanilla' PSy-layer code which is output to stdout.

In order to generate an OpenCL PSy layer instead, PSyclone must be
provided with a transformation script::

```sh
psyclone -api "gocean1.0" -s ./ocl_trans.py alg.f90
```

where `ocl_trans.py` simply applies the
`psyclone.domain.gocean.transformations.GOOpenCLTrans`
transformation to the Schedule of the Invoke. This will generate the OpenCL
driver layer to stdout and a 'kernel_name'.cl file for each of the kernels
referenced in alg.f90 translated to OpenCL.

To compile the application the Makefile provides the target:
```sh
make compile-ocl
```
This target will execute the `ocl_trans.py` script with PSyclone and generate
the necessary files. Note that this application depends on the dl_esm_inf and
FortCL libraries. The directory containing this libraries can be specified
in the Makefile (SHARED_DIR) but defaults to the git submodules provided by
this repository.

An OpenCL implementation needs to be installed in the system for the compilation
to succeed. There are multiple OpenCL implementations provided by the main
vendors (Intel, AMD, NVidia, Xilinx) or portable implementations provided by
the distributions, e.g. POCL, which in Ubuntu 20.04 can be installed with:
```sh
sudo apt-get install opencl-headers ocl-icd-opencl-dev pocl-opencl-icd
```

To run the application, the `FORTCL_KERNELS_FILE` environment variable needs
to provide the OpenCl kernels. These can be in source-code format (for JIT
compilation) or compiled ahead-of-time. The Makefile compile-ocl target already
generate an `allkernels.cl` file with includes the source code of all needed
kernels. To run the application with this file use the following command:
```sh
FORTCL_KERNELS_FILE=allkernels.cl ./alg_opencl.exe
```

This Makefile also provides a target to combine OpenCL and distributed
memory:
```sh
make compile-mpi-ocl
```

In addition to the details above, the distributed memory target needs an mpi
compiler specified by the F90 environment variable and that the libraries have
been compiled with that compiler. The example can be compiled and executed
across 2 nodes with the following commands:

```sh
make allclean
export F90=mpifc
make compile-mpi-ocl
FORTCL_KERNELS_FILE=allkernels.cl mpirun -n 2 ./alg_dm_opencl.exe
```

The previous example uses a single accelerator device in each node. If more
than one accelerator is available in each node, these can be used by setting
the `OCL_DEVICES_PER_NODE` parameter in the PSyclone configuration file and
then providing the mpirun command with the appropriate parameter to place as
many MPI ranks per node as as there are accelerators devices. For example,
with Intel MPI, the following command can be used to run across 2 nodes with
2 devices per node:

```sh
# Update psyclone.cfg
make allclean
export F90=mpifc
make compile-mpi-ocl
FORTCL_KERNELS_FILE=allkernels.cl mpirun -n 4 -ppn 2 ./alg_dm_opencl.exe
```

## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2018-2021, Science and Technology Facilities Council
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------

# PSyclone GOcean Example 6

**Author:** S. Siso, STFC Daresbury Lab

## Introduction

This example informs the development of the code generation of PSy-layer
code using the PSyIR language backends.


## Running

The code generation is performed using the `make` command which will call
the necessary PSyclone command. The standard PSyclone code generation is
ignored with the flags `-oalg /dev/null -opsy /dev/null` and for now the
PSyclone transformation script itself is responsible for generating the
code and writing it to stdout.

The code generation is incomplete, so no options to compile nor run the code
have been added to the Makefile.

# PSyclone PSyAD Example1: creating an adjoint kernel and test harness.

**Author:** A. R. Porter, STFC Daresbury Lab
**Modified by:** R. W. Ford, STFC Daresbury Lab

In order to use PSyclone you must first install it, ideally with pip.
See `../../../README.md` for more details.

This example demonstrates the use of PSyAD to create the adjoint of a
simple kernel (contained in `testkern_mod.f90`).
It also demonstrates the creation of a test harness for the adjoint kernel.

PSyAD can be run in the directory containing this file by executing, e.g.

```sh
make
```

Alternatively, PSyAD may be run from the command line as:

```sh
psyad -t -otest test_harness.f90 -oad testkernadj_mod.f90 testkern_mod.f90
```

This will generate two new files, `testkernadj_mod.f90` and `test_harness.f90`.

The Makefile also supports the `compile` target which will build
the kernel, its adjoint and the test harness. The `run` target will execute
the test harness giving output something like:

```sh
Running PSyAD-generated test harness...
 Test of adjoint of 'testkern_code' passed: diff =    0.0000000000000000
...done.
```

Note, you may find that the test fails, but if so the diff should be
relatively small.

## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------

# PSyclone GOcean Example 4

**Authors:** A. R. Porter and S. Siso, STFC Daresbury Lab

The directory containing this file contains an example of the use of
PSyclone to transform kernels that access variables and routines
via module use statements.

In order to use PSyclone you must first install it, ideally with pip.
See `../../../README.md` for more details.

PSyclone can be run in the directory containing this file by 
executing, e.g.:

```sh
psyclone -api "gocean1.0" alg_kern_with_use.f90
```

This will produce 'vanilla' PSy code along with a re-written version of
the algorithm.

The example algorithm files (alg_*.f90) each contain an Invoke that
calls a single kernel. Each of these illustrates a different aspect
of kernels accessing data/routines via module use statements:

1. `alg_kern_use_var` - an example of a kernel that uses a variable
   declared in another module;

2. `alg_kern_call_kern` - a kernel that calls another routine (kernel)
   defined in another module;

3. `alg_nested_use` - a kernel that calls another routine that itself
   uses data defined in another module.

These various forms of kernel only present a problem if a user wishes
to transform them e.g. for use in either an OpenACC or OpenCL
application. For instance, we can use PSyclone with a suitable
transformation script (employing the `KernelImportsToArguments` and
`GOOpenCLTrans` transformations) to generate OpenCL code for the first
example:

```sh
psyclone -api "gocean1.0" -s ./ocl_transform.py alg_kern_use_var.f90
```

The generated PSy- and Algorithm-layer code is written to stdout and a
transformed version of the kernel is written to
kern_use_var_kern_use_var_0.cl. This kernel has the `gravity` variable
(previously accessed from a module in the original Fortran) passed by
argument:

    __kernel void kern_use_var_code(
      __global double * restrict fld,
      double gravity
      ){

Similarly, we can generate an OpenACC version of the same example by
doing:

```sh
psyclone -api "gocean1.0" -s ./acc_transform.py alg_kern_use_var.f90
```

which write the OpenACC PSy- and Algorithm-layer code to stdout with
the used kernel inlined in the PSy-layer.

However, attempting to perform the same transformation for the
`alg_kern_call_kern` example will not work - although the kernels
named in the Invoke would be transformed, the other kernels that they
then call would not and this means that they would not be compiled for
execution on the OpenACC device.
Support for recursive kernel transformation is the subject of
[Issue #342](https://github.com/stfc/PSyclone/issues/342) and will
be demonstrated by:

```sh
psyclone -api "gocean1.0" -s ./acc_transform.py alg_kern_call_kern.f90
```

Currently this raises a TransformationError because PSyclone spots
that the kernel accesses the global symbol 'my_function'.

The third example:

```sh
psyclone -api "gocean1.0" -s ./acc_transform.py alg_nested_use.f90
```

also currently raises a TransformationError for the same reason.


Additionally, this example's Makefile has the necessary rules to compile
the OpenAcc version of `alg_kern_use_var.f90`. This is done with the
`compile-acc` target. Note that this requires an OpenACC compatible compiler
(currently the Makefile only supports pgf90 - the build system flags will need
to be updated to support other OpenACC compilers) and the infrastructure libraries
must be built with the same compiler. To make sure the infrastructure and the
generated files are compiled as described, we can do:

```sh
export F90=pgf90
make allclean
make compile-acc
```


## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2019-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

-----------------------------------------------------------------------------

# PSyclone GOcean PSyData Profiling Example

**Author:** J. Henrichs, Bureau of Meteorology

## Introduction

This is a very simple test that shows how to use the profiling
support in PSyclone. It is a stand alone program that can be compiled
and run. 

## Compilation
The makefile supports compiling and linking with the following PSyclone
profile wrapper libraries:
- template
- simple_timing
- dl_timer
- drhook
- lfric

By default (``make`` without an argument) the ``template`` library will 
be used, which just prints the name of the regions called.
In order to test any of the other libraries, just use the
command ``make <wrapper library name>`` and use the name listed above
for ``<wrapper library name>``. The name of the executable will be
``profile_test.<wrapper library name>``. There is also a target ``make all``
which will create executables for all libraries listed above.    

You have to compile the GOcean infrastructure library
dl_esm_inf, and the corresponding profile wrapper library in
``lib/profiling``. By default, the compilation uses the version
of the dl_esm_inf library provided as a git submodule (under
``external/dl_esm_inf ``- see
https://psyclone-dev.readthedocs.io/en/latest/working_practises.html)
within the PSyclone repository (set the environment variable``INF_DIR``
for the ``make`` command to pick a different version). The default build
uses the "template" profiling library in ``lib/profiling/template``.
More detailed instructions for compiling these libraries are are given in
the corresponding subdirectories.

If you are using ``dl_timer`` or ``drhook``, you need to compile these
libraries yourself first, and modify the ``Makefile`` in this directory
to specify the required linking parameters. The ``Makefile``
supports the following environment variables that can be defined
to find the various software packages:

### INF_DIR:
The location of the dl_esm_inf infrastructure library, it defaults to
``../../../../external/dl_esm_inf/finite_difference``,
which is the version included in PSyclone.
### DL_TIMER_ROOT:
The location of the apeg-dl_timer library. It defaults to
``../../../../../apeg-dl_timer``, i.e. it is assumed that apeg-dl_timer
is installed next to PSyclone.
Note that until Issue #730 is complete, executing this example
will fail as the labels produced by PSyclone are longer than
permitted by the dl_timer library.
### DRHOOK_DIR:
The location of DrHook. It defaults to
``../../../../../drhook``, i.e. it is assumed that DrHook is
installed next to PSyclone.
### LFRIC_DIR
The location of the LFRic infrastructure library. It defaults to
``../../../src/psyclone/tests/test_files/dynamo0p3/infrastructure``,
which is the small, stand-alone LFRic infrastructure library that
is included in PSyclone. In spite of the dependence on LFRic, this
profiling wrapper library can be used with with any application.

The makefile here will invoke psyclone with the ``--profile invokes``
flag, which will add profiling around the two invokes used in the example.

### Note:
The actual runtime is extremely short, so likely the profiling
tool used will report 0 seconds for each of the invokes.

### Note for LFRic wrapper library
The LFRic timer library writes its output to a file ``timer.txt``
(and it will overwrite this file if it should already exist).

## Running
The output will depend on the wrapper library used. For the ``template``
library, you should see:
```
 ...
 profile_PSyDataInit called
 ...
 PreStart called for module 'psy_test' region 'invoke_0:r0'
 PostEnd called for module 'psy_test' region 'invoke_0:r0'
 PreStart called for module 'psy_test' region 'invoke_1_update_field:update_field_code:r0'
 PostEnd called for module 'psy_test' region 'invoke_1_update_field:update_field_code:r0'
 ...  
 profile_PSyDataShutdown called
```

## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2020-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------

# Standalone LFRic Kernel Extraction Example

This directory contains a runnable example of kernel extraction
with LFRic. The main code is explained in more details in the
directory ``../full_example``.

It applies the PSyData extraction transformations to the
user-supplied kernels (due to #637 we cannot instrument builtins
at the moment). See the [PSyKE](https://psyclone.readthedocs.io/en/stable/psyke.html)
chapter of the PSyclone documentation for details about this transformation.

## Compilation

A simple makefile is provided to compile the example. It needs:
- the infrastructure library ``liblfric.a`` provided in
  ``<PSYCLONEHOME>/src/psyclone/tests/test_files/dynamo0p3/infrastructure``
- the LFRic PSyData wrapper library ``lib_kernel_data_netcdf`` from
  ``<PSYCLONEHOME>/lib/extract/netcdf/lfric``, and
- NetCDF

The infrastructure and PSyData wrapper libraries will be compiled
if they are not available.

The following environment variables can be set to define the compiler
you want to use:
```shell
export F90=gfortran
export F90FLAGS="-Wall -g -fcheck=bound"
make
```

The location of the PSyData wrapper library can be set with
the environment variable ``EXTRACT_DIR``, and the location
of the LFRic infrastructure libraries is set using
``LFRIC_DIR`` - both defaulting to the versions included in
PSyclone.

## Running

The binary can be executed using ``extract`` without additional parameters:
```shell
./extract 
 Mesh has           5 layers.
20210318131720.135+1100:INFO : Min/max minmax of field1 =   0.10000000E+01  0.80000000E+01
```
This will produce a NetCDF file called ``main-update.nc``:
```shell
ncdump main-update.nc | less
netcdf main-update {
dimensions:
        field1dim%1 = 539 ;
        field2dim%1 = 539 ;
        map_w0dim%1 = 27 ;
        map_w0dim%2 = 9 ;
        field1_postdim%1 = 539 ;
variables:
        double field1(field1dim%1) ;
        double field2(field2dim%1) ;
        int map_w0(map_w0dim%2, map_w0dim%1) ;
        int ndf_w0 ;
        int nlayers ;
        int undf_w0 ;
        int cell_post ;
        double field1_post(field1_postdim%1) ;
data:

 field1 = 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
...
```

# PSyclone GOcean PSyData Kernel-Extraction Example

**Author** J. Henrichs, Bureau of Meteorology

## Introduction

This is a very simple test that shows how to use the kernel-data extraction
support in PSyclone. It is a stand-alone program that can be compiled
and run.

## Compilation
This example needs two libraries: the gocean infrastructure library
dl_esm_inf, and a corresponding extraction library. By default
it will use the infrastructure library in ``../../../../external/dl_esm_inf``
and automatically compile this library
(see https://psyclone-dev.readthedocs.io/en/latest/working_practises.html
for the correct way of checking out all required software) . You can set
the environment variable ``INF_DIR`` to point to a different directory.
The NetCDF extraction library in ``../../../../lib/extract/netcdf`` is used
as default, and will also be automatically compiled. You can set the
environment variable ``EXTRACT_DIR`` to point to a different library if 
required. More details on compiling these libraries are in the
corresponding subdirectories.
To create and compile the example, modify the Makefile if required
and type ``make``.

PSyclone is supplied with the ``extract_transform.py`` transformation script
which will add extract regions around the invokes:
```
psyclone -nodm -l -api "gocean1.0"             \
         --config ../../../../config/psyclone.cfg \
         -s ./extract_transform.py             \
         -opsy psy.f90 -oalg alg.f90 test.x90
```

This will also create two driver files, but because of #644 the
driver will not compile.

## Running
When running the program, you should see:
```
parallel_init: Not running with MPI
go_decompose: using grid of   1x  1
Tile width =    3, tile height =    3
...
Allocating C-T field with bounds: (1: 12,1:  6)
Internal region is:(2:  4,2:  4)
Grid has bounds:  (1: 12,1:  6)
   15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000        15.000000000000000     
```

Two NetCDF files will be produced, one for each of the two invokes
instrumented with an extract region.

## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2020-2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------

# PSyclone GOcean PSyData NaN-check Example

**Author:** J. Henrichs, Bureau of Meteorology

## Introduction

This is a simple example that shows how to use the NaN verification
support in PSyclone. It is a stand-alone program that can be compiled
and run. 

## Compilation
A makefile is provided to compile this example. If required,
it will compile the dl_esm_inf library and the nan_test
wrapper library. By default, the compilation uses the version
of the dl_esm_inf library provided as a git submodule (under
``../../../external/dl_esm_inf/finite_difference``- see
https://psyclone-dev.readthedocs.io/en/latest/working_practises.html)
within the PSyclone repository. You can set the environment variable
``INF_DIR`` for the ``make`` command to pick a different version.

The makefile here invokes psyclone with the script ``test_nan_transform.py``.
This script uses PSyclone's ``NanTestTrans`` to instrument the two
invokes in the ``test.x90`` source file.

The source code computes divisions by 0 on the diagonals, resulting in
invalid numbers (Infinity).

## Running
```
$ ./nan_test
...
Allocating C-T field with bounds: (1:   6,1:   6), internal region is (2:   4,2:   4)
PSyData: Variable a_fld has the invalid value Inf at index/indices 1 1 in module 'main' region 'update'.
PSyData: Variable a_fld has the invalid value Inf at index/indices 2 2 in module 'main' region 'update'.

```
After calling the kernel ``mainupdate``, five warnings are printed,
indicating that the field ``a_fld`` has a value of infinity on the diagonals
(i.e. indices 1 1, ..., 5 5).

## Licence

-----------------------------------------------------------------------------

BSD 3-Clause License

Copyright (c) 2021, Science and Technology Facilities Council.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------

# Standalone LFRic Example with NetCDF

This example contains the minimum infrastructure required to create
a field, and call a simple kernel on this field. The grid is read
from the NetCDF file ``mesh_BiP128x16-400x100.nc``. The following
steps are required for this (using simplified code examples):

1) A global mesh is created from a NetCDF file:
    ```fortran
    global_mesh = global_mesh_type("mesh_BiP128x16-400x100.nc", "dynamics")
    ```
   
2) A 1x1 planar partition for one process is created:
    ```fortran
    partitioner_ptr => partitioner_planar
    partition = partition_type(global_mesh_ptr, &
                               partitioner_ptr, &
                               1, 1,  &    ! # procs in x and y direction
                               0,     &    ! max stencil size
                               0,     &    ! local rank
                               1)          ! number of proceses
    ```

3) Create a uniform extrusion:
    ```fortran
    extrusion = uniform_extrusion_type(0.0d0, 100.0d0, 5)
    extrusion_ptr => extrusion
    ```

4) Create a mesh using the global mesh, partition and extrusion:
    ```fortran
    mesh = mesh_type(global_mesh_ptr, partition, extrusion_ptr)
    ```

5) Create a function/vector space:
    ```fortran
    vector_space = function_space_type( mesh,          &
                                        element_order, &
                                        lfric_fs,      &
                                        ndata_sz)
    ```

6) Create two fields for the test kernel:
    ```fortran
    call field1%initialise( vector_space = vector_space_ptr, name="field1" )
    call field2%initialise( vector_space = vector_space_ptr, name="field2" )
    ```

7) Call some built-ins:
    ```fortran
    call invoke( name = 'Initialise fields',        &
                 setval_c( field1,     0.0_r_def ), &
                 setval_c( field2,     1.0_r_def )  &
                 )
    ```

8) Call a user-defined kernel:
    ```fortran
    call invoke( name = 'testkern_w0', testkern_w0_type(field1, field2) )
    ```

## Compilation

A simple makefile is provided to compile the example. It needs 
a full installation of NetCDF, since it is using ``nf-config`` to
query the required compiler and linker flags, and the
infrastructure library ``liblfric_netcdf.a`` provided in
``<PSYCLONEHOME>/src/psyclone/tests/test_files/dynamo0p3/infrastructure``.
If the latter is not available, it will be automatically compiled.

The following environment variables can be set to define the compiler
you want to use:
```shell
export F90=gfortran
export F90FLAGS="-Wall -g -fcheck=bound $(nf-config --fflags)"

make compile
```

## Running

The binary ``example`` can be executed without any parameters:
```shell
./example
 Mesh has           5 layers.
20210318131551.091+1100:INFO : Min/max minmax of field1 =   0.10000000E+01  0.80000000E+01
```

MODULE traldf_iso
   !!======================================================================
   !!                   ***  MODULE  traldf_iso  ***
   !! Ocean  tracers:  horizontal component of the lateral tracer mixing trend
   !!======================================================================
   !! History :  OPA  ! 1994-08  (G. Madec, M. Imbard)
   !!            8.0  ! 1997-05  (G. Madec)  split into traldf and trazdf
   !!            NEMO ! 2002-08  (G. Madec)  Free form, F90
   !!            1.0  ! 2005-11  (G. Madec)  merge traldf and trazdf :-)
   !!            3.3  ! 2010-09  (C. Ethe, G. Madec) Merge TRA-TRC
   !!            3.7  ! 2014-01  (G. Madec, S. Masson)  restructuration/simplification of aht/aeiv specification
   !!             -   ! 2014-02  (F. Lemarie, G. Madec)  triad operator (Griffies) + Method of Stabilizing Correction
   !!----------------------------------------------------------------------

   !!----------------------------------------------------------------------
   !!   tra_ldf_iso   : update the tracer trend with the horizontal component of a iso-neutral laplacian operator
   !!                   and with the vertical part of the isopycnal or geopotential s-coord. operator 
   !!----------------------------------------------------------------------
   USE oce            ! ocean dynamics and active tracers
   USE dom_oce        ! ocean space and time domain
   USE trc_oce        ! share passive tracers/Ocean variables
   USE zdf_oce        ! ocean vertical physics
   USE ldftra         ! lateral diffusion: tracer eddy coefficients
   USE ldfslp         ! iso-neutral slopes
   USE diaptr         ! poleward transport diagnostics
   USE diaar5         ! AR5 diagnostics
   !
   USE in_out_manager ! I/O manager
   USE iom            ! I/O library
   USE phycst         ! physical constants
   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)

   IMPLICIT NONE
   PRIVATE

   PUBLIC   tra_ldf_iso   ! routine called by step.F90

   LOGICAL  ::   l_ptr   ! flag to compute poleward transport
   LOGICAL  ::   l_hst   ! flag to compute heat transport

   !! * Substitutions
!#  include "vectopt_loop_substitute.h90"
   !!----------------------------------------------------------------------
   !! NEMO/OPA 3.7 , NEMO Consortium (2015)
   !! $Id: traldf_iso.F90 9124 2017-12-19 08:26:25Z gm $
   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
   !!----------------------------------------------------------------------
CONTAINS

  SUBROUTINE tra_ldf_iso( kt, kit000, cdtype, pahu, pahv, pgu , pgv ,   &
      &                                                   pgui, pgvi,   &
      &                                       ptb , ptbb, pta , kjpt, kpass )
      !!----------------------------------------------------------------------
      !!                  ***  ROUTINE tra_ldf_iso  ***
      !!
      !! ** Purpose :   Compute the before horizontal tracer (t & s) diffusive 
      !!      trend for a laplacian tensor (ezxcept the dz[ dz[.] ] term) and 
      !!      add it to the general trend of tracer equation.
      !!
      !! ** Method  :   The horizontal component of the lateral diffusive trends 
      !!      is provided by a 2nd order operator rotated along neural or geopo-
      !!      tential surfaces to which an eddy induced advection can be added
      !!      It is computed using before fields (forward in time) and isopyc-
      !!      nal or geopotential slopes computed in routine ldfslp.
      !!
      !!      1st part :  masked horizontal derivative of T  ( di[ t ] )
      !!      ========    with partial cell update if ln_zps=T
      !!                  with top     cell update if ln_isfcav
      !!
      !!      2nd part :  horizontal fluxes of the lateral mixing operator
      !!      ========    
      !!         zftu =  pahu e2u*e3u/e1u di[ tb ]
      !!               - pahu e2u*uslp    dk[ mi(mk(tb)) ]
      !!         zftv =  pahv e1v*e3v/e2v dj[ tb ]
      !!               - pahv e2u*vslp    dk[ mj(mk(tb)) ]
      !!      take the horizontal divergence of the fluxes:
      !!         difft = 1/(e1e2t*e3t) {  di-1[ zftu ] +  dj-1[ zftv ]  }
      !!      Add this trend to the general trend (ta,sa):
      !!         ta = ta + difft
      !!
      !!      3rd part: vertical trends of the lateral mixing operator
      !!      ========  (excluding the vertical flux proportional to dk[t] )
      !!      vertical fluxes associated with the rotated lateral mixing:
      !!         zftw = - {  mi(mk(pahu)) * e2t*wslpi di[ mi(mk(tb)) ]
      !!                   + mj(mk(pahv)) * e1t*wslpj dj[ mj(mk(tb)) ]  }
      !!      take the horizontal divergence of the fluxes:
      !!         difft = 1/(e1e2t*e3t) dk[ zftw ]
      !!      Add this trend to the general trend (ta,sa):
      !!         pta = pta + difft
      !!
      !! ** Action :   Update pta arrays with the before rotated diffusion
      !!----------------------------------------------------------------------
      INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
      INTEGER                              , INTENT(in   ) ::   kit000     ! first time step index
      CHARACTER(len=3)                     , INTENT(in   ) ::   cdtype     ! =TRA or TRC (tracer indicator)
      INTEGER                              , INTENT(in   ) ::   kjpt       ! number of tracers
      INTEGER                              , INTENT(in   ) ::   kpass      ! =1/2 first or second passage
      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   pahu, pahv ! eddy diffusivity at u- and v-points  [m2/s]
      REAL(wp), DIMENSION(jpi,jpj    ,kjpt), INTENT(in   ) ::   pgu, pgv   ! tracer gradient at pstep levels
      REAL(wp), DIMENSION(jpi,jpj,    kjpt), INTENT(in   ) ::   pgui, pgvi ! tracer gradient at top   levels
      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! tracer (kpass=1) or laplacian of tracer (kpass=2)
      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptbb       ! tracer (only used in kpass=2)
      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend
      !
      INTEGER  ::  ji, jj, jk, jn   ! dummy loop indices
      INTEGER  ::  ikt
      INTEGER  ::  ierr             ! local integer
      REAL(wp) ::  zmsku, zahu_w, zabe1, zcof1, zcoef3   ! local scalars
      REAL(wp) ::  zmskv, zahv_w, zabe2, zcof2, zcoef4   !   -      -
      REAL(wp) ::  zcoef0, ze3w_2, zsign, z2dt, z1_2dt   !   -      -
      REAL(wp), DIMENSION(jpi,jpj)     ::   zdkt, zdk1t, z2d
      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdit, zdjt, zftu, zftv, ztfw 
      !!----------------------------------------------------------------------
      !
      IF( kt == kit000 )  THEN
         IF(lwp) WRITE(numout,*)
         IF(lwp) WRITE(numout,*) 'tra_ldf_iso : rotated laplacian diffusion operator on ', cdtype
         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
         !
         akz     (:,:,:) = 0._wp      
         ah_wslp2(:,:,:) = 0._wp
      ENDIF
      !   
      l_hst = .FALSE.
      l_ptr = .FALSE.
      IF( cdtype == 'TRA' .AND. ln_diaptr )                                                 l_ptr = .TRUE. 
      IF( cdtype == 'TRA' .AND. ( iom_use("uadv_heattr") .OR. iom_use("vadv_heattr") .OR. &
         &                        iom_use("uadv_salttr") .OR. iom_use("vadv_salttr")  ) )   l_hst = .TRUE.
      !
      !                                            ! set time step size (Euler/Leapfrog)
      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;   z2dt =     rdt      ! at nit000   (Euler)
      ELSE                                        ;   z2dt = 2.* rdt      !             (Leapfrog)
      ENDIF
      z1_2dt = 1._wp / z2dt
      !
      IF( kpass == 1 ) THEN   ;   zsign =  1._wp      ! bilaplacian operator require a minus sign (eddy diffusivity >0)
      ELSE                    ;   zsign = -1._wp
      ENDIF
         
      !!----------------------------------------------------------------------
      !!   0 - calculate  ah_wslp2 and akz
      !!----------------------------------------------------------------------
      !
      IF( kpass == 1 ) THEN                  !==  first pass only  ==!
         !
         DO jk = 2, jpkm1
            DO jj = 2, jpjm1
               DO ji = fs_2, fs_jpim1   ! vector opt.
                  !
                  zmsku = wmask(ji,jj,jk) / MAX(   umask(ji  ,jj,jk-1) + umask(ji-1,jj,jk)          &
                     &                           + umask(ji-1,jj,jk-1) + umask(ji  ,jj,jk) , 1._wp  )
                  zmskv = wmask(ji,jj,jk) / MAX(   vmask(ji,jj  ,jk-1) + vmask(ji,jj-1,jk)          &
                     &                           + vmask(ji,jj-1,jk-1) + vmask(ji,jj  ,jk) , 1._wp  )
                     !
                  zahu_w = (   pahu(ji  ,jj,jk-1) + pahu(ji-1,jj,jk)    &
                     &       + pahu(ji-1,jj,jk-1) + pahu(ji  ,jj,jk)  ) * zmsku
                  zahv_w = (   pahv(ji,jj  ,jk-1) + pahv(ji,jj-1,jk)    &
                     &       + pahv(ji,jj-1,jk-1) + pahv(ji,jj  ,jk)  ) * zmskv
                     !
                  ah_wslp2(ji,jj,jk) = zahu_w * wslpi(ji,jj,jk) * wslpi(ji,jj,jk)   &
                     &               + zahv_w * wslpj(ji,jj,jk) * wslpj(ji,jj,jk)
               END DO
            END DO
         END DO
         !
         IF( ln_traldf_msc ) THEN                ! stabilizing vertical diffusivity coefficient
            DO jk = 2, jpkm1
               DO jj = 2, jpjm1
                  DO ji = fs_2, fs_jpim1
                     akz(ji,jj,jk) = 0.25_wp * (                                                                     &
                        &              ( pahu(ji  ,jj,jk) + pahu(ji  ,jj,jk-1) ) / ( e1u(ji  ,jj) * e1u(ji  ,jj) )   &
                        &            + ( pahu(ji-1,jj,jk) + pahu(ji-1,jj,jk-1) ) / ( e1u(ji-1,jj) * e1u(ji-1,jj) )   &
                        &            + ( pahv(ji,jj  ,jk) + pahv(ji,jj  ,jk-1) ) / ( e2v(ji,jj  ) * e2v(ji,jj  ) )   &
                        &            + ( pahv(ji,jj-1,jk) + pahv(ji,jj-1,jk-1) ) / ( e2v(ji,jj-1) * e2v(ji,jj-1) )   )
                  END DO
               END DO
            END DO
            !
            IF( ln_traldf_blp ) THEN                ! bilaplacian operator
               DO jk = 2, jpkm1
                  DO jj = 1, jpjm1
                     DO ji = 1, fs_jpim1
                        akz(ji,jj,jk) = 16._wp * ah_wslp2(ji,jj,jk)   &
                           &          * (  akz(ji,jj,jk) + ah_wslp2(ji,jj,jk) / ( e3w_n(ji,jj,jk) * e3w_n(ji,jj,jk) )  )
                     END DO
                  END DO
               END DO
            ELSEIF( ln_traldf_lap ) THEN              ! laplacian operator
               DO jk = 2, jpkm1
                  DO jj = 1, jpjm1
                     DO ji = 1, fs_jpim1
                        ze3w_2 = e3w_n(ji,jj,jk) * e3w_n(ji,jj,jk)
                        zcoef0 = z2dt * (  akz(ji,jj,jk) + ah_wslp2(ji,jj,jk) / ze3w_2  )
                        akz(ji,jj,jk) = MAX( zcoef0 - 0.5_wp , 0._wp ) * ze3w_2 * z1_2dt
                     END DO
                  END DO
               END DO
           ENDIF
           !
         ELSE                                    ! 33 flux set to zero with akz=ah_wslp2 ==>> computed in full implicit
            akz(:,:,:) = ah_wslp2(:,:,:)      
         ENDIF
      ENDIF
      !
      !                                                          ! ===========
      DO jn = 1, kjpt                                            ! tracer loop
         !                                                       ! ===========
         !                                               
         !!----------------------------------------------------------------------
         !!   I - masked horizontal derivative 
         !!----------------------------------------------------------------------
!!gm : bug.... why (x,:,:)?   (1,jpj,:) and (jpi,1,:) should be sufficient....
         zdit (1,:,:) = 0._wp     ;     zdit (jpi,:,:) = 0._wp
         zdjt (1,:,:) = 0._wp     ;     zdjt (jpi,:,:) = 0._wp
         !!end

         ! Horizontal tracer gradient 
         DO jk = 1, jpkm1
            DO jj = 1, jpjm1
               DO ji = 1, fs_jpim1   ! vector opt.
                  zdit(ji,jj,jk) = ( ptb(ji+1,jj  ,jk,jn) - ptb(ji,jj,jk,jn) ) * umask(ji,jj,jk)
                  zdjt(ji,jj,jk) = ( ptb(ji  ,jj+1,jk,jn) - ptb(ji,jj,jk,jn) ) * vmask(ji,jj,jk)
               END DO
            END DO
         END DO
         IF( ln_zps ) THEN      ! botton and surface ocean correction of the horizontal gradient
            DO jj = 1, jpjm1              ! bottom correction (partial bottom cell)
               DO ji = 1, fs_jpim1   ! vector opt.
                  zdit(ji,jj,mbku(ji,jj)) = pgu(ji,jj,jn)          
                  zdjt(ji,jj,mbkv(ji,jj)) = pgv(ji,jj,jn)
               END DO
            END DO
            IF( ln_isfcav ) THEN      ! first wet level beneath a cavity
               DO jj = 1, jpjm1
                  DO ji = 1, fs_jpim1   ! vector opt.
                     IF( miku(ji,jj) > 1 )   zdit(ji,jj,miku(ji,jj)) = pgui(ji,jj,jn)          
                     IF( mikv(ji,jj) > 1 )   zdjt(ji,jj,mikv(ji,jj)) = pgvi(ji,jj,jn)     
                  END DO
               END DO
            ENDIF
         ENDIF
         !
         !!----------------------------------------------------------------------
         !!   II - horizontal trend  (full)
         !!----------------------------------------------------------------------
         !
         DO jk = 1, jpkm1                                 ! Horizontal slab
            !
            !                             !== Vertical tracer gradient
            zdk1t(:,:) = ( ptb(:,:,jk,jn) - ptb(:,:,jk+1,jn) ) * wmask(:,:,jk+1)     ! level jk+1
            !
            IF( jk == 1 ) THEN   ;   zdkt(:,:) = zdk1t(:,:)                          ! surface: zdkt(jk=1)=zdkt(jk=2)
            ELSE                 ;   zdkt(:,:) = ( ptb(:,:,jk-1,jn) - ptb(:,:,jk,jn) ) * wmask(:,:,jk)
            ENDIF
            DO jj = 1 , jpjm1            !==  Horizontal fluxes
               DO ji = 1, fs_jpim1   ! vector opt.
                  zabe1 = pahu(ji,jj,jk) * e2_e1u(ji,jj) * e3u_n(ji,jj,jk)
                  zabe2 = pahv(ji,jj,jk) * e1_e2v(ji,jj) * e3v_n(ji,jj,jk)
                  !
                  zmsku = 1. / MAX(  wmask(ji+1,jj,jk  ) + wmask(ji,jj,jk+1)   &
                     &             + wmask(ji+1,jj,jk+1) + wmask(ji,jj,jk  ), 1. )
                  !
                  zmskv = 1. / MAX(  wmask(ji,jj+1,jk  ) + wmask(ji,jj,jk+1)   &
                     &             + wmask(ji,jj+1,jk+1) + wmask(ji,jj,jk  ), 1. )
                  !
                  zcof1 = - pahu(ji,jj,jk) * e2u(ji,jj) * uslp(ji,jj,jk) * zmsku
                  zcof2 = - pahv(ji,jj,jk) * e1v(ji,jj) * vslp(ji,jj,jk) * zmskv
                  !
                  zftu(ji,jj,jk ) = (  zabe1 * zdit(ji,jj,jk)   &
                     &               + zcof1 * (  zdkt (ji+1,jj) + zdk1t(ji,jj)      &
                     &                          + zdk1t(ji+1,jj) + zdkt (ji,jj)  )  ) * umask(ji,jj,jk)
                  zftv(ji,jj,jk) = (  zabe2 * zdjt(ji,jj,jk)   &
                     &               + zcof2 * (  zdkt (ji,jj+1) + zdk1t(ji,jj)      &
                     &                          + zdk1t(ji,jj+1) + zdkt (ji,jj)  )  ) * vmask(ji,jj,jk)                  
               END DO
            END DO
            !
            DO jj = 2 , jpjm1          !== horizontal divergence and add to pta
               DO ji = fs_2, fs_jpim1   ! vector opt.
                  pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + zsign * (  zftu(ji,jj,jk) - zftu(ji-1,jj,jk)      &
                     &                                           + zftv(ji,jj,jk) - zftv(ji,jj-1,jk)  )   &
                     &                                        * r1_e1e2t(ji,jj) / e3t_n(ji,jj,jk)
               END DO
            END DO
         END DO                                        !   End of slab  

         !!----------------------------------------------------------------------
         !!   III - vertical trend (full)
         !!----------------------------------------------------------------------
         !
         ztfw(1,:,:) = 0._wp     ;     ztfw(jpi,:,:) = 0._wp
         !
         ! Vertical fluxes
         ! ---------------
         !                          ! Surface and bottom vertical fluxes set to zero
         ztfw(:,:, 1 ) = 0._wp      ;      ztfw(:,:,jpk) = 0._wp
         
         DO jk = 2, jpkm1           ! interior (2=<jk=<jpk-1)
            DO jj = 2, jpjm1
               DO ji = fs_2, fs_jpim1   ! vector opt.
                  !
                  zmsku = wmask(ji,jj,jk) / MAX(   umask(ji  ,jj,jk-1) + umask(ji-1,jj,jk)          &
                     &                           + umask(ji-1,jj,jk-1) + umask(ji  ,jj,jk) , 1._wp  )
                  zmskv = wmask(ji,jj,jk) / MAX(   vmask(ji,jj  ,jk-1) + vmask(ji,jj-1,jk)          &
                     &                           + vmask(ji,jj-1,jk-1) + vmask(ji,jj  ,jk) , 1._wp  )
                     !
                  zahu_w = (   pahu(ji  ,jj,jk-1) + pahu(ji-1,jj,jk)    &
                     &       + pahu(ji-1,jj,jk-1) + pahu(ji  ,jj,jk)  ) * zmsku
                  zahv_w = (   pahv(ji,jj  ,jk-1) + pahv(ji,jj-1,jk)    &
                     &       + pahv(ji,jj-1,jk-1) + pahv(ji,jj  ,jk)  ) * zmskv
                     !
                  zcoef3 = - zahu_w * e2t(ji,jj) * zmsku * wslpi (ji,jj,jk)   !wslpi & j are already w-masked
                  zcoef4 = - zahv_w * e1t(ji,jj) * zmskv * wslpj (ji,jj,jk)
                  !
                  ztfw(ji,jj,jk) = zcoef3 * (   zdit(ji  ,jj  ,jk-1) + zdit(ji-1,jj  ,jk)      &
                     &                        + zdit(ji-1,jj  ,jk-1) + zdit(ji  ,jj  ,jk)  )   &
                     &           + zcoef4 * (   zdjt(ji  ,jj  ,jk-1) + zdjt(ji  ,jj-1,jk)      &
                     &                        + zdjt(ji  ,jj-1,jk-1) + zdjt(ji  ,jj  ,jk)  )
               END DO
            END DO
         END DO
         !                                !==  add the vertical 33 flux  ==!
         IF( ln_traldf_lap ) THEN               ! laplacian case: eddy coef = ah_wslp2 - akz
            DO jk = 2, jpkm1       
               DO jj = 1, jpjm1
                  DO ji = fs_2, fs_jpim1
                     ztfw(ji,jj,jk) = ztfw(ji,jj,jk) + e1e2t(ji,jj) / e3w_n(ji,jj,jk) * wmask(ji,jj,jk)   &
                        &                            * ( ah_wslp2(ji,jj,jk) - akz(ji,jj,jk) )             &
                        &                            * ( ptb(ji,jj,jk-1,jn) - ptb(ji,jj,jk,jn) )
                  END DO
               END DO
            END DO
            !
         ELSE                                   ! bilaplacian 
            SELECT CASE( kpass )
            CASE(  1  )                            ! 1st pass : eddy coef = ah_wslp2
               DO jk = 2, jpkm1 
                  DO jj = 1, jpjm1
                     DO ji = fs_2, fs_jpim1
                        ztfw(ji,jj,jk) = ztfw(ji,jj,jk)    &
                           &           + ah_wslp2(ji,jj,jk) * e1e2t(ji,jj)   &
                           &           * ( ptb(ji,jj,jk-1,jn) - ptb(ji,jj,jk,jn) ) / e3w_n(ji,jj,jk) * wmask(ji,jj,jk)
                     END DO
                  END DO
               END DO 
            CASE(  2  )                         ! 2nd pass : eddy flux = ah_wslp2 and akz applied on ptb  and ptbb gradients, resp.
               DO jk = 2, jpkm1 
                  DO jj = 1, jpjm1
                     DO ji = fs_2, fs_jpim1
                        ztfw(ji,jj,jk) = ztfw(ji,jj,jk) + e1e2t(ji,jj) / e3w_n(ji,jj,jk) * wmask(ji,jj,jk)                      &
                           &                            * (  ah_wslp2(ji,jj,jk) * ( ptb (ji,jj,jk-1,jn) - ptb (ji,jj,jk,jn) )   &
                           &                               + akz     (ji,jj,jk) * ( ptbb(ji,jj,jk-1,jn) - ptbb(ji,jj,jk,jn) )   )
                     END DO
                  END DO
               END DO
            END SELECT
         ENDIF
         !         
         DO jk = 1, jpkm1                 !==  Divergence of vertical fluxes added to pta  ==!
            DO jj = 2, jpjm1
               DO ji = fs_2, fs_jpim1   ! vector opt.
                  pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + zsign * (  ztfw (ji,jj,jk) - ztfw(ji,jj,jk+1)  )   &
                     &                                        * r1_e1e2t(ji,jj) / e3t_n(ji,jj,jk)
               END DO
            END DO
         END DO
         !
         IF( ( kpass == 1 .AND. ln_traldf_lap ) .OR.  &     !==  first pass only (  laplacian)  ==!
             ( kpass == 2 .AND. ln_traldf_blp ) ) THEN      !==  2nd   pass      (bilaplacian)  ==!
            !
            !                             ! "Poleward" diffusive heat or salt transports (T-S case only)
               ! note sign is reversed to give down-gradient diffusive transports )
            IF( l_ptr )  CALL dia_ptr_hst( jn, 'ldf', -zftv(:,:,:)  )
            !                          ! Diffusive heat transports
            IF( l_hst )  CALL dia_ar5_hst( jn, 'ldf', -zftu(:,:,:), -zftv(:,:,:) )
            !
         ENDIF                                                    !== end pass selection  ==!
         !
         !                                                        ! ===============
      END DO                                                      ! end tracer loop
      !
   END SUBROUTINE tra_ldf_iso

   !!==============================================================================
END MODULE traldf_iso

program tra_adv
  use iso_c_binding, only : c_int64_t
  integer, parameter :: wp = 8
  real(kind=wp), allocatable, dimension(:,:,:,:) :: t3sn
  real(kind=wp), allocatable, dimension(:,:,:,:) :: t3ns
  real(kind=wp), allocatable, dimension(:,:,:,:) :: t3ew
  real(kind=wp), allocatable, dimension(:,:,:,:) :: t3we
  real(kind=wp), allocatable, dimension(:,:,:) :: tsn
  real(kind=wp), allocatable, dimension(:,:,:) :: pun
  real(kind=wp), allocatable, dimension(:,:,:) :: pvn
  real(kind=wp), allocatable, dimension(:,:,:) :: pwn
  real(kind=wp), allocatable, dimension(:,:,:) :: mydomain
  real(kind=wp), allocatable, dimension(:,:,:) :: zslpx
  real(kind=wp), allocatable, dimension(:,:,:) :: zslpy
  real(kind=wp), allocatable, dimension(:,:,:) :: zwx
  real(kind=wp), allocatable, dimension(:,:,:) :: zwy
  real(kind=wp), allocatable, dimension(:,:,:) :: umask
  real(kind=wp), allocatable, dimension(:,:,:) :: vmask
  real(kind=wp), allocatable, dimension(:,:,:) :: tmask
  real(kind=wp), allocatable, dimension(:,:,:) :: zind
  real(kind=wp), allocatable, dimension(:,:) :: ztfreez
  real(kind=wp), allocatable, dimension(:,:) :: rnfmsk
  real(kind=wp), allocatable, dimension(:,:) :: upsmsk
  real(kind=wp), allocatable, dimension(:) :: rnfmsk_z
  real(kind=wp) :: zice
  real(kind=wp) :: zu
  real(kind=wp) :: z0u
  real(kind=wp) :: zzwx
  real(kind=wp) :: zv
  real(kind=wp) :: z0v
  real(kind=wp) :: zzwy
  real(kind=wp) :: ztra
  real(kind=wp) :: zbtr
  real(kind=wp) :: zdt
  real(kind=wp) :: zalpha
  real(kind=wp) :: r
  real(kind=wp) :: zw
  real(kind=wp) :: z0w
  integer :: jpi
  integer :: jpj
  integer :: jpk
  integer :: ji
  integer :: jj
  integer :: jk
  integer :: jt
  integer(kind=c_int64_t) :: it
  CHARACTER(LEN = 10) :: env

  call get_environment_variable('JPI', env)
  READ(env, '(i10)') jpi
  call get_environment_variable('JPJ', env)
  READ(env, '(i10)') jpj
  call get_environment_variable('JPK', env)
  READ(env, '(i10)') jpk
  call get_environment_variable('IT', env)
  READ(env, '(i10)') it
  ALLOCATE(mydomain(jpi, jpj, jpk))
  ALLOCATE(zwx(jpi, jpj, jpk))
  ALLOCATE(zwy(jpi, jpj, jpk))
  ALLOCATE(zslpx(jpi, jpj, jpk))
  ALLOCATE(zslpy(jpi, jpj, jpk))
  ALLOCATE(pun(jpi, jpj, jpk))
  ALLOCATE(pvn(jpi, jpj, jpk))
  ALLOCATE(pwn(jpi, jpj, jpk))
  ALLOCATE(umask(jpi, jpj, jpk))
  ALLOCATE(vmask(jpi, jpj, jpk))
  ALLOCATE(tmask(jpi, jpj, jpk))
  ALLOCATE(zind(jpi, jpj, jpk))
  ALLOCATE(ztfreez(jpi, jpj))
  ALLOCATE(rnfmsk(jpi, jpj))
  ALLOCATE(upsmsk(jpi, jpj))
  ALLOCATE(rnfmsk_z(jpk))
  ALLOCATE(tsn(jpi, jpj, jpk))
  r = jpi * jpj * jpk
  do jk = 1, jpk, 1
    do jj = 1, jpj, 1
      do ji = 1, jpi, 1
        umask(ji,jj,jk) = ji * jj * jk / r
        mydomain(ji,jj,jk) = ji * jj * jk / r
        pun(ji,jj,jk) = ji * jj * jk / r
        pvn(ji,jj,jk) = ji * jj * jk / r
        pwn(ji,jj,jk) = ji * jj * jk / r
        vmask(ji,jj,jk) = ji * jj * jk / r
        tsn(ji,jj,jk) = ji * jj * jk / r
        tmask(ji,jj,jk) = ji * jj * jk / r
      enddo
    enddo
  enddo
  r = jpi * jpj
  do jj = 1, jpj, 1
    do ji = 1, jpi, 1
      ztfreez(ji,jj) = ji * jj / r
      upsmsk(ji,jj) = ji * jj / r
      rnfmsk(ji,jj) = ji * jj / r
    enddo
  enddo
  do jk = 1, jpk, 1
    rnfmsk_z(jk) = jk / jpk
  enddo
  do jt = 1, it, 1
    do jk = 1, jpk, 1
      do jj = 1, jpj, 1
        do ji = 1, jpi, 1
          if (tsn(ji,jj,jk) <= ztfreez(ji,jj) + 0.1d0) then
            zice = 1.d0
          else
            zice = 0.d0
          end if
          zind(ji,jj,jk) = MAX(rnfmsk(ji,jj) * rnfmsk_z(jk), upsmsk(ji,jj), zice) * tmask(ji,jj,jk)
          zind(ji,jj,jk) = 1 - zind(ji,jj,jk)
        enddo
      enddo
    enddo
    !$acc data copyin(pun,pvn,pwn,tmask,umask,vmask,zind) copyout(zslpx,zslpy,zwx,zwy) copy(mydomain)
    !$acc kernels default(present)
    zwx(:,:,jpk) = 0.e0
    zwy(:,:,jpk) = 0.e0
    do jk = 1, jpk - 1, 1
      do jj = 1, jpj - 1, 1
        do ji = 1, jpi - 1, 1
          zwx(ji,jj,jk) = umask(ji,jj,jk) * (mydomain(ji + 1,jj,jk) - mydomain(ji,jj,jk))
          zwy(ji,jj,jk) = vmask(ji,jj,jk) * (mydomain(ji,jj + 1,jk) - mydomain(ji,jj,jk))
        enddo
      enddo
    enddo
    zslpx(:,:,jpk) = 0.e0
    zslpy(:,:,jpk) = 0.e0
    do jk = 1, jpk - 1, 1
      do jj = 2, jpj, 1
        do ji = 2, jpi, 1
          zslpx(ji,jj,jk) = (zwx(ji,jj,jk) + zwx(ji - 1,jj,jk)) * (0.25d0 + SIGN(0.25d0, zwx(ji,jj,jk) * zwx(ji - 1,jj,jk)))
          zslpy(ji,jj,jk) = (zwy(ji,jj,jk) + zwy(ji,jj - 1,jk)) * (0.25d0 + SIGN(0.25d0, zwy(ji,jj,jk) * zwy(ji,jj - 1,jk)))
        enddo
      enddo
    enddo
    do jk = 1, jpk - 1, 1
      do jj = 2, jpj, 1
        do ji = 2, jpi, 1
          zslpx(ji,jj,jk) = SIGN(1.d0, zslpx(ji,jj,jk)) * MIN(ABS(zslpx(ji,jj,jk)), 2.d0 * ABS(zwx(ji - 1,jj,jk)), 2.d0 * &
&ABS(zwx(ji,jj,jk)))
          zslpy(ji,jj,jk) = SIGN(1.d0, zslpy(ji,jj,jk)) * MIN(ABS(zslpy(ji,jj,jk)), 2.d0 * ABS(zwy(ji,jj - 1,jk)), 2.d0 * &
&ABS(zwy(ji,jj,jk)))
        enddo
      enddo
    enddo
    do jk = 1, jpk - 1, 1
      zdt = 1
      do jj = 2, jpj - 1, 1
        do ji = 2, jpi - 1, 1
          z0u = SIGN(0.5d0, pun(ji,jj,jk))
          zalpha = 0.5d0 - z0u
          zu = z0u - 0.5d0 * pun(ji,jj,jk) * zdt
          zzwx = mydomain(ji + 1,jj,jk) + zind(ji,jj,jk) * (zu * zslpx(ji + 1,jj,jk))
          zzwy = mydomain(ji,jj,jk) + zind(ji,jj,jk) * (zu * zslpx(ji,jj,jk))
          zwx(ji,jj,jk) = pun(ji,jj,jk) * (zalpha * zzwx + (1. - zalpha) * zzwy)
          z0v = SIGN(0.5d0, pvn(ji,jj,jk))
          zalpha = 0.5d0 - z0v
          zv = z0v - 0.5d0 * pvn(ji,jj,jk) * zdt
          zzwx = mydomain(ji,jj + 1,jk) + zind(ji,jj,jk) * (zv * zslpy(ji,jj + 1,jk))
          zzwy = mydomain(ji,jj,jk) + zind(ji,jj,jk) * (zv * zslpy(ji,jj,jk))
          zwy(ji,jj,jk) = pvn(ji,jj,jk) * (zalpha * zzwx + (1.d0 - zalpha) * zzwy)
        enddo
      enddo
    enddo
    do jk = 1, jpk - 1, 1
      do jj = 2, jpj - 1, 1
        do ji = 2, jpi - 1, 1
          zbtr = 1.
          ztra = -zbtr * (zwx(ji,jj,jk) - zwx(ji - 1,jj,jk) + zwy(ji,jj,jk) - zwy(ji,jj - 1,jk))
          mydomain(ji,jj,jk) = mydomain(ji,jj,jk) + ztra
        enddo
      enddo
    enddo
    zwx(:,:,1) = 0.e0
    zwx(:,:,jpk) = 0.e0
    do jk = 2, jpk - 1, 1
      zwx(:,:,jk) = tmask(:,:,jk) * (mydomain(:,:,jk - 1) - mydomain(:,:,jk))
    enddo
    zslpx(:,:,1) = 0.e0
    do jk = 2, jpk - 1, 1
      do jj = 1, jpj, 1
        do ji = 1, jpi, 1
          zslpx(ji,jj,jk) = (zwx(ji,jj,jk) + zwx(ji,jj,jk + 1)) * (0.25d0 + SIGN(0.25d0, zwx(ji,jj,jk) * zwx(ji,jj,jk + 1)))
        enddo
      enddo
    enddo
    do jk = 2, jpk - 1, 1
      do jj = 1, jpj, 1
        do ji = 1, jpi, 1
          zslpx(ji,jj,jk) = SIGN(1.d0, zslpx(ji,jj,jk)) * MIN(ABS(zslpx(ji,jj,jk)), 2.d0 * ABS(zwx(ji,jj,jk + 1)), 2.d0 * &
&ABS(zwx(ji,jj,jk)))
        enddo
      enddo
    enddo
    zwx(:,:,1) = pwn(:,:,1) * mydomain(:,:,1)
    zdt = 1
    zbtr = 1.
    do jk = 1, jpk - 1, 1
      do jj = 2, jpj - 1, 1
        do ji = 2, jpi - 1, 1
          z0w = SIGN(0.5d0, pwn(ji,jj,jk + 1))
          zalpha = 0.5d0 + z0w
          zw = z0w - 0.5d0 * pwn(ji,jj,jk + 1) * zdt * zbtr
          zzwx = mydomain(ji,jj,jk + 1) + zind(ji,jj,jk) * (zw * zslpx(ji,jj,jk + 1))
          zzwy = mydomain(ji,jj,jk) + zind(ji,jj,jk) * (zw * zslpx(ji,jj,jk))
          zwx(ji,jj,jk + 1) = pwn(ji,jj,jk + 1) * (zalpha * zzwx + (1. - zalpha) * zzwy)
        enddo
      enddo
    enddo
    zbtr = 1.
    do jk = 1, jpk - 1, 1
      do jj = 2, jpj - 1, 1
        do ji = 2, jpi - 1, 1
          ztra = -zbtr * (zwx(ji,jj,jk) - zwx(ji,jj,jk + 1))
          mydomain(ji,jj,jk) = ztra
        enddo
      enddo
    enddo
    !$acc end kernels
    !$acc end data
  enddo
  OPEN(UNIT = 4, FILE = 'output.dat', FORM = 'formatted')
  do jk = 1, jpk - 1, 1
    do jj = 2, jpj - 1, 1
      do ji = 2, jpi - 1, 1
        WRITE(4, *) mydomain(ji, jj, jk)
      enddo
    enddo
  enddo
  CLOSE(UNIT = 4)
  DEALLOCATE(mydomain)
  DEALLOCATE(zwx)
  DEALLOCATE(zwy)
  DEALLOCATE(zslpx)
  DEALLOCATE(zslpy)
  DEALLOCATE(pun)
  DEALLOCATE(pvn)
  DEALLOCATE(pwn)
  DEALLOCATE(umask)
  DEALLOCATE(vmask)
  DEALLOCATE(tmask)
  DEALLOCATE(zind)
  DEALLOCATE(ztfreez)
  DEALLOCATE(rnfmsk)
  DEALLOCATE(upsmsk)
  DEALLOCATE(rnfmsk_z)
  DEALLOCATE(tsn)

end program tra_adv

module testkern_mod_adj
  implicit none
  public

  public :: testkern_code_adj

  contains
  subroutine testkern_code_adj(ascalar, field1, field2, field3, npts)
    real, intent(in) :: ascalar
    integer, intent(in) :: npts
    real, dimension(npts), intent(inout) :: field2
    real, dimension(npts), intent(inout) :: field1
    real, dimension(npts), intent(inout) :: field3
    real :: tmp
    real :: tmp2
    real :: tmp3
    integer :: i
    integer :: idx

    tmp = ascalar * ascalar
    do idx = UBOUND(field2, 1), LBOUND(field2, 1), -1
      field1(idx) = field1(idx) + field2(idx)
      field3(idx) = field3(idx) - tmp * field2(idx)
      field2(idx) = 0.0
    enddo
    field1(1) = field1(1) + field2(npts)
    do i = npts, 1, -1
      tmp2 = tmp * i
      tmp3 = tmp2 * 3.0
      field1(i) = field1(i) + field2(i) / tmp2
      field2(i) = field2(i) + field1(i)
      field3(i) = field3(i) + field1(i)
      field1(i) = tmp * field1(i)
    enddo

  end subroutine testkern_code_adj

end module testkern_mod_adj

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2019, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author R. W. Ford, STFC Daresbury Lab

! Illustration of performing a tri-diagonal solve in the vertical (k
! dimension). This is a Fortran implementation of the Dawn Python
! example.
program tridiagonal_solve
  implicit none
  integer, parameter :: n=10
  integer :: i,j,k
  real :: m
  real, dimension(n,n,n) :: a,b,c,d
  do k=1,n
     do j=1,n
        do i=1,n
           c(i,j,k) = c(i,j,k)/b(i,j,k)
        end do
     end do
  end do
  do k=2,n
     do j=1,n
        do i=1,n
           m = 1.0/(b(i,j,k)-a(i,j,k)*c(i,j,k-1))
           c(i,j,k) = c(i,j,k)*m
           d(i,j,k) = (d(i,j,k)-a(i,j,k)*d(i,j,k-1))*m
        end do
     end do
  end do  
  do k=n-1,1,-1
     do j=1,n
        do i=1,n
           d(i,j,k) = d(i,j,k) - c(i,j,k)*d(i,j,k+1)
        end do
     end do
  end do
  
end program tridiagonal_solve

  MODULE psy_test
    USE field_mod
    USE kind_params_mod
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(a_fld, b_fld)
      USE nan_test_psy_data_mod, ONLY: nan_test_PSyDataType
      USE init_field_mod, ONLY: init_field_code
      TYPE(r2d_field), intent(inout) :: a_fld
      TYPE(r2d_field), intent(inout) :: b_fld
      INTEGER j
      INTEGER i
      TYPE(nan_test_PSyDataType), save, target :: nan_test_psy_data

      CALL nan_test_psy_data % PreStart("main", "init", 8, 4)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL nan_test_psy_data % PreDeclareVariable("b_fld%whole%xstart", b_fld % whole % xstart)
      CALL nan_test_psy_data % PreDeclareVariable("b_fld%whole%xstop", b_fld % whole % xstop)
      CALL nan_test_psy_data % PreDeclareVariable("b_fld%whole%ystart", b_fld % whole % ystart)
      CALL nan_test_psy_data % PreDeclareVariable("b_fld%whole%ystop", b_fld % whole % ystop)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld", a_fld)
      CALL nan_test_psy_data % PreDeclareVariable("b_fld", b_fld)
      CALL nan_test_psy_data % PreDeclareVariable("i", i)
      CALL nan_test_psy_data % PreDeclareVariable("j", j)
      CALL nan_test_psy_data % PreEndDeclaration
      CALL nan_test_psy_data % ProvideVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL nan_test_psy_data % ProvideVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL nan_test_psy_data % ProvideVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL nan_test_psy_data % ProvideVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL nan_test_psy_data % ProvideVariable("b_fld%whole%xstart", b_fld % whole % xstart)
      CALL nan_test_psy_data % ProvideVariable("b_fld%whole%xstop", b_fld % whole % xstop)
      CALL nan_test_psy_data % ProvideVariable("b_fld%whole%ystart", b_fld % whole % ystart)
      CALL nan_test_psy_data % ProvideVariable("b_fld%whole%ystop", b_fld % whole % ystop)
      CALL nan_test_psy_data % PreEnd
      DO j = a_fld%whole%ystart, a_fld%whole%ystop, 1
        DO i = a_fld%whole%xstart, a_fld%whole%xstop, 1
          CALL init_field_code(i, j, a_fld%data, 1.0)
        END DO
      END DO
      DO j = b_fld%whole%ystart, b_fld%whole%ystop, 1
        DO i = b_fld%whole%xstart, b_fld%whole%xstop, 1
          CALL init_field_code(i, j, b_fld%data, 2.0)
        END DO
      END DO
      CALL nan_test_psy_data % PostStart
      CALL nan_test_psy_data % ProvideVariable("a_fld", a_fld)
      CALL nan_test_psy_data % ProvideVariable("b_fld", b_fld)
      CALL nan_test_psy_data % ProvideVariable("i", i)
      CALL nan_test_psy_data % ProvideVariable("j", j)
      CALL nan_test_psy_data % PostEnd

    END SUBROUTINE invoke_0
    SUBROUTINE invoke_1_update_field(a_fld, b_fld)
      USE nan_test_psy_data_mod, ONLY: nan_test_PSyDataType
      USE update_field_mod, ONLY: update_field_code
      TYPE(r2d_field), intent(inout) :: a_fld
      TYPE(r2d_field), intent(inout) :: b_fld
      INTEGER j
      INTEGER i
      TYPE(nan_test_PSyDataType), save, target :: nan_test_psy_data

      CALL nan_test_psy_data % PreStart("main", "update", 6, 3)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld", a_fld)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL nan_test_psy_data % PreDeclareVariable("b_fld", b_fld)
      CALL nan_test_psy_data % PreDeclareVariable("a_fld", a_fld)
      CALL nan_test_psy_data % PreDeclareVariable("i", i)
      CALL nan_test_psy_data % PreDeclareVariable("j", j)
      CALL nan_test_psy_data % PreEndDeclaration
      CALL nan_test_psy_data % ProvideVariable("a_fld", a_fld)
      CALL nan_test_psy_data % ProvideVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL nan_test_psy_data % ProvideVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL nan_test_psy_data % ProvideVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL nan_test_psy_data % ProvideVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL nan_test_psy_data % ProvideVariable("b_fld", b_fld)
      CALL nan_test_psy_data % PreEnd
      DO j = a_fld%whole%ystart, a_fld%whole%ystop, 1
        DO i = a_fld%whole%xstart, a_fld%whole%xstop, 1
          CALL update_field_code(i, j, a_fld%data, b_fld%data)
        END DO
      END DO
      CALL nan_test_psy_data % PostStart
      CALL nan_test_psy_data % ProvideVariable("a_fld", a_fld)
      CALL nan_test_psy_data % ProvideVariable("i", i)
      CALL nan_test_psy_data % ProvideVariable("j", j)
      CALL nan_test_psy_data % PostEnd

    END SUBROUTINE invoke_1_update_field
  END MODULE psy_test

  MODULE psy_simple
    USE field_mod
    USE kind_params_mod
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(cu_fld, p_fld, u_fld, cv_fld, v_fld, z_fld, h_fld)
      USE fortcl, ONLY: get_cmd_queues, get_kernel_by_name, get_num_cmd_queues
      USE clfortran, ONLY: clEnqueueNDRangeKernel, clFinish
      USE iso_c_binding, ONLY: C_LOC, C_NULL_PTR
      TYPE(r2d_field), intent(inout) :: cu_fld
      TYPE(r2d_field), intent(inout) :: p_fld
      TYPE(r2d_field), intent(inout) :: u_fld
      TYPE(r2d_field), intent(inout) :: cv_fld
      TYPE(r2d_field), intent(inout) :: v_fld
      TYPE(r2d_field), intent(inout) :: z_fld
      TYPE(r2d_field), intent(inout) :: h_fld
      INTEGER j
      INTEGER i
      INTEGER xstart
      INTEGER xstop
      INTEGER ystart
      INTEGER ystop
      INTEGER xstart_1
      INTEGER xstop_1
      INTEGER ystart_1
      INTEGER ystop_1
      INTEGER xstart_2
      INTEGER xstop_2
      INTEGER ystart_2
      INTEGER ystop_2
      INTEGER xstart_3
      INTEGER xstop_3
      INTEGER ystart_3
      INTEGER ystop_3
      INTEGER(KIND=c_intptr_t), pointer, save :: cmd_queues(:)
      LOGICAL, save :: first_time = .true.
      INTEGER ierr
      INTEGER(KIND=c_size_t), target :: globalsize(2)
      INTEGER(KIND=c_size_t), target :: localsize(2)
      INTEGER(KIND=c_intptr_t), TARGET, SAVE :: kernel_compute_cu_code
      INTEGER(KIND=c_intptr_t), TARGET, SAVE :: kernel_compute_cv_code
      INTEGER(KIND=c_intptr_t), TARGET, SAVE :: kernel_compute_z_code
      INTEGER(KIND=c_intptr_t), TARGET, SAVE :: kernel_compute_h_code
      INTEGER(KIND=c_intptr_t) cu_fld_cl_mem
      INTEGER(KIND=c_intptr_t) p_fld_cl_mem
      INTEGER(KIND=c_intptr_t) u_fld_cl_mem
      INTEGER(KIND=c_intptr_t) cv_fld_cl_mem
      INTEGER(KIND=c_intptr_t) v_fld_cl_mem
      INTEGER(KIND=c_intptr_t) z_fld_cl_mem
      INTEGER(KIND=c_intptr_t) h_fld_cl_mem

      xstart = cu_fld%internal%xstart
      xstop = cu_fld%internal%xstop
      ystart = cu_fld%internal%ystart
      ystop = cu_fld%internal%ystop
      xstart_1 = cv_fld%internal%xstart
      xstop_1 = cv_fld%internal%xstop
      ystart_1 = cv_fld%internal%ystart
      ystop_1 = cv_fld%internal%ystop
      xstart_2 = z_fld%internal%xstart
      xstop_2 = z_fld%internal%xstop
      ystart_2 = z_fld%internal%ystart
      ystop_2 = z_fld%internal%ystop
      xstart_3 = h_fld%internal%xstart
      xstop_3 = h_fld%internal%xstop
      ystart_3 = h_fld%internal%ystart
      ystop_3 = h_fld%internal%ystop
      ! Initialise OpenCL runtime, kernels and buffers
      IF (first_time) THEN
        CALL psy_init
        cmd_queues => get_cmd_queues()
        kernel_compute_cu_code = get_kernel_by_name('compute_cu_code')
        kernel_compute_cv_code = get_kernel_by_name('compute_cv_code')
        kernel_compute_z_code = get_kernel_by_name('compute_z_code')
        kernel_compute_h_code = get_kernel_by_name('compute_h_code')
        CALL initialise_device_buffer(cu_fld)
        CALL initialise_device_buffer(p_fld)
        CALL initialise_device_buffer(u_fld)
        CALL initialise_device_buffer(cv_fld)
        CALL initialise_device_buffer(v_fld)
        CALL initialise_device_buffer(z_fld)
        CALL initialise_device_buffer(h_fld)
        ! Do a set_args now so subsequent writes place the data appropriately
        cu_fld_cl_mem = TRANSFER(cu_fld%device_ptr, cu_fld_cl_mem)
        p_fld_cl_mem = TRANSFER(p_fld%device_ptr, p_fld_cl_mem)
        u_fld_cl_mem = TRANSFER(u_fld%device_ptr, u_fld_cl_mem)
        CALL compute_cu_code_set_args(kernel_compute_cu_code, cu_fld_cl_mem, p_fld_cl_mem, u_fld_cl_mem, xstart - 1, xstop - 1, &
&ystart - 1, ystop - 1)
        cv_fld_cl_mem = TRANSFER(cv_fld%device_ptr, cv_fld_cl_mem)
        p_fld_cl_mem = TRANSFER(p_fld%device_ptr, p_fld_cl_mem)
        v_fld_cl_mem = TRANSFER(v_fld%device_ptr, v_fld_cl_mem)
        CALL compute_cv_code_set_args(kernel_compute_cv_code, cv_fld_cl_mem, p_fld_cl_mem, v_fld_cl_mem, xstart_1 - 1, &
&xstop_1 - 1, ystart_1 - 1, ystop_1 - 1)
        z_fld_cl_mem = TRANSFER(z_fld%device_ptr, z_fld_cl_mem)
        p_fld_cl_mem = TRANSFER(p_fld%device_ptr, p_fld_cl_mem)
        u_fld_cl_mem = TRANSFER(u_fld%device_ptr, u_fld_cl_mem)
        v_fld_cl_mem = TRANSFER(v_fld%device_ptr, v_fld_cl_mem)
        CALL compute_z_code_set_args(kernel_compute_z_code, z_fld_cl_mem, p_fld_cl_mem, u_fld_cl_mem, v_fld_cl_mem, p_fld%grid%dx, &
&p_fld%grid%dy, xstart_2 - 1, xstop_2 - 1, ystart_2 - 1, ystop_2 - 1)
        h_fld_cl_mem = TRANSFER(h_fld%device_ptr, h_fld_cl_mem)
        p_fld_cl_mem = TRANSFER(p_fld%device_ptr, p_fld_cl_mem)
        u_fld_cl_mem = TRANSFER(u_fld%device_ptr, u_fld_cl_mem)
        v_fld_cl_mem = TRANSFER(v_fld%device_ptr, v_fld_cl_mem)
        CALL compute_h_code_set_args(kernel_compute_h_code, h_fld_cl_mem, p_fld_cl_mem, u_fld_cl_mem, v_fld_cl_mem, xstart_3 - 1, &
&xstop_3 - 1, ystart_3 - 1, ystop_3 - 1)
        ! Write data to the device
        CALL v_fld%write_to_device
        CALL u_fld%write_to_device
        CALL cu_fld%write_to_device
        CALL cv_fld%write_to_device
        CALL z_fld%write_to_device
        CALL p_fld%write_to_device
        CALL h_fld%write_to_device
      END IF
      globalsize = (/p_fld%grid%nx, p_fld%grid%ny/)
      localsize = (/4, 1/)
      cu_fld_cl_mem = TRANSFER(cu_fld%device_ptr, cu_fld_cl_mem)
      p_fld_cl_mem = TRANSFER(p_fld%device_ptr, p_fld_cl_mem)
      u_fld_cl_mem = TRANSFER(u_fld%device_ptr, u_fld_cl_mem)
      CALL compute_cu_code_set_args(kernel_compute_cu_code, cu_fld_cl_mem, p_fld_cl_mem, u_fld_cl_mem, xstart - 1, xstop - 1, &
&ystart - 1, ystop - 1)
      ! Launch the kernel
      ierr = clEnqueueNDRangeKernel(cmd_queues(1), kernel_compute_cu_code, 2, C_NULL_PTR, C_LOC(globalsize), C_LOC(localsize), 0, &
&C_NULL_PTR, C_NULL_PTR)
      globalsize = (/p_fld%grid%nx, p_fld%grid%ny/)
      localsize = (/4, 1/)
      cv_fld_cl_mem = TRANSFER(cv_fld%device_ptr, cv_fld_cl_mem)
      p_fld_cl_mem = TRANSFER(p_fld%device_ptr, p_fld_cl_mem)
      v_fld_cl_mem = TRANSFER(v_fld%device_ptr, v_fld_cl_mem)
      CALL compute_cv_code_set_args(kernel_compute_cv_code, cv_fld_cl_mem, p_fld_cl_mem, v_fld_cl_mem, xstart_1 - 1, xstop_1 - 1, &
&ystart_1 - 1, ystop_1 - 1)
      ! Launch the kernel
      ierr = clEnqueueNDRangeKernel(cmd_queues(2), kernel_compute_cv_code, 2, C_NULL_PTR, C_LOC(globalsize), C_LOC(localsize), 0, &
&C_NULL_PTR, C_NULL_PTR)
      globalsize = (/p_fld%grid%nx, p_fld%grid%ny/)
      localsize = (/4, 1/)
      z_fld_cl_mem = TRANSFER(z_fld%device_ptr, z_fld_cl_mem)
      p_fld_cl_mem = TRANSFER(p_fld%device_ptr, p_fld_cl_mem)
      u_fld_cl_mem = TRANSFER(u_fld%device_ptr, u_fld_cl_mem)
      v_fld_cl_mem = TRANSFER(v_fld%device_ptr, v_fld_cl_mem)
      CALL compute_z_code_set_args(kernel_compute_z_code, z_fld_cl_mem, p_fld_cl_mem, u_fld_cl_mem, v_fld_cl_mem, p_fld%grid%dx, &
&p_fld%grid%dy, xstart_2 - 1, xstop_2 - 1, ystart_2 - 1, ystop_2 - 1)
      ! Launch the kernel
      ierr = clEnqueueNDRangeKernel(cmd_queues(3), kernel_compute_z_code, 2, C_NULL_PTR, C_LOC(globalsize), C_LOC(localsize), 0, &
&C_NULL_PTR, C_NULL_PTR)
      globalsize = (/p_fld%grid%nx, p_fld%grid%ny/)
      localsize = (/4, 1/)
      h_fld_cl_mem = TRANSFER(h_fld%device_ptr, h_fld_cl_mem)
      p_fld_cl_mem = TRANSFER(p_fld%device_ptr, p_fld_cl_mem)
      u_fld_cl_mem = TRANSFER(u_fld%device_ptr, u_fld_cl_mem)
      v_fld_cl_mem = TRANSFER(v_fld%device_ptr, v_fld_cl_mem)
      CALL compute_h_code_set_args(kernel_compute_h_code, h_fld_cl_mem, p_fld_cl_mem, u_fld_cl_mem, v_fld_cl_mem, xstart_3 - 1, &
&xstop_3 - 1, ystart_3 - 1, ystop_3 - 1)
      ! Launch the kernel
      ierr = clEnqueueNDRangeKernel(cmd_queues(4), kernel_compute_h_code, 2, C_NULL_PTR, C_LOC(globalsize), C_LOC(localsize), 0, &
&C_NULL_PTR, C_NULL_PTR)
      ! Wait until all kernels have finished
      ierr = clFinish(cmd_queues(1))
      ierr = clFinish(cmd_queues(2))
      ierr = clFinish(cmd_queues(3))
      ierr = clFinish(cmd_queues(4))
      ! Unset the first time flag
      first_time = .false.

    END SUBROUTINE invoke_0
    SUBROUTINE psy_init()
      USE fortcl, ONLY: add_kernels, ocl_env_init
      CHARACTER(LEN=30) kernel_names(4)
      INTEGER :: ocl_device_num = 1
      LOGICAL, SAVE :: initialised = .FALSE.

      IF (.NOT.initialised) THEN
        initialised = .true.
        CALL ocl_env_init(4, ocl_device_num, .false., .false.)
        kernel_names(1) = 'compute_h_code'
        kernel_names(2) = 'compute_cv_code'
        kernel_names(3) = 'compute_z_code'
        kernel_names(4) = 'compute_cu_code'
        CALL add_kernels(4, kernel_names)
      END IF

    END SUBROUTINE psy_init
    SUBROUTINE initialise_grid_device_buffers(field)
      USE fortcl, ONLY: create_ronly_buffer
      USE field_mod
      TYPE(r2d_field), INTENT(INOUT), TARGET :: field
      INTEGER(KIND=c_size_t) size_in_bytes

      IF (.NOT.c_associated(field%grid%tmask_device)) THEN
        size_in_bytes = INT(field%grid%nx * field%grid%ny, 8) * c_sizeof(field%grid%tmask(1,1))
        field%grid%tmask_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%tmask_device)
        size_in_bytes = INT(field%grid%nx * field%grid%ny, 8) * c_sizeof(field%grid%area_t(1,1))
        field%grid%area_t_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%area_t_device)
        field%grid%area_u_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%area_u_device)
        field%grid%area_v_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%area_v_device)
        field%grid%dx_t_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%dx_t_device)
        field%grid%dx_u_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%dx_u_device)
        field%grid%dx_v_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%dx_v_device)
        field%grid%dy_t_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%dy_t_device)
        field%grid%dy_u_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%dy_u_device)
        field%grid%dy_v_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%dy_v_device)
        field%grid%gphiu_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%gphiu_device)
        field%grid%gphiv_device = TRANSFER(create_ronly_buffer(size_in_bytes), field%grid%gphiv_device)
      END IF

    END SUBROUTINE initialise_grid_device_buffers
    SUBROUTINE write_grid_buffers(field)
      USE fortcl, ONLY: get_cmd_queues
      USE iso_c_binding, ONLY: c_intptr_t, c_size_t, c_sizeof
      USE clfortran
      USE ocl_utils_mod, ONLY: check_status
      TYPE(r2d_field), INTENT(INOUT), TARGET :: field
      INTEGER(KIND=c_size_t) size_in_bytes
      INTEGER(KIND=c_intptr_t), POINTER :: cmd_queues(:)
      INTEGER(KIND=c_intptr_t) cl_mem
      INTEGER ierr

      cmd_queues => get_cmd_queues()
      size_in_bytes = INT(field%grid%nx * field%grid%ny, 8) * c_sizeof(field%grid%tmask(1,1))
      cl_mem = TRANSFER(field%grid%tmask_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%tmask),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer tmask', ierr)
      size_in_bytes = INT(field%grid%nx * field%grid%ny, 8) * c_sizeof(field%grid%area_t(1,1))
      cl_mem = TRANSFER(field%grid%area_t_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%area_t),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer area_t_device', ierr)
      cl_mem = TRANSFER(field%grid%area_u_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%area_u),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer area_u_device', ierr)
      cl_mem = TRANSFER(field%grid%area_v_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%area_v),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer area_v_device', ierr)
      cl_mem = TRANSFER(field%grid%dx_u_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%dx_u),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer dx_u_device', ierr)
      cl_mem = TRANSFER(field%grid%dx_v_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%dx_v),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer dx_v_device', ierr)
      cl_mem = TRANSFER(field%grid%dx_t_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%dx_t),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer dx_t_device', ierr)
      cl_mem = TRANSFER(field%grid%dy_u_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%dy_u),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer dy_u_device', ierr)
      cl_mem = TRANSFER(field%grid%dy_v_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%dy_v),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer dy_v_device', ierr)
      cl_mem = TRANSFER(field%grid%dy_t_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%dy_t),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer dy_t_device', ierr)
      cl_mem = TRANSFER(field%grid%gphiu_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%gphiu),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer gphiu_device', ierr)
      cl_mem = TRANSFER(field%grid%gphiv_device, cl_mem)
      ierr = clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,0_8,size_in_bytes,c_loc(field%grid%gphiv),0,C_NULL_PTR,C_NULL_PTR)
      CALL check_status('clEnqueueWriteBuffer gphiv_device', ierr)

    END SUBROUTINE write_grid_buffers
    SUBROUTINE read_from_device(from, to, startx, starty, nx, ny, blocking)
      USE iso_c_binding, ONLY: c_intptr_t, c_ptr, c_size_t, c_sizeof
      USE ocl_utils_mod, ONLY: check_status
      USE kind_params_mod, ONLY: go_wp
      USE clfortran
      USE fortcl, ONLY: get_cmd_queues
      TYPE(c_ptr), intent(in) :: from
      REAL(KIND=go_wp), INTENT(INOUT), DIMENSION(:, :), TARGET :: to
      INTEGER, intent(in) :: startx
      INTEGER, intent(in) :: starty
      INTEGER, intent(in) :: nx
      INTEGER, intent(in) :: ny
      LOGICAL, intent(in) :: blocking
      INTEGER(KIND=c_size_t) size_in_bytes
      INTEGER(KIND=c_size_t) offset_in_bytes
      INTEGER(KIND=c_intptr_t) cl_mem
      INTEGER(KIND=c_intptr_t), POINTER :: cmd_queues(:)
      INTEGER ierr
      INTEGER i

      cl_mem = TRANSFER(from, cl_mem)
      cmd_queues => get_cmd_queues()
      IF (nx < SIZE(to, 1) / 2) THEN
        DO i = starty, starty + ny, 1
          size_in_bytes = INT(nx, 8) * c_sizeof(to(1,1))
          offset_in_bytes = INT(SIZE(to, 1) * (i - 1) + (startx - 1)) * c_sizeof(to(1,1))
          ierr = &
&clenqueuereadbuffer(cmd_queues(1),cl_mem,CL_FALSE,offset_in_bytes,size_in_bytes,c_loc(to(startx,i)),0,C_NULL_PTR,C_NULL_PTR)
          CALL check_status('clEnqueueReadBuffer', ierr)
        END DO
        IF (blocking) THEN
          CALL check_status('clFinish on read', clfinish(cmd_queues(1)))
        END IF
      ELSE
        size_in_bytes = INT(SIZE(to, 1) * ny, 8) * c_sizeof(to(1,1))
        offset_in_bytes = INT(SIZE(to, 1) * (starty - 1), 8) * c_sizeof(to(1,1))
        ierr = &
&clenqueuereadbuffer(cmd_queues(1),cl_mem,CL_TRUE,offset_in_bytes,size_in_bytes,c_loc(to(1,starty)),0,C_NULL_PTR,C_NULL_PTR)
        CALL check_status('clEnqueueReadBuffer', ierr)
      END IF

    END SUBROUTINE read_from_device
    SUBROUTINE write_to_device(from, to, startx, starty, nx, ny, blocking)
      USE iso_c_binding, ONLY: c_intptr_t, c_ptr, c_size_t, c_sizeof
      USE ocl_utils_mod, ONLY: check_status
      USE kind_params_mod, ONLY: go_wp
      USE clfortran
      USE fortcl, ONLY: get_cmd_queues
      REAL(KIND=go_wp), INTENT(IN), DIMENSION(:, :), TARGET :: from
      TYPE(c_ptr), intent(in) :: to
      INTEGER, intent(in) :: startx
      INTEGER, intent(in) :: starty
      INTEGER, intent(in) :: nx
      INTEGER, intent(in) :: ny
      LOGICAL, intent(in) :: blocking
      INTEGER(KIND=c_intptr_t) cl_mem
      INTEGER(KIND=c_size_t) size_in_bytes
      INTEGER(KIND=c_size_t) offset_in_bytes
      INTEGER(KIND=c_intptr_t), POINTER :: cmd_queues(:)
      INTEGER ierr
      INTEGER i

      cl_mem = TRANSFER(to, cl_mem)
      cmd_queues => get_cmd_queues()
      IF (nx < SIZE(from, 1) / 2) THEN
        DO i = starty, starty + ny, 1
          size_in_bytes = INT(nx, 8) * c_sizeof(from(1,1))
          offset_in_bytes = INT(SIZE(from, 1) * (i - 1) + (startx - 1)) * c_sizeof(from(1,1))
          ierr = &
&clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_FALSE,offset_in_bytes,size_in_bytes,c_loc(from(startx,i)),0,C_NULL_PTR,C_NULL_PTR)
          CALL check_status('clEnqueueWriteBuffer', ierr)
        END DO
        IF (blocking) THEN
          CALL check_status('clFinish on write', clfinish(cmd_queues(1)))
        END IF
      ELSE
        size_in_bytes = INT(SIZE(from, 1) * ny, 8) * c_sizeof(from(1,1))
        offset_in_bytes = INT(SIZE(from, 1) * (starty - 1)) * c_sizeof(from(1,1))
        ierr = &
&clenqueuewritebuffer(cmd_queues(1),cl_mem,CL_TRUE,offset_in_bytes,size_in_bytes,c_loc(from(1,starty)),0,C_NULL_PTR,C_NULL_PTR)
        CALL check_status('clEnqueueWriteBuffer', ierr)
      END IF

    END SUBROUTINE write_to_device
    SUBROUTINE initialise_device_buffer(field)
      USE fortcl, ONLY: create_rw_buffer
      USE field_mod
      TYPE(r2d_field), INTENT(INOUT), TARGET :: field
      INTEGER(KIND=c_size_t) size_in_bytes

      IF (.NOT.field%data_on_device) THEN
        size_in_bytes = INT(field%grid%nx * field%grid%ny, 8) * c_sizeof(field%data(1,1))
        field%device_ptr = TRANSFER(create_rw_buffer(size_in_bytes), field%device_ptr)
        field%data_on_device = .true.
        field%read_from_device_f => read_from_device
        field%write_to_device_f => write_to_device
      END IF

    END SUBROUTINE initialise_device_buffer
    SUBROUTINE compute_cu_code_set_args(kernel_obj, cu_fld, p_fld, u_fld, xstart, xstop, ystart, ystop)
      USE clfortran, ONLY: clSetKernelArg
      USE iso_c_binding, ONLY: C_LOC, C_SIZEOF, c_intptr_t
      USE ocl_utils_mod, ONLY: check_status
      INTEGER(KIND=c_intptr_t), TARGET :: kernel_obj
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: cu_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: p_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: u_fld
      INTEGER, INTENT(IN), TARGET :: xstart
      INTEGER, INTENT(IN), TARGET :: xstop
      INTEGER, INTENT(IN), TARGET :: ystart
      INTEGER, INTENT(IN), TARGET :: ystop
      INTEGER ierr

      ! Set the arguments for the compute_cu_code OpenCL Kernel
      ierr = clSetKernelArg(kernel_obj, 0, C_SIZEOF(cu_fld), C_LOC(cu_fld))
      CALL check_status('clSetKernelArg: arg 0 of compute_cu_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 1, C_SIZEOF(p_fld), C_LOC(p_fld))
      CALL check_status('clSetKernelArg: arg 1 of compute_cu_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 2, C_SIZEOF(u_fld), C_LOC(u_fld))
      CALL check_status('clSetKernelArg: arg 2 of compute_cu_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 3, C_SIZEOF(xstart), C_LOC(xstart))
      CALL check_status('clSetKernelArg: arg 3 of compute_cu_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 4, C_SIZEOF(xstop), C_LOC(xstop))
      CALL check_status('clSetKernelArg: arg 4 of compute_cu_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 5, C_SIZEOF(ystart), C_LOC(ystart))
      CALL check_status('clSetKernelArg: arg 5 of compute_cu_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 6, C_SIZEOF(ystop), C_LOC(ystop))
      CALL check_status('clSetKernelArg: arg 6 of compute_cu_code', ierr)

    END SUBROUTINE compute_cu_code_set_args
    SUBROUTINE compute_cv_code_set_args(kernel_obj, cv_fld, p_fld, v_fld, xstart_1, xstop_1, ystart_1, ystop_1)
      USE clfortran, ONLY: clSetKernelArg
      USE iso_c_binding, ONLY: C_LOC, C_SIZEOF, c_intptr_t
      USE ocl_utils_mod, ONLY: check_status
      INTEGER(KIND=c_intptr_t), TARGET :: kernel_obj
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: cv_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: p_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: v_fld
      INTEGER, INTENT(IN), TARGET :: xstart_1
      INTEGER, INTENT(IN), TARGET :: xstop_1
      INTEGER, INTENT(IN), TARGET :: ystart_1
      INTEGER, INTENT(IN), TARGET :: ystop_1
      INTEGER ierr

      ! Set the arguments for the compute_cv_code OpenCL Kernel
      ierr = clSetKernelArg(kernel_obj, 0, C_SIZEOF(cv_fld), C_LOC(cv_fld))
      CALL check_status('clSetKernelArg: arg 0 of compute_cv_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 1, C_SIZEOF(p_fld), C_LOC(p_fld))
      CALL check_status('clSetKernelArg: arg 1 of compute_cv_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 2, C_SIZEOF(v_fld), C_LOC(v_fld))
      CALL check_status('clSetKernelArg: arg 2 of compute_cv_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 3, C_SIZEOF(xstart_1), C_LOC(xstart_1))
      CALL check_status('clSetKernelArg: arg 3 of compute_cv_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 4, C_SIZEOF(xstop_1), C_LOC(xstop_1))
      CALL check_status('clSetKernelArg: arg 4 of compute_cv_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 5, C_SIZEOF(ystart_1), C_LOC(ystart_1))
      CALL check_status('clSetKernelArg: arg 5 of compute_cv_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 6, C_SIZEOF(ystop_1), C_LOC(ystop_1))
      CALL check_status('clSetKernelArg: arg 6 of compute_cv_code', ierr)

    END SUBROUTINE compute_cv_code_set_args
    SUBROUTINE compute_z_code_set_args(kernel_obj, z_fld, p_fld, u_fld, v_fld, dx, dy, xstart_2, xstop_2, ystart_2, ystop_2)
      USE clfortran, ONLY: clSetKernelArg
      USE iso_c_binding, ONLY: C_LOC, C_SIZEOF, c_intptr_t
      USE ocl_utils_mod, ONLY: check_status
      INTEGER(KIND=c_intptr_t), TARGET :: kernel_obj
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: z_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: p_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: u_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: v_fld
      REAL(KIND=go_wp), INTENT(IN), TARGET :: dx
      REAL(KIND=go_wp), INTENT(IN), TARGET :: dy
      INTEGER, INTENT(IN), TARGET :: xstart_2
      INTEGER, INTENT(IN), TARGET :: xstop_2
      INTEGER, INTENT(IN), TARGET :: ystart_2
      INTEGER, INTENT(IN), TARGET :: ystop_2
      INTEGER ierr

      ! Set the arguments for the compute_z_code OpenCL Kernel
      ierr = clSetKernelArg(kernel_obj, 0, C_SIZEOF(z_fld), C_LOC(z_fld))
      CALL check_status('clSetKernelArg: arg 0 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 1, C_SIZEOF(p_fld), C_LOC(p_fld))
      CALL check_status('clSetKernelArg: arg 1 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 2, C_SIZEOF(u_fld), C_LOC(u_fld))
      CALL check_status('clSetKernelArg: arg 2 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 3, C_SIZEOF(v_fld), C_LOC(v_fld))
      CALL check_status('clSetKernelArg: arg 3 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 4, C_SIZEOF(dx), C_LOC(dx))
      CALL check_status('clSetKernelArg: arg 4 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 5, C_SIZEOF(dy), C_LOC(dy))
      CALL check_status('clSetKernelArg: arg 5 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 6, C_SIZEOF(xstart_2), C_LOC(xstart_2))
      CALL check_status('clSetKernelArg: arg 6 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 7, C_SIZEOF(xstop_2), C_LOC(xstop_2))
      CALL check_status('clSetKernelArg: arg 7 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 8, C_SIZEOF(ystart_2), C_LOC(ystart_2))
      CALL check_status('clSetKernelArg: arg 8 of compute_z_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 9, C_SIZEOF(ystop_2), C_LOC(ystop_2))
      CALL check_status('clSetKernelArg: arg 9 of compute_z_code', ierr)

    END SUBROUTINE compute_z_code_set_args
    SUBROUTINE compute_h_code_set_args(kernel_obj, h_fld, p_fld, u_fld, v_fld, xstart_3, xstop_3, ystart_3, ystop_3)
      USE clfortran, ONLY: clSetKernelArg
      USE iso_c_binding, ONLY: C_LOC, C_SIZEOF, c_intptr_t
      USE ocl_utils_mod, ONLY: check_status
      INTEGER(KIND=c_intptr_t), TARGET :: kernel_obj
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: h_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: p_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: u_fld
      INTEGER(KIND=c_intptr_t), INTENT(IN), TARGET :: v_fld
      INTEGER, INTENT(IN), TARGET :: xstart_3
      INTEGER, INTENT(IN), TARGET :: xstop_3
      INTEGER, INTENT(IN), TARGET :: ystart_3
      INTEGER, INTENT(IN), TARGET :: ystop_3
      INTEGER ierr

      ! Set the arguments for the compute_h_code OpenCL Kernel
      ierr = clSetKernelArg(kernel_obj, 0, C_SIZEOF(h_fld), C_LOC(h_fld))
      CALL check_status('clSetKernelArg: arg 0 of compute_h_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 1, C_SIZEOF(p_fld), C_LOC(p_fld))
      CALL check_status('clSetKernelArg: arg 1 of compute_h_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 2, C_SIZEOF(u_fld), C_LOC(u_fld))
      CALL check_status('clSetKernelArg: arg 2 of compute_h_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 3, C_SIZEOF(v_fld), C_LOC(v_fld))
      CALL check_status('clSetKernelArg: arg 3 of compute_h_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 4, C_SIZEOF(xstart_3), C_LOC(xstart_3))
      CALL check_status('clSetKernelArg: arg 4 of compute_h_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 5, C_SIZEOF(xstop_3), C_LOC(xstop_3))
      CALL check_status('clSetKernelArg: arg 5 of compute_h_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 6, C_SIZEOF(ystart_3), C_LOC(ystart_3))
      CALL check_status('clSetKernelArg: arg 6 of compute_h_code', ierr)
      ierr = clSetKernelArg(kernel_obj, 7, C_SIZEOF(ystop_3), C_LOC(ystop_3))
      CALL check_status('clSetKernelArg: arg 7 of compute_h_code', ierr)

    END SUBROUTINE compute_h_code_set_args
  END MODULE psy_simple

!-----------------------------------------------------------------------------
! (C) Crown copyright 2021 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------
! LICENCE is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE
! -----------------------------------------------------------------------------
!
! BSD 3-Clause License
!
! Modifications copyright (c) 2022, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by R. W. Ford, STFC Daresbury Lab

!> @brief Computes the tangent linear for hydrostatic balance.
!> @details The nonlinear term is
!!          \f  < \nabla . (cp \theta v) , \Pi > + < \nabla . v, \Phi > \f
!!          The linearized term is
!!          \f    < \nabla . (cp ls_\theta v) , \Pi >
!!             +  < \nabla . (cp \theta v) , ls_\Pi >     \f
module tl_hydrostatic_kernel_mod
  use argument_mod,      only : arg_type, func_type,       &
                                GH_FIELD, GH_REAL,         &
                                GH_SCALAR,                 &
                                GH_READ, GH_INC,           &
                                GH_BASIS, GH_DIFF_BASIS,   &
                                CELL_COLUMN,               &
                                GH_QUADRATURE_XYoZ,        &
                                ANY_W2
  use constants_mod,     only : r_def
  use fs_continuity_mod, only : W3, Wtheta
  use kernel_mod,        only : kernel_type
  implicit none
  private
  !---------------------------------------------------------------------------
  ! Public types
  !---------------------------------------------------------------------------
  !> The type declaration for the kernel. Contains the metadata needed by the
  !> Psy layer.
  !>
  type, public, extends(kernel_type) :: tl_hydrostatic_kernel_type
    private
    type(arg_type) :: meta_args(8) = (/                      &
        arg_type(GH_FIELD,   GH_REAL, GH_INC,  ANY_W2),      &
        arg_type(GH_FIELD,   GH_REAL, GH_READ, W3),          &
        arg_type(GH_FIELD,   GH_REAL, GH_READ, Wtheta),      &
        arg_type(GH_FIELD*3, GH_REAL, GH_READ, Wtheta),      &
        arg_type(GH_FIELD,   GH_REAL, GH_READ, W3),          &
        arg_type(GH_FIELD,   GH_REAL, GH_READ, Wtheta),      &
        arg_type(GH_FIELD*3, GH_REAL, GH_READ, Wtheta),      &
        arg_type(GH_SCALAR,  GH_REAL, GH_READ)               &
        /)
    type(func_type) :: meta_funcs(3) = (/                &
        func_type(ANY_W2,      GH_BASIS, GH_DIFF_BASIS), &
        func_type(W3,          GH_BASIS),                &
        func_type(Wtheta,      GH_BASIS, GH_DIFF_BASIS)  &
        /)
    integer :: operates_on = CELL_COLUMN
    integer :: gh_shape = GH_QUADRATURE_XYoZ
  contains
    procedure, nopass ::tl_hydrostatic_code
  end type
  !---------------------------------------------------------------------------
  ! Contained functions/subroutines
  !---------------------------------------------------------------------------
  public tl_hydrostatic_code
contains
!> @brief Compute the tangent linear of the hydrostatic term.
!! @param[in] nlayers       Number of layers
!! @param[in,out] r_u       ACTIVE Change in Momentum equation right hand side
!! @param[in] exner         ACTIVE Change in Exner pressure field
!! @param[in] theta         ACTIVE Change in Potential temperature field
!! @param[in] moist_dyn_gas ACTIVE Change in Moist dynamics factor in gas law
!! @param[in] moist_dyn_tot ACTIVE Change in Moist dynamics total mass factor
!! @param[in] moist_dyn_fac ACTIVE Change in Moist dynamics water factor
!! @param[in] ls_exner         Lin state Exner pressure field
!! @param[in] ls_theta         Lin state Potential temperature field
!! @param[in] ls_moist_dyn_gas Lin state Moist dynamics factor in gas law
!! @param[in] ls_moist_dyn_tot Lin state Moist dynamics total mass factor
!! @param[in] ls_moist_dyn_fac Lin state Moist dynamics water factor
!! @param[in] cp            Specific heat of dry air at constant pressure
!! @param[in] ndf_w2        Number of degrees of freedom per cell for w2
!! @param[in] undf_w2       Number of unique degrees of freedom  for w2
!! @param[in] map_w2        Dofmap for the cell at the base of the column for w2
!! @param[in] w2_basis      Basis functions evaluated at quadrature points
!! @param[in] w2_diff_basis Differential of the basis functions evaluated
!!                          at quadrature points
!! @param[in] ndf_w3        Number of degrees of freedom per cell for w3
!! @param[in] undf_w3       Number of unique degrees of freedom  for w3
!! @param[in] map_w3        Dofmap for the cell at the base of the column for w3
!! @param[in] w3_basis      Basis functions evaluated at gaussian quadrature
!!                          points
!! @param[in] ndf_wt        Number of degrees of freedom per cell for wt
!! @param[in] undf_wt       Number of unique degrees of freedom  for wt
!! @param[in] map_wt        Dofmap for the cell at the base of the column for wt
!! @param[in] wt_basis      Basis functions evaluated at gaussian quadrature
!!                          points
!! @param[in] wt_diff_basis Differential of the basis functions evaluated at
!!                          quadrature points
!! @param[in] nqp_h         Number of quadrature points in the horizontal
!! @param[in] nqp_v         Number of quadrature points in the vertical
!! @param[in] wqp_h         Horizontal quadrature weights
!! @param[in] wqp_v         Vertical quadrature weights
subroutine tl_hydrostatic_code(nlayers,          &
                               r_u,              &
                               exner,            &
                               theta,            &
                               moist_dyn_gas,    &
                               moist_dyn_tot,    &
                               moist_dyn_fac,    &
                               ls_exner,         &
                               ls_theta,         &
                               ls_moist_dyn_gas, &
                               ls_moist_dyn_tot, &
                               ls_moist_dyn_fac, &
                               cp,               &
                               ndf_w2,           &
                               undf_w2,          &
                               map_w2,           &
                               w2_basis,         &
                               w2_diff_basis,    &
                               ndf_w3,           &
                               undf_w3,          &
                               map_w3,           &
                               w3_basis,         &
                               ndf_wt,           &
                               undf_wt,          &
                               map_wt,           &
                               wt_basis,         &
                               wt_diff_basis,    &
                               nqp_h,            &
                               nqp_v,            &
                               wqp_h,            &
                               wqp_v             &
                               )
  implicit none
  ! Arguments
  integer, intent(in) :: nlayers,nqp_h, nqp_v
  integer, intent(in) :: ndf_wt, ndf_w2, ndf_w3
  integer, intent(in) :: undf_wt, undf_w2, undf_w3
  integer, dimension(ndf_wt), intent(in) :: map_wt
  integer, dimension(ndf_w2), intent(in) :: map_w2
  integer, dimension(ndf_w3), intent(in) :: map_w3
  real(kind=r_def), dimension(1,ndf_w3,nqp_h,nqp_v), intent(in) :: w3_basis
  real(kind=r_def), dimension(3,ndf_w2,nqp_h,nqp_v), intent(in) :: w2_basis
  real(kind=r_def), dimension(1,ndf_wt,nqp_h,nqp_v), intent(in) :: wt_basis
  real(kind=r_def), dimension(1,ndf_w2,nqp_h,nqp_v), intent(in) :: w2_diff_basis
  real(kind=r_def), dimension(3,ndf_wt,nqp_h,nqp_v), intent(in) :: wt_diff_basis
  real(kind=r_def), dimension(undf_w2), intent(inout) :: r_u
  real(kind=r_def), dimension(undf_w3), intent(in)    :: exner
  real(kind=r_def), dimension(undf_wt), intent(in)    :: theta
  real(kind=r_def), dimension(undf_wt), intent(in)    :: moist_dyn_gas, &
                                                         moist_dyn_tot, &
                                                         moist_dyn_fac
  real(kind=r_def), dimension(undf_w3), intent(in)    :: ls_exner
  real(kind=r_def), dimension(undf_wt), intent(in)    :: ls_theta
  real(kind=r_def), dimension(undf_wt), intent(in)    :: ls_moist_dyn_gas, &
                                                         ls_moist_dyn_tot, &
                                                         ls_moist_dyn_fac
  real(kind=r_def),                     intent(in)    :: cp
  real(kind=r_def), dimension(nqp_h), intent(in)      ::  wqp_h
  real(kind=r_def), dimension(nqp_v), intent(in)      ::  wqp_v
  ! Internal variables
  integer               :: df, k
  integer               :: qp1, qp2
  real(kind=r_def), dimension(ndf_w3)          :: exner_e
  real(kind=r_def), dimension(ndf_wt)          :: theta_v_e
  real(kind=r_def), dimension(ndf_w3)          :: ls_exner_e
  real(kind=r_def), dimension(ndf_wt)          :: ls_theta_v_e
  real(kind=r_def) :: grad_theta_v_at_quad(3), ls_grad_theta_v_at_quad(3), v(3)
  real(kind=r_def) :: exner_at_quad, theta_v_at_quad,       &
                      ls_exner_at_quad, ls_theta_v_at_quad, &
                      grad_term, dv
  do k = 0, nlayers-1
    ! Linearisation state
    do df = 1, ndf_w3
      ls_exner_e(df) = ls_exner( map_w3(df) + k )
    end do
    do df = 1, ndf_wt
      ls_theta_v_e(df) = ls_theta( map_wt(df) + k ) * &
                         ls_moist_dyn_gas( map_wt(df) + k ) / &
                         ls_moist_dyn_tot( map_wt(df) + k )
    end do
    ! Perturbation
    do df = 1, ndf_w3
      exner_e(df) = exner( map_w3(df) + k )
    end do
    do df = 1, ndf_wt
      theta_v_e(df) = ls_theta_v_e(df) * &
         ( theta( map_wt(df) + k ) /  ls_theta( map_wt(df) + k )  +               &
           moist_dyn_gas( map_wt(df) + k ) / ls_moist_dyn_gas( map_wt(df) + k ) - &
           moist_dyn_tot( map_wt(df) + k ) / ls_moist_dyn_tot( map_wt(df) + k ) )
    end do
    ! Compute the RHS integrated over one cell
    do qp2 = 1, nqp_v
      do qp1 = 1, nqp_h
        ! Linearisation state
        ls_exner_at_quad = 0.0_r_def
        do df = 1, ndf_w3
          ls_exner_at_quad  = ls_exner_at_quad + ls_exner_e(df)*w3_basis(1,df,qp1,qp2)
        end do
        ls_theta_v_at_quad = 0.0_r_def
        ls_grad_theta_v_at_quad(:) = 0.0_r_def
        do df = 1, ndf_wt
          ls_theta_v_at_quad   = ls_theta_v_at_quad                                 &
                            + ls_theta_v_e(df)*wt_basis(1,df,qp1,qp2)
          ls_grad_theta_v_at_quad(:) = ls_grad_theta_v_at_quad(:)                   &
                                  + ls_theta_v_e(df)*wt_diff_basis(:,df,qp1,qp2)
        end do
        ! Perturbation
        exner_at_quad = 0.0_r_def
        do df = 1, ndf_w3
          exner_at_quad  = exner_at_quad + exner_e(df)*w3_basis(1,df,qp1,qp2)
        end do
        theta_v_at_quad = 0.0_r_def
        grad_theta_v_at_quad(:) = 0.0_r_def
        do df = 1, ndf_wt
          theta_v_at_quad   = theta_v_at_quad                                 &
                            + theta_v_e(df)*wt_basis(1,df,qp1,qp2)
          grad_theta_v_at_quad(:) = grad_theta_v_at_quad(:)                   &
                                   + theta_v_e(df)*wt_diff_basis(:,df,qp1,qp2)
        end do
        ! Calculation
        do df = 1, ndf_w2
          v  = w2_basis(:,df,qp1,qp2)
          dv = w2_diff_basis(1,df,qp1,qp2)
          ! Pressure gradient term
          grad_term = cp * ls_exner_at_quad * (                        &
                      theta_v_at_quad * dv                             &
                    + dot_product( grad_theta_v_at_quad(:),v) ) +      &
                      cp * exner_at_quad * (                           &
                      ls_theta_v_at_quad * dv                          &
                    + dot_product( ls_grad_theta_v_at_quad(:),v) )
          r_u( map_w2(df) + k ) = r_u( map_w2(df) + k ) &
                                + wqp_h(qp1)*wqp_v(qp2)*grad_term
        end do
      end do
    end do
  end do
end subroutine tl_hydrostatic_code
end module tl_hydrostatic_kernel_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2021-2022, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! ------------------------------------------------------------------------------
! Author: A. R. Porter, STFC Daresbury Lab
! Modified by: R. W. Ford, STFC Daresbury Lab

! Example module containing a very simple kernel subroutine that
! contains assignments within a loop over array elements.

module testkern_mod
  implicit none

contains

  subroutine testkern_code(ascalar, field1, field2, field3, npts)
    real, intent(in) :: ascalar
    integer, intent(in) :: npts
    real, intent(inout), dimension(npts) :: field2
    ! Deliberately leave off the intent for 'field1' to demonstrate that
    ! it is correctly set in the generated adjoint code.
    real, dimension(npts) :: field1
    ! This argument must be made intent(inout) in the adjoint
    real, intent(in), dimension(npts) :: field3
    ! Locals
    real :: tmp, tmp2, tmp3
    integer :: i

    tmp = ascalar*ascalar
    do i=1,npts
       tmp2 = tmp*i
       field1(i) = tmp*field1(i) + field2(i) + field3(i)
       tmp3 = tmp2*3.0
       field2(i) = field2(i) + field1(i)/tmp2
    end do
    field2(npts) = field2(npts) + field1(1)
    field2(:) = field1(:) - tmp*field3(:)

  end subroutine testkern_code
  
end module testkern_mod

! BSD 3-Clause License
!
! Copyright (c) 2017-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author R. W. Ford, STFC Daresbury Lab
! Modified by J. Henrichs, Bureau of Meteorology
! Modified by I. Kavcic, Met Office

module testkern_w0_kernel_mod

  use argument_mod
  use kernel_mod
  use fs_continuity_mod, only: W0

  use constants_mod

  implicit none

  private

  type, public, extends(kernel_type) :: testkern_w0_kernel_type
     private
     type(arg_type), dimension(2) :: meta_args =       &
          (/ arg_type(gh_field, gh_real, gh_inc,  w0), &
             arg_type(gh_field, gh_real, gh_read, w0)  &
           /)
     integer :: operates_on = cell_column
   contains
     procedure, nopass :: code => testkern_w0_code
  end type testkern_w0_kernel_type

  public :: testkern_w0_code

contains

  subroutine testkern_w0_code(nlayers, fld1, fld2, ndf_w0, undf_w0, map_w0)

    implicit none

    integer(kind=i_def), intent(in)                     :: nlayers
    integer(kind=i_def)                                 :: ndf_w0, undf_w0
    real(kind=r_def), dimension(undf_w0), intent(inout) :: fld1
    real(kind=r_def), dimension(undf_w0), intent(in)    :: fld2
    integer(kind=i_def), dimension(ndf_w0)              :: map_w0

    integer(kind=i_def)                                 :: i, k

    do k=0, nlayers-1
      do i=1, ndf_w0
        fld1(map_w0(i)+k) = fld1(map_w0(i)+k) + fld2(map_w0(i)+k)
      end do
    end do

  end subroutine testkern_w0_code

end module testkern_w0_kernel_mod

  MODULE psy_shallow
    USE field_mod
    USE kind_params_mod
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(cu_fld, p_fld, u_fld, cv_fld, v_fld, z_fld, h_fld)
      USE compute_cu_mod, ONLY: compute_cu_code
      USE compute_cv_mod, ONLY: compute_cv_code
      USE compute_z_mod, ONLY: compute_z_code
      USE compute_h_mod, ONLY: compute_h_code
      TYPE(r2d_field), intent(inout) :: cu_fld
      TYPE(r2d_field), intent(inout) :: p_fld
      TYPE(r2d_field), intent(inout) :: u_fld
      TYPE(r2d_field), intent(inout) :: cv_fld
      TYPE(r2d_field), intent(inout) :: v_fld
      TYPE(r2d_field), intent(inout) :: z_fld
      TYPE(r2d_field), intent(inout) :: h_fld
      INTEGER j
      INTEGER i

      !$omp parallel default(shared), private(i,j)
      !$omp single
      !$omp taskloop
      DO j = cu_fld%internal%ystart, cu_fld%internal%ystop, 1
        DO i = cu_fld%internal%xstart, cu_fld%internal%xstop, 1
          CALL compute_cu_code(i, j, cu_fld%data, p_fld%data, u_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = cv_fld%internal%ystart, cv_fld%internal%ystop, 1
        DO i = cv_fld%internal%xstart, cv_fld%internal%xstop, 1
          CALL compute_cv_code(i, j, cv_fld%data, p_fld%data, v_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = z_fld%internal%ystart, z_fld%internal%ystop, 1
        DO i = z_fld%internal%xstart, z_fld%internal%xstop, 1
          CALL compute_z_code(i, j, z_fld%data, p_fld%data, u_fld%data, v_fld%data, p_fld%grid%dx, p_fld%grid%dy)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = h_fld%internal%ystart, h_fld%internal%ystop, 1
        DO i = h_fld%internal%xstart, h_fld%internal%xstop, 1
          CALL compute_h_code(i, j, h_fld%data, p_fld%data, u_fld%data, v_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp end single
      !$omp end parallel

    END SUBROUTINE invoke_0
    SUBROUTINE invoke_1(unew_fld, uold_fld, z_fld, cv_fld, h_fld, tdt, vnew_fld, vold_fld, cu_fld, pnew_fld, pold_fld)
      USE compute_unew_mod, ONLY: compute_unew_code
      USE compute_vnew_mod, ONLY: compute_vnew_code
      USE compute_pnew_mod, ONLY: compute_pnew_code
      TYPE(r2d_field), intent(inout) :: unew_fld
      TYPE(r2d_field), intent(inout) :: uold_fld
      TYPE(r2d_field), intent(inout) :: z_fld
      TYPE(r2d_field), intent(inout) :: cv_fld
      TYPE(r2d_field), intent(inout) :: h_fld
      REAL(KIND=go_wp), intent(inout) :: tdt
      TYPE(r2d_field), intent(inout) :: vnew_fld
      TYPE(r2d_field), intent(inout) :: vold_fld
      TYPE(r2d_field), intent(inout) :: cu_fld
      TYPE(r2d_field), intent(inout) :: pnew_fld
      TYPE(r2d_field), intent(inout) :: pold_fld
      INTEGER j
      INTEGER i

      !$omp parallel default(shared), private(i,j)
      !$omp single
      !$omp taskloop
      DO j = unew_fld%internal%ystart, unew_fld%internal%ystop, 1
        DO i = unew_fld%internal%xstart, unew_fld%internal%xstop, 1
          CALL compute_unew_code(i, j, unew_fld%data, uold_fld%data, z_fld%data, cv_fld%data, h_fld%data, tdt, uold_fld%grid%dy)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = vnew_fld%internal%ystart, vnew_fld%internal%ystop, 1
        DO i = vnew_fld%internal%xstart, vnew_fld%internal%xstop, 1
          CALL compute_vnew_code(i, j, vnew_fld%data, vold_fld%data, z_fld%data, cu_fld%data, h_fld%data, tdt, vold_fld%grid%dy)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = pnew_fld%internal%ystart, pnew_fld%internal%ystop, 1
        DO i = pnew_fld%internal%xstart, pnew_fld%internal%xstop, 1
          CALL compute_pnew_code(i, j, pnew_fld%data, pold_fld%data, cu_fld%data, cv_fld%data, tdt, pold_fld%grid%dx, &
&pold_fld%grid%dy)
        END DO
      END DO
      !$omp end taskloop
      !$omp end single
      !$omp end parallel

    END SUBROUTINE invoke_1
    SUBROUTINE invoke_2(u_fld, unew_fld, uold_fld, v_fld, vnew_fld, vold_fld, p_fld, pnew_fld, pold_fld)
      USE time_smooth_mod, ONLY: time_smooth_code
      TYPE(r2d_field), intent(inout) :: u_fld
      TYPE(r2d_field), intent(inout) :: unew_fld
      TYPE(r2d_field), intent(inout) :: uold_fld
      TYPE(r2d_field), intent(inout) :: v_fld
      TYPE(r2d_field), intent(inout) :: vnew_fld
      TYPE(r2d_field), intent(inout) :: vold_fld
      TYPE(r2d_field), intent(inout) :: p_fld
      TYPE(r2d_field), intent(inout) :: pnew_fld
      TYPE(r2d_field), intent(inout) :: pold_fld
      INTEGER j
      INTEGER i

      !$omp parallel default(shared), private(i,j)
      !$omp single
      !$omp taskloop
      DO j = 1, SIZE(uold_fld%data, 2), 1
        DO i = 1, SIZE(uold_fld%data, 1), 1
          CALL time_smooth_code(i, j, u_fld%data, unew_fld%data, uold_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = 1, SIZE(vold_fld%data, 2), 1
        DO i = 1, SIZE(vold_fld%data, 1), 1
          CALL time_smooth_code(i, j, v_fld%data, vnew_fld%data, vold_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = 1, SIZE(pold_fld%data, 2), 1
        DO i = 1, SIZE(pold_fld%data, 1), 1
          CALL time_smooth_code(i, j, p_fld%data, pnew_fld%data, pold_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp end single
      !$omp end parallel

    END SUBROUTINE invoke_2
    SUBROUTINE invoke_3(u_fld, unew_fld, v_fld, vnew_fld, p_fld, pnew_fld)
      USE infrastructure_mod, ONLY: field_copy_code
      TYPE(r2d_field), intent(inout) :: u_fld
      TYPE(r2d_field), intent(inout) :: unew_fld
      TYPE(r2d_field), intent(inout) :: v_fld
      TYPE(r2d_field), intent(inout) :: vnew_fld
      TYPE(r2d_field), intent(inout) :: p_fld
      TYPE(r2d_field), intent(inout) :: pnew_fld
      INTEGER j
      INTEGER i

      !$omp parallel default(shared), private(i,j)
      !$omp single
      !$omp taskloop
      DO j = 1, SIZE(u_fld%data, 2), 1
        DO i = 1, SIZE(u_fld%data, 1), 1
          CALL field_copy_code(i, j, u_fld%data, unew_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = 1, SIZE(v_fld%data, 2), 1
        DO i = 1, SIZE(v_fld%data, 1), 1
          CALL field_copy_code(i, j, v_fld%data, vnew_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp taskloop
      DO j = 1, SIZE(p_fld%data, 2), 1
        DO i = 1, SIZE(p_fld%data, 1), 1
          CALL field_copy_code(i, j, p_fld%data, pnew_fld%data)
        END DO
      END DO
      !$omp end taskloop
      !$omp end single
      !$omp end parallel

    END SUBROUTINE invoke_3
  END MODULE psy_shallow

program shallow
  use kind_params_mod
  use shallow_io_mod
  use timing_mod
  use gocean_mod, only : model_write_log
  use model_mod
  use grid_mod
  use field_mod
  use initial_conditions_mod
  use time_smooth_mod, only : time_smooth
  use apply_bcs_mod, only : invoke_apply_bcs
  use compute_cu_mod, only : compute_cu
  use compute_cv_mod, only : compute_cv
  use compute_z_mod, only : compute_z
  use compute_h_mod, only : compute_h
  use compute_unew_mod, only : compute_unew
  use compute_vnew_mod, only : compute_vnew
  use compute_pnew_mod, only : compute_pnew
  use infrastructure_mod, only : copy
  use psy_shallow, only : invoke_0, invoke_1, invoke_2, invoke_3
  TYPE(grid_type), TARGET :: model_grid
  type(r2d_field) :: p_fld
  type(r2d_field) :: pold_fld
  type(r2d_field) :: pnew_fld
  type(r2d_field) :: u_fld
  type(r2d_field) :: uold_fld
  type(r2d_field) :: unew_fld
  type(r2d_field) :: v_fld
  type(r2d_field) :: vold_fld
  type(r2d_field) :: vnew_fld
  type(r2d_field) :: cu_fld
  type(r2d_field) :: cv_fld
  type(r2d_field) :: z_fld
  type(r2d_field) :: h_fld
  type(r2d_field) :: psi_fld
  integer :: ncycle
  integer :: itmax
  integer :: idxt0
  integer :: idxt1
  real(kind=go_wp) :: dt
  real(kind=go_wp) :: tdt

  model_grid = grid_type(GO_ARAKAWA_C,(/GO_BC_PERIODIC, GO_BC_PERIODIC, GO_BC_NONE/),GO_OFFSET_SW)
  call model_init(model_grid)
  p_fld = r2d_field(model_grid,GO_T_POINTS)
  pold_fld = r2d_field(model_grid,GO_T_POINTS)
  pnew_fld = r2d_field(model_grid,GO_T_POINTS)
  u_fld = r2d_field(model_grid,GO_U_POINTS)
  uold_fld = r2d_field(model_grid,GO_U_POINTS)
  unew_fld = r2d_field(model_grid,GO_U_POINTS)
  v_fld = r2d_field(model_grid,GO_V_POINTS)
  vold_fld = r2d_field(model_grid,GO_V_POINTS)
  vnew_fld = r2d_field(model_grid,GO_V_POINTS)
  cu_fld = r2d_field(model_grid,GO_U_POINTS)
  cv_fld = r2d_field(model_grid,GO_V_POINTS)
  z_fld = r2d_field(model_grid,GO_F_POINTS)
  h_fld = r2d_field(model_grid,GO_T_POINTS)
  psi_fld = r2d_field(model_grid,GO_F_POINTS)
  tdt = dt
  call init_initial_condition_params(p_fld)
  call invoke_init_stream_fn_kernel(psi_fld)
  call init_pressure(p_fld)
  call init_velocity_u(u_fld, psi_fld)
  call init_velocity_v(v_fld, psi_fld)
  call invoke_apply_bcs(u_fld)
  call invoke_apply_bcs(v_fld)
  call model_write_log("('psi initial CHECKSUM = ',E24.16)", field_checksum(psi_fld))
  call model_write_log("('P initial CHECKSUM = ',E24.16)", field_checksum(p_fld))
  call model_write_log("('U initial CHECKSUM = ',E24.16)", field_checksum(u_fld))
  call model_write_log("('V initial CHECKSUM = ',E24.16)", field_checksum(v_fld))
  call copy_field(u_fld, uold_fld)
  call copy_field(v_fld, vold_fld)
  call copy_field(p_fld, pold_fld)
  call ascii_write(0, 'psifld.dat', psi_fld%data, psi_fld%internal%nx, psi_fld%internal%ny, psi_fld%internal%xstart, &
&psi_fld%internal%ystart)
  call model_write(0, p_fld, u_fld, v_fld)
  call timer_start('Time-stepping', idxt0)
  do ncycle = 1, itmax, 1
    call timer_start('Compute c{u,v},z,h', idxt1)
    call invoke_0(cu_fld, p_fld, u_fld, cv_fld, v_fld, z_fld, h_fld)
    call timer_stop(idxt1)
    call timer_start('PBCs-1', idxt1)
    call invoke_apply_bcs(cu_fld)
    call invoke_apply_bcs(cv_fld)
    call invoke_apply_bcs(h_fld)
    call invoke_apply_bcs(z_fld)
    call timer_stop(idxt1)
    call timer_start('Compute new fields', idxt1)
    call invoke_1(unew_fld, uold_fld, z_fld, cv_fld, h_fld, tdt, vnew_fld, vold_fld, cu_fld, pnew_fld, pold_fld)
    call timer_stop(idxt1)
    call timer_start('PBCs-2', idxt1)
    call invoke_apply_bcs(unew_fld)
    call invoke_apply_bcs(vnew_fld)
    call invoke_apply_bcs(pnew_fld)
    call timer_stop(idxt1)
    call model_write(ncycle, p_fld, u_fld, v_fld)
    if (ncycle > 1) then
      call timer_start('Time smoothing', idxt1)
      call invoke_2(u_fld, unew_fld, uold_fld, v_fld, vnew_fld, vold_fld, p_fld, pnew_fld, pold_fld)
      call timer_stop(idxt1)
    else
      tdt = tdt + dt
    end if
    call timer_start('Field copy', idxt1)
    call invoke_3(u_fld, unew_fld, v_fld, vnew_fld, p_fld, pnew_fld)
    call timer_stop(idxt1)
  enddo
  call timer_stop(idxt0)
  call model_write_log("('P CHECKSUM after ',I6,' steps = ',E24.16)", itmax, field_checksum(pnew_fld))
  call model_write_log("('U CHECKSUM after ',I6,' steps = ',E24.16)", itmax, field_checksum(unew_fld))
  call model_write_log("('V CHECKSUM after ',I6,' steps = ',E24.16)", itmax, field_checksum(vnew_fld))
  call model_finalise()

end program shallow

PROGRAM main
  USE main_psy, ONLY: invoke_1
  USE main_psy, ONLY: invoke_0
  USE mesh_mod, ONLY: mesh_type, plane
  USE partition_mod, ONLY: partition_type, partitioner_interface, partitioner_planar
  USE global_mesh_base_mod, ONLY: global_mesh_base_type
  USE extrusion_mod, ONLY: uniform_extrusion_type
  USE field_mod, ONLY: field_type
  USE function_space_mod, ONLY: function_space_type
  USE fs_continuity_mod, ONLY: w0, w3, wtheta
  USE constants_mod, ONLY: i_def, r_def
  USE operator_mod, ONLY: operator_type
  USE tl_rhs_eos_kernel_mod, ONLY: tl_rhs_eos_kernel_type
  USE tl_rhs_eos_kernel_mod_adj, ONLY: tl_rhs_eos_kernel_type_adj
  USE quadrature_xyoz_mod, ONLY: quadrature_xyoz_type
  USE quadrature_rule_gaussian_mod, ONLY: quadrature_rule_gaussian_type
  INTEGER, PARAMETER :: element_order = 1
  REAL(KIND = r_def), PARAMETER :: overall_tolerance = 1500.0_r_def
  TYPE(partition_type) :: partition
  TYPE(mesh_type), TARGET :: mesh
  TYPE(global_mesh_base_type), TARGET :: global_mesh
  CLASS(global_mesh_base_type), POINTER :: global_mesh_ptr
  TYPE(uniform_extrusion_type), TARGET :: extrusion
  TYPE(uniform_extrusion_type), POINTER :: extrusion_ptr
  PROCEDURE(partitioner_interface), POINTER :: partitioner_ptr
  INTEGER :: ndata_sz
  TYPE(function_space_type), TARGET :: vector_space_w0
  TYPE(function_space_type), POINTER :: vector_space_w0_ptr
  TYPE(function_space_type), TARGET :: vector_space_w3
  TYPE(function_space_type), POINTER :: vector_space_w3_ptr
  TYPE(function_space_type), TARGET :: vector_space_wtheta
  TYPE(function_space_type), POINTER :: vector_space_wtheta_ptr
  TYPE(field_type) :: field_1
  TYPE(field_type) :: field_2
  TYPE(field_type) :: field_3
  TYPE(field_type) :: field_4
  TYPE(field_type) :: field_5
  TYPE(field_type) :: field_6
  TYPE(field_type) :: field_7
  TYPE(field_type) :: field_8
  TYPE(field_type) :: field_9
  TYPE(field_type), DIMENSION(3) :: field_10
  TYPE(field_type) :: field_11
  REAL(KIND = r_def) :: rscalar_12
  REAL(KIND = r_def) :: rscalar_13
  REAL(KIND = r_def) :: rscalar_14
  TYPE(quadrature_xyoz_type) :: qr_xyoz
  TYPE(quadrature_rule_gaussian_type) :: quadrature_rule
  TYPE(field_type) :: field_1_input
  TYPE(field_type) :: field_2_input
  TYPE(field_type) :: field_3_input
  TYPE(field_type) :: field_4_input
  TYPE(field_type) :: field_5_input
  TYPE(field_type) :: field_6_input
  TYPE(field_type) :: field_7_input
  TYPE(field_type) :: field_8_input
  TYPE(field_type) :: field_9_input
  TYPE(field_type), DIMENSION(3) :: field_10_input
  TYPE(field_type) :: field_11_input
  REAL(KIND = r_def) :: rscalar_12_input
  REAL(KIND = r_def) :: rscalar_13_input
  REAL(KIND = r_def) :: rscalar_14_input
  TYPE(quadrature_xyoz_type) :: qr_xyoz_input
  REAL(KIND = r_def) :: field_1_inner_prod
  REAL(KIND = r_def) :: field_2_inner_prod
  REAL(KIND = r_def) :: field_3_inner_prod
  REAL(KIND = r_def) :: field_4_inner_prod
  REAL(KIND = r_def) :: field_5_inner_prod
  REAL(KIND = r_def) :: field_6_inner_prod
  REAL(KIND = r_def) :: field_7_inner_prod
  REAL(KIND = r_def) :: field_8_inner_prod
  REAL(KIND = r_def) :: field_9_inner_prod
  REAL(KIND = r_def), DIMENSION(3) :: field_10_inner_prod
  REAL(KIND = r_def) :: field_11_inner_prod
  REAL(KIND = r_def) :: inner1
  REAL(KIND = r_def) :: inner2
  REAL(KIND = r_def) :: MachineTol
  REAL(KIND = r_def) :: relative_diff
  global_mesh = global_mesh_base_type()
  global_mesh_ptr => global_mesh
  partitioner_ptr => partitioner_planar
  partition = partition_type(global_mesh_ptr, partitioner_ptr, 1, 1, 0, 0, 1)
  extrusion = uniform_extrusion_type(0.0_r_def, 100.0_r_def, 100)
  extrusion_ptr => extrusion
  mesh = mesh_type(global_mesh_ptr, partition, extrusion_ptr)
  WRITE(*, *) "Mesh has", mesh % get_nlayers(), "layers."
  ndata_sz = 1
  vector_space_w0 = function_space_type(mesh, element_order, w0, ndata_sz)
  vector_space_w0_ptr => vector_space_w0
  vector_space_w3 = function_space_type(mesh, element_order, w3, ndata_sz)
  vector_space_w3_ptr => vector_space_w3
  vector_space_wtheta = function_space_type(mesh, element_order, wtheta, ndata_sz)
  vector_space_wtheta_ptr => vector_space_wtheta
  CALL field_1 % initialise(vector_space = vector_space_w3_ptr, name = 'field_1')
  CALL field_2 % initialise(vector_space = vector_space_w3_ptr, name = 'field_2')
  CALL field_3 % initialise(vector_space = vector_space_w3_ptr, name = 'field_3')
  CALL field_4 % initialise(vector_space = vector_space_wtheta_ptr, name = 'field_4')
  CALL field_5 % initialise(vector_space = vector_space_wtheta_ptr, name = 'field_5')
  CALL field_6 % initialise(vector_space = vector_space_w3_ptr, name = 'field_6')
  CALL field_7 % initialise(vector_space = vector_space_w3_ptr, name = 'field_7')
  CALL field_8 % initialise(vector_space = vector_space_wtheta_ptr, name = 'field_8')
  CALL field_9 % initialise(vector_space = vector_space_wtheta_ptr, name = 'field_9')
  CALL field_10(1) % initialise(vector_space = vector_space_w0_ptr, name = 'field_10')
  CALL field_10(2) % initialise(vector_space = vector_space_w0_ptr, name = 'field_10')
  CALL field_10(3) % initialise(vector_space = vector_space_w0_ptr, name = 'field_10')
  CALL field_11 % initialise(vector_space = vector_space_w3_ptr, name = 'field_11')
  qr_xyoz = quadrature_xyoz_type(element_order + 3, quadrature_rule)
  CALL random_number(rscalar_12)
  rscalar_12_input = rscalar_12
  CALL random_number(rscalar_13)
  rscalar_13_input = rscalar_13
  CALL random_number(rscalar_14)
  rscalar_14_input = rscalar_14
  CALL field_1_input % initialise(vector_space = vector_space_w3_ptr, name = 'field_1_input')
  CALL field_2_input % initialise(vector_space = vector_space_w3_ptr, name = 'field_2_input')
  CALL field_3_input % initialise(vector_space = vector_space_w3_ptr, name = 'field_3_input')
  CALL field_4_input % initialise(vector_space = vector_space_wtheta_ptr, name = 'field_4_input')
  CALL field_5_input % initialise(vector_space = vector_space_wtheta_ptr, name = 'field_5_input')
  CALL field_6_input % initialise(vector_space = vector_space_w3_ptr, name = 'field_6_input')
  CALL field_7_input % initialise(vector_space = vector_space_w3_ptr, name = 'field_7_input')
  CALL field_8_input % initialise(vector_space = vector_space_wtheta_ptr, name = 'field_8_input')
  CALL field_9_input % initialise(vector_space = vector_space_wtheta_ptr, name = 'field_9_input')
  CALL field_10_input(1) % initialise(vector_space = vector_space_w0_ptr, name = 'field_10_input')
  CALL field_10_input(2) % initialise(vector_space = vector_space_w0_ptr, name = 'field_10_input')
  CALL field_10_input(3) % initialise(vector_space = vector_space_w0_ptr, name = 'field_10_input')
  CALL field_11_input % initialise(vector_space = vector_space_w3_ptr, name = 'field_11_input')
  field_1_inner_prod = 0.0_r_def
  field_2_inner_prod = 0.0_r_def
  field_3_inner_prod = 0.0_r_def
  field_4_inner_prod = 0.0_r_def
  field_5_inner_prod = 0.0_r_def
  field_6_inner_prod = 0.0_r_def
  field_7_inner_prod = 0.0_r_def
  field_8_inner_prod = 0.0_r_def
  field_9_inner_prod = 0.0_r_def
  field_10_inner_prod(1) = 0.0_r_def
  field_10_inner_prod(2) = 0.0_r_def
  field_10_inner_prod(3) = 0.0_r_def
  field_11_inner_prod = 0.0_r_def
  CALL invoke_0(field_1, field_1_input, field_2, field_2_input, field_3, field_3_input, field_4, field_4_input, field_5, &
&field_5_input, field_6, field_6_input, field_7, field_7_input, field_8, field_8_input, field_9, field_9_input, field_10(1), &
&field_10_input(1), field_10(2), field_10_input(2), field_10(3), field_10_input(3), field_11, field_11_input, field_10, &
&rscalar_12, rscalar_13, rscalar_14, field_1_inner_prod, field_2_inner_prod, field_3_inner_prod, field_4_inner_prod, &
&field_5_inner_prod, field_6_inner_prod, field_7_inner_prod, field_8_inner_prod, field_9_inner_prod, field_10_inner_prod(1), &
&field_10_inner_prod(2), field_10_inner_prod(3), field_11_inner_prod, qr_xyoz)
  inner1 = 0.0_r_def
  inner1 = inner1 + rscalar_12 * rscalar_12
  inner1 = inner1 + rscalar_13 * rscalar_13
  inner1 = inner1 + rscalar_14 * rscalar_14
  inner1 = inner1 + field_1_inner_prod
  inner1 = inner1 + field_2_inner_prod
  inner1 = inner1 + field_3_inner_prod
  inner1 = inner1 + field_4_inner_prod
  inner1 = inner1 + field_5_inner_prod
  inner1 = inner1 + field_6_inner_prod
  inner1 = inner1 + field_7_inner_prod
  inner1 = inner1 + field_8_inner_prod
  inner1 = inner1 + field_9_inner_prod
  inner1 = inner1 + field_10_inner_prod(1)
  inner1 = inner1 + field_10_inner_prod(2)
  inner1 = inner1 + field_10_inner_prod(3)
  inner1 = inner1 + field_11_inner_prod
  field_1_inner_prod = 0.0_r_def
  field_2_inner_prod = 0.0_r_def
  field_3_inner_prod = 0.0_r_def
  field_4_inner_prod = 0.0_r_def
  field_5_inner_prod = 0.0_r_def
  field_6_inner_prod = 0.0_r_def
  field_7_inner_prod = 0.0_r_def
  field_8_inner_prod = 0.0_r_def
  field_9_inner_prod = 0.0_r_def
  field_10_inner_prod(1) = 0.0_r_def
  field_10_inner_prod(2) = 0.0_r_def
  field_10_inner_prod(3) = 0.0_r_def
  field_11_inner_prod = 0.0_r_def
  CALL invoke_1(field_1, field_2, field_3, field_4, field_5, field_6, field_7, field_8, field_9, field_10, field_11, rscalar_12, &
&rscalar_13, rscalar_14, field_1_inner_prod, field_1_input, field_2_inner_prod, field_2_input, field_3_inner_prod, field_3_input, &
&field_4_inner_prod, field_4_input, field_5_inner_prod, field_5_input, field_6_inner_prod, field_6_input, field_7_inner_prod, &
&field_7_input, field_8_inner_prod, field_8_input, field_9_inner_prod, field_9_input, field_10_inner_prod(1), field_10(1), &
&field_10_input(1), field_10_inner_prod(2), field_10(2), field_10_input(2), field_10_inner_prod(3), field_10(3), &
&field_10_input(3), field_11_inner_prod, field_11_input, qr_xyoz)
  inner2 = 0.0_r_def
  inner2 = inner2 + rscalar_12 * rscalar_12_input
  inner2 = inner2 + rscalar_13 * rscalar_13_input
  inner2 = inner2 + rscalar_14 * rscalar_14_input
  inner2 = inner2 + field_1_inner_prod
  inner2 = inner2 + field_2_inner_prod
  inner2 = inner2 + field_3_inner_prod
  inner2 = inner2 + field_4_inner_prod
  inner2 = inner2 + field_5_inner_prod
  inner2 = inner2 + field_6_inner_prod
  inner2 = inner2 + field_7_inner_prod
  inner2 = inner2 + field_8_inner_prod
  inner2 = inner2 + field_9_inner_prod
  inner2 = inner2 + field_10_inner_prod(1)
  inner2 = inner2 + field_10_inner_prod(2)
  inner2 = inner2 + field_10_inner_prod(3)
  inner2 = inner2 + field_11_inner_prod
  MachineTol = SPACING(MAX(ABS(inner1), ABS(inner2)))
  relative_diff = ABS(inner1 - inner2) / MachineTol
  IF (relative_diff < overall_tolerance) THEN
    WRITE(*, *) 'Test of adjoint of ''tl_rhs_eos_kernel_type'' PASSED: ', inner1, inner2, relative_diff
  ELSE
    WRITE(*, *) 'Test of adjoint of ''tl_rhs_eos_kernel_type'' FAILED: ', inner1, inner2, relative_diff
  END IF
END PROGRAM main

! ================================================== !
! THIS FILE IS CREATED FROM THE JINJA TEMPLATE FILE  !
! DO NOT MODIFY DIRECTLY                             !
! ================================================== !




! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: J. Henrichs, Bureau of Meteorology
! Modified: I. Kavcic, Met Office

module psy_data_base_mod

    use, intrinsic :: iso_fortran_env, only : int64, int32,   &
                                              real32, real64, &
                                              stderr => Error_Unit
    implicit none

    !> Maximum string length for module- and region-names
    integer, parameter :: MAX_STRING_LENGTH = 512

    !> If this section is enabled or not. Controlled by the two
    !! static functions PSyDataStart and PSyDataStop. Note that
    !! none of the functions here use this value at all, it is up
    !! to the derived classes to implement the start/stop functionality.
    logical :: is_enabled = .true.

    !> This is a useful base class for PSyData wrapper libraries.
    !! It is not required to use this as a base, but it provides
    !! useful functionality.

    type, public:: PSyDataBaseType

        !> The index of the variables as they are being declared
        !! and as they are being provided. It is useful to provided
        !! a variable-dependent index.
        integer :: next_var_index

        !> Verbosity level for output at runtime. This is taken from the
        !! PSYDATA_VERBOSE environment variable.
        !! 0: Only errors will be written (PSYDATA_VERBOSE undefined)
        !! 1: Additionally write the name of the confirmed kernel_name
        !! 2: Also write the name of each tested variable
        integer :: verbosity

        !> Store the name of the module and region
        character(MAX_STRING_LENGTH) :: module_name, region_name

        contains

            procedure :: PreStart
            procedure :: PreEndDeclaration
            procedure :: PreEnd
            procedure :: PostStart
            procedure :: PostEnd
            procedure :: Abort

            procedure :: DeclareScalarInt
            procedure :: ProvideScalarInt
            procedure :: DeclareArray2dInt
            procedure :: ProvideArray2dInt
            procedure :: DeclareScalarReal
            procedure :: ProvideScalarReal
            procedure :: DeclareArray2dReal
            procedure :: ProvideArray2dReal
            procedure :: DeclareScalarDouble
            procedure :: ProvideScalarDouble
            procedure :: DeclareArray2dDouble
            procedure :: ProvideArray2dDouble

            !> Declare generic interface for PreDeclareVariable. The generic
            !! interface is only added if explicitly requested. This allows
            !! a derived class to provide its own implementation of a function
            !! to be part of this generic interface.
            generic, public :: PreDeclareVariable => &
                DeclareScalarInt, &
                DeclareArray2dInt, &
                DeclareScalarReal, &
                DeclareArray2dReal, &
                DeclareScalarDouble, &
                DeclareArray2dDouble


    end type PSyDataBaseType

contains

    ! -------------------------------------------------------------------------
    !> This subroutine is the first function called when an instrumented region
    !! is entered. It initialises this object, and stores module and regin
    !! names.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] module_name The name of the module of the instrumented
    !!            region.
    !! @param[in] region_name The name of the instrumented region.
    !! @param[in] num_pre_vars The number of variables that are declared and
    !!            written before the instrumented region (unused atm).
    !! @param[in] num_post_vars The number of variables that are also declared
    !!            before an instrumented region of code, but are written after
    !!            this region (unused atm).
    subroutine PreStart(this, module_name, region_name, num_pre_vars, &
                        num_post_vars)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: module_name, region_name
        integer, intent(in)      :: num_pre_vars, num_post_vars

        character(1) :: verbose
        integer      :: status

        call get_environment_variable("PSYDATA_VERBOSE", verbose, status=status)
        this%verbosity = 0
        if (status == 0) then
            if (verbose == "0") then
                this%verbosity = 0
            else if (verbose == "1") then
                this%verbosity = 1
            else if (verbose == "2") then
                this%verbosity = 2
            else
                write(stderr,*) "PSyData: invalid setting of PSYDATA_VERBOSE."
                write(stderr,*) "It must be '0', 1' or '2', but it is '", verbose,"'."
                this%verbosity = 0
            endif
        endif

        this%next_var_index = 1
        this%module_name = module_name
        this%region_name = region_name

        if (.not. is_enabled) return

        if (this%verbosity > 0) &
            write(stderr,*) "PSyData: PreStart ", module_name, " ", region_name

    end subroutine PreStart

    ! -------------------------------------------------------------------------
    !> This subroutine is called once all variables are declared. It makes
    !! sure that the next variable index is starting at 1 again.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    subroutine PreEndDeclaration(this)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this

        this%next_var_index = 1

    end subroutine PreEndDeclaration

    ! -------------------------------------------------------------------------
    !> This subroutine is called after the value of all variables has been
    !! provided (and declared). After this call the instrumented region will
    !! be executed. Nothing is done here.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    subroutine PreEnd(this)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this

    end subroutine PreEnd

    ! -------------------------------------------------------------------------
    !> This subroutine is called after the instrumented region has been
    !! executed. After this call the value of variables after the instrumented
    !! region will be provided. Nothing is done here.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    subroutine PostStart(this)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this

    end subroutine PostStart

    ! -------------------------------------------------------------------------
    !> This subroutine is called after the instrumented region has been
    !! executed and all values of variables after the instrumented
    !! region have been provided. No special functionality required here.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    subroutine PostEnd(this)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this

        if (.not. is_enabled) return

        if (this%verbosity > 0) &
            write(stderr, *) "PSyData: PostEnd ", trim(this%module_name), &
                    " ", trim(this%region_name)

    end subroutine PostEnd

    ! -------------------------------------------------------------------------
    !> Displays the message and aborts execution. This base implementation
    !! just uses `stop`.
    !! @param[in] message Error message to be displayed (string).
    subroutine Abort(this, message)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*) :: message

        write(stderr, *) "PSyData Error:", message
        stop "PSyData: Aborting"

    end subroutine Abort

    ! -------------------------------------------------------------------------
    !> An optional initialisation subroutine.
    subroutine nan_test_PSyDataInit()

      implicit none

      return

    end subroutine nan_test_PSyDataInit

    ! -------------------------------------------------------------------------
    !> An optional initialisation subroutine.
    subroutine nan_test_PSyDataShutdown()

      implicit none

      return

    end subroutine nan_test_PSyDataShutdown

    ! -------------------------------------------------------------------------
    !> Enables PSyData handling (if it is not already enabled).
    subroutine nan_test_PSyDataStart()

      implicit none

      is_enabled = .true.

    end subroutine nan_test_PSyDataStart

    ! -------------------------------------------------------------------------
    !> Disables PSyData handling.
    subroutine nan_test_PSyDataStop()

      implicit none

      is_enabled = .false.

    end subroutine nan_test_PSyDataStop

    ! =========================================================================
    ! Jinja created code:
    ! =========================================================================
    ! -------------------------------------------------------------------------
    !> This subroutine declares a scalar integer(kind=int32) value. This
    !! implementation only increases the next index, and prints
    !! the name of the variable if verbose output is requested.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareScalarInt(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), intent(in) :: value

        this%next_var_index = this%next_var_index+1

        if (.not. is_enabled) return

        if (this%verbosity > 1) &
            write(stderr,*) "PSyData: DeclareScalarInt: ", &
                            trim(this%module_name), " ", &
                            trim(this%region_name), ": ", name

    end subroutine DeclareScalarInt

    ! -------------------------------------------------------------------------
    !> This subroutine provides a scalar integer(kind=int32) value. This
    !! implementation only increases the next index.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarInt(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), intent(in) :: value

        this%next_var_index = this%next_var_index+1

    end subroutine ProvideScalarInt

    ! ---------------------------------------------------------------------
    !> This subroutine handles a declaration of a 2d-array of
    !! integer(kind=int32) values. This base implementation only increases
    !! next_var_index and prints the name of the variable if
    !! verbose output is requested.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareArray2dInt(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), dimension(:,:), intent(in) :: value
        this%next_var_index = this%next_var_index + 1

        if (.not. is_enabled) return

        if (this%verbosity > 1) &
            write(stderr,*) "PSyData: DeclareArray2dInt: ", &
                            trim(this%module_name), " ", &
                            trim(this%region_name), ": ", name

    end subroutine DeclareArray2dInt

    ! -------------------------------------------------------------------------
    !> This subroutine handles a provide call for a 2d integer(kind=int32) array.
    !! This base implementation only increases next_var_index.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dInt(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), dimension(:,:), intent(in) :: value

        this%next_var_index = this%next_var_index + 1

    end subroutine ProvideArray2dInt

    ! -------------------------------------------------------------------------
    !> This subroutine declares a scalar real(kind=real32) value. This
    !! implementation only increases the next index, and prints
    !! the name of the variable if verbose output is requested.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareScalarReal(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), intent(in) :: value

        this%next_var_index = this%next_var_index+1

        if (.not. is_enabled) return

        if (this%verbosity > 1) &
            write(stderr,*) "PSyData: DeclareScalarReal: ", &
                            trim(this%module_name), " ", &
                            trim(this%region_name), ": ", name

    end subroutine DeclareScalarReal

    ! -------------------------------------------------------------------------
    !> This subroutine provides a scalar real(kind=real32) value. This
    !! implementation only increases the next index.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarReal(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), intent(in) :: value

        this%next_var_index = this%next_var_index+1

    end subroutine ProvideScalarReal

    ! ---------------------------------------------------------------------
    !> This subroutine handles a declaration of a 2d-array of
    !! real(kind=real32) values. This base implementation only increases
    !! next_var_index and prints the name of the variable if
    !! verbose output is requested.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareArray2dReal(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), dimension(:,:), intent(in) :: value
        this%next_var_index = this%next_var_index + 1

        if (.not. is_enabled) return

        if (this%verbosity > 1) &
            write(stderr,*) "PSyData: DeclareArray2dReal: ", &
                            trim(this%module_name), " ", &
                            trim(this%region_name), ": ", name

    end subroutine DeclareArray2dReal

    ! -------------------------------------------------------------------------
    !> This subroutine handles a provide call for a 2d real(kind=real32) array.
    !! This base implementation only increases next_var_index.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dReal(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), dimension(:,:), intent(in) :: value

        this%next_var_index = this%next_var_index + 1

    end subroutine ProvideArray2dReal

    ! -------------------------------------------------------------------------
    !> This subroutine declares a scalar real(kind=real64) value. This
    !! implementation only increases the next index, and prints
    !! the name of the variable if verbose output is requested.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareScalarDouble(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), intent(in) :: value

        this%next_var_index = this%next_var_index+1

        if (.not. is_enabled) return

        if (this%verbosity > 1) &
            write(stderr,*) "PSyData: DeclareScalarDouble: ", &
                            trim(this%module_name), " ", &
                            trim(this%region_name), ": ", name

    end subroutine DeclareScalarDouble

    ! -------------------------------------------------------------------------
    !> This subroutine provides a scalar real(kind=real64) value. This
    !! implementation only increases the next index.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarDouble(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), intent(in) :: value

        this%next_var_index = this%next_var_index+1

    end subroutine ProvideScalarDouble

    ! ---------------------------------------------------------------------
    !> This subroutine handles a declaration of a 2d-array of
    !! real(kind=real64) values. This base implementation only increases
    !! next_var_index and prints the name of the variable if
    !! verbose output is requested.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareArray2dDouble(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), dimension(:,:), intent(in) :: value
        this%next_var_index = this%next_var_index + 1

        if (.not. is_enabled) return

        if (this%verbosity > 1) &
            write(stderr,*) "PSyData: DeclareArray2dDouble: ", &
                            trim(this%module_name), " ", &
                            trim(this%region_name), ": ", name

    end subroutine DeclareArray2dDouble

    ! -------------------------------------------------------------------------
    !> This subroutine handles a provide call for a 2d real(kind=real64) array.
    !! This base implementation only increases next_var_index.
    !! @param[in,out] this The instance of the PSyDataBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dDouble(this, name, value)

        implicit none

        class(PSyDataBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), dimension(:,:), intent(in) :: value

        this%next_var_index = this%next_var_index + 1

    end subroutine ProvideArray2dDouble


end module psy_data_base_mod

module tl_rhs_eos_kernel_mod_adj
  use argument_mod, only : any_discontinuous_space_3, any_space_9, arg_type, cell_column, func_type, gh_basis, gh_diff_basis, gh_field, gh_quadrature_xyoz, gh_read, gh_real, gh_scalar, gh_write
  use constants_mod, only : i_def, r_def
  use fs_continuity_mod, only : w3, wtheta
  use kernel_mod, only : kernel_type
  implicit none
  type, public, extends(kernel_type) :: tl_rhs_eos_kernel_type_adj
  PRIVATE
  TYPE(arg_type) :: meta_args(14) = (/arg_type(GH_FIELD, GH_REAL, GH_WRITE, W3), arg_type(GH_FIELD, GH_REAL, GH_READ, W3), arg_type(GH_FIELD, GH_REAL, GH_READ, W3), arg_type(GH_FIELD, GH_REAL, GH_READ, Wtheta), arg_type(GH_FIELD, GH_REAL, GH_READ, Wtheta), arg_type(GH_FIELD, GH_REAL, GH_READ, W3), arg_type(GH_FIELD, GH_REAL, GH_READ, W3), arg_type(GH_FIELD, GH_REAL, GH_READ, Wtheta), arg_type(GH_FIELD, GH_REAL, GH_READ, Wtheta), arg_type(GH_FIELD * 3, GH_REAL, GH_READ, ANY_SPACE_9), arg_type(GH_FIELD, GH_REAL, GH_READ, ANY_DISCONTINUOUS_SPACE_3), arg_type(GH_SCALAR, GH_REAL, GH_READ), arg_type(GH_SCALAR, GH_REAL, GH_READ), arg_type(GH_SCALAR, GH_REAL, GH_READ)/)
  TYPE(func_type) :: meta_funcs(3) = (/func_type(W3, GH_BASIS), func_type(Wtheta, GH_BASIS), func_type(ANY_SPACE_9, GH_BASIS, GH_DIFF_BASIS)/)
  INTEGER :: operates_on = CELL_COLUMN
  INTEGER :: gh_shape = GH_QUADRATURE_XYoZ
  CONTAINS
  PROCEDURE, NOPASS :: tl_rhs_eos_code_adj
END TYPE
  private

  public :: tl_rhs_eos_code_adj

  contains
  subroutine tl_rhs_eos_code_adj(nlayers, rhs_eos, exner, rho, theta, moist_dyn_gas, ls_exner, ls_rho, ls_theta, ls_moist_dyn_gas, chi1, chi2, chi3, panel_id, kappa, rd, p_zero, ndf_w3, undf_w3, map_w3, w3_basis, ndf_wt, undf_wt, map_wt, wt_basis, ndf_chi, undf_chi, map_chi, chi_basis, chi_diff_basis, ndf_pid, undf_pid, map_pid, nqp_h, nqp_v, wqp_h, wqp_v)
    use coordinate_jacobian_mod, only : coordinate_jacobian
    integer(kind=i_def), intent(in) :: nlayers
    integer(kind=i_def), intent(in) :: nqp_h
    integer(kind=i_def), intent(in) :: nqp_v
    integer(kind=i_def), intent(in) :: ndf_wt
    integer(kind=i_def), intent(in) :: ndf_w3
    integer(kind=i_def), intent(in) :: ndf_chi
    integer(kind=i_def), intent(in) :: ndf_pid
    integer(kind=i_def), intent(in) :: undf_wt
    integer(kind=i_def), intent(in) :: undf_w3
    integer(kind=i_def), intent(in) :: undf_chi
    integer(kind=i_def), intent(in) :: undf_pid
    integer(kind=i_def), dimension(ndf_w3), intent(in) :: map_w3
    integer(kind=i_def), dimension(ndf_wt), intent(in) :: map_wt
    integer(kind=i_def), dimension(ndf_chi), intent(in) :: map_chi
    integer(kind=i_def), dimension(ndf_pid), intent(in) :: map_pid
    real(kind=r_def), dimension(1,ndf_w3,nqp_h,nqp_v), intent(in) :: w3_basis
    real(kind=r_def), dimension(1,ndf_wt,nqp_h,nqp_v), intent(in) :: wt_basis
    real(kind=r_def), dimension(1,ndf_chi,nqp_h,nqp_v), intent(in) :: chi_basis
    real(kind=r_def), dimension(3,ndf_chi,nqp_h,nqp_v), intent(in) :: chi_diff_basis
    real(kind=r_def), dimension(undf_w3), intent(inout) :: rhs_eos
    real(kind=r_def), dimension(undf_wt), intent(inout) :: theta
    real(kind=r_def), dimension(undf_wt), intent(inout) :: moist_dyn_gas
    real(kind=r_def), dimension(undf_w3), intent(inout) :: rho
    real(kind=r_def), dimension(undf_w3), intent(inout) :: exner
    real(kind=r_def), dimension(undf_wt), intent(in) :: ls_theta
    real(kind=r_def), dimension(undf_wt), intent(in) :: ls_moist_dyn_gas
    real(kind=r_def), dimension(undf_w3), intent(in) :: ls_rho
    real(kind=r_def), dimension(undf_w3), intent(in) :: ls_exner
    real(kind=r_def), dimension(undf_chi), intent(in) :: chi1
    real(kind=r_def), dimension(undf_chi), intent(in) :: chi2
    real(kind=r_def), dimension(undf_chi), intent(in) :: chi3
    real(kind=r_def), dimension(undf_pid), intent(in) :: panel_id
    real(kind=r_def), dimension(nqp_h), intent(in) :: wqp_h
    real(kind=r_def), dimension(nqp_v), intent(in) :: wqp_v
    real(kind=r_def), intent(in) :: kappa
    real(kind=r_def), intent(in) :: rd
    real(kind=r_def), intent(in) :: p_zero
    integer(kind=i_def) :: df
    integer(kind=i_def) :: k
    integer(kind=i_def) :: qp1
    integer(kind=i_def) :: qp2
    real(kind=r_def), dimension(ndf_wt) :: theta_vd_e
    real(kind=r_def), dimension(ndf_wt) :: ls_theta_vd_e
    real(kind=r_def), dimension(ndf_chi) :: chi1_e
    real(kind=r_def), dimension(ndf_chi) :: chi2_e
    real(kind=r_def), dimension(ndf_chi) :: chi3_e
    real(kind=r_def), dimension(ndf_w3) :: rho_e
    real(kind=r_def), dimension(ndf_w3) :: exner_e
    real(kind=r_def) :: rho_quad
    real(kind=r_def) :: theta_vd_quad
    real(kind=r_def) :: exner_quad
    real(kind=r_def), dimension(ndf_w3) :: ls_rho_e
    real(kind=r_def), dimension(ndf_w3) :: ls_exner_e
    real(kind=r_def) :: ls_rho_quad
    real(kind=r_def) :: ls_theta_vd_quad
    real(kind=r_def) :: ls_exner_quad
    real(kind=r_def) :: eos
    real(kind=r_def) :: p0_over_rd
    real(kind=r_def) :: onemk_over_k
    real(kind=r_def) :: ls_eos
    real(kind=r_def), dimension(nqp_h,nqp_v) :: dj
    real(kind=r_def), dimension(3,3,nqp_h,nqp_v) :: jac
    integer(kind=i_def) :: ipanel

    rho_e = 0.0_r_def
    rho_quad = 0.0_r_def
    eos = 0.0_r_def
    theta_vd_quad = 0.0_r_def
    exner_quad = 0.0_r_def
    exner_e = 0.0_r_def
    theta_vd_e = 0.0_r_def
    ipanel = INT(panel_id(map_pid(1)), i_def)
    p0_over_rd = p_zero / rd
    onemk_over_k = -1 + 1.0 / kappa
    do k = nlayers - 1, 0, -1
      do df = 1, ndf_chi, 1
        chi1_e(df) = chi1(map_chi(df) + k)
        chi2_e(df) = chi2(map_chi(df) + k)
        chi3_e(df) = chi3(map_chi(df) + k)
      enddo
      call coordinate_jacobian(ndf_chi, nqp_h, nqp_v, chi1_e, chi2_e, chi3_e, ipanel, chi_basis, chi_diff_basis, jac, dj)
      do df = 1, ndf_wt, 1
        ls_theta_vd_e(df) = ls_theta(map_wt(df) + k) * ls_moist_dyn_gas(map_wt(df) + k)
      enddo
      do df = 1, ndf_w3, 1
        ls_exner_e(df) = ls_exner(map_w3(df) + k)
        ls_rho_e(df) = ls_rho(map_w3(df) + k)
      enddo
      do qp2 = nqp_v, 1, -1
        do qp1 = nqp_h, 1, -1
          ls_theta_vd_quad = 0.0_r_def
          do df = 1, ndf_wt, 1
            ls_theta_vd_quad = ls_theta_vd_quad + ls_theta_vd_e(df) * wt_basis(1,df,qp1,qp2)
          enddo
          ls_exner_quad = 0.0_r_def
          ls_rho_quad = 0.0_r_def
          do df = 1, ndf_w3, 1
            ls_exner_quad = ls_exner_quad + ls_exner_e(df) * w3_basis(1,df,qp1,qp2)
            ls_rho_quad = ls_rho_quad + ls_rho_e(df) * w3_basis(1,df,qp1,qp2)
          enddo
          ls_eos = 0.0_r_def - p0_over_rd * ls_exner_quad ** onemk_over_k / (ls_rho_quad * ls_theta_vd_quad)
          do df = ndf_w3, 1, -1
            eos = eos - w3_basis(1,df,qp1,qp2) * rhs_eos(map_w3(df) + k)
          enddo
          eos = wqp_h(qp1) * wqp_v(qp2) * dj(qp1,qp2) * eos
          exner_quad = exner_quad + eos * ls_eos * onemk_over_k / ls_exner_quad
          theta_vd_quad = theta_vd_quad - ls_eos * eos / ls_theta_vd_quad
          rho_quad = rho_quad - ls_eos * eos / ls_rho_quad
          eos = 0.0
          do df = ndf_w3, 1, -1
            rho_e(df) = rho_e(df) + rho_quad * w3_basis(1,df,qp1,qp2)
            exner_e(df) = exner_e(df) + exner_quad * w3_basis(1,df,qp1,qp2)
          enddo
          rho_quad = 0.0
          exner_quad = 0.0
          do df = ndf_wt, 1, -1
            theta_vd_e(df) = theta_vd_e(df) + theta_vd_quad * wt_basis(1,df,qp1,qp2)
          enddo
          theta_vd_quad = 0.0
        enddo
      enddo
      do df = ndf_w3, 1, -1
        rhs_eos(map_w3(df) + k) = 0.0
        rho(map_w3(df) + k) = rho(map_w3(df) + k) + rho_e(df)
        rho_e(df) = 0.0
        exner(map_w3(df) + k) = exner(map_w3(df) + k) + exner_e(df)
        exner_e(df) = 0.0
      enddo
      do df = ndf_wt, 1, -1
        moist_dyn_gas(map_wt(df) + k) = moist_dyn_gas(map_wt(df) + k) + ls_theta(map_wt(df) + k) * theta_vd_e(df)
        theta(map_wt(df) + k) = theta(map_wt(df) + k) + theta_vd_e(df) * ls_moist_dyn_gas(map_wt(df) + k)
        theta_vd_e(df) = 0.0
      enddo
    enddo

  end subroutine tl_rhs_eos_code_adj

end module tl_rhs_eos_kernel_mod_adj

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2022, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office
!
!> @brief Kernel which calculates the product of two columnwise operators,
!!        op_C = op_C + op_A * op_B.
module columnwise_op_mul_kernel_mod

use kernel_mod,              only : kernel_type
use argument_mod,            only : arg_type,                               &
                                    GH_COLUMNWISE_OPERATOR, GH_REAL,        &
                                    GH_READ, GH_READWRITE,                  &
                                    ANY_SPACE_1, ANY_SPACE_2, ANY_SPACE_3,  &
                                    CELL_COLUMN

use constants_mod,           only : r_solver, i_def

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------

type, public, extends(kernel_type) :: columnwise_op_mul_kernel_type
   private
  type(arg_type) :: meta_args(3) = (/                                                     &
       arg_type(GH_COLUMNWISE_OPERATOR, GH_REAL, GH_READ,      ANY_SPACE_1, ANY_SPACE_2), &
       arg_type(GH_COLUMNWISE_OPERATOR, GH_REAL, GH_READ,      ANY_SPACE_2, ANY_SPACE_3), &
       arg_type(GH_COLUMNWISE_OPERATOR, GH_REAL, GH_READWRITE, ANY_SPACE_1, ANY_SPACE_3)  &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: columnwise_op_mul_kernel_code
end type columnwise_op_mul_kernel_type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public columnwise_op_mul_kernel_code

contains

  !> @brief The subroutine which is called directly from the PSy layer and
  !!        calculates op_C = op_C + op_A * op_B.
  !>
  !> @param [in] cell Horizontal cell index
  !> @param [in] ncell_2d Total number of cells in 2D grid
  !> @param [in] columnwise_matrix_A Banded matrix op_A
  !> @param [in] nrow_A Number of rows in the banded matrix A
  !> @param [in] ncol_A Number of columns in the banded matrix A
  !> @param [in] bandwidth_A Bandwidth of the banded matrix
  !> @param [in] alpha_A Banded matrix parameter \f$\alpha\f$
  !> @param [in] beta_A Banded matrix parameter \f$\beta\f$
  !> @param [in] gamma_m_A Banded matrix parameter \f$\gamma_-\f$
  !> @param [in] gamma_p_A Banded matrix parameter \f$\gamma_+\f$
  !> @param [in] columnwise_matrix_B Banded matrix op_B
  !> @param [in] nrow_B Number of rows in the banded matrix B
  !> @param [in] ncol_B Number of columns in the banded matrix B
  !> @param [in] bandwidth_B Bandwidth of the banded matrix
  !> @param [in] alpha_B Banded matrix parameter \f$\alpha\f$
  !> @param [in] beta_B Banded matrix parameter \f$\beta\f$
  !> @param [in] gamma_m_B Banded matrix parameter \f$\gamma_-\f$
  !> @param [in] gamma_p_B Banded matrix parameter \f$\gamma_+\f$
  !> @param [in,out] columnwise_matrix_C Banded matrix op_C
  !> @param [in] nrow_C Number of rows in the banded matrix C
  !> @param [in] ncol_C Number of columns in the banded matrix C
  !> @param [in] bandwidth_C Bandwidth of the banded matrix
  !> @param [in] alpha_C Banded matrix parameter \f$\alpha\f$
  !> @param [in] beta_C Banded matrix parameter \f$\beta\f$
  !> @param [in] gamma_m_C Banded matrix parameter \f$\gamma_-\f$
  !> @param [in] gamma_p_C Banded matrix parameter \f$\gamma_+\f$
  subroutine columnwise_op_mul_kernel_code(cell,                      &
                                           ncell_2d,                  &
                                           columnwise_matrix_A,       &
                                           nrow_A, ncol_A,            &
                                           bandwidth_A,               &
                                           alpha_A,                   &
                                           beta_A,                    &
                                           gamma_m_A,                 &
                                           gamma_p_A,                 &
                                           columnwise_matrix_B,       &
                                           nrow_B, ncol_B,            &
                                           bandwidth_B,               &
                                           alpha_B,                   &
                                           beta_B,                    &
                                           gamma_m_B,                 &
                                           gamma_p_B,                 &
                                           columnwise_matrix_C,       &
                                           nrow_C, ncol_C,            &
                                           bandwidth_C,               &
                                           alpha_C,                   &
                                           beta_C,                    &
                                           gamma_m_C,                 &
                                           gamma_p_C)

    implicit none

    ! Arguments
    integer(kind=i_def), intent(in) :: cell,  ncell_2d
    integer(kind=i_def), intent(in) :: nrow_A, ncol_A
    integer(kind=i_def), intent(in) :: nrow_B, ncol_B
    integer(kind=i_def), intent(in) :: nrow_C, ncol_C
    integer(kind=i_def), intent(in) :: bandwidth_A, bandwidth_B, bandwidth_C
    real(kind=r_solver), dimension(bandwidth_A,nrow_A,ncell_2d), intent(in) :: columnwise_matrix_A
    real(kind=r_solver), dimension(bandwidth_B,nrow_B,ncell_2d), intent(in) :: columnwise_matrix_B
    real(kind=r_solver), dimension(bandwidth_C,nrow_C,ncell_2d), intent(inout) :: columnwise_matrix_C

    integer(kind=i_def), intent(in) :: alpha_A, beta_A, gamma_m_A, gamma_p_A
    integer(kind=i_def), intent(in) :: alpha_B, beta_B, gamma_m_B, gamma_p_B
    integer(kind=i_def), intent(in) :: alpha_C, beta_C, gamma_m_C, gamma_p_C

    ! Internal parameters
    integer(kind=i_def) :: i, j, ell ! Row and column index index
    ! Smallest index in a particular row
    integer(kind=i_def) :: j_minus_A, j_minus_B, j_minus_C
    integer(kind=i_def) :: j_plus_A, j_plus_B, j_plus_C
    real(kind=r_solver) :: matrixentry

    do i = 1, nrow_C
       j_minus_A = ceiling((alpha_A*i-gamma_p_A)/(1.0_r_solver*beta_A), i_def)
       j_plus_A = floor((alpha_A*i+gamma_m_A)/(1.0_r_solver*beta_A), i_def)
       j_minus_C = ceiling((alpha_C*i-gamma_p_C)/(1.0_r_solver*beta_C), i_def)
       j_plus_C = floor((alpha_C*i+gamma_m_C)/(1.0_r_solver*beta_C), i_def)
       do j = MAX(1,j_minus_C), MIN(ncol_C,j_plus_C)
          matrixentry = 0.0_r_solver
          do ell = MAX(1,j_minus_A), MIN(ncol_A,j_plus_A)
             j_minus_B = ceiling((alpha_B*ell-gamma_p_B)/(1.0_r_solver*beta_B), i_def)
             j_plus_B = floor((alpha_B*ell+gamma_m_B)/(1.0_r_solver*beta_B), i_def)
             if ( (j_minus_B <= j) .and. (j <= j_plus_B) ) then
                matrixentry = matrixentry                                 &
                            + columnwise_matrix_A(ell-j_minus_A+1,i,cell) &
                            * columnwise_matrix_B(j-j_minus_B+1,ell,cell)
             end if
         end do
         columnwise_matrix_C(j-j_minus_C+1,i,cell) &
           = columnwise_matrix_C(j-j_minus_C+1,i,cell) + matrixentry
       end do
    end do

  end subroutine columnwise_op_mul_kernel_code

end module columnwise_op_mul_kernel_mod

  MODULE main
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE main_code()
      USE init_field_mod, ONLY: init_field_code
      USE extract_psy_data_mod, ONLY: extract_PSyDataType
      IMPLICIT NONE
      INTEGER j
      INTEGER i
      REAL(KIND=8), allocatable, dimension(:,:) :: j_post
      REAL(KIND=8), allocatable, dimension(:,:) :: j
      REAL(KIND=8), allocatable, dimension(:,:) :: i_post
      REAL(KIND=8), allocatable, dimension(:,:) :: i
      REAL(KIND=8), allocatable, dimension(:,:) :: d_fld_post
      REAL(KIND=8), allocatable, dimension(:,:) :: d_fld
      REAL(KIND=8), allocatable, dimension(:,:) :: c_fld_post
      REAL(KIND=8), allocatable, dimension(:,:) :: c_fld
      REAL(KIND=8), allocatable, dimension(:,:) :: b_fld_post
      REAL(KIND=8), allocatable, dimension(:,:) :: b_fld
      REAL(KIND=8), allocatable, dimension(:,:) :: a_fld_post
      REAL(KIND=8), allocatable, dimension(:,:) :: a_fld
      TYPE(extract_PSyDataType) extract_psy_data
      CALL extract_psy_data%OpenRead("main", "init")
      CALL extract_psy_data%ReadVariable("a_fld_post", a_fld_post)
      ALLOCATE (a_fld, mold=a_fld_post)
      a_fld = 0.0d0
      CALL extract_psy_data%ReadVariable("b_fld_post", b_fld_post)
      ALLOCATE (b_fld, mold=b_fld_post)
      b_fld = 0.0d0
      CALL extract_psy_data%ReadVariable("c_fld_post", c_fld_post)
      ALLOCATE (c_fld, mold=c_fld_post)
      c_fld = 0.0d0
      CALL extract_psy_data%ReadVariable("d_fld_post", d_fld_post)
      ALLOCATE (d_fld, mold=d_fld_post)
      d_fld = 0.0d0
      CALL extract_psy_data%ReadVariable("i_post", i_post)
      ALLOCATE (i, mold=i_post)
      i = 0.0d0
      CALL extract_psy_data%ReadVariable("j_post", j_post)
      ALLOCATE (j, mold=j_post)
      j = 0.0d0
      !
      ! RegionStart
      DO j=ystart,ystop
        DO i=xstart,xstop
          CALL init_field_code(i, j, a_fld, 1.0)
        END DO
      END DO
      DO j=ystart,ystop
        DO i=xstart,xstop
          CALL init_field_code(i, j, b_fld, 2.0)
        END DO
      END DO
      DO j=ystart,ystop
        DO i=xstart,xstop
          CALL init_field_code(i, j, c_fld, 3.0)
        END DO
      END DO
      DO j=ystart,ystop
        DO i=xstart,xstop
          CALL init_field_code(i, j, d_fld, 4.0)
        END DO
      END DO
      ! RegionEnd
      !
      ! Check a_fld
      ! Check b_fld
      ! Check c_fld
      ! Check d_fld
      ! Check i
      ! Check j
    END SUBROUTINE main_code
  END MODULE main

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office

!> This module implements a PSyData-based verification that floating point
!! input and output parameters are not NAN and not infinite for the
!! dl_esm_inf library. It is based on the NANTestBaseType (from which it
!! inherits the handling of the basic Fortran data types and 2d-arrays,
!! as specified in the Makefile). It adds the support for the
!! dl_esm_inf-specific field type.

module nan_test_psy_data_mod

    use, intrinsic :: iso_fortran_env, only : int64, int32,   &
                                              real32, real64, &
                                              stderr => Error_Unit

    use nan_test_base_mod, only : NANTestBaseType, nan_test_PSyDataInit, &
                 nan_test_PSyDataShutdown, is_enabled, &
                 nan_test_PSyDataStart, nan_test_PSyDataStop

    implicit none

    type, extends(NANTestBaseType), public:: nan_test_PSyDataType

    contains

        ! The various procedures used from this class
        procedure :: DeclareField
        procedure :: ProvideField

        !> The generic interface for declaring a variable. The 'Declare'
        !! functions are actually not used at all, but they must be provided
        !! as empty functions (the base class creates other functions, e.g.
        !! DeclareArray2dInt, but since they are not used by
        !! GOcean, there is no need to add them here).
        generic, public :: PreDeclareVariable => DeclareField

        !> The generic interface for providing the value of variables,
        !! which in this case verifies that all floating point values
        !! are not NAN and not infinite.
        generic, public :: ProvideVariable => ProvideField

    end type nan_test_PSyDataType

contains

    ! -------------------------------------------------------------------------
    !> This subroutine declares a field as defined in
    !! dl_esm_inf (r2d_field). It does nothing in the NAN checking library.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareField(this, name, value)

        use field_mod, only : r2d_field

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(r2d_field), intent(in) :: value

    end subroutine DeclareField

    ! -------------------------------------------------------------------------
    !> This subroutine checks that a dl_esm_inf field does not contain
    !! a NAN or infinite floating point value.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideField(this, name, value)

        use field_mod, only : r2d_field
        use nan_test_base_mod, only : NANTestBaseType

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(r2d_field), intent(in) :: value

        call this%ProvideArray2dDouble(name, value%data)

    end subroutine ProvideField

end module nan_test_psy_data_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2018-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office
!
!> @brief Kernel which computes the advective update u.grad(t) through fitting a
!>        high order upwind 1D reconstruction
!> @details Compute the advective update for a tracer field using a high order
!>          polynomial fit to the tracer values. The stencil used for the
!>          polynomial is centred, with an upwind bias if an even number of
!>          points are used, therefore for an upwind shceme an odd ordered
!>          polynomial should be used. In the vertical the order is reduced
!>          near the boundaries depending on the number of points available.
!>          This method is only valid for lowest order elements
module sample_poly_adv_kernel_mod

use argument_mod,          only: arg_type, func_type,         &
                                 GH_FIELD, GH_REAL,           &
                                 GH_WRITE, GH_READ,           &
                                 ANY_SPACE_1, STENCIL, CROSS, &
                                 GH_BASIS, GH_DIFF_BASIS,     &
                                 CELL_COLUMN, GH_EVALUATOR
use fs_continuity_mod,     only: W2, Wtheta
use constants_mod,         only: r_def, i_def
use kernel_mod,            only: kernel_type
use reference_element_mod, only: W, E, N, S
use transport_config_mod,  only: consistent_metric

use transport_config_mod,  only: enforce_monotonicity
use timestepping_config_mod,  only: dt

implicit none

private

! Precomputed operators, these are the same for all model columns
real(kind=r_def), allocatable,    private :: coeff_matrix(:,:)
integer(kind=i_def), allocatable, private :: dof_stencil(:,:)
integer(kind=i_def), allocatable, private :: np_v(:,:)
integer(kind=i_def),              private :: np
real(kind=r_def),                 private :: x0
real(kind=r_def), allocatable,    private :: dx0(:)
real(kind=r_def), allocatable,    private :: coeff_matrix_v(:,:,:)

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------
!> The type declaration for the kernel. Contains the metadata needed by the Psy layer
type, public, extends(kernel_type) :: sample_poly_adv_kernel_type
  private
  type(arg_type) :: meta_args(6) = (/                                      &
       arg_type(GH_FIELD, GH_REAL, GH_WRITE, Wtheta),                      &
       arg_type(GH_FIELD, GH_REAL, GH_READ,  Wtheta, STENCIL(CROSS)),      &
       arg_type(GH_FIELD, GH_REAL, GH_READ,  W2),                          &
       arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1, STENCIL(CROSS)), &
       arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1),                 &
       arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1)                  &
       /)
  type(func_type) :: meta_funcs(2) = (/                                    &
       func_type(W2,          GH_BASIS),                                   &
       func_type(ANY_SPACE_1, GH_BASIS, GH_DIFF_BASIS)                     &
       /)
  integer :: operates_on = CELL_COLUMN
  integer :: gh_shape = GH_EVALUATOR
contains
  procedure, nopass :: sample_poly_adv_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public sample_poly_adv_code
public sample_poly_adv_init

contains

!> @brief Computes the advective update
!! @param[in]  nlayers Number of layers
!! @param[out] advection Advective update to compute
!! @param[in]  tracer Tracer field
!! @param[in]  stencil_size Size of the stencil (number of cells)
!! @param[in]  stencil_map Dofmaps for the stencil
!! @param[in]  wind Wind field
!! @param[in]  mt_lumped_inv Lumped inverse mass matrix for wtheta
!! @param[in]  chi1 The physical x coordinate in chi
!! @param[in]  stencil_size_wx Size of the stencil (number of cells) for chi
!! @param[in]  stencil_map_wx Dofmaps for the stencil for chi
!! @param[in]  chi2 The physical y coordinate in chi
!! @param[in]  chi3 The physical z coordinate in chi
!! @param[in]  ndf_wt Number of degrees of freedom per cell
!! @param[in]  undf_wt Number of unique degrees of freedom for the tracer field
!! @param[in]  ndf_w2 Number of degrees of freedom per cell
!! @param[in]  undf_w2 Number of unique degrees of freedom for the wind field
!! @param[in]  map_w2 Dofmap for the cell at the base of the column
!! @param[in]  basis_w2 Basis function array evaluated at w2 nodes
!! @param[in]  ndf_wx Number of degrees of freedom per cell
!! @param[in]  undf_wx Number of unique degrees of freedom for chi
!! @param[in]  map_wx Dofmap for the cell at the base of the column
!! @param[in]  basis_wx Basis function array evaluated at chi nodes
!! @param[in]  diff_basis_wx Differential basis function array evaluated at chi nodes
subroutine sample_poly_adv_code( nlayers,              &
                                 advection,            &
                                 tracer,               &
                                 stencil_size,         &
                                 stencil_map,          &
                                 wind,                 &
                                 mt_lumped_inv,        &
                                 chi1,                 &
                                 stencil_size_wx,      &
                                 stencil_map_wx,       &
                                 chi2, chi3,           &
                                 ndf_wt,               &
                                 undf_wt,              &
                                 map_wt,               &
                                 ndf_w2,               &
                                 undf_w2,              &
                                 map_w2,               &
                                 basis_w2,             &
                                 ndf_wx,               &
                                 undf_wx,              &
                                 map_wx,               &
                                 basis_wx,             &
                                 diff_basis_wx         &
                                 )

  implicit none

  ! Arguments
  integer(kind=i_def), intent(in)                    :: nlayers
  integer(kind=i_def), intent(in)                    :: ndf_wt
  integer(kind=i_def), intent(in)                    :: undf_wt
  integer(kind=i_def), dimension(ndf_wt), intent(in) :: map_wt
  integer(kind=i_def), intent(in)                    :: ndf_w2
  integer(kind=i_def), intent(in)                    :: undf_w2
  integer(kind=i_def), dimension(ndf_w2), intent(in) :: map_w2
  integer(kind=i_def), intent(in)                    :: ndf_wx
  integer(kind=i_def), intent(in)                    :: undf_wx
  integer(kind=i_def), dimension(ndf_wx), intent(in) :: map_wx

  real(kind=r_def), dimension(undf_wt), intent(inout) :: advection
  real(kind=r_def), dimension(undf_w2), intent(in)    :: wind
  real(kind=r_def), dimension(undf_wt), intent(in)    :: tracer
  real(kind=r_def), dimension(undf_wx), intent(in)    :: chi1, chi2, chi3
  real(kind=r_def), dimension(undf_wt), intent(in)    :: mt_lumped_inv

  real(kind=r_def), dimension(3,ndf_w2,ndf_wt), intent(in) :: basis_w2
  real(kind=r_def), dimension(1,ndf_wx,ndf_wt), intent(in) :: basis_wx
  real(kind=r_def), dimension(3,ndf_wx,ndf_wt), intent(in) :: diff_basis_wx

  integer(kind=i_def),                                 intent(in) :: stencil_size
  integer(kind=i_def), dimension(ndf_wt,stencil_size), intent(in) :: stencil_map
  integer(kind=i_def),                                 intent(in) :: stencil_size_wx
  integer(kind=i_def), dimension(ndf_wx,stencil_size_wx), intent(in) :: stencil_map_wx

  ! Internal variables
  integer(kind=i_def) :: k, df, dft, p, dir, id, idx, km1, kp1
  real(kind=r_def)    :: u(3,nlayers+1)
  real(kind=r_def)    :: polynomial_tracer, advection_update, z0
  real(kind=r_def), allocatable :: x(:,:,:)
  real(kind=r_def)    :: etadot, dzdx_l, dzdx_c, dzdy_l, dzdy_c, dx, dy, dz
  real(kind=r_def)    :: tracer_min, tracer_max
  real(kind=r_def)    :: coeff(np), tracer_stencil(np)

  ! Compute wind at tracer points
  u(:,:) = 0.0_r_def
  do k = 0, nlayers - 1
    do df = 1,ndf_w2
      do dft = 1,ndf_wt
        u(:,k + dft) = u(:,k + dft) + wind(map_w2(df) + k)*basis_w2(:,df,dft)
      end do
    end do
  end do
  ! Average velocities across cell boundaries due to double counting
  ! the winds at the surface and lid are also reduced to mimic
  ! the weighting in the fem mass matrix
  ! which for the surface term is int(1-z,z=0..1) = 1/2
  ! whilst for interior terms it is  int(1-z,z=0..1) + int(z,z=0..1) = 1
  do k = 1,nlayers+1
    u(:,k) = u(:,k)*0.5_r_def
  end do

  ! Compute coordinates at all tracer points in stencil
  if ( consistent_metric ) then
    allocate( x(3,nlayers+1,stencil_size) )
    x(:,:,:) = 0.0_r_def
    do p = 1,stencil_size
      do df = 1,ndf_wx
        do dft = 1,ndf_wt
          do k = 0, nlayers - 1
            x(1,k + dft,p) = x(1,k + dft,p) + chi1(stencil_map_wx(df,p) + k)*basis_wx(1,df,dft)
            x(2,k + dft,p) = x(2,k + dft,p) + chi2(stencil_map_wx(df,p) + k)*basis_wx(1,df,dft)
            x(3,k + dft,p) = x(3,k + dft,p) + chi3(stencil_map_wx(df,p) + k)*basis_wx(1,df,dft)
          end do
        end do
      end do
      ! Average coordinates across cell boundaries due to double counting from
      ! the vertical continuity of Wtheta
      do k = 2,nlayers
        x(:,k,p) = 0.5_r_def*x(:,k,p)
      end do
    end do
  end if

  ! Tracer data is stored contiguously and so can just use dft = 1
  ! and increment by 1 to get each subsequent level up to dft + nlayers
  ! for the model lid
  do k = 0, nlayers
    dft = 1
    ! Compute x stencil
    ! stencil_dir is East if u < 0 otherwise it is West
    if (  u(1,k+dft) >= 0.0_r_def ) then
      dir = W
    else
      dir = E
    end if
    do p = 1,np
      tracer_stencil(p) = tracer( stencil_map(dft,dof_stencil(p,dir)) + k )
    end do
    coeff(:) = matmul(coeff_matrix,tracer_stencil)
    polynomial_tracer = 0.0_r_def
    do p = 1,np-1
      polynomial_tracer = polynomial_tracer + coeff(p+1)*dx0(p)
    end do
    ! Polynomial tracer contains the directional derivative
    ! ( dP/dx for u > 0, -dP/dx for u < 0) so need to cancel
    ! out sign of wind - hence presense of abs(u)
    advection_update = abs(u(1,k+dft))*polynomial_tracer

    ! Compute metric term using advection scheme
    if ( consistent_metric ) then
      do p = 1,np
        tracer_stencil(p) = x(3,k+dft,dof_stencil(p,dir))
      end do
      coeff(:) = matmul(coeff_matrix,tracer_stencil)
      dzdx_c = 0.0_r_def
      do p = 1,np-1
        dzdx_c = dzdx_c + coeff(p+1)*dx0(p)
      end do
    end if
    ! Compute y stencil
    ! stencil_dir is north if v < 0 otherwise it is south
    if (  u(2,k+dft) >= 0.0_r_def ) then
      dir = S
    else
      dir = N
    end if
    do p = 1,np
      tracer_stencil(p) = tracer( stencil_map(dft,dof_stencil(p,dir)) + k )
    end do
    coeff(:) = matmul(coeff_matrix,tracer_stencil)
    polynomial_tracer = 0.0_r_def
    do p = 1,np-1
      polynomial_tracer = polynomial_tracer + coeff(p+1)*dx0(p)
    end do
    ! Polynomial tracer contains the directional derivative
    ! ( dP/dy for v > 0, -dP/dy for v < 0) so need to cancel
    ! out sign of wind - hence presense of abs(v)
    advection_update = advection_update + abs(u(2,k+dft))*polynomial_tracer

    ! Compute metric term using advection scheme
    if ( consistent_metric ) then
      do p = 1,np
        tracer_stencil(p) = x(3,k+dft,dof_stencil(p,dir))
      end do
      coeff(:) = matmul(coeff_matrix,tracer_stencil)
      dzdy_c = 0.0_r_def
      do p = 1,np-1
        dzdy_c = dzdy_c + coeff(p+1)*dx0(p)
      end do

      ! Modify vertical velocity to take account of inconsistent metric terms
      ! w => w + u*(dzdx_l - dzdx_c) + v*(dzdy_l - dzdy_c)
      ! with _l indicating centred linear approximation
      ! and _c indicating upwind cubic (or whatever form the horizontal advection
      ! uses)
      dzdx_l = 0.0_r_def
      dzdy_l = 0.0_r_def
      dx = 0.0_r_def
      dy = 0.0_r_def
      dz = 0.0_r_def
      do df = 1,ndf_wx
        dx = dx + chi1(stencil_map_wx(df,1)+k)*diff_basis_wx(1,df,dft)
        dy = dy + chi2(stencil_map_wx(df,1)+k)*diff_basis_wx(2,df,dft)
        dz = dz + chi3(stencil_map_wx(df,1)+k)*diff_basis_wx(3,df,dft)
        dzdx_l = dzdx_l + chi3(stencil_map_wx(df,1)+k)*diff_basis_wx(1,df,dft)
        dzdy_l = dzdy_l + chi3(stencil_map_wx(df,1)+k)*diff_basis_wx(2,df,dft)
      end do
      dzdx_l = dzdx_l / dx
      dzdy_l = dzdy_l / dy
      dzdx_c = dzdx_c / dx
      dzdy_c = dzdy_c / dy

      etadot = u(3,k+dft) + u(1,k+dft)*dx/dz*(dzdx_l-dzdx_c) + u(2,k+dft)*dy/dz*(dzdy_l-dzdy_c)
      if ( k == 0 .or. k == nlayers ) etadot = 0.0_r_def
    else
      etadot = u(3,k+dft)
    end if
    ! Compute z stencil, dir < 0 if w > 0
    if (  etadot >= 0.0_r_def ) then
      dir = -1
      idx = 1
    else
      dir = 1
      idx = 2
    end if
    do p = 1,np_v(k,idx)
      id = stencil_map(dft,1) + k + dir*(np_v(k,idx)/2 - (p-1))
      tracer_stencil(p) = tracer( id )
    end do

    ! Use appropriate inverse matrix for the order of this point
    coeff(1:np_v(k,idx)) = matmul(coeff_matrix_v(1:np_v(k,idx),1:np_v(k,idx),np_v(k,idx)), &
                                  tracer_stencil(1:np_v(k,idx)))
    z0 = real(np_v(k,idx)/2,r_def)
    polynomial_tracer = 0.0_r_def
    do p = 1,np_v(k,idx)-1
      polynomial_tracer = polynomial_tracer + coeff(p+1)*real(p,r_def)*z0**(p-1)
    end do
    ! Polynomial tracer contains the directional derivative
    ! ( dP/dz for w > 0, -dP/dz for w < 0) so need to cancel
    ! out sign of wind - hence presense of abs(w)

    advection_update = advection_update + abs(etadot)*polynomial_tracer

    if (enforce_monotonicity)then
      km1=max(0,k-1)
      kp1=min(nlayers, k+1)
      tracer_min = minval(tracer( stencil_map(dft,1:stencil_size)+k))
      tracer_min = min(tracer_min, minval(tracer( stencil_map(dft,1)+km1:stencil_map(dft,1)+kp1)) )
      tracer_max = maxval(tracer( stencil_map(dft,1:stencil_size)+k))
      tracer_max = max(tracer_max, maxval(tracer( stencil_map(dft,1)+km1:stencil_map(dft,1)+kp1)) )

      advection_update = min((tracer(stencil_map(dft,1)+k) - tracer_min)/dt &
         /mt_lumped_inv(stencil_map(dft,1)+k), &
         advection_update)
      advection_update = max((tracer(stencil_map(dft,1)+k) - tracer_max)/dt &
         /mt_lumped_inv(stencil_map(dft,1)+k), &
         advection_update)
    end if

    advection(stencil_map(dft,1)+k) = advection_update
  end do
end subroutine sample_poly_adv_code

!=============================================================================!
!>@brief Initialise various quantities needed for sample_poly_adv_code
!>@param[in] order Polynomial order for advective computations
!>@param[in] nlayers Number of vertical layers
subroutine sample_poly_adv_init(order, nlayers)

  use matrix_invert_mod, only: matrix_invert

  implicit none

  integer(kind=i_def), intent(in) :: order, nlayers
  integer(kind=i_def)             :: p, i, j, k
  integer(kind=i_def)             :: nupwindcells, ndownwindcells
  real(kind=r_def), allocatable   :: inv_coeff_matrix(:,:)

  ! Order p polynomial has p+1 coefficients
  np = order + 1_i_def

  ! Compute the stencil table
  ! This give the cell id's in the stencilmap in a different order so that
  ! in each direction the first entry is the most upwind cell and the last
  ! the most downwind cell.
  ! e.g for a 1depth stencil map
  !     ---
  !     |5|
  !   -------
  !   |2|1|4|
  !   -------
  !     |3|
  !     ---
  !
  ! The stencil array will be:
  ! stencil = ( 2,1,4
  !             3,1,5
  !             4,1,2
  !             5,1,3)
  ! that is ( i+1, i, i-1
  !           j+1, j, j-1
  !           i-1, i, i+1
  !           j-1, j, j+1)
  allocate(dof_stencil(np,4))

  ! Index of first upwind cell is  (j + (nupwindcells-1)*4)
  ! where j = [2,3,4,5] for [W,S,E,N] directions
  nupwindcells = int(real(np,r_def)/2.0_r_def)
  i = 1
  do p = 1,nupwindcells
    dof_stencil(i,1) = int((2 + (nupwindcells-1)*4) - (p-1)*4,i_def)
    dof_stencil(i,2) = int((3 + (nupwindcells-1)*4) - (p-1)*4,i_def)
    dof_stencil(i,3) = int((4 + (nupwindcells-1)*4) - (p-1)*4,i_def)
    dof_stencil(i,4) = int((5 + (nupwindcells-1)*4) - (p-1)*4,i_def)
    i = i + 1
  end do
  ! Index of centre cell in stencil is always 1
  dof_stencil(i,:) = 1
  i = i + 1
  ! Index of first downwind cell is j
  ! where j = [5,4,3,2] for [W,S,E,N] directions
  ndownwindcells = int(real(np-1,r_def)/2.0_r_def)
  do p = 1,ndownwindcells
    dof_stencil(i,1) = int(4 + (p-1)*4,i_def)
    dof_stencil(i,2) = int(5 + (p-1)*4,i_def)
    dof_stencil(i,3) = int(2 + (p-1)*4,i_def)
    dof_stencil(i,4) = int(3 + (p-1)*4,i_def)
    i = i + 1
  end do

  ! Build Coefficient matrix of arbritray order
  allocate(coeff_matrix(np,np), inv_coeff_matrix(np,np))
  do i = 1,np
    do j = 1,np
      ! (i-1)**(j-1)
      inv_coeff_matrix(i,j) = real(i-1,r_def)**(j-1)
    end do
  end do
  call matrix_invert(inv_coeff_matrix,coeff_matrix,np)

  ! Find sampling point,
  ! first tracer point in stencil is at x = 0,
  ! x0 then depends upon the number of upwind cells used
  x0 = floor(real(np,r_def)/2.0_r_def)

  ! Compute derivative of x0^p
  allocate( dx0(np-1) )
  do p = 1,np-1
    dx0(p) = real(p,r_def)*x0**(p-1)
  end do

  ! For vertical terms we may need to reduce orders near the boundaries
  ! due to lack of points so for each cell compute order and
  ! number of points in stencil of vertical terms
  ! np_v(:,1) is used if w > 0
  ! np_v(:,2) is used if w < 0
  allocate( np_v(0:nlayers,2) )
  np_v(:,:) = np

  ! Reduce to linear/cubic on levels 1 & n-1
  np_v(1,1) = min(np,2_i_def)
  np_v(1,2) = min(np,4_i_def)
  np_v(nlayers-1,2) = min(np,2_i_def)
  np_v(nlayers-1,1) = min(np,4_i_def)

  ! Reduce to constant on first and last levels
  np_v(0,:) = 1_i_def
  np_v(nlayers,:) = 1_i_def

  do k = 2,nlayers-2
    np_v(k,:) = int(min(np,min(2*k+1,2*(nlayers-k)+1)),i_def)
  end do

  ! Compute inverses for vertical
  ! Each lower order matrix is just a subset of the high order matrix
  allocate(coeff_matrix_v(1:np,1:np,np) )
  do p = 1,np
    call matrix_invert(inv_coeff_matrix(1:p,1:p),coeff_matrix_v(1:p,1:p,p),p)
  end do

end subroutine sample_poly_adv_init

end module sample_poly_adv_kernel_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------

!> @brief This version is for use on continuous spaces and will force
!>        halo exchanges on the input fields
module matrix_vector_kernel_mod
  use argument_mod,            only : arg_type,                 &
                                      GH_FIELD, GH_OPERATOR,    &
                                      GH_REAL, GH_READ, GH_INC, &
                                      ANY_SPACE_1, ANY_SPACE_2, &
                                      CELL_COLUMN
  use constants_mod,           only : i_def, r_single, r_double
  use kernel_mod,              only : kernel_type

  implicit none

  private

  !-------------------------------------------------------------------------------
  ! Public types
  !-------------------------------------------------------------------------------
  type, public, extends(kernel_type) :: matrix_vector_kernel_type
    private
    type(arg_type) :: meta_args(3) = (/                                    &
         arg_type(GH_FIELD,    GH_REAL, GH_INC,  ANY_SPACE_1),             &
         arg_type(GH_FIELD,    GH_REAL, GH_READ, ANY_SPACE_2),             &
         arg_type(GH_OPERATOR, GH_REAL, GH_READ, ANY_SPACE_1, ANY_SPACE_2) &
         /)
    integer :: operates_on = CELL_COLUMN
  end type

  !-------------------------------------------------------------------------------
  ! Contained functions/subroutines
  !-------------------------------------------------------------------------------
  public :: matrix_vector_code

  ! Generic interface for real32 and real64 types
  interface matrix_vector_code
    module procedure  &
      ! matrix_vector_code_r_single, &
      matrix_vector_code_r_double
  end interface

contains

  !> @brief Computes lhs = matrix*x
  !> @brief real32 and real64 variants
  !! @param[in] cell Horizontal cell index
  !! @param[in] nlayers Number of layers
  !! @param[inout] lhs Output lhs (A*x)
  !! @param[in] x Input data
  !! @param[in] ncell_3d Total number of cells
  !! @param[in] matrix Local matrix assembly form of the operator A
  !! @param[in] ndf1 Number of degrees of freedom per cell for the output field
  !! @param[in] undf1 Unique number of degrees of freedom  for the output field
  !! @param[in] map1 Dofmap for the cell at the base of the column for the
  !! output field
  !! @param[in] ndf2 Number of degrees of freedom per cell for the input field
  !! @param[in] undf2 Unique number of degrees of freedom for the input field
  !! @param[in] map2 Dofmap for the cell at the base of the column for the input
  !! field

  ! R_SINGLE PRECISION
  ! ==================
  !subroutine matrix_vector_code_r_single(cell,              &
  !                                       nlayers,           &
  !                                       lhs, x,            &
  !                                       ncell_3d,          &
  !                                       matrix,            &
  !                                       ndf1, undf1, map1, &
  !                                       ndf2, undf2, map2)

  !  implicit none

  !  ! Arguments
  !  integer(kind=i_def),                  intent(in) :: cell, nlayers, ncell_3d
  !  integer(kind=i_def),                  intent(in) :: undf1, ndf1
  !  integer(kind=i_def),                  intent(in) :: undf2, ndf2
  !  integer(kind=i_def), dimension(ndf1), intent(in) :: map1
  !  integer(kind=i_def), dimension(ndf2), intent(in) :: map2
  !  real(kind=r_single), dimension(undf2),              intent(in)    :: x
  !  real(kind=r_single), dimension(undf1),              intent(inout) :: lhs
  !  real(kind=r_single), dimension(ndf1,ndf2,ncell_3d), intent(in)    :: matrix

    ! Internal variables
  !  integer(kind=i_def)                  :: df, k, ik
  !  real(kind=r_single), dimension(ndf2) :: x_e
  !  real(kind=r_single), dimension(ndf1) :: lhs_e

  !  do k = 0, nlayers-1
  !    do df = 1, ndf2
  !      x_e(df) = x(map2(df)+k)
  !    end do
  !    ik = (cell-1)*nlayers + k + 1
  !    lhs_e = matmul(matrix(:,:,ik),x_e)
  !    do df = 1,ndf1
  !      lhs(map1(df)+k) = lhs(map1(df)+k) + lhs_e(df)
  !    end do
  !  end do

  !end subroutine matrix_vector_code_r_single


  ! R_DOUBLE PRECISION
  ! ==================
  subroutine matrix_vector_code_r_double(cell,              &
                                         nlayers,           &
                                         lhs, x,            &
                                         ncell_3d,          &
                                         matrix,            &
                                         ndf1, undf1, map1, &
                                         ndf2, undf2, map2)

    implicit none

    ! Arguments
    integer(kind=i_def),                  intent(in) :: cell, nlayers, ncell_3d
    integer(kind=i_def),                  intent(in) :: undf1, ndf1
    integer(kind=i_def),                  intent(in) :: undf2, ndf2
    integer(kind=i_def), dimension(ndf1), intent(in) :: map1
    integer(kind=i_def), dimension(ndf2), intent(in) :: map2
    real(kind=r_double), dimension(undf2),              intent(in)    :: x
    real(kind=r_double), dimension(undf1),              intent(inout) :: lhs
    real(kind=r_double), dimension(ndf1,ndf2,ncell_3d), intent(in)    :: matrix

    ! Internal variables
    integer(kind=i_def)                  :: df, k, ik
    real(kind=r_double), dimension(ndf2) :: x_e
    real(kind=r_double), dimension(ndf1) :: lhs_e

    do k = 0, nlayers-1
      do df = 1, ndf2
        x_e(df) = x(map2(df)+k)
      end do
      ik = (cell-1)*nlayers + k + 1
      lhs_e = matmul(matrix(:,:,ik),x_e)
      do df = 1,ndf1
        lhs(map1(df)+k) = lhs(map1(df)+k) + lhs_e(df)
      end do
    end do

  end subroutine matrix_vector_code_r_double

end module matrix_vector_kernel_mod

!-----------------------------------------------------------------------------
! (C) Crown copyright 2018 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------

!> @brief Applies the strong curl: xi = curl(u) with u in W1 and xi in W2.
!>
!> @details Applies the strong form of the curl operator: xi = curl(u) with
!>          u in W1 and xi in W2. Since curl maps W1->W2 then curl(u) is in
!>          W2 and so the equation holds the strong form and can therefore
!>          be applied anywhere, for convenience if is sampled at
!>          the nodal points of xi to compute xi in w2
!>
module strong_curl_kernel_mod

  use argument_mod,      only : arg_type, func_type,     &
                                GH_FIELD, GH_REAL,       &
                                GH_READ, GH_INC,         &
                                GH_DIFF_BASIS, GH_BASIS, &
                                CELL_COLUMN, GH_EVALUATOR
  use constants_mod,     only : r_def, i_def
  use fs_continuity_mod, only : W1, W2
  use kernel_mod,        only : kernel_type

  implicit none

  private

  !---------------------------------------------------------------------------
  ! Public types
  !---------------------------------------------------------------------------
  !> The type declaration for the kernel. Contains the metadata needed by the
  !> Psy layer.
  !>
  type, public, extends(kernel_type) :: strong_curl_kernel_type
    private
    type(arg_type) :: meta_args(2) = (/            &
         arg_type(GH_FIELD, GH_REAL, GH_INC,  W2), &
         arg_type(GH_FIELD, GH_REAL, GH_READ, W1)  &
         /)
    type(func_type) :: meta_funcs(2) = (/          &
         func_type(W2, GH_BASIS),                  &
         func_type(W1, GH_DIFF_BASIS)              &
         /)
    integer :: operates_on = CELL_COLUMN
    integer :: gh_shape = GH_EVALUATOR
  contains
    procedure, nopass :: strong_curl_code
  end type

  !---------------------------------------------------------------------------
  ! Contained functions/subroutines
  !---------------------------------------------------------------------------
  public :: strong_curl_code

contains

!> @brief Kernel to compute the strong curl: xi = curl(u)
!! @param[in] nlayers Number of layers
!! @param[in,out] xi Field to contain curl of u
!! @param[in] u Wind field
!! @param[in] ndf2 Number of degrees of freedom per cell for W2
!! @param[in] undf2 Number of unique degrees of freedom for W2
!! @param[in] map2 Dofmap for the cell at the base of the column for W2
!! @param[in] basis_w2 W2 basis functions evaluated at nodal points of W2
!! @param[in] ndf1 Number of degrees of freedom per cell for W1
!! @param[in] undf1 Number of unique degrees of freedom for W1
!! @param[in] map1 Dofmap for the cell at the base of the column for the field to be advected
!! @param[in] diff_basis_w1 Differential W1 basis functions evaluated at nodal points of W2
subroutine strong_curl_code(nlayers,                         &
                            xi, u,                           &
                            ndf2, undf2, map2, basis_w2,     &
                            ndf1, undf1, map1, diff_basis_w1 &
                            )

  implicit none

  ! Arguments
  integer(kind=i_def),                      intent(in)    :: nlayers
  integer(kind=i_def),                      intent(in)    :: ndf1, undf1, &
                                                             ndf2, undf2
  integer(kind=i_def), dimension(ndf1),     intent(in)    :: map1
  integer(kind=i_def), dimension(ndf2),     intent(in)    :: map2
  real(kind=r_def), dimension(3,ndf2,ndf2), intent(in)    :: basis_w2
  real(kind=r_def), dimension(3,ndf1,ndf2), intent(in)    :: diff_basis_w1
  real(kind=r_def), dimension(undf2),       intent(inout) :: xi
  real(kind=r_def), dimension(undf1),       intent(in)    :: u

  ! Internal variables
  integer(kind=i_def)            :: df1, df2, k
  real(kind=r_def), dimension(3) :: curl_u

  do k = 0, nlayers-1
    do df2 = 1,ndf2
      curl_u(:) = 0.0_r_def
      do df1 = 1,ndf1
        curl_u(:) = curl_u(:) + u(map1(df1)+k)*diff_basis_w1(:,df1,df2)
      end do
      xi( map2(df2)+k ) = dot_product(basis_w2(:,df2,df2),curl_u)
    end do
  end do

end subroutine strong_curl_code

end module strong_curl_kernel_mod

!-----------------------------------------------------------------------------
! (C) Crown copyright 2021 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------
!> @brief Computes the rhs for the tangent linear of the equation of state.
!>
!> @details The kernel computes the rhs of the linearized equation of state.
!> The nonlinear is:
!> \f[ rhs_{\Pi} = 1 - p0/Rd * exner ^ (1-kappa)/kappa /(rho*theta_vd) \f]
!> Following \f[delta r = dr/dp delta p + dr/drho delta rho + dr/dt delta t \f]
!> The linear is:
!> \f[ rhs = -L ( gamma*exner/ls_exner - rho/ls_rho - theta/ls_theta ) \f]
!> where
!> \f[ L = p0/Rd * ls_exner ^ gamma /(ls_rho*ls_theta_vd) \f]
!> and \f[ gamma = (1-kappa)/kappa \f]

module tl_rhs_eos_kernel_mod

  use argument_mod,      only : arg_type, func_type,         &
                                GH_FIELD, GH_READ, GH_WRITE, &
                                GH_SCALAR,                   &
                                GH_REAL, ANY_SPACE_9,        &
                                ANY_DISCONTINUOUS_SPACE_3,   &
                                GH_BASIS, GH_DIFF_BASIS,     &
                                CELL_COLUMN, GH_QUADRATURE_XYoZ
  use constants_mod,     only : r_def, i_def
  use fs_continuity_mod, only : W3, Wtheta
  use kernel_mod,        only : kernel_type

  implicit none

  private

  !-------------------------------------------------------------------------------
  ! Public types
  !-------------------------------------------------------------------------------
  !> The type declaration for the kernel. Contains the metadata needed by the
  !> Psy layer.
  !>
  type, public, extends(kernel_type) :: tl_rhs_eos_kernel_type
    private
    type(arg_type) :: meta_args(14) = (/                                     &
         arg_type(GH_FIELD,   GH_REAL, GH_WRITE, W3),                        &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  W3),                        &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  W3),                        &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  Wtheta),                    &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  Wtheta),                    &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  W3),                        &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  W3),                        &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  Wtheta),                    &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  Wtheta),                    &
         arg_type(GH_FIELD*3, GH_REAL, GH_READ,  ANY_SPACE_9),               &
         arg_type(GH_FIELD,   GH_REAL, GH_READ,  ANY_DISCONTINUOUS_SPACE_3), &
         arg_type(GH_SCALAR, GH_REAL, GH_READ),                              &
         arg_type(GH_SCALAR, GH_REAL, GH_READ),                              &
         arg_type(GH_SCALAR, GH_REAL, GH_READ)                               &
         /)
    type(func_type) :: meta_funcs(3) = (/                                   &
         func_type(W3,          GH_BASIS),                                  &
         func_type(Wtheta,      GH_BASIS),                                  &
         func_type(ANY_SPACE_9, GH_BASIS, GH_DIFF_BASIS)                    &
         /)
    integer :: operates_on = CELL_COLUMN
    integer :: gh_shape = GH_QUADRATURE_XYoZ
  contains
    procedure, nopass :: tl_rhs_eos_code
  end type

  !---------------------------------------------------------------------------
  ! Contained functions/subroutines
  !---------------------------------------------------------------------------
  public :: tl_rhs_eos_code

contains

!> @brief Computes lhs of the equation of state for the nonlinear equations
!! @param[in] nlayers       Number of layers
!! @param[in,out] rhs_eos   RHS array for the tangent linear equation of state
!! @param[in] exner         Change in Pressure
!! @param[in] rho           Change in Density
!! @param[in] theta         Change in Potential temperature
!! @param[in] moist_dyn_gas Change in Moist dynamics factor in gas law
!! @param[in] ls_exner      Lin state for Pressure
!! @param[in] ls_rho        Lin state for Density
!! @param[in] ls_theta      Lin state for Potential temperature
!! @param[in] ls_moist_dyn_gas Lin state for Moist dynamics factor in gas law
!! @param[in] chi_1         1st coordinate field in Wchi
!! @param[in] chi_2         2nd coordinate field in Wchi
!! @param[in] chi_3         3rd coordinate field in Wchi
!! @param[in] panel_id      Field giving the ID for mesh panels
!! @param[in] kappa         Ratio of rd and cp
!! @param[in] rd            Specific heat of dry air at constant density
!! @param[in] p_zero        Reference surface pressure
!! @param[in] ndf_w3        Number of degrees of freedom per cell for W3
!! @param[in] undf_w3       Number of (local) unique degrees of freedom
!! @param[in] map_w3        Dofmap for the cell at the base of the column for W3
!! @param[in] w3_basis      Basis functions evaluated at quadrature points
!! @param[in] ndf_wt        Number of degrees of freedom per cell for wt
!! @param[in] undf_wt       Number of (local) unique degrees of freedom
!! @param[in] map_wt        Dofmap for the cell at the base of the column for wt
!! @param[in] wt_basis      Basis functions evaluated at quadrature points
!! @param[in] ndf_chi       Number of degrees of freedom per cell for chi
!! @param[in] undf_chi      Number of (local) unique degrees of freedom for chi
!! @param[in] map_chi       Dofmap for the cell at the base of the column
!!                             for chi
!! @param[in] chi_basis     Wchi basis functions evaluated at quadrature points
!! @param[in] chi_diff_basis Wchi derivatives of basis functions
!!                             evaluated at quadrature points
!! @param[in] ndf_pid       Number of degrees of freedom per cell for panel_id
!! @param[in] undf_pid      Number of unique degrees of freedom for panel_id
!! @param[in] map_pid       Dofmap for the cell at the base of the column
!!                             for panel_id
!! @param[in] nqp_h         Number of quadrature points in the horizontal
!! @param[in] nqp_v         Number of quadrature points in the vertical
!! @param[in] wqp_h         Horizontal quadrature weights
!! @param[in] wqp_v         Vertical quadrature weights
subroutine tl_rhs_eos_code(nlayers,                                         &
                           rhs_eos, exner, rho, theta, moist_dyn_gas,       &
                           ls_exner, ls_rho, ls_theta, ls_moist_dyn_gas,    &
                           chi1, chi2, chi3, panel_id,                      &
                           kappa, rd, p_zero,                               &
                           ndf_w3, undf_w3, map_w3, w3_basis,               &
                           ndf_wt, undf_wt, map_wt, wt_basis,               &
                           ndf_chi, undf_chi, map_chi,                      &
                           chi_basis, chi_diff_basis,                       &
                           ndf_pid, undf_pid, map_pid,                      &
                           nqp_h, nqp_v, wqp_h, wqp_v)

  use coordinate_jacobian_mod,  only: coordinate_jacobian

  implicit none
  ! Arguments
  integer(kind=i_def), intent(in) :: nlayers, nqp_h, nqp_v
  integer(kind=i_def), intent(in) :: ndf_wt, ndf_w3, ndf_chi, ndf_pid
  integer(kind=i_def), intent(in) :: undf_wt, undf_w3, undf_chi, undf_pid
  integer(kind=i_def), dimension(ndf_w3),  intent(in) :: map_w3
  integer(kind=i_def), dimension(ndf_wt),  intent(in) :: map_wt
  integer(kind=i_def), dimension(ndf_chi), intent(in) :: map_chi
  integer(kind=i_def), dimension(ndf_pid), intent(in) :: map_pid

  real(kind=r_def), dimension(1,ndf_w3,nqp_h,nqp_v),  intent(in) :: w3_basis
  real(kind=r_def), dimension(1,ndf_wt,nqp_h,nqp_v),  intent(in) :: wt_basis
  real(kind=r_def), dimension(1,ndf_chi,nqp_h,nqp_v), intent(in) :: chi_basis
  real(kind=r_def), dimension(3,ndf_chi,nqp_h,nqp_v), intent(in) :: chi_diff_basis

  real(kind=r_def), dimension(undf_w3), intent(inout) :: rhs_eos
  real(kind=r_def), dimension(undf_wt), intent(in)    :: theta
  real(kind=r_def), dimension(undf_wt), intent(in)    :: moist_dyn_gas
  real(kind=r_def), dimension(undf_w3), intent(in)    :: rho, exner
  real(kind=r_def), dimension(undf_wt), intent(in)    :: ls_theta
  real(kind=r_def), dimension(undf_wt), intent(in)    :: ls_moist_dyn_gas
  real(kind=r_def), dimension(undf_w3), intent(in)    :: ls_rho, ls_exner
  real(kind=r_def), dimension(undf_chi), intent(in)   :: chi1, chi2, chi3
  real(kind=r_def), dimension(undf_pid), intent(in)   :: panel_id

  real(kind=r_def), dimension(nqp_h), intent(in)      ::  wqp_h
  real(kind=r_def), dimension(nqp_v), intent(in)      ::  wqp_v

  real(kind=r_def), intent(in) :: kappa
  real(kind=r_def), intent(in) :: rd
  real(kind=r_def), intent(in) :: p_zero

  ! Internal variables
  integer(kind=i_def) :: df, k
  integer(kind=i_def) :: qp1, qp2

  real(kind=r_def), dimension(ndf_wt)  :: theta_vd_e
  real(kind=r_def), dimension(ndf_wt)  :: ls_theta_vd_e
  real(kind=r_def), dimension(ndf_chi) :: chi1_e, chi2_e, chi3_e
  real(kind=r_def), dimension(ndf_w3)  :: rho_e, exner_e
  real(kind=r_def)                     :: rho_quad, theta_vd_quad, exner_quad
  real(kind=r_def), dimension(ndf_w3)  :: ls_rho_e, ls_exner_e
  real(kind=r_def)                     :: ls_rho_quad, ls_theta_vd_quad
  real(kind=r_def)                     :: ls_exner_quad
  real(kind=r_def)                             :: eos, p0_over_rd, onemk_over_k
  real(kind=r_def)                             :: ls_eos
  real(kind=r_def), dimension(nqp_h,nqp_v)     :: dj
  real(kind=r_def), dimension(3,3,nqp_h,nqp_v) :: jac

  integer(kind=i_def) :: ipanel

  ipanel = int(panel_id(map_pid(1)), i_def)

  p0_over_rd = p_zero/Rd
  onemk_over_k = (1.0_r_def - kappa)/kappa

  do k = 0, nlayers-1

    do df = 1, ndf_chi
      chi1_e(df) = chi1(map_chi(df) + k)
      chi2_e(df) = chi2(map_chi(df) + k)
      chi3_e(df) = chi3(map_chi(df) + k)
    end do
    call coordinate_jacobian(ndf_chi, nqp_h, nqp_v, chi1_e, chi2_e, chi3_e,  &
                             ipanel, chi_basis, chi_diff_basis, jac, dj)

    ! Linearisation state
    do df = 1, ndf_wt
      ls_theta_vd_e(df) = ls_theta(map_wt(df) + k) &
                        * ls_moist_dyn_gas(map_wt(df) + k)
    end do
    do df = 1, ndf_w3
      ls_exner_e(df) = ls_exner(map_w3(df) + k)
      ls_rho_e(df) = ls_rho(map_w3(df) + k)
    end do

    ! Perturbation
    do df = 1, ndf_wt
      theta_vd_e(df) = ( ls_theta(map_wt(df) + k) *         &
                         moist_dyn_gas(map_wt(df) + k) )    &
                     + ( theta(map_wt(df) + k) *            &
                         ls_moist_dyn_gas(map_wt(df) + k) )
    end do
    do df = 1, ndf_w3
      exner_e(df) = exner(map_w3(df) + k)
      rho_e(df) = rho(map_w3(df) + k)
      rhs_eos(map_w3(df)+k) = 0.0_r_def
    end do

    do qp2 = 1, nqp_v
      do qp1 = 1, nqp_h

        ! Linearisation state
        ls_theta_vd_quad = 0.0_r_def
        do df = 1, ndf_wt
          ls_theta_vd_quad = ls_theta_vd_quad &
                           + ls_theta_vd_e(df)*wt_basis(1,df,qp1,qp2)
        end do
        ls_exner_quad = 0.0_r_def
        ls_rho_quad = 0.0_r_def
        do df = 1, ndf_w3
          ls_exner_quad = ls_exner_quad + ls_exner_e(df)*w3_basis(1,df,qp1,qp2)
          ls_rho_quad   = ls_rho_quad   + ls_rho_e(df)  *w3_basis(1,df,qp1,qp2)
        end do

        ls_eos = 0.0_r_def - p0_over_rd * ls_exner_quad ** onemk_over_k &
               / ( ls_rho_quad *  ls_theta_vd_quad )

        ! Perturbation
        theta_vd_quad = 0.0_r_def
        do df = 1, ndf_wt
          theta_vd_quad = theta_vd_quad + theta_vd_e(df)*wt_basis(1,df,qp1,qp2)
        end do
        exner_quad = 0.0_r_def
        rho_quad = 0.0_r_def
        do df = 1, ndf_w3
          exner_quad = exner_quad + exner_e(df)*w3_basis(1,df,qp1,qp2)
          rho_quad   = rho_quad   + rho_e(df)  *w3_basis(1,df,qp1,qp2)
        end do

        ! Calculation
        eos = ( onemk_over_k * exner_quad / ls_exner_quad  - &
                rho_quad / ls_rho_quad                     - &
                theta_vd_quad / ls_theta_vd_quad ) * ls_eos

        eos = wqp_h(qp1) * wqp_v(qp2) * dj(qp1,qp2) * eos

        do df = 1, ndf_w3
          rhs_eos(map_w3(df)+k) = rhs_eos(map_w3(df)+k) &
                                - w3_basis(1,df,qp1,qp2) * eos
        end do

      end do
    end do
  end do

end subroutine tl_rhs_eos_code

end module tl_rhs_eos_kernel_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!------------------------------------------------------------------------------
! Modified by A. Porter, STFC
! Modified by I. Kavcic, Met Office

!> @brief Applies boundary conditions to a field
!> @details Wrapper code for applying boundary conditions to a field
!>          When the Psyclone api is updated to correctly deal with
!>          boundary dofs this can be removed
module enforce_bc_kernel_mod

use kernel_mod,              only : kernel_type
use argument_mod,            only : arg_type, func_type,                     &
                                    GH_FIELD, GH_REAL, GH_INC,               &
                                    ANY_SPACE_1,                             &
                                    CELL_COLUMN
use constants_mod,           only : r_def, i_def

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------
!> The type declaration for the kernel. Contains the metadata needed by the Psy layer
type, public, extends(kernel_type) :: enforce_bc_kernel_type
  private
  type(arg_type) :: meta_args(1) = (/                                  &
       arg_type(GH_FIELD,  GH_REAL,  GH_INC,  ANY_SPACE_1)             &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: enforce_bc_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public enforce_bc_code

contains

!> @brief Applies boundary conditions to a field
!! @param[in] nlayers Number of layers
!! @param[in,out] field Input/Output data
!! @param[in] ndf Number of degrees of freedom per cell
!! @param[in] undf Number unique of degrees of freedom
!! @param[in] map Dofmap for the cell at the base of the column
!! @param[in] boundary_value Flags (= 0) for dofs that live on the
!!            vertical boundaries of the cell (=1 for other dofs)
subroutine enforce_bc_code(nlayers,                        &
                           field,                          &
                           ndf, undf, map, boundary_value  &
                          )

  implicit none

  ! Arguments
  integer(kind=i_def), intent(in) :: nlayers
  integer(kind=i_def), intent(in) :: ndf
  integer(kind=i_def), intent(in) :: undf
  integer(kind=i_def), dimension(ndf),   intent(in) :: map
  integer(kind=i_def), dimension(ndf,2), intent(in) :: boundary_value

  real(kind=r_def), dimension(undf), intent(inout) :: field

  ! Local variables
  integer(kind=i_def) :: df, k

  k = 0
  do df = 1,ndf
    field(map(df) + k) = field(map(df) + k)*real(boundary_value(df,1))
  end do
  k = nlayers - 1
  do df = 1,ndf
    field(map(df) + k) = field(map(df) + k)*real(boundary_value(df,2))
  end do

end subroutine enforce_bc_code

end module enforce_bc_kernel_mod

module compute_h_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod
  use field_mod
  implicit none

  private

  public invoke_compute_h
  public compute_h, compute_h_code

  type, extends(kernel_type) :: compute_h
     type(go_arg), dimension(4) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_CT, GO_POINTWISE),            & ! h
             go_arg(GO_READ,  GO_CT, GO_POINTWISE),            & ! p
             go_arg(GO_READ,  GO_CU, GO_STENCIL(000,011,000)), & ! u
             go_arg(GO_READ,  GO_CV, GO_STENCIL(010,010,000))  & ! v
           /)
     !> This kernel writes only to internal points of the
     !! simulation domain.
     integer :: ITERATES_OVER = GO_INTERNAL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => compute_h_code
  end type compute_h

contains

  !===================================================

  subroutine invoke_compute_h(hfld, pfld, ufld, vfld)
    implicit none
    type(r2d_field), intent(inout) :: hfld
    type(r2d_field), intent(in)    :: pfld, ufld,vfld
    ! Locals
    integer :: I, J

    ! Note that we do not loop over the full extent of the field.
    ! Fields are allocated with extents (M+1,N+1).
    ! Presumably the extra row and column are needed for periodic BCs.
    ! We are updating a quantity on CT.
    ! This loop writes to h(1:M,1:N) so this looks like
    ! (using x to indicate a location that is written):
    !
    ! i=1   i=M
    !  o  o  o  o 
    !  x  x  x  o   j=N
    !  x  x  x  o
    !  x  x  x  o   j=1

    ! Quantity H is defined as:
    !         H = P + 0.5(<u^2>_x + <v^2>_y)
    ! where <d>_x indicates average over field d in x direction.

    ! Original code looked like:
    !
    !     DO J=1,N
    !        DO I=1,M
    !           H(I,J) = P(I,J)+.25*(U(I+1,J)*U(I+1,J)+U(I,J)*U(I,J)     & 
    !                               +V(I,J+1)*V(I,J+1)+V(I,J)*V(I,J))
    !        END DO
    !     END DO

    ! h(i,j) depends upon:
    !   p(i,j)                                : CT
    !   u(i,j), u(i+1,j)                      : CU
    !    => lateral CU neighbours of the CT pt being updated 
    !   v(i,j), v(i,j+1)                      : CV
    !    => vertical CV neighbours of the CT pt being updated

    !   x-------vij+1---fi+1j+1
    !   |       |       |
    !   |       |       |
    !   uij-----Tij-----ui+1j
    !   |       |       |
    !   |       |       |
    !   fij-----vij-----fi+1j
    !   |       |       |
    !   |       |       |
    !   uij-1- -Tij-1---ui+1j-1
    !

    DO J=hfld%internal%ystart, hfld%internal%ystop, 1
       DO I=hfld%internal%xstart, hfld%internal%xstop, 1

          CALL compute_h_code(i, j, hfld%data, &
                              pfld%data, ufld%data, vfld%data)
       END DO
    END DO

  end subroutine invoke_compute_h

  !===================================================

  SUBROUTINE compute_h_code(i, j, h, p, u, v)
    IMPLICIT none
    integer,  intent(in) :: I, J
    REAL(go_wp), INTENT(out), DIMENSION(:,:) :: h
    REAL(go_wp), INTENT(in),  DIMENSION(:,:) :: p, u, v

    H(I,J) = P(I,J)+.25d0*(U(I+1,J)*U(I+1,J)+U(I,J)*U(I,J) + & 
                           V(I,J+1)*V(I,J+1)+V(I,J)*V(I,J))

  END SUBROUTINE compute_h_code

END MODULE compute_h_mod

  MODULE main
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE main_code()
      USE update_field_mod, ONLY: update_field_code
      USE extract_psy_data_mod, ONLY: extract_PSyDataType
      IMPLICIT NONE
      INTEGER j
      INTEGER i
      REAL(KIND=8), allocatable, dimension(:,:) :: z
      REAL(KIND=8), allocatable, dimension(:,:) :: y_post
      REAL(KIND=8), allocatable, dimension(:,:) :: y
      REAL(KIND=8), allocatable, dimension(:,:) :: x_post
      REAL(KIND=8), allocatable, dimension(:,:) :: x
      REAL(KIND=8), allocatable, dimension(:,:) :: j_post
      REAL(KIND=8), allocatable, dimension(:,:) :: j
      REAL(KIND=8), allocatable, dimension(:,:) :: i_post
      REAL(KIND=8), allocatable, dimension(:,:) :: i
      REAL(KIND=8), allocatable, dimension(:,:) :: d_fld
      REAL(KIND=8), allocatable, dimension(:,:) :: c_fld
      REAL(KIND=8), allocatable, dimension(:,:) :: dx
      REAL(KIND=8), allocatable, dimension(:,:) :: b_fld
      REAL(KIND=8), allocatable, dimension(:,:) :: a_fld_post
      REAL(KIND=8), allocatable, dimension(:,:) :: a_fld
      TYPE(extract_PSyDataType) extract_psy_data
      CALL extract_psy_data%OpenRead("main", "update")
      CALL extract_psy_data%ReadVariable("a_fld", a_fld)
      CALL extract_psy_data%ReadVariable("a_fld_post", a_fld_post)
      CALL extract_psy_data%ReadVariable("b_fld", b_fld)
      CALL extract_psy_data%ReadVariable("b_fld%grid%dx", dx)
      CALL extract_psy_data%ReadVariable("c_fld", c_fld)
      CALL extract_psy_data%ReadVariable("d_fld", d_fld)
      CALL extract_psy_data%ReadVariable("i_post", i_post)
      ALLOCATE (i, mold=i_post)
      i = 0.0d0
      CALL extract_psy_data%ReadVariable("j_post", j_post)
      ALLOCATE (j, mold=j_post)
      j = 0.0d0
      CALL extract_psy_data%ReadVariable("x", x)
      CALL extract_psy_data%ReadVariable("x_post", x_post)
      CALL extract_psy_data%ReadVariable("y_post", y_post)
      ALLOCATE (y, mold=y_post)
      y = 0.0d0
      CALL extract_psy_data%ReadVariable("z", z)
      !
      ! RegionStart
      DO j=ystart,ystop
        DO i=xstart,xstop
          CALL update_field_code(i, j, a_fld, b_fld, c_fld, d_fld, x, y, z, dx)
        END DO
      END DO
      ! RegionEnd
      !
      ! Check a_fld
      ! Check i
      ! Check j
      ! Check x
      ! Check y
    END SUBROUTINE main_code
  END MODULE main

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2018, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: A. R. Porter, STFC Daresbury Lab.

! A simple, single Invoke example to demonstrate the generation of an
! OpenCL driver PSy layer.
program simple

  use kind_params_mod, only: go_wp
  use grid_mod
  use field_mod
  use gocean_mod, only: gocean_initialise
  use compute_cu_mod,   only: compute_cu
  use compute_cv_mod,   only: compute_cv
  use compute_z_mod,    only: compute_z
  use compute_h_mod,    only: compute_h
  implicit none

  type(grid_type), target :: model_grid
  integer, allocatable, dimension(:,:) :: tmask

  type(r2d_field) :: p_fld
  type(r2d_field) :: u_fld, v_fld
  type(r2d_field) :: cu_fld, cv_fld
  type(r2d_field) :: z_fld
  type(r2d_field) :: h_fld

  integer :: ncycle, ierr
  integer :: jpiglo, jpjglo

  ! Dimensions of our domain
  jpiglo = 50
  jpjglo = 50

  call gocean_initialise()

  ! Create our grid
  model_grid = grid_type(GO_ARAKAWA_C,                                 &
                         (/GO_BC_PERIODIC,GO_BC_PERIODIC,GO_BC_NONE/), &
                         GO_OFFSET_SW)
  !> Generate a domain decomposition
  call model_grid%decompose(jpiglo, jpjglo)

  ! Set-up the T mask for the local domain. This defines the model domain.
  allocate(tmask(model_grid%subdomain%global%nx, &
                 model_grid%subdomain%global%ny), stat=ierr)
  if(ierr /= 0)then
     stop 'Failed to allocate T mask'
  end if

  tmask(:,:) = 0

  ! Having specified the T points mask, we can set up mesh parameters
  call grid_init(model_grid, 1000.0_go_wp, 1000.0_go_wp, tmask)

  ! Create fields on this grid
  p_fld  = r2d_field(model_grid, GO_T_POINTS)
  u_fld  = r2d_field(model_grid, GO_U_POINTS)
  v_fld  = r2d_field(model_grid, GO_V_POINTS)
  cu_fld = r2d_field(model_grid, GO_U_POINTS)
  cv_fld = r2d_field(model_grid, GO_V_POINTS)
  z_fld = r2d_field(model_grid, GO_F_POINTS)
  h_fld = r2d_field(model_grid, GO_T_POINTS)

  write(*,*) "Simulation start"
  do ncycle=1, 100
    call invoke( compute_cu(CU_fld, p_fld, u_fld),      &
                 compute_cv(CV_fld, p_fld, v_fld),      &
                 compute_z(z_fld, p_fld, u_fld, v_fld), &
                 compute_h(h_fld, p_fld, u_fld, v_fld) )
  end do
  write(*,*) "Simulation end"

end program simple

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2017-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author R. W. Ford STFC Daresbury Lab
! Modified I. Kavcic Met Office
module testkern_qr

  use constants_mod
  use argument_mod
  use fs_continuity_mod
  use kernel_mod

  implicit none

  type, extends(kernel_type) :: testkern_qr_type
     type(arg_type), dimension(6) :: meta_args =           &
          (/ arg_type(gh_field,  gh_real,    gh_inc,  w1), &
             arg_type(gh_field,  gh_real,    gh_read, w2), &
             arg_type(gh_field,  gh_real,    gh_read, w2), &
             arg_type(gh_scalar, gh_real,    gh_read),     &
             arg_type(gh_field,  gh_real,    gh_read, w3), &
             arg_type(gh_scalar, gh_integer, gh_read)      &
           /)
     type(func_type), dimension(3) :: meta_funcs =         &
          (/ func_type(w1, gh_basis),                      &
             func_type(w2, gh_diff_basis),                 &
             func_type(w3, gh_basis, gh_diff_basis)        &
           /)
     integer :: operates_on = cell_column
     integer :: gh_shape = gh_quadrature_XYoZ
   contains
     procedure, nopass :: code => testkern_qr_code
  end type testkern_qr_type

contains

  subroutine testkern_qr_code(nlayers, f1, f2, f3, ascalar, f4, iscalar, &
                              ndf_w1, undf_w1, map_w1, basis_w1, ndf_w2, &
                              undf_w2, map_w2, diff_basis_w2, ndf_w3,    &
                              undf_w3, map_w3, basis_w3, diff_basis_w3,  &
                              nqp_h, nqp_v, wh, wv)

    implicit none

    integer(kind=i_def) :: nlayers, iscalar
    integer(kind=i_def) :: ndf_w1, undf_w1, ndf_w2, undf_w2, ndf_w3, undf_w3
    integer(kind=i_def) :: nqp_h, nqp_v
    integer(kind=i_def), dimension(:) :: map_w1, map_w2, map_w3
    real(kind=r_def) :: ascalar
    real(kind=r_def), dimension(:) :: f1, f2, f3, f4
    real(kind=r_def), dimension(:) :: wh, wv
    real(kind=r_def), dimension(:,:,:,:) :: basis_w1, diff_basis_w2
    real(kind=r_def), dimension(:,:,:,:) :: basis_w3, diff_basis_w3

  end subroutine testkern_qr_code

end module testkern_qr

! ==================================================
! THIS FILE IS CREATED FROM THE JINJA TEMPLATE FILE 
! DO NOT MODIFY DIRECTLY                            
! ==================================================





! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Authors J. Henrichs, Bureau of Meteorology

!> This module implements a verification that read-only fields are
!! not overwritten (due to memory overwrites etc)
!! 

module read_only_base_mod
    use, intrinsic :: iso_fortran_env, only : int64, int32,   &
                                              real32, real64, &
                                              stderr=>Error_Unit
    use psy_data_base_mod, only : PSyDataBaseType, &
        read_only_verify_PSyDataShutdown, &
        read_only_verify_PSyDataInit, is_enabled, &
        read_only_verify_PSyDataStart, read_only_verify_PSyDataStop

    implicit none

    !> This is the data type that stores a checksum for each read-only
    !! variable. A static instance of this type is created for each
    !! instrumented region with PSyclone.

    type, extends(PSyDataBaseType), public:: ReadOnlyBaseType
        !> This field stores a 64-bit integer checksum for each
        !! variable.
        integer(kind=int64), dimension(:), allocatable :: checksums

        !> This boolean flag switches from 'computing and storing checksum'
        !! to 'verify checksum'.
        logical :: verify_checksums

    contains
        ! The various procedures used
        procedure :: PreStart, PreEndDeclaration
        procedure :: PostStart

        procedure :: ProvideScalarInt
        procedure :: ProvideArray2dInt
        procedure :: ProvideScalarReal
        procedure :: ProvideArray2dReal
        procedure :: ProvideScalarDouble
        procedure :: ProvideArray2dDouble

    end type ReadOnlyBaseType

                        
    ! Generic interface for all ComputeChecksum functions
    interface ComputeChecksum
      module procedure &
        ComputeChecksum2dInt, &
        ComputeChecksum2dReal, &
        ComputeChecksum2dDouble
    end interface ComputeChecksum

    public ComputeChecksum

Contains

    ! -------------------------------------------------------------------------
    !> This subroutine is the first function called when an instrumented region
    !! is entered. It initialises this object, and stores module and regin
    !! names. 
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    !! @param[in] module_name The name of the module of the instrumented
    !!            region.
    !! @param[in] kernel_name The name of the instrumented region.
    !! @param[in] num_pre_vars The number of variables that are declared and
    !!            checksum'ed before the instrumented region.
    !! @param[in] num_post_vars The number of variables that are also declared
    !!            before an instrumented region of code, but are checksum'ed
    !!            after this region.
    subroutine PreStart(this, module_name, region_name, num_pre_vars, &
                        num_post_vars)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this
        character(*), intent(in) :: module_name, region_name
        integer, intent(in)      :: num_pre_vars, num_post_vars

        character(1) :: verbose
        integer :: status
        call this%PSyDataBaseType%PreStart(module_name, region_name, &
                                           num_pre_vars, num_post_vars)
        this%verify_checksums = .false.

        if (.not. is_enabled) return

        if (num_pre_vars /= num_post_vars) then
            write(stderr, *) "PSYDATA: The same number of variables must be provided before"
            write(stderr, *) "and after the instrumented region. But the values are:"
            write(stderr, *) "Before: ", num_pre_vars, " after: ", num_post_vars
            call this%Abort("PreStart: Inconsistent parameters")
        endif

    end subroutine PreStart

    ! -------------------------------------------------------------------------
    !> This subroutine is called once all variables are declared. It makes
    !! sure that the next variable index is starting at 1 again.
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    subroutine PreEndDeclaration(this)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this
        integer :: err

        if (.not. is_enabled) return

        ! During the declaration the number of checksums to be
        ! stored was counted in next_var_index, so allocate the array
        ! now (if it has not been allocated already in a previous call):
        if (.not. allocated(this%checksums)) then
            allocate(this%checksums(this%next_var_index-1), stat=err)
            if(err/=0) then
                write(stderr, *) "PSyData: Could not allocate ", &
                                 this%next_var_index-1,          &
                                 " integers, aborting."
                call this%Abort("Out of memory")
            endif
        endif
        call this%PSyDataBaseType%PreEndDeclaration()
    end subroutine PreEndDeclaration

    ! -------------------------------------------------------------------------
    !> This subroutine is called after the instrumented region has been
    !! executed. After this call the value of variables after the instrumented
    !! region will be provided. This subroutine sets the 'verify_checksum'
    !! flag to true, causing all further checksum calls to verify that the
    !! checksum has not changed. It also resets the next variable index to 1
    !! again.
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    subroutine PostStart(this)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this

        call this%PSyDataBaseType%PostStart()
        ! The pointer mst be reset to 1 to make sure we compare
        ! with the previously computed checksums
        this%next_var_index = 1
        this%verify_checksums = .true.
    end subroutine PostStart


    ! =========================================================================
    ! Jinja created code.
    ! =========================================================================



    ! =========================================================================
    ! Implementation for all integer(kind=int32) types
    ! =========================================================================
    ! -------------------------------------------------------------------------
    !> This subroutine either computes a checksum or compares a checksum
    !! (depending on this%verify_checksums) for a single Int.
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarInt(this, name, value)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), intent(in)     :: value

        integer(kind=int32)            :: orig_value
        integer(kind=int64) :: checksum, int_64

        integer(kind=int32) :: int_32

        if (.not. is_enabled) return

        ! `transfer` leaves undefined bits in a 64-bit value
        ! so assign to 32-bit, then assign to 64-bit to have all bits defined
        int_32 = transfer(value, int_32)
        checksum = int_32

        if (this%verify_checksums) then
            if (checksum /= this%checksums(this%next_var_index)) then
                write(stderr,*) "------------- PSyData -------------------------"
                write(stderr,*) "integer(kind=int32) variable ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                ! We can recreate the original value which is stored as
                ! 64-bit integer as the checksum:
                int_32 = this%checksums(this%next_var_index)
                orig_value = transfer(int_32, orig_value)
                write(stderr,*) "Original value: ", orig_value
                write(stderr,*) "New value:      ", value
                write(stderr,*) "------------- PSyData -------------------------"
            else if(this%verbosity>1) then
                write(stderr,*) "PSYDATA: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = checksum
        endif
        call this%PSyDataBaseType%ProvideScalarInt(name, value)
    end subroutine ProvideScalarInt

    ! -------------------------------------------------------------------------
    !> This subroutine either computes a checksum or compares a checksum
    !! (depending on this%verify_checksums) for a 2d-array of integer
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dInt(this, name, value)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), dimension(:,:), intent(in) :: value
        integer(kind=int64) :: checksum
        integer :: i, j

        if (.not. is_enabled) return

        checksum = ComputeChecksum(value)
        if (this%verify_checksums) then
            if (checksum /= this%checksums(this%next_var_index)) then
                write(stderr,*) "------------- PSyData -------------------------"
                write(stderr,*) "2d Int array ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                write(stderr,*) "Original checksum: ", this%checksums(this%next_var_index)
                write(stderr,*) "New checksum:      ", checksum
                write(stderr,*) "------------- PSyData -------------------------"
            else if(this%verbosity>1) then
                write(stderr,*) "PSYDATA: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = checksum
        endif
        call this%PSyDataBaseType%ProvideArray2dInt(name, value)
    end subroutine ProvideArray2dInt


    ! -------------------------------------------------------------------------
    !> This function computes a 64-bit integer checksum for a 2d
    !! integer(kind=int32) Fortran array.
    function ComputeChecksum2dInt(field) result(checksum)
        implicit none
        integer(kind=int32), dimension(:,:) :: field

        integer :: i1,i2
        integer(kind=int32) :: int_32
        integer(kind=int64) :: checksum, int_64

        checksum = 0
        do i2=1, size(field, 2)
           do i1=1, size(field, 1)
              ! transfer leaves undefined bits in a 64-bit target
              ! so we transfer to 32-bits and then assign to 64-bit
              int_32 = transfer(field(i1,i2), int_32)
              int_64 = int_32
              checksum = checksum + int_64
           enddo
        enddo
    end function ComputeChecksum2dInt

   
    ! =========================================================================
    ! Implementation for all real(kind=real32) types
    ! =========================================================================
    ! -------------------------------------------------------------------------
    !> This subroutine either computes a checksum or compares a checksum
    !! (depending on this%verify_checksums) for a single Real.
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarReal(this, name, value)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), intent(in)     :: value

        real(kind=real32)            :: orig_value
        integer(kind=int64) :: checksum, int_64

        integer(kind=int32) :: int_32

        if (.not. is_enabled) return

        ! `transfer` leaves undefined bits in a 64-bit value
        ! so assign to 32-bit, then assign to 64-bit to have all bits defined
        int_32 = transfer(value, int_32)
        checksum = int_32

        if (this%verify_checksums) then
            if (checksum /= this%checksums(this%next_var_index)) then
                write(stderr,*) "------------- PSyData -------------------------"
                write(stderr,*) "real(kind=real32) variable ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                ! We can recreate the original value which is stored as
                ! 64-bit integer as the checksum:
                int_32 = this%checksums(this%next_var_index)
                orig_value = transfer(int_32, orig_value)
                write(stderr,*) "Original value: ", orig_value
                write(stderr,*) "New value:      ", value
                write(stderr,*) "------------- PSyData -------------------------"
            else if(this%verbosity>1) then
                write(stderr,*) "PSYDATA: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = checksum
        endif
        call this%PSyDataBaseType%ProvideScalarReal(name, value)
    end subroutine ProvideScalarReal

    ! -------------------------------------------------------------------------
    !> This subroutine either computes a checksum or compares a checksum
    !! (depending on this%verify_checksums) for a 2d-array of integer
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dReal(this, name, value)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), dimension(:,:), intent(in) :: value
        integer(kind=int64) :: checksum
        integer :: i, j

        if (.not. is_enabled) return

        checksum = ComputeChecksum(value)
        if (this%verify_checksums) then
            if (checksum /= this%checksums(this%next_var_index)) then
                write(stderr,*) "------------- PSyData -------------------------"
                write(stderr,*) "2d Real array ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                write(stderr,*) "Original checksum: ", this%checksums(this%next_var_index)
                write(stderr,*) "New checksum:      ", checksum
                write(stderr,*) "------------- PSyData -------------------------"
            else if(this%verbosity>1) then
                write(stderr,*) "PSYDATA: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = checksum
        endif
        call this%PSyDataBaseType%ProvideArray2dReal(name, value)
    end subroutine ProvideArray2dReal


    ! -------------------------------------------------------------------------
    !> This function computes a 64-bit integer checksum for a 2d
    !! real(kind=real32) Fortran array.
    function ComputeChecksum2dReal(field) result(checksum)
        implicit none
        real(kind=real32), dimension(:,:) :: field

        integer :: i1,i2
        integer(kind=int32) :: int_32
        integer(kind=int64) :: checksum, int_64

        checksum = 0
        do i2=1, size(field, 2)
           do i1=1, size(field, 1)
              ! transfer leaves undefined bits in a 64-bit target
              ! so we transfer to 32-bits and then assign to 64-bit
              int_32 = transfer(field(i1,i2), int_32)
              int_64 = int_32
              checksum = checksum + int_64
           enddo
        enddo
    end function ComputeChecksum2dReal

   
    ! =========================================================================
    ! Implementation for all real(kind=real64) types
    ! =========================================================================
    ! -------------------------------------------------------------------------
    !> This subroutine either computes a checksum or compares a checksum
    !! (depending on this%verify_checksums) for a single Double.
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarDouble(this, name, value)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), intent(in)     :: value

        real(kind=real64)            :: orig_value
        integer(kind=int64) :: checksum, int_64


        if (.not. is_enabled) return

        checksum = transfer(value, int_64)

        if (this%verify_checksums) then
            if (checksum /= this%checksums(this%next_var_index)) then
                write(stderr,*) "------------- PSyData -------------------------"
                write(stderr,*) "real(kind=real64) variable ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                ! We can recreate the original value which is stored as
                ! 64-bit integer as the checksum:
                orig_value = transfer(this%checksums(this%next_var_index), orig_value)
                write(stderr,*) "Original value: ", orig_value
                write(stderr,*) "New value:      ", value
                write(stderr,*) "------------- PSyData -------------------------"
            else if(this%verbosity>1) then
                write(stderr,*) "PSYDATA: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = checksum
        endif
        call this%PSyDataBaseType%ProvideScalarDouble(name, value)
    end subroutine ProvideScalarDouble

    ! -------------------------------------------------------------------------
    !> This subroutine either computes a checksum or compares a checksum
    !! (depending on this%verify_checksums) for a 2d-array of integer
    !! @param[inout] this The instance of the ReadOnlyBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dDouble(this, name, value)
        implicit none
        class(ReadOnlyBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), dimension(:,:), intent(in) :: value
        integer(kind=int64) :: checksum
        integer :: i, j

        if (.not. is_enabled) return

        checksum = ComputeChecksum(value)
        if (this%verify_checksums) then
            if (checksum /= this%checksums(this%next_var_index)) then
                write(stderr,*) "------------- PSyData -------------------------"
                write(stderr,*) "2d Double array ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                write(stderr,*) "Original checksum: ", this%checksums(this%next_var_index)
                write(stderr,*) "New checksum:      ", checksum
                write(stderr,*) "------------- PSyData -------------------------"
            else if(this%verbosity>1) then
                write(stderr,*) "PSYDATA: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = checksum
        endif
        call this%PSyDataBaseType%ProvideArray2dDouble(name, value)
    end subroutine ProvideArray2dDouble


    ! -------------------------------------------------------------------------
    !> This function computes a 64-bit integer checksum for a 2d
    !! real(kind=real64) Fortran array.
    function ComputeChecksum2dDouble(field) result(checksum)
        implicit none
        real(kind=real64), dimension(:,:) :: field

        integer :: i1,i2
        integer(kind=int64) :: checksum, int_64

        checksum = 0
        do i2=1, size(field, 2)
           do i1=1, size(field, 1)
              int_64 = transfer(field(i1,i2), checksum)
              checksum = checksum + int_64
           enddo
        enddo
    end function ComputeChecksum2dDouble

      
    ! -------------------------------------------------------------------------
    
end module read_only_base_mod

  MODULE gw_mixed_schur_preconditioner_alg_mod_psy
    USE constants_mod, ONLY: r_def, i_def
    USE field_mod, ONLY: field_type, field_proxy_type
    USE operator_mod, ONLY: operator_type, operator_proxy_type
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(ones, m_lumped, mb, self_mb_lumped_inv)
      USE matrix_vector_kernel_0_mod, ONLY: matrix_vector_kernel_0_code
      USE mesh_mod, ONLY: mesh_type
      TYPE(field_type), intent(in) :: ones, m_lumped, self_mb_lumped_inv
      TYPE(operator_type), intent(in) :: mb
      INTEGER(KIND=i_def) cell
      INTEGER df
      INTEGER(KIND=i_def) loop3_start, loop3_stop
      INTEGER(KIND=i_def) loop2_start, loop2_stop
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      INTEGER(KIND=i_def) nlayers
      TYPE(operator_proxy_type) mb_proxy
      TYPE(field_proxy_type) ones_proxy, m_lumped_proxy, self_mb_lumped_inv_proxy
      INTEGER(KIND=i_def), pointer :: map_aspc1_m_lumped(:,:) => null(), map_aspc2_ones(:,:) => null()
      INTEGER(KIND=i_def) ndf_aspc1_ones, undf_aspc1_ones, ndf_aspc1_m_lumped, undf_aspc1_m_lumped, ndf_aspc2_ones, &
&undf_aspc2_ones, ndf_aspc1_self_mb_lumped_inv, undf_aspc1_self_mb_lumped_inv
      INTEGER(KIND=i_def) max_halo_depth_mesh
      TYPE(mesh_type), pointer :: mesh => null()
      !
      ! Initialise field and/or operator proxies
      !
      ones_proxy = ones%get_proxy()
      m_lumped_proxy = m_lumped%get_proxy()
      mb_proxy = mb%get_proxy()
      self_mb_lumped_inv_proxy = self_mb_lumped_inv%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = ones_proxy%vspace%get_nlayers()
      !
      ! Create a mesh object
      !
      mesh => ones_proxy%vspace%get_mesh()
      max_halo_depth_mesh = mesh%get_halo_depth()
      !
      ! Look-up dofmaps for each function space
      !
      map_aspc1_m_lumped => m_lumped_proxy%vspace%get_whole_dofmap()
      map_aspc2_ones => ones_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for aspc1_ones
      !
      ndf_aspc1_ones = ones_proxy%vspace%get_ndf()
      undf_aspc1_ones = ones_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_m_lumped
      !
      ndf_aspc1_m_lumped = m_lumped_proxy%vspace%get_ndf()
      undf_aspc1_m_lumped = m_lumped_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc2_ones
      !
      ndf_aspc2_ones = ones_proxy%vspace%get_ndf()
      undf_aspc2_ones = ones_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_self_mb_lumped_inv
      !
      ndf_aspc1_self_mb_lumped_inv = self_mb_lumped_inv_proxy%vspace%get_ndf()
      undf_aspc1_self_mb_lumped_inv = self_mb_lumped_inv_proxy%vspace%get_undf()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = ones_proxy%vspace%get_last_dof_owned()
      loop1_start = 1
      loop1_stop = m_lumped_proxy%vspace%get_last_dof_owned()
      loop2_start = 1
      loop2_stop = mesh%get_last_halo_cell(1)
      loop3_start = 1
      loop3_stop = self_mb_lumped_inv_proxy%vspace%get_last_dof_owned()
      !
      ! Call kernels and communication routines
      !
      DO df=loop0_start,loop0_stop
        ones_proxy%data(df) = 1.0_r_def
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL ones_proxy%set_dirty()
      !
      DO df=loop1_start,loop1_stop
        m_lumped_proxy%data(df) = 0.0_r_def
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL m_lumped_proxy%set_dirty()
      !
      CALL m_lumped_proxy%halo_exchange(depth=1)
      !
      CALL ones_proxy%halo_exchange(depth=1)
      !
      DO cell=loop2_start,loop2_stop
        !
        CALL matrix_vector_kernel_0_code(cell, nlayers, m_lumped_proxy%data, ones_proxy%data, mb_proxy%ncell_3d, &
&mb_proxy%local_stencil, ndf_aspc1_m_lumped, undf_aspc1_m_lumped, map_aspc1_m_lumped(:,cell), ndf_aspc2_ones, undf_aspc2_ones, &
&map_aspc2_ones(:,cell))
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL m_lumped_proxy%set_dirty()
      !
      DO df=loop3_start,loop3_stop
        self_mb_lumped_inv_proxy%data(df) = ones_proxy%data(df) / m_lumped_proxy%data(df)
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_mb_lumped_inv_proxy%set_dirty()
      !
      !
    END SUBROUTINE invoke_0
    SUBROUTINE invoke_1(self_mb_rb, rhs0_vector, self_mb_lumped_inv, self_rhs_u, self_q, const1, rhs0_vector_1)
      USE matrix_vector_kernel_1_mod, ONLY: matrix_vector_kernel_1_code
      USE mesh_mod, ONLY: mesh_type
      REAL(KIND=r_def), intent(in) :: const1
      TYPE(field_type), intent(in) :: self_mb_rb, rhs0_vector, self_mb_lumped_inv, self_rhs_u, rhs0_vector_1
      TYPE(operator_type), intent(in) :: self_q
      INTEGER(KIND=i_def) cell
      INTEGER df
      INTEGER(KIND=i_def) loop3_start, loop3_stop
      INTEGER(KIND=i_def) loop2_start, loop2_stop
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      INTEGER(KIND=i_def) nlayers
      TYPE(operator_proxy_type) self_q_proxy
      TYPE(field_proxy_type) self_mb_rb_proxy, rhs0_vector_proxy, self_mb_lumped_inv_proxy, self_rhs_u_proxy, rhs0_vector_1_proxy
      INTEGER(KIND=i_def), pointer :: map_aspc1_self_rhs_u(:,:) => null(), map_aspc2_self_mb_rb(:,:) => null()
      INTEGER(KIND=i_def) ndf_aspc1_self_mb_rb, undf_aspc1_self_mb_rb, ndf_aspc1_self_rhs_u, undf_aspc1_self_rhs_u, &
&ndf_aspc2_self_mb_rb, undf_aspc2_self_mb_rb
      INTEGER(KIND=i_def) max_halo_depth_mesh
      TYPE(mesh_type), pointer :: mesh => null()
      !
      ! Initialise field and/or operator proxies
      !
      self_mb_rb_proxy = self_mb_rb%get_proxy()
      rhs0_vector_proxy = rhs0_vector%get_proxy()
      self_mb_lumped_inv_proxy = self_mb_lumped_inv%get_proxy()
      self_rhs_u_proxy = self_rhs_u%get_proxy()
      self_q_proxy = self_q%get_proxy()
      rhs0_vector_1_proxy = rhs0_vector_1%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = self_mb_rb_proxy%vspace%get_nlayers()
      !
      ! Create a mesh object
      !
      mesh => self_mb_rb_proxy%vspace%get_mesh()
      max_halo_depth_mesh = mesh%get_halo_depth()
      !
      ! Look-up dofmaps for each function space
      !
      map_aspc1_self_rhs_u => self_rhs_u_proxy%vspace%get_whole_dofmap()
      map_aspc2_self_mb_rb => self_mb_rb_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for aspc1_self_mb_rb
      !
      ndf_aspc1_self_mb_rb = self_mb_rb_proxy%vspace%get_ndf()
      undf_aspc1_self_mb_rb = self_mb_rb_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_self_rhs_u
      !
      ndf_aspc1_self_rhs_u = self_rhs_u_proxy%vspace%get_ndf()
      undf_aspc1_self_rhs_u = self_rhs_u_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc2_self_mb_rb
      !
      ndf_aspc2_self_mb_rb = self_mb_rb_proxy%vspace%get_ndf()
      undf_aspc2_self_mb_rb = self_mb_rb_proxy%vspace%get_undf()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = self_mb_rb_proxy%vspace%get_last_dof_owned()
      loop1_start = 1
      loop1_stop = self_rhs_u_proxy%vspace%get_last_dof_owned()
      loop2_start = 1
      loop2_stop = mesh%get_last_halo_cell(1)
      loop3_start = 1
      loop3_stop = self_rhs_u_proxy%vspace%get_last_dof_owned()
      !
      ! Call kernels and communication routines
      !
      DO df=loop0_start,loop0_stop
        self_mb_rb_proxy%data(df) = rhs0_vector_proxy%data(df) * self_mb_lumped_inv_proxy%data(df)
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_mb_rb_proxy%set_dirty()
      !
      DO df=loop1_start,loop1_stop
        self_rhs_u_proxy%data(df) = 0.0_r_def
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_rhs_u_proxy%set_dirty()
      !
      CALL self_rhs_u_proxy%halo_exchange(depth=1)
      !
      CALL self_mb_rb_proxy%halo_exchange(depth=1)
      !
      DO cell=loop2_start,loop2_stop
        !
        CALL matrix_vector_kernel_1_code(cell, nlayers, self_rhs_u_proxy%data, self_mb_rb_proxy%data, self_q_proxy%ncell_3d, &
&self_q_proxy%local_stencil, ndf_aspc1_self_rhs_u, undf_aspc1_self_rhs_u, map_aspc1_self_rhs_u(:,cell), ndf_aspc2_self_mb_rb, &
&undf_aspc2_self_mb_rb, map_aspc2_self_mb_rb(:,cell))
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_rhs_u_proxy%set_dirty()
      !
      DO df=loop3_start,loop3_stop
        self_rhs_u_proxy%data(df) = const1 * self_rhs_u_proxy%data(df) + rhs0_vector_1_proxy%data(df)
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_rhs_u_proxy%set_dirty()
      !
      !
    END SUBROUTINE invoke_1
    SUBROUTINE invoke_2(self_hb_ru, self_rhs_u, self_hb_lumped_inv, self_rhs_p_tmp, div, self_rhs_p, m3_inv, const2, rhs0_vector)
      USE dg_matrix_vector_kernel_1_mod, ONLY: dg_matrix_vector_kernel_1_code
      USE dg_matrix_vector_kernel_0_mod, ONLY: dg_matrix_vector_kernel_0_code
      USE mesh_mod, ONLY: mesh_type
      REAL(KIND=r_def), intent(in) :: const2
      TYPE(field_type), intent(in) :: self_hb_ru, self_rhs_u, self_hb_lumped_inv, self_rhs_p_tmp, self_rhs_p, rhs0_vector
      TYPE(operator_type), intent(in) :: div, m3_inv
      INTEGER(KIND=i_def) cell
      INTEGER df
      INTEGER(KIND=i_def) loop3_start, loop3_stop
      INTEGER(KIND=i_def) loop2_start, loop2_stop
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      INTEGER(KIND=i_def) nlayers
      TYPE(operator_proxy_type) div_proxy, m3_inv_proxy
      TYPE(field_proxy_type) self_hb_ru_proxy, self_rhs_u_proxy, self_hb_lumped_inv_proxy, self_rhs_p_tmp_proxy, self_rhs_p_proxy, &
&rhs0_vector_proxy
      INTEGER(KIND=i_def), pointer :: map_adspc1_self_rhs_p(:,:) => null(), map_adspc1_self_rhs_p_tmp(:,:) => null(), &
&map_aspc1_self_hb_ru(:,:) => null(), map_aspc1_self_rhs_p_tmp(:,:) => null()
      INTEGER(KIND=i_def) ndf_aspc1_self_hb_ru, undf_aspc1_self_hb_ru, ndf_adspc1_self_rhs_p_tmp, undf_adspc1_self_rhs_p_tmp, &
&ndf_adspc1_self_rhs_p, undf_adspc1_self_rhs_p, ndf_aspc1_self_rhs_p_tmp, undf_aspc1_self_rhs_p_tmp, ndf_aspc1_self_rhs_p, &
&undf_aspc1_self_rhs_p
      INTEGER(KIND=i_def) max_halo_depth_mesh
      TYPE(mesh_type), pointer :: mesh => null()
      !
      ! Initialise field and/or operator proxies
      !
      self_hb_ru_proxy = self_hb_ru%get_proxy()
      self_rhs_u_proxy = self_rhs_u%get_proxy()
      self_hb_lumped_inv_proxy = self_hb_lumped_inv%get_proxy()
      self_rhs_p_tmp_proxy = self_rhs_p_tmp%get_proxy()
      div_proxy = div%get_proxy()
      self_rhs_p_proxy = self_rhs_p%get_proxy()
      m3_inv_proxy = m3_inv%get_proxy()
      rhs0_vector_proxy = rhs0_vector%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = self_hb_ru_proxy%vspace%get_nlayers()
      !
      ! Create a mesh object
      !
      mesh => self_hb_ru_proxy%vspace%get_mesh()
      max_halo_depth_mesh = mesh%get_halo_depth()
      !
      ! Look-up dofmaps for each function space
      !
      map_adspc1_self_rhs_p_tmp => self_rhs_p_tmp_proxy%vspace%get_whole_dofmap()
      map_aspc1_self_hb_ru => self_hb_ru_proxy%vspace%get_whole_dofmap()
      map_adspc1_self_rhs_p => self_rhs_p_proxy%vspace%get_whole_dofmap()
      map_aspc1_self_rhs_p_tmp => self_rhs_p_tmp_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for aspc1_self_hb_ru
      !
      ndf_aspc1_self_hb_ru = self_hb_ru_proxy%vspace%get_ndf()
      undf_aspc1_self_hb_ru = self_hb_ru_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for adspc1_self_rhs_p_tmp
      !
      ndf_adspc1_self_rhs_p_tmp = self_rhs_p_tmp_proxy%vspace%get_ndf()
      undf_adspc1_self_rhs_p_tmp = self_rhs_p_tmp_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for adspc1_self_rhs_p
      !
      ndf_adspc1_self_rhs_p = self_rhs_p_proxy%vspace%get_ndf()
      undf_adspc1_self_rhs_p = self_rhs_p_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_self_rhs_p_tmp
      !
      ndf_aspc1_self_rhs_p_tmp = self_rhs_p_tmp_proxy%vspace%get_ndf()
      undf_aspc1_self_rhs_p_tmp = self_rhs_p_tmp_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_self_rhs_p
      !
      ndf_aspc1_self_rhs_p = self_rhs_p_proxy%vspace%get_ndf()
      undf_aspc1_self_rhs_p = self_rhs_p_proxy%vspace%get_undf()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = self_hb_ru_proxy%vspace%get_last_dof_owned()
      loop1_start = 1
      loop1_stop = mesh%get_last_edge_cell()
      loop2_start = 1
      loop2_stop = mesh%get_last_edge_cell()
      loop3_start = 1
      loop3_stop = self_rhs_p_proxy%vspace%get_last_dof_owned()
      !
      ! Call kernels and communication routines
      !
      DO df=loop0_start,loop0_stop
        self_hb_ru_proxy%data(df) = self_rhs_u_proxy%data(df) * self_hb_lumped_inv_proxy%data(df)
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_hb_ru_proxy%set_dirty()
      !
      CALL self_hb_ru_proxy%halo_exchange(depth=1)
      !
      DO cell=loop1_start,loop1_stop
        !
        CALL dg_matrix_vector_kernel_0_code(cell, nlayers, self_rhs_p_tmp_proxy%data, self_hb_ru_proxy%data, div_proxy%ncell_3d, &
&div_proxy%local_stencil, ndf_adspc1_self_rhs_p_tmp, undf_adspc1_self_rhs_p_tmp, map_adspc1_self_rhs_p_tmp(:,cell), &
&ndf_aspc1_self_hb_ru, undf_aspc1_self_hb_ru, map_aspc1_self_hb_ru(:,cell))
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_rhs_p_tmp_proxy%set_dirty()
      !
      CALL self_rhs_p_tmp_proxy%halo_exchange(depth=1)
      !
      DO cell=loop2_start,loop2_stop
        !
        CALL dg_matrix_vector_kernel_1_code(cell, nlayers, self_rhs_p_proxy%data, self_rhs_p_tmp_proxy%data, &
&m3_inv_proxy%ncell_3d, m3_inv_proxy%local_stencil, ndf_adspc1_self_rhs_p, undf_adspc1_self_rhs_p, map_adspc1_self_rhs_p(:,cell), &
&ndf_aspc1_self_rhs_p_tmp, undf_aspc1_self_rhs_p_tmp, map_aspc1_self_rhs_p_tmp(:,cell))
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_rhs_p_proxy%set_dirty()
      !
      DO df=loop3_start,loop3_stop
        self_rhs_p_proxy%data(df) = const2 * self_rhs_p_proxy%data(df) + rhs0_vector_proxy%data(df)
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL self_rhs_p_proxy%set_dirty()
      !
      !
    END SUBROUTINE invoke_2
  END MODULE gw_mixed_schur_preconditioner_alg_mod_psy

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2019, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author R. W. Ford, STFC Daresbury Lab

! Illustration of copying one field to another with some form of
! staggering. This is a Fortran implementation of the Dawn Python
! example.
program copy_stencil
  implicit none
  integer, parameter :: n=10
  integer :: i,j,k
  real, dimension(n+1,n,n) :: out,in
  do k=1,n
     do j=1,n
        do i=1,n
           out(i,j,k) = in(i+1,j,k)
        end do
     end do
  end do
end program copy_stencil

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2022, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office
!
!> @brief Kernel which (incrementally) applies a columnwise assembled operator
!!        to a field.
module columnwise_op_app_kernel_mod

use kernel_mod,              only : kernel_type
use argument_mod,            only : arg_type, func_type,                    &
                                    GH_FIELD, GH_COLUMNWISE_OPERATOR,       &
                                    GH_REAL, GH_READ, GH_INC,               &
                                    ANY_SPACE_1, ANY_SPACE_2,               &
                                    CELL_COLUMN

use constants_mod,           only : r_def, r_solver, i_def

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------

type, public, extends(kernel_type) :: columnwise_op_app_kernel_type
  private
  type(arg_type) :: meta_args(3) = (/                                               &
       arg_type(GH_FIELD,               GH_REAL, GH_INC,  ANY_SPACE_1),             &
       arg_type(GH_FIELD,               GH_REAL, GH_READ, ANY_SPACE_2),             &
       arg_type(GH_COLUMNWISE_OPERATOR, GH_REAL, GH_READ, ANY_SPACE_1, ANY_SPACE_2) &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: columnwise_op_app_kernel_code
end type columnwise_op_app_kernel_type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public columnwise_op_app_kernel_code

contains

  !> @brief The subroutine which is called directly from the PSy layer and
  !!        applies the operator as lhs += A.x.
  !>
  !> @param [in] cell Horizontal cell index
  !> @param [in] ncell_2d Number of cells in 2D grid
  !> @param [in,out] lhs Resulting field lhs += A.x
  !> @param [in] x Input field
  !> @param [in] columnwise_matrix Banded matrix to assemble into
  !> @param [in] nrow Number of rows in the banded matrix
  !> @param [in] ncol Number of columns in the banded matrix
  !> @param [in] bandwidth Bandwidth of the banded matrix
  !> @param [in] alpha Banded matrix parameter \f$\alpha\f$
  !> @param [in] beta Banded matrix parameter \f$\beta\f$
  !> @param [in] gamma_m Banded matrix parameter \f$\gamma_-\f$
  !> @param [in] gamma_p Banded matrix parameter \f$\gamma_+\f$
  !> @param [in] ndf1 Number of degrees of freedom per cell for the to-space
  !> @param [in] undf1 Unique number of degrees of freedom  for the to-space
  !> @param [in] map1 Dofmap for the to-space
  !> @param [in] indirection_dofmap_to Indirection map for to-space
  !> @param [in] ndf2 Number of degrees of freedom per cell for the from-space
  !> @param [in] undf2 Unique number of degrees of freedom for the from-space
  !> @param [in] map2 Dofmap for the from-space
  !> @param [in] indirection_dofmap_from Indirection map for from-space
  subroutine columnwise_op_app_kernel_code(cell,                  &
                                           ncell_2d,              &
                                           lhs, x,                &
                                           columnwise_matrix,     &
                                           nrow,                  &
                                           ncol,                  &
                                           bandwidth,             &
                                           alpha,                 &
                                           beta,                  &
                                           gamma_m,               &
                                           gamma_p,               &
                                           ndf1, undf1, map1,     &
                                           indirection_dofmap_to, &
                                           ndf2, undf2, map2,     &
                                           indirection_dofmap_from)

    implicit none

    ! Arguments
    integer(kind=i_def), intent(in) :: cell,  ncell_2d
    integer(kind=i_def), intent(in) :: nrow, ncol, bandwidth
    integer(kind=i_def), intent(in) :: undf1, ndf1
    integer(kind=i_def), intent(in) :: undf2, ndf2
    real(kind=r_def), dimension(undf1), intent(inout) :: lhs
    real(kind=r_def), dimension(undf2), intent(in) :: x
    real(kind=r_solver), dimension(bandwidth,nrow,ncell_2d), intent(in) :: columnwise_matrix
    integer(kind=i_def), dimension(ndf1), intent(in) :: map1
    integer(kind=i_def), dimension(ndf2), intent(in) :: map2

    integer(kind=i_def), intent(in) :: alpha, beta, gamma_m, gamma_p
    integer(kind=i_def), dimension(nrow), intent(in) :: indirection_dofmap_to
    integer(kind=i_def), dimension(ncol), intent(in) :: indirection_dofmap_from

    ! Internal parameters
    ! Row and column index index
    integer(kind=i_def) :: i,j, mu_i, mu_j
    ! Smallest/largest index in a particular row
    integer(kind=i_def) :: j_minus, j_plus

    do i = 1, nrow
       ! Assumes that the first entry in the dofmaps is the smallest
       mu_i = map1(1) + indirection_dofmap_to(i) - 1
       j_minus = ceiling((alpha*i-gamma_p)/(1.0_r_solver*beta), i_def)
       j_plus = floor((alpha*i+gamma_m)/(1.0_r_solver*beta), i_def)
       do j = MAX(1,j_minus), MIN(ncol,j_plus)
          mu_j = map2(1) + indirection_dofmap_from(j) - 1
          lhs(mu_i) = lhs(mu_i) &
                    + real(columnwise_matrix(j-j_minus+1,i,cell), r_def) * x(mu_j)
       end do
    end do

  end subroutine columnwise_op_app_kernel_code

end module columnwise_op_app_kernel_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!------------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office

!> @brief Calculates the coefficients, a0,a1,a2, for 1D subgrid
!>        representation of rho, rho(x) = a0 + a1*x+a2*x**2 with 0<x<1,
!>        here x simply represents a local coordinate within a cell in either
!>        the chi1, chi2, or chi3 directions.

!> @detail The kernel computes the coefficients a0,a1,a2 where rho is represented in 1D
!>         by the approximation rho(x) = a0+a1*x+a2*x**2
!>         Various cases for calculating a0,a1 and a2 are available, including
!>         constant,linear and quadratic subgrid representations of rho.
!>         For linear representation there are several options. If no slope limiter is
!>         required then centered difference is used to estimate the slope.
!>         Slope limiters which are currently available are minmod and superbee.
!>         These slope limiters are extensively covered in the literature on slope limiters
!>         and have good performance.
!>         For quadratic representation of rho PPM is used and the options of
!>         positivity and monotonicity are available
!>
!>         Note that this kernel only works when rho is a W3 field at lowest order
!>         since it is assumed that ndf_w3 = 1 with stencil_map(1,:) containing
!>         the relevant dofmaps.
module subgrid_coeffs_kernel_mod

use argument_mod,       only : arg_type,          &
                               GH_FIELD, GH_REAL, &
                               GH_READ, GH_WRITE, &
                               STENCIL, CROSS, CELL_COLUMN
use fs_continuity_mod,  only : W3
use constants_mod,      only : r_def, i_def, l_def
use subgrid_config_mod, only : subgrid_rho_approximation_constant_subgrid,     &
                               subgrid_rho_approximation_constant_positive,    &
                               subgrid_rho_approximation_linear_centered_diff, &
                               subgrid_rho_approximation_linear_superbee,      &
                               subgrid_rho_approximation_linear_minmod,        &
                               subgrid_rho_approximation_ppm_no_limiter,       &
                               subgrid_rho_approximation_ppm_positive_only,    &
                               subgrid_rho_approximation_ppm_positive_monotone,&
                               rho_stencil_length
use kernel_mod,         only : kernel_type

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------
!> The type declaration for the kernel. Contains the metadata needed by the Psy layer
type, public, extends(kernel_type) :: subgrid_coeffs_kernel_type
  private
  type(arg_type) :: meta_args(4) = (/                                  &
       arg_type(GH_FIELD, GH_REAL, GH_WRITE, W3),                      &
       arg_type(GH_FIELD, GH_REAL, GH_WRITE, W3),                      &
       arg_type(GH_FIELD, GH_REAL, GH_WRITE, W3),                      &
       arg_type(GH_FIELD, GH_REAL, GH_READ,  W3, STENCIL(CROSS))       &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: subgrid_coeffs_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public subgrid_coeffs_code

contains

!> @brief Compute the subgrid reconstruction coeffiecients for a density field
!! @param[in] nlayers Number of layers
!! @param[out] a0 Coefficient a0
!! @param[out] a1 Coefficient a1
!! @param[out] a2 Coefficient a2
!! @param[in] rho Density
!! @param[in] stencil_length Local length of a stencil (5 for PPM)
!! @param[in] stencil_map Dofmap for the stencil
!! @param[in] ndf_w3 Number of degrees of freedom for W3 per cell
!! @param[in] undf_w3 Number of unique degrees of freedom for W3
!! @param[in] map_w3 Dofmap for the cell at the base of the column for W3
subroutine subgrid_coeffs_code(                                               &
                                nlayers,                                      &
                                a0,                                           &
                                a1,                                           &
                                a2,                                           &
                                rho,                                          &
                                stencil_length,                               &
                                stencil_map,                                  &
                                ndf_w3,                                       &
                                undf_w3,                                      &
                                map_w3                                        &
                                )

  use subgrid_rho_mod, only: return_ppm_output, minmod_function, maxmod_function, subgridrho_option


  implicit none

  ! Arguments
  integer(kind=i_def), intent(in) :: nlayers
  integer(kind=i_def), intent(in) :: undf_w3
  real(kind=r_def), intent(in)    :: rho(undf_w3)
  integer(kind=i_def), intent(in) :: ndf_w3
  integer(kind=i_def), intent(in) :: stencil_length
  integer(kind=i_def), intent(in) :: stencil_map(1:ndf_w3,1:stencil_length)
  integer(kind=i_def), intent(in) :: w3_map()
  real(kind=r_def), intent(inout) :: a0(undf_w3)
  real(kind=r_def), intent(inout) :: a1(undf_w3)
  real(kind=r_def), intent(inout) :: a2(undf_w3)

  real(kind=r_def)               :: sigma1,sigma2
  real(kind=r_def)               :: coeffs(1:3)

  integer(kind=i_def) :: k

  logical(kind=l_def) :: positive, monotone

  do k=0,nlayers-1

    select case(subgridrho_option)
      case (subgrid_rho_approximation_constant_subgrid)
        a0(stencil_map(1,1)) = rho(stencil_map(1,1))
        a1(stencil_map(1,1)) = 0.0_r_def
        a2(stencil_map(1,1)) = 0.0_r_def

      case (subgrid_rho_approximation_constant_positive)
        a0(stencil_map(1,1)) = max(rho(stencil_map(1,1)),0.0_r_def)
        a1(stencil_map(1,1)) = 0.0_r_def
        a2(stencil_map(1,1)) = 0.0_r_def

      case (subgrid_rho_approximation_linear_centered_diff)
        a1(stencil_map(1,1)) = (rho(stencil_map(1,3))-rho(stencil_map(1,2)))/2.0_r_def
        a0(stencil_map(1,1)) = rho(stencil_map(1,1))-a1(stencil_map(1,1))*0.5_r_def
        a2(stencil_map(1,1)) = 0.0_r_def

      case (subgrid_rho_approximation_linear_superbee)
        sigma1 = minmod_function(                                             &
                      rho(stencil_map(1,3))-rho(stencil_map(1,1)),            &
                      2.0_r_def*(rho(stencil_map(1,1))-rho(stencil_map(1,2))) &
                                )
        sigma2 = minmod_function(                                             &
                      2.0_r_def*(rho(stencil_map(1,3))-rho(stencil_map(1,1))),&
                      rho(stencil_map(1,1))-rho(stencil_map(1,2)) )

        a1(stencil_map(1,1)) = maxmod_function( sigma1, sigma2)
        a0(stencil_map(1,1)) = rho(stencil_map(1,1))-a1(stencil_map(1,1))*0.5_r_def
        a2(stencil_map(1,1)) = 0.0_r_def

      case (subgrid_rho_approximation_linear_minmod)
        a1(stencil_map(1,1)) = minmod_function(                               &
                                rho(stencil_map(1,1))-rho(stencil_map(1,2)) , &
                                rho(stencil_map(1,3))-rho(stencil_map(1,1)) )
        a0(stencil_map(1,1)) = rho(stencil_map(1,1))-a1(stencil_map(1,1))*0.5_r_def
        a2(stencil_map(1,1)) = 0.0_r_def

      case (subgrid_rho_approximation_ppm_no_limiter)
        positive=.false.
        monotone=.false.
        call return_ppm_output(rho(stencil_map(1,1:5)),coeffs,positive,monotone)
        a0(stencil_map(1,1)) = coeffs(1)
        a1(stencil_map(1,1)) = coeffs(2)
        a2(stencil_map(1,1)) = coeffs(3)

      case (subgrid_rho_approximation_ppm_positive_only, &
            subgrid_rho_approximation_ppm_positive_monotone)
        positive=.true.
        monotone=.false.
        if ( subgridrho_option == subgrid_rho_approximation_ppm_positive_monotone) monotone=.true.
        call return_ppm_output(rho(stencil_map(1,1:5)),coeffs,positive,monotone)
        a0(stencil_map(1,1)) = coeffs(1)
        a1(stencil_map(1,1)) = coeffs(2)
        a2(stencil_map(1,1)) = coeffs(3)

    end select

  end do

end subroutine subgrid_coeffs_code

end module subgrid_coeffs_kernel_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2018-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office
!
!> @brief The kernel computes the rhs of the thermodynamic equation for the nonlinear
!>        equations for horizontally discontinuous temperature basis functions,
!>        this consists of the term theta*gamma*div(u) + theta u*grad(gamma)
!> @details Kernel to  compute the rhs of thermodynamic equation for the nonlinear
!>          equations, in the absense of source terms this is
!>          rtheta = -(theta*gamma*div(u) + theta u*grad(gamma))
module rtheta_wtheta_kernel_mod

use kernel_mod,              only : kernel_type
use argument_mod,            only : arg_type, func_type,     &
                                    GH_FIELD, GH_REAL,       &
                                    GH_READ, GH_READWRITE,   &
                                    GH_BASIS, GH_DIFF_BASIS, &
                                    CELL_COLUMN, GH_QUADRATURE_XYoZ
use fs_continuity_mod,       only : W2, Wtheta
use constants_mod,           only : r_def, i_def

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------
!> The type declaration for the kernel. Contains the metadata needed by the Psy layer
type, public, extends(kernel_type) :: rtheta_wtheta_kernel_type
  private
  type(arg_type) :: meta_args(3) = (/                                  &
       arg_type(GH_FIELD, GH_REAL, GH_READWRITE, Wtheta),              &
       arg_type(GH_FIELD, GH_REAL, GH_READ,      Wtheta),              &
       arg_type(GH_FIELD, GH_REAL, GH_READ,      W2)                   &
       /)
  type(func_type) :: meta_funcs(2) = (/                                &
       func_type(Wtheta, GH_BASIS, GH_DIFF_BASIS),                     &
       func_type(W2, GH_BASIS, GH_DIFF_BASIS)                          &
       /)
  integer :: operates_on = CELL_COLUMN
  integer :: gh_shape = GH_QUADRATURE_XYoZ
contains
  procedure, nopass :: rtheta_wtheta_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public rtheta_wtheta_code

contains

!> @brief Compute right hand side of the thermodynamic equation
!! @param[in] nlayers Number of layers
!! @param[in,out] r_theta Right hand side of the thermodynamic equation
!! @param[in] theta Potential temperature
!! @param[in] u Velocity
!! @param[in] ndf_w2 Number of degrees of freedom per cell for w2
!! @param[in] undf_w2  Number of unique degrees of freedom  for w2
!! @param[in] map_w2 Dofmap for the cell at the base of the column for w2
!! @param[in] w2_basis Basis functions evaluated at gaussian quadrature points
!! @param[in] w2_diff_basis Differential basis functions evaluated at gaussian quadrature points
!! @param[in] ndf_wtheta Number of degrees of freedom per cell for wtheta
!! @param[in] undf_wtheta Number of unique degrees of freedom for wtheta
!! @param[in] map_wtheta Dofmap for the cell at the base of the column for wtheta
!! @param[in] wtheta_basis Basis functions evaluated at gaussian quadrature points
!! @param[in] wtheta_diff_basis Differential basis functions evaluated at gaussian quadrature points
!! @param[in] nqp_h Number of horizontal quadrature points
!! @param[in] nqp_v Number of vertical quadrature points
!! @param[in] wqp_h Weights of the horizontal quadrature points
!! @param[in] wqp_v Weights of the vertical quadrature points

subroutine rtheta_wtheta_code(nlayers,                                                        &
                       r_theta, theta, u,                                                     &
                       ndf_wtheta, undf_wtheta, map_wtheta, wtheta_basis, wtheta_diff_basis,  &
                       ndf_w2, undf_w2, map_w2, w2_basis, w2_diff_basis,                      &
                       nqp_h, nqp_v, wqp_h, wqp_v )

  implicit none

  ! Arguments
  integer(kind=i_def), intent(in) :: nlayers, nqp_h, nqp_v
  integer(kind=i_def), intent(in) :: ndf_w2, ndf_wtheta, undf_w2, undf_wtheta

  integer(kind=i_def), dimension(ndf_wtheta), intent(in) :: map_wtheta
  integer(kind=i_def), dimension(ndf_w2), intent(in) :: map_w2

  real(kind=r_def), dimension(1,ndf_wtheta,nqp_h,nqp_v), intent(in) :: wtheta_basis
  real(kind=r_def), dimension(3,ndf_wtheta,nqp_h,nqp_v), intent(in) :: wtheta_diff_basis
  real(kind=r_def), dimension(3,ndf_w2,nqp_h,nqp_v), intent(in) :: w2_basis
  real(kind=r_def), dimension(1,ndf_w2,nqp_h,nqp_v), intent(in) :: w2_diff_basis

  real(kind=r_def), dimension(undf_wtheta), intent(inout) :: r_theta
  real(kind=r_def), dimension(undf_wtheta), intent(in)    :: theta
  real(kind=r_def), dimension(undf_w2), intent(in)    :: u

  real(kind=r_def), dimension(nqp_h), intent(in)      ::  wqp_h
  real(kind=r_def), dimension(nqp_v), intent(in)      ::  wqp_v

  ! Internal variables
  integer(kind=i_def)               :: df, k
  integer(kind=i_def)               :: qp1, qp2

  real(kind=r_def), dimension(ndf_wtheta)      :: rtheta_e, theta_e
  real(kind=r_def), dimension(ndf_w2)          :: u_e
  real(kind=r_def) :: u_at_quad(3)
  real(kind=r_def) :: theta_at_quad, grad_theta_at_quad(3), div_u_at_quad
  real(kind=r_def) :: gamma_wtheta, grad_gamma_wtheta(3)

  do k = 0, nlayers-1
    ! Extract element arrays of chi
    do df = 1, ndf_wtheta
      rtheta_e(df) = 0.0_r_def
      theta_e(df)  = theta(  map_wtheta(df) + k )
    end do
    do df = 1, ndf_w2
      u_e(df) = u( map_w2(df) + k )
    end do

    ! Compute the RHS integrated over one cell
    do qp2 = 1, nqp_v
      do qp1 = 1, nqp_h
        u_at_quad(:) = 0.0_r_def
        do df = 1, ndf_w2
          u_at_quad(:)  = u_at_quad(:)  + u_e(df)*w2_basis(:,df,qp1,qp2)
        end do

        div_u_at_quad = 0.0_r_def
        do df = 1, ndf_w2
          div_u_at_quad    = div_u_at_quad + u_e(df)*w2_diff_basis(1,df,qp1,qp2)
        end do

        theta_at_quad = 0.0_r_def
        do df = 1, ndf_wtheta
          theta_at_quad   = theta_at_quad + theta_e(df)*wtheta_basis(1,df,qp1,qp2)
        end do

        grad_theta_at_quad(:) = 0.0_r_def
        do df = 1, ndf_wtheta
          grad_theta_at_quad(:) = grad_theta_at_quad(:) &
                                + theta_e(df)*wtheta_diff_basis(:,df,qp1,qp2)
        end do

        do df = 1, ndf_wtheta
          gamma_wtheta         = wtheta_basis(1, df, qp1, qp2)
          grad_gamma_wtheta(:) = wtheta_diff_basis(:, df, qp1, qp2)
          rtheta_e(df)         = rtheta_e(df) + wqp_h(qp1)*wqp_v(qp2) * theta_at_quad * &
                                   ( gamma_wtheta * div_u_at_quad + &
                                      dot_product(u_at_quad, grad_gamma_wtheta) )
        end do
      end do
    end do

    do df = 1, ndf_wtheta
      r_theta( map_wtheta(df) + k ) =  r_theta( map_wtheta(df) + k ) - rtheta_e(df)
    end do
  end do

end subroutine rtheta_wtheta_code

end module rtheta_wtheta_kernel_mod

! -----------------------------------------------------------------------------
!
! Original code Governed by the CeCILL licence (http://www.cecill.info)
!
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Code modifications Copyright (c) 2019-2020, Science and Technology Facilities
! Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author R. W. Ford, STFC Daresbury Lab

! Code extracted from the tra_adv benchmark making use of intrinsics
! MIN, ABS and SIGN. Literals have had the Fortran double precision
! specification (e.g. 1.d0) removed. This code is provided purely to
! demonstrate the removal of intrinsics via PSyclone transformations,
! it is not designed to be run.
program test_intrinsics

  integer, parameter :: jpi=10, jpj=10, jpk=10
  real, dimension(jpi,jpj,jpk) :: zwx, zwy, zslpx, zslpy
  integer :: ji, jj, jk
  
  DO jk = 1, jpk-1    
     DO jj = 2, jpj
        DO ji = 2, jpi
           zslpx(ji,jj,jk) = SIGN( 1.0, zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
           &                                                2.0*ABS( zwx  (ji-1,jj,jk) ),   &
           &                                                2.0*ABS( zwx  (ji  ,jj,jk) ) )
           zslpy(ji,jj,jk) = SIGN( 1.0, zslpy(ji,jj,jk) ) * MIN(    ABS( zslpy(ji,jj  ,jk) ),   &
           &                                                2.0*ABS( zwy  (ji,jj-1,jk) ),   &
           &                                                2.0*ABS( zwy  (ji,jj  ,jk) ) )
        END DO
     END DO
  END DO

end program test_intrinsics

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2019-20, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: A. R. Porter, STFC Daresbury Lab.

module alg

contains

  subroutine do_update(fld2)
    use field_mod, only: r2d_field
    use kern_call_kern_mod, only: kern_call_kern
    implicit none
    type(r2d_field), intent(inout) :: fld2

    ! Invoke calls kernel that itself calls a kernel defined in
    ! another module
    call invoke(kern_call_kern(fld2))

  end subroutine do_update

end module alg

!-------------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-------------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by R. W. Ford and A. R. Porter, STFC
!             I. Kavcic, Met Office
!
!-------------------------------------------------------------------------------

!> @brief Computes LHS of Galerkin projection and solves equation in W3 space.
!>
module w3_solver_kernel_mod

  use argument_mod,      only : arg_type, func_type,     &
                                GH_FIELD, CELL_COLUMN,   &
                                GH_REAL, GH_INTEGER,     &
                                GH_READ, GH_READWRITE,   &
                                GH_BASIS, GH_DIFF_BASIS, &
                                GH_QUADRATURE_XYoZ,      &
                                ANY_DISCONTINUOUS_SPACE_3
  use constants_mod,     only : r_def, i_def
  use fs_continuity_mod, only : W3, Wchi
  use kernel_mod,        only : kernel_type

  implicit none

  private

  !---------------------------------------------------------------------------
  ! Public types
  !---------------------------------------------------------------------------
  !> The type declaration for the kernel. Contains the metadata needed by the
  !> Psy layer.
  !>
  type, public, extends(kernel_type) :: w3_solver_kernel_type
    private
    type(arg_type) :: meta_args(4) = (/                                           &
        ! TODO: This access should be GH_WRITE (to be corrected in issue #1003)
        arg_type(GH_FIELD,   GH_REAL,    GH_READWRITE, W3),                       &
        arg_type(GH_FIELD,   GH_REAL,    GH_READ,      W3),                       &
        arg_type(GH_FIELD*3, GH_REAL,    GH_READ,      Wchi),                     &
        arg_type(GH_FIELD,   GH_INTEGER, GH_READ,      ANY_DISCONTINUOUS_SPACE_3) &
        /)
    type(func_type) :: meta_funcs(2) = (/                                         &
        func_type(W3,   GH_BASIS),                                                &
        func_type(Wchi, GH_BASIS, GH_DIFF_BASIS)                                  &
        /)
    integer :: operates_on = CELL_COLUMN
    integer :: gh_shape = GH_QUADRATURE_XYoZ
  contains
    procedure, nopass :: solver_w3_code
  end type

  !---------------------------------------------------------------------------
  ! Contained functions/subroutines
  !---------------------------------------------------------------------------
  public solver_w3_code

contains

!> @brief Invert and apply the W3 mass matrix
!! @param[in] nlayers Number of layers
!! @param[in,out] x Output vector
!! @param[in] rhs Input vector
!! @param[in] chi_1 1st (spherical) coordinate field in Wchi
!! @param[in] chi_2 2nd (spherical) coordinate field in Wchi
!! @param[in] chi_3 3rd (spherical) coordinate field in Wchi
!! @param[in] panel_id Field giving the ID for mesh panels
!! @param[in] ndf_w3 Number of degrees of freedom per cell for W3
!! @param[in] undf_w3 Total number of degrees of freedom for W3
!! @param[in] map_w3 Dofmap for the cell at the base of the column for W3
!! @param[in] w3_basis Basis functions evaluated at gaussian quadrature points
!! @param[in] ndf_wchi Number of degrees of freedom per cell for Wchi
!! @param[in] undf_wchi Total number of degrees of freedom for Wchi
!! @param[in] map_wchi Dofmap for the cell at the base of the column for Wchi
!! @param[in] chi_basis Wchi basis functions evaluated at gaussian quadrature points
!! @param[in] chi_diff_basis Derivatives of Wchi basis functions
!!                           evaluated at gaussian quadrature points
!! @param[in] ndf_pid  Number of degrees of freedom per cell for panel_id
!! @param[in] undf_pid Number of unique degrees of freedom for panel_id
!! @param[in] map_pid  Dofmap for the cell at the base of the column for panel_id
!! @param[in] nqp_h Number of horizontal quadrature points
!! @param[in] nqp_v Number of vertical quadrature points
!! @param[in] wqp_h Weights of the horizontal quadrature points
!! @param[in] wqp_v Weights of the vertical quadrature points
subroutine solver_w3_code(nlayers,                           &
                          x, rhs,                            &
                          chi_1, chi_2, chi_3, panel_id,     &
                          ndf_w3, undf_w3, map_w3, w3_basis, &
                          ndf_wchi, undf_wchi, map_wchi,     &
                          chi_basis, chi_diff_basis,         &
                          ndf_pid, undf_pid, map_pid,        &
                          nqp_h, nqp_v, wqp_h, wqp_v         &
                         )

  use matrix_invert_mod,       only : matrix_invert
  use coordinate_jacobian_mod, only : coordinate_jacobian

  implicit none

  ! Needs to compute the integral of rho_df * P
  ! P_analytic over a single column

  ! Arguments
  integer(kind=i_def), intent(in) :: nlayers, nqp_h, nqp_v
  integer(kind=i_def), intent(in) :: ndf_w3, undf_w3
  integer(kind=i_def), intent(in) :: ndf_wchi, undf_wchi
  integer(kind=i_def), intent(in) :: ndf_pid, undf_pid
  integer(kind=i_def), dimension(ndf_w3),   intent(in) :: map_w3
  integer(kind=i_def), dimension(ndf_wchi), intent(in) :: map_wchi
  integer(kind=i_def), dimension(ndf_pid),  intent(in) :: map_pid

  real(kind=r_def), intent(in), dimension(1,ndf_w3,nqp_h,nqp_v)   :: w3_basis
  real(kind=r_def), intent(in), dimension(1,ndf_wchi,nqp_h,nqp_v) :: chi_basis
  real(kind=r_def), intent(in), dimension(3,ndf_wchi,nqp_h,nqp_v) :: chi_diff_basis
  real(kind=r_def),    dimension(undf_w3),   intent(inout) :: x
  real(kind=r_def),    dimension(undf_w3),   intent(in)    :: rhs
  real(kind=r_def),    dimension(undf_wchi), intent(in)    :: chi_1, chi_2, chi_3
  integer(kind=i_def), dimension(undf_pid),  intent(in)    :: panel_id

  real(kind=r_def), dimension(nqp_h), intent(in)           :: wqp_h
  real(kind=r_def), dimension(nqp_v), intent(in)           :: wqp_v

  ! Internal variables
  integer(kind=i_def) :: df1, df2, k
  integer(kind=i_def) :: qp1, qp2
  integer(kind=i_def) :: ipanel

  real(kind=r_def) :: x_e(ndf_w3), rhs_e(ndf_w3)
  real(kind=r_def) :: integrand
  real(kind=r_def), dimension(ndf_w3,ndf_w3)   :: mass_matrix_w3, inv_mass_matrix_w3
  real(kind=r_def), dimension(nqp_h,nqp_v)     :: dj
  real(kind=r_def), dimension(3,3,nqp_h,nqp_v) :: jac
  real(kind=r_def), dimension(ndf_wchi)        :: chi_1_e, chi_2_e, chi_3_e

  ipanel = panel_id(map_pid(1))

  ! Compute the LHS integrated over one cell and solve
  do k = 0, nlayers-1
    do df1 = 1, ndf_wchi
      chi_1_e(df1) = chi_1( map_wchi(df1) + k)
      chi_2_e(df1) = chi_2( map_wchi(df1) + k)
      chi_3_e(df1) = chi_3( map_wchi(df1) + k)
    end do

    call coordinate_jacobian(ndf_wchi, nqp_h, nqp_v, chi_1_e, chi_2_e, chi_3_e, &
                             ipanel, chi_basis, chi_diff_basis, jac, dj)

    do df1 = 1, ndf_w3
       do df2 = 1, ndf_w3
          mass_matrix_w3(df1,df2) = 0.0_r_def
          do qp2 = 1, nqp_v
             do qp1 = 1, nqp_h
                integrand =  w3_basis(1,df1,qp1,qp2) * &
                             w3_basis(1,df2,qp1,qp2) * dj(qp1,qp2)
                 mass_matrix_w3(df1,df2) = mass_matrix_w3(df1,df2) &
                                         + wqp_h(qp1)*wqp_v(qp2)*integrand
             end do
          end do
       end do
       rhs_e(df1) = rhs(map_w3(df1)+k)
    end do
    call matrix_invert(mass_matrix_w3,inv_mass_matrix_w3,ndf_w3)
    x_e = matmul(inv_mass_matrix_w3,rhs_e)
    do df1 = 1,ndf_w3
      x(map_w3(df1)+k) = x_e(df1)
    end do
  end do

end subroutine solver_w3_code

end module w3_solver_kernel_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!------------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office

!> @brief Kernel which computes the fluxes for the split transport scheme
module conservative_flux_kernel_mod

use constants_mod,     only : r_def, i_def
use argument_mod,      only : arg_type,          &
                              GH_FIELD, GH_REAL, &
                              GH_INC, GH_READ,   &
                              STENCIL, XORY1D, CELL_COLUMN
use fs_continuity_mod, only : W2, W3
use kernel_mod,        only : kernel_type

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------
!> The type declaration for the kernel. Contains the metadata needed by the Psy layer
type, public, extends(kernel_type) :: conservative_flux_kernel_type
  private
  type(arg_type) :: meta_args(7) = (/                                  &
       arg_type(GH_FIELD,  GH_REAL,  GH_INC,   W2),                    &
       arg_type(GH_FIELD,  GH_REAL,  GH_READ,  W2),                    &
       arg_type(GH_FIELD,  GH_REAL,  GH_READ,  W2),                    &
       arg_type(GH_FIELD,  GH_REAL,  GH_READ,  W3, STENCIL(XORY1D)),   &
       arg_type(GH_FIELD,  GH_REAL,  GH_READ,  W3, STENCIL(XORY1D)),   &
       arg_type(GH_FIELD,  GH_REAL,  GH_READ,  W3, STENCIL(XORY1D)),   &
       arg_type(GH_FIELD,  GH_REAL,  GH_READ,  W3, STENCIL(XORY1D))    &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: conservative_flux_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public conservative_flux_code

contains

!> @brief Computes the fluxes for the split advection scheme
!! @param[in] nlayers Number of layers
!! @param[in,out] flux Flux values which are calculated
!! @param[in] dep_pts Departure points
!! @param[in] u_piola Piola winds
!! @param[in] rho Density values in W3
!! @param[in] rho_stencil_length Length of the 1D stencil for density
!! @param[in] rho_direction Direction in which to calculate the fluxes for density
!! @param[in] rho_stencil_map Dofmaps for the stencil for density
!! @param[in] a0_coeffs Coefficients for the subgrid approximation of density
!! @param[in] a0_stencil_length Length of the 1D stencil for a0
!! @param[in] a0_direction Direction in which to calculate the fluxes for a0
!! @param[in] a0_stencil_map Dofmaps for the stencil for a0
!! @param[in] a1_coeffs Coefficients for the subgrid approximation of density
!! @param[in] a1_stencil_length Length of the 1D stencil for a1
!! @param[in] a1_direction Direction in which to calculate the fluxes for a1
!! @param[in] a1_stencil_map Dofmaps for the stencil for a1
!! @param[in] a2_coeffs Coefficients for the subgrid approximation of density
!! @param[in] a2_stencil_length Length of the 1D stencil for a2
!! @param[in] a2_direction Direction in which to calculate the fluxes for a2
!! @param[in] a2_stencil_map Dofmaps for the stencil for a2
!! @param[in] ndf_w2 Number of degrees of freedom per cell
!! @param[in] undf_w2 Number of unique degrees of freedom
!! @param[in] map_w2 Dofmap for the cell at the base of the column
!! @param[in] ndf_w3 Number of degrees of freedom per cell
!! @param[in] undf_w3 Number of unique degrees of freedom
!! @param[in] map_w3 Dofmap for the cell at the base of the column
subroutine conservative_flux_code( nlayers,              &
                                   flux,                 &
                                   dep_pts,              &
                                   u_piola,              &
                                   rho,                  &
                                   rho_stencil_length,   &
                                   rho_direction,        &
                                   rho_stencil_map,      &
                                   a0_coeffs,            &
                                   a0_stencil_length,    &
                                   a0_direction,         &
                                   a0_stencil_map,       &
                                   a1_coeffs,            &
                                   a1_stencil_length,    &
                                   a1_direction,         &
                                   a1_stencil_map,       &
                                   a2_coeffs,            &
                                   a2_stencil_length,    &
                                   a2_direction,         &
                                   a2_stencil_map,       &
                                   ndf_w2,               &
                                   undf_w2,              &
                                   map_w2,               &
                                   ndf_w3,               &
                                   undf_w3,              &
                                   map_w3)

  use cosmic_flux_mod,    only : calc_stencil_ordering,                &
                                 frac_and_int_part,                    &
                                 calc_integration_limits,              &
                                 populate_array,                       &
                                 map_cell_index,                       &
                                 return_part_mass
  use flux_direction_mod, only : x_direction, y_direction

  use timestepping_config_mod,      only: dt

  implicit none

  ! Arguments
  integer(kind=i_def), intent(in)                       :: nlayers
  integer(kind=i_def), intent(in)                       :: ndf_w3
  integer(kind=i_def), intent(in)                       :: undf_w3
  integer(kind=i_def), dimension(ndf_w3), intent(in)    :: map_w3
  real(kind=r_def), dimension(undf_w3), intent(in)      :: rho
  real(kind=r_def), dimension(undf_w3), intent(in)      :: a0_coeffs
  real(kind=r_def), dimension(undf_w3), intent(in)      :: a1_coeffs
  real(kind=r_def), dimension(undf_w3), intent(in)      :: a2_coeffs
  integer(kind=i_def), intent(in)                       :: ndf_w2
  integer(kind=i_def), intent(in)                       :: undf_w2
  integer(kind=i_def), dimension(ndf_w2), intent(in)    :: map_w2
  real(kind=r_def), dimension(undf_w2), intent(inout)   :: flux
  real(kind=r_def), dimension(undf_w2), intent(in)      :: dep_pts
  real(kind=r_def), dimension(undf_w2), intent(in)      :: u_piola
  integer(kind=i_def), intent(in)                       :: rho_stencil_length, a0_stencil_length
  integer(kind=i_def), intent(in)                       :: a1_stencil_length, a2_stencil_length
  integer(kind=i_def), intent(in)                       :: rho_direction, a0_direction
  integer(kind=i_def), intent(in)                       :: a1_direction, a2_direction
  integer(kind=i_def), intent(in)                       :: rho_stencil_map(1:rho_stencil_length)
  integer(kind=i_def), intent(in)                       :: a0_stencil_map(1:a0_stencil_length)
  integer(kind=i_def), intent(in)                       :: a1_stencil_map(1:a1_stencil_length)
  integer(kind=i_def), intent(in)                       :: a2_stencil_map(1:a2_stencil_length)

  ! Internal variables
  real(kind=r_def) :: mass_total
  real(kind=r_def) :: departure_dist
  real(kind=r_def) :: rho_local(1:rho_stencil_length)
  real(kind=r_def) :: a0_local(1:a0_stencil_length)
  real(kind=r_def) :: a1_local(1:a1_stencil_length)
  real(kind=r_def) :: a2_local(1:a2_stencil_length)
  real(kind=r_def) :: fractional_distance
  real(kind=r_def) :: mass_frac
  real(kind=r_def) :: mass_from_whole_cells
  real(kind=r_def) :: left_integration_limit
  real(kind=r_def) :: right_integration_limit
  real(kind=r_def) :: subgrid_coeffs(3)

  integer(kind=i_def), allocatable :: index_array(:)
  integer(kind=i_def), allocatable :: local_density_index(:)

  integer(kind=i_def) :: stencil_ordering(1:rho_stencil_length)
  integer(kind=i_def) :: k
  integer(kind=i_def) :: df1
  integer(kind=i_def) :: ii
  integer(kind=i_def) :: edge_option
  integer(kind=i_def) :: n_cells_to_sum


  call calc_stencil_ordering(rho_stencil_length,stencil_ordering)

  if (direction == x_direction ) then
    edge_option = 0
    df1=1
  elseif (direction == y_direction) then
    edge_option = 0
    df1=2
  endif


  do k=0,nlayers-1

    departure_dist = dep_pts( map_w2(df1) + k )

    ! Rearrange data such that it is in the order 1 | 2 | 3 | 4 | 5 | 6 | 7 etc

    do ii=1,rho_stencil_length
      rho_local(ii) = rho( rho_stencil_map(stencil_ordering(ii)) )
      a0_local(ii)  = a0_coeffs( rho_stencil_map(stencil_ordering(ii)) )
      a1_local(ii)  = a1_coeffs( rho_stencil_map(stencil_ordering(ii)) )
      a2_local(ii)  = a2_coeffs( rho_stencil_map(stencil_ordering(ii)) )
    end do

    ! Calculates number of cells of interest and fraction of a cell to add.
    call frac_and_int_part(departure_dist,n_cells_to_sum,fractional_distance)

    ! Calcuates the left and right integration limits for the fractional cell.
    call calc_integration_limits( departure_dist,             &
                                  fractional_distance,        &
                                  left_integration_limit,     &
                                  right_integration_limit )

    allocate(index_array(n_cells_to_sum))
    allocate(local_density_index(n_cells_to_sum))

    call populate_array(n_cells_to_sum,index_array,departure_dist,edge_option)

    do ii=1,n_cells_to_sum
      local_density_index(ii) = map_cell_index(index_array(ii),rho_stencil_length)
    end do

    mass_from_whole_cells = sum(rho_local(local_density_index(1:n_cells_to_sum-1)))

    subgrid_coeffs = (/ a0_local(local_density_index(n_cells_to_sum)), &
                        a1_local(local_density_index(n_cells_to_sum)), &
                        a2_local(local_density_index(n_cells_to_sum)) /)

    mass_frac = return_part_mass(3,subgrid_coeffs,left_integration_limit,right_integration_limit)

    mass_total = mass_from_whole_cells + mass_frac

    flux( map_w2(df1) + k ) = sign(1.0_r_def,u_piola( map_w2(df1) + k ))*mass_total/dt

    if (allocated(index_array)) deallocate(index_array)
    if (allocated(local_density_index)) deallocate(local_density_index)

  end do

end subroutine conservative_flux_code

end module conservative_flux_kernel_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!------------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office

!> @brief Stores the diagonal elements of a mass matrix

!> @details Stores the diagonal elements of a mass matrix M into a field D
!>          i.e D(df) = M(df,df)
module mm_diagonal_kernel_mod

use argument_mod,            only : arg_type,                 &
                                    GH_FIELD, GH_OPERATOR,    &
                                    GH_REAL, GH_READ, GH_INC, &
                                    ANY_SPACE_1,              &
                                    CELL_COLUMN
use constants_mod,           only : r_def, i_def
use kernel_mod,              only : kernel_type

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------

type, public, extends(kernel_type) :: mm_diagonal_kernel_type
  private
  type(arg_type) :: meta_args(2) = (/                                    &
       arg_type(GH_FIELD,    GH_REAL, GH_INC,  ANY_SPACE_1),             &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ, ANY_SPACE_1, ANY_SPACE_1) &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: mm_diagonal_kernel_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public mm_diagonal_kernel_code

contains

!> @brief Stores the diagonal of a mass_matrix
!> @param[in] cell Horizontal cell index
!! @param[in] nlayers Number of layers
!! @param[in,out] mm_diag Diagonal entries of the mass matrix
!! @param[in] ncell_3d Total number of cells
!! @param[in] mass_matrix Mass matrix values
!! @param[in] ndf Number of degrees of freedom per cell
!! @param[in] undf Unique number of degrees of freedom
!! @param[in] map Dofmap for the cell at the base of the column
subroutine mm_diagonal_kernel_code(cell,        &
                                   nlayers,     &
                                   mm_diag,     &
                                   ncell_3d,    &
                                   mass_matrix, &
                                   ndf, undf, map)

  implicit none

  ! Arguments
  integer(kind=i_def),                   intent(in) :: cell, nlayers, ndf
  integer(kind=i_def),                   intent(in) :: undf, ncell_3d
  integer(kind=i_def), dimension(ndf),   intent(in) :: map
  real(kind=r_def), dimension(undf), intent(inout) :: mm_diag
  real(kind=r_def), dimension(ndf,ndf,ncell_3d), intent(in) :: mass_matrix

  ! Internal variables
  integer(kind=i_def) :: df, k, ik

  do k = 0, nlayers-1
    ik = (cell-1)*nlayers + k + 1
    do df = 1,ndf
       mm_diag(map(df)+k) = mm_diag(map(df)+k) + mass_matrix(df,df,ik)
    end do
  end do

end subroutine mm_diagonal_kernel_code

end module mm_diagonal_kernel_mod

module inc_field_0_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod, only : go_offset_sw
  implicit none
  type, extends(kernel_type), public :: inc_field
  TYPE(go_arg), DIMENSION(4) :: meta_args = (/go_arg(go_write, go_ct, go_pointwise), go_arg(go_read, go_i_scalar, go_pointwise), &
&go_arg(go_read, go_i_scalar, go_pointwise), go_arg(go_read, go_i_scalar, go_pointwise)/)
  INTEGER :: iterates_over = go_internal_pts
  INTEGER :: index_offset = go_offset_sw
  CONTAINS
  PROCEDURE, NOPASS :: code => inc_field_0_code
END TYPE inc_field
  public

  public :: inc_field_0_code

  contains
  subroutine inc_field_0_code(ji, jj, fld1, nx, ny, istp)
    integer, intent(in) :: ji
    integer, intent(in) :: jj
    integer, intent(in) :: nx
    integer, intent(in) :: ny
    real(kind=go_wp), dimension(nx,ny), intent(inout) :: fld1
    integer, intent(in) :: istp

    !$acc routine
    fld1(ji,jj) = fld1(ji,jj) + REAL(istp, go_wp)

  end subroutine inc_field_0_code

end module inc_field_0_mod

!-----------------------------------------------------------------------------
! (C) Crown copyright 2018 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------

!> @brief Projects a field into a given space.
!>
module w2_to_w1_projection_kernel_mod

  use argument_mod,      only : arg_type, func_type,   &
                                GH_FIELD, GH_REAL,     &
                                GH_INC, GH_READ,       &
                                GH_BASIS, CELL_COLUMN, &
                                GH_QUADRATURE_XYoZ
  use constants_mod,     only : r_def, i_def
  use fs_continuity_mod, only : W1, W2
  use kernel_mod,        only : kernel_type

  implicit none

  private

  !---------------------------------------------------------------------------
  ! Public types
  !---------------------------------------------------------------------------
  !> The type declaration for the kernel. Contains the metadata needed by the
  !> Psy layer.
  !>
  type, public, extends(kernel_type) :: w2_to_w1_projection_kernel_type
    private
    type(arg_type) :: meta_args(2) = (/            &
         arg_type(GH_FIELD, GH_REAL, GH_INC,  W1), &
         arg_type(GH_FIELD, GH_REAL, GH_READ, W2)  &
         /)
    type(func_type) :: meta_funcs(2) = (/          &
         func_type(W1, GH_BASIS),                  &
         func_type(W2, GH_BASIS)                   &
         /)
    integer :: operates_on = CELL_COLUMN
    integer :: gh_shape = GH_QUADRATURE_XYoZ
  contains
    procedure, nopass :: w2_to_w1_projection_code
  end type

!-----------------------------------------------------------------------------
! Contained functions/subroutines
!-----------------------------------------------------------------------------
public :: w2_to_w1_projection_code

contains

!> @brief     Subroutine to compute right hand side of a Galerkin projection of
!>            a field from W2 into W1
!> @details   Computes int( gamma * f  dx) to compute the right hand side of the
!>            Galerkin projection of scalar field f into another space of which gamma
!>            is the test function
!! @param[in] nlayers Number of layers
!! @param[in,out] v_w1 Field containing the integral of test_function * field
!! @param[in] u_w2 Field to be projected
!! @param[in] ndf1 Number of degrees of freedom per cell
!! @param[in] undf1 Number of (local) unique degrees of freedom of the field rhs
!! @param[in] map1 Dofmap for the cell at the base of the column
!! @param[in] basis1 Basis functions evaluated at quadrature points
!! @param[in] ndf2 Number of degrees of freedom per cell for the field to be projected
!! @param[in] undf2 Number of (local) unique degrees of freedom of the proj. field
!! @param[in] map2 Dofmap for the cell at the base of the column
!! @param[in] basis2 Basis functions evaluated at quadrature points
!! @param[in] nqp_h Number of horizontal quadrature points
!! @param[in] nqp_v Number of vertical quadrature points
!! @param[in] wqp_h Horizontal quadrature weights
!! @param[in] wqp_v Vertical quadrature weights
subroutine w2_to_w1_projection_code(nlayers,                     &
                                    v_w1, u_w2,                  &
                                    ndf1, undf1, map1, basis_w1, &
                                    ndf2, undf2, map2, basis_w2, &
                                    nqp_h, nqp_v, wqp_h, wqp_v)

  implicit none

  ! Arguments
  integer(kind=i_def), intent(in) :: nlayers, ndf1, undf1
  integer(kind=i_def), intent(in) :: ndf2, undf2
  integer(kind=i_def), intent(in) :: nqp_h, nqp_v

  integer(kind=i_def), dimension(ndf1), intent(in) :: map1
  integer(kind=i_def), dimension(ndf2), intent(in) :: map2

  real(kind=r_def), intent(in), dimension(3,ndf1,nqp_h,nqp_v) :: basis_w1
  real(kind=r_def), intent(in), dimension(3,ndf2,nqp_h,nqp_v) :: basis_w2

  real(kind=r_def), dimension(undf1), intent(inout) :: v_w1
  real(kind=r_def), dimension(undf2), intent(in)    :: u_w2

  real(kind=r_def), dimension(nqp_h), intent(in) ::  wqp_h
  real(kind=r_def), dimension(nqp_v), intent(in) ::  wqp_v

  ! Internal variables
  integer(kind=i_def)            :: df1, df2, k, qp1, qp2
  real(kind=r_def), dimension(3) :: wind
  real(kind=r_def)               :: vu

  do k = 0, nlayers-1
    do qp2 = 1, nqp_v
      do qp1 = 1, nqp_h
        wind(:) = 0.0_r_def
        do df2 = 1, ndf2
          wind(:) = wind(:) + basis_w2(:,df2,qp1,qp2)*u_w2(map2(df2) + k)
        end do
        do df1 = 1, ndf1
          vu = wqp_h(qp1)*wqp_v(qp2)*dot_product(basis_w1(:,df1,qp1,qp2),wind(:))
          v_w1(map1(df1) + k) = v_w1(map1(df1) + k) + vu
        end do
      end do
    end do
  end do

end subroutine w2_to_w1_projection_code

end module w2_to_w1_projection_kernel_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2018-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office


!> An implemention of the PSyData API for profiling, which wraps the use
!> of the dl_timer library (https://bitbucket.org/apeg/dl_timer).

module profile_psy_data_mod

  use psy_data_base_mod, only : PSyDataBaseType, profile_PSyDataStart, &
                                profile_PSyDataStop, is_enabled

  implicit none

  type, extends(PSyDataBaseType) :: profile_PSyDataType
      integer                   :: timer_index
      logical                   :: registered = .false.
  contains
      ! The profiling API uses only the two following calls:
      procedure :: PreStart
      procedure :: PostEnd
  end type profile_PSyDataType

contains

  ! ---------------------------------------------------------------------------
  !> The initialisation subroutine. It is not called directly from
  !! any PSyclone created code, so a call to profile_PSyDataInit must be
  !! inserted manually by the developer.
  !!
  subroutine profile_PSyDataInit()

    use dl_timer, only : timer_init

    implicit none

    call timer_init()

  end subroutine profile_PSyDataInit

  ! ---------------------------------------------------------------------------
  !> Starts a profiling area. The module and region name can be used to create
  !! a unique name for each region.
  !! Parameters:
  !! @param[in,out] this This PSyData instance.
  !! @param[in] module_name Name of the module in which the region is
  !! @param[in] region_name Name of the region (could be name of an invoke, or
  !!            subroutine name).
  !! @param[in] num_pre_vars The number of variables that are declared and
  !!            written before the instrumented region.
  !! @param[in] num_post_vars The number of variables that are also declared
  !!            before an instrumented region of code, but are written after
  !!            this region.
  subroutine PreStart(this, module_name, region_name, num_pre_vars, &
                      num_post_vars)

    use dl_timer, only : timer_register, timer_start

    implicit none

    class(profile_PSyDataType), intent(inout), target :: this
    character(*), intent(in) :: module_name, region_name
    integer, intent(in) :: num_pre_vars, num_post_vars

    if ( .not. this%registered) then
       call this%PSyDataBaseType%PreStart(module_name, region_name, &
                                          num_pre_vars, num_post_vars)
       call timer_register(this%timer_index, &
                           label=module_name//":"//region_name)
       this%registered = .true.
    endif
    if (is_enabled) call timer_start(this%timer_index)

  end subroutine PreStart

  ! ---------------------------------------------------------------------------
  !> Ends a profiling area. It takes a PSyDataType type that corresponds to
  !! to the PreStart call.
  !! @param[in,out] this This PSyData instance.
  !
  subroutine PostEnd(this)

    use dl_timer, only : timer_stop

    implicit none

    class(profile_PSyDataType), intent(inout), target :: this

    if (is_enabled) call timer_stop(this%timer_index)

  end subroutine PostEnd

  ! ---------------------------------------------------------------------------
  !> Called at the end of the execution of a program, usually to generate
  !! all output for the profiling library. Calls timer_report in dl_timer.
  subroutine profile_PSyDataShutdown()

    use dl_timer, only : timer_report

    implicit none

    call timer_report()

  end subroutine profile_PSyDataShutdown

end module profile_psy_data_mod

  MODULE helmholtz_solver_alg_mod_psy
    USE constants_mod, ONLY: r_def, i_def
    USE field_mod, ONLY: field_type, field_proxy_type
    USE operator_mod, ONLY: operator_type, operator_proxy_type
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(grad_p, p, div_star, hb_inv, u_normalisation)
      USE scaled_matrix_vector_kernel_mod, ONLY: opt_scaled_matrix_vector_code
      USE mesh_mod, ONLY: mesh_type
      TYPE(field_type), intent(in) :: grad_p, p, hb_inv, u_normalisation
      TYPE(operator_type), intent(in) :: div_star
      INTEGER(KIND=i_def) cell
      INTEGER df
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      INTEGER(KIND=i_def) nlayers
      TYPE(operator_proxy_type) div_star_proxy
      TYPE(field_proxy_type) grad_p_proxy, p_proxy, hb_inv_proxy, u_normalisation_proxy
      INTEGER(KIND=i_def), pointer :: map_w2(:,:) => null(), map_w3(:,:) => null()
      INTEGER(KIND=i_def) ndf_aspc1_grad_p, undf_aspc1_grad_p, ndf_w2, undf_w2, ndf_w3, undf_w3
      INTEGER(KIND=i_def) max_halo_depth_mesh
      TYPE(mesh_type), pointer :: mesh => null()
      !
      ! Initialise field and/or operator proxies
      !
      grad_p_proxy = grad_p%get_proxy()
      p_proxy = p%get_proxy()
      div_star_proxy = div_star%get_proxy()
      hb_inv_proxy = hb_inv%get_proxy()
      u_normalisation_proxy = u_normalisation%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = grad_p_proxy%vspace%get_nlayers()
      !
      ! Create a mesh object
      !
      mesh => grad_p_proxy%vspace%get_mesh()
      max_halo_depth_mesh = mesh%get_halo_depth()
      !
      ! Look-up dofmaps for each function space
      !
      map_w2 => grad_p_proxy%vspace%get_whole_dofmap()
      map_w3 => p_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for aspc1_grad_p
      !
      ndf_aspc1_grad_p = grad_p_proxy%vspace%get_ndf()
      undf_aspc1_grad_p = grad_p_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for w2
      !
      ndf_w2 = grad_p_proxy%vspace%get_ndf()
      undf_w2 = grad_p_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for w3
      !
      ndf_w3 = p_proxy%vspace%get_ndf()
      undf_w3 = p_proxy%vspace%get_undf()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = grad_p_proxy%vspace%get_last_dof_halo(1)
      loop1_start = 1
      loop1_stop = mesh%get_last_halo_cell(1)
      !
      ! Call kernels and communication routines
      !
      IF (p_proxy%is_dirty(depth=1)) THEN
        CALL p_proxy%halo_exchange_start(depth=1)
      END IF
      !
      IF (hb_inv_proxy%is_dirty(depth=1)) THEN
        CALL hb_inv_proxy%halo_exchange_start(depth=1)
      END IF
      !
      IF (u_normalisation_proxy%is_dirty(depth=1)) THEN
        CALL u_normalisation_proxy%halo_exchange_start(depth=1)
      END IF
      !
      DO df=loop0_start,loop0_stop
        grad_p_proxy%data(df) = 0.0_r_def
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL grad_p_proxy%set_dirty()
      CALL grad_p_proxy%set_clean(1)
      !
      IF (p_proxy%is_dirty(depth=1)) THEN
        CALL p_proxy%halo_exchange_finish(depth=1)
      END IF
      !
      IF (hb_inv_proxy%is_dirty(depth=1)) THEN
        CALL hb_inv_proxy%halo_exchange_finish(depth=1)
      END IF
      !
      IF (u_normalisation_proxy%is_dirty(depth=1)) THEN
        CALL u_normalisation_proxy%halo_exchange_finish(depth=1)
      END IF
      !
      DO cell=loop1_start,loop1_stop
        !
        CALL opt_scaled_matrix_vector_code(cell, nlayers, grad_p_proxy%data, p_proxy%data, div_star_proxy%ncell_3d, &
&div_star_proxy%local_stencil, hb_inv_proxy%data, u_normalisation_proxy%data, ndf_w2, undf_w2, map_w2(:,cell), ndf_w3, undf_w3, &
&map_w3(:,cell))
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL grad_p_proxy%set_dirty()
      !
      !
    END SUBROUTINE invoke_0
  END MODULE helmholtz_solver_alg_mod_psy

  MODULE psy_alg
    USE field_mod
    USE kind_params_mod
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0_inc_field(fld1, nx, ny, this_step)
      USE inc_field_0_mod, ONLY: inc_field_0_code
      TYPE(r2d_field), intent(inout) :: fld1
      INTEGER, intent(inout) :: nx
      INTEGER, intent(inout) :: ny
      INTEGER, intent(inout) :: this_step
      INTEGER j
      INTEGER i

      fld1%data_on_device = .true.
      fld1%read_from_device_f => read_from_device
      !$acc enter data copyin(fld1,fld1%data,nx,ny,this_step)
      !$acc parallel default(present)
      !$acc loop independent collapse(2)
      DO j = fld1%internal%ystart, fld1%internal%ystop, 1
        DO i = fld1%internal%xstart, fld1%internal%xstop, 1
          CALL inc_field_0_code(i, j, fld1%data, nx, ny, this_step)
        END DO
      END DO
      !$acc end parallel

    END SUBROUTINE invoke_0_inc_field
    SUBROUTINE read_from_device(from, to, startx, starty, nx, ny, blocking)
      USE iso_c_binding, ONLY: c_ptr
      USE kind_params_mod, ONLY: go_wp
      TYPE(c_ptr), intent(in) :: from
      REAL(KIND=go_wp), DIMENSION(:, :), INTENT(INOUT), TARGET :: to
      INTEGER, intent(in) :: startx
      INTEGER, intent(in) :: starty
      INTEGER, intent(in) :: nx
      INTEGER, intent(in) :: ny
      LOGICAL, intent(in) :: blocking

      !$acc update host(to)

    END SUBROUTINE read_from_device
  END MODULE psy_alg

!> \brief Compute the mass flux in the x direction, cu
!! \detail Given the current pressure and velocity fields,
!! computes the mass flux in the x direction.
module compute_cu_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use field_mod
  use grid_mod
  implicit none

  private

  public invoke_compute_cu
  public compute_cu, compute_cu_code

  type, extends(kernel_type) :: compute_cu
     type(go_arg), dimension(3) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_CU, GO_POINTWISE),            & ! cu
             go_arg(GO_READ,  GO_CT, GO_STENCIL(000,110,000)), & ! p
             go_arg(GO_READ,  GO_CU, GO_POINTWISE)             & ! u
           /)
     !> This kernel writes only to internal points of the
     !! simulation domain.
     integer :: ITERATES_OVER = GO_INTERNAL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => compute_cu_code
  end type compute_cu

contains

  !===================================================

  !> Manual implementation of the code needed to invoke
  !! compute_cu_code().
  subroutine invoke_compute_cu(cufld, pfld, ufld)
    implicit none
    type(r2d_field), intent(inout) :: cufld
    type(r2d_field), intent(in)    :: pfld, ufld
    ! Locals
    integer :: I, J

    ! Note that we do not loop over the full extent of the field.
    ! Fields are allocated with extents (M+1,N+1).
    ! Presumably the extra row and column are needed for periodic BCs.
    ! We are updating a quantity on CU.
    ! This loop writes to cu(2:M+1,1:N) so this looks like
    ! (using x to indicate a location that is written):
    !
    ! i=1   i=M
    !  o  o  o  o 
    !  o  x  x  x   j=N
    !  o  x  x  x
    !  o  x  x  x   j=1

    ! Quantity CU is mass flux in x direction.

    ! Original code looked like:
    !
    !    DO J=1,N
    !      DO I=1,M
    !           CU(I+1,J) = .5*(P(I+1,J)+P(I,J))*U(I+1,J)
    !      END DO
    !    END DO

    ! cu(i,j) depends upon:
    !   p(i-1,j), p(i,j) : CT
    !    => lateral CT neighbours of the CU pt being updated
    !   u(i,j)           : CU
    !    => the horiz. vel. component at the CU pt being updated

    !   vi-1j+1--fij+1---vij+1---fi+1j+1
    !   |        |       |       |
    !   |        |       |       |
    !   Ti-1j----uij-----Tij-----ui+1j
    !   |        |       |       |
    !   |        |       |       |
    !   vi-1j----fij-----vij-----fi+1j
    !   |        |       |       |
    !   |        |       |       |
    !   Ti-1j-1--uij-1---Tij-1---ui+1j-1
    !

    do J=cufld%internal%ystart, cufld%internal%ystop
       do I=cufld%internal%xstart, cufld%internal%xstop

          call compute_cu_code(i, j, cufld%data, pfld%data, ufld%data)
       end do
    end do

  end subroutine invoke_compute_cu

  !===================================================

  !> Compute the mass flux in the x direction at point (i,j)
  subroutine compute_cu_code(i, j, cu, p, u)
    implicit none
    integer,  intent(in) :: I, J
    real(go_wp), intent(out), dimension(:,:) :: cu
    real(go_wp), intent(in),  dimension(:,:) :: p, u


    CU(I,J) = 0.5d0*(P(i,J)+P(I-1,J))*U(I,J)
    
    !write (*,"('CU calc: ',I3,1x,I3,3(1x,E24.16))") &
    !     i, j, p(i,j), p(i-1,j), u(i,j)

  end subroutine compute_cu_code

end module compute_cu_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2017-2022, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Authors: R. W. Ford and A. R. Porter, STFC Daresbury Lab
! Modified: I. Kavcic, Met Office
!
!> @brief Meta-data for the LFRic API built-in operations.
!> @details This meta-data is purely to provide PSyclone with a
!!          specification of each operation. This specification is used
!!          for correctness checking as well as to enable optimisations
!!          of invokes containing calls to built-in operations.
!!          The actual implementation of these built-ins is
!!          generated by PSyclone (hence the empty ..._code routines in
!!          this file).
module lfric_builtins_mod

use kernel_mod,    only : kernel_type
use argument_mod,  only : arg_type,            &
                          GH_FIELD, GH_SCALAR, &
                          GH_REAL, GH_INTEGER, &
                          GH_READ, GH_WRITE,   &
                          GH_READWRITE,        &
                          ANY_SPACE_1, DOF

! ******************************************************************* !
! ************** Built-ins for real-valued fields ******************* !
! ******************************************************************* !

! ------------------------------------------------------------------- !
! ============== Adding (scaled) real fields ======================== !
! ------------------------------------------------------------------- !

  !> field3 = field1 + field2
  type, public, extends(kernel_type) :: X_plus_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_WRITE, ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1)          &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_plus_Y_code
  end type X_plus_Y

  !> field1 = field1 + field2
  type, public, extends(kernel_type) :: inc_X_plus_Y
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_READWRITE, ANY_SPACE_1),     &
          arg_type(GH_FIELD, GH_REAL, GH_READ,      ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_plus_Y_code
  end type inc_X_plus_Y

  !> field2 = scalar + field1
  type, public, extends(kernel_type) :: a_plus_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: a_plus_X_code
  end type a_plus_X

  !> field = scalar + field
  type, public, extends(kernel_type) :: inc_a_plus_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_a_plus_X_code
  end type inc_a_plus_X

  !> field3 = scalar*field1 + field2
  type, public, extends(kernel_type) :: aX_plus_Y
     private
     type(arg_type) :: meta_args(4) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: aX_plus_Y_code
  end type aX_plus_Y

  !> field1 = scalar*field1 + field2
  type, public, extends(kernel_type) :: inc_aX_plus_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,      ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_aX_plus_Y_code
  end type inc_aX_plus_Y

  !> field1 = field1 + scalar*field2
  type, public, extends(kernel_type) :: inc_X_plus_bY
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1),    &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,      ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_plus_bY_code
  end type inc_X_plus_bY

  !> field3 = scalar1*field1 + scalar2*field2
  type, public, extends(kernel_type) :: aX_plus_bY
     private
     type(arg_type) :: meta_args(5) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: aX_plus_bY_code
  end type aX_plus_bY

  !> field1 = scalar1*field1 + scalar2*field2
  type, public, extends(kernel_type) :: inc_aX_plus_bY
     private
     type(arg_type) :: meta_args(4) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1),    &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,      ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_aX_plus_bY_code
  end type inc_aX_plus_bY

  !> field3 = scalar*(field1 + field2)
  type, public, extends(kernel_type) :: aX_plus_aY
     private
     type(arg_type) :: meta_args(4) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: aX_plus_aY_code
  end type aX_plus_aY

! ------------------------------------------------------------------- !
! ============== Subtracting (scaled) real fields =================== !
! ------------------------------------------------------------------- !

  !> field3 = field1 - field2
  type, public, extends(kernel_type) :: X_minus_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_WRITE, ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1)          &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_minus_Y_code
  end type X_minus_Y

  !> field1 = field1 - field2
  type, public, extends(kernel_type) :: inc_X_minus_Y
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_READWRITE, ANY_SPACE_1),     &
          arg_type(GH_FIELD, GH_REAL, GH_READ,      ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_minus_Y_code
  end type inc_X_minus_Y

  !> field2 = scalar - field1
  type, public, extends(kernel_type) :: a_minus_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: a_minus_X_code
  end type a_minus_X

  !> field = scalar - field
  type, public, extends(kernel_type) :: inc_a_minus_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_a_minus_X_code
  end type inc_a_minus_X

  !> field2 = field1 - scalar
  type, public, extends(kernel_type) :: X_minus_a
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              )         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_minus_a_code
  end type X_minus_a

  !> field = field - scalar
  type, public, extends(kernel_type) :: inc_X_minus_a
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1),    &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  )     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_minus_a_code
  end type inc_X_minus_a

  !> field3 = scalar*field1 - field2
  type, public, extends(kernel_type) :: aX_minus_Y
     private
     type(arg_type) :: meta_args(4) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: aX_minus_Y_code
  end type aX_minus_Y

  !> field3 = field1 - scalar*field2
  type, public, extends(kernel_type) :: X_minus_bY
     private
     type(arg_type) :: meta_args(4) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_minus_bY_code
  end type X_minus_bY

  !> field1 = field1 - scalar*field2
  type, public, extends(kernel_type) :: inc_X_minus_bY
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1),    &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,      ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_minus_bY_code
  end type inc_X_minus_bY

  !> field3 = scalar1*field1 - scalar2*field2
  type, public, extends(kernel_type) :: aX_minus_bY
     private
     type(arg_type) :: meta_args(5) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: aX_minus_bY_code
  end type aX_minus_bY

! ------------------------------------------------------------------- !
! ============== Multiplying (scaled) real fields =================== !
! ------------------------------------------------------------------- !

  !> field3 = field1*field2
  type, public, extends(kernel_type) :: X_times_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_WRITE, ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1)          &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_times_Y_code
  end type X_times_Y

  !> field1 = field1*field2
  type, public, extends(kernel_type) :: inc_X_times_Y
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_READWRITE, ANY_SPACE_1),     &
          arg_type(GH_FIELD, GH_REAL, GH_READ,      ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_times_Y_code
  end type inc_X_times_Y

  !> field1 = scalar*field1*field2
  type, public, extends(kernel_type) :: inc_aX_times_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,      ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_aX_times_Y_code
  end type inc_aX_times_Y

! ------------------------------------------------------------------- !
! ============== Scaling real fields ================================ !
! ------------------------------------------------------------------- !

  !> field2 = scalar*field1
  type, public, extends(kernel_type) :: a_times_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: a_times_X_code
  end type a_times_X

  !> field = scalar*field
  type, public, extends(kernel_type) :: inc_a_times_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_a_times_X_code
  end type inc_a_times_X

! ------------------------------------------------------------------- !
! ============== Dividing real fields =============================== !
! ------------------------------------------------------------------- !

  !> field3 = field1/field2
  type, public, extends(kernel_type) :: X_divideby_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_WRITE, ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1)          &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_divideby_Y_code
  end type X_divideby_Y

  !> field1 = field1/field2
  type, public, extends(kernel_type) :: inc_X_divideby_Y
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_READWRITE, ANY_SPACE_1),     &
          arg_type(GH_FIELD, GH_REAL, GH_READ,      ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_divideby_Y_code
  end type inc_X_divideby_Y

  !> field2 = field1/scalar
  type, public, extends(kernel_type) :: X_divideby_a
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              )         &

          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_divideby_a_code
  end type X_divideby_a

  !> field = field/scalar
  type, public, extends(kernel_type) :: inc_X_divideby_a
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1),    &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  )     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_divideby_a_code
  end type inc_X_divideby_a

! ------------------------------------------------------------------- !
! ============== Inverse scaling of real fields ===================== !
! ------------------------------------------------------------------- !

  !> field2 = scalar/field1
  type, public, extends(kernel_type) :: a_divideby_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: a_divideby_X_code
  end type a_divideby_X

  !> field = scalar/field
  type, public, extends(kernel_type) :: inc_a_divideby_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  ),    &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_a_divideby_X_code
  end type inc_a_divideby_X

! ------------------------------------------------------------------- !
! ============== Raising a real field to a scalar =================== !
! ------------------------------------------------------------------- !

  !> field =  field**rscalar (real scalar)
  type, public, extends(kernel_type) :: inc_X_powreal_a
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1),    &
          arg_type(GH_SCALAR, GH_REAL, GH_READ                  )     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_powreal_a_code
  end type inc_X_powreal_a

  !> field =  field**iscalar (integer scalar)
  type, public, extends(kernel_type) :: inc_X_powint_n
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD,  GH_REAL,    GH_READWRITE, ANY_SPACE_1), &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ                  )  &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_X_powint_n_code
  end type inc_X_powint_n

! ------------------------------------------------------------------- !
! ============== Setting real field elements to a value  ============ !
! ------------------------------------------------------------------- !

  !> field = scalar
  type, public, extends(kernel_type) :: setval_c
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              )         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: setval_c_code
  end type setval_c

  !> field2 = field1
  type, public, extends(kernel_type) :: setval_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_REAL, GH_WRITE, ANY_SPACE_1),         &
          arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_SPACE_1)          &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: setval_X_code
  end type setval_X

! ------------------------------------------------------------------- !
! ============== Inner product of real fields ======================= !
! ------------------------------------------------------------------- !

  !> innprod = innprod + field1(i,j,..)*field2(i,j,...)
  type, public, extends(kernel_type) :: X_innerproduct_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_SUM              ),         &
          arg_type(GH_FIELD,  GH_REAL, GH_READ, ANY_SPACE_1),         &
          arg_type(GH_FIELD,  GH_REAL, GH_READ, ANY_SPACE_1)          &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_innerproduct_Y_code
  end type X_innerproduct_Y

  !> innprod = innprod + field(i,j,..)*field(i,j,...)
  type, public, extends(kernel_type) :: X_innerproduct_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_SUM              ),         &
          arg_type(GH_FIELD,  GH_REAL, GH_READ, ANY_SPACE_1)          &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: X_innerproduct_X_code
  end type X_innerproduct_X

! ------------------------------------------------------------------- !
! ============== Sum real field elements ============================ !
! ------------------------------------------------------------------- !

  !> sumfld = SUM(field(:,:,...))
  type, public, extends(kernel_type) :: sum_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_SUM              ),         &
          arg_type(GH_FIELD,  GH_REAL, GH_READ, ANY_SPACE_1)          &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: sum_X_code
  end type sum_X

! ------------------------------------------------------------------- !
! ============== Sign of real field elements ======================== !
! ------------------------------------------------------------------- !

  !> field2 = SIGN(scalar, field1)
  type, public, extends(kernel_type) :: sign_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: sign_X_code
  end type sign_X

! ------------------------------------------------------------------- !
! ============== Maximum of (real scalar, real field elements) ====== !
! ------------------------------------------------------------------- !

  !> field2 = MAX(scalar, field1)
  type, public, extends(kernel_type) :: max_aX
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: max_aX_code
  end type max_aX

  !> field = MAX(scalar, field)
  type, public, extends(kernel_type) :: inc_max_aX
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_max_aX_code
  end type inc_max_aX

! ------------------------------------------------------------------- !
! ============== Minimum of (real scalar, real field elements) ====== !
! ------------------------------------------------------------------- !

  !> field2 = MIN(scalar, field1)
  type, public, extends(kernel_type) :: min_aX
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_REAL, GH_WRITE, ANY_SPACE_1),        &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READ,  ANY_SPACE_1)         &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: min_aX_code
  end type min_aX

  !> field = MIN(scalar, field)
  type, public, extends(kernel_type) :: inc_min_aX
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_REAL, GH_READ              ),        &
          arg_type(GH_FIELD,  GH_REAL, GH_READWRITE, ANY_SPACE_1)     &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: inc_min_aX_code
  end type inc_min_aX

! ------------------------------------------------------------------- !
! ============== Converting real to integer field elements ========== !
! ------------------------------------------------------------------- !

  !> ifield2 = int(field1, i_def)
  type, public, extends(kernel_type) :: int_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_INTEGER, GH_WRITE, ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_REAL,    GH_READ,  ANY_SPACE_1)       &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_X_code
  end type int_X

! ******************************************************************* !
! ************** Built-ins for integer-valued fields **************** !
! ******************************************************************* !

! ------------------------------------------------------------------- !
! ============== Adding integer fields ============================== !
! ------------------------------------------------------------------- !

  !> ifield3 = ifield1 + ifield2
  type, public, extends(kernel_type) :: int_X_plus_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD, GH_INTEGER, GH_WRITE, ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,  ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,  ANY_SPACE_1)       &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_X_plus_Y_code
  end type int_X_plus_Y

  !> ifield1 = ifield1 + ifield2
  type, public, extends(kernel_type) :: int_inc_X_plus_Y
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_INTEGER, GH_READWRITE, ANY_SPACE_1),  &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,      ANY_SPACE_1)   &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_X_plus_Y_code
  end type int_inc_X_plus_Y

  !> ifield2 = iscalar + ifield1
  type, public, extends(kernel_type) :: int_a_plus_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_WRITE, ANY_SPACE_1),     &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              ),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READ,  ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_a_plus_X_code
  end type int_a_plus_X

  !> ifield = iscalar + ifield
  type, public, extends(kernel_type) :: int_inc_a_plus_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ                  ), &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READWRITE, ANY_SPACE_1)  &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_a_plus_X_code
  end type int_inc_a_plus_X

! ------------------------------------------------------------------- !
! ============== Subtracting integer fields ========================= !
! ------------------------------------------------------------------- !

  !> ifield3 = ifield1 - ifield2
  type, public, extends(kernel_type) :: int_X_minus_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD, GH_INTEGER, GH_WRITE, ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,  ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,  ANY_SPACE_1)       &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_X_minus_Y_code
  end type int_X_minus_Y

  !> ifield1 = ifield1 - ifield2
  type, public, extends(kernel_type) :: int_inc_X_minus_Y
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_INTEGER, GH_READWRITE, ANY_SPACE_1),  &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,      ANY_SPACE_1)   &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_X_minus_Y_code
  end type int_inc_X_minus_Y

  !> ifield2 = iscalar - ifield1
  type, public, extends(kernel_type) :: int_a_minus_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_WRITE, ANY_SPACE_1),     &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              ),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READ,  ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_a_minus_X_code
  end type int_a_minus_X

  !> ifield = iscalar - ifield
  type, public, extends(kernel_type) :: int_inc_a_minus_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ                  ), &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READWRITE, ANY_SPACE_1)  &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_a_minus_X_code
  end type int_inc_a_minus_X

  !> ifield2 = ifield1 - iscalar
  type, public, extends(kernel_type) :: int_X_minus_a
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_WRITE, ANY_SPACE_1),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READ,  ANY_SPACE_1),     &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              )      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_X_minus_a_code
  end type int_X_minus_a

  !> ifield = ifield - iscalar
  type, public, extends(kernel_type) :: int_inc_X_minus_a
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READWRITE, ANY_SPACE_1), &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              )      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_X_minus_a_code
  end type int_inc_X_minus_a

! ------------------------------------------------------------------- !
! ============== Multiplying integer fields ========================= !
! ------------------------------------------------------------------- !

  !> ifield3 = ifield1*ifield2
  type, public, extends(kernel_type) :: int_X_times_Y
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD, GH_INTEGER, GH_WRITE, ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,  ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,  ANY_SPACE_1)       &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_X_times_Y_code
  end type int_X_times_Y

  !> ifield1 = ifield1*ifield2
  type, public, extends(kernel_type) :: int_inc_X_times_Y
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_INTEGER, GH_READWRITE, ANY_SPACE_1),  &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,      ANY_SPACE_1)   &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_X_times_Y_code
  end type int_inc_X_times_Y

! ------------------------------------------------------------------- !
! ============== Scaling integer fields ============================= !
! ------------------------------------------------------------------- !

  !> ifield2 = iscalar*ifield1
  type, public, extends(kernel_type) :: int_a_times_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_WRITE, ANY_SPACE_1),     &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              ),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READ,  ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_a_times_X_code
  end type int_a_times_X

  !> ifield = iscalar*ifield
  type, public, extends(kernel_type) :: int_inc_a_times_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ                  ), &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READWRITE, ANY_SPACE_1)  &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_a_times_X_code
  end type int_inc_a_times_X

! ------------------------------------------------------------------- !
! ============== Setting integer field elements to a value  ========= !
! ------------------------------------------------------------------- !

  !> ifield = iscalar
  type, public, extends(kernel_type) :: int_setval_c
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_WRITE, ANY_SPACE_1),     &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              )      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_setval_c_code
  end type int_setval_c

  !> ifield2 = ifield1
  type, public, extends(kernel_type) :: int_setval_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_INTEGER, GH_WRITE, ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,  ANY_SPACE_1)       &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_setval_X_code
  end type int_setval_X

! ------------------------------------------------------------------- !
! ============== Sign of integer field elements ===================== !
! ------------------------------------------------------------------- !

  !> ifield2 = SIGN(iscalar, ifield1)
  type, public, extends(kernel_type) :: int_sign_X
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_WRITE, ANY_SPACE_1),     &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              ),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READ,  ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_sign_X_code
  end type int_sign_X

! ------------------------------------------------------------------- !
! ======== Maximum of (integer scalar, integer field elements) ====== !
! ------------------------------------------------------------------- !

  !> ifield2 = MAX(iscalar, ifield1)
  type, public, extends(kernel_type) :: int_max_aX
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_WRITE, ANY_SPACE_1),     &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              ),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READ,  ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_max_aX_code
  end type int_max_aX

  !> ifield = MAX(iscalar, ifield)
  type, public, extends(kernel_type) :: int_inc_max_aX
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              ),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READWRITE, ANY_SPACE_1)  &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_max_aX_code
  end type int_inc_max_aX

! ------------------------------------------------------------------- !
! ======== Minimum of (integer scalar, integer field elements) ====== !
! ------------------------------------------------------------------- !

  !> ifield2 = MIN(iscalar, ifield1)
  type, public, extends(kernel_type) :: int_min_aX
     private
     type(arg_type) :: meta_args(3) = (/                              &
          arg_type(GH_FIELD,  GH_INTEGER, GH_WRITE, ANY_SPACE_1),     &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              ),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READ,  ANY_SPACE_1)      &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_min_aX_code
  end type int_min_aX

  !> ifield = MIN(iscalar, ifield)
  type, public, extends(kernel_type) :: int_inc_min_aX
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_SCALAR, GH_INTEGER, GH_READ              ),     &
          arg_type(GH_FIELD,  GH_INTEGER, GH_READWRITE, ANY_SPACE_1)  &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: int_inc_min_aX_code
  end type int_inc_min_aX

! ------------------------------------------------------------------- !
! ============== Converting integer to real field elements ========== !
! ------------------------------------------------------------------- !

  !> field2 = real(ifield1, r_def)
  type, public, extends(kernel_type) :: real_X
     private
     type(arg_type) :: meta_args(2) = (/                              &
          arg_type(GH_FIELD, GH_REAL,    GH_WRITE, ANY_SPACE_1),      &
          arg_type(GH_FIELD, GH_INTEGER, GH_READ,  ANY_SPACE_1)       &
          /)
     integer :: operates_on = DOF
   contains
     procedure, nopass :: real_X_code
  end type real_X

contains

  ! ***** Real-valued fields ***** !
  ! Adding (scaled) real fields
  subroutine X_plus_Y_code()
  end subroutine X_plus_Y_code

  subroutine inc_X_plus_Y_code()
  end subroutine inc_X_plus_Y_code

  subroutine a_plus_X_code()
  end subroutine a_plus_X_code

  subroutine inc_a_plus_X_code()
  end subroutine inc_a_plus_X_code

  subroutine aX_plus_Y_code()
  end subroutine aX_plus_Y_code

  subroutine inc_aX_plus_Y_code()
  end subroutine inc_aX_plus_Y_code

  subroutine inc_X_plus_bY_code()
  end subroutine inc_X_plus_bY_code

  subroutine aX_plus_bY_code()
  end subroutine aX_plus_bY_code

  subroutine inc_aX_plus_bY_code()
  end subroutine inc_aX_plus_bY_code

  subroutine aX_plus_aY_code()
  end subroutine aX_plus_aY_code

  ! Subtracting (scaled) real fields
  subroutine X_minus_Y_code()
  end subroutine X_minus_Y_code

  subroutine inc_X_minus_Y_code()
  end subroutine inc_X_minus_Y_code

  subroutine a_minus_X_code()
  end subroutine a_minus_X_code

  subroutine inc_a_minus_X_code()
  end subroutine inc_a_minus_X_code

  subroutine X_minus_a_code()
  end subroutine X_minus_a_code

  subroutine inc_X_minus_a_code()
  end subroutine inc_X_minus_a_code

  subroutine aX_minus_Y_code()
  end subroutine aX_minus_Y_code

  subroutine X_minus_bY_code()
  end subroutine X_minus_bY_code

  subroutine inc_X_minus_bY_code()
  end subroutine inc_X_minus_bY_code

  subroutine aX_minus_bY_code()
  end subroutine aX_minus_bY_code

  ! Multiplying (scaled) real fields
  subroutine X_times_Y_code()
  end subroutine X_times_Y_code

  subroutine inc_X_times_Y_code()
  end subroutine inc_X_times_Y_code

  subroutine inc_aX_times_Y_code()
  end subroutine inc_aX_times_Y_code

  ! Multiplying real fields by a real scalar
  ! (scaling fields)
  subroutine a_times_X_code()
  end subroutine a_times_X_code

  subroutine inc_a_times_X_code()
  end subroutine inc_a_times_X_code

  ! Dividing real fields
  subroutine X_divideby_Y_code()
  end subroutine X_divideby_Y_code

  subroutine inc_X_divideby_Y_code()
  end subroutine inc_X_divideby_Y_code

  subroutine X_divideby_a_code()
  end subroutine X_divideby_a_code

  subroutine inc_X_divideby_a_code()
  end subroutine inc_X_divideby_a_code

  ! Dividing a real scalar by elements of a
  ! real field (inverse scaling of fields)
  subroutine a_divideby_X_code()
  end subroutine a_divideby_X_code

  subroutine inc_a_divideby_X_code()
  end subroutine inc_a_divideby_X_code

  ! Raising a real field to a scalar
  subroutine inc_X_powreal_a_code()
  end subroutine inc_X_powreal_a_code

  subroutine inc_X_powint_n_code()
  end subroutine inc_X_powint_n_code

  ! Setting real field elements to a real scalar
  ! or other real field's values
  subroutine setval_c_code()
  end subroutine setval_c_code

  subroutine setval_X_code()
  end subroutine setval_X_code

  ! Inner product of real fields
  subroutine X_innerproduct_Y_code()
  end subroutine X_innerproduct_Y_code

  subroutine X_innerproduct_X_code()
  end subroutine X_innerproduct_X_code

  ! Sum values of a real field
  subroutine sum_X_code()
  end subroutine sum_X_code

  ! Sign of real field elements
  subroutine sign_X_code()
  end subroutine sign_X_code

  ! Maximum of (real scalar, real field elements)
  subroutine max_aX_code()
  end subroutine max_aX_code

  subroutine inc_max_aX_code()
  end subroutine inc_max_aX_code

  ! Minimum of (real scalar, real field elements)
  subroutine min_aX_code()
  end subroutine min_aX_code

  subroutine inc_min_aX_code()
  end subroutine inc_min_aX_code

  ! Converting real to integer field elements
  subroutine int_X_code()
  end subroutine int_X_code

  ! ***** Integer-valued fields ***** !
  ! Adding integer fields
  subroutine int_X_plus_Y_code()
  end subroutine int_X_plus_Y_code

  subroutine int_inc_X_plus_Y_code()
  end subroutine int_inc_X_plus_Y_code

  subroutine int_a_plus_X_code()
  end subroutine int_a_plus_X_code

  subroutine int_inc_a_plus_X_code()
  end subroutine int_inc_a_plus_X_code

  ! Subtracting integer fields
  subroutine int_X_minus_Y_code()
  end subroutine int_X_minus_Y_code

  subroutine int_inc_X_minus_Y_code()
  end subroutine int_inc_X_minus_Y_code

  subroutine int_a_minus_X_code()
  end subroutine int_a_minus_X_code

  subroutine int_inc_a_minus_X_code()
  end subroutine int_inc_a_minus_X_code

  subroutine int_X_minus_a_code()
  end subroutine int_X_minus_a_code

  subroutine int_inc_X_minus_a_code()
  end subroutine int_inc_X_minus_a_code

  ! Multiplying integer fields
  subroutine int_X_times_Y_code()
  end subroutine int_X_times_Y_code

  subroutine int_inc_X_times_Y_code()
  end subroutine int_inc_X_times_Y_code

  ! Multiplying integer fields by an integer scalar
  ! (scaling fields)
  subroutine int_a_times_X_code()
  end subroutine int_a_times_X_code

  subroutine int_inc_a_times_X_code()
  end subroutine int_inc_a_times_X_code

  ! Setting integer field elements to an integer scalar
  ! or other integer field's values
  subroutine int_setval_c_code()
  end subroutine int_setval_c_code

  subroutine int_setval_X_code()
  end subroutine int_setval_X_code

  ! Sign of integer field elements
  subroutine int_sign_X_code()
  end subroutine int_sign_X_code

  ! Maximum of (integer scalar, integer field elements)
  subroutine int_max_aX_code()
  end subroutine int_max_aX_code

  subroutine int_inc_max_aX_code()
  end subroutine int_inc_max_aX_code

  ! Minimum of (integer scalar, integer field elements)
  subroutine int_min_aX_code()
  end subroutine int_min_aX_code

  subroutine int_inc_min_aX_code()
  end subroutine int_inc_min_aX_code

  ! Converting integer to real field elements
  subroutine real_X_code()
  end subroutine real_X_code

end module lfric_builtins_mod

!> \brief Compute the mass flux in the y direction, cv
!! \detail Given the current pressure and velocity fields,
!! computes the mass flux in the y direction.
module compute_cv_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod
  use field_mod
  implicit none

  private

  public invoke_compute_cv
  public compute_cv, compute_cv_code

  type, extends(kernel_type) :: compute_cv
     type(go_arg), dimension(3) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_CV, GO_POINTWISE),            & ! cv
             go_arg(GO_READ,  GO_CT, GO_STENCIL(000,010,010)), & ! p
             go_arg(GO_READ,  GO_CV, GO_POINTWISE)             & ! v
           /)
     !> This kernel writes only to internal points of the
     !! simulation domain.
     integer :: ITERATES_OVER = GO_INTERNAL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => compute_cv_code
  end type compute_cv

contains

  !===================================================

  !> Manual implementation of the code needed to invoke
  !! compute_cv_code().
  subroutine invoke_compute_cv(cvfld, pfld, vfld)
    implicit none
    type(r2d_field), intent(inout) :: cvfld
    type(r2d_field), intent(in)    :: pfld, vfld
    ! Locals
    integer :: I, J

    ! Note that we do not loop over the full extent of the field.
    ! Fields are allocated with extents (M+1,N+1).
    ! Presumably the extra row and column are needed for periodic BCs.
    ! We are updating a quantity on CV.
    ! This loop writes to cv(1:M,2:N+1) so this looks like
    ! (using x to indicate a location that is written):
    !
    ! i=1   i=M
    !  x  x  x  o 
    !  x  x  x  o   j=N
    !  x  x  x  o
    !  o  o  o  o   j=1

    ! Quantity CV is mass flux in y direction.

    ! Original code looked like:
    !
    !    DO J=1,N
    !      DO I=1,M
    !           CV(I,J+1) = .5*(P(I,J+1)+P(I,J))*V(I,J+1)
    !      END DO
    !    END DO

    ! cv(i,j) depends upon:
    !   p(i,j-1), p(i,j) : CT
    !    => vertical CT neighbours of the CV pt being updated
    !   v(i,j)           : CV
    !    => the velocity component at the CV pt being updated

    !   vi-1j+1--fij+1---vij+1---fi+1j+1
    !   |        |       |       |
    !   |        |       |       |
    !   Ti-1j----uij-----Tij-----ui+1j
    !   |        |       |       |
    !   |        |       |       |
    !   vi-1j----fij-----vij-----fi+1j
    !   |        |       |       |
    !   |        |       |       |
    !   Ti-1j-1--uij-1---Tij-1---ui+1j-1
    !

    do J=cvfld%internal%ystart, cvfld%internal%ystop
       do I=cvfld%internal%xstart, cvfld%internal%xstop

          call compute_cv_code(i, j, cvfld%data, pfld%data, vfld%data)
       end do
    end do

  end subroutine invoke_compute_cv

  !===================================================

  !> Compute the mass flux in the y direction at point (i,j)
  subroutine compute_cv_code(i, j, cv, p, v)
    implicit none
    integer,  intent(in) :: I, J
    real(go_wp), intent(out), dimension(:,:) :: cv
    real(go_wp), intent(in),  dimension(:,:) :: p, v

    CV(I,J) = .5d0*(P(I,J)+P(I,J-1))*V(I,J)

  end subroutine compute_cv_code

end module compute_cv_mod

program simple
  use kind_params_mod, only : go_wp
  use grid_mod
  use field_mod
  use gocean_mod, only : gocean_initialise
  use compute_cu_mod, only : compute_cu
  use compute_cv_mod, only : compute_cv
  use compute_z_mod, only : compute_z
  use compute_h_mod, only : compute_h
  use psy_simple, only : invoke_0
  TYPE(grid_type), TARGET :: model_grid
  integer, allocatable, dimension(:,:) :: tmask
  type(r2d_field) :: p_fld
  type(r2d_field) :: u_fld
  type(r2d_field) :: v_fld
  type(r2d_field) :: cu_fld
  type(r2d_field) :: cv_fld
  type(r2d_field) :: z_fld
  type(r2d_field) :: h_fld
  integer :: ncycle
  integer :: ierr
  integer :: jpiglo
  integer :: jpjglo

  jpiglo = 50
  jpjglo = 50
  call gocean_initialise()
  model_grid = grid_type(GO_ARAKAWA_C,(/GO_BC_PERIODIC, GO_BC_PERIODIC, GO_BC_NONE/),GO_OFFSET_SW)
  call model_grid%decompose(jpiglo, jpjglo)
  ALLOCATE(tmask(model_grid % subdomain % global % nx, model_grid % subdomain % global % ny), STAT = ierr)
  if (ierr /= 0) then
    STOP 'Failed to allocate T mask'
  end if
  tmask(:,:) = 0
  call grid_init(model_grid, 1000.0_go_wp, 1000.0_go_wp, tmask)
  p_fld = r2d_field(model_grid,GO_T_POINTS)
  u_fld = r2d_field(model_grid,GO_U_POINTS)
  v_fld = r2d_field(model_grid,GO_V_POINTS)
  cu_fld = r2d_field(model_grid,GO_U_POINTS)
  cv_fld = r2d_field(model_grid,GO_V_POINTS)
  z_fld = r2d_field(model_grid,GO_F_POINTS)
  h_fld = r2d_field(model_grid,GO_T_POINTS)
  WRITE(*, *) "Simulation start"
  do ncycle = 1, 100, 1
    call invoke_0(cu_fld, p_fld, u_fld, cv_fld, v_fld, z_fld, h_fld)
  enddo
  WRITE(*, *) "Simulation end"

end program simple

!-----------------------------------------------------------------------------
! (C) Crown copyright 2019 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------
! LICENCE is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE
! -----------------------------------------------------------------------------
!
! BSD 3-Clause License
!
! Modifications copyright (c) 2019-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified A. R. Porter, STFC Daresbury Lab
! Modified I. Kavcic, Met Office

!> @brief Perform the prolongation operation from a coarse grid field to a fine
!!        grid field
!> @details Prolong the coarse grid correction into all cells on the fine grid
!!          that are contained in that coarse grid cell. Values are assumed to
!!          be pointwise scalar values so no area weighting is used

module prolong_kernel_mod

use constants_mod,           only: i_def, r_def
use kernel_mod,              only: kernel_type
use argument_mod,            only: arg_type,                  &
                                   GH_FIELD, GH_REAL,         &
                                   CELL_COLUMN,               &
                                   GH_READ, GH_READWRITE,     &
                                   ANY_DISCONTINUOUS_SPACE_1, &
                                   ANY_DISCONTINUOUS_SPACE_2, &
                                   GH_COARSE, GH_FINE

implicit none

private

type, public, extends(kernel_type) :: prolong_kernel_type
   private
   type(arg_type) :: meta_args(2) = (/                                       &
        arg_type(GH_FIELD, GH_REAL, GH_READWRITE, ANY_DISCONTINUOUS_SPACE_1, &
                                                  mesh_arg=GH_FINE),         &
        arg_type(GH_FIELD, GH_REAL, GH_READ,      ANY_DISCONTINUOUS_SPACE_2, &
                                                  mesh_arg=GH_COARSE)        &
        /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: prolong_kernel_code
end type prolong_kernel_type

public :: prolong_kernel_code

contains

  !> @brief Subroutine to perform the prolongation operation
  !> @param[in] nlayers Number of layers in a model column
  !> @param[in] cell_map Map of which fine grid cells lie in the coarse grid
  !!                     cell
  !> @param[in] ncell_f_per_c_x Number of fine cells per coarse cell in x-direction
  !> @param[in] ncell_f_per_c_y Number of fine cells per coarse cell in y-direction
  !> @param[in] ncell_f Number of cells in the fine grid
  !> @param[in,out] fine Fine grid field to update
  !> @param[in] coarse Coarse grid field to prolong
  !> @param[in] ndf Number of degrees of freedom per cell on both the coarse and
  !!                fine grid
  !> @param[in] undf_f Total number of degrees of freedom on the fine grid
  !> @param[in] dofmap_f Cell dofmap on the fine grid
  !> @param[in] undf_c Total number of degrees of freedom on the coarse grid
  !> @param[in] dofmap_c Cell dofmap on the coarse grid
  subroutine prolong_kernel_code(nlayers,         &
                                 cell_map,        &
                                 ncell_f_per_c_x, &
                                 ncell_f_per_c_y, &
                                 ncell_f,         &
                                 fine,            &
                                 coarse,          &
                                 ndf,             &
                                 undf_f,          &
                                 dofmap_f,        &
                                 undf_c,          &
                                 dofmap_c)

    implicit none

    integer(kind=i_def), intent(in) :: nlayers
    integer(kind=i_def), intent(in) :: ncell_f_per_c_x
    integer(kind=i_def), intent(in) :: ncell_f_per_c_y
    integer(kind=i_def), dimension(ncell_f_per_c_x, ncell_f_per_c_y), intent(in) :: cell_map
    integer(kind=i_def), intent(in) :: ncell_f
    integer(kind=i_def), intent(in) :: ndf
    integer(kind=i_def), dimension(ndf, ncell_f), intent(in) :: dofmap_f
    integer(kind=i_def), dimension(ndf), intent(in) :: dofmap_c
    integer(kind=i_def), intent(in) :: undf_f, undf_c
    real(kind=r_def), dimension(undf_c), intent(in)    :: coarse
    real(kind=r_def), dimension(undf_f), intent(inout) :: fine

    integer(kind=i_def) :: df, k, lp_x, lp_y

    do k = 0, nlayers-1
      do df = 1, ndf
        do lp_y = 1, ncell_f_per_c_y
          do lp_x = 1, ncell_f_per_c_x
            fine(dofmap_f(df,cell_map(lp_x,lp_y))+k) &
                  = fine(dofmap_f(df,cell_map(lp_x,lp_y))+k) + coarse(dofmap_c(df)+k)
          end do
        end do
      end do
    end do

  end subroutine prolong_kernel_code

end module prolong_kernel_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office

!> This module implements a simple NetCDF writer using the PSyData
!! interface. It is specific to the LFRic infrastructure library.
!! A Fortran code instrumented with corresponding calls
!! to the PSyData API and linked in with this library will write
!! the requested input and output parameters to a NetCDF file.
!!

module extract_psy_data_mod

    use, intrinsic :: iso_fortran_env, only : int64, int32
    use extract_netcdf_base_mod,       only : ExtractNetcdfBaseType, CheckError

    implicit none

    !> This is the data type that manages the information required
    !! to write data to a NetCDF file using the PSyData API. A
    !! static instance of this type is created for each instrumented
    !! region with PSyclone (and each region will write a separate
    !! file).
    type, extends(ExtractNetcdfBaseType), public :: extract_PsyDataType

    contains

        ! The various procedures defined here
        procedure :: DeclareField
        procedure :: WriteField
        procedure :: DeclareFieldVector
        procedure :: WriteFieldVector
        procedure :: DeclareIntField
        procedure :: WriteIntField
        procedure :: DeclareIntFieldVector
        procedure :: WriteIntFieldVector

        !> Declare generic interface for PreDeclareVariable:
        generic, public :: PreDeclareVariable => &
                           DeclareField,         &
                           DeclareFieldVector,   &
                           DeclareIntField,      &
                           DeclareIntFieldVector

        !> The generic interface for providing the value of variables,
        !! which in case of the kernel extraction writes the data to
        !! the NetCDF file.
        generic, public :: ProvideVariable => &
                           WriteField,        &
                           WriteFieldVector,  &
                           WriteIntField,     &
                           WriteIntFieldVector

    end type extract_PSyDataType

contains

    ! -------------------------------------------------------------------------
    !> This subroutine declares an LFRic field with real-valued data.
    !! It calls the PreDeclareVariable function provided by the base class
    !! (depending on the type of the argument, e.g. it might call
    !! DeclareArray1dDouble).
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareField(this, name, value)

        use field_mod, only : field_type, field_proxy_type

        implicit none

        class(extract_PsyDataType), intent(inout), target :: this
        character(*), intent(in)                          :: name
        type(field_type), intent(in)                      :: value

        type(field_proxy_type) :: value_proxy

        value_proxy = value%get_proxy()
        call this%PreDeclareVariable(name, value_proxy%data)

    end subroutine DeclareField

    ! -------------------------------------------------------------------------
    !> This subroutine declares an LFRic field with integer-valued data.
    !! It calls the PreDeclareVariable function provided by the base class
    !! (depending on the type of the argument, e.g. it might call
    !! DeclareArray1dInt).
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareIntField(this, name, value)

        use integer_field_mod, only : integer_field_type, &
                                      integer_field_proxy_type

        implicit none

        class(extract_PsyDataType), intent(inout), target :: this
        character(*), intent(in)                          :: name
        type(integer_field_type), intent(in)              :: value

        type(integer_field_proxy_type) :: value_proxy

        value_proxy = value%get_proxy()
        call this%PreDeclareVariable(name, value_proxy%data)

    end subroutine DeclareIntField

    ! -------------------------------------------------------------------------
    !> This subroutine writes the values of an LFRic real-valued field.
    !! to the NetCDF file. It uses the corresponding function
    !! provided by the base class.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteField(this, name, value)

        use field_mod, only : field_type, field_proxy_type

        implicit none

        class(extract_PsyDataType), intent(inout), target :: this
        character(*), intent(in)                          :: name
        type(field_type), intent(in)                      :: value

        type(field_proxy_type) :: value_proxy

        value_proxy = value%get_proxy()
        call this%ProvideVariable(name, value_proxy%data)

    end subroutine WriteField

    ! -------------------------------------------------------------------------
    !> This subroutine writes the values of an LFRic integer-valued field.
    !! to the NetCDF file. It uses the corresponding function
    !! provided by the base class.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteIntField(this, name, value)

        use integer_field_mod, only : integer_field_type, &
                                      integer_field_proxy_type

        implicit none

        class(extract_PsyDataType), intent(inout), target :: this
        character(*), intent(in)                          :: name
        type(integer_field_type), intent(in)              :: value

        type(integer_field_proxy_type) :: value_proxy

        value_proxy = value%get_proxy()
        call this%ProvideVariable(name, value_proxy%data)

    end subroutine WriteIntField

    ! -------------------------------------------------------------------------
    !> This subroutine declares an LFric real-valued field vector. Each
    !! component of the vector is stored as a separate variable, using the
    !! corresponding array function of the base class.
    !! @param[in,out] this The instance of the extract_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareFieldVector(this, name, value)

        use netcdf,    only : nf90_def_dim, nf90_def_var, NF90_REAL8
        use field_mod, only : field_type, field_proxy_type

        implicit none

        class(extract_PSyDataType), intent(inout), target :: this
        character(*), intent(in)                          :: name
        type(field_type), dimension(:), intent(in)        :: value

        integer                :: i
        type(field_proxy_type) :: value_proxy
        character(9)           :: number

        ! Provide each component of the vector as an individual 1d array.
        ! The base class will re-allocate internal array sizes if required
        do i = 1, size(value)
            value_proxy = value(i)%get_proxy()
            ! We add a '%' here to avoid a potential name clash if
            ! the user should have a vector field 'a' (which is now stored
            ! as a%1, a%2, ...), and a field 'a1'
            write(number, '("%",i0)') i
            call this%PreDeclareVariable(name//trim(number), value_proxy%data)
        enddo

    end subroutine DeclareFieldVector

    ! -------------------------------------------------------------------------
    !> This subroutine declares an LFric integer-valued field vector. Each
    !! component of the vector is stored as a separate variable, using the
    !! corresponding array function of the base class.
    !! @param[in,out] this The instance of the extract_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareIntFieldVector(this, name, value)

        use netcdf,            only : nf90_def_dim, nf90_def_var, NF90_INT4
        use integer_field_mod, only : integer_field_type, &
                                      integer_field_proxy_type

        implicit none

        class(extract_PSyDataType), intent(inout), target  :: this
        character(*), intent(in)                           :: name
        type(integer_field_type), dimension(:), intent(in) :: value

        integer                        :: i
        type(integer_field_proxy_type) :: value_proxy
        character(9)                   :: number

        ! Provide each component of the vector as an individual 1d array.
        ! The base class will re-allocate internal array sizes if required
        do i = 1, size(value)
            value_proxy = value(i)%get_proxy()
            ! We add a '%' here to avoid a potential name clash if
            ! the user should have a vector field 'a' (which is now stored
            ! as a%1, a%2, ...), and a field 'a1'
            write(number, '("%",i0)') i
            call this%PreDeclareVariable(name//trim(number), value_proxy%data)
        enddo

    end subroutine DeclareIntFieldVector

    ! -------------------------------------------------------------------------
    !> This subroutine writes an LFRic real-valued field vector to the NetCDF
    !! file. Each component is stored as an individual variable using the
    !! corresponding array function of the base class.
    !! @param[in,out] this The instance of the extract_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteFieldVector(this, name, value)

        use netcdf,    only : nf90_put_var
        use field_mod, only : field_type, field_proxy_type

        implicit none

        class(extract_PSyDataType), intent(inout), target :: this
        character(*), intent(in)                          :: name
        type(field_type), dimension(:), intent(in)        :: value

        integer                :: i
        type(field_proxy_type) :: value_proxy
        character(9)           :: number

        ! Provide each dimension of the vector as an individual 1d array.
        do i = 1, size(value, 1)
            value_proxy = value(i)%get_proxy()
            write(number, '("%",i0)') i
            call this%ProvideVariable(name//trim(number), value_proxy%data)
        enddo

    end subroutine WriteFieldVector

! -------------------------------------------------------------------------
    !> This subroutine writes an LFRic integer-valued field vector to the
    !! NetCDF file. Each component is stored as an individual variable
    !! using the corresponding array function of the base class.
    !! @param[in,out] this The instance of the extract_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteIntFieldVector(this, name, value)

        use netcdf,            only : nf90_put_var
        use integer_field_mod, only : integer_field_type, &
                                      integer_field_proxy_type

        implicit none

        class(extract_PSyDataType), intent(inout), target  :: this
        character(*), intent(in)                           :: name
        type(integer_field_type), dimension(:), intent(in) :: value

        integer                        :: i
        type(integer_field_proxy_type) :: value_proxy
        character(9)                   :: number

        ! Provide each dimension of the vector as an individual 1d array.
        do i = 1, size(value, 1)
            value_proxy = value(i)%get_proxy()
            write(number, '("%",i0)') i
            call this%ProvideVariable(name//trim(number), value_proxy%data)
        enddo

    end subroutine WriteIntFieldVector

end module extract_psy_data_mod

program adj_test
  use testkern_mod, only : testkern_code
  use testkern_mod_adj, only : testkern_code_adj
  integer, parameter :: array_extent = 20
  integer, parameter :: npts = array_extent
  real, parameter :: overall_tolerance = 1500.0
  real :: inner1
  real :: inner2
  real :: ascalar
  real :: ascalar_input
  real, dimension(npts) :: field1
  real, dimension(npts) :: field1_input
  real, dimension(npts) :: field2
  real, dimension(npts) :: field2_input
  real, dimension(npts) :: field3
  real, dimension(npts) :: field3_input
  real :: MachineTol
  real :: relative_diff

  ! Initialise the kernel arguments and keep copies of them
  CALL random_number(ascalar)
  ascalar_input = ascalar
  CALL random_number(field1)
  field1_input = field1
  CALL random_number(field2)
  field2_input = field2
  CALL random_number(field3)
  field3_input = field3
  ! Call the tangent-linear kernel
  call testkern_code(ascalar, field1, field2, field3, npts)
  ! Compute the inner product of the results of the tangent-linear kernel
  inner1 = 0.0
  inner1 = inner1 + ascalar * ascalar
  inner1 = inner1 + DOT_PRODUCT(field1, field1)
  inner1 = inner1 + DOT_PRODUCT(field2, field2)
  inner1 = inner1 + DOT_PRODUCT(field3, field3)
  ! Call the adjoint of the kernel
  call testkern_code_adj(ascalar, field1, field2, field3, npts)
  ! Compute inner product of results of adjoint kernel with the original inputs to the tangent-linear kernel
  inner2 = 0.0
  inner2 = inner2 + ascalar * ascalar_input
  inner2 = inner2 + DOT_PRODUCT(field1, field1_input)
  inner2 = inner2 + DOT_PRODUCT(field2, field2_input)
  inner2 = inner2 + DOT_PRODUCT(field3, field3_input)
  ! Test the inner-product values for equality, allowing for the precision of the active variables
  MachineTol = SPACING(MAX(ABS(inner1), ABS(inner2)))
  relative_diff = ABS(inner1 - inner2) / MachineTol
  if (relative_diff < overall_tolerance) then
    WRITE(*, *) 'Test of adjoint of ''testkern_code'' PASSED: ', inner1, inner2, relative_diff
  else
    WRITE(*, *) 'Test of adjoint of ''testkern_code'' FAILED: ', inner1, inner2, relative_diff
  end if

end program adj_test

!-----------------------------------------------------------------------------
! (C) Crown copyright 2021 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------
! LICENCE is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE
! ----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified: R. W. Ford, STFC Daresbury Lab

module impose_min_flux_kernel_mod

use argument_mod,            only : arg_type,                         &
                                    GH_FIELD, GH_OPERATOR, GH_SCALAR, &
                                    GH_REAL, GH_READ, GH_READINC,     &
                                    CELL_COLUMN
                                    
use fs_continuity_mod,       only : W3, W2
use constants_mod,           only : r_def, i_def, tiny_eps, l_def, EPS
use kernel_mod,              only : kernel_type
use log_mod,                 only : log_event,           &
                                    log_scratch_space,   &
                                    LOG_LEVEL_INFO

implicit none

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------

type, public, extends(kernel_type) :: impose_min_flux_kernel_type
  private
  type(arg_type) :: meta_args(6) = (/                      &
       arg_type(GH_FIELD,    GH_REAL, GH_READ,    W3),     &
       arg_type(GH_FIELD,    GH_REAL, GH_READINC, W2),     &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,    W3, W2), &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,    W3, W3), &
       arg_type(GH_SCALAR,   GH_REAL, GH_READ),            &
       arg_type(GH_SCALAR,   GH_REAL, GH_READ)             &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: impose_min_flux_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public :: impose_min_flux_code

contains

!> @brief Modify the flux so the updated field f(n+1) is greater than field_min
!!        i.e., f(n+1) = f(n) - dts*div(flux) >= field_min
!! @param[in] cell Horizontal cell index
!! @param[in] nlayers Number of layers
!! @param[in] field Field at level time n
!! @param[in,out] flux Input/output
!! @param[in] ncell_3d1 Total number of cells related to div
!! @param[in] div Divergence operator used in the update
!! @param[in] ncell_3d2 Total number of cells related to div_multiplier
!! @param[in] div_multiplier Divergence multiplier used in the update
!! @param[in] field_min The minimum value we want to enfore for the updated field
!! @param[in] dts  The time-step used in the update
!! @param[in] ndf1 Number of degrees of freedom per cell for the output field
!! @param[in] undf1 Unique number of degrees of freedom  for the output field
!! @param[in] map1 Dofmap for the cell at the base of the column for the output field
!! @param[in] ndf2 Number of degrees of freedom per cell for the input field
!! @param[in] undf2 Unique number of degrees of freedom for the input field
!! @param[in] map2 Dofmap for the cell at the base of the column for the input field
subroutine impose_min_flux_code(cell,              &
                                nlayers,           &
                                field, flux,       &
                                ncell_3d1,         &
                                div,               &
                                ncell_3d2,         &
                                div_multiplier,    &
                                field_min,         &
                                dts,               &
                                ndf1, undf1, map1, &
                                ndf2, undf2, map2  )

  implicit none

  ! Arguments
  integer(kind=i_def),                  intent(in) :: cell, nlayers
  integer(kind=i_def),                  intent(in) :: ncell_3d1, ncell_3d2
  integer(kind=i_def),                  intent(in) :: undf1, ndf1
  integer(kind=i_def),                  intent(in) :: undf2, ndf2
  integer(kind=i_def), dimension(ndf1), intent(in) :: map1
  integer(kind=i_def), dimension(ndf2), intent(in) :: map2
  real(kind=r_def), dimension(undf2),               intent(inout) :: flux
  real(kind=r_def), dimension(undf1),               intent(in)    :: field
  real(kind=r_def), dimension(ndf1,ndf2,ncell_3d1), intent(in)    :: div
  real(kind=r_def), dimension(ndf1,ndf1,ncell_3d2), intent(in)    :: div_multiplier
  real(kind=r_def), intent(in)                                    :: field_min
  real(kind=r_def), intent(in)                                    :: dts

  ! Internal variables
  integer(kind=i_def)                  :: k, ik, df1, df2
  real(kind=r_def), dimension(ndf2)    :: cell_fluxes
  real(kind=r_def)                     :: a, b, inc, inc_n, flux_scaler
  integer(kind=i_def), dimension(ndf2) :: flux_change_id

  do k = 0, nlayers-1

    ! flux is read (gathered) here so needs to have valid values,
    ! including any halo values that are accessed.
    do df2 = 1, ndf2
      cell_fluxes(df2) = flux(map2(df2)+k)
    end do
    ik = (cell-1)*nlayers + k + 1

    do df1 = 1, ndf1

       inc_n = 0.0_r_def
       flux_change_id = 0_i_def

       do df2 = 1, ndf2
         inc = - dts*div(df1,df2,ik)*div_multiplier(df1,df1,ik)*cell_fluxes(df2)
         if ( inc < 0.0_r_def ) then
             inc_n = inc_n - inc
             flux_change_id(df2) = 1_i_def
         end if
       end do

       a = field(map1(df1)+k) - (field_min + EPS)
       b = a / max(inc_n, EPS)
       flux_scaler = min(max(0.0_r_def,b),1.0_r_def)

       ! flux is incremented here and is continuous in the horizontal
       ! so for this access the outermost halo region that is accessed
       ! does not need to contain valid flux values (as the resultant
       ! flux values will be incorrect even if the flux values were
       ! valid). However the kernel itself does require these flux
       ! values to be valid due to the earlier read, which makes the
       ! kernel flux access GH_READINC.
       do df2 = 1, ndf2
          if ( flux_change_id(df2) == 1_i_def ) then
              flux(map2(df2)+k) = flux(map2(df2)+k) * flux_scaler
          end if
       end do

    end do

  end do

end subroutine impose_min_flux_code

end module impose_min_flux_kernel_mod

module compute_unew_mod
  USE kind_params_mod
  USE kernel_mod
  use argument_mod
  use grid_mod
  use field_mod
  implicit none

  private

  public invoke_compute_unew
  public compute_unew, compute_unew_code

  type, extends(kernel_type) :: compute_unew
     type(go_arg), dimension(7) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_CU, GO_POINTWISE),        & ! unew
             go_arg(GO_READ,  GO_CU, GO_POINTWISE),        & ! uold
             go_arg(GO_READ,  GO_CF, GO_STENCIL(010,010,000)),        & ! z
             go_arg(GO_READ,  GO_CV, GO_STENCIL(110,110,000)),        & ! cv
             go_arg(GO_READ,  GO_CT, GO_STENCIL(000,110,000)),        & ! h
             go_arg(GO_READ,  GO_R_SCALAR, GO_POINTWISE),  & ! tdt
             go_arg(GO_READ,  GO_GRID_DY_CONST)            & ! dy
           /)
     !> This kernel operates on fields that live on an
     !! orthogonal, regular grid.
     integer :: GRID_TYPE = GO_ORTHOGONAL_REGULAR

     !> We only have one value per grid point and that means
     !! we have a single DOF per grid point.
     integer :: ITERATES_OVER = GO_INTERNAL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => compute_unew_code
  end type compute_unew

contains

  !===================================================

  subroutine invoke_compute_unew(unew, uold, z, cv, h, tdt)
    implicit none
    type(r2d_field), intent(inout) :: unew
    type(r2d_field), intent(in)    :: uold, z, cv, h
    real(go_wp), intent(in) :: tdt
    ! Locals
    integer  :: I, J
    real(go_wp) :: dx

    ! Note that we do not loop over the full extent of the field.
    ! Fields are allocated with extents (M+1,N+1).
    ! Presumably the extra row and column are needed for periodic BCs.
    ! We are updating a quantity on CU.
    ! This loop writes to unew(2:M+1,1:N) so this looks like
    ! (using x to indicate a location that is written):
    !
    ! i=1   i=M
    !  o  o  o  o 
    !  o  x  x  x   j=N
    !  o  x  x  x
    !  o  x  x  x   j=1

    ! unew(i,j) depends upon:
    !   uold(i,j)
    !   z(i,j+1),  z(i,j)
    !  cv(i,j),   cv(i,j+1), cv(i-1,j+1), cv(i-1,j)
    !   h(i,j),    h(i-1,j)

    ! Swap indices, e.g. XX(i+1,j) => YY(i,j+1)
    ! Any field on U replaced with field on V
    ! => produces same code for the update of corresponding field on V.

    ! Original code looked like:
    !
    ! DO J=1,N
    !   DO I=1,M
    !     UNEW(I+1,J) = UOLD(I+1,J)+                                     &
    !         TDTS8*(Z(I+1,J+1)+Z(I+1,J))*(CV(I+1,J+1)+CV(I,J+1)+CV(I,J) &
    !        +CV(I+1,J))-TDTSDX*(H(I+1,J)-H(I,J))                       
    !   END DO
    ! END DO
    dx = unew%grid%dx

    DO J=unew%internal%ystart, unew%internal%ystop, 1
       DO I=unew%internal%xstart, unew%internal%xstop, 1

          CALL compute_unew_code(i, j,                 &
                                 unew%data, uold%data, &
                                 z%data, cv%data, h%data, tdt, dx)
       END DO
    END DO

  END SUBROUTINE invoke_compute_unew

  !===================================================

  subroutine compute_unew_code(i, j,  &
                               unew, uold, z, cv, h, tdt, dx)
    implicit none
    integer,  intent(in) :: I, J
    real(go_wp), intent(in) :: dx
    real(go_wp), intent(out), dimension(:,:) :: unew
    real(go_wp), intent(in),  dimension(:,:) :: uold, z, cv, h
    real(go_wp), intent(in) :: tdt
    ! Locals
    real(go_wp) :: tdts8, tdtsdx

    !> These quantities are computed here because tdt is not
    !! constant. (It is == dt for first time step, 2xdt for
    !! all remaining time steps.)
    tdts8 = tdt/8.0d0
    tdtsdx = tdt/dx

    UNEW(I,J) = UOLD(I,J) +                     &
                TDTS8*(Z(I,J+1) + Z(I,J)) * &
                (CV(I,J+1)+CV(I-1,J+1)+CV(I-1,J)+CV(I,J)) -   &
                TDTSDX*(H(I,J)-H(I-1,J))

  end subroutine compute_unew_code

end module compute_unew_mod

PROGRAM main
  USE main_psy, ONLY: invoke_testkern_w0
  USE main_psy, ONLY: invoke_initialise_fields
  USE global_mesh_base_mod, ONLY: global_mesh_base_type
  USE global_mesh_netcdf_mod, ONLY: global_mesh_netcdf_type
  USE mesh_mod, ONLY: mesh_type, PLANE
  USE partition_mod, ONLY: partition_type, partitioner_planar, partitioner_interface
  USE extrusion_mod, ONLY: uniform_extrusion_type
  USE function_space_mod, ONLY: function_space_type
  USE fs_continuity_mod, ONLY: W0, W1, W2, W2V, W2H
  USE field_mod, ONLY: field_type
  USE testkern_w0_kernel_mod, ONLY: testkern_w0_kernel_type
  USE constants_mod, ONLY: r_def, i_def
  USE log_mod, ONLY: LOG_LEVEL_ALWAYS
  IMPLICIT NONE
  TYPE(global_mesh_netcdf_type), TARGET :: global_mesh
  CLASS(global_mesh_base_type), POINTER :: global_mesh_ptr
  TYPE(partition_type) :: partition
  TYPE(mesh_type), TARGET :: mesh
  TYPE(uniform_extrusion_type), TARGET :: extrusion
  TYPE(uniform_extrusion_type), POINTER :: extrusion_ptr
  TYPE(function_space_type), TARGET :: vector_space
  TYPE(function_space_type), POINTER :: vector_space_ptr
  PROCEDURE(partitioner_interface), POINTER :: partitioner_ptr
  TYPE(field_type) :: field1, field2
  INTEGER(KIND = i_def) :: lfric_fs = W0
  INTEGER(KIND = i_def) :: element_order = 1
  INTEGER(KIND = i_def) :: ndata_sz
  global_mesh = global_mesh_netcdf_type("mesh_BiP128x16-400x100.nc", "dynamics")
  global_mesh_ptr => global_mesh
  partitioner_ptr => partitioner_planar
  partition = partition_type(global_mesh_ptr, partitioner_ptr, 1, 1, 0, 0, 1)
  extrusion = uniform_extrusion_type(0.0_r_def, 100.0_r_def, 5)
  extrusion_ptr => extrusion
  mesh = mesh_type(global_mesh_ptr, partition, extrusion_ptr)
  WRITE(*, *) "Mesh has", mesh % get_nlayers(), "layers."
  ndata_sz = 1
  vector_space = function_space_type(mesh, element_order, lfric_fs, ndata_sz)
  vector_space_ptr => vector_space
  CALL field1 % initialise(vector_space = vector_space_ptr, name = "field1")
  CALL field2 % initialise(vector_space = vector_space_ptr, name = "field2")
  CALL invoke_initialise_fields(field1, field2)
  CALL invoke_testkern_w0(field1, field2)
  CALL field1 % log_minmax(LOG_LEVEL_ALWAYS, "minmax of field1")
END PROGRAM main

module tra_adv_compute_mod

  implicit none

contains

  subroutine tra_adv_compute(pun, pvn, pwn, umask, vmask, tmask, mydomain, jpi, jpj, jpk)
    implicit none

    REAL*8, DIMENSION(:,:,:), intent(in)   :: pun, pvn, pwn, umask, vmask, tmask
    REAL*8, DIMENSION(:,:,:), intent(inout)   :: mydomain
    INTEGER, INTENT(IN) :: jpi, jpj, jpk
    ! Not sure what to do with 2D and 1D arrays in the SIR backend
    !REAL*8, DIMENSION(:,:)     :: ztfreez, rnfmsk, upsmsk
    !REAL*8, DIMENSION(:)       :: rnfmsk_z
    REAL*8, DIMENSION(:,:,:)    :: rnfmsk, upsmsk, rnfmsk_z, zice
    
    ! local variables
    REAL*8, DIMENSION(jpi,jpj, jpk)               :: zslpx, zslpy, zwx, zwy, zind
    REAL*8                                        :: zu, z0u, zzwx, zv, z0v, zzwy, ztra, zbtr, zdt, zalpha
    REAL*8                                        :: zw, z0w
    INTEGER                                       :: ji, jj, jk

    ! Mapping of 1D and 2D arrays not yet supported in the SIR backend
    !DO jk = 1, jpk
    !   DO jj = 1, jpj
    !      DO ji = 1, jpi
    !         IF( tsn(ji,jj,jk) <= ztfreez(ji,jj) + 0.1d0 ) THEN   ;   zice = 1.d0
    !         ELSE                                                 ;   zice = 0.d0
    !         ENDIF
    !         zind(ji,jj,jk) = MAX (   &
    !            rnfmsk(ji,jj) * rnfmsk_z(jk),      & 
    !            upsmsk(ji,jj)               ,      &
    !            zice                               &
    !            &                  ) * tmask(ji,jj,jk)
    !      END DO
    !   END DO
    !END DO
    
    ! Create a temporary similar loop structure to the original
    ! commented out version above to test out the MAX intrinsic
    ! transformation.
    DO jk = 1, jpk
       DO jj = 1, jpj
          DO ji = 1, jpi
             zind(ji,jj,jk) = MAX (   &
                rnfmsk(ji,jj,jk) * rnfmsk_z(ji,jj,jk),      & 
                upsmsk(ji,jj,jk)               ,      &
                zice(ji,jj,jk)                               &
                &                  ) * tmask(ji,jj,jk)
             zind(ji,jj,jk) = 1 - zind(ji,jj,jk)
          END DO
       END DO
    END DO

    zwx(:,:,jpk) = 0.e0   ;   zwy(:,:,jpk) = 0.e0

    DO jk = 1, jpk-1
       DO jj = 1, jpj-1
          DO ji = 1, jpi-1
             zwx(ji,jj,jk) = umask(ji,jj,jk) * ( mydomain(ji+1,jj,jk) - mydomain(ji,jj,jk) )
             zwy(ji,jj,jk) = vmask(ji,jj,jk) * ( mydomain(ji,jj+1,jk) - mydomain(ji,jj,jk) )
          END DO
       END DO
    END DO

    zslpx(:,:,jpk) = 0.e0   ;   zslpy(:,:,jpk) = 0.e0

    DO jk = 1, jpk-1
       DO jj = 2, jpj
          DO ji = 2, jpi 
             zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji-1,jj  ,jk) )   &
                  &            * ( 0.25d0 + SIGN( 0.25d0, zwx(ji,jj,jk) * zwx(ji-1,jj  ,jk) ) )
             zslpy(ji,jj,jk) =                    ( zwy(ji,jj,jk) + zwy(ji  ,jj-1,jk) )   &
                  &            * ( 0.25d0 + SIGN( 0.25d0, zwy(ji,jj,jk) * zwy(ji  ,jj-1,jk) ) )
          END DO
       END DO
    END DO

    DO jk = 1, jpk-1    
       DO jj = 2, jpj
          DO ji = 2, jpi
             zslpx(ji,jj,jk) = SIGN( 1.d0, zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
                  &                                                2.d0*ABS( zwx  (ji-1,jj,jk) ),   &
                  &                                                2.d0*ABS( zwx  (ji  ,jj,jk) ) )
             zslpy(ji,jj,jk) = SIGN( 1.d0, zslpy(ji,jj,jk) ) * MIN(    ABS( zslpy(ji,jj  ,jk) ),   &
                  &                                                2.d0*ABS( zwy  (ji,jj-1,jk) ),   &
                  &                                                2.d0*ABS( zwy  (ji,jj  ,jk) ) )
          END DO
       END DO
    END DO

    DO jk = 1, jpk-1
       zdt  = 1
       DO jj = 2, jpj-1
          DO ji = 2, jpi-1
             z0u = SIGN( 0.5d0, pun(ji,jj,jk) )
             zalpha = 0.5d0 - z0u
             zu  = z0u - 0.5d0 * pun(ji,jj,jk) * zdt
             
             zzwx = mydomain(ji+1,jj,jk) + zind(ji,jj,jk) * (zu * zslpx(ji+1,jj,jk))
             zzwy = mydomain(ji  ,jj,jk) + zind(ji,jj,jk) * (zu * zslpx(ji  ,jj,jk))
             
             zwx(ji,jj,jk) = pun(ji,jj,jk) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
             
             z0v = SIGN( 0.5d0, pvn(ji,jj,jk) )
             zalpha = 0.5d0 - z0v
             zv  = z0v - 0.5d0 * pvn(ji,jj,jk) * zdt
             
             zzwx = mydomain(ji,jj+1,jk) + zind(ji,jj,jk) * (zv * zslpy(ji,jj+1,jk))
             zzwy = mydomain(ji,jj  ,jk) + zind(ji,jj,jk) * (zv * zslpy(ji,jj  ,jk))
             
             zwy(ji,jj,jk) = pvn(ji,jj,jk) * ( zalpha * zzwx + (1.d0-zalpha) * zzwy )
          END DO
       END DO
    END DO
    
    DO jk = 1, jpk-1
       DO jj = 2, jpj-1     
          DO ji = 2, jpi-1
             zbtr = 1.
             ztra = - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
                  &               + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  ) )
             mydomain(ji,jj,jk) = mydomain(ji,jj,jk) + ztra
          END DO
       END DO
    END DO
    
    zwx (:,:, 1 ) = 0.e0    ;    zwx (:,:,jpk) = 0.e0
    
    DO jk = 2, jpk-1   
       zwx(:,:,jk) = tmask(:,:,jk) * ( mydomain(:,:,jk-1) - mydomain(:,:,jk) )
    END DO

    zslpx(:,:,1) = 0.e0
    
    DO jk = 2, jpk-1    
       DO jj = 1, jpj
          DO ji = 1, jpi
             zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji,jj,jk+1) )   &
                  &            * ( 0.25d0 + SIGN( 0.25d0, zwx(ji,jj,jk) * zwx(ji,jj,jk+1) ) )
          END DO
       END DO
    END DO

    DO jk = 2, jpk-1     
       DO jj = 1, jpj
          DO ji = 1, jpi
             zslpx(ji,jj,jk) = SIGN( 1.d0, zslpx(ji,jj,jk) ) * MIN( ABS( zslpx(ji,jj,jk  ) ), &
                  &                                               2.d0*ABS( zwx  (ji,jj,jk+1) ),   &
                  &                                               2.d0*ABS( zwx  (ji,jj,jk  ) )  )
          END DO
       END DO
    END DO
    
    zwx(:,:, 1 ) = pwn(:,:,1) * mydomain(:,:,1)

    zdt  = 1
    zbtr = 1.
    DO jk = 1, jpk-1
       DO jj = 2, jpj-1     
          DO ji = 2, jpi-1
             z0w = SIGN( 0.5d0, pwn(ji,jj,jk+1) )
             zalpha = 0.5d0 + z0w
             zw  = z0w - 0.5d0 * pwn(ji,jj,jk+1) * zdt * zbtr
             
             zzwx = mydomain(ji,jj,jk+1) + zind(ji,jj,jk) * (zw * zslpx(ji,jj,jk+1))
             zzwy = mydomain(ji,jj,jk  ) + zind(ji,jj,jk) * (zw * zslpx(ji,jj,jk  ))
             
             zwx(ji,jj,jk+1) = pwn(ji,jj,jk+1) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
          END DO
       END DO
    END DO

    zbtr = 1.
    DO jk = 1, jpk-1
       DO jj = 2, jpj-1     
          DO ji = 2, jpi-1
             ztra = -zbtr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )
             mydomain(ji,jj,jk) = ztra
          END DO
       END DO
    END DO

  end subroutine tra_adv_compute

end module tra_adv_compute_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2017-2021, Science and Technology Facilities Council
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author R. W. Ford, STFC Daresbury Lab
! Modified I. Kavcic, Met Office

module testkern_stencil_multi_mod

  use argument_mod
  use fs_continuity_mod
  use kernel_mod
  use constants_mod

  implicit none

  type, extends(kernel_type) :: testkern_stencil_multi_type
     type(arg_type), dimension(4) :: meta_args =                        &
          (/ arg_type(gh_field, gh_real, gh_inc,  w1),                  &
             arg_type(gh_field, gh_real, gh_read, w2, stencil(cross)),  &
             arg_type(gh_field, gh_real, gh_read, w2, stencil(xory1d)), &
             arg_type(gh_field, gh_real, gh_read, w3, stencil(x1d))     &
           /)
     integer :: operates_on = cell_column
   contains
     procedure, nopass :: code => testkern_stencil_multi_code
  end type testkern_stencil_multi_type

contains

  subroutine testkern_stencil_multi_code()
  end subroutine testkern_stencil_multi_code

end module testkern_stencil_multi_mod

program alg
  use kind_params_mod, only : go_wp
  use parallel_mod
  use grid_mod
  use field_mod, only : go_t_points, r2d_field
  use gocean_mod, only : gocean_initialise
  use inc_field_mod, only : inc_field
  use psy_alg, only : invoke_0_inc_field
  integer, parameter :: nsteps = 10
  type(decomposition_type) :: decomp
  integer :: my_rank
  integer :: istp
  integer :: ierr
  integer :: this_step
  integer :: jpiglo
  integer :: jpjglo
  integer, allocatable, dimension(:,:) :: tmask
  type(r2d_field) :: fld1
  TYPE(grid_type), TARGET :: grid1
  integer :: nx
  integer :: ny

  jpiglo = 50
  jpjglo = 50
  call gocean_initialise()
  grid1 = grid_type(GO_ARAKAWA_C,(/GO_BC_PERIODIC, GO_BC_PERIODIC, GO_BC_NONE/),GO_OFFSET_SW)
  call grid1%decompose(jpiglo, jpjglo)
  my_rank = get_rank()
  ALLOCATE(tmask(grid1 % subdomain % global % nx, grid1 % subdomain % global % ny), STAT = ierr)
  if (ierr /= 0) then
    STOP 'Failed to allocate T mask'
  end if
  tmask(:,:) = 0
  call grid_init(grid1, 1000.0_go_wp, 1000.0_go_wp, tmask)
  fld1 = r2d_field(grid1,go_t_points)
  fld1%data(:,:) = 0.0_go_wp
  nx = fld1%whole%nx
  ny = fld1%whole%ny
  do istp = 1, nsteps, 1
    this_step = istp
    call invoke_0_inc_field(fld1, nx, ny, this_step)
  enddo
  WRITE(*, *) "nsteps = ", nsteps, "field(2,2) = ", fld1 % data(2, 2)

end program alg

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2018, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: A. R. Porter, STFC Daresbury Lab.

module compute_h_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod
  use field_mod
  implicit none

  private

  public compute_h, compute_h_code

  type, extends(kernel_type) :: compute_h
     type(go_arg), dimension(4) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_CT, GO_POINTWISE),        & ! h
             go_arg(GO_READ,  GO_CT, GO_POINTWISE),        & ! p
             go_arg(GO_READ,  GO_CU, GO_POINTWISE),        & ! u
             go_arg(GO_READ,  GO_CV, GO_POINTWISE)         & ! v
           /)
     !> This kernel writes only to internal points of the
     !! simulation domain.
     integer :: ITERATES_OVER = GO_INTERNAL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => compute_h_code
  end type compute_h

contains

  !===================================================

  SUBROUTINE compute_h_code(i, j, h, p, u, v)
    IMPLICIT none
    integer,  intent(in) :: I, J
    REAL(go_wp), INTENT(out), DIMENSION(:,:) :: h
    REAL(go_wp), INTENT(in),  DIMENSION(:,:) :: p, u, v

    H(I,J) = P(I,J)+.25d0*(U(I+1,J)*U(I+1,J)+U(I,J)*U(I,J) + & 
                           V(I,J+1)*V(I,J+1)+V(I,J)*V(I,J))

  END SUBROUTINE compute_h_code

END MODULE compute_h_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office

!> This module implements a verification that read-only fields (in the
!! dl_esm_inf infrastructure) are not overwritten (due to memory overwrites etc).
!! It is based on the ReadOnlyBaseType (from which it inherits the handling
!! of the basic Fortran data types and 2d-arrays, as specified in the Makefile).
!! It adds the support for the dl_esm_inf-specific field type.

module read_only_verify_psy_data_mod

    use, intrinsic :: iso_fortran_env, only : int64, int32,   &
                                              real32, real64, &
                                              stderr => Error_Unit

    use read_only_base_mod, only : ReadOnlyBaseType, read_only_verify_PSyDataInit, &
                 read_only_verify_PSyDataShutdown, is_enabled, &
                 read_only_verify_PSyDataStart, read_only_verify_PSyDataStop

    implicit none

    !> This is the data type that stores a checksum for each read-only
    !! variable. A static instance of this type is created for each
    !! instrumented region with PSyclone.
    type, extends(ReadOnlyBaseType), public :: read_only_verify_PSyDataType

    contains

        ! The various procedures used from this class
        procedure :: DeclareFieldDouble
        procedure :: ProvideFieldDouble
        procedure :: Abort

        !> Add the `DeclareFieldDouble` subroutine to the generic
        !! PreDeclareVariable interface. Note that the other generic
        !! `declareXXX` subroutines are declared in the PsyData base class.
        generic, public :: PreDeclareVariable => DeclareFieldDouble

        !> Add the function to handle fields to the generic interface.
        !! The ReadOnly base class provides additional methods for
        !! the generic interface like ProvideArray2dInt, ...
        generic, public :: ProvideVariable => ProvideFieldDouble

    end type read_only_verify_PSyDataType

contains

    ! -------------------------------------------------------------------------
    !> Displays the message and aborts execution. Use dl_esm_inf'subroutine
    !! `abort` function.
    !! @param[in] message Error message to be displayed (string).
    subroutine Abort(this, message)

        use gocean_mod, only : gocean_stop

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*) :: message

        call gocean_stop(message)

    end subroutine Abort

    ! -------------------------------------------------------------------------
    !> This subroutine declares a double precision field as defined in
    !! dl_esm_inf (r2d_field). It does nothing for the read-only verification.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    subroutine DeclareFieldDouble(this, name, value)

        use field_mod, only : r2d_field

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(r2d_field), intent(in) :: value

        this%next_var_index = this%next_var_index + 1

    end subroutine DeclareFieldDouble

    ! -------------------------------------------------------------------------
    !> This subroutine either computes a checksum or compares a checksum
    !! (depending on this%verify_checksums) of a dl_esm_field (r2d_field)
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideFieldDouble(this, name, value)

        use field_mod, only : r2d_field
        use read_onlY_base_mod, only : ComputeChecksum

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(r2d_field), intent(in) :: value
        integer(kind=int64) :: cksum

        this%next_var_index = this%next_var_index + 1

        if (.not. is_enabled) return

        cksum = ComputeChecksum(value%data)
        if(this%verify_checksums) then
            if(this%checksums(this%next_var_index) /= cksum) then
                write(stderr, *) "------------------- PSyData -------------------"
                write(stderr, *) "Double precision field ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                write(stderr, *) "Original checksum: ", this%checksums(this%next_var_index)
                write(stderr, *) "New checksum:      ", cksum
                write(stderr, *) "------------------- PSyData -------------------"
            else if(this%verbosity>1) then
                write(stderr, *) "PSyData: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = cksum
        endif

        this%next_var_index = this%next_var_index + 1

    end subroutine ProvideFieldDouble

end module read_only_verify_psy_data_mod

program shallow

!> @mainpage BENCHMARK WEATHER PREDICTION PROGRAM FOR COMPARING THE
!! PREFORMANCE OF CURRENT SUPERCOMPUTERS. THE MODEL IS
!! BASED OF THE PAPER - THE DYNAMICS OF FINITE-DIFFERENCE
!! MODELS OF THE SHALLOW-WATER EQUATIONS, BY ROBERT SADOURNY
!! J. ATM. SCIENCES, VOL 32, NO 4, APRIL 1975.
!!     
!! CODE BY PAUL N. SWARZTRAUBER, NATIONAL CENTER FOR
!! ATMOSPHERIC RESEARCH, BOULDER, CO,  OCTOBER 1984.
!! Modified by Juliana Rew, NCAR, January 2006
!
!     In this version, shallow4.f, initial and calculated values
!     of U, V, and P are written to a netCDF file
!     for later use in visualizing the results. The netCDF data
!     management library is freely available from
!     http://www.unidata.ucar.edu/software/netcdf
!     This code is still serial but has been brought up to modern
!     Fortran constructs and uses portable intrinsic Fortran 90 timing routines
!     This can be compiled on the IBM SP using:
!     xlf90 -qmaxmem=-1 -g -o shallow4 -qfixed=132 -qsclk=micro \
!     -I/usr/local/include shallow4.f -L/usr/local/lib32/r4i4 -l netcdf
!     where the -L and -I point to local installation of netCDF
!     
!     Changes from shallow4.f (Annette Osprey, January 2010):
!     - Converted to free-form fortran 90.  
!     - Some tidying up of old commented-out code.   
!     - Explicit type declarations.
!     - Variables n, m, itmax and mprint read in from namelist. 
!     - Dynamic array allocation.
!     - Only write to netcdf at mprint timesteps.
!     - Don't write wrap-around points to NetCDF file.
!     - Use 8-byte reals. 
!
!     This version heavily modified as part of the GOcean-2D project
!     with the mantra "all computation must occur in a kernel."
!     Andrew Porter, April 2014

  use kind_params_mod
  use shallow_io_mod
  use timing_mod
  use gocean_mod, only: model_write_log
  use model_mod
  use grid_mod
  use field_mod
  use initial_conditions_mod
  use time_smooth_mod,  only: time_smooth
  use apply_bcs_mod,    only: invoke_apply_bcs
  use compute_cu_mod,   only: compute_cu
  use compute_cv_mod,   only: compute_cv
  use compute_z_mod,    only: compute_z
  use compute_h_mod,    only: compute_h
  use compute_unew_mod, only: compute_unew
  use compute_vnew_mod, only: compute_vnew
  use compute_pnew_mod, only: compute_pnew
  use infrastructure_mod,only: copy
  implicit none

  type(grid_type), target :: model_grid
  !> Pressure at {current,previous,next} time step
  type(r2d_field) :: p_fld, pold_fld, pnew_fld
  !> Velocity in x direction at {current,previous,next} time step
  type(r2d_field) :: u_fld, uold_fld, unew_fld
  !> Velocity in x direction at {current,previous,next} time step
  type(r2d_field) :: v_fld, vold_fld, vnew_fld
  !> Mass flux in x and y directions
  type(r2d_field) :: cu_fld, cv_fld
  !> Potential vorticity
  type(r2d_field) :: z_fld
  !> Surface height
  type(r2d_field) :: h_fld
  !> Stream function
  type(r2d_field) :: psi_fld

  !> Loop counter for time-stepping loop
  INTEGER :: ncycle, itmax
   
  !> Integer tags for timers
  INTEGER :: idxt0, idxt1
  REAL(KIND=go_wp) dt, tdt

  !> \todo The call to grid_type here should *not* specify the grid
  !! offset choice as that is an implementation detail. PSyclone
  !! should re-write this call to pass the offset information after it
  !! has examined the kernels to see what they are expecting.
  model_grid = grid_type(GO_ARAKAWA_C,                           &
                         (/GO_BC_PERIODIC,GO_BC_PERIODIC,GO_BC_NONE/), &
                         GO_OFFSET_SW)

  !  ** Initialisations of model parameters (dt etc) **
  CALL model_init(model_grid)

  ! Create fields on this grid
  p_fld    = r2d_field(model_grid, GO_T_POINTS)
  pold_fld = r2d_field(model_grid, GO_T_POINTS)
  pnew_fld = r2d_field(model_grid, GO_T_POINTS)

  u_fld    = r2d_field(model_grid, GO_U_POINTS)
  uold_fld = r2d_field(model_grid, GO_U_POINTS)
  unew_fld = r2d_field(model_grid, GO_U_POINTS)

  v_fld    = r2d_field(model_grid, GO_V_POINTS)
  vold_fld = r2d_field(model_grid, GO_V_POINTS)
  vnew_fld = r2d_field(model_grid, GO_V_POINTS)

  cu_fld = r2d_field(model_grid, GO_U_POINTS)

  cv_fld = r2d_field(model_grid, GO_V_POINTS)

  z_fld = r2d_field(model_grid, GO_F_POINTS)

  h_fld = r2d_field(model_grid, GO_T_POINTS)

  psi_fld = r2d_field(model_grid, GO_F_POINTS)

  ! NOTE BELOW THAT TWO DELTA T (TDT) IS SET TO DT ON THE FIRST
  ! CYCLE AFTER WHICH IT IS RESET TO DT+DT.
  tdt = dt

  !     INITIAL VALUES OF THE STREAM FUNCTION AND P

  call init_initial_condition_params(p_fld)
  call invoke_init_stream_fn_kernel(psi_fld)
  call init_pressure(p_fld)

  !     INITIALIZE VELOCITIES
 
  call init_velocity_u(u_fld, psi_fld)
  call init_velocity_v(v_fld, psi_fld)

  !     PERIODIC CONTINUATION
  call invoke_apply_bcs(u_fld)
  call invoke_apply_bcs(v_fld)

  ! Generate and output checksums of initial fields
  CALL model_write_log("('psi initial CHECKSUM = ',E24.16)", &
                       field_checksum(psi_fld))
  CALL model_write_log("('P initial CHECKSUM = ',E24.16)",   &
                         field_checksum(p_fld))
  CALL model_write_log("('U initial CHECKSUM = ',E24.16)",   &
                       field_checksum(u_fld))
  CALL model_write_log("('V initial CHECKSUM = ',E24.16)",   &
                       field_checksum(v_fld))

  ! Initialise fields that will hold data at previous time step
  CALL copy_field(u_fld, uold_fld)
  CALL copy_field(v_fld, vold_fld)
  CALL copy_field(p_fld, pold_fld)
     
  ! Write intial values of p, u, and v into a netCDF file   
  call ascii_write(0, 'psifld.dat', psi_fld%data,            &
                   psi_fld%internal%nx, psi_fld%internal%ny, &
                   psi_fld%internal%xstart, psi_fld%internal%ystart)
  CALL model_write(0, p_fld, u_fld, v_fld)

  !     Start timer
  CALL timer_start('Time-stepping',idxt0)

  !  ** Start of time loop ** 
  DO ncycle=1,itmax
    
    ! COMPUTE CAPITAL U, CAPITAL V, Z AND H

    CALL timer_start('Compute c{u,v},z,h', idxt1)

    call invoke( compute_cu(CU_fld, p_fld, u_fld),      &
                 compute_cv(CV_fld, p_fld, v_fld),      &
                 compute_z(z_fld, p_fld, u_fld, v_fld), &
                 compute_h(h_fld, p_fld, u_fld, v_fld) )

    call timer_stop(idxt1)

    ! PERIODIC CONTINUATION

    call timer_start('PBCs-1',idxt1)
    ! This call could be generated automatically by PSyclone
    call invoke_apply_bcs(CU_fld)
    call invoke_apply_bcs(CV_fld)
    call invoke_apply_bcs(H_fld)
    call invoke_apply_bcs(Z_fld)
    call timer_stop(idxt1)

    ! COMPUTE NEW VALUES U,V AND P

    call timer_start('Compute new fields', idxt1)
    call invoke( compute_unew(unew_fld, uold_fld, z_fld, cv_fld, h_fld, tdt), &
                 compute_vnew(vnew_fld, vold_fld, z_fld, cu_fld, h_fld, tdt), &
                 compute_pnew(pnew_fld, pold_fld, cu_fld, cv_fld, tdt) )
    call timer_stop(idxt1)

    ! PERIODIC CONTINUATION
    call timer_start('PBCs-2',idxt1)
    ! This call could be generated by PSyclone
    call invoke_apply_bcs(UNEW_fld)
    call invoke_apply_bcs(VNEW_fld)
    call invoke_apply_bcs(PNEW_fld)
    call timer_stop(idxt1)

    ! Time is in seconds but we never actually need it
    !time = time + dt

    call model_write(ncycle, p_fld, u_fld, v_fld)

    ! TIME SMOOTHING AND UPDATE FOR NEXT CYCLE
    if(NCYCLE .GT. 1) then

      call timer_start('Time smoothing',idxt1)

      call invoke( time_smooth(u_fld, UNEW_fld, UOLD_fld), &
                   time_smooth(v_fld, VNEW_fld, VOLD_fld), &
                   time_smooth(p_fld, PNEW_fld, POLD_fld) )

      call timer_stop(idxt1)

    else ! ncycle == 1

      ! Make TDT actually = 2*DT
       tdt = tdt + dt

    endif ! ncycle > 1

    call timer_start('Field copy',idxt1)

    call invoke(                       &
                copy(u_fld, unew_fld), &
                copy(v_fld, vnew_fld), &
                copy(p_fld, pnew_fld)  &
               )
!    call copy_field(UNEW_fld, U_fld)
!    call copy_field(VNEW_fld, V_fld)
!    call copy_field(PNEW_fld, p_fld)

    call timer_stop(idxt1)

  end do

  !  ** End of time loop ** 

  call timer_stop(idxt0)

  ! Output field checksums at end of run for correctness check
  call model_write_log("('P CHECKSUM after ',I6,' steps = ',E24.16)", &
                       itmax, field_checksum(pnew_fld))
  call model_write_log("('U CHECKSUM after ',I6,' steps = ',E24.16)", &
                       itmax, field_checksum(unew_fld))
  call model_write_log("('V CHECKSUM after ',I6,' steps = ',E24.16)", &
                       itmax, field_checksum(vnew_fld))

  call model_finalise()

end program shallow

! Below is a manual implementation of the inc_x_plus_by builtin for
! testing purposes. If this is run through psyad 'psyad
! incx_plus_by.f90 -a field1 field2' (assuming that the fields are
! active and the scalar is not!) we find that the adjoint is the same
! as inc_x_plus_by, except that the fields are swapped. This gives a
! simple short term solution to writing the adjoint:
!
! call invoke(inc_x_plus_by(x,b,y)
!
! can simply be changed to
!
! call invoke(inc_x_plus_by(y,b,x)
!
subroutine inc_x_plus_by(field1, rscalar, field2)
  ! field1 and field2 are active
  real, intent(inout) :: field1(:)
  real, intent(in) :: field2(:), rscalar
  field1(:) = field1(:) + rscalar*field2(:)
end subroutine inc_x_plus_by

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2018-2021, Science and Technology Facilities
! Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by: I. Kavcic, Met Office
!              A. R. Porter, STFC Daresbury Laboratory
!-------------------------------------------------------------------------------
!> @brief Kernel which computes the boundary integral part of rhs of the
!>        thermodynamic equation for the nonlinear equations.
!>
!> @details The kernel computes the boundary integral on rhs of the
!>          thermodynamic equation for the nonlinear equations This consists of:
!>          rtheta_bd = theta * gamma * u * normal.
!>
module rtheta_bd_kernel_mod

  use argument_mod,          only : arg_type, func_type,         &
                                    mesh_data_type,              &
                                    reference_element_data_type, &
                                    GH_FIELD, GH_REAL,           &
                                    GH_READ, GH_READWRITE,       &
                                    STENCIL, CROSS,              &
                                    GH_BASIS, GH_DIFF_BASIS,     &
                                    GH_QUADRATURE_face,          &
                                    CELL_COLUMN, adjacent_face,  &
                                    normals_to_horizontal_faces, &
                                    outward_normals_to_horizontal_faces
  use constants_mod,         only : r_def, i_def, l_def
  use cross_product_mod,     only : cross_product
  use fs_continuity_mod,     only : W2, Wtheta
  use kernel_mod,            only : kernel_type
  use planet_config_mod,     only : cp

  implicit none

  private

  !---------------------------------------------------------------------------
  ! Public types
  !---------------------------------------------------------------------------
  !> The type declaration for the kernel. Contains the metadata needed by the
  !> PSy layer.
  type, public, extends(kernel_type) :: rtheta_bd_kernel_type
    private
    type(arg_type) :: meta_args(3) = (/                                     &
         arg_type(GH_FIELD, GH_REAL, GH_READWRITE, Wtheta),                 &
         arg_type(GH_FIELD, GH_REAL, GH_READ,      Wtheta, STENCIL(CROSS)), &
         arg_type(GH_FIELD, GH_REAL, GH_READ,      W2,     STENCIL(CROSS))  &
         /)
    type(func_type) :: meta_funcs(2) = (/                                   &
         func_type(W2,     GH_BASIS),                                       &
         func_type(Wtheta, GH_BASIS)                                        &
         /)
    type(mesh_data_type) :: meta_mesh(1) = (/                               &
         mesh_data_type( adjacent_face )                                    &
         /)
    type(reference_element_data_type) :: meta_reference_element(2) = (/     &
         reference_element_data_type( normals_to_horizontal_faces ),        &
         reference_element_data_type( outward_normals_to_horizontal_faces ) &
         /)
    integer :: operates_on = CELL_COLUMN
    integer :: gh_shape = GH_QUADRATURE_face
  contains
    procedure, nopass :: rtheta_bd_code
  end type

  !---------------------------------------------------------------------------
  ! Contained functions/subroutines
  !---------------------------------------------------------------------------
  public rtheta_bd_code

contains

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !> @brief Computes the boundary integral terms in the potential temperature.
  !>
  !> @param[in] nlayers Number of layers
  !> @param[in,out] r_theta_bd Right-hand side of the thermodynamic equation
  !> @param[in] theta Potential temperature field
  !> @param[in] stencil_wtheta_size Size of the Wtheta stencil (number of cells)
  !> @param[in] stencil_wtheta_map Wtheta dofmaps for the stencil
  !> @param[in] u Wind field
  !> @param[in] stencil_w2_size Size of the W2 stencil (number of cells)
  !> @param[in] stencil_w2_map W2 dofmaps for the stencil
  !> @param[in] ndf_wtheta Number of degrees of freedom per cell for Wtheta
  !> @param[in] undf_wtheta Number of unique degrees of freedom for Wtheta
  !> @param[in] map_wtheta Dofmap for the cell at the base of the column for
  !!                       Wtheta
  !> @param[in] wtheta_basis_face Wtheta basis functions evaluated at Gaussian
  !!                              quadrature points on horizontal faces
  !> @param[in] ndf_w2 Number of degrees of freedom per cell for W2
  !> @param[in] undf_w2 Number of unique degrees of freedom for W2
  !> @param[in] map_w2 Dofmap for the cell at the base of the column for W2
  !> @param[in] w2_basis_face W2 basis functions evaluated at Gaussian
  !!                          quadrature points on horizontal faces
  !> @param[in] nfaces_re_h Number of reference element faces bisected by a
  !!                        horizontal plane
  !> @param[in] normals_to_horizontal_faces Vector of normals to the reference
  !!                                        element horizontal faces
  !> @param[in] outward_normals_to_horizontal_faces Vector of normals to the
  !!                                                reference element horizontal
  !!                                                "outward faces"
  !> @param[in] adjacent_face Vector containing information on neighbouring
  !!                          face index for the current cell
  !> @param[in] nfaces_qr Number of faces in the quadrature rule
  !> @param[in] nqp_f Number of quadrature points on horizontal faces
  !> @param[in] wqp_f Quadrature weights on horizontal faces
  !>
  subroutine rtheta_bd_code( nlayers,                             &
                             r_theta_bd, theta,                   &
                             stencil_wtheta_size,                 &
                             stencil_wtheta_map,                  &
                             u,                                   &
                             stencil_w2_size, stencil_w2_map,     &
                             ndf_wtheta, undf_wtheta, map_wtheta, &
                             wtheta_basis_face,                   &
                             ndf_w2, undf_w2, map_w2,             &
                             w2_basis_face,                       &
                             nfaces_re_h,                         &
                             normals_to_horizontal_faces,         &
                             outward_normals_to_horizontal_faces, &
                             adjacent_face,                       &
                             nfaces_qr, nqp_f, wqp_f )

    implicit none

    ! Arguments
    integer(kind=i_def), intent(in) :: nlayers
    integer(kind=i_def), intent(in) :: nfaces_qr, nqp_f
    integer(kind=i_def), intent(in) :: ndf_w2, undf_w2
    integer(kind=i_def), intent(in) :: ndf_wtheta, undf_wtheta
    integer(kind=i_def), intent(in) :: nfaces_re_h

    integer(kind=i_def), intent(in) :: stencil_w2_size
    integer(kind=i_def), intent(in) :: stencil_wtheta_size

    integer(kind=i_def), dimension(ndf_w2,stencil_w2_size),         intent(in) :: stencil_w2_map
    integer(kind=i_def), dimension(ndf_wtheta,stencil_wtheta_size), intent(in) :: stencil_wtheta_map

    integer(kind=i_def), dimension(ndf_w2),     intent(in) :: map_w2
    integer(kind=i_def), dimension(ndf_wtheta), intent(in) :: map_wtheta

    real(kind=r_def), dimension(3,ndf_w2,nqp_f,nfaces_qr),     intent(in) :: w2_basis_face
    real(kind=r_def), dimension(1,ndf_wtheta,nqp_f,nfaces_qr), intent(in) :: wtheta_basis_face
    real(kind=r_def), dimension(nqp_f,nfaces_qr),              intent(in) :: wqp_f

    integer(kind=i_def), intent(in) :: adjacent_face(:)

    real(kind=r_def),    intent(in) :: normals_to_horizontal_faces(:,:)
    real(kind=r_def),    intent(in) :: outward_normals_to_horizontal_faces(:,:)

    real(kind=r_def), dimension(undf_wtheta), intent(inout) :: r_theta_bd
    real(kind=r_def), dimension(undf_wtheta), intent(in)    :: theta
    real(kind=r_def), dimension(undf_w2),     intent(in)    :: u

    ! Internal variables
    integer(kind=i_def) :: df, k, face, face_next
    integer(kind=i_def) :: qp
    integer(kind=i_def) :: i_face

    real(kind=r_def), dimension(ndf_wtheta) :: theta_e, theta_next_e
    real(kind=r_def), dimension(ndf_wtheta) :: rtheta_bd_e
    real(kind=r_def), dimension(ndf_w2)     :: u_e, u_next_e

    real(kind=r_def) :: u_at_uquad(3), u_next_at_uquad(3), face_next_inward_normal(3)
    real(kind=r_def) :: theta_at_uquad, theta_next_at_uquad
    real(kind=r_def) :: bdary_term, gamma_wtheta, sign_face_next_outward, flux_term

    logical(kind=l_def) :: upwind = .false.

    ! Assumes same number of horizontal qp in x and y

    do k = 0, nlayers-1

      do df = 1, ndf_wtheta
        rtheta_bd_e(df) = 0.0_r_def
      end do

      do face = 1, nfaces_re_h

        ! Storing opposite face number on neighbouring cell
        face_next = adjacent_face(face)
        i_face = int(floor(real(mod(face_next, nfaces_re_h),r_def)/2.0_r_def) + 1.0_r_def)
        sign_face_next_outward = (-1.0_r_def)**i_face
        face_next_inward_normal(:) = -sign_face_next_outward &
                                     * normals_to_horizontal_faces(:,face_next)

        ! Computing theta and f in adjacent cells

        do df = 1, ndf_w2
          u_e(df)      = u( stencil_w2_map(df, 1) + k )
          u_next_e(df) = u( stencil_w2_map(df, face+1) + k )
        end do

        do df = 1, ndf_wtheta
          theta_e(df)      = theta( stencil_wtheta_map(df, 1) + k )
          theta_next_e(df) = theta( stencil_wtheta_map(df, face+1) + k )
        end do

        ! Compute the boundary RHS integrated over one cell
        do qp = 1, nqp_f
          theta_at_uquad = 0.0_r_def
          theta_next_at_uquad = 0.0_r_def

          do df = 1, ndf_wtheta
            theta_at_uquad       = theta_at_uquad +      &
                                   theta_e(df)*wtheta_basis_face(1,df,qp,face)
            theta_next_at_uquad  = theta_next_at_uquad + &
                                   theta_next_e(df)*wtheta_basis_face(1,df,qp,face_next)
          end do

          u_at_uquad(:) = 0.0_r_def
          u_next_at_uquad(:) = 0.0_r_def

          do df = 1, ndf_w2
            u_at_uquad(:)       = u_at_uquad(:)      + u_e(df)     *w2_basis_face(:,df,qp,face)
            u_next_at_uquad(:)  = u_next_at_uquad(:) + u_next_e(df)*w2_basis_face(:,df,qp,face_next)
          end do

          flux_term = 0.5_r_def * (theta_next_at_uquad *                  &
                                   dot_product(u_next_at_uquad,           &
                                               face_next_inward_normal) + &
                                   theta_at_uquad      *                  &
                                   dot_product(u_at_uquad,                &
                                       outward_normals_to_horizontal_faces(:, face)))

          if (upwind) then
            flux_term = flux_term + 0.5_r_def *                                     &
                            abs(dot_product(                                        &
                                   u_at_uquad,                                      &
                                   outward_normals_to_horizontal_faces(:, face))) * &
                               (dot_product(                                        &
                                   theta_at_uquad *                                 &
                                   outward_normals_to_horizontal_faces(:, face),    &
                                   outward_normals_to_horizontal_faces(:, face)) -  &
                                dot_product(                                        &
                                   theta_next_at_uquad *                            &
                                   face_next_inward_normal,                         &
                                   face_next_inward_normal))
          end if

          do df = 1, ndf_wtheta
            gamma_wtheta  = wtheta_basis_face(1,df,qp,face)

            bdary_term = gamma_wtheta * flux_term
            rtheta_bd_e(df) = rtheta_bd_e(df) +  wqp_f(qp,face) * bdary_term
          end do

        end do ! qp

      end do ! faces

      do df = 1, ndf_wtheta
        r_theta_bd( stencil_wtheta_map(df, 1) + k ) =  &
                    r_theta_bd( stencil_wtheta_map(df, 1) + k ) + rtheta_bd_e(df)
      end do

    end do ! layers

  end subroutine rtheta_bd_code

end module rtheta_bd_kernel_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2018-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: J. Henrichs, Bureau of Meteorology
! Modified: I. Kavcic, Met Office

module profile_psy_data_mod

  use psy_data_base_mod, only : PSyDataBaseType, profile_PSyDataStart, &
                                profile_PSyDataStop, is_enabled

  implicit none

  type, extends(PSyDataBaseType) :: profile_PSyDataType
  contains
      ! The profiling API uses only the two following calls:
      procedure :: PreStart
      procedure :: PostEnd
  end type profile_PSyDataType

  logical :: has_been_initialised = .false.

contains

  ! ---------------------------------------------------------------------------
  !> An optional initialisation subroutine. It is not called directly from
  !> any PSyclone created code, but for most existing profiling libraries the
  !> application will have to call it. In this dummy library it is called once
  !> from ProfileStart.
  subroutine profile_PSyDataInit()

    implicit none

    if (is_enabled) then
       write(*,*) "profile_PSyDataInit called"
    else
       write(*,*) "profile_PSyDataInit called, but profiling is disabled"
    endif
    has_been_initialised = .true.

  end subroutine profile_PSyDataInit

  ! ---------------------------------------------------------------------------
  !> Starts a profiling area. The module and region name can be used to create
  !! a unique name for each region.
  !! Parameters:
  !! @param[in,out] this This PSyData instance.
  !! @param[in] module_name Name of the module in which the region is.
  !! @param[in] region_name Name of the region (could be name of an invoke,
  !!                        or subroutine name).
  !! @param[in] num_pre_vars The number of variables that are declared and
  !!                         written before the instrumented region.
  !! @param[in] num_post_vars The number of variables that are also declared
  !!                          before an instrumented region of code, but are
  !!                          written after this region.
  subroutine PreStart(this, module_name, region_name, num_pre_vars, &
                      num_post_vars)

    implicit none

    class(profile_PSyDataType), intent(inout), target :: this
    character(len=*), intent(in) :: module_name, region_name
    integer, intent(in) :: num_pre_vars, num_post_vars

    if ( .not. has_been_initialised ) then
       call profile_PSyDataInit()
    endif

    call this%PSyDataBaseType%PreStart(module_name, region_name, 0, 0)
    if (is_enabled) then
       write(*,*) "PreStart called for module '", module_name,  &
                  "' region '", region_name, "'"
    else
       write(*,*) "PreStart called for module '", module_name,  &
                  "' region '", region_name, "', but profiling is disabled"
    endif

  end subroutine PreStart

  ! ---------------------------------------------------------------------------
  !> Ends a profiling area. It takes a ProfileData type that corresponds to
  !> to the ProfileStart call.
  !> @param[in,out] this This PSyData instance.
  !
  subroutine PostEnd(this)

    implicit none

    class(profile_PSyDataType), intent(inout), target :: this

    if (is_enabled) then
       write(*,*) "PostEnd called for module '", trim(this%module_name), &
                  "' region '", trim(this%region_name), "'"
    else
       write(*,*) "PostEnd called for module '", trim(this%module_name), &
                  "' region '", trim(this%region_name), "', but profiling is disabled"
    endif

  end subroutine PostEnd

  ! ---------------------------------------------------------------------------
  !> The finalise function prints the results. This subroutine must be called
  !> for most profiling libraries, otherwise no results will be produced.
  !> This call must be added to the program explicitly, it is not called
  !> automatically.
  subroutine profile_PSyDataShutdown()

    implicit none

    write(*,*) "profile_PSyDataShutdown called"

  end subroutine profile_PSyDataShutdown

end module profile_psy_data_mod

MODULE helmholtz_solver_alg_mod
  CONTAINS
  SUBROUTINE apply_helmholtz_lhs(Hp, p)
    USE helmholtz_solver_alg_mod_psy, ONLY: invoke_0
    USE field_mod, ONLY: field_type
    USE operator_mod, ONLY: operator_type
    USE scaled_matrix_vector_kernel_mod, ONLY: opt_scaled_matrix_vector_kernel_type
    IMPLICIT NONE
    TYPE(field_type), INTENT(INOUT) :: Hp
    TYPE(field_type), INTENT(IN) :: p
    TYPE(field_type) :: grad_p, hb_inv, u_normalisation
    TYPE(operator_type) :: div_star
    CALL invoke_0(grad_p, p, div_star, hb_inv, u_normalisation)
  END SUBROUTINE apply_helmholtz_lhs
END MODULE helmholtz_solver_alg_mod
PROGRAM driver
  USE helmholtz_solver_alg_mod, ONLY: apply_helmholtz_lhs
  USE field_mod, ONLY: field_type
  TYPE(field_type) :: Hp, p
  CALL apply_helmholtz_lhs(Hp, p)
END PROGRAM driver

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2019-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office
! Modified by R. W. Ford, STFC Daresbury Lab
!
module matrix_vector_kernel_mod

  use argument_mod,            only : arg_type,                 &
                                      GH_FIELD, GH_OPERATOR,    &
                                      GH_REAL, GH_READ, GH_INC, &
                                      ANY_SPACE_1, ANY_SPACE_2, &
                                      CELL_COLUMN
  use constants_mod,           only : r_def, i_def
  use kernel_mod,              only : kernel_type

  implicit none

  private

  !------------------------------------------------------------------------------
  ! Public types
  !------------------------------------------------------------------------------

  type, public, extends(kernel_type) :: matrix_vector_kernel_type
    private
    type(arg_type) :: meta_args(3) = (/                                    &
         arg_type(GH_FIELD,    GH_REAL, GH_INC,  ANY_SPACE_1),             &
         arg_type(GH_FIELD,    GH_REAL, GH_READ, ANY_SPACE_2),             &
         arg_type(GH_OPERATOR, GH_REAL, GH_READ, ANY_SPACE_1, ANY_SPACE_2) &
         /)
    integer :: operates_on = CELL_COLUMN
  contains
    procedure, nopass :: matrix_vector_kernel_code
  end type

  !------------------------------------------------------------------------------
  ! Contained functions/subroutines
  !------------------------------------------------------------------------------
  public matrix_vector_kernel_code

contains

!> @brief Computes lhs = matrix*x
!! @param[in] cell Horizontal cell index
!! @param[in] nlayers Number of layers
!! @param[in,out] lhs Output lhs (A*x)
!! @param[in] x Input data
!! @param[in] ncell_3d Total number of cells
!! @param[in] matrix Local matrix assembly form of the operator A
!! @param[in] ndf1 Number of degrees of freedom per cell for the output field
!! @param[in] undf1 Unique number of degrees of freedom  for the output field
!! @param[in] map1 Dofmap for the cell at the base of the column for the
!!                 output field
!! @param[in] ndf2 Number of degrees of freedom per cell for the input field
!! @param[in] undf2 Unique number of degrees of freedom for the input field
!! @param[in] map2 Dofmap for the cell at the base of the column for the
!!                 input field
subroutine matrix_vector_kernel_code(cell,              &
                                     nlayers,           &
                                     lhs, x,            &
                                     ncell_3d,          &
                                     matrix,            &
                                     ndf1, undf1, map1, &
                                     ndf2, undf2, map2)

  implicit none

  ! Arguments
  integer(kind=i_def),                  intent(in) :: cell, nlayers, ncell_3d
  integer(kind=i_def),                  intent(in) :: undf1, ndf1
  integer(kind=i_def),                  intent(in) :: undf2, ndf2
  integer(kind=i_def), dimension(ndf1), intent(in) :: map1
  integer(kind=i_def), dimension(ndf2), intent(in) :: map2
  real(kind=r_def), dimension(undf2),              intent(in)    :: x
  real(kind=r_def), dimension(undf1),              intent(inout) :: lhs
  real(kind=r_def), dimension(ndf1,ndf2,ncell_3d), intent(in)    :: matrix

  ! Internal variables
  integer(kind=i_def)               :: df, k, ik
  real(kind=r_def), dimension(ndf2) :: x_e
  real(kind=r_def), dimension(ndf1) :: lhs_e

  do k = 0, nlayers-1
    do df = 1, ndf2
      x_e(df) = x(map2(df)+k)
    end do
    ik = (cell-1)*nlayers + k + 1
    lhs_e = matmul(matrix(:,:,ik),x_e)
    do df = 1,ndf1
       lhs(map1(df)+k) = lhs(map1(df)+k) + lhs_e(df)
    end do
  end do

end subroutine matrix_vector_kernel_code

end module matrix_vector_kernel_mod

!-------------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-------------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!------------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office

module apply_variable_hx_kernel_mod

use argument_mod,            only : arg_type,                         &
                                    GH_FIELD, GH_OPERATOR, GH_SCALAR, &
                                    GH_REAL, GH_READ, GH_WRITE,       &
                                    ANY_SPACE_1, CELL_COLUMN
use fs_continuity_mod,       only : W3, W2
use constants_mod,           only : r_def, i_def
use kernel_mod,              only : kernel_type

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------

type, public, extends(kernel_type) :: apply_variable_hx_kernel_type
  private
  type(arg_type) :: meta_args(10) = (/                                 &
       arg_type(GH_FIELD,    GH_REAL, GH_WRITE, W3),                   &
       arg_type(GH_FIELD,    GH_REAL, GH_READ,  W2),                   &
       arg_type(GH_FIELD,    GH_REAL, GH_READ,  ANY_SPACE_1),          &
       arg_type(GH_FIELD,    GH_REAL, GH_READ,  W3),                   &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,  W3, W2),               &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,  W3, ANY_SPACE_1),      &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,  ANY_SPACE_1, W2),      &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,  W3, W3),               &
       arg_type(GH_SCALAR,   GH_REAL, GH_READ),                        &
       arg_type(GH_SCALAR,   GH_REAL, GH_READ)                         &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: apply_variable_hx_code
end type
type, public, extends(kernel_type) :: opt_apply_variable_hx_kernel_type
  private
  type(arg_type) :: meta_args(10) = (/                                 &
       arg_type(GH_FIELD,    GH_REAL, GH_WRITE, W3),                   &
       arg_type(GH_FIELD,    GH_REAL, GH_READ,  W2),                   &
       arg_type(GH_FIELD,    GH_REAL, GH_READ,  ANY_SPACE_1),          &
       arg_type(GH_FIELD,    GH_REAL, GH_READ,  W3),                   &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,  W3, W2),               &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,  W3, ANY_SPACE_1),      &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,  ANY_SPACE_1, W2),      &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ,  W3, W3),               &
       arg_type(GH_SCALAR,   GH_REAL, GH_READ),                        &
       arg_type(GH_SCALAR,   GH_REAL, GH_READ)                         &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: opt_apply_variable_hx_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public apply_variable_hx_code
public opt_apply_variable_hx_code

contains

!> @brief Applies the component of the helmholtz operator that maps from velocity space
!>        to the pressure space as well as the constant in space part
!> @details The Helmholtz operator can be summarised as:
!>          \f[
!>             H(p) = Mp + \nabla.\left( \nabla p \right) + \bar{ \nabla p }
!>         \f]
!>        For a given p & \f[ \nabla p \f] this kernel applies the
!>        divergence \f[ \nabla. X \f] and averaging  \f[ \bar{X} \f]
!>        operators as well as the application of the mass matrix M
!> @param[in] cell Horizontal cell index
!> @param[in] nlayers Number of layers
!> @param[in,out] lhs Pressure field with helmholtz operator applied to it
!> @param[in] x Gradient of the pressure field in the velocity space
!> @param[in] mt_inv Lumped inverse mass matrix for the temperature space
!> @param[in] pressure Field that helmholtz operator is being applied to
!> @param[in] ncell_3d_1 Total number of cells for divergence matrix
!> @param[in] div Generalised divergence matrix
!> @param[in] ncell_3d_2 Total number of cells for p3t matrix
!> @param[in] p3t Mapping from temperature space to pressure space
!> @param[in] ncell_3d_3 Total number of cells for pt2 matrix
!> @param[in] pt2 Mapping from velocity space to temperature space
!> @param[in] ncell_3d_4 Total number of cells for m3 matrix
!> @param[in] m3 Mass matrix for the pressure space
!> @param[in] tau Relaxation weight
!> @param[in] dt Weight based upon the timestep
!> @param[in] ndf_w3 Number of degrees of freedom per cell for the pressure space
!> @param[in] undf_w3 Unique number of degrees of freedom  for the pressure space
!> @param[in] map_w3 Dofmap for the cell at the base of the column for the pressure space
!> @param[in] ndf_w2 Number of degrees of freedom per cell for the velocity space
!> @param[in] undf_w2 Unique number of degrees of freedom  for the velocity space
!> @param[in] map_w2 Dofmap for the cell at the base of the column for the velocity space
!> @param[in] ndf_wt Number of degrees of freedom per cell for the temperature space
!> @param[in] undf_wt Unique number of degrees of freedom  for the temperature space
!> @param[in] map_wt Dofmap for the cell at the base of the column for the temperature space
subroutine apply_variable_hx_code(cell,        &
                                  nlayers,     &
                                  lhs, x,      &
                                  mt_inv,      &
                                  pressure,    &
                                  ncell_3d_1,  &
                                  div,         &
                                  ncell_3d_2,  &
                                  p3t,         &
                                  ncell_3d_3,  &
                                  pt2,         &
                                  ncell_3d_4,  &
                                  m3,          &
                                  tau,         &
                                  dt,          &
                                  ndf_w3, undf_w3, map_w3, &
                                  ndf_w2, undf_w2, map_w2, &
                                  ndf_wt, undf_wt, map_wt)

  implicit none

  ! Arguments
  integer(kind=i_def),                    intent(in) :: cell, nlayers
  integer(kind=i_def),                    intent(in) :: ncell_3d_1, ncell_3d_2, ncell_3d_3, ncell_3d_4
  integer(kind=i_def),                    intent(in) :: undf_w2, ndf_w2
  integer(kind=i_def),                    intent(in) :: undf_w3, ndf_w3
  integer(kind=i_def),                    intent(in) :: undf_wt, ndf_wt
  integer(kind=i_def), dimension(ndf_w3), intent(in) :: map_w3
  integer(kind=i_def), dimension(ndf_w2), intent(in) :: map_w2
  integer(kind=i_def), dimension(ndf_wt), intent(in) :: map_wt

  real(kind=r_def), dimension(undf_w2), intent(in)    :: x
  real(kind=r_def), dimension(undf_wt), intent(in)    :: mt_inv
  real(kind=r_def), dimension(undf_w3), intent(inout) :: lhs
  real(kind=r_def), dimension(undf_w3), intent(in)    :: pressure
  real(kind=r_def),                     intent(in)    :: tau, dt

  real(kind=r_def), dimension(ndf_w3,ndf_w2,ncell_3d_1), intent(in) :: div
  real(kind=r_def), dimension(ndf_wt,ndf_w2,ncell_3d_2), intent(in) :: pt2
  real(kind=r_def), dimension(ndf_w3,ndf_wt,ncell_3d_3), intent(in) :: p3t
  real(kind=r_def), dimension(ndf_w3,ndf_w3,ncell_3d_4), intent(in) :: m3

  ! Internal variables
  integer(kind=i_def)                 :: df, k, ik, is, ie
  real(kind=r_def), dimension(ndf_w2) :: x_e
  real(kind=r_def), dimension(ndf_w3) :: lhs_e, p_e
  real(kind=r_def), dimension(ndf_wt) :: t_e

  real(kind=r_def), allocatable, dimension(:) :: t

  ! Only need a section of the theta field that contains indices for this
  ! column
  is = minval(map_wt)
  ie = maxval(map_wt)+nlayers-1
  allocate( t(is:ie) )
  t(is:ie) = 0.0_r_def

  ! Compute Pt2 * u
  do k = 0, nlayers-1
    do df = 1, ndf_w2
      x_e(df) = x(map_w2(df)+k)
    end do
    ik = (cell-1)*nlayers + k + 1

    t_e = matmul(pt2(:,:,ik),x_e)
    do df = 1,ndf_wt
      t(map_wt(df)+k) = t(map_wt(df)+k) + t_e(df)
    end do
  end do

  ! Compute D * u + tau * P3t * Mt^-1 * ( Pt2 * u )
  do k = 0,nlayers-1
    do df = 1,ndf_wt
      t_e(df) = t(map_wt(df)+k)*mt_inv(map_wt(df)+k)*tau
    end do
    do df = 1, ndf_w2
      x_e(df) = x(map_w2(df)+k)
    end do
    do df = 1, ndf_w3
      p_e(df) = pressure(map_w3(df)+k)
    end do

    ik = (cell-1)*nlayers + k + 1

    lhs_e = matmul(m3(:,:,ik),p_e) + dt*(matmul(div(:,:,ik),x_e) + matmul(p3t(:,:,ik),t_e))
    do df = 1,ndf_w3
       lhs(map_w3(df)+k) = lhs_e(df)
    end do
  end do
end subroutine apply_variable_hx_code

!=============================================================================!
!> @brief Applies the component of the helmholtz operator that maps from velocity space
!>        to the pressure space as well as the constant in space part, optimised for lowest
!>        order elements with horizontally discontinuous temperature space
!> @details The Helmholtz operator can be summarised as:
!>          \f[
!>             H(p) = Mp + \nabla.\left( \nabla p \right) + \bar{ \nabla p }
!>         \f]
!>        For a given p & \f[ \nabla p \f] this kernel applies the
!>        divergence \f[ \nabla. X \f] and averaging  \f[ \bar{X} \f]
!>        operators as well as the application of the mass matrix M
!> @param[in] cell Horizontal cell index
!> @param[in] nlayers Number of layers
!> @param[inout] lhs pressure field with helmholtz operator applied to it
!> @param[in] x gradient of the pressure field in the velocity space
!> @param[in] mt_inv lumped inverse mass matrix for the temperature space
!> @param[in] pressure field that helmholtz operator is being applied to
!> @param[in] ncell_3d_1 Total number of cells for divergence matrix
!> @param[in] div generalised divergence matrix
!> @param[in] ncell_3d_2 Total number of cells for p3t matrix
!> @param[in] p3t mapping from temperature space to pressure space
!> @param[in] ncell_3d_3 Total number of cells for pt2 matrix
!> @param[in] pt2 mapping from velocity space to temperature space
!> @param[in] ncell_3d_4 Total number of cells for m3 matrix
!> @param[in] m3 mass matrix for the pressure space
!> @param[in] tau relaxtation weight
!> @param[in] dt weight based upon the timestep
!> @param[in] ndf_w3 Number of degrees of freedom per cell for the pressure space
!> @param[in] undf_w3 Unique number of degrees of freedom  for the pressure space
!> @param[in] map_w3 Dofmap for the cell at the base of the column for the pressure space
!> @param[in] ndf_w2 Number of degrees of freedom per cell for the velocity space
!> @param[in] undf_w2 Unique number of degrees of freedom  for the velocity space
!> @param[in] map_w2 Dofmap for the cell at the base of the column for the velocity space
!> @param[in] ndf_wt Number of degrees of freedom per cell for the temperature space
!> @param[in] undf_wt Unique number of degrees of freedom  for the temperature space
!> @param[in] map_wt Dofmap for the cell at the base of the column for the temperature space
subroutine opt_apply_variable_hx_code(cell,        &
                                  nlayers,     &
                                  lhs, x,      &
                                  mt_inv,      &
                                  pressure,    &
                                  ncell_3d_1,  &
                                  div,         &
                                  ncell_3d_2,  &
                                  p3t,         &
                                  ncell_3d_3,  &
                                  pt2,         &
                                  ncell_3d_4,  &
                                  m3,          &
                                  tau,         &
                                  dt,          &
                                  ndf_w3, undf_w3, map_w3, &
                                  ndf_w2, undf_w2, map_w2, &
                                  ndf_wt, undf_wt, map_wt)

  implicit none

  ! Arguments
  integer(kind=i_def),                    intent(in) :: cell, nlayers
  integer(kind=i_def),                    intent(in) :: ncell_3d_1, ncell_3d_2, ncell_3d_3, ncell_3d_4
  integer(kind=i_def),                    intent(in) :: undf_w2, ndf_w2
  integer(kind=i_def),                    intent(in) :: undf_w3, ndf_w3
  integer(kind=i_def),                    intent(in) :: undf_wt, ndf_wt
  integer(kind=i_def), dimension(ndf_w3), intent(in) :: map_w3
  integer(kind=i_def), dimension(ndf_w2), intent(in) :: map_w2
  integer(kind=i_def), dimension(ndf_wt), intent(in) :: map_wt

  real(kind=r_def), dimension(undf_w2), intent(in)    :: x
  real(kind=r_def), dimension(undf_wt), intent(in)    :: mt_inv
  real(kind=r_def), dimension(undf_w3), intent(inout) :: lhs
  real(kind=r_def), dimension(undf_w3), intent(in)    :: pressure
  real(kind=r_def),                     intent(in)    :: tau, dt

  real(kind=r_def), dimension(1,6,ncell_3d_1), intent(in) :: div
  real(kind=r_def), dimension(2,6,ncell_3d_2), intent(in) :: pt2
  real(kind=r_def), dimension(1,2,ncell_3d_3), intent(in) :: p3t
  real(kind=r_def), dimension(1,1,ncell_3d_4), intent(in) :: m3

  ! Internal variables
  integer(kind=i_def)            :: df, k, ik
  real(kind=r_def), dimension(2) :: t_e
  real(kind=r_def)               :: div_u

  ! Compute D * u + tau * P3t * Mt^-1 * ( Pt2 * u )
  ! Hard wired optimisation for desired configuration
  k = 0
  ik = (cell-1)*nlayers + k + 1
  t_e(1:2) = 0.0_r_def
  do df = 1,6
    t_e(1) = t_e(1) + pt2(1,df,ik)*x(map_w2(df)+k)
    t_e(2) = t_e(2) + pt2(2,df,ik)*x(map_w2(df)+k) + pt2(1,df,ik+1)*x(map_w2(df)+k+1)
  end do
  t_e(1) = mt_inv(map_wt(1)+k)*p3t(1,1,ik)*t_e(1)
  t_e(2) = mt_inv(map_wt(2)+k)*p3t(1,2,ik)*t_e(2)

  div_u = div(1,1,ik)*x(map_w2(1)+k) + div(1,2,ik)*x(map_w2(2)+k) + div(1,3,ik)*x(map_w2(3)+k) &
        + div(1,4,ik)*x(map_w2(4)+k) + div(1,5,ik)*x(map_w2(5)+k) + div(1,6,ik)*x(map_w2(6)+k)
  lhs(map_w3(1)+k) = m3(1,1,ik)*pressure(map_w3(1)+k) &
                   + dt*(div_u + tau*(t_e(1) + t_e(2)))

  do k = 1,nlayers-2
    ik = (cell-1)*nlayers + k + 1
    t_e(1:2) = 0.0_r_def
    do df = 1,6
      t_e(1) = t_e(1) + pt2(1,df,ik)*x(map_w2(df)+k) + pt2(2,df,ik-1)*x(map_w2(df)+k-1)
      t_e(2) = t_e(2) + pt2(2,df,ik)*x(map_w2(df)+k) + pt2(1,df,ik+1)*x(map_w2(df)+k+1)
    end do
    t_e(1) = mt_inv(map_wt(1)+k)*p3t(1,1,ik)*t_e(1)
    t_e(2) = mt_inv(map_wt(2)+k)*p3t(1,2,ik)*t_e(2)

    div_u = div(1,1,ik)*x(map_w2(1)+k) + div(1,2,ik)*x(map_w2(2)+k) + div(1,3,ik)*x(map_w2(3)+k) &
          + div(1,4,ik)*x(map_w2(4)+k) + div(1,5,ik)*x(map_w2(5)+k) + div(1,6,ik)*x(map_w2(6)+k)
    lhs(map_w3(1)+k) = m3(1,1,ik)*pressure(map_w3(1)+k) &
                     + dt*(div_u + tau*(t_e(1) + t_e(2)))
  end do

  k = nlayers-1
  ik = (cell-1)*nlayers + k + 1
  t_e(1:2) = 0.0_r_def
  do df = 1,6
    t_e(1) = t_e(1) + pt2(1,df,ik)*x(map_w2(df)+k) + pt2(2,df,ik-1)*x(map_w2(df)+k-1)
    t_e(2) = t_e(2) + pt2(2,df,ik)*x(map_w2(df)+k)
  end do
  t_e(1) = mt_inv(map_wt(1)+k)*p3t(1,1,ik)*t_e(1)
  t_e(2) = mt_inv(map_wt(2)+k)*p3t(1,2,ik)*t_e(2)

  div_u = div(1,1,ik)*x(map_w2(1)+k) + div(1,2,ik)*x(map_w2(2)+k) + div(1,3,ik)*x(map_w2(3)+k) &
        + div(1,4,ik)*x(map_w2(4)+k) + div(1,5,ik)*x(map_w2(5)+k) + div(1,6,ik)*x(map_w2(6)+k)
  lhs(map_w3(1)+k) = m3(1,1,ik)*pressure(map_w3(1)+k) &
                   + dt*(div_u + tau*(t_e(1) + t_e(2)))

end subroutine opt_apply_variable_hx_code

end module apply_variable_hx_kernel_mod

program alg
  use field_mod, only : r2d_field
  use kern_use_var_mod, only : kern_use_var
  use psy_alg, only : invoke_0_kern_use_var
  type(r2d_field) :: fld1

  call invoke_0_kern_use_var(fld1)

end program alg

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2022, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: R. W. Ford, STFC Daresbury Lab
! Modified: I. Kavcic, Met Office
!           A. R. Porter, STFC Daresbury Lab

! A kernel which writes to a field on 'any_space'. Such a kernel must guarantee
! that any writes to a given shared entity are for the same value and that the
! first access to such an entity is a write.
module testkern_write_any_mod

  use constants_mod
  use argument_mod
  use fs_continuity_mod
  use kernel_mod

  implicit none

  ! Description: function spaces with one continuous ('any_space_1')
  ! field writer.
  type, extends(kernel_type) :: testkern_write_any_type
     type(arg_type), dimension(2) :: meta_args = (/                        &
          arg_type(gh_field, gh_real, gh_write, any_space_1),              &
          arg_type(gh_field, gh_real, gh_read,  w2)                        &
          /)
     integer :: operates_on = cell_column
   contains
     procedure, nopass :: code => testkern_write_any_code
  end type testkern_write_any_type

contains

  subroutine testkern_write_any_code(nlayers,                             &
                                     field1, field2,                      &
                                     ndf_aspc1, undf_aspc1, map_aspc1,    &
                                     ndf_w2, undf_w2, map_w2)

    implicit none

    integer(kind=i_def), intent(in) :: nlayers
    integer(kind=i_def), intent(in) :: ndf_aspc1
    integer(kind=i_def), intent(in) :: ndf_w2
    integer(kind=i_def), intent(in) :: undf_aspc1, undf_w2
    integer(kind=i_def), intent(in), dimension(ndf_aspc1)  :: map_aspc1
    integer(kind=i_def), intent(in), dimension(ndf_w2)     :: map_w2
    real(kind=r_def), intent(out), dimension(undf_aspc1)   :: field1
    real(kind=r_def), intent(in), dimension(undf_w2)       :: field2

  end subroutine testkern_write_any_code

end module testkern_write_any_mod

MODULE gw_mixed_schur_preconditioner_alg_mod
  USE field_mod, ONLY: field_type
  USE field_vector_mod, ONLY: field_vector_type
  USE constants_mod, ONLY: r_def
  USE runtime_constants_mod, ONLY: get_mass_matrix, get_div, w0_id, w3_id, w3inv_id, wt_id
  USE timestepping_config_mod, ONLY: dt
  USE gravity_wave_constants_config_mod, ONLY: cs_square, b_space, gravity_wave_constants_b_space_w0, &
&gravity_wave_constants_b_space_w3, gravity_wave_constants_b_space_wtheta
  USE operator_mod, ONLY: operator_type
  USE preconditioner_mod, ONLY: abstract_preconditioner_type
  USE iterative_solver_mod, ONLY: abstract_iterative_solver_type
  USE field_indices_mod, ONLY: igw_u, igw_p, igw_b
  USE log_mod, ONLY: log_event, LOG_LEVEL_INFO, LOG_LEVEL_DEBUG
  IMPLICIT NONE
  PRIVATE
  TYPE, PUBLIC, EXTENDS(abstract_preconditioner_type) :: gw_mixed_schur_preconditioner_type
    PRIVATE
    REAL(KIND = r_def) :: alpha
    TYPE(operator_type) :: Q
    TYPE(field_type) :: p_inc, b_inc, u_inc
    TYPE(field_type) :: rhs_p_tmp
    TYPE(field_type) :: rhs_u
    TYPE(field_type) :: rhs_p
    TYPE(field_vector_type) :: pressure_b
    TYPE(field_vector_type) :: pressure_x
    TYPE(field_type) :: hb_ru
    TYPE(field_type) :: mb_rb
    TYPE(field_type) :: Mb_lumped_inv, Hb_lumped_inv
    CLASS(abstract_iterative_solver_type), POINTER :: gw_pressure_solver
    CONTAINS
    PROCEDURE, PRIVATE :: build_pressure_rhs
    FINAL :: destroy_gw_mixed_schur_preconditioner
  END TYPE gw_mixed_schur_preconditioner_type
  INTERFACE gw_mixed_schur_preconditioner_type
    MODULE PROCEDURE gw_mixed_schur_preconditioner_constructor
  END INTERFACE
  CONTAINS
  SUBROUTINE gw_mixed_schur_preconditioner_constructor(self, state, Hb_lumped_inv, pressure_solver)
    USE gw_mixed_schur_preconditioner_alg_mod_psy, ONLY: invoke_0
    USE function_space_mod, ONLY: function_space_type
    USE finite_element_config_mod, ONLY: element_order
    USE quadrature_xyoz_mod, ONLY: quadrature_xyoz_type
    USE quadrature_rule_gaussian_mod, ONLY: quadrature_rule_gaussian_type
    USE matrix_vector_kernel_mod, ONLY: matrix_vector_kernel_type
    IMPLICIT NONE
    CLASS(gw_mixed_schur_preconditioner_type), INTENT(INOUT) :: self
    TYPE(field_vector_type), INTENT(IN) :: state
    TYPE(field_type), INTENT(IN) :: Hb_lumped_inv
    CLASS(abstract_iterative_solver_type), TARGET, INTENT(IN) :: pressure_solver
    TYPE(function_space_type), POINTER :: wp => null(), wu => null(), wb => null()
    TYPE(field_type) :: ones, M_lumped
    TYPE(operator_type), POINTER :: Mb => null()
    TYPE(quadrature_xyoz_type) :: qr
    TYPE(quadrature_rule_gaussian_type) :: quadrature_rule
    CALL log_event('Constructing gravity waves mixed preconditioner...', LOG_LEVEL_INFO)
    self % alpha = 0.5_r_def
    wu => state % vector(igw_u) % get_function_space()
    wp => state % vector(igw_p) % get_function_space()
    wb => state % vector(igw_b) % get_function_space()
    self % p_inc = field_type(vector_space = wp)
    self % b_inc = field_type(vector_space = wb)
    self % u_inc = field_type(vector_space = wu)
    self % rhs_u = field_type(vector_space = wu)
    self % rhs_p = field_type(vector_space = wp)
    self % rhs_p_tmp = field_type(vector_space = wp)
    self % mb_rb = field_type(vector_space = wb)
    self % hb_ru = field_type(vector_space = wu)
    self % pressure_b = field_vector_type(1)
    self % pressure_x = field_vector_type(1)
    ones = field_type(vector_space = wb)
    M_lumped = field_type(vector_space = wb)
    self % Mb_lumped_inv = field_type(vector_space = wb)
    SELECT CASE (b_space)
    CASE (gravity_wave_constants_b_space_w0)
      Mb => get_mass_matrix(w0_id)
    CASE (gravity_wave_constants_b_space_w3)
      Mb => get_mass_matrix(w3_id)
    CASE (gravity_wave_constants_b_space_wtheta)
      Mb => get_mass_matrix(wt_id)
    END SELECT
    CALL invoke_0(ones, m_lumped, mb, self % mb_lumped_inv)
    self % Hb_lumped_inv = Hb_lumped_inv
    self % gw_pressure_solver => pressure_solver
    CALL log_event('done', LOG_LEVEL_INFO)
  END SUBROUTINE gw_mixed_schur_preconditioner_constructor
  SUBROUTINE build_pressure_rhs(self, rhs0)
    USE gw_mixed_schur_preconditioner_alg_mod_psy, ONLY: invoke_2
    USE gw_mixed_schur_preconditioner_alg_mod_psy, ONLY: invoke_1
    USE matrix_vector_kernel_mod, ONLY: matrix_vector_kernel_type
    USE dg_matrix_vector_kernel_mod, ONLY: dg_matrix_vector_kernel_type
    IMPLICIT NONE
    CLASS(gw_mixed_schur_preconditioner_type), INTENT(INOUT) :: self
    TYPE(field_vector_type), INTENT(IN) :: rhs0
    TYPE(operator_type), POINTER :: div => null(), M3_inv => null()
    REAL(KIND = r_def) :: const1, const2
    const1 = self % alpha * dt
    CALL invoke_1(self % mb_rb, rhs0 % vector(igw_b), self % mb_lumped_inv, self % rhs_u, self % q, const1, rhs0 % vector(igw_u))
    div => get_div()
    M3_inv => get_mass_matrix(w3inv_id)
    const2 = - self % alpha * dt * cs_square
    CALL invoke_2(self % hb_ru, self % rhs_u, self % hb_lumped_inv, self % rhs_p_tmp, div, self % rhs_p, m3_inv, const2, &
&rhs0 % vector(igw_p))
    CALL self % rhs_p % log_minmax(LOG_LEVEL_DEBUG, 'gw_pressure_rhs ')
  END SUBROUTINE build_pressure_rhs
  SUBROUTINE destroy_gw_mixed_schur_preconditioner(self)
    IMPLICIT NONE
    TYPE(gw_mixed_schur_preconditioner_type), INTENT(INOUT) :: self
  END SUBROUTINE destroy_gw_mixed_schur_preconditioner
END MODULE gw_mixed_schur_preconditioner_alg_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office

!> This module implements a NAN verification for the LFRic API
!!

module nan_test_psy_data_mod

    use, intrinsic :: iso_fortran_env, only : int64, int32,   &
                                              real32, real64, &
                                              stderr => Error_Unit
    use field_mod, only : field_type
    use integer_field_mod, only : integer_field_type
    use nan_test_base_mod, only : NANTestBaseType, is_enabled

    implicit none

    type, extends(NANTestBaseType), public :: nan_test_PSyDataType

    contains

        ! The LFRic-specific procedures defined here
        procedure :: DeclareField
        procedure :: ProvideField
        procedure :: DeclareFieldVector
        procedure :: ProvideFieldVector
        procedure :: DeclareIntField
        procedure :: ProvideIntField
        procedure :: DeclareIntFieldVector
        procedure :: ProvideIntFieldVector

        ! Declare generic interface for PreDeclareVariable:
        generic, public :: PreDeclareVariable => &
                           DeclareField,         &
                           DeclareFieldVector,   &
                           DeclareIntField,      &
                           DeclareIntFieldVector

        !> The generic interface for providing the value of variables
        !! (which checks for non normal IEEE numbers)
        generic, public :: ProvideVariable =>  &
                           ProvideField,       &
                           ProvideFieldVector, &
                           ProvideIntField,    &
                           ProvideIntFieldVector

    end type nan_test_PSyDataType

contains

    ! -------------------------------------------------------------------------
    !> This subroutine declares LFRic real-valued fields. No functionality is
    !! needed for NAN checking, so it is just an empty function.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareField(this, name, value)

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(field_type), intent(in) :: value

    end subroutine DeclareField

    ! -------------------------------------------------------------------------
    !> This subroutine declares LFRic integer-valued fields. No functionality
    !! is needed for NAN checking, so it is just an empty function.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareIntField(this, name, value)

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(integer_field_type), intent(in) :: value

    end subroutine DeclareIntField

    ! -------------------------------------------------------------------------
    !> This subroutine checks whether a real-valued LFRic field has NAN or
    !! infinite floating-point values.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideField(this, name, value)

        use field_mod, only : field_type, field_proxy_type

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in)                           :: name
        type(field_type), intent(in)                       :: value

        type(field_proxy_type) :: value_proxy

        if (.not. is_enabled) return

        if (this%verbosity>1) then
            write(stderr, *) "PSyData - testing ", name
        endif
        value_proxy = value%get_proxy()
        call this%ProvideVariable(name, value_proxy%data)

    end subroutine ProvideField

    ! -------------------------------------------------------------------------
    !> This subroutine checks whether an integer-valued LFRic field has NAN or
    !! infinite values.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideIntField(this, name, value)

        use integer_field_mod, only : integer_field_type, &
                                      integer_field_proxy_type

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in)                           :: name
        type(integer_field_type), intent(in)               :: value

        type(integer_field_proxy_type) :: value_proxy

        if (.not. is_enabled) return

        if (this%verbosity>1) then
            write(stderr, *) "PSyData - testing ", name
        endif
        value_proxy = value%get_proxy()
        call this%ProvideVariable(name, value_proxy%data)

    end subroutine ProvideIntField

    ! -------------------------------------------------------------------------
    !> This subroutine declares LFRic real-valued field vectors. No
    !! functionality is needed here, so it is just an empty function.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareFieldVector(this, name, value)

        use field_mod, only : field_type

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in)                           :: name
        type(field_type), dimension(:), intent(in)         :: value

    end subroutine DeclareFieldVector

    ! -------------------------------------------------------------------------
    !> This subroutine declares LFRic integer-valued field vectors. No
    !! functionality is needed here, so it is just an empty function.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareIntFieldVector(this, name, value)

        use integer_field_mod, only : integer_field_type

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in)                           :: name
        type(integer_field_type), dimension(:), intent(in) :: value

    end subroutine DeclareIntFieldVector

    ! -------------------------------------------------------------------------
    !> This subroutine checks whether a real-valued LFRic vector field has NAN
    !! or infinite floating-point values.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The vector of fields.
    subroutine ProvideFieldVector(this, name, value)

        use field_mod, only : field_type

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in)                           :: name
        type(field_type), dimension(:), intent(in)         :: value

        integer      :: i
        character(8) :: index_string   ! Enough for a 6 digit number plus '()'

        if (.not. is_enabled) return

        ! Provide each member of the vector as a normal field. This way
        ! the NAN/infinite testing will be done for each member individually.
        do i = 1, size(value, 1)
            write(index_string, '("(",i0,")")') i
            call this%ProvideVariable(name//trim(index_string), value(i))
        enddo

    end subroutine ProvideFieldVector

    ! -------------------------------------------------------------------------
    !> This subroutine checks whether an integer-valued LFRic vector field has
    !! NAN or infinite values.
    !! @param[in,out] this The instance of the nan_test_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The vector of fields.
    subroutine ProvideIntFieldVector(this, name, value)

        use integer_field_mod, only : integer_field_type

        implicit none

        class(nan_test_PSyDataType), intent(inout), target :: this
        character(*), intent(in)                           :: name
        type(integer_field_type), dimension(:), intent(in) :: value

        integer      :: i
        character(8) :: index_string   ! Enough for a 6 digit number plus '()'

        if (.not. is_enabled) return

        ! Provide each member of the vector as a normal field. This way
        ! the NAN/infinite testing will be done for each member individually.
        do i = 1, size(value, 1)
            write(index_string, '("(",i0,")")') i
            call this%ProvideVariable(name//trim(index_string), value(i))
        enddo

    end subroutine ProvideIntFieldVector

    ! -------------------------------------------------------------------------

end module nan_test_psy_data_mod

PROGRAM mixed_precision
  USE mixed_precision_psy, ONLY: invoke_0
  USE constants_mod, ONLY: r_def, r_solver, r_tran
  USE mixed_kernel_mod, ONLY: mixed_kernel_type
  REAL(KIND = r_def) :: scalar_r_def
  REAL(KIND = r_solver) :: scalar_r_solver
  REAL(KIND = r_tran) :: scalar_r_tran
  TYPE(field_type) :: field_r_def
  TYPE(r_solver_field_type) :: field_r_solver
  TYPE(r_tran_field_type) :: field_r_tran
  TYPE(operator_type) :: operator_r_def
  TYPE(r_solver_operator_type) :: operator_r_solver
  CALL invoke_0(scalar_r_def, field_r_def, operator_r_def, scalar_r_solver, field_r_solver, operator_r_solver, scalar_r_tran, &
&field_r_tran)
END PROGRAM mixed_precision

! ================================================== !
! THIS FILE IS CREATED FROM THE JINJA TEMPLATE FILE  !
! DO NOT MODIFY DIRECTLY                             !
! ================================================== !



! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: J. Henrichs, Bureau of Meteorology
! Modified: I. Kavcic, Met Office

!> This module implements a simple NetCDF writer using the PSyData
!! interface. A Fortran code instrumented with corresponding calls
!! to the PSyData API and linked in with this library will create
!! a NetCDF file that contains all scalar values, and the dimensions
!! and content for each array.
!! As an extention to the PSyData API it defines additional methods
!! that can be used by a driver/reader:
!! OpenRead:      opens a file for reading
!! ReadScalar...: reads the specified scalar value

module extract_netcdf_base_mod

    use psy_data_base_mod, only : PSyDataBaseType, is_enabled

    use, intrinsic :: iso_fortran_env, only : int64, int32,   &
                                              real32, real64, &
                                              stderr => Error_Unit

    implicit none

    !> This is the data type that manages the information required
    !! to write data to a NetCDF file using the PSyData API. A
    !! static instance of this type is created for each instrumented
    !! region with PSyclone (and each region will write a separate
    !! file).
    type, extends(PSyDataBaseType), public :: ExtractNetcdfBaseType

        !> The NetCDF ID used for this file.
        integer                            :: ncid
        !> Each variable ID. This is required to associate data
        !! with the declared variables: the variables are declared
        !! in the same order in which their value is provided

        integer, dimension(:), allocatable :: var_id

    contains

        ! The various procedures used
        procedure :: PreStart
        procedure :: PreEndDeclaration
        procedure :: PostEnd
        procedure :: OpenRead

        procedure :: DeclareScalarInt
        procedure :: WriteScalarInt
        procedure :: ReadScalarInt
        procedure :: DeclareArray2dInt
        procedure :: WriteArray2dInt
        procedure :: ReadArray2dInt
        procedure :: DeclareScalarReal
        procedure :: WriteScalarReal
        procedure :: ReadScalarReal
        procedure :: DeclareArray2dReal
        procedure :: WriteArray2dReal
        procedure :: ReadArray2dReal
        procedure :: DeclareScalarDouble
        procedure :: WriteScalarDouble
        procedure :: ReadScalarDouble
        procedure :: DeclareArray2dDouble
        procedure :: WriteArray2dDouble
        procedure :: ReadArray2dDouble

        ! Declare generic interface for PreDeclareVariable:
        generic, public :: PreDeclareVariable => &
            DeclareScalarInt, &
            DeclareArray2dInt, &
            DeclareScalarReal, &
            DeclareArray2dReal, &
            DeclareScalarDouble, &
            DeclareArray2dDouble

        !> The generic interface for providing the value of variables:
        generic, public :: ProvideVariable => &
            WriteScalarInt, &
            WriteArray2dInt, &
            WriteScalarReal, &
            WriteArray2dReal, &
            WriteScalarDouble, &
            WriteArray2dDouble

        !> The generic interface for reading the value of variables.
        !! This is not part of the official PSyData API, but is used in
        !! the drivers created by PSyclone.
        generic, public :: ReadVariable => &
            ReadScalarInt, &
            ReadArray2dInt, &
            ReadScalarReal, &
            ReadArray2dReal, &
            ReadScalarDouble, &
            ReadArray2dDouble

    end type ExtractNetcdfBaseType

contains

    ! -------------------------------------------------------------------------
    !> Checks if the return value from a NetCDF call indicates an error.
    !! If so, print the corresponding error message and aborts the program.
    !! It is typically used as a wrapper around NetCDF calls:
    !! retval = CheckError(nf90_close(ncid))
    !! @param[in] retval The return value from a NetCDF operation.
    !! Returns the return value.
    function CheckError(retval)

        use netcdf, only : nf90_noerr, nf90_strerror

        implicit none

        integer, intent(in) :: retval
        integer             :: CheckError

        if (retval /= nf90_noerr) then
            write(stderr, *) "NetCDF Error:"
            write(stderr, *) trim(nf90_strerror(retval))
            stop
        endif
        CheckError = retval

    end function CheckError

    ! -------------------------------------------------------------------------
    !> This is a one-time init function. It is not required for the kernel
    !! extraction and is therefore empty.
    subroutine extract_PSyDataInit()
        implicit none
    end subroutine extract_PSyDataInit

    ! -------------------------------------------------------------------------
    !> This is a one-time shutdown function. It is not required for the kernel
    !! extraction and is therefore empty.
    subroutine extract_PSyDataShutdown()
        implicit none
    end subroutine extract_PSyDataShutdown

    ! -------------------------------------------------------------------------
    !> This subroutine is the first function called when data is written out
    !! before an instrumented region of code.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] module_name The name of the module of the instrumented
    !!            region.
    !! @param[in] region_name The name of the instrumented region.
    !! @param[in] num_pre_vars The number of variables that are declared and
    !!            written before the instrumented region.
    !! @param[in] num_post_vars The number of variables that are also declared
    !!            before an instrumented region of code, but are written after
    !!            this region.
    subroutine PreStart(this, module_name, region_name, num_pre_vars, &
                        num_post_vars)

        use netcdf, only : nf90_create, NF90_CLOBBER

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: module_name, &
                                                               region_name
        integer, intent(in)                                 :: num_pre_vars, &
                                                               num_post_vars

        integer :: retval

        call this%PSyDataBaseType%PreStart(module_name, region_name, &
                                           num_pre_vars, num_post_vars)

        ! Open the NetCDF file
        retval = CheckError(nf90_create(module_name//"-"//region_name//".nc", &
                                        NF90_CLOBBER, this%ncid))
        ! Allocate the array that will store the variable IDs of all
        ! variables that are going to be declared. Note that there might
        ! actually be more variables stored (in LFRic vector fields are
        ! stored as individual NetCDF variables, so a 3d vector field
        ! would actually use 3 individual NetCDF variables). If required,
        ! this array will be re-allocated in the declare functions.
        if (.not. allocated(this%var_id)) then
            allocate(this%var_id(num_pre_vars+num_post_vars))
        endif

    end subroutine PreStart

    ! -------------------------------------------------------------------------
    !> This subroutine is called to open a NetCDF file for reading. The
    !! filename is based on the module and kernel name. This is used by a
    !! driver program that will read a NetCDF file previously created by the
    !! PSyData API.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] module_name The name of the module of the instrumented
    !!            region.
    !! @param[in] region_name The name of the instrumented region.
    subroutine OpenRead(this, module_name, region_name)

        use netcdf, only : nf90_open, NF90_NOWRITE

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: module_name, &
                                                               region_name
        integer :: retval

        retval = CheckError(nf90_open(module_name//"-"//region_name//".nc", &
                                        NF90_NOWRITE, this%ncid))

    end subroutine OpenRead

    ! -------------------------------------------------------------------------
    !> This subroutine is called once all variables are declared (this includes
    !! variables that will be written before as well as variables that are
    !! written after the instrumented region). It is used to switch the NetCDF
    !! file from declaration to writing state, and reset the next_var_index
    !! back to 1.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    subroutine PreEndDeclaration(this)

        use netcdf, only : nf90_enddef

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this

        integer :: retval

        call this%PSyDataBaseType%PreEndDeclaration()
        retval = CheckError(nf90_enddef(this%ncid))

    end subroutine PreEndDeclaration

    ! -------------------------------------------------------------------------
    !> This subroutine is called after the instrumented region has been
    !! executed and all values of variables after the instrumented
    !! region have been provided. This will close the NetCDF file.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    subroutine PostEnd(this)

        use netcdf, only : nf90_close

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this

        integer :: retval
        retval = CheckError(nf90_close(this%ncid))
        call this%PSyDataBaseType%PostEnd()

    end subroutine PostEnd

    ! -------------------------------------------------------------------------
    !> This subroutine declares a scalar integer(kind=int32) value.
    !! A corresponding variable definition is added to the NetCDF file, and
    !! the variable id is stored in the var_id field.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareScalarInt(this, name, value)

        use netcdf, only : nf90_def_var, NF90_INT

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        integer(kind=int32), intent(in)                                :: value

        integer                            :: retval
        integer, dimension(:), allocatable :: tmp_var_id

        if (this%next_var_index > size(this%var_id)) then
            ! This can happen in LFRic when vector fields are used
            ! Each dimension of this vector becomes one NetCDF
            ! variable, so we need to potentially reallocate this field
            allocate(tmp_var_id(2*size(this%var_id)))
            tmp_var_id(1:size(this%var_id)) = this%var_id
            deallocate(this%var_id)
            call move_alloc(tmp_var_id, this%var_id)
            ! tmp_var_id is deallacted as part of move_alloc
        endif
        retval = CheckError(nf90_def_var(this%ncid, name, NF90_INT, &
                                         this%var_id(this%next_var_index)))
        call this%PSyDataBaseType%DeclareScalarInt(name, value)

    end subroutine DeclareScalarInt

    ! -------------------------------------------------------------------------
    !> This subroutine writes the value of a scalar integer(kind=int32)
    !! variable to the NetCDF file. It takes the variable id from the
    !! corresponding declaration.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteScalarInt(this, name, value)

        use netcdf, only : nf90_put_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        integer(kind=int32), intent(in)                                :: value
        integer                                             :: retval

        retval = CheckError(nf90_put_var(this%ncid, this%var_id(this%next_var_index), &
                                         value))
        call this%PSyDataBaseType%ProvideScalarInt(name, value)

    end subroutine WriteScalarInt

    ! -------------------------------------------------------------------------
    !> This subroutine reads the value of a scalar integer(kind=int32)
    !! variable from the NetCDF file and returns it to the user. Note that
    !! this function is not part of the PSyData API, but it is convenient to
    !! have these functions together here. The driver can then be linked with
    !! this  PSyData library and will be able to read the files.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[out] value The read value is stored here.
    subroutine ReadScalarInt(this, name, value)

        use netcdf, only : nf90_inq_varid, nf90_get_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        integer(kind=int32), intent(out)                               :: value

        integer                                             :: retval, varid

        retval = CheckError(nf90_inq_varid(this%ncid, name, varid))
        retval = CheckError(nf90_get_var(this%ncid, varid, value))

    end subroutine ReadScalarInt



    ! -------------------------------------------------------------------------
    !> This subroutine declares a 2d-array of integer(kind=int32).
    !! A corresponding variable and dimension definitions are added
    !! to the NetCDF file, and the variable id is stored in the var_id field.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareArray2dInt(this, name, value)

        use netcdf

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        integer(kind=int32), dimension(:,:), intent(in)      :: value

        integer                            :: dimid1, dimid2
        integer                            :: retval
        integer, dimension(2)        :: dimids
        integer, dimension(:), allocatable :: tmp_var_id

        if (.not. is_enabled) return

        if (this%next_var_index > size(this%var_id)) then
            allocate(tmp_var_id(2*size(this%var_id)))
            tmp_var_id(1:size(this%var_id)) = this%var_id
            deallocate(this%var_id)
            call move_alloc(tmp_var_id, this%var_id)
            ! tmp_var_id is deallacted as part of move_alloc
        endif

        ! A '%' is added to avoid a clash if the user should have say
        ! an array 'a', and 'adim1'.
        retval = CheckError(nf90_def_dim(this%ncid, name//"dim%1", &
                                         size(value,1), dimid1))
        ! A '%' is added to avoid a clash if the user should have say
        ! an array 'a', and 'adim1'.
        retval = CheckError(nf90_def_dim(this%ncid, name//"dim%2", &
                                         size(value,2), dimid2))
        dimids =  (/ dimid1, dimid2 /)
        retval = CheckError(nf90_def_var(this%ncid, name, NF90_INT, &
                                         dimids, this%var_id(this%next_var_index)))

        call this%PSyDataBaseType%DeclareArray2dInt(name, value)

    end subroutine DeclareArray2dInt

    ! -------------------------------------------------------------------------
    !> This subroutine writes a 2d-array of integer(kind=int32)
    !! to the NetCDF file.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteArray2dInt(this, name, value)

        use netcdf, only : nf90_put_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        integer(kind=int32), dimension(:,:), intent(in)      :: value

        integer :: retval

        if (.not. is_enabled) return
        retval = CheckError(nf90_put_var(this%ncid, this%var_id(this%next_var_index), &
                                         value(:,:)))
        call this%PSyDataBaseType%ProvideArray2dInt(name, value)

    end subroutine WriteArray2dInt

    ! -------------------------------------------------------------------------
    !> This subroutine reads the values of a 2d-array of integer(kind=int32)
    !! It allocates memory for the allocatable parameter 'value' to store the
    !! read values which is then returned to the caller. If the memory for the
    !! array cannot be allocated, the application will be stopped.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[out] value An allocatable, unallocated 2d-double precision array
    !!             which is allocated here and stores the values read.
    subroutine ReadArray2dInt(this, name, value)

        use netcdf

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target          :: this
        character(*), intent(in)                                     :: name
        integer(kind=int32), dimension(:,:), allocatable, intent(out) :: value

        integer        :: retval, varid
        integer        :: dim_id
        integer        :: dim_size1,dim_size2
        integer        :: ierr

        ! First query the dimensions of the original array from the
        ! NetCDF file
        retval = CheckError(nf90_inq_dimid(this%ncid, trim(name//"dim%1"), &
                                           dim_id))
        retval = CheckError(nf90_inquire_dimension(this%ncid, dim_id, &
                                                   len=dim_size1))
        retval = CheckError(nf90_inq_dimid(this%ncid, trim(name//"dim%2"), &
                                           dim_id))
        retval = CheckError(nf90_inquire_dimension(this%ncid, dim_id, &
                                                   len=dim_size2))

        ! Allocate enough space to store the values to be read:
        allocate(value(dim_size1,dim_size2), Stat=ierr)
        if (ierr /= 0) then
            write(stderr,*) "Cannot allocate array for ", name, &
                            " of size ", dim_size1,dim_size2, &
                            " in ReadArray2dInt."
            stop
        endif

        ! Initialise it with 0, so that an array comparison will work
        ! even though e.g. boundary areas or so might not be set at all.
        ! The compiler will convert the double precision value to the right
        ! type (e.g. int or single precision).
        value = 0.0d0
        retval = CheckError(nf90_inq_varid(this%ncid, name, varid))
        retval = CheckError(nf90_get_var(this%ncid, varid, value))

    end subroutine ReadArray2dInt

    ! -------------------------------------------------------------------------
    !> This subroutine declares a scalar real(kind=real32) value.
    !! A corresponding variable definition is added to the NetCDF file, and
    !! the variable id is stored in the var_id field.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareScalarReal(this, name, value)

        use netcdf, only : nf90_def_var, NF90_REAL

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real32), intent(in)                                :: value

        integer                            :: retval
        integer, dimension(:), allocatable :: tmp_var_id

        if (this%next_var_index > size(this%var_id)) then
            ! This can happen in LFRic when vector fields are used
            ! Each dimension of this vector becomes one NetCDF
            ! variable, so we need to potentially reallocate this field
            allocate(tmp_var_id(2*size(this%var_id)))
            tmp_var_id(1:size(this%var_id)) = this%var_id
            deallocate(this%var_id)
            call move_alloc(tmp_var_id, this%var_id)
            ! tmp_var_id is deallacted as part of move_alloc
        endif
        retval = CheckError(nf90_def_var(this%ncid, name, NF90_REAL, &
                                         this%var_id(this%next_var_index)))
        call this%PSyDataBaseType%DeclareScalarReal(name, value)

    end subroutine DeclareScalarReal

    ! -------------------------------------------------------------------------
    !> This subroutine writes the value of a scalar real(kind=real32)
    !! variable to the NetCDF file. It takes the variable id from the
    !! corresponding declaration.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteScalarReal(this, name, value)

        use netcdf, only : nf90_put_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real32), intent(in)                                :: value
        integer                                             :: retval

        retval = CheckError(nf90_put_var(this%ncid, this%var_id(this%next_var_index), &
                                         value))
        call this%PSyDataBaseType%ProvideScalarReal(name, value)

    end subroutine WriteScalarReal

    ! -------------------------------------------------------------------------
    !> This subroutine reads the value of a scalar real(kind=real32)
    !! variable from the NetCDF file and returns it to the user. Note that
    !! this function is not part of the PSyData API, but it is convenient to
    !! have these functions together here. The driver can then be linked with
    !! this  PSyData library and will be able to read the files.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[out] value The read value is stored here.
    subroutine ReadScalarReal(this, name, value)

        use netcdf, only : nf90_inq_varid, nf90_get_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real32), intent(out)                               :: value

        integer                                             :: retval, varid

        retval = CheckError(nf90_inq_varid(this%ncid, name, varid))
        retval = CheckError(nf90_get_var(this%ncid, varid, value))

    end subroutine ReadScalarReal



    ! -------------------------------------------------------------------------
    !> This subroutine declares a 2d-array of real(kind=real32).
    !! A corresponding variable and dimension definitions are added
    !! to the NetCDF file, and the variable id is stored in the var_id field.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareArray2dReal(this, name, value)

        use netcdf

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real32), dimension(:,:), intent(in)      :: value

        integer                            :: dimid1, dimid2
        integer                            :: retval
        integer, dimension(2)        :: dimids
        integer, dimension(:), allocatable :: tmp_var_id

        if (.not. is_enabled) return

        if (this%next_var_index > size(this%var_id)) then
            allocate(tmp_var_id(2*size(this%var_id)))
            tmp_var_id(1:size(this%var_id)) = this%var_id
            deallocate(this%var_id)
            call move_alloc(tmp_var_id, this%var_id)
            ! tmp_var_id is deallacted as part of move_alloc
        endif

        ! A '%' is added to avoid a clash if the user should have say
        ! an array 'a', and 'adim1'.
        retval = CheckError(nf90_def_dim(this%ncid, name//"dim%1", &
                                         size(value,1), dimid1))
        ! A '%' is added to avoid a clash if the user should have say
        ! an array 'a', and 'adim1'.
        retval = CheckError(nf90_def_dim(this%ncid, name//"dim%2", &
                                         size(value,2), dimid2))
        dimids =  (/ dimid1, dimid2 /)
        retval = CheckError(nf90_def_var(this%ncid, name, NF90_REAL, &
                                         dimids, this%var_id(this%next_var_index)))

        call this%PSyDataBaseType%DeclareArray2dReal(name, value)

    end subroutine DeclareArray2dReal

    ! -------------------------------------------------------------------------
    !> This subroutine writes a 2d-array of real(kind=real32)
    !! to the NetCDF file.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteArray2dReal(this, name, value)

        use netcdf, only : nf90_put_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real32), dimension(:,:), intent(in)      :: value

        integer :: retval

        if (.not. is_enabled) return
        retval = CheckError(nf90_put_var(this%ncid, this%var_id(this%next_var_index), &
                                         value(:,:)))
        call this%PSyDataBaseType%ProvideArray2dReal(name, value)

    end subroutine WriteArray2dReal

    ! -------------------------------------------------------------------------
    !> This subroutine reads the values of a 2d-array of real(kind=real32)
    !! It allocates memory for the allocatable parameter 'value' to store the
    !! read values which is then returned to the caller. If the memory for the
    !! array cannot be allocated, the application will be stopped.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[out] value An allocatable, unallocated 2d-double precision array
    !!             which is allocated here and stores the values read.
    subroutine ReadArray2dReal(this, name, value)

        use netcdf

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target          :: this
        character(*), intent(in)                                     :: name
        real(kind=real32), dimension(:,:), allocatable, intent(out) :: value

        integer        :: retval, varid
        integer        :: dim_id
        integer        :: dim_size1,dim_size2
        integer        :: ierr

        ! First query the dimensions of the original array from the
        ! NetCDF file
        retval = CheckError(nf90_inq_dimid(this%ncid, trim(name//"dim%1"), &
                                           dim_id))
        retval = CheckError(nf90_inquire_dimension(this%ncid, dim_id, &
                                                   len=dim_size1))
        retval = CheckError(nf90_inq_dimid(this%ncid, trim(name//"dim%2"), &
                                           dim_id))
        retval = CheckError(nf90_inquire_dimension(this%ncid, dim_id, &
                                                   len=dim_size2))

        ! Allocate enough space to store the values to be read:
        allocate(value(dim_size1,dim_size2), Stat=ierr)
        if (ierr /= 0) then
            write(stderr,*) "Cannot allocate array for ", name, &
                            " of size ", dim_size1,dim_size2, &
                            " in ReadArray2dReal."
            stop
        endif

        ! Initialise it with 0, so that an array comparison will work
        ! even though e.g. boundary areas or so might not be set at all.
        ! The compiler will convert the double precision value to the right
        ! type (e.g. int or single precision).
        value = 0.0d0
        retval = CheckError(nf90_inq_varid(this%ncid, name, varid))
        retval = CheckError(nf90_get_var(this%ncid, varid, value))

    end subroutine ReadArray2dReal

    ! -------------------------------------------------------------------------
    !> This subroutine declares a scalar real(kind=real64) value.
    !! A corresponding variable definition is added to the NetCDF file, and
    !! the variable id is stored in the var_id field.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareScalarDouble(this, name, value)

        use netcdf, only : nf90_def_var, NF90_DOUBLE

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real64), intent(in)                                :: value

        integer                            :: retval
        integer, dimension(:), allocatable :: tmp_var_id

        if (this%next_var_index > size(this%var_id)) then
            ! This can happen in LFRic when vector fields are used
            ! Each dimension of this vector becomes one NetCDF
            ! variable, so we need to potentially reallocate this field
            allocate(tmp_var_id(2*size(this%var_id)))
            tmp_var_id(1:size(this%var_id)) = this%var_id
            deallocate(this%var_id)
            call move_alloc(tmp_var_id, this%var_id)
            ! tmp_var_id is deallacted as part of move_alloc
        endif
        retval = CheckError(nf90_def_var(this%ncid, name, NF90_DOUBLE, &
                                         this%var_id(this%next_var_index)))
        call this%PSyDataBaseType%DeclareScalarDouble(name, value)

    end subroutine DeclareScalarDouble

    ! -------------------------------------------------------------------------
    !> This subroutine writes the value of a scalar real(kind=real64)
    !! variable to the NetCDF file. It takes the variable id from the
    !! corresponding declaration.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteScalarDouble(this, name, value)

        use netcdf, only : nf90_put_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real64), intent(in)                                :: value
        integer                                             :: retval

        retval = CheckError(nf90_put_var(this%ncid, this%var_id(this%next_var_index), &
                                         value))
        call this%PSyDataBaseType%ProvideScalarDouble(name, value)

    end subroutine WriteScalarDouble

    ! -------------------------------------------------------------------------
    !> This subroutine reads the value of a scalar real(kind=real64)
    !! variable from the NetCDF file and returns it to the user. Note that
    !! this function is not part of the PSyData API, but it is convenient to
    !! have these functions together here. The driver can then be linked with
    !! this  PSyData library and will be able to read the files.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[out] value The read value is stored here.
    subroutine ReadScalarDouble(this, name, value)

        use netcdf, only : nf90_inq_varid, nf90_get_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real64), intent(out)                               :: value

        integer                                             :: retval, varid

        retval = CheckError(nf90_inq_varid(this%ncid, name, varid))
        retval = CheckError(nf90_get_var(this%ncid, varid, value))

    end subroutine ReadScalarDouble



    ! -------------------------------------------------------------------------
    !> This subroutine declares a 2d-array of real(kind=real64).
    !! A corresponding variable and dimension definitions are added
    !! to the NetCDF file, and the variable id is stored in the var_id field.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareArray2dDouble(this, name, value)

        use netcdf

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real64), dimension(:,:), intent(in)      :: value

        integer                            :: dimid1, dimid2
        integer                            :: retval
        integer, dimension(2)        :: dimids
        integer, dimension(:), allocatable :: tmp_var_id

        if (.not. is_enabled) return

        if (this%next_var_index > size(this%var_id)) then
            allocate(tmp_var_id(2*size(this%var_id)))
            tmp_var_id(1:size(this%var_id)) = this%var_id
            deallocate(this%var_id)
            call move_alloc(tmp_var_id, this%var_id)
            ! tmp_var_id is deallacted as part of move_alloc
        endif

        ! A '%' is added to avoid a clash if the user should have say
        ! an array 'a', and 'adim1'.
        retval = CheckError(nf90_def_dim(this%ncid, name//"dim%1", &
                                         size(value,1), dimid1))
        ! A '%' is added to avoid a clash if the user should have say
        ! an array 'a', and 'adim1'.
        retval = CheckError(nf90_def_dim(this%ncid, name//"dim%2", &
                                         size(value,2), dimid2))
        dimids =  (/ dimid1, dimid2 /)
        retval = CheckError(nf90_def_var(this%ncid, name, NF90_DOUBLE, &
                                         dimids, this%var_id(this%next_var_index)))

        call this%PSyDataBaseType%DeclareArray2dDouble(name, value)

    end subroutine DeclareArray2dDouble

    ! -------------------------------------------------------------------------
    !> This subroutine writes a 2d-array of real(kind=real64)
    !! to the NetCDF file.
    !! @param[in,out] this The instance of the ExtractNetcdfBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteArray2dDouble(this, name, value)

        use netcdf, only : nf90_put_var

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target :: this
        character(*), intent(in)                            :: name
        real(kind=real64), dimension(:,:), intent(in)      :: value

        integer :: retval

        if (.not. is_enabled) return
        retval = CheckError(nf90_put_var(this%ncid, this%var_id(this%next_var_index), &
                                         value(:,:)))
        call this%PSyDataBaseType%ProvideArray2dDouble(name, value)

    end subroutine WriteArray2dDouble

    ! -------------------------------------------------------------------------
    !> This subroutine reads the values of a 2d-array of real(kind=real64)
    !! It allocates memory for the allocatable parameter 'value' to store the
    !! read values which is then returned to the caller. If the memory for the
    !! array cannot be allocated, the application will be stopped.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[out] value An allocatable, unallocated 2d-double precision array
    !!             which is allocated here and stores the values read.
    subroutine ReadArray2dDouble(this, name, value)

        use netcdf

        implicit none

        class(ExtractNetcdfBaseType), intent(inout), target          :: this
        character(*), intent(in)                                     :: name
        real(kind=real64), dimension(:,:), allocatable, intent(out) :: value

        integer        :: retval, varid
        integer        :: dim_id
        integer        :: dim_size1,dim_size2
        integer        :: ierr

        ! First query the dimensions of the original array from the
        ! NetCDF file
        retval = CheckError(nf90_inq_dimid(this%ncid, trim(name//"dim%1"), &
                                           dim_id))
        retval = CheckError(nf90_inquire_dimension(this%ncid, dim_id, &
                                                   len=dim_size1))
        retval = CheckError(nf90_inq_dimid(this%ncid, trim(name//"dim%2"), &
                                           dim_id))
        retval = CheckError(nf90_inquire_dimension(this%ncid, dim_id, &
                                                   len=dim_size2))

        ! Allocate enough space to store the values to be read:
        allocate(value(dim_size1,dim_size2), Stat=ierr)
        if (ierr /= 0) then
            write(stderr,*) "Cannot allocate array for ", name, &
                            " of size ", dim_size1,dim_size2, &
                            " in ReadArray2dDouble."
            stop
        endif

        ! Initialise it with 0, so that an array comparison will work
        ! even though e.g. boundary areas or so might not be set at all.
        ! The compiler will convert the double precision value to the right
        ! type (e.g. int or single precision).
        value = 0.0d0
        retval = CheckError(nf90_inq_varid(this%ncid, name, varid))
        retval = CheckError(nf90_get_var(this%ncid, varid, value))

    end subroutine ReadArray2dDouble


end module extract_netcdf_base_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office

!> This module implements a verification that read-only fields are
!! not overwritten (due to memory overwrites etc)
!!

module read_only_verify_psy_data_mod

    use, intrinsic :: iso_fortran_env, only : int64, int32,   &
                                              real32, real64, &
                                              stderr => Error_Unit
    use field_mod, only : field_type
    use integer_field_mod, only : integer_field_type
    use read_only_base_mod, only : ReadOnlyBaseType, is_enabled

    implicit none

    !> This is the data type that stores a checksum for each read-only
    !! variable. A static instance of this type is created for each
    !! instrumented region with PSyclone.

    type, extends(ReadOnlyBaseType), public :: read_only_verify_PSyDataType

    contains

        ! The LFRic-specific procedures defined here
        procedure :: DeclareField
        procedure :: ProvideField
        procedure :: DeclareFieldVector
        procedure :: ProvideFieldVector
        procedure :: DeclareIntField
        procedure :: ProvideIntField
        procedure :: DeclareIntFieldVector
        procedure :: ProvideIntFieldVector

        ! Declare generic interface for PreDeclareVariable:
        generic, public :: PreDeclareVariable => &
                           DeclareField,         &
                           DeclareFieldVector,   &
                           DeclareIntField,      &
                           DeclareIntFieldVector

        !> The generic interface for providing the value of variables,
        !! which in case of the read-only verification either computes
        !! the checksum (before a kernel), or compares a checksum (after
        !! a kernel call).
        generic, public :: ProvideVariable =>  &
                           ProvideField,       &
                           ProvideFieldVector, &
                           ProvideIntField,    &
                           ProvideIntFieldVector

    end type read_only_verify_PSyDataType

contains

    ! -------------------------------------------------------------------------
    !> This subroutine declares a real-valued (double precision) field based on
    !! the LFRic infrastructure type field_type.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareField(this, name, value)

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(field_type), intent(in) :: value

        this%next_var_index = this%next_var_index + 1

    end subroutine DeclareField

    ! -------------------------------------------------------------------------
    !> This subroutine declares an integer field based on the LFRic
    !! infrastructure type integer_field_type.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareIntField(this, name, value)

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(integer_field_type), intent(in) :: value

        this%next_var_index = this%next_var_index + 1

    end subroutine DeclareIntField

    ! -------------------------------------------------------------------------
    !> This subroutine computes the checksum for a real-valued field based on
    !! the LFRic infrastructure type field_type. Depending on state
    !! (this%verify_checksum) it either stores the checksum, or compares it
    !! with a previously computed checksum.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideField(this, name, value)

        use field_mod, only : field_type, field_proxy_type
        use read_only_base_mod, only : ComputeChecksum

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(field_type), intent(in) :: value
        type(field_proxy_type) :: value_proxy
        integer(kind=int64):: cksum

        if (.not. is_enabled) return

        value_proxy = value%get_proxy()
        cksum = ComputeChecksum(value_proxy%data)
        ! We could call ProvideArray1DDouble here, but would get a
        ! confusing error message
        if (this%verify_checksums) then
            if (this%checksums(this%next_var_index) /= cksum) then
                write(stderr,*) "------------- PSyData -------------------------"
                write(stderr, *) "Double precision field ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                write(stderr, *) "Original checksum: ", this%checksums(this%next_var_index)
                write(stderr, *) "New checksum:      ", cksum
                write(stderr,*) "------------- PSyData -------------------------"
            else if (this%verbosity>1) then
                write(stderr, *) "PSyData: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = cksum
        endif

        this%next_var_index = this%next_var_index + 1

    end subroutine ProvideField

    ! -------------------------------------------------------------------------
    !> This subroutine computes the checksum for an integer-valued field based
    !! on the LFRic infrastructure type integer_field_type. Depending on state
    !! (this%verify_checksum) it either stores the checksum, or compares it
    !! with a previously computed checksum.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideIntField(this, name, value)

        use integer_field_mod,  only : integer_field_type, &
                                       integer_field_proxy_type
        use read_only_base_mod, only : ComputeChecksum

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(integer_field_type), intent(in) :: value
        type(integer_field_proxy_type) :: value_proxy
        integer(kind=int64):: cksum

        if (.not. is_enabled) return

        value_proxy = value%get_proxy()
        cksum = ComputeChecksum(value_proxy%data)
        ! We could call ProvideArray1DInt here, but would get a
        ! confusing error message
        if (this%verify_checksums) then
            if (this%checksums(this%next_var_index) /= cksum) then
                write(stderr,*) "------------- PSyData -------------------------"
                write(stderr, *) "Integer-valued field ", name, " has been modified in ", &
                    trim(this%module_name)," : ", trim(this%region_name)
                write(stderr, *) "Original checksum: ", this%checksums(this%next_var_index)
                write(stderr, *) "New checksum:      ", cksum
                write(stderr,*) "------------- PSyData -------------------------"
            else if (this%verbosity>1) then
                write(stderr, *) "PSyData: checked variable ", trim(name)
            endif
        else
            this%checksums(this%next_var_index) = cksum
        endif

        this%next_var_index = this%next_var_index + 1

    end subroutine ProvideIntField

    ! -------------------------------------------------------------------------
    !> This subroutine declares a vector of real-valued (double precision)
    !! fields based on the LFRic infrastructure type field_type.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareFieldVector(this, name, value)

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(field_type), dimension(:), intent(in) :: value

        this%next_var_index = this%next_var_index + size(value, 1)

    end subroutine DeclareFieldVector

    ! -------------------------------------------------------------------------
    !> This subroutine declares a vector of integer fields based on
    !! the LFRic infrastructure type integer_field_type.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareIntFieldVector(this, name, value)

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(integer_field_type), dimension(:), intent(in) :: value

        this%next_var_index = this%next_var_index + size(value, 1)

    end subroutine DeclareIntFieldVector

    ! -------------------------------------------------------------------------
    !> This subroutine computes the checksums for a vector of real-valued
    !! fields based on the LFRic infrastructure type field_type. It uses
    !! ProvideField to handle each individual field of the vector (i.e.
    !! storing or comparing the checksum). This way the read-only verification
    !! is done separately for each field member of the vector.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The vector of fields.
    subroutine ProvideFieldVector(this, name, value)

        use field_mod, only : field_type, field_proxy_type

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(field_type), dimension(:), intent(in) :: value
        type(field_proxy_type) :: value_proxy
        integer(kind=int64) :: cksum
        integer :: i
        ! Enough for a 6 digit number plus '()'
        character(8) :: index_string

        if (.not. is_enabled) return

        ! Provide each member of the vector as a normal field. This way
        ! the checksum will be computed for each member individually.
        do i = 1, size(value, 1)
            value_proxy = value(i)%get_proxy()
            write(index_string, '("(",i0,")")') i
            call this%ProvideField(name//trim(index_string), value(i))
        enddo

    end subroutine ProvideFieldVector

    ! -------------------------------------------------------------------------
    !> This subroutine computes the checksums for a vector of integer-valued
    !! fields based on the LFRic infrastructure type integer_field_type. It
    !! uses ProvideField to handle each individual field of the vector
    !! (i.e. storing or comparing the checksum). This way the read-only
    !! verification is done separately for each field member of the vector.
    !! @param[in,out] this The instance of the read_only_verify_PSyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The vector of fields.
    subroutine ProvideIntFieldVector(this, name, value)

        use integer_field_mod, only : integer_field_type, &
                                      integer_field_proxy_type

        implicit none

        class(read_only_verify_PSyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(integer_field_type), dimension(:), intent(in) :: value
        type(integer_field_proxy_type) :: value_proxy
        integer(kind=int64) :: cksum
        integer :: i
        ! Enough for a 6 digit number plus '()'
        character(8) :: index_string

        if (.not. is_enabled) return

        ! Provide each member of the vector as a normal field. This way
        ! the checksum will be computed for each member individually.
        do i = 1, size(value, 1)
            value_proxy = value(i)%get_proxy()
            write(index_string, '("(",i0,")")') i
            call this%ProvideIntField(name//trim(index_string), value(i))
        enddo

    end subroutine ProvideIntFieldVector

    ! -------------------------------------------------------------------------

end module read_only_verify_psy_data_mod

module compute_pnew_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod
  use field_mod
  implicit none

  private

  public invoke_compute_pnew
  public compute_pnew, compute_pnew_code

  type, extends(kernel_type) :: compute_pnew
     type(go_arg), dimension(7) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_CT, GO_POINTWISE),            & ! pnew
             go_arg(GO_READ,  GO_CT, GO_POINTWISE),            & ! pold
             go_arg(GO_READ,  GO_CU, GO_STENCIL(000,011,000)), & ! cu
             go_arg(GO_READ,  GO_CV, GO_STENCIL(010,010,000)), & ! cv
             go_arg(GO_READ,  GO_R_SCALAR, GO_POINTWISE),  & ! tdt
             go_arg(GO_READ,  GO_GRID_DX_CONST),        & ! dx
             go_arg(GO_READ,  GO_GRID_DY_CONST)         & ! dy
           /)
     !> This kernel operates on fields that live on an
     !! orthogonal, regular grid.
     integer :: GRID_TYPE = GO_ORTHOGONAL_REGULAR

     !> This kernel writes only to internal grid points
     INTEGER :: ITERATES_OVER = GO_INTERNAL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => compute_pnew_code
  end type compute_pnew

contains

  !===================================================

  subroutine invoke_compute_pnew(pnew, pold, cu, cv, tdt)
    implicit none
    type(r2d_field), intent(inout) :: pnew
    type(r2d_field), intent(in)    :: pold, cu, cv
    real(go_wp), intent(in) :: tdt
    ! Locals
    integer :: I, J
    real(go_wp) :: dx, dy

    ! Note that we do not loop over the full extent of the field.
    ! Fields are allocated with extents (M+1,N+1).
    ! Presumably the extra row and column are needed for periodic BCs.
    ! We are updating a quantity on CT.
    ! This loop writes to pnew(1:M,1:N) so this looks like
    ! (using x to indicate a location that is written):
    !
    ! i=1   i=M
    !  o  o  o  o 
    !  x  x  x  o   j=N
    !  x  x  x  o
    !  x  x  x  o   j=1

    ! Original code looked like:
    !
    !     DO J=1,N
    !        DO I=1,M
    !           PNEW(I,J) = POLD(I,J)-TDTSDX*(CU(I+1,J)-CU(I,J))   & 
    !               -TDTSDY*(CV(I,J+1)-CV(I,J))
    !        END DO
    !     END DO

    ! pnew(i,j) depends upon:
    !   pold(i,j)                                : CT
    !   cu(i,j), cu(i+1,j)                       : CU
    !    => lateral CU neighbours of the CT pt being updated 
    !   cv(i,j), cv(i,j+1)                       : CT
    !    => vertical CV neighbours of the CT pt being updated

    !   x-------vij+1---fi+1j+1
    !   |       |       |
    !   |       |       |
    !   uij-----Tij-----ui+1j
    !   |       |       |
    !   |       |       |
    !   fij-----vij-----fi+1j
    !   |       |       |
    !   |       |       |
    !   uij-1- -Tij-1---ui+1j-1
    !
    dx = pnew%grid%dx
    dy = pnew%grid%dy

    DO J=pnew%internal%ystart, pnew%internal%ystop, 1
       DO I=pnew%internal%xstart, pnew%internal%xstop, 1

          CALL compute_pnew_code(i, j,                 &
                                 pnew%data, pold%data, &
                                 cu%data, cv%data, tdt, dx, dy)
       END DO
    END DO

  end subroutine invoke_compute_pnew

  !===================================================

  subroutine compute_pnew_code(i, j, &
                               pnew, pold, cu, cv, &
                               tdt, dx, dy)
    implicit none
    integer,  intent(in) :: I, J
    real(go_wp), intent(in) :: dx, dy
    real(go_wp), intent(out), dimension(:,:) :: pnew
    real(go_wp), intent(in),  dimension(:,:) :: pold, cu, cv
    real(go_wp), intent(in) :: tdt
    ! Locals
    real(go_wp) :: tdtsdx, tdtsdy

    !> These quantities are computed here because tdt is not
    !! constant. (It is == dt for first time step, 2xdt for
    !! all remaining time steps.)
    tdtsdx = tdt/dx
    tdtsdy = tdt/dy

    PNEW(I,J) = POLD(I,J)-TDTSDX*(CU(I+1,J)-CU(I,J))   & 
                         -TDTSDY*(CV(I,J+1)-CV(I,J))

  END SUBROUTINE compute_pnew_code

END MODULE compute_pnew_mod

  MODULE main_psy
    USE constants_mod, ONLY: r_def, i_def
    USE field_mod, ONLY: field_type, field_proxy_type
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(field_1, field_1_input, field_2, field_2_input, field_3, field_3_input, field_4, field_4_input, field_5, &
&field_5_input, field_6, field_6_input, field_7, field_7_input, field_8, field_8_input, field_9, field_9_input, field_10, &
&field_10_input, field_10_1, field_10_input_1, field_10_2, field_10_input_2, field_11, field_11_input, field_10_3, rscalar_12, &
&rscalar_13, rscalar_14, field_1_inner_prod, field_2_inner_prod, field_3_inner_prod, field_4_inner_prod, field_5_inner_prod, &
&field_6_inner_prod, field_7_inner_prod, field_8_inner_prod, field_9_inner_prod, field_10_inner_prod, field_10_inner_prod_1, &
&field_10_inner_prod_2, field_11_inner_prod, qr_xyoz)
      USE tl_rhs_eos_kernel_mod, ONLY: tl_rhs_eos_code
      USE nan_test_psy_data_mod, ONLY: nan_test_PSyDataType
      USE quadrature_xyoz_mod, ONLY: quadrature_xyoz_type, quadrature_xyoz_proxy_type
      USE function_space_mod, ONLY: BASIS, DIFF_BASIS
      REAL(KIND=r_def), intent(out) :: field_1_inner_prod, field_2_inner_prod, field_3_inner_prod, field_4_inner_prod, &
&field_5_inner_prod, field_6_inner_prod, field_7_inner_prod, field_8_inner_prod, field_9_inner_prod, field_10_inner_prod, &
&field_10_inner_prod_1, field_10_inner_prod_2, field_11_inner_prod
      REAL(KIND=r_def), intent(in) :: rscalar_12, rscalar_13, rscalar_14
      TYPE(field_type), intent(in) :: field_1, field_1_input, field_2, field_2_input, field_3, field_3_input, field_4, &
&field_4_input, field_5, field_5_input, field_6, field_6_input, field_7, field_7_input, field_8, field_8_input, field_9, &
&field_9_input, field_10, field_10_input, field_10_1, field_10_input_1, field_10_2, field_10_input_2, field_11, field_11_input, &
&field_10_3(3)
      TYPE(quadrature_xyoz_type), intent(in) :: qr_xyoz
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_39
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_38
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_37
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_36
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_35
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_34
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_33
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_32
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_31
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_30
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_29
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_28
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_27
      INTEGER(KIND=i_def) cell
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_26
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_25
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_24
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_23
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_22
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_21
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_20
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_19
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_18
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_17
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_16
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_15
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_14
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_13
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_12
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_11
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_10
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_9
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_8
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_7
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_6
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_5
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_4
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_3
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_2
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_1
      INTEGER df
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data
      INTEGER(KIND=i_def) loop39_start, loop39_stop
      INTEGER(KIND=i_def) loop38_start, loop38_stop
      INTEGER(KIND=i_def) loop37_start, loop37_stop
      INTEGER(KIND=i_def) loop36_start, loop36_stop
      INTEGER(KIND=i_def) loop35_start, loop35_stop
      INTEGER(KIND=i_def) loop34_start, loop34_stop
      INTEGER(KIND=i_def) loop33_start, loop33_stop
      INTEGER(KIND=i_def) loop32_start, loop32_stop
      INTEGER(KIND=i_def) loop31_start, loop31_stop
      INTEGER(KIND=i_def) loop30_start, loop30_stop
      INTEGER(KIND=i_def) loop29_start, loop29_stop
      INTEGER(KIND=i_def) loop28_start, loop28_stop
      INTEGER(KIND=i_def) loop27_start, loop27_stop
      INTEGER(KIND=i_def) loop26_start, loop26_stop
      INTEGER(KIND=i_def) loop25_start, loop25_stop
      INTEGER(KIND=i_def) loop24_start, loop24_stop
      INTEGER(KIND=i_def) loop23_start, loop23_stop
      INTEGER(KIND=i_def) loop22_start, loop22_stop
      INTEGER(KIND=i_def) loop21_start, loop21_stop
      INTEGER(KIND=i_def) loop20_start, loop20_stop
      INTEGER(KIND=i_def) loop19_start, loop19_stop
      INTEGER(KIND=i_def) loop18_start, loop18_stop
      INTEGER(KIND=i_def) loop17_start, loop17_stop
      INTEGER(KIND=i_def) loop16_start, loop16_stop
      INTEGER(KIND=i_def) loop15_start, loop15_stop
      INTEGER(KIND=i_def) loop14_start, loop14_stop
      INTEGER(KIND=i_def) loop13_start, loop13_stop
      INTEGER(KIND=i_def) loop12_start, loop12_stop
      INTEGER(KIND=i_def) loop11_start, loop11_stop
      INTEGER(KIND=i_def) loop10_start, loop10_stop
      INTEGER(KIND=i_def) loop9_start, loop9_stop
      INTEGER(KIND=i_def) loop8_start, loop8_stop
      INTEGER(KIND=i_def) loop7_start, loop7_stop
      INTEGER(KIND=i_def) loop6_start, loop6_stop
      INTEGER(KIND=i_def) loop5_start, loop5_stop
      INTEGER(KIND=i_def) loop4_start, loop4_stop
      INTEGER(KIND=i_def) loop3_start, loop3_stop
      INTEGER(KIND=i_def) loop2_start, loop2_stop
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      REAL(KIND=r_def), allocatable :: basis_w3_qr_xyoz(:,:,:,:), basis_wtheta_qr_xyoz(:,:,:,:), &
&basis_aspc9_field_10_3_qr_xyoz(:,:,:,:), diff_basis_aspc9_field_10_3_qr_xyoz(:,:,:,:)
      INTEGER(KIND=i_def) dim_w3, dim_wtheta, dim_aspc9_field_10_3, diff_dim_aspc9_field_10_3
      REAL(KIND=r_def), pointer :: weights_xy_qr_xyoz(:) => null(), weights_z_qr_xyoz(:) => null()
      INTEGER(KIND=i_def) np_xy_qr_xyoz, np_z_qr_xyoz
      INTEGER(KIND=i_def) nlayers
      TYPE(field_proxy_type) field_1_proxy, field_1_input_proxy, field_2_proxy, field_2_input_proxy, field_3_proxy, &
&field_3_input_proxy, field_4_proxy, field_4_input_proxy, field_5_proxy, field_5_input_proxy, field_6_proxy, field_6_input_proxy, &
&field_7_proxy, field_7_input_proxy, field_8_proxy, field_8_input_proxy, field_9_proxy, field_9_input_proxy, field_10_proxy, &
&field_10_input_proxy, field_10_1_proxy, field_10_input_1_proxy, field_10_2_proxy, field_10_input_2_proxy, field_11_proxy, &
&field_11_input_proxy, field_10_3_proxy(3)
      TYPE(quadrature_xyoz_proxy_type) qr_xyoz_proxy
      INTEGER(KIND=i_def), pointer :: map_adspc3_field_11(:,:) => null(), map_aspc9_field_10_3(:,:) => null(), &
&map_w3(:,:) => null(), map_wtheta(:,:) => null()
      INTEGER(KIND=i_def) ndf_aspc1_field_1, undf_aspc1_field_1, ndf_aspc1_field_1_input, undf_aspc1_field_1_input, &
&ndf_aspc1_field_2, undf_aspc1_field_2, ndf_aspc1_field_2_input, undf_aspc1_field_2_input, ndf_aspc1_field_3, undf_aspc1_field_3, &
&ndf_aspc1_field_3_input, undf_aspc1_field_3_input, ndf_aspc1_field_4, undf_aspc1_field_4, ndf_aspc1_field_4_input, &
&undf_aspc1_field_4_input, ndf_aspc1_field_5, undf_aspc1_field_5, ndf_aspc1_field_5_input, undf_aspc1_field_5_input, &
&ndf_aspc1_field_6, undf_aspc1_field_6, ndf_aspc1_field_6_input, undf_aspc1_field_6_input, ndf_aspc1_field_7, undf_aspc1_field_7, &
&ndf_aspc1_field_7_input, undf_aspc1_field_7_input, ndf_aspc1_field_8, undf_aspc1_field_8, ndf_aspc1_field_8_input, &
&undf_aspc1_field_8_input, ndf_aspc1_field_9, undf_aspc1_field_9, ndf_aspc1_field_9_input, undf_aspc1_field_9_input, &
&ndf_aspc1_field_10, undf_aspc1_field_10, ndf_aspc1_field_10_input, undf_aspc1_field_10_input, ndf_aspc1_field_10_1, &
&undf_aspc1_field_10_1, ndf_aspc1_field_10_input_1, undf_aspc1_field_10_input_1, ndf_aspc1_field_10_2, undf_aspc1_field_10_2, &
&ndf_aspc1_field_10_input_2, undf_aspc1_field_10_input_2, ndf_aspc1_field_11, undf_aspc1_field_11, ndf_aspc1_field_11_input, &
&undf_aspc1_field_11_input, ndf_w3, undf_w3, ndf_wtheta, undf_wtheta, ndf_aspc9_field_10_3, undf_aspc9_field_10_3, &
&ndf_adspc3_field_11, undf_adspc3_field_11
      !
      ! Initialise field and/or operator proxies
      !
      field_1_proxy = field_1%get_proxy()
      field_1_input_proxy = field_1_input%get_proxy()
      field_2_proxy = field_2%get_proxy()
      field_2_input_proxy = field_2_input%get_proxy()
      field_3_proxy = field_3%get_proxy()
      field_3_input_proxy = field_3_input%get_proxy()
      field_4_proxy = field_4%get_proxy()
      field_4_input_proxy = field_4_input%get_proxy()
      field_5_proxy = field_5%get_proxy()
      field_5_input_proxy = field_5_input%get_proxy()
      field_6_proxy = field_6%get_proxy()
      field_6_input_proxy = field_6_input%get_proxy()
      field_7_proxy = field_7%get_proxy()
      field_7_input_proxy = field_7_input%get_proxy()
      field_8_proxy = field_8%get_proxy()
      field_8_input_proxy = field_8_input%get_proxy()
      field_9_proxy = field_9%get_proxy()
      field_9_input_proxy = field_9_input%get_proxy()
      field_10_proxy = field_10%get_proxy()
      field_10_input_proxy = field_10_input%get_proxy()
      field_10_1_proxy = field_10_1%get_proxy()
      field_10_input_1_proxy = field_10_input_1%get_proxy()
      field_10_2_proxy = field_10_2%get_proxy()
      field_10_input_2_proxy = field_10_input_2%get_proxy()
      field_11_proxy = field_11%get_proxy()
      field_11_input_proxy = field_11_input%get_proxy()
      field_10_3_proxy(1) = field_10_3(1)%get_proxy()
      field_10_3_proxy(2) = field_10_3(2)%get_proxy()
      field_10_3_proxy(3) = field_10_3(3)%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = field_1_proxy%vspace%get_nlayers()
      !
      ! Look-up dofmaps for each function space
      !
      map_w3 => field_1_proxy%vspace%get_whole_dofmap()
      map_wtheta => field_4_proxy%vspace%get_whole_dofmap()
      map_aspc9_field_10_3 => field_10_3_proxy(1)%vspace%get_whole_dofmap()
      map_adspc3_field_11 => field_11_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for aspc1_field_1
      !
      ndf_aspc1_field_1 = field_1_proxy%vspace%get_ndf()
      undf_aspc1_field_1 = field_1_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_1_input
      !
      ndf_aspc1_field_1_input = field_1_input_proxy%vspace%get_ndf()
      undf_aspc1_field_1_input = field_1_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_2
      !
      ndf_aspc1_field_2 = field_2_proxy%vspace%get_ndf()
      undf_aspc1_field_2 = field_2_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_2_input
      !
      ndf_aspc1_field_2_input = field_2_input_proxy%vspace%get_ndf()
      undf_aspc1_field_2_input = field_2_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_3
      !
      ndf_aspc1_field_3 = field_3_proxy%vspace%get_ndf()
      undf_aspc1_field_3 = field_3_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_3_input
      !
      ndf_aspc1_field_3_input = field_3_input_proxy%vspace%get_ndf()
      undf_aspc1_field_3_input = field_3_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_4
      !
      ndf_aspc1_field_4 = field_4_proxy%vspace%get_ndf()
      undf_aspc1_field_4 = field_4_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_4_input
      !
      ndf_aspc1_field_4_input = field_4_input_proxy%vspace%get_ndf()
      undf_aspc1_field_4_input = field_4_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_5
      !
      ndf_aspc1_field_5 = field_5_proxy%vspace%get_ndf()
      undf_aspc1_field_5 = field_5_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_5_input
      !
      ndf_aspc1_field_5_input = field_5_input_proxy%vspace%get_ndf()
      undf_aspc1_field_5_input = field_5_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_6
      !
      ndf_aspc1_field_6 = field_6_proxy%vspace%get_ndf()
      undf_aspc1_field_6 = field_6_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_6_input
      !
      ndf_aspc1_field_6_input = field_6_input_proxy%vspace%get_ndf()
      undf_aspc1_field_6_input = field_6_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_7
      !
      ndf_aspc1_field_7 = field_7_proxy%vspace%get_ndf()
      undf_aspc1_field_7 = field_7_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_7_input
      !
      ndf_aspc1_field_7_input = field_7_input_proxy%vspace%get_ndf()
      undf_aspc1_field_7_input = field_7_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_8
      !
      ndf_aspc1_field_8 = field_8_proxy%vspace%get_ndf()
      undf_aspc1_field_8 = field_8_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_8_input
      !
      ndf_aspc1_field_8_input = field_8_input_proxy%vspace%get_ndf()
      undf_aspc1_field_8_input = field_8_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_9
      !
      ndf_aspc1_field_9 = field_9_proxy%vspace%get_ndf()
      undf_aspc1_field_9 = field_9_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_9_input
      !
      ndf_aspc1_field_9_input = field_9_input_proxy%vspace%get_ndf()
      undf_aspc1_field_9_input = field_9_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10
      !
      ndf_aspc1_field_10 = field_10_proxy%vspace%get_ndf()
      undf_aspc1_field_10 = field_10_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10_input
      !
      ndf_aspc1_field_10_input = field_10_input_proxy%vspace%get_ndf()
      undf_aspc1_field_10_input = field_10_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10_1
      !
      ndf_aspc1_field_10_1 = field_10_1_proxy%vspace%get_ndf()
      undf_aspc1_field_10_1 = field_10_1_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10_input_1
      !
      ndf_aspc1_field_10_input_1 = field_10_input_1_proxy%vspace%get_ndf()
      undf_aspc1_field_10_input_1 = field_10_input_1_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10_2
      !
      ndf_aspc1_field_10_2 = field_10_2_proxy%vspace%get_ndf()
      undf_aspc1_field_10_2 = field_10_2_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10_input_2
      !
      ndf_aspc1_field_10_input_2 = field_10_input_2_proxy%vspace%get_ndf()
      undf_aspc1_field_10_input_2 = field_10_input_2_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_11
      !
      ndf_aspc1_field_11 = field_11_proxy%vspace%get_ndf()
      undf_aspc1_field_11 = field_11_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_11_input
      !
      ndf_aspc1_field_11_input = field_11_input_proxy%vspace%get_ndf()
      undf_aspc1_field_11_input = field_11_input_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for w3
      !
      ndf_w3 = field_1_proxy%vspace%get_ndf()
      undf_w3 = field_1_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for wtheta
      !
      ndf_wtheta = field_4_proxy%vspace%get_ndf()
      undf_wtheta = field_4_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc9_field_10_3
      !
      ndf_aspc9_field_10_3 = field_10_3_proxy(1)%vspace%get_ndf()
      undf_aspc9_field_10_3 = field_10_3_proxy(1)%vspace%get_undf()
      !
      ! Initialise number of DoFs for adspc3_field_11
      !
      ndf_adspc3_field_11 = field_11_proxy%vspace%get_ndf()
      undf_adspc3_field_11 = field_11_proxy%vspace%get_undf()
      !
      ! Look-up quadrature variables
      !
      qr_xyoz_proxy = qr_xyoz%get_quadrature_proxy()
      np_xy_qr_xyoz = qr_xyoz_proxy%np_xy
      np_z_qr_xyoz = qr_xyoz_proxy%np_z
      weights_xy_qr_xyoz => qr_xyoz_proxy%weights_xy
      weights_z_qr_xyoz => qr_xyoz_proxy%weights_z
      !
      ! Allocate basis/diff-basis arrays
      !
      dim_w3 = field_1_proxy%vspace%get_dim_space()
      dim_wtheta = field_4_proxy%vspace%get_dim_space()
      dim_aspc9_field_10_3 = field_10_3_proxy(1)%vspace%get_dim_space()
      diff_dim_aspc9_field_10_3 = field_10_3_proxy(1)%vspace%get_dim_space_diff()
      ALLOCATE (basis_w3_qr_xyoz(dim_w3, ndf_w3, np_xy_qr_xyoz, np_z_qr_xyoz))
      ALLOCATE (basis_wtheta_qr_xyoz(dim_wtheta, ndf_wtheta, np_xy_qr_xyoz, np_z_qr_xyoz))
      ALLOCATE (basis_aspc9_field_10_3_qr_xyoz(dim_aspc9_field_10_3, ndf_aspc9_field_10_3, np_xy_qr_xyoz, np_z_qr_xyoz))
      ALLOCATE (diff_basis_aspc9_field_10_3_qr_xyoz(diff_dim_aspc9_field_10_3, ndf_aspc9_field_10_3, np_xy_qr_xyoz, np_z_qr_xyoz))
      !
      ! Compute basis/diff-basis arrays
      !
      CALL qr_xyoz%compute_function(BASIS, field_1_proxy%vspace, dim_w3, ndf_w3, basis_w3_qr_xyoz)
      CALL qr_xyoz%compute_function(BASIS, field_4_proxy%vspace, dim_wtheta, ndf_wtheta, basis_wtheta_qr_xyoz)
      CALL qr_xyoz%compute_function(BASIS, field_10_3_proxy(1)%vspace, dim_aspc9_field_10_3, ndf_aspc9_field_10_3, &
&basis_aspc9_field_10_3_qr_xyoz)
      CALL qr_xyoz%compute_function(DIFF_BASIS, field_10_3_proxy(1)%vspace, diff_dim_aspc9_field_10_3, ndf_aspc9_field_10_3, &
&diff_basis_aspc9_field_10_3_qr_xyoz)
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = undf_aspc1_field_1
      loop1_start = 1
      loop1_stop = undf_aspc1_field_1_input
      loop2_start = 1
      loop2_stop = undf_aspc1_field_2
      loop3_start = 1
      loop3_stop = undf_aspc1_field_2_input
      loop4_start = 1
      loop4_stop = undf_aspc1_field_3
      loop5_start = 1
      loop5_stop = undf_aspc1_field_3_input
      loop6_start = 1
      loop6_stop = undf_aspc1_field_4
      loop7_start = 1
      loop7_stop = undf_aspc1_field_4_input
      loop8_start = 1
      loop8_stop = undf_aspc1_field_5
      loop9_start = 1
      loop9_stop = undf_aspc1_field_5_input
      loop10_start = 1
      loop10_stop = undf_aspc1_field_6
      loop11_start = 1
      loop11_stop = undf_aspc1_field_6_input
      loop12_start = 1
      loop12_stop = undf_aspc1_field_7
      loop13_start = 1
      loop13_stop = undf_aspc1_field_7_input
      loop14_start = 1
      loop14_stop = undf_aspc1_field_8
      loop15_start = 1
      loop15_stop = undf_aspc1_field_8_input
      loop16_start = 1
      loop16_stop = undf_aspc1_field_9
      loop17_start = 1
      loop17_stop = undf_aspc1_field_9_input
      loop18_start = 1
      loop18_stop = undf_aspc1_field_10
      loop19_start = 1
      loop19_stop = undf_aspc1_field_10_input
      loop20_start = 1
      loop20_stop = undf_aspc1_field_10_1
      loop21_start = 1
      loop21_stop = undf_aspc1_field_10_input_1
      loop22_start = 1
      loop22_stop = undf_aspc1_field_10_2
      loop23_start = 1
      loop23_stop = undf_aspc1_field_10_input_2
      loop24_start = 1
      loop24_stop = undf_aspc1_field_11
      loop25_start = 1
      loop25_stop = undf_aspc1_field_11_input
      loop26_start = 1
      loop26_stop = field_1_proxy%vspace%get_ncell()
      loop27_start = 1
      loop27_stop = undf_aspc1_field_1
      loop28_start = 1
      loop28_stop = undf_aspc1_field_2
      loop29_start = 1
      loop29_stop = undf_aspc1_field_3
      loop30_start = 1
      loop30_stop = undf_aspc1_field_4
      loop31_start = 1
      loop31_stop = undf_aspc1_field_5
      loop32_start = 1
      loop32_stop = undf_aspc1_field_6
      loop33_start = 1
      loop33_stop = undf_aspc1_field_7
      loop34_start = 1
      loop34_stop = undf_aspc1_field_8
      loop35_start = 1
      loop35_stop = undf_aspc1_field_9
      loop36_start = 1
      loop36_stop = undf_aspc1_field_10
      loop37_start = 1
      loop37_stop = undf_aspc1_field_10_1
      loop38_start = 1
      loop38_stop = undf_aspc1_field_10_2
      loop39_start = 1
      loop39_stop = undf_aspc1_field_11
      !
      ! Call our kernels
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data%PreStart("invoke_0", "loop0", 2, 1)
      CALL nan_test_psy_data%PreDeclareVariable("loop0_start", loop0_start)
      CALL nan_test_psy_data%PreDeclareVariable("loop0_stop", loop0_stop)
      CALL nan_test_psy_data%PreDeclareVariable("df", df)
      CALL nan_test_psy_data%PreEndDeclaration
      CALL nan_test_psy_data%ProvideVariable("loop0_start", loop0_start)
      CALL nan_test_psy_data%ProvideVariable("loop0_stop", loop0_stop)
      CALL nan_test_psy_data%PreEnd
      DO df=loop0_start,loop0_stop
        CALL random_number(field_1_proxy%data(df))
      END DO
      CALL nan_test_psy_data%PostStart
      CALL nan_test_psy_data%ProvideVariable("df", df)
      CALL nan_test_psy_data%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_1%PreStart("invoke_0", "loop1", 2, 1)
      CALL nan_test_psy_data_1%PreDeclareVariable("loop1_start", loop1_start)
      CALL nan_test_psy_data_1%PreDeclareVariable("loop1_stop", loop1_stop)
      CALL nan_test_psy_data_1%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_1%PreEndDeclaration
      CALL nan_test_psy_data_1%ProvideVariable("loop1_start", loop1_start)
      CALL nan_test_psy_data_1%ProvideVariable("loop1_stop", loop1_stop)
      CALL nan_test_psy_data_1%PreEnd
      DO df=loop1_start,loop1_stop
        field_1_input_proxy%data(df) = field_1_proxy%data(df)
      END DO
      CALL nan_test_psy_data_1%PostStart
      CALL nan_test_psy_data_1%ProvideVariable("df", df)
      CALL nan_test_psy_data_1%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_2%PreStart("invoke_0", "loop2", 2, 1)
      CALL nan_test_psy_data_2%PreDeclareVariable("loop2_start", loop2_start)
      CALL nan_test_psy_data_2%PreDeclareVariable("loop2_stop", loop2_stop)
      CALL nan_test_psy_data_2%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_2%PreEndDeclaration
      CALL nan_test_psy_data_2%ProvideVariable("loop2_start", loop2_start)
      CALL nan_test_psy_data_2%ProvideVariable("loop2_stop", loop2_stop)
      CALL nan_test_psy_data_2%PreEnd
      DO df=loop2_start,loop2_stop
        CALL random_number(field_2_proxy%data(df))
      END DO
      CALL nan_test_psy_data_2%PostStart
      CALL nan_test_psy_data_2%ProvideVariable("df", df)
      CALL nan_test_psy_data_2%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_3%PreStart("invoke_0", "loop3", 2, 1)
      CALL nan_test_psy_data_3%PreDeclareVariable("loop3_start", loop3_start)
      CALL nan_test_psy_data_3%PreDeclareVariable("loop3_stop", loop3_stop)
      CALL nan_test_psy_data_3%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_3%PreEndDeclaration
      CALL nan_test_psy_data_3%ProvideVariable("loop3_start", loop3_start)
      CALL nan_test_psy_data_3%ProvideVariable("loop3_stop", loop3_stop)
      CALL nan_test_psy_data_3%PreEnd
      DO df=loop3_start,loop3_stop
        field_2_input_proxy%data(df) = field_2_proxy%data(df)
      END DO
      CALL nan_test_psy_data_3%PostStart
      CALL nan_test_psy_data_3%ProvideVariable("df", df)
      CALL nan_test_psy_data_3%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_4%PreStart("invoke_0", "loop4", 2, 1)
      CALL nan_test_psy_data_4%PreDeclareVariable("loop4_start", loop4_start)
      CALL nan_test_psy_data_4%PreDeclareVariable("loop4_stop", loop4_stop)
      CALL nan_test_psy_data_4%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_4%PreEndDeclaration
      CALL nan_test_psy_data_4%ProvideVariable("loop4_start", loop4_start)
      CALL nan_test_psy_data_4%ProvideVariable("loop4_stop", loop4_stop)
      CALL nan_test_psy_data_4%PreEnd
      DO df=loop4_start,loop4_stop
        CALL random_number(field_3_proxy%data(df))
      END DO
      CALL nan_test_psy_data_4%PostStart
      CALL nan_test_psy_data_4%ProvideVariable("df", df)
      CALL nan_test_psy_data_4%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_5%PreStart("invoke_0", "loop5", 2, 1)
      CALL nan_test_psy_data_5%PreDeclareVariable("loop5_start", loop5_start)
      CALL nan_test_psy_data_5%PreDeclareVariable("loop5_stop", loop5_stop)
      CALL nan_test_psy_data_5%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_5%PreEndDeclaration
      CALL nan_test_psy_data_5%ProvideVariable("loop5_start", loop5_start)
      CALL nan_test_psy_data_5%ProvideVariable("loop5_stop", loop5_stop)
      CALL nan_test_psy_data_5%PreEnd
      DO df=loop5_start,loop5_stop
        field_3_input_proxy%data(df) = field_3_proxy%data(df)
      END DO
      CALL nan_test_psy_data_5%PostStart
      CALL nan_test_psy_data_5%ProvideVariable("df", df)
      CALL nan_test_psy_data_5%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_6%PreStart("invoke_0", "loop6", 2, 1)
      CALL nan_test_psy_data_6%PreDeclareVariable("loop6_start", loop6_start)
      CALL nan_test_psy_data_6%PreDeclareVariable("loop6_stop", loop6_stop)
      CALL nan_test_psy_data_6%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_6%PreEndDeclaration
      CALL nan_test_psy_data_6%ProvideVariable("loop6_start", loop6_start)
      CALL nan_test_psy_data_6%ProvideVariable("loop6_stop", loop6_stop)
      CALL nan_test_psy_data_6%PreEnd
      DO df=loop6_start,loop6_stop
        CALL random_number(field_4_proxy%data(df))
      END DO
      CALL nan_test_psy_data_6%PostStart
      CALL nan_test_psy_data_6%ProvideVariable("df", df)
      CALL nan_test_psy_data_6%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_7%PreStart("invoke_0", "loop7", 2, 1)
      CALL nan_test_psy_data_7%PreDeclareVariable("loop7_start", loop7_start)
      CALL nan_test_psy_data_7%PreDeclareVariable("loop7_stop", loop7_stop)
      CALL nan_test_psy_data_7%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_7%PreEndDeclaration
      CALL nan_test_psy_data_7%ProvideVariable("loop7_start", loop7_start)
      CALL nan_test_psy_data_7%ProvideVariable("loop7_stop", loop7_stop)
      CALL nan_test_psy_data_7%PreEnd
      DO df=loop7_start,loop7_stop
        field_4_input_proxy%data(df) = field_4_proxy%data(df)
      END DO
      CALL nan_test_psy_data_7%PostStart
      CALL nan_test_psy_data_7%ProvideVariable("df", df)
      CALL nan_test_psy_data_7%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_8%PreStart("invoke_0", "loop8", 2, 1)
      CALL nan_test_psy_data_8%PreDeclareVariable("loop8_start", loop8_start)
      CALL nan_test_psy_data_8%PreDeclareVariable("loop8_stop", loop8_stop)
      CALL nan_test_psy_data_8%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_8%PreEndDeclaration
      CALL nan_test_psy_data_8%ProvideVariable("loop8_start", loop8_start)
      CALL nan_test_psy_data_8%ProvideVariable("loop8_stop", loop8_stop)
      CALL nan_test_psy_data_8%PreEnd
      DO df=loop8_start,loop8_stop
        CALL random_number(field_5_proxy%data(df))
      END DO
      CALL nan_test_psy_data_8%PostStart
      CALL nan_test_psy_data_8%ProvideVariable("df", df)
      CALL nan_test_psy_data_8%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_9%PreStart("invoke_0", "loop9", 2, 1)
      CALL nan_test_psy_data_9%PreDeclareVariable("loop9_start", loop9_start)
      CALL nan_test_psy_data_9%PreDeclareVariable("loop9_stop", loop9_stop)
      CALL nan_test_psy_data_9%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_9%PreEndDeclaration
      CALL nan_test_psy_data_9%ProvideVariable("loop9_start", loop9_start)
      CALL nan_test_psy_data_9%ProvideVariable("loop9_stop", loop9_stop)
      CALL nan_test_psy_data_9%PreEnd
      DO df=loop9_start,loop9_stop
        field_5_input_proxy%data(df) = field_5_proxy%data(df)
      END DO
      CALL nan_test_psy_data_9%PostStart
      CALL nan_test_psy_data_9%ProvideVariable("df", df)
      CALL nan_test_psy_data_9%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_10%PreStart("invoke_0", "loop10", 2, 1)
      CALL nan_test_psy_data_10%PreDeclareVariable("loop10_start", loop10_start)
      CALL nan_test_psy_data_10%PreDeclareVariable("loop10_stop", loop10_stop)
      CALL nan_test_psy_data_10%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_10%PreEndDeclaration
      CALL nan_test_psy_data_10%ProvideVariable("loop10_start", loop10_start)
      CALL nan_test_psy_data_10%ProvideVariable("loop10_stop", loop10_stop)
      CALL nan_test_psy_data_10%PreEnd
      DO df=loop10_start,loop10_stop
        CALL random_number(field_6_proxy%data(df))
      END DO
      CALL nan_test_psy_data_10%PostStart
      CALL nan_test_psy_data_10%ProvideVariable("df", df)
      CALL nan_test_psy_data_10%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_11%PreStart("invoke_0", "loop11", 2, 1)
      CALL nan_test_psy_data_11%PreDeclareVariable("loop11_start", loop11_start)
      CALL nan_test_psy_data_11%PreDeclareVariable("loop11_stop", loop11_stop)
      CALL nan_test_psy_data_11%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_11%PreEndDeclaration
      CALL nan_test_psy_data_11%ProvideVariable("loop11_start", loop11_start)
      CALL nan_test_psy_data_11%ProvideVariable("loop11_stop", loop11_stop)
      CALL nan_test_psy_data_11%PreEnd
      DO df=loop11_start,loop11_stop
        field_6_input_proxy%data(df) = field_6_proxy%data(df)
      END DO
      CALL nan_test_psy_data_11%PostStart
      CALL nan_test_psy_data_11%ProvideVariable("df", df)
      CALL nan_test_psy_data_11%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_12%PreStart("invoke_0", "loop12", 2, 1)
      CALL nan_test_psy_data_12%PreDeclareVariable("loop12_start", loop12_start)
      CALL nan_test_psy_data_12%PreDeclareVariable("loop12_stop", loop12_stop)
      CALL nan_test_psy_data_12%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_12%PreEndDeclaration
      CALL nan_test_psy_data_12%ProvideVariable("loop12_start", loop12_start)
      CALL nan_test_psy_data_12%ProvideVariable("loop12_stop", loop12_stop)
      CALL nan_test_psy_data_12%PreEnd
      DO df=loop12_start,loop12_stop
        CALL random_number(field_7_proxy%data(df))
      END DO
      CALL nan_test_psy_data_12%PostStart
      CALL nan_test_psy_data_12%ProvideVariable("df", df)
      CALL nan_test_psy_data_12%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_13%PreStart("invoke_0", "loop13", 2, 1)
      CALL nan_test_psy_data_13%PreDeclareVariable("loop13_start", loop13_start)
      CALL nan_test_psy_data_13%PreDeclareVariable("loop13_stop", loop13_stop)
      CALL nan_test_psy_data_13%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_13%PreEndDeclaration
      CALL nan_test_psy_data_13%ProvideVariable("loop13_start", loop13_start)
      CALL nan_test_psy_data_13%ProvideVariable("loop13_stop", loop13_stop)
      CALL nan_test_psy_data_13%PreEnd
      DO df=loop13_start,loop13_stop
        field_7_input_proxy%data(df) = field_7_proxy%data(df)
      END DO
      CALL nan_test_psy_data_13%PostStart
      CALL nan_test_psy_data_13%ProvideVariable("df", df)
      CALL nan_test_psy_data_13%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_14%PreStart("invoke_0", "loop14", 2, 1)
      CALL nan_test_psy_data_14%PreDeclareVariable("loop14_start", loop14_start)
      CALL nan_test_psy_data_14%PreDeclareVariable("loop14_stop", loop14_stop)
      CALL nan_test_psy_data_14%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_14%PreEndDeclaration
      CALL nan_test_psy_data_14%ProvideVariable("loop14_start", loop14_start)
      CALL nan_test_psy_data_14%ProvideVariable("loop14_stop", loop14_stop)
      CALL nan_test_psy_data_14%PreEnd
      DO df=loop14_start,loop14_stop
        CALL random_number(field_8_proxy%data(df))
      END DO
      CALL nan_test_psy_data_14%PostStart
      CALL nan_test_psy_data_14%ProvideVariable("df", df)
      CALL nan_test_psy_data_14%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_15%PreStart("invoke_0", "loop15", 2, 1)
      CALL nan_test_psy_data_15%PreDeclareVariable("loop15_start", loop15_start)
      CALL nan_test_psy_data_15%PreDeclareVariable("loop15_stop", loop15_stop)
      CALL nan_test_psy_data_15%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_15%PreEndDeclaration
      CALL nan_test_psy_data_15%ProvideVariable("loop15_start", loop15_start)
      CALL nan_test_psy_data_15%ProvideVariable("loop15_stop", loop15_stop)
      CALL nan_test_psy_data_15%PreEnd
      DO df=loop15_start,loop15_stop
        field_8_input_proxy%data(df) = field_8_proxy%data(df)
      END DO
      CALL nan_test_psy_data_15%PostStart
      CALL nan_test_psy_data_15%ProvideVariable("df", df)
      CALL nan_test_psy_data_15%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_16%PreStart("invoke_0", "loop16", 2, 1)
      CALL nan_test_psy_data_16%PreDeclareVariable("loop16_start", loop16_start)
      CALL nan_test_psy_data_16%PreDeclareVariable("loop16_stop", loop16_stop)
      CALL nan_test_psy_data_16%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_16%PreEndDeclaration
      CALL nan_test_psy_data_16%ProvideVariable("loop16_start", loop16_start)
      CALL nan_test_psy_data_16%ProvideVariable("loop16_stop", loop16_stop)
      CALL nan_test_psy_data_16%PreEnd
      DO df=loop16_start,loop16_stop
        CALL random_number(field_9_proxy%data(df))
      END DO
      CALL nan_test_psy_data_16%PostStart
      CALL nan_test_psy_data_16%ProvideVariable("df", df)
      CALL nan_test_psy_data_16%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_17%PreStart("invoke_0", "loop17", 2, 1)
      CALL nan_test_psy_data_17%PreDeclareVariable("loop17_start", loop17_start)
      CALL nan_test_psy_data_17%PreDeclareVariable("loop17_stop", loop17_stop)
      CALL nan_test_psy_data_17%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_17%PreEndDeclaration
      CALL nan_test_psy_data_17%ProvideVariable("loop17_start", loop17_start)
      CALL nan_test_psy_data_17%ProvideVariable("loop17_stop", loop17_stop)
      CALL nan_test_psy_data_17%PreEnd
      DO df=loop17_start,loop17_stop
        field_9_input_proxy%data(df) = field_9_proxy%data(df)
      END DO
      CALL nan_test_psy_data_17%PostStart
      CALL nan_test_psy_data_17%ProvideVariable("df", df)
      CALL nan_test_psy_data_17%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_18%PreStart("invoke_0", "loop18", 2, 1)
      CALL nan_test_psy_data_18%PreDeclareVariable("loop18_start", loop18_start)
      CALL nan_test_psy_data_18%PreDeclareVariable("loop18_stop", loop18_stop)
      CALL nan_test_psy_data_18%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_18%PreEndDeclaration
      CALL nan_test_psy_data_18%ProvideVariable("loop18_start", loop18_start)
      CALL nan_test_psy_data_18%ProvideVariable("loop18_stop", loop18_stop)
      CALL nan_test_psy_data_18%PreEnd
      DO df=loop18_start,loop18_stop
        CALL random_number(field_10_proxy%data(df))
      END DO
      CALL nan_test_psy_data_18%PostStart
      CALL nan_test_psy_data_18%ProvideVariable("df", df)
      CALL nan_test_psy_data_18%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_19%PreStart("invoke_0", "loop19", 2, 1)
      CALL nan_test_psy_data_19%PreDeclareVariable("loop19_start", loop19_start)
      CALL nan_test_psy_data_19%PreDeclareVariable("loop19_stop", loop19_stop)
      CALL nan_test_psy_data_19%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_19%PreEndDeclaration
      CALL nan_test_psy_data_19%ProvideVariable("loop19_start", loop19_start)
      CALL nan_test_psy_data_19%ProvideVariable("loop19_stop", loop19_stop)
      CALL nan_test_psy_data_19%PreEnd
      DO df=loop19_start,loop19_stop
        field_10_input_proxy%data(df) = field_10_proxy%data(df)
      END DO
      CALL nan_test_psy_data_19%PostStart
      CALL nan_test_psy_data_19%ProvideVariable("df", df)
      CALL nan_test_psy_data_19%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_20%PreStart("invoke_0", "loop20", 2, 1)
      CALL nan_test_psy_data_20%PreDeclareVariable("loop20_start", loop20_start)
      CALL nan_test_psy_data_20%PreDeclareVariable("loop20_stop", loop20_stop)
      CALL nan_test_psy_data_20%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_20%PreEndDeclaration
      CALL nan_test_psy_data_20%ProvideVariable("loop20_start", loop20_start)
      CALL nan_test_psy_data_20%ProvideVariable("loop20_stop", loop20_stop)
      CALL nan_test_psy_data_20%PreEnd
      DO df=loop20_start,loop20_stop
        CALL random_number(field_10_1_proxy%data(df))
      END DO
      CALL nan_test_psy_data_20%PostStart
      CALL nan_test_psy_data_20%ProvideVariable("df", df)
      CALL nan_test_psy_data_20%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_21%PreStart("invoke_0", "loop21", 2, 1)
      CALL nan_test_psy_data_21%PreDeclareVariable("loop21_start", loop21_start)
      CALL nan_test_psy_data_21%PreDeclareVariable("loop21_stop", loop21_stop)
      CALL nan_test_psy_data_21%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_21%PreEndDeclaration
      CALL nan_test_psy_data_21%ProvideVariable("loop21_start", loop21_start)
      CALL nan_test_psy_data_21%ProvideVariable("loop21_stop", loop21_stop)
      CALL nan_test_psy_data_21%PreEnd
      DO df=loop21_start,loop21_stop
        field_10_input_1_proxy%data(df) = field_10_1_proxy%data(df)
      END DO
      CALL nan_test_psy_data_21%PostStart
      CALL nan_test_psy_data_21%ProvideVariable("df", df)
      CALL nan_test_psy_data_21%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_22%PreStart("invoke_0", "loop22", 2, 1)
      CALL nan_test_psy_data_22%PreDeclareVariable("loop22_start", loop22_start)
      CALL nan_test_psy_data_22%PreDeclareVariable("loop22_stop", loop22_stop)
      CALL nan_test_psy_data_22%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_22%PreEndDeclaration
      CALL nan_test_psy_data_22%ProvideVariable("loop22_start", loop22_start)
      CALL nan_test_psy_data_22%ProvideVariable("loop22_stop", loop22_stop)
      CALL nan_test_psy_data_22%PreEnd
      DO df=loop22_start,loop22_stop
        CALL random_number(field_10_2_proxy%data(df))
      END DO
      CALL nan_test_psy_data_22%PostStart
      CALL nan_test_psy_data_22%ProvideVariable("df", df)
      CALL nan_test_psy_data_22%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_23%PreStart("invoke_0", "loop23", 2, 1)
      CALL nan_test_psy_data_23%PreDeclareVariable("loop23_start", loop23_start)
      CALL nan_test_psy_data_23%PreDeclareVariable("loop23_stop", loop23_stop)
      CALL nan_test_psy_data_23%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_23%PreEndDeclaration
      CALL nan_test_psy_data_23%ProvideVariable("loop23_start", loop23_start)
      CALL nan_test_psy_data_23%ProvideVariable("loop23_stop", loop23_stop)
      CALL nan_test_psy_data_23%PreEnd
      DO df=loop23_start,loop23_stop
        field_10_input_2_proxy%data(df) = field_10_2_proxy%data(df)
      END DO
      CALL nan_test_psy_data_23%PostStart
      CALL nan_test_psy_data_23%ProvideVariable("df", df)
      CALL nan_test_psy_data_23%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_24%PreStart("invoke_0", "loop24", 2, 1)
      CALL nan_test_psy_data_24%PreDeclareVariable("loop24_start", loop24_start)
      CALL nan_test_psy_data_24%PreDeclareVariable("loop24_stop", loop24_stop)
      CALL nan_test_psy_data_24%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_24%PreEndDeclaration
      CALL nan_test_psy_data_24%ProvideVariable("loop24_start", loop24_start)
      CALL nan_test_psy_data_24%ProvideVariable("loop24_stop", loop24_stop)
      CALL nan_test_psy_data_24%PreEnd
      DO df=loop24_start,loop24_stop
        CALL random_number(field_11_proxy%data(df))
      END DO
      CALL nan_test_psy_data_24%PostStart
      CALL nan_test_psy_data_24%ProvideVariable("df", df)
      CALL nan_test_psy_data_24%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_25%PreStart("invoke_0", "loop25", 2, 1)
      CALL nan_test_psy_data_25%PreDeclareVariable("loop25_start", loop25_start)
      CALL nan_test_psy_data_25%PreDeclareVariable("loop25_stop", loop25_stop)
      CALL nan_test_psy_data_25%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_25%PreEndDeclaration
      CALL nan_test_psy_data_25%ProvideVariable("loop25_start", loop25_start)
      CALL nan_test_psy_data_25%ProvideVariable("loop25_stop", loop25_stop)
      CALL nan_test_psy_data_25%PreEnd
      DO df=loop25_start,loop25_stop
        field_11_input_proxy%data(df) = field_11_proxy%data(df)
      END DO
      CALL nan_test_psy_data_25%PostStart
      CALL nan_test_psy_data_25%ProvideVariable("df", df)
      CALL nan_test_psy_data_25%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_26%PreStart("invoke_0", "loop26", 36, 2)
      CALL nan_test_psy_data_26%PreDeclareVariable("basis_aspc9_field_10_3_qr_xyoz", basis_aspc9_field_10_3_qr_xyoz)
      CALL nan_test_psy_data_26%PreDeclareVariable("basis_w3_qr_xyoz", basis_w3_qr_xyoz)
      CALL nan_test_psy_data_26%PreDeclareVariable("basis_wtheta_qr_xyoz", basis_wtheta_qr_xyoz)
      CALL nan_test_psy_data_26%PreDeclareVariable("diff_basis_aspc9_field_10_3_qr_xyoz", diff_basis_aspc9_field_10_3_qr_xyoz)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_10_3", field_10_3)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_11", field_11)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_2", field_2)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_3", field_3)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_4", field_4)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_5", field_5)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_6", field_6)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_7", field_7)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_8", field_8)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_9", field_9)
      CALL nan_test_psy_data_26%PreDeclareVariable("loop26_start", loop26_start)
      CALL nan_test_psy_data_26%PreDeclareVariable("loop26_stop", loop26_stop)
      CALL nan_test_psy_data_26%PreDeclareVariable("map_adspc3_field_11", map_adspc3_field_11)
      CALL nan_test_psy_data_26%PreDeclareVariable("map_aspc9_field_10_3", map_aspc9_field_10_3)
      CALL nan_test_psy_data_26%PreDeclareVariable("map_w3", map_w3)
      CALL nan_test_psy_data_26%PreDeclareVariable("map_wtheta", map_wtheta)
      CALL nan_test_psy_data_26%PreDeclareVariable("ndf_adspc3_field_11", ndf_adspc3_field_11)
      CALL nan_test_psy_data_26%PreDeclareVariable("ndf_aspc9_field_10_3", ndf_aspc9_field_10_3)
      CALL nan_test_psy_data_26%PreDeclareVariable("ndf_w3", ndf_w3)
      CALL nan_test_psy_data_26%PreDeclareVariable("ndf_wtheta", ndf_wtheta)
      CALL nan_test_psy_data_26%PreDeclareVariable("nlayers", nlayers)
      CALL nan_test_psy_data_26%PreDeclareVariable("np_xy_qr_xyoz", np_xy_qr_xyoz)
      CALL nan_test_psy_data_26%PreDeclareVariable("np_z_qr_xyoz", np_z_qr_xyoz)
      CALL nan_test_psy_data_26%PreDeclareVariable("rscalar_12", rscalar_12)
      CALL nan_test_psy_data_26%PreDeclareVariable("rscalar_13", rscalar_13)
      CALL nan_test_psy_data_26%PreDeclareVariable("rscalar_14", rscalar_14)
      CALL nan_test_psy_data_26%PreDeclareVariable("undf_adspc3_field_11", undf_adspc3_field_11)
      CALL nan_test_psy_data_26%PreDeclareVariable("undf_aspc9_field_10_3", undf_aspc9_field_10_3)
      CALL nan_test_psy_data_26%PreDeclareVariable("undf_w3", undf_w3)
      CALL nan_test_psy_data_26%PreDeclareVariable("undf_wtheta", undf_wtheta)
      CALL nan_test_psy_data_26%PreDeclareVariable("weights_xy_qr_xyoz", weights_xy_qr_xyoz)
      CALL nan_test_psy_data_26%PreDeclareVariable("weights_z_qr_xyoz", weights_z_qr_xyoz)
      CALL nan_test_psy_data_26%PreDeclareVariable("cell", cell)
      CALL nan_test_psy_data_26%PreDeclareVariable("field_1", field_1)
      CALL nan_test_psy_data_26%PreEndDeclaration
      CALL nan_test_psy_data_26%ProvideVariable("basis_aspc9_field_10_3_qr_xyoz", basis_aspc9_field_10_3_qr_xyoz)
      CALL nan_test_psy_data_26%ProvideVariable("basis_w3_qr_xyoz", basis_w3_qr_xyoz)
      CALL nan_test_psy_data_26%ProvideVariable("basis_wtheta_qr_xyoz", basis_wtheta_qr_xyoz)
      CALL nan_test_psy_data_26%ProvideVariable("diff_basis_aspc9_field_10_3_qr_xyoz", diff_basis_aspc9_field_10_3_qr_xyoz)
      CALL nan_test_psy_data_26%ProvideVariable("field_10_3", field_10_3)
      CALL nan_test_psy_data_26%ProvideVariable("field_11", field_11)
      CALL nan_test_psy_data_26%ProvideVariable("field_2", field_2)
      CALL nan_test_psy_data_26%ProvideVariable("field_3", field_3)
      CALL nan_test_psy_data_26%ProvideVariable("field_4", field_4)
      CALL nan_test_psy_data_26%ProvideVariable("field_5", field_5)
      CALL nan_test_psy_data_26%ProvideVariable("field_6", field_6)
      CALL nan_test_psy_data_26%ProvideVariable("field_7", field_7)
      CALL nan_test_psy_data_26%ProvideVariable("field_8", field_8)
      CALL nan_test_psy_data_26%ProvideVariable("field_9", field_9)
      CALL nan_test_psy_data_26%ProvideVariable("loop26_start", loop26_start)
      CALL nan_test_psy_data_26%ProvideVariable("loop26_stop", loop26_stop)
      CALL nan_test_psy_data_26%ProvideVariable("map_adspc3_field_11", map_adspc3_field_11)
      CALL nan_test_psy_data_26%ProvideVariable("map_aspc9_field_10_3", map_aspc9_field_10_3)
      CALL nan_test_psy_data_26%ProvideVariable("map_w3", map_w3)
      CALL nan_test_psy_data_26%ProvideVariable("map_wtheta", map_wtheta)
      CALL nan_test_psy_data_26%ProvideVariable("ndf_adspc3_field_11", ndf_adspc3_field_11)
      CALL nan_test_psy_data_26%ProvideVariable("ndf_aspc9_field_10_3", ndf_aspc9_field_10_3)
      CALL nan_test_psy_data_26%ProvideVariable("ndf_w3", ndf_w3)
      CALL nan_test_psy_data_26%ProvideVariable("ndf_wtheta", ndf_wtheta)
      CALL nan_test_psy_data_26%ProvideVariable("nlayers", nlayers)
      CALL nan_test_psy_data_26%ProvideVariable("np_xy_qr_xyoz", np_xy_qr_xyoz)
      CALL nan_test_psy_data_26%ProvideVariable("np_z_qr_xyoz", np_z_qr_xyoz)
      CALL nan_test_psy_data_26%ProvideVariable("rscalar_12", rscalar_12)
      CALL nan_test_psy_data_26%ProvideVariable("rscalar_13", rscalar_13)
      CALL nan_test_psy_data_26%ProvideVariable("rscalar_14", rscalar_14)
      CALL nan_test_psy_data_26%ProvideVariable("undf_adspc3_field_11", undf_adspc3_field_11)
      CALL nan_test_psy_data_26%ProvideVariable("undf_aspc9_field_10_3", undf_aspc9_field_10_3)
      CALL nan_test_psy_data_26%ProvideVariable("undf_w3", undf_w3)
      CALL nan_test_psy_data_26%ProvideVariable("undf_wtheta", undf_wtheta)
      CALL nan_test_psy_data_26%ProvideVariable("weights_xy_qr_xyoz", weights_xy_qr_xyoz)
      CALL nan_test_psy_data_26%ProvideVariable("weights_z_qr_xyoz", weights_z_qr_xyoz)
      CALL nan_test_psy_data_26%PreEnd
      DO cell=loop26_start,loop26_stop
        !
        CALL tl_rhs_eos_code(nlayers, field_1_proxy%data, field_2_proxy%data, field_3_proxy%data, field_4_proxy%data, &
&field_5_proxy%data, field_6_proxy%data, field_7_proxy%data, field_8_proxy%data, field_9_proxy%data, field_10_3_proxy(1)%data, &
&field_10_3_proxy(2)%data, field_10_3_proxy(3)%data, field_11_proxy%data, rscalar_12, rscalar_13, rscalar_14, ndf_w3, undf_w3, &
&map_w3(:,cell), basis_w3_qr_xyoz, ndf_wtheta, undf_wtheta, map_wtheta(:,cell), basis_wtheta_qr_xyoz, ndf_aspc9_field_10_3, &
&undf_aspc9_field_10_3, map_aspc9_field_10_3(:,cell), basis_aspc9_field_10_3_qr_xyoz, diff_basis_aspc9_field_10_3_qr_xyoz, &
&ndf_adspc3_field_11, undf_adspc3_field_11, map_adspc3_field_11(:,cell), np_xy_qr_xyoz, np_z_qr_xyoz, weights_xy_qr_xyoz, &
&weights_z_qr_xyoz)
      END DO
      CALL nan_test_psy_data_26%PostStart
      CALL nan_test_psy_data_26%ProvideVariable("cell", cell)
      CALL nan_test_psy_data_26%ProvideVariable("field_1", field_1)
      CALL nan_test_psy_data_26%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_27%PreStart("invoke_0", "loop27", 2, 1)
      CALL nan_test_psy_data_27%PreDeclareVariable("loop27_start", loop27_start)
      CALL nan_test_psy_data_27%PreDeclareVariable("loop27_stop", loop27_stop)
      CALL nan_test_psy_data_27%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_27%PreEndDeclaration
      CALL nan_test_psy_data_27%ProvideVariable("loop27_start", loop27_start)
      CALL nan_test_psy_data_27%ProvideVariable("loop27_stop", loop27_stop)
      CALL nan_test_psy_data_27%PreEnd
      !
      ! Zero summation variables
      !
      field_1_inner_prod = 0.0_r_def
      !
      DO df=loop27_start,loop27_stop
        field_1_inner_prod = field_1_inner_prod + field_1_proxy%data(df)*field_1_proxy%data(df)
      END DO
      CALL nan_test_psy_data_27%PostStart
      CALL nan_test_psy_data_27%ProvideVariable("df", df)
      CALL nan_test_psy_data_27%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_28%PreStart("invoke_0", "loop28", 2, 1)
      CALL nan_test_psy_data_28%PreDeclareVariable("loop28_start", loop28_start)
      CALL nan_test_psy_data_28%PreDeclareVariable("loop28_stop", loop28_stop)
      CALL nan_test_psy_data_28%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_28%PreEndDeclaration
      CALL nan_test_psy_data_28%ProvideVariable("loop28_start", loop28_start)
      CALL nan_test_psy_data_28%ProvideVariable("loop28_stop", loop28_stop)
      CALL nan_test_psy_data_28%PreEnd
      !
      ! Zero summation variables
      !
      field_2_inner_prod = 0.0_r_def
      !
      DO df=loop28_start,loop28_stop
        field_2_inner_prod = field_2_inner_prod + field_2_proxy%data(df)*field_2_proxy%data(df)
      END DO
      CALL nan_test_psy_data_28%PostStart
      CALL nan_test_psy_data_28%ProvideVariable("df", df)
      CALL nan_test_psy_data_28%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_29%PreStart("invoke_0", "loop29", 2, 1)
      CALL nan_test_psy_data_29%PreDeclareVariable("loop29_start", loop29_start)
      CALL nan_test_psy_data_29%PreDeclareVariable("loop29_stop", loop29_stop)
      CALL nan_test_psy_data_29%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_29%PreEndDeclaration
      CALL nan_test_psy_data_29%ProvideVariable("loop29_start", loop29_start)
      CALL nan_test_psy_data_29%ProvideVariable("loop29_stop", loop29_stop)
      CALL nan_test_psy_data_29%PreEnd
      !
      ! Zero summation variables
      !
      field_3_inner_prod = 0.0_r_def
      !
      DO df=loop29_start,loop29_stop
        field_3_inner_prod = field_3_inner_prod + field_3_proxy%data(df)*field_3_proxy%data(df)
      END DO
      CALL nan_test_psy_data_29%PostStart
      CALL nan_test_psy_data_29%ProvideVariable("df", df)
      CALL nan_test_psy_data_29%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_30%PreStart("invoke_0", "loop30", 2, 1)
      CALL nan_test_psy_data_30%PreDeclareVariable("loop30_start", loop30_start)
      CALL nan_test_psy_data_30%PreDeclareVariable("loop30_stop", loop30_stop)
      CALL nan_test_psy_data_30%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_30%PreEndDeclaration
      CALL nan_test_psy_data_30%ProvideVariable("loop30_start", loop30_start)
      CALL nan_test_psy_data_30%ProvideVariable("loop30_stop", loop30_stop)
      CALL nan_test_psy_data_30%PreEnd
      !
      ! Zero summation variables
      !
      field_4_inner_prod = 0.0_r_def
      !
      DO df=loop30_start,loop30_stop
        field_4_inner_prod = field_4_inner_prod + field_4_proxy%data(df)*field_4_proxy%data(df)
      END DO
      CALL nan_test_psy_data_30%PostStart
      CALL nan_test_psy_data_30%ProvideVariable("df", df)
      CALL nan_test_psy_data_30%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_31%PreStart("invoke_0", "loop31", 2, 1)
      CALL nan_test_psy_data_31%PreDeclareVariable("loop31_start", loop31_start)
      CALL nan_test_psy_data_31%PreDeclareVariable("loop31_stop", loop31_stop)
      CALL nan_test_psy_data_31%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_31%PreEndDeclaration
      CALL nan_test_psy_data_31%ProvideVariable("loop31_start", loop31_start)
      CALL nan_test_psy_data_31%ProvideVariable("loop31_stop", loop31_stop)
      CALL nan_test_psy_data_31%PreEnd
      !
      ! Zero summation variables
      !
      field_5_inner_prod = 0.0_r_def
      !
      DO df=loop31_start,loop31_stop
        field_5_inner_prod = field_5_inner_prod + field_5_proxy%data(df)*field_5_proxy%data(df)
      END DO
      CALL nan_test_psy_data_31%PostStart
      CALL nan_test_psy_data_31%ProvideVariable("df", df)
      CALL nan_test_psy_data_31%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_32%PreStart("invoke_0", "loop32", 2, 1)
      CALL nan_test_psy_data_32%PreDeclareVariable("loop32_start", loop32_start)
      CALL nan_test_psy_data_32%PreDeclareVariable("loop32_stop", loop32_stop)
      CALL nan_test_psy_data_32%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_32%PreEndDeclaration
      CALL nan_test_psy_data_32%ProvideVariable("loop32_start", loop32_start)
      CALL nan_test_psy_data_32%ProvideVariable("loop32_stop", loop32_stop)
      CALL nan_test_psy_data_32%PreEnd
      !
      ! Zero summation variables
      !
      field_6_inner_prod = 0.0_r_def
      !
      DO df=loop32_start,loop32_stop
        field_6_inner_prod = field_6_inner_prod + field_6_proxy%data(df)*field_6_proxy%data(df)
      END DO
      CALL nan_test_psy_data_32%PostStart
      CALL nan_test_psy_data_32%ProvideVariable("df", df)
      CALL nan_test_psy_data_32%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_33%PreStart("invoke_0", "loop33", 2, 1)
      CALL nan_test_psy_data_33%PreDeclareVariable("loop33_start", loop33_start)
      CALL nan_test_psy_data_33%PreDeclareVariable("loop33_stop", loop33_stop)
      CALL nan_test_psy_data_33%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_33%PreEndDeclaration
      CALL nan_test_psy_data_33%ProvideVariable("loop33_start", loop33_start)
      CALL nan_test_psy_data_33%ProvideVariable("loop33_stop", loop33_stop)
      CALL nan_test_psy_data_33%PreEnd
      !
      ! Zero summation variables
      !
      field_7_inner_prod = 0.0_r_def
      !
      DO df=loop33_start,loop33_stop
        field_7_inner_prod = field_7_inner_prod + field_7_proxy%data(df)*field_7_proxy%data(df)
      END DO
      CALL nan_test_psy_data_33%PostStart
      CALL nan_test_psy_data_33%ProvideVariable("df", df)
      CALL nan_test_psy_data_33%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_34%PreStart("invoke_0", "loop34", 2, 1)
      CALL nan_test_psy_data_34%PreDeclareVariable("loop34_start", loop34_start)
      CALL nan_test_psy_data_34%PreDeclareVariable("loop34_stop", loop34_stop)
      CALL nan_test_psy_data_34%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_34%PreEndDeclaration
      CALL nan_test_psy_data_34%ProvideVariable("loop34_start", loop34_start)
      CALL nan_test_psy_data_34%ProvideVariable("loop34_stop", loop34_stop)
      CALL nan_test_psy_data_34%PreEnd
      !
      ! Zero summation variables
      !
      field_8_inner_prod = 0.0_r_def
      !
      DO df=loop34_start,loop34_stop
        field_8_inner_prod = field_8_inner_prod + field_8_proxy%data(df)*field_8_proxy%data(df)
      END DO
      CALL nan_test_psy_data_34%PostStart
      CALL nan_test_psy_data_34%ProvideVariable("df", df)
      CALL nan_test_psy_data_34%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_35%PreStart("invoke_0", "loop35", 2, 1)
      CALL nan_test_psy_data_35%PreDeclareVariable("loop35_start", loop35_start)
      CALL nan_test_psy_data_35%PreDeclareVariable("loop35_stop", loop35_stop)
      CALL nan_test_psy_data_35%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_35%PreEndDeclaration
      CALL nan_test_psy_data_35%ProvideVariable("loop35_start", loop35_start)
      CALL nan_test_psy_data_35%ProvideVariable("loop35_stop", loop35_stop)
      CALL nan_test_psy_data_35%PreEnd
      !
      ! Zero summation variables
      !
      field_9_inner_prod = 0.0_r_def
      !
      DO df=loop35_start,loop35_stop
        field_9_inner_prod = field_9_inner_prod + field_9_proxy%data(df)*field_9_proxy%data(df)
      END DO
      CALL nan_test_psy_data_35%PostStart
      CALL nan_test_psy_data_35%ProvideVariable("df", df)
      CALL nan_test_psy_data_35%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_36%PreStart("invoke_0", "loop36", 2, 1)
      CALL nan_test_psy_data_36%PreDeclareVariable("loop36_start", loop36_start)
      CALL nan_test_psy_data_36%PreDeclareVariable("loop36_stop", loop36_stop)
      CALL nan_test_psy_data_36%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_36%PreEndDeclaration
      CALL nan_test_psy_data_36%ProvideVariable("loop36_start", loop36_start)
      CALL nan_test_psy_data_36%ProvideVariable("loop36_stop", loop36_stop)
      CALL nan_test_psy_data_36%PreEnd
      !
      ! Zero summation variables
      !
      field_10_inner_prod = 0.0_r_def
      !
      DO df=loop36_start,loop36_stop
        field_10_inner_prod = field_10_inner_prod + field_10_proxy%data(df)*field_10_proxy%data(df)
      END DO
      CALL nan_test_psy_data_36%PostStart
      CALL nan_test_psy_data_36%ProvideVariable("df", df)
      CALL nan_test_psy_data_36%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_37%PreStart("invoke_0", "loop37", 2, 1)
      CALL nan_test_psy_data_37%PreDeclareVariable("loop37_start", loop37_start)
      CALL nan_test_psy_data_37%PreDeclareVariable("loop37_stop", loop37_stop)
      CALL nan_test_psy_data_37%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_37%PreEndDeclaration
      CALL nan_test_psy_data_37%ProvideVariable("loop37_start", loop37_start)
      CALL nan_test_psy_data_37%ProvideVariable("loop37_stop", loop37_stop)
      CALL nan_test_psy_data_37%PreEnd
      !
      ! Zero summation variables
      !
      field_10_inner_prod_1 = 0.0_r_def
      !
      DO df=loop37_start,loop37_stop
        field_10_inner_prod_1 = field_10_inner_prod_1 + field_10_1_proxy%data(df)*field_10_1_proxy%data(df)
      END DO
      CALL nan_test_psy_data_37%PostStart
      CALL nan_test_psy_data_37%ProvideVariable("df", df)
      CALL nan_test_psy_data_37%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_38%PreStart("invoke_0", "loop38", 2, 1)
      CALL nan_test_psy_data_38%PreDeclareVariable("loop38_start", loop38_start)
      CALL nan_test_psy_data_38%PreDeclareVariable("loop38_stop", loop38_stop)
      CALL nan_test_psy_data_38%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_38%PreEndDeclaration
      CALL nan_test_psy_data_38%ProvideVariable("loop38_start", loop38_start)
      CALL nan_test_psy_data_38%ProvideVariable("loop38_stop", loop38_stop)
      CALL nan_test_psy_data_38%PreEnd
      !
      ! Zero summation variables
      !
      field_10_inner_prod_2 = 0.0_r_def
      !
      DO df=loop38_start,loop38_stop
        field_10_inner_prod_2 = field_10_inner_prod_2 + field_10_2_proxy%data(df)*field_10_2_proxy%data(df)
      END DO
      CALL nan_test_psy_data_38%PostStart
      CALL nan_test_psy_data_38%ProvideVariable("df", df)
      CALL nan_test_psy_data_38%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_39%PreStart("invoke_0", "loop39", 2, 1)
      CALL nan_test_psy_data_39%PreDeclareVariable("loop39_start", loop39_start)
      CALL nan_test_psy_data_39%PreDeclareVariable("loop39_stop", loop39_stop)
      CALL nan_test_psy_data_39%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_39%PreEndDeclaration
      CALL nan_test_psy_data_39%ProvideVariable("loop39_start", loop39_start)
      CALL nan_test_psy_data_39%ProvideVariable("loop39_stop", loop39_stop)
      CALL nan_test_psy_data_39%PreEnd
      !
      ! Zero summation variables
      !
      field_11_inner_prod = 0.0_r_def
      !
      DO df=loop39_start,loop39_stop
        field_11_inner_prod = field_11_inner_prod + field_11_proxy%data(df)*field_11_proxy%data(df)
      END DO
      CALL nan_test_psy_data_39%PostStart
      CALL nan_test_psy_data_39%ProvideVariable("df", df)
      CALL nan_test_psy_data_39%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! Deallocate basis arrays
      !
      DEALLOCATE (basis_aspc9_field_10_3_qr_xyoz, basis_w3_qr_xyoz, basis_wtheta_qr_xyoz, diff_basis_aspc9_field_10_3_qr_xyoz)
      !
    END SUBROUTINE invoke_0
    SUBROUTINE invoke_1(field_1, field_2, field_3, field_4, field_5, field_6, field_7, field_8, field_9, field_10, field_11, &
&rscalar_12, rscalar_13, rscalar_14, field_1_inner_prod, field_1_input, field_2_inner_prod, field_2_input, field_3_inner_prod, &
&field_3_input, field_4_inner_prod, field_4_input, field_5_inner_prod, field_5_input, field_6_inner_prod, field_6_input, &
&field_7_inner_prod, field_7_input, field_8_inner_prod, field_8_input, field_9_inner_prod, field_9_input, field_10_inner_prod, &
&field_10_1, field_10_input, field_10_inner_prod_1, field_10_2, field_10_input_1, field_10_inner_prod_2, field_10_3, &
&field_10_input_2, field_11_inner_prod, field_11_input, qr_xyoz)
      USE tl_rhs_eos_kernel_mod_adj, ONLY: tl_rhs_eos_code_adj
      USE nan_test_psy_data_mod, ONLY: nan_test_PSyDataType
      USE quadrature_xyoz_mod, ONLY: quadrature_xyoz_type, quadrature_xyoz_proxy_type
      USE function_space_mod, ONLY: BASIS, DIFF_BASIS
      REAL(KIND=r_def), intent(out) :: field_1_inner_prod, field_2_inner_prod, field_3_inner_prod, field_4_inner_prod, &
&field_5_inner_prod, field_6_inner_prod, field_7_inner_prod, field_8_inner_prod, field_9_inner_prod, field_10_inner_prod, &
&field_10_inner_prod_1, field_10_inner_prod_2, field_11_inner_prod
      REAL(KIND=r_def), intent(in) :: rscalar_12, rscalar_13, rscalar_14
      TYPE(field_type), intent(in) :: field_1, field_2, field_3, field_4, field_5, field_6, field_7, field_8, field_9, &
&field_10(3), field_11, field_1_input, field_2_input, field_3_input, field_4_input, field_5_input, field_6_input, field_7_input, &
&field_8_input, field_9_input, field_10_1, field_10_input, field_10_2, field_10_input_1, field_10_3, field_10_input_2, &
&field_11_input
      TYPE(quadrature_xyoz_type), intent(in) :: qr_xyoz
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_13
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_12
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_11
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_10
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_9
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_8
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_7
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_6
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_5
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_4
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_3
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_2
      INTEGER df
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data_1
      INTEGER(KIND=i_def) cell
      TYPE(nan_test_PSyDataType), target, save :: nan_test_psy_data
      INTEGER(KIND=i_def) loop13_start, loop13_stop
      INTEGER(KIND=i_def) loop12_start, loop12_stop
      INTEGER(KIND=i_def) loop11_start, loop11_stop
      INTEGER(KIND=i_def) loop10_start, loop10_stop
      INTEGER(KIND=i_def) loop9_start, loop9_stop
      INTEGER(KIND=i_def) loop8_start, loop8_stop
      INTEGER(KIND=i_def) loop7_start, loop7_stop
      INTEGER(KIND=i_def) loop6_start, loop6_stop
      INTEGER(KIND=i_def) loop5_start, loop5_stop
      INTEGER(KIND=i_def) loop4_start, loop4_stop
      INTEGER(KIND=i_def) loop3_start, loop3_stop
      INTEGER(KIND=i_def) loop2_start, loop2_stop
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      REAL(KIND=r_def), allocatable :: basis_w3_qr_xyoz(:,:,:,:), basis_wtheta_qr_xyoz(:,:,:,:), &
&basis_aspc9_field_10_qr_xyoz(:,:,:,:), diff_basis_aspc9_field_10_qr_xyoz(:,:,:,:)
      INTEGER(KIND=i_def) dim_w3, dim_wtheta, dim_aspc9_field_10, diff_dim_aspc9_field_10
      REAL(KIND=r_def), pointer :: weights_xy_qr_xyoz(:) => null(), weights_z_qr_xyoz(:) => null()
      INTEGER(KIND=i_def) np_xy_qr_xyoz, np_z_qr_xyoz
      INTEGER(KIND=i_def) nlayers
      TYPE(field_proxy_type) field_1_proxy, field_2_proxy, field_3_proxy, field_4_proxy, field_5_proxy, field_6_proxy, &
&field_7_proxy, field_8_proxy, field_9_proxy, field_10_proxy(3), field_11_proxy, field_1_input_proxy, field_2_input_proxy, &
&field_3_input_proxy, field_4_input_proxy, field_5_input_proxy, field_6_input_proxy, field_7_input_proxy, field_8_input_proxy, &
&field_9_input_proxy, field_10_1_proxy, field_10_input_proxy, field_10_2_proxy, field_10_input_1_proxy, field_10_3_proxy, &
&field_10_input_2_proxy, field_11_input_proxy
      TYPE(quadrature_xyoz_proxy_type) qr_xyoz_proxy
      INTEGER(KIND=i_def), pointer :: map_adspc3_field_11(:,:) => null(), map_aspc9_field_10(:,:) => null(), &
&map_w3(:,:) => null(), map_wtheta(:,:) => null()
      INTEGER(KIND=i_def) ndf_w3, undf_w3, ndf_wtheta, undf_wtheta, ndf_aspc9_field_10, undf_aspc9_field_10, ndf_adspc3_field_11, &
&undf_adspc3_field_11, ndf_aspc1_field_1, undf_aspc1_field_1, ndf_aspc1_field_2, undf_aspc1_field_2, ndf_aspc1_field_3, &
&undf_aspc1_field_3, ndf_aspc1_field_4, undf_aspc1_field_4, ndf_aspc1_field_5, undf_aspc1_field_5, ndf_aspc1_field_6, &
&undf_aspc1_field_6, ndf_aspc1_field_7, undf_aspc1_field_7, ndf_aspc1_field_8, undf_aspc1_field_8, ndf_aspc1_field_9, &
&undf_aspc1_field_9, ndf_aspc1_field_10_1, undf_aspc1_field_10_1, ndf_aspc1_field_10_2, undf_aspc1_field_10_2, &
&ndf_aspc1_field_10_3, undf_aspc1_field_10_3, ndf_aspc1_field_11, undf_aspc1_field_11
      !
      ! Initialise field and/or operator proxies
      !
      field_1_proxy = field_1%get_proxy()
      field_2_proxy = field_2%get_proxy()
      field_3_proxy = field_3%get_proxy()
      field_4_proxy = field_4%get_proxy()
      field_5_proxy = field_5%get_proxy()
      field_6_proxy = field_6%get_proxy()
      field_7_proxy = field_7%get_proxy()
      field_8_proxy = field_8%get_proxy()
      field_9_proxy = field_9%get_proxy()
      field_10_proxy(1) = field_10(1)%get_proxy()
      field_10_proxy(2) = field_10(2)%get_proxy()
      field_10_proxy(3) = field_10(3)%get_proxy()
      field_11_proxy = field_11%get_proxy()
      field_1_input_proxy = field_1_input%get_proxy()
      field_2_input_proxy = field_2_input%get_proxy()
      field_3_input_proxy = field_3_input%get_proxy()
      field_4_input_proxy = field_4_input%get_proxy()
      field_5_input_proxy = field_5_input%get_proxy()
      field_6_input_proxy = field_6_input%get_proxy()
      field_7_input_proxy = field_7_input%get_proxy()
      field_8_input_proxy = field_8_input%get_proxy()
      field_9_input_proxy = field_9_input%get_proxy()
      field_10_1_proxy = field_10_1%get_proxy()
      field_10_input_proxy = field_10_input%get_proxy()
      field_10_2_proxy = field_10_2%get_proxy()
      field_10_input_1_proxy = field_10_input_1%get_proxy()
      field_10_3_proxy = field_10_3%get_proxy()
      field_10_input_2_proxy = field_10_input_2%get_proxy()
      field_11_input_proxy = field_11_input%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = field_1_proxy%vspace%get_nlayers()
      !
      ! Look-up dofmaps for each function space
      !
      map_w3 => field_1_proxy%vspace%get_whole_dofmap()
      map_wtheta => field_4_proxy%vspace%get_whole_dofmap()
      map_aspc9_field_10 => field_10_proxy(1)%vspace%get_whole_dofmap()
      map_adspc3_field_11 => field_11_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for w3
      !
      ndf_w3 = field_1_proxy%vspace%get_ndf()
      undf_w3 = field_1_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for wtheta
      !
      ndf_wtheta = field_4_proxy%vspace%get_ndf()
      undf_wtheta = field_4_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc9_field_10
      !
      ndf_aspc9_field_10 = field_10_proxy(1)%vspace%get_ndf()
      undf_aspc9_field_10 = field_10_proxy(1)%vspace%get_undf()
      !
      ! Initialise number of DoFs for adspc3_field_11
      !
      ndf_adspc3_field_11 = field_11_proxy%vspace%get_ndf()
      undf_adspc3_field_11 = field_11_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_1
      !
      ndf_aspc1_field_1 = field_1_proxy%vspace%get_ndf()
      undf_aspc1_field_1 = field_1_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_2
      !
      ndf_aspc1_field_2 = field_2_proxy%vspace%get_ndf()
      undf_aspc1_field_2 = field_2_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_3
      !
      ndf_aspc1_field_3 = field_3_proxy%vspace%get_ndf()
      undf_aspc1_field_3 = field_3_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_4
      !
      ndf_aspc1_field_4 = field_4_proxy%vspace%get_ndf()
      undf_aspc1_field_4 = field_4_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_5
      !
      ndf_aspc1_field_5 = field_5_proxy%vspace%get_ndf()
      undf_aspc1_field_5 = field_5_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_6
      !
      ndf_aspc1_field_6 = field_6_proxy%vspace%get_ndf()
      undf_aspc1_field_6 = field_6_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_7
      !
      ndf_aspc1_field_7 = field_7_proxy%vspace%get_ndf()
      undf_aspc1_field_7 = field_7_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_8
      !
      ndf_aspc1_field_8 = field_8_proxy%vspace%get_ndf()
      undf_aspc1_field_8 = field_8_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_9
      !
      ndf_aspc1_field_9 = field_9_proxy%vspace%get_ndf()
      undf_aspc1_field_9 = field_9_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10_1
      !
      ndf_aspc1_field_10_1 = field_10_1_proxy%vspace%get_ndf()
      undf_aspc1_field_10_1 = field_10_1_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10_2
      !
      ndf_aspc1_field_10_2 = field_10_2_proxy%vspace%get_ndf()
      undf_aspc1_field_10_2 = field_10_2_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_10_3
      !
      ndf_aspc1_field_10_3 = field_10_3_proxy%vspace%get_ndf()
      undf_aspc1_field_10_3 = field_10_3_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field_11
      !
      ndf_aspc1_field_11 = field_11_proxy%vspace%get_ndf()
      undf_aspc1_field_11 = field_11_proxy%vspace%get_undf()
      !
      ! Look-up quadrature variables
      !
      qr_xyoz_proxy = qr_xyoz%get_quadrature_proxy()
      np_xy_qr_xyoz = qr_xyoz_proxy%np_xy
      np_z_qr_xyoz = qr_xyoz_proxy%np_z
      weights_xy_qr_xyoz => qr_xyoz_proxy%weights_xy
      weights_z_qr_xyoz => qr_xyoz_proxy%weights_z
      !
      ! Allocate basis/diff-basis arrays
      !
      dim_w3 = field_1_proxy%vspace%get_dim_space()
      dim_wtheta = field_4_proxy%vspace%get_dim_space()
      dim_aspc9_field_10 = field_10_proxy(1)%vspace%get_dim_space()
      diff_dim_aspc9_field_10 = field_10_proxy(1)%vspace%get_dim_space_diff()
      ALLOCATE (basis_w3_qr_xyoz(dim_w3, ndf_w3, np_xy_qr_xyoz, np_z_qr_xyoz))
      ALLOCATE (basis_wtheta_qr_xyoz(dim_wtheta, ndf_wtheta, np_xy_qr_xyoz, np_z_qr_xyoz))
      ALLOCATE (basis_aspc9_field_10_qr_xyoz(dim_aspc9_field_10, ndf_aspc9_field_10, np_xy_qr_xyoz, np_z_qr_xyoz))
      ALLOCATE (diff_basis_aspc9_field_10_qr_xyoz(diff_dim_aspc9_field_10, ndf_aspc9_field_10, np_xy_qr_xyoz, np_z_qr_xyoz))
      !
      ! Compute basis/diff-basis arrays
      !
      CALL qr_xyoz%compute_function(BASIS, field_1_proxy%vspace, dim_w3, ndf_w3, basis_w3_qr_xyoz)
      CALL qr_xyoz%compute_function(BASIS, field_4_proxy%vspace, dim_wtheta, ndf_wtheta, basis_wtheta_qr_xyoz)
      CALL qr_xyoz%compute_function(BASIS, field_10_proxy(1)%vspace, dim_aspc9_field_10, ndf_aspc9_field_10, &
&basis_aspc9_field_10_qr_xyoz)
      CALL qr_xyoz%compute_function(DIFF_BASIS, field_10_proxy(1)%vspace, diff_dim_aspc9_field_10, ndf_aspc9_field_10, &
&diff_basis_aspc9_field_10_qr_xyoz)
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = field_1_proxy%vspace%get_ncell()
      loop1_start = 1
      loop1_stop = undf_aspc1_field_1
      loop2_start = 1
      loop2_stop = undf_aspc1_field_2
      loop3_start = 1
      loop3_stop = undf_aspc1_field_3
      loop4_start = 1
      loop4_stop = undf_aspc1_field_4
      loop5_start = 1
      loop5_stop = undf_aspc1_field_5
      loop6_start = 1
      loop6_stop = undf_aspc1_field_6
      loop7_start = 1
      loop7_stop = undf_aspc1_field_7
      loop8_start = 1
      loop8_stop = undf_aspc1_field_8
      loop9_start = 1
      loop9_stop = undf_aspc1_field_9
      loop10_start = 1
      loop10_stop = undf_aspc1_field_10_1
      loop11_start = 1
      loop11_stop = undf_aspc1_field_10_2
      loop12_start = 1
      loop12_stop = undf_aspc1_field_10_3
      loop13_start = 1
      loop13_stop = undf_aspc1_field_11
      !
      ! Call our kernels
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data%PreStart("invoke_1", "loop0", 36, 2)
      CALL nan_test_psy_data%PreDeclareVariable("basis_aspc9_field_10_qr_xyoz", basis_aspc9_field_10_qr_xyoz)
      CALL nan_test_psy_data%PreDeclareVariable("basis_w3_qr_xyoz", basis_w3_qr_xyoz)
      CALL nan_test_psy_data%PreDeclareVariable("basis_wtheta_qr_xyoz", basis_wtheta_qr_xyoz)
      CALL nan_test_psy_data%PreDeclareVariable("diff_basis_aspc9_field_10_qr_xyoz", diff_basis_aspc9_field_10_qr_xyoz)
      CALL nan_test_psy_data%PreDeclareVariable("field_10", field_10)
      CALL nan_test_psy_data%PreDeclareVariable("field_11", field_11)
      CALL nan_test_psy_data%PreDeclareVariable("field_2", field_2)
      CALL nan_test_psy_data%PreDeclareVariable("field_3", field_3)
      CALL nan_test_psy_data%PreDeclareVariable("field_4", field_4)
      CALL nan_test_psy_data%PreDeclareVariable("field_5", field_5)
      CALL nan_test_psy_data%PreDeclareVariable("field_6", field_6)
      CALL nan_test_psy_data%PreDeclareVariable("field_7", field_7)
      CALL nan_test_psy_data%PreDeclareVariable("field_8", field_8)
      CALL nan_test_psy_data%PreDeclareVariable("field_9", field_9)
      CALL nan_test_psy_data%PreDeclareVariable("loop0_start", loop0_start)
      CALL nan_test_psy_data%PreDeclareVariable("loop0_stop", loop0_stop)
      CALL nan_test_psy_data%PreDeclareVariable("map_adspc3_field_11", map_adspc3_field_11)
      CALL nan_test_psy_data%PreDeclareVariable("map_aspc9_field_10", map_aspc9_field_10)
      CALL nan_test_psy_data%PreDeclareVariable("map_w3", map_w3)
      CALL nan_test_psy_data%PreDeclareVariable("map_wtheta", map_wtheta)
      CALL nan_test_psy_data%PreDeclareVariable("ndf_adspc3_field_11", ndf_adspc3_field_11)
      CALL nan_test_psy_data%PreDeclareVariable("ndf_aspc9_field_10", ndf_aspc9_field_10)
      CALL nan_test_psy_data%PreDeclareVariable("ndf_w3", ndf_w3)
      CALL nan_test_psy_data%PreDeclareVariable("ndf_wtheta", ndf_wtheta)
      CALL nan_test_psy_data%PreDeclareVariable("nlayers", nlayers)
      CALL nan_test_psy_data%PreDeclareVariable("np_xy_qr_xyoz", np_xy_qr_xyoz)
      CALL nan_test_psy_data%PreDeclareVariable("np_z_qr_xyoz", np_z_qr_xyoz)
      CALL nan_test_psy_data%PreDeclareVariable("rscalar_12", rscalar_12)
      CALL nan_test_psy_data%PreDeclareVariable("rscalar_13", rscalar_13)
      CALL nan_test_psy_data%PreDeclareVariable("rscalar_14", rscalar_14)
      CALL nan_test_psy_data%PreDeclareVariable("undf_adspc3_field_11", undf_adspc3_field_11)
      CALL nan_test_psy_data%PreDeclareVariable("undf_aspc9_field_10", undf_aspc9_field_10)
      CALL nan_test_psy_data%PreDeclareVariable("undf_w3", undf_w3)
      CALL nan_test_psy_data%PreDeclareVariable("undf_wtheta", undf_wtheta)
      CALL nan_test_psy_data%PreDeclareVariable("weights_xy_qr_xyoz", weights_xy_qr_xyoz)
      CALL nan_test_psy_data%PreDeclareVariable("weights_z_qr_xyoz", weights_z_qr_xyoz)
      CALL nan_test_psy_data%PreDeclareVariable("cell", cell)
      CALL nan_test_psy_data%PreDeclareVariable("field_1", field_1)
      CALL nan_test_psy_data%PreEndDeclaration
      CALL nan_test_psy_data%ProvideVariable("basis_aspc9_field_10_qr_xyoz", basis_aspc9_field_10_qr_xyoz)
      CALL nan_test_psy_data%ProvideVariable("basis_w3_qr_xyoz", basis_w3_qr_xyoz)
      CALL nan_test_psy_data%ProvideVariable("basis_wtheta_qr_xyoz", basis_wtheta_qr_xyoz)
      CALL nan_test_psy_data%ProvideVariable("diff_basis_aspc9_field_10_qr_xyoz", diff_basis_aspc9_field_10_qr_xyoz)
      CALL nan_test_psy_data%ProvideVariable("field_10", field_10)
      CALL nan_test_psy_data%ProvideVariable("field_11", field_11)
      CALL nan_test_psy_data%ProvideVariable("field_2", field_2)
      CALL nan_test_psy_data%ProvideVariable("field_3", field_3)
      CALL nan_test_psy_data%ProvideVariable("field_4", field_4)
      CALL nan_test_psy_data%ProvideVariable("field_5", field_5)
      CALL nan_test_psy_data%ProvideVariable("field_6", field_6)
      CALL nan_test_psy_data%ProvideVariable("field_7", field_7)
      CALL nan_test_psy_data%ProvideVariable("field_8", field_8)
      CALL nan_test_psy_data%ProvideVariable("field_9", field_9)
      CALL nan_test_psy_data%ProvideVariable("loop0_start", loop0_start)
      CALL nan_test_psy_data%ProvideVariable("loop0_stop", loop0_stop)
      CALL nan_test_psy_data%ProvideVariable("map_adspc3_field_11", map_adspc3_field_11)
      CALL nan_test_psy_data%ProvideVariable("map_aspc9_field_10", map_aspc9_field_10)
      CALL nan_test_psy_data%ProvideVariable("map_w3", map_w3)
      CALL nan_test_psy_data%ProvideVariable("map_wtheta", map_wtheta)
      CALL nan_test_psy_data%ProvideVariable("ndf_adspc3_field_11", ndf_adspc3_field_11)
      CALL nan_test_psy_data%ProvideVariable("ndf_aspc9_field_10", ndf_aspc9_field_10)
      CALL nan_test_psy_data%ProvideVariable("ndf_w3", ndf_w3)
      CALL nan_test_psy_data%ProvideVariable("ndf_wtheta", ndf_wtheta)
      CALL nan_test_psy_data%ProvideVariable("nlayers", nlayers)
      CALL nan_test_psy_data%ProvideVariable("np_xy_qr_xyoz", np_xy_qr_xyoz)
      CALL nan_test_psy_data%ProvideVariable("np_z_qr_xyoz", np_z_qr_xyoz)
      CALL nan_test_psy_data%ProvideVariable("rscalar_12", rscalar_12)
      CALL nan_test_psy_data%ProvideVariable("rscalar_13", rscalar_13)
      CALL nan_test_psy_data%ProvideVariable("rscalar_14", rscalar_14)
      CALL nan_test_psy_data%ProvideVariable("undf_adspc3_field_11", undf_adspc3_field_11)
      CALL nan_test_psy_data%ProvideVariable("undf_aspc9_field_10", undf_aspc9_field_10)
      CALL nan_test_psy_data%ProvideVariable("undf_w3", undf_w3)
      CALL nan_test_psy_data%ProvideVariable("undf_wtheta", undf_wtheta)
      CALL nan_test_psy_data%ProvideVariable("weights_xy_qr_xyoz", weights_xy_qr_xyoz)
      CALL nan_test_psy_data%ProvideVariable("weights_z_qr_xyoz", weights_z_qr_xyoz)
      CALL nan_test_psy_data%PreEnd
      DO cell=loop0_start,loop0_stop
        !
        CALL tl_rhs_eos_code_adj(nlayers, field_1_proxy%data, field_2_proxy%data, field_3_proxy%data, field_4_proxy%data, &
&field_5_proxy%data, field_6_proxy%data, field_7_proxy%data, field_8_proxy%data, field_9_proxy%data, field_10_proxy(1)%data, &
&field_10_proxy(2)%data, field_10_proxy(3)%data, field_11_proxy%data, rscalar_12, rscalar_13, rscalar_14, ndf_w3, undf_w3, &
&map_w3(:,cell), basis_w3_qr_xyoz, ndf_wtheta, undf_wtheta, map_wtheta(:,cell), basis_wtheta_qr_xyoz, ndf_aspc9_field_10, &
&undf_aspc9_field_10, map_aspc9_field_10(:,cell), basis_aspc9_field_10_qr_xyoz, diff_basis_aspc9_field_10_qr_xyoz, &
&ndf_adspc3_field_11, undf_adspc3_field_11, map_adspc3_field_11(:,cell), np_xy_qr_xyoz, np_z_qr_xyoz, weights_xy_qr_xyoz, &
&weights_z_qr_xyoz)
      END DO
      CALL nan_test_psy_data%PostStart
      CALL nan_test_psy_data%ProvideVariable("cell", cell)
      CALL nan_test_psy_data%ProvideVariable("field_1", field_1)
      CALL nan_test_psy_data%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_1%PreStart("invoke_1", "loop1", 2, 1)
      CALL nan_test_psy_data_1%PreDeclareVariable("loop1_start", loop1_start)
      CALL nan_test_psy_data_1%PreDeclareVariable("loop1_stop", loop1_stop)
      CALL nan_test_psy_data_1%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_1%PreEndDeclaration
      CALL nan_test_psy_data_1%ProvideVariable("loop1_start", loop1_start)
      CALL nan_test_psy_data_1%ProvideVariable("loop1_stop", loop1_stop)
      CALL nan_test_psy_data_1%PreEnd
      !
      ! Zero summation variables
      !
      field_1_inner_prod = 0.0_r_def
      !
      DO df=loop1_start,loop1_stop
        field_1_inner_prod = field_1_inner_prod + field_1_proxy%data(df)*field_1_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_1%PostStart
      CALL nan_test_psy_data_1%ProvideVariable("df", df)
      CALL nan_test_psy_data_1%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_2%PreStart("invoke_1", "loop2", 2, 1)
      CALL nan_test_psy_data_2%PreDeclareVariable("loop2_start", loop2_start)
      CALL nan_test_psy_data_2%PreDeclareVariable("loop2_stop", loop2_stop)
      CALL nan_test_psy_data_2%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_2%PreEndDeclaration
      CALL nan_test_psy_data_2%ProvideVariable("loop2_start", loop2_start)
      CALL nan_test_psy_data_2%ProvideVariable("loop2_stop", loop2_stop)
      CALL nan_test_psy_data_2%PreEnd
      !
      ! Zero summation variables
      !
      field_2_inner_prod = 0.0_r_def
      !
      DO df=loop2_start,loop2_stop
        field_2_inner_prod = field_2_inner_prod + field_2_proxy%data(df)*field_2_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_2%PostStart
      CALL nan_test_psy_data_2%ProvideVariable("df", df)
      CALL nan_test_psy_data_2%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_3%PreStart("invoke_1", "loop3", 2, 1)
      CALL nan_test_psy_data_3%PreDeclareVariable("loop3_start", loop3_start)
      CALL nan_test_psy_data_3%PreDeclareVariable("loop3_stop", loop3_stop)
      CALL nan_test_psy_data_3%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_3%PreEndDeclaration
      CALL nan_test_psy_data_3%ProvideVariable("loop3_start", loop3_start)
      CALL nan_test_psy_data_3%ProvideVariable("loop3_stop", loop3_stop)
      CALL nan_test_psy_data_3%PreEnd
      !
      ! Zero summation variables
      !
      field_3_inner_prod = 0.0_r_def
      !
      DO df=loop3_start,loop3_stop
        field_3_inner_prod = field_3_inner_prod + field_3_proxy%data(df)*field_3_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_3%PostStart
      CALL nan_test_psy_data_3%ProvideVariable("df", df)
      CALL nan_test_psy_data_3%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_4%PreStart("invoke_1", "loop4", 2, 1)
      CALL nan_test_psy_data_4%PreDeclareVariable("loop4_start", loop4_start)
      CALL nan_test_psy_data_4%PreDeclareVariable("loop4_stop", loop4_stop)
      CALL nan_test_psy_data_4%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_4%PreEndDeclaration
      CALL nan_test_psy_data_4%ProvideVariable("loop4_start", loop4_start)
      CALL nan_test_psy_data_4%ProvideVariable("loop4_stop", loop4_stop)
      CALL nan_test_psy_data_4%PreEnd
      !
      ! Zero summation variables
      !
      field_4_inner_prod = 0.0_r_def
      !
      DO df=loop4_start,loop4_stop
        field_4_inner_prod = field_4_inner_prod + field_4_proxy%data(df)*field_4_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_4%PostStart
      CALL nan_test_psy_data_4%ProvideVariable("df", df)
      CALL nan_test_psy_data_4%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_5%PreStart("invoke_1", "loop5", 2, 1)
      CALL nan_test_psy_data_5%PreDeclareVariable("loop5_start", loop5_start)
      CALL nan_test_psy_data_5%PreDeclareVariable("loop5_stop", loop5_stop)
      CALL nan_test_psy_data_5%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_5%PreEndDeclaration
      CALL nan_test_psy_data_5%ProvideVariable("loop5_start", loop5_start)
      CALL nan_test_psy_data_5%ProvideVariable("loop5_stop", loop5_stop)
      CALL nan_test_psy_data_5%PreEnd
      !
      ! Zero summation variables
      !
      field_5_inner_prod = 0.0_r_def
      !
      DO df=loop5_start,loop5_stop
        field_5_inner_prod = field_5_inner_prod + field_5_proxy%data(df)*field_5_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_5%PostStart
      CALL nan_test_psy_data_5%ProvideVariable("df", df)
      CALL nan_test_psy_data_5%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_6%PreStart("invoke_1", "loop6", 2, 1)
      CALL nan_test_psy_data_6%PreDeclareVariable("loop6_start", loop6_start)
      CALL nan_test_psy_data_6%PreDeclareVariable("loop6_stop", loop6_stop)
      CALL nan_test_psy_data_6%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_6%PreEndDeclaration
      CALL nan_test_psy_data_6%ProvideVariable("loop6_start", loop6_start)
      CALL nan_test_psy_data_6%ProvideVariable("loop6_stop", loop6_stop)
      CALL nan_test_psy_data_6%PreEnd
      !
      ! Zero summation variables
      !
      field_6_inner_prod = 0.0_r_def
      !
      DO df=loop6_start,loop6_stop
        field_6_inner_prod = field_6_inner_prod + field_6_proxy%data(df)*field_6_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_6%PostStart
      CALL nan_test_psy_data_6%ProvideVariable("df", df)
      CALL nan_test_psy_data_6%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_7%PreStart("invoke_1", "loop7", 2, 1)
      CALL nan_test_psy_data_7%PreDeclareVariable("loop7_start", loop7_start)
      CALL nan_test_psy_data_7%PreDeclareVariable("loop7_stop", loop7_stop)
      CALL nan_test_psy_data_7%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_7%PreEndDeclaration
      CALL nan_test_psy_data_7%ProvideVariable("loop7_start", loop7_start)
      CALL nan_test_psy_data_7%ProvideVariable("loop7_stop", loop7_stop)
      CALL nan_test_psy_data_7%PreEnd
      !
      ! Zero summation variables
      !
      field_7_inner_prod = 0.0_r_def
      !
      DO df=loop7_start,loop7_stop
        field_7_inner_prod = field_7_inner_prod + field_7_proxy%data(df)*field_7_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_7%PostStart
      CALL nan_test_psy_data_7%ProvideVariable("df", df)
      CALL nan_test_psy_data_7%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_8%PreStart("invoke_1", "loop8", 2, 1)
      CALL nan_test_psy_data_8%PreDeclareVariable("loop8_start", loop8_start)
      CALL nan_test_psy_data_8%PreDeclareVariable("loop8_stop", loop8_stop)
      CALL nan_test_psy_data_8%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_8%PreEndDeclaration
      CALL nan_test_psy_data_8%ProvideVariable("loop8_start", loop8_start)
      CALL nan_test_psy_data_8%ProvideVariable("loop8_stop", loop8_stop)
      CALL nan_test_psy_data_8%PreEnd
      !
      ! Zero summation variables
      !
      field_8_inner_prod = 0.0_r_def
      !
      DO df=loop8_start,loop8_stop
        field_8_inner_prod = field_8_inner_prod + field_8_proxy%data(df)*field_8_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_8%PostStart
      CALL nan_test_psy_data_8%ProvideVariable("df", df)
      CALL nan_test_psy_data_8%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_9%PreStart("invoke_1", "loop9", 2, 1)
      CALL nan_test_psy_data_9%PreDeclareVariable("loop9_start", loop9_start)
      CALL nan_test_psy_data_9%PreDeclareVariable("loop9_stop", loop9_stop)
      CALL nan_test_psy_data_9%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_9%PreEndDeclaration
      CALL nan_test_psy_data_9%ProvideVariable("loop9_start", loop9_start)
      CALL nan_test_psy_data_9%ProvideVariable("loop9_stop", loop9_stop)
      CALL nan_test_psy_data_9%PreEnd
      !
      ! Zero summation variables
      !
      field_9_inner_prod = 0.0_r_def
      !
      DO df=loop9_start,loop9_stop
        field_9_inner_prod = field_9_inner_prod + field_9_proxy%data(df)*field_9_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_9%PostStart
      CALL nan_test_psy_data_9%ProvideVariable("df", df)
      CALL nan_test_psy_data_9%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_10%PreStart("invoke_1", "loop10", 2, 1)
      CALL nan_test_psy_data_10%PreDeclareVariable("loop10_start", loop10_start)
      CALL nan_test_psy_data_10%PreDeclareVariable("loop10_stop", loop10_stop)
      CALL nan_test_psy_data_10%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_10%PreEndDeclaration
      CALL nan_test_psy_data_10%ProvideVariable("loop10_start", loop10_start)
      CALL nan_test_psy_data_10%ProvideVariable("loop10_stop", loop10_stop)
      CALL nan_test_psy_data_10%PreEnd
      !
      ! Zero summation variables
      !
      field_10_inner_prod = 0.0_r_def
      !
      DO df=loop10_start,loop10_stop
        field_10_inner_prod = field_10_inner_prod + field_10_1_proxy%data(df)*field_10_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_10%PostStart
      CALL nan_test_psy_data_10%ProvideVariable("df", df)
      CALL nan_test_psy_data_10%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_11%PreStart("invoke_1", "loop11", 2, 1)
      CALL nan_test_psy_data_11%PreDeclareVariable("loop11_start", loop11_start)
      CALL nan_test_psy_data_11%PreDeclareVariable("loop11_stop", loop11_stop)
      CALL nan_test_psy_data_11%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_11%PreEndDeclaration
      CALL nan_test_psy_data_11%ProvideVariable("loop11_start", loop11_start)
      CALL nan_test_psy_data_11%ProvideVariable("loop11_stop", loop11_stop)
      CALL nan_test_psy_data_11%PreEnd
      !
      ! Zero summation variables
      !
      field_10_inner_prod_1 = 0.0_r_def
      !
      DO df=loop11_start,loop11_stop
        field_10_inner_prod_1 = field_10_inner_prod_1 + field_10_2_proxy%data(df)*field_10_input_1_proxy%data(df)
      END DO
      CALL nan_test_psy_data_11%PostStart
      CALL nan_test_psy_data_11%ProvideVariable("df", df)
      CALL nan_test_psy_data_11%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_12%PreStart("invoke_1", "loop12", 2, 1)
      CALL nan_test_psy_data_12%PreDeclareVariable("loop12_start", loop12_start)
      CALL nan_test_psy_data_12%PreDeclareVariable("loop12_stop", loop12_stop)
      CALL nan_test_psy_data_12%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_12%PreEndDeclaration
      CALL nan_test_psy_data_12%ProvideVariable("loop12_start", loop12_start)
      CALL nan_test_psy_data_12%ProvideVariable("loop12_stop", loop12_stop)
      CALL nan_test_psy_data_12%PreEnd
      !
      ! Zero summation variables
      !
      field_10_inner_prod_2 = 0.0_r_def
      !
      DO df=loop12_start,loop12_stop
        field_10_inner_prod_2 = field_10_inner_prod_2 + field_10_3_proxy%data(df)*field_10_input_2_proxy%data(df)
      END DO
      CALL nan_test_psy_data_12%PostStart
      CALL nan_test_psy_data_12%ProvideVariable("df", df)
      CALL nan_test_psy_data_12%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! NanTestStart
      !
      CALL nan_test_psy_data_13%PreStart("invoke_1", "loop13", 2, 1)
      CALL nan_test_psy_data_13%PreDeclareVariable("loop13_start", loop13_start)
      CALL nan_test_psy_data_13%PreDeclareVariable("loop13_stop", loop13_stop)
      CALL nan_test_psy_data_13%PreDeclareVariable("df", df)
      CALL nan_test_psy_data_13%PreEndDeclaration
      CALL nan_test_psy_data_13%ProvideVariable("loop13_start", loop13_start)
      CALL nan_test_psy_data_13%ProvideVariable("loop13_stop", loop13_stop)
      CALL nan_test_psy_data_13%PreEnd
      !
      ! Zero summation variables
      !
      field_11_inner_prod = 0.0_r_def
      !
      DO df=loop13_start,loop13_stop
        field_11_inner_prod = field_11_inner_prod + field_11_proxy%data(df)*field_11_input_proxy%data(df)
      END DO
      CALL nan_test_psy_data_13%PostStart
      CALL nan_test_psy_data_13%ProvideVariable("df", df)
      CALL nan_test_psy_data_13%PostEnd
      !
      ! NanTestEnd
      !
      !
      ! Deallocate basis arrays
      !
      DEALLOCATE (basis_aspc9_field_10_qr_xyoz, basis_w3_qr_xyoz, basis_wtheta_qr_xyoz, diff_basis_aspc9_field_10_qr_xyoz)
      !
    END SUBROUTINE invoke_1
  END MODULE main_psy

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
!> @brief This version is for use on discontinous spaces and over-writes the
!>        output field entirely, hence can only be used for W3 spaces
module dg_matrix_vector_kernel_mod

  use constants_mod, only : r_def, i_def
  use kernel_mod,    only : kernel_type
  use argument_mod,  only : arg_type,                  &
                            GH_FIELD, GH_OPERATOR,     &
                            GH_READ, GH_WRITE,         &
                            GH_REAL, ANY_SPACE_1,      &
                            ANY_DISCONTINUOUS_SPACE_1, &
                            CELL_COLUMN

  implicit none

  private

  !---------------------------------------------------------------------------
  ! Public types
  !---------------------------------------------------------------------------

  type, public, extends(kernel_type) :: dg_matrix_vector_kernel_type
    private
    type(arg_type) :: meta_args(3) = (/                                       &
         arg_type(GH_FIELD,    GH_REAL, GH_WRITE, ANY_DISCONTINUOUS_SPACE_1), &
         arg_type(GH_FIELD,    GH_REAL, GH_READ,  ANY_SPACE_1),               &
         arg_type(GH_OPERATOR, GH_REAL, GH_READ,  ANY_DISCONTINUOUS_SPACE_1,  &
                                                  ANY_SPACE_1)                &
         /)
    integer :: operates_on = CELL_COLUMN
  contains
    procedure, nopass :: dg_matrix_vector_code
  end type

  !---------------------------------------------------------------------------
  ! Contained functions/subroutines
  !---------------------------------------------------------------------------
  public :: dg_matrix_vector_code

contains

!> @brief Computes lhs = matrix*x for discontinuous function spaces
!> @param[in] cell Horizontal cell index
!> @param[in] nlayers Number of layers
!> @param[in,out] lhs Output lhs (A*x)
!> @param[in] x input data
!> @param[in] ncell_3d Total number of cells
!> @param[in] matrix Matrix values in LMA form
!> @param[in] ndf1 Number of degrees of freedom per cell for the output field
!> @param[in] undf1 Unique number of degrees of freedom  for the output field
!> @param[in] map1 Dofmap for the cell at the base of the column for the output field
!> @param[in] ndf2 Number of degrees of freedom per cell for the input field
!> @param[in] undf2 Unique number of degrees of freedom for the input field
!> @param[in] map2 Dofmap for the cell at the base of the column for the input field
subroutine dg_matrix_vector_code(cell,              &
                                 nlayers,           &
                                 lhs, x,            &
                                 ncell_3d,          &
                                 matrix,            &
                                 ndf1, undf1, map1, &
                                 ndf2, undf2, map2)

  implicit none

  ! Arguments
  integer(kind=i_def),                   intent(in) :: cell, nlayers, ncell_3d
  integer(kind=i_def),                   intent(in) :: undf1, ndf1
  integer(kind=i_def),                   intent(in) :: undf2, ndf2
  integer(kind=i_def), dimension(ndf1),  intent(in) :: map1
  integer(kind=i_def), dimension(ndf2),  intent(in) :: map2
  real(kind=r_def), dimension(undf2),              intent(in)    :: x
  real(kind=r_def), dimension(undf1),              intent(inout) :: lhs
  real(kind=r_def), dimension(ndf1,ndf2,ncell_3d), intent(in)    :: matrix

  ! Internal variables
  integer(kind=i_def)               :: df, k, ik
  real(kind=r_def), dimension(ndf2) :: x_e
  real(kind=r_def), dimension(ndf1) :: lhs_e

  do k = 0, nlayers-1
    do df = 1, ndf2
      x_e(df) = x(map2(df)+k)
    end do
    ik = (cell-1)*nlayers + k + 1
    lhs_e = matmul(matrix(:,:,ik),x_e)
    do df = 1,ndf1
       lhs(map1(df)+k) = lhs_e(df)
    end do
  end do

end subroutine dg_matrix_vector_code

end module dg_matrix_vector_kernel_mod

program test
  use field_mod
  use grid_mod
  use decomposition_mod, only : decomposition_type
  use parallel_mod, only : parallel_init
  use init_field_mod, only : init_field
  use update_field_mod, only : update_field
  use nan_test_psy_data_mod, only : nan_test_psydatainit, nan_test_psydatashutdown, nan_test_psydatastart
  use psy_test, only : invoke_0, invoke_1_update_field
  type(r2d_field) :: a_fld
  type(r2d_field) :: b_fld
  TYPE(grid_type), TARGET :: grid

  call parallel_init()
  call nan_test_psydatainit()
  call nan_test_psydatastart()
  grid = grid_type(GO_ARAKAWA_C,(/GO_BC_PERIODIC, GO_BC_PERIODIC, GO_BC_NONE/),GO_OFFSET_SW)
  call grid%decompose(3, 3, 1, 1, 1, halo_width=1)
  call grid_init(grid, 1.0_8, 1.0_8)
  a_fld = r2d_field(grid,GO_T_POINTS)
  b_fld = r2d_field(grid,GO_T_POINTS)
  call invoke_0(a_fld, b_fld)
  call invoke_1_update_field(a_fld, b_fld)
  PRINT *, "a_fld is", a_fld % data
  call nan_test_psydatashutdown()

end program test

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2017-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Authors: R. W. Ford and A. R. Porter, STFC Daresbury Laboratory
! Modified: I. Kavcic, Met Office

module testkern_mod

  use argument_mod
  use fs_continuity_mod
  use kernel_mod
  use constants_mod

  implicit none

  type, extends(kernel_type) :: testkern_type
     type(arg_type), dimension(5) :: meta_args =        &
          (/ arg_type(gh_scalar, gh_real, gh_read),     &
             arg_type(gh_field,  gh_real, gh_inc,  w1), &
             arg_type(gh_field,  gh_real, gh_read, w2), &
             arg_type(gh_field,  gh_real, gh_read, w2), &
             arg_type(gh_field,  gh_real, gh_read, w3)  &
           /)
     integer :: operates_on = cell_column
   contains
     procedure, nopass :: code => testkern_code
  end type testkern_type

contains

  subroutine testkern_code(nlayers, ascalar,        &
                           fld1, fld2, fld3, fld4,  &
                           ndf_w1, undf_w1, map_w1, &
                           ndf_w2, undf_w2, map_w2, &
                           ndf_w3, undf_w3, map_w3)
    implicit none

    integer(kind=i_def), intent(in) :: nlayers
    integer(kind=i_def), intent(in) :: ndf_w1
    integer(kind=i_def), intent(in) :: ndf_w2
    integer(kind=i_def), intent(in) :: ndf_w3
    integer(kind=i_def), intent(in) :: undf_w1, undf_w2, undf_w3
    integer(kind=i_def), intent(in), dimension(ndf_w1) :: map_w1
    integer(kind=i_def), intent(in), dimension(ndf_w2) :: map_w2
    integer(kind=i_def), intent(in), dimension(ndf_w3) :: map_w3
    real(kind=r_def), intent(in) :: ascalar
    real(kind=r_def), intent(inout), dimension(undf_w1) :: fld1
    real(kind=r_def), intent(in), dimension(undf_w2)  :: fld2
    real(kind=r_def), intent(in), dimension(undf_w2)  :: fld3
    real(kind=r_def), intent(in), dimension(undf_w3)  :: fld4

  end subroutine testkern_code

end module testkern_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: J. Henrichs, Bureau of Meteorology

!> This module contains a simple 'update' kernel that
!! creates some NAN values in the output field by
!! calling some division by 0. If the compiler should
!! catch floating point exceptions, the code for checking
!! for NANs will not be executed.

module update_field_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod, only: GO_OFFSET_SW
  implicit none

  type, extends(kernel_type) :: update_field
     type(go_arg), dimension(2) :: meta_args =                 &
          (/ go_arg(GO_READWRITE, GO_CT,       GO_POINTWISE),  & ! field
             go_arg(GO_READ,      GO_CT,       GO_POINTWISE)   & ! field
           /)
     !> This kernel writes only to internal points of the
     !! simulation domain.
     integer :: ITERATES_OVER = GO_ALL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => update_field_code
  end type update_field

contains

  subroutine update_field_code(i, j, a_f, b_f)
    integer, intent(in) :: i, j
    real(go_wp), dimension(:,:), intent(inout) :: a_f
    real(go_wp), dimension(:,:), intent(in) :: b_f

    ! Trigger a NAN result on the diagonal:
    a_f(i,j) = b_f(i,j) / (i-j)

  end subroutine update_field_code

end module update_field_mod

  MODULE main_psy
    USE constants_mod, ONLY: r_def, i_def
    USE field_mod, ONLY: field_type, field_proxy_type
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_initialise_fields(field1, field2)
      USE mesh_mod, ONLY: mesh_type
      TYPE(field_type), intent(in) :: field1, field2
      INTEGER df
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      TYPE(field_proxy_type) field1_proxy, field2_proxy
      INTEGER(KIND=i_def) max_halo_depth_mesh
      TYPE(mesh_type), pointer :: mesh => null()
      !
      ! Initialise field and/or operator proxies
      !
      field1_proxy = field1%get_proxy()
      field2_proxy = field2%get_proxy()
      !
      ! Create a mesh object
      !
      mesh => field1_proxy%vspace%get_mesh()
      max_halo_depth_mesh = mesh%get_halo_depth()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = field1_proxy%vspace%get_last_dof_owned()
      loop1_start = 1
      loop1_stop = field2_proxy%vspace%get_last_dof_owned()
      !
      ! Call kernels and communication routines
      !
      !$acc enter data  &
!$acc& copyin(0.0_r_def,1.0_r_def,field1_proxy,field1_proxy%data,field2_proxy,field2_proxy%data,map_aspc1_field1,map_aspc1_field2, &
!$acc& ndf_aspc1_field1,ndf_aspc1_field2,nlayers,undf_aspc1_field1,undf_aspc1_field2)
      !
      !$acc parallel default(present)
      !$acc loop independent
      DO df=loop0_start,loop0_stop
        field1_proxy%data(df) = 0.0_r_def
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL field1_proxy%set_dirty()
      !
      !$acc end parallel
      !$acc parallel default(present)
      !$acc loop independent
      DO df=loop1_start,loop1_stop
        field2_proxy%data(df) = 1.0_r_def
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL field2_proxy%set_dirty()
      !
      !$acc end parallel
      !
    END SUBROUTINE invoke_initialise_fields
    SUBROUTINE invoke_testkern_w0(field1, field2)
      USE testkern_w0_kernel_mod, ONLY: testkern_w0_code
      USE mesh_mod, ONLY: mesh_type
      TYPE(field_type), intent(in) :: field1, field2
      INTEGER(KIND=i_def) cell
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      INTEGER(KIND=i_def) nlayers
      TYPE(field_proxy_type) field1_proxy, field2_proxy
      INTEGER(KIND=i_def), pointer :: map_w0(:,:) => null()
      INTEGER(KIND=i_def) ndf_w0, undf_w0
      INTEGER(KIND=i_def) max_halo_depth_mesh
      TYPE(mesh_type), pointer :: mesh => null()
      !
      ! Initialise field and/or operator proxies
      !
      field1_proxy = field1%get_proxy()
      field2_proxy = field2%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = field1_proxy%vspace%get_nlayers()
      !
      ! Create a mesh object
      !
      mesh => field1_proxy%vspace%get_mesh()
      max_halo_depth_mesh = mesh%get_halo_depth()
      !
      ! Look-up dofmaps for each function space
      !
      map_w0 => field1_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for w0
      !
      ndf_w0 = field1_proxy%vspace%get_ndf()
      undf_w0 = field1_proxy%vspace%get_undf()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = mesh%get_last_halo_cell(1)
      !
      ! Call kernels and communication routines
      !
      !$acc enter data copyin(field1_proxy,field1_proxy%data,field2_proxy,field2_proxy%data,map_w0,ndf_w0,nlayers,undf_w0)
      !
      IF (field1_proxy%is_dirty(depth=1)) THEN
        CALL field1_proxy%halo_exchange(depth=1)
      END IF
      !
      IF (field2_proxy%is_dirty(depth=1)) THEN
        CALL field2_proxy%halo_exchange(depth=1)
      END IF
      !
      !$acc parallel default(present)
      !$acc loop independent
      DO cell=loop0_start,loop0_stop
        !
        CALL testkern_w0_code(nlayers, field1_proxy%data, field2_proxy%data, ndf_w0, undf_w0, map_w0(:,cell))
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL field1_proxy%set_dirty()
      !
      !$acc end parallel
      !
    END SUBROUTINE invoke_testkern_w0
  END MODULE main_psy

!-----------------------------------------------------------------------------
! (C) Crown copyright 2021 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------
!
!> @brief Tangent Linear to the vorticity advection component
!>        of the rhs of the momentum equation.
!> @details The nonlinear model is:
!>          \f[ \xi/ \times u (with vorticity \xi and wind u) \f]
!>          The tangent linear is:
!>          \f[ \xi/ \times ls_u + ls_\xi/ \times u \f]
module tl_vorticity_advection_kernel_mod
use kernel_mod,              only: kernel_type
use argument_mod,            only: arg_type, func_type,                 &
                                   GH_FIELD, GH_REAL,                   &
                                   GH_READ, GH_INC,                     &
                                   ANY_SPACE_9,                         &
                                   ANY_DISCONTINUOUS_SPACE_3,           &
                                   GH_BASIS, GH_DIFF_BASIS,             &
                                   CELL_COLUMN, GH_QUADRATURE_XYoZ
use constants_mod,           only: r_def, i_def
use fs_continuity_mod,       only: W1, W2
use cross_product_mod,       only: cross_product

implicit none

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------
!> The type declaration for the kernel. Contains the metadata needed by the Psy layer
type, public, extends(kernel_type) :: tl_vorticity_advection_kernel_type
  private
  type(arg_type) :: meta_args(7) = (/                                  &
       arg_type(GH_FIELD,   GH_REAL, GH_INC,  W2),                     &
       arg_type(GH_FIELD,   GH_REAL, GH_READ, W2),                     &
       arg_type(GH_FIELD,   GH_REAL, GH_READ, W1),                     &
       arg_type(GH_FIELD,   GH_REAL, GH_READ, W2),                     &
       arg_type(GH_FIELD,   GH_REAL, GH_READ, W1),                     &
       arg_type(GH_FIELD*3, GH_REAL, GH_READ, ANY_SPACE_9),            &
       arg_type(GH_FIELD,   GH_REAL, GH_READ, ANY_DISCONTINUOUS_SPACE_3)        &
       /)
  type(func_type) :: meta_funcs(3) = (/                                &
       func_type(W2, GH_BASIS),                                        &
       func_type(W1, GH_BASIS),                                        &
       func_type(ANY_SPACE_9, GH_BASIS, GH_DIFF_BASIS)                 &
       /)
  integer :: operates_on = CELL_COLUMN
  integer :: gh_shape = GH_QUADRATURE_XYoZ
contains
  procedure, nopass :: tl_vorticity_advection_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public tl_vorticity_advection_code
contains

!> @brief Compute the tangent linear for vorticity advection.
!! @param[in] nlayers      Number of layers
!! @param[inout] r_u       ACTIVE Change in right hand side of the mom equation
!! @param[in] wind         ACTIVE Change in advecting wind field
!! @param[in] vorticity    ACTIVE Change in vorticity field = curl(u)
!! @param[in] ls_wind      Lin state advecting wind field
!! @param[in] ls_vorticity Lin state vorticity field = curl(ls_u)
!! @param[in] chi_1        1st (spherical) coordinate field in Wchi
!! @param[in] chi_2        2nd (spherical) coordinate field in Wchi
!! @param[in] chi_3        3rd (spherical) coordinate field in Wchi
!! @param[in] panel_id     Field giving the ID for mesh panels.
!! @param[in] ndf_w2       Number of degrees of freedom per cell for w2
!! @param[in] undf_w2      Number of unique degrees of freedom  for w2
!! @param[in] map_w2       Dofmap for the cell at the base of the column for w2
!! @param[in] w2_basis     Basis functions evaluated at quadrature points
!! @param[in] ndf_w1       Number of degrees of freedom per cell for w1
!! @param[in] undf_w1      Number of unique degrees of freedom  for w1
!! @param[in] map_w1       Dofmap for the cell at the base of the column for w1
!! @param[in] w1_basis     Basis functions evaluated at gaussian quadrature points
!! @param[in] ndf_chi      Number of degrees of freedom per cell for chi
!! @param[in] undf_chi     Number of unique degrees of freedom  for chi
!! @param[in] map_chi      Dofmap for the cell at the base of the column for chi
!! @param[in] chi_basis    Wchi basis functions evaluated at gaussian quadrature points.
!! @param[in] chi_diff_basis Derivatives of Wchi basis functions
!!                           evaluated at gaussian quadrature points
!! @param[in] ndf_pid      Number of degrees of freedom per cell for panel_id
!! @param[in] undf_pid     Number of unique degrees of freedom for panel_id
!! @param[in] map_pid      Dofmap for the cell at the base of the column for panel_id
!! @param[in] nqp_h        Number of quadrature points in the horizontal
!! @param[in] nqp_v        Number of quadrature points in the vertical
!! @param[in] wqp_h        Horizontal quadrature weights
!! @param[in] wqp_v        Vertical quadrature weights
subroutine tl_vorticity_advection_code(nlayers,         &
                                       r_u,             &
                                       wind,            &
                                       vorticity,       &
                                       ls_wind,         &
                                       ls_vorticity,    &
                                       chi_1,           &
                                       chi_2,           &
                                       chi_3,           &
                                       panel_id,        &
                                       ndf_w2,          &
                                       undf_w2,         &
                                       map_w2,          &
                                       w2_basis,        &
                                       ndf_w1,          &
                                       undf_w1,         &
                                       map_w1,          &
                                       w1_basis,        &
                                       ndf_chi,         &
                                       undf_chi,        &
                                       map_chi,         &
                                       chi_basis,       &
                                       chi_diff_basis,  &
                                       ndf_pid,         &
                                       undf_pid,        &
                                       map_pid,         &
                                       nqp_h,           &
                                       nqp_v,           &
                                       wqp_h,           &
                                       wqp_v            &
                                       )

  use coordinate_jacobian_mod, only: pointwise_coordinate_jacobian, &
                                     pointwise_coordinate_jacobian_inverse
  implicit none

  ! Arguments
  integer, intent(in) :: nlayers,nqp_h, nqp_v
  integer, intent(in) :: ndf_chi, ndf_w1, ndf_w2, ndf_pid
  integer, intent(in) :: undf_chi, undf_w1, undf_w2, undf_pid
  integer, dimension(ndf_chi), intent(in) :: map_chi
  integer, dimension(ndf_w1),  intent(in) :: map_w1
  integer, dimension(ndf_w2),  intent(in) :: map_w2
  integer, dimension(ndf_pid), intent(in) :: map_pid

  real(kind=r_def), dimension(3,ndf_w2,nqp_h,nqp_v),  intent(in) :: w2_basis
  real(kind=r_def), dimension(3,ndf_w1,nqp_h,nqp_v),  intent(in) :: w1_basis
  real(kind=r_def), dimension(1,ndf_chi,nqp_h,nqp_v), intent(in) :: chi_basis
  real(kind=r_def), dimension(3,ndf_chi,nqp_h,nqp_v), intent(in) :: chi_diff_basis

  real(kind=r_def), dimension(undf_w2),  intent(inout) :: r_u
  real(kind=r_def), dimension(undf_w2),  intent(in)    :: wind
  real(kind=r_def), dimension(undf_w1),  intent(in)    :: vorticity
  real(kind=r_def), dimension(undf_w2),  intent(in)    :: ls_wind
  real(kind=r_def), dimension(undf_w1),  intent(in)    :: ls_vorticity
  real(kind=r_def), dimension(undf_chi), intent(in)    :: chi_1, chi_2, chi_3
  real(kind=r_def), dimension(undf_pid), intent(in)    :: panel_id

  real(kind=r_def), dimension(nqp_h),    intent(in)    ::  wqp_h
  real(kind=r_def), dimension(nqp_v),    intent(in)    ::  wqp_v

  ! Internal variables
  integer(kind=i_def) :: df, k, loc, ipanel
  integer(kind=r_def) :: qp1, qp2

  real(kind=r_def), dimension(ndf_chi)  :: chi_1_e, chi_2_e, chi_3_e
  real(kind=r_def)                      :: dj
  real(kind=r_def), dimension(3,3)      :: jac, jac_inv
  real(kind=r_def), dimension(3)        :: vorticity_at_quad, u_at_quad,       &
                                           ls_vorticity_at_quad, u_ls_at_quad, &
                                           j_vorticity, j_ls_vorticity,        &
                                           vorticity_term

  ipanel = int(panel_id(map_pid(1)), i_def)

  do k = 0, nlayers-1
  ! Extract element arrays of chi
    do df = 1, ndf_chi
      loc = map_chi(df) + k
      chi_1_e(df) = chi_1( loc )
      chi_2_e(df) = chi_2( loc )
      chi_3_e(df) = chi_3( loc )
    end do

    ! The nonlinear term is:
    ! v.( [(J^-1 * J^-T) * vorticity] cross u )
    ! The corresponding linear term is:
    ! v.( ( [(J^-1 * J^-T) * ls_vorticity] cross u )
    ! + ( [(J^-1 * J^-T) * vorticity] cross u_ls ) )

    do qp2 = 1, nqp_v
      do qp1 = 1, nqp_h

        ! Constants
        call pointwise_coordinate_jacobian(ndf_chi, chi_1_e, chi_2_e, chi_3_e,  &
                                           ipanel, chi_basis(:,:,qp1,qp2),      &
                                           chi_diff_basis(:,:,qp1,qp2), jac, dj)
        jac_inv =  pointwise_coordinate_jacobian_inverse(jac, dj)
        jac = matmul(jac_inv,transpose(jac_inv))

        ! Linearisation state
        ls_vorticity_at_quad(:) = 0.0_r_def
        do df = 1, ndf_w1
          ls_vorticity_at_quad(:) = ls_vorticity_at_quad(:)        &
                                  + ls_vorticity( map_w1(df) + k ) &
                                  * w1_basis(:,df,qp1,qp2)
        end do
        u_ls_at_quad(:) = 0.0_r_def
        do df = 1, ndf_w2
          u_ls_at_quad(:) = u_ls_at_quad(:)           &
                          + ls_wind( map_w2(df) + k ) &
                          * w2_basis(:,df,qp1,qp2)
        end do

        ! Perturbation
        vorticity_at_quad(:) = 0.0_r_def
        do df = 1, ndf_w1
          vorticity_at_quad(:) = vorticity_at_quad(:)        &
                               + vorticity( map_w1(df) + k ) &
                               * w1_basis(:,df,qp1,qp2)
        end do
        u_at_quad(:) = 0.0_r_def
        do df = 1, ndf_w2
          u_at_quad(:) = u_at_quad(:)           &
                       + wind( map_w2(df) + k ) &
                       * w2_basis(:,df,qp1,qp2)
        end do

        ! Calculation
        j_ls_vorticity = wqp_h(qp1) * wqp_v(qp2) *             &
                         matmul( jac, ls_vorticity_at_quad )

        j_vorticity = wqp_h(qp1) * wqp_v(qp2) *        &
                      matmul( jac, vorticity_at_quad )

        vorticity_term = cross_product( j_ls_vorticity, u_at_quad ) + &
                         cross_product( j_vorticity, u_ls_at_quad )

        do df = 1, ndf_w2
          r_u( map_w2(df) + k ) = r_u( map_w2(df) + k )                &
                                - dot_product( w2_basis(:,df,qp1,qp2), &
                                              vorticity_term )
        end do

      end do
    end do
  end do

end subroutine tl_vorticity_advection_code

end module tl_vorticity_advection_kernel_mod

  MODULE mixed_precision_psy
    USE constants_mod, ONLY: r_tran, r_solver, r_def, i_def
    USE field_mod, ONLY: field_type, field_proxy_type
    USE r_solver_field_mod, ONLY: r_solver_field_type, r_solver_field_proxy_type
    USE r_tran_field_mod, ONLY: r_tran_field_type, r_tran_field_proxy_type
    USE operator_mod, ONLY: r_solver_operator_type, r_solver_operator_proxy_type, operator_type, operator_proxy_type
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(scalar_r_def, field_r_def, operator_r_def, scalar_r_solver, field_r_solver, operator_r_solver, &
&scalar_r_tran, field_r_tran)
      USE mixed_kernel_mod, ONLY: mixed_kernel_code
      USE mesh_mod, ONLY: mesh_type
      REAL(KIND=r_def), intent(in) :: scalar_r_def
      REAL(KIND=r_solver), intent(in) :: scalar_r_solver
      REAL(KIND=r_tran), intent(in) :: scalar_r_tran
      TYPE(field_type), intent(in) :: field_r_def
      TYPE(r_solver_field_type), intent(in) :: field_r_solver
      TYPE(r_tran_field_type), intent(in) :: field_r_tran
      TYPE(operator_type), intent(in) :: operator_r_def
      TYPE(r_solver_operator_type), intent(in) :: operator_r_solver
      INTEGER(KIND=i_def) cell
      INTEGER(KIND=i_def) loop2_start, loop2_stop
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      INTEGER(KIND=i_def) nlayers
      TYPE(r_solver_operator_proxy_type) operator_r_solver_proxy
      TYPE(operator_proxy_type) operator_r_def_proxy
      TYPE(r_tran_field_proxy_type) field_r_tran_proxy
      TYPE(r_solver_field_proxy_type) field_r_solver_proxy
      TYPE(field_proxy_type) field_r_def_proxy
      INTEGER(KIND=i_def), pointer :: map_w3(:,:) => null()
      INTEGER(KIND=i_def) ndf_w3, undf_w3, ndf_w0
      INTEGER(KIND=i_def) max_halo_depth_mesh
      TYPE(mesh_type), pointer :: mesh => null()
      !
      ! Initialise field and/or operator proxies
      !
      field_r_def_proxy = field_r_def%get_proxy()
      operator_r_def_proxy = operator_r_def%get_proxy()
      field_r_solver_proxy = field_r_solver%get_proxy()
      operator_r_solver_proxy = operator_r_solver%get_proxy()
      field_r_tran_proxy = field_r_tran%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = field_r_def_proxy%vspace%get_nlayers()
      !
      ! Create a mesh object
      !
      mesh => field_r_def_proxy%vspace%get_mesh()
      max_halo_depth_mesh = mesh%get_halo_depth()
      !
      ! Look-up dofmaps for each function space
      !
      map_w3 => field_r_def_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for w3
      !
      ndf_w3 = field_r_def_proxy%vspace%get_ndf()
      undf_w3 = field_r_def_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for w0
      !
      ndf_w0 = operator_r_def_proxy%fs_from%get_ndf()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = mesh%get_last_edge_cell()
      loop1_start = 1
      loop1_stop = mesh%get_last_edge_cell()
      loop2_start = 1
      loop2_stop = mesh%get_last_edge_cell()
      !
      ! Call kernels and communication routines
      !
      DO cell=loop0_start,loop0_stop
        !
        CALL mixed_kernel_code(cell, nlayers, scalar_r_def, field_r_def_proxy%data, operator_r_def_proxy%ncell_3d, &
&operator_r_def_proxy%local_stencil, ndf_w3, undf_w3, map_w3(:,cell), ndf_w0)
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL field_r_def_proxy%set_dirty()
      !
      DO cell=loop1_start,loop1_stop
        !
        CALL mixed_kernel_code(cell, nlayers, scalar_r_solver, field_r_solver_proxy%data, operator_r_solver_proxy%ncell_3d, &
&operator_r_solver_proxy%local_stencil, ndf_w3, undf_w3, map_w3(:,cell), ndf_w0)
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL field_r_solver_proxy%set_dirty()
      !
      DO cell=loop2_start,loop2_stop
        !
        CALL mixed_kernel_code(cell, nlayers, scalar_r_tran, field_r_tran_proxy%data, operator_r_def_proxy%ncell_3d, &
&operator_r_def_proxy%local_stencil, ndf_w3, undf_w3, map_w3(:,cell), ndf_w0)
      END DO
      !
      ! Set halos dirty/clean for fields modified in the above loop
      !
      CALL field_r_tran_proxy%set_dirty()
      !
      !
    END SUBROUTINE invoke_0
  END MODULE mixed_precision_psy

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2022, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office
!
!> @brief Kernel which assembles a locally assembled matrix (LMA) into a
!!        columnwise assembled matrix (CMA).
module columnwise_op_asm_kernel_mod

use kernel_mod,              only : kernel_type
use argument_mod,            only : arg_type, func_type,                    &
                                    GH_OPERATOR, GH_COLUMNWISE_OPERATOR,    &
                                    GH_REAL, GH_READ, GH_WRITE,             &
                                    ANY_SPACE_1, ANY_SPACE_2,               &
                                    CELL_COLUMN

use constants_mod,           only : r_def, r_solver, i_def

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------

type, public, extends(kernel_type) :: columnwise_op_asm_kernel_type
  private
  type(arg_type) :: meta_args(2) = (/                                                 &
       arg_type(GH_OPERATOR,            GH_REAL, GH_READ,  ANY_SPACE_1, ANY_SPACE_2), &
       arg_type(GH_COLUMNWISE_OPERATOR, GH_REAL, GH_WRITE, ANY_SPACE_1, ANY_SPACE_2)  &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: columnwise_op_asm_kernel_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public columnwise_op_asm_kernel_code

contains

  !> @brief The subroutine which is called directly from the PSy layer and
  !!        assembles the LMA into a CMA operator.
  !> @details Given an LMA representation of the operator mapping between
  !!          two horizontally discontinuous spaces, assemble the columnwise
  !!          matrix representation of the operator.
  !>
  !> @param [in] cell Horizontal cell index
  !> @param [in] nlayers Number of vertical layers
  !> @param [in] ncell_2d Number of cells in 2D grid
  !> @param [in] ncell_3d Total number of cells
  !> @param [in] local_stencil Locally assembled matrix
  !> @param [in,out] columnwise_matrix Banded matrix to assemble into
  !> @param [in] nrow Number of rows in the banded matrix
  !> @param [in] ncol Number of columns in the banded matrix
  !> @param [in] bandwidth Bandwidth of the banded matrix
  !> @param [in] alpha Banded matrix parameter \f$\alpha\f$
  !> @param [in] beta Banded matrix parameter \f$\beta\f$
  !> @param [in] gamma_m Banded matrix parameter \f$\gamma_-\f$
  !> @param [in] gamma_p Banded matrix parameter \f$\gamma_+\f$
  !> @param [in] ndf_to Number of degrees of freedom per cell for the to-space
  !> @param [in] column_banded_dofmap_to List of offsets for to-space
  !> @param [in] ndf_from Number of degrees of freedom per cell for the from-sp
  !> @param [in] column_banded_dofmap_from List of offsets for from-space
  subroutine columnwise_op_asm_kernel_code(cell,                     &
                                           nlayers,                  &
                                           ncell_2d,                 &
                                           ncell_3d,                 &
                                           local_stencil,            &
                                           columnwise_matrix,        &
                                           nrow,                     &
                                           ncol,                     &
                                           bandwidth,                &
                                           alpha,                    &
                                           beta,                     &
                                           gamma_m,                  &
                                           gamma_p,                  &
                                           ndf_to,                   &
                                           column_banded_dofmap_to,  &
                                           ndf_from,                 &
                                           column_banded_dofmap_from)

    implicit none

    ! Arguments
    integer(kind=i_def), intent(in) :: cell,  nlayers, ncell_3d, ncell_2d
    real(kind=r_def), dimension(ndf_to,ndf_from,ncell_3d), intent(in) :: local_stencil
    integer(kind=i_def), intent(in) :: nrow, ncol, bandwidth
    real(kind=r_solver), dimension(bandwidth,nrow,ncell_2d), intent(inout) :: columnwise_matrix
    integer(kind=i_def), intent(in) :: ndf_to, ndf_from
    integer(kind=i_def), intent(in) :: alpha, beta, gamma_m, gamma_p
    integer(kind=i_def), dimension(ndf_to,nlayers), intent(in) :: column_banded_dofmap_to
    integer(kind=i_def), dimension(ndf_from,nlayers), intent(in) :: column_banded_dofmap_from

    ! Internal parameters
    integer(kind=i_def) :: df1, df2 ! Loop indices for dofs
    integer(kind=i_def) :: i, j ! Row and column index index
    integer(kind=i_def) :: j_minus ! First column in a row
    integer(kind=i_def) :: ik ! ncell3d counter
    integer(kind=i_def) :: k ! nlayers counter

    k = gamma_m + ncol

    ! Initialise matrix to zero
    columnwise_matrix( :, :, cell ) = 0.0_r_solver
    ! Loop over all vertical layers
    do k = 1, nlayers
       ik = (cell-1)*nlayers + k ! Cell index in 3D
       do df1 = 1, ndf_to
          i = column_banded_dofmap_to( df1, k )
          j_minus = ceiling((alpha*i-gamma_p)/(1.0_r_solver*beta), i_def)
          do df2 = 1, ndf_from
             j = column_banded_dofmap_from( df2, k )
             columnwise_matrix( j-j_minus+1, i, cell )        &
                  = columnwise_matrix( j-j_minus+1, i, cell ) &
                  + real(local_stencil( df1 ,df2, ik ), r_solver)
         end do
       end do
    end do

  end subroutine columnwise_op_asm_kernel_code

end module columnwise_op_asm_kernel_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office

!> This module implements a simple NetCDF writer using the PSyData
!! interface. It is specific to the dl_esm_inf library used with
!! the GOcean API.
!! A Fortran code instrumented with corresponding calls
!! to the PSyData API and linked in with this library will nf90_create
!! a NetCDF file that contains the dimensions for each
!! field.
!!

module extract_psy_data_mod

    use extract_netcdf_base_mod, only : ExtractNetcdfBaseType

    implicit none

    !> This is the data type that manages the information required
    !! to write data to a NetCDF file using the PSyData API. A
    !! static instance of this type is created for each instrumented
    !! region with PSyclone (and each region will write a separate
    !! file).
    type, extends(ExtractNetcdfBaseType), public :: extract_PsyDataType

    contains

        ! The various procedures used
        procedure :: DeclareFieldDouble
        procedure :: WriteFieldDouble

        !> The generic interface for declaring a variable:
        generic, public :: PreDeclareVariable => DeclareFieldDouble

        !> The generic interface for providing the value of variables,
        !! which in case of the NetCDF interface is written:
        generic, public :: ProvideVariable => WriteFieldDouble

    end type extract_PSyDataType

contains

    ! -------------------------------------------------------------------------
    !> Checks if the return value from a NetCDF call indicates an error.
    !! If so, print the corresponding error message and aborts the program.
    !! It is typically used as a wrapper around NetCDF calls:
    !! retval = CheckError(nf90_close(ncid))
    !! @param[in] retval The return value from a NetCDF operation.
    !! Returns the return value.
    function CheckError(retval)

        use netcdf, only : nf90_noerr, nf90_strerror

        implicit none

        integer :: CheckError
        integer, intent(in) :: retval

        if (retval /= nf90_noerr) then
            print *,"NetCDF Error:"
            print *,trim(nf90_strerror(retval))
            stop
        endif

        CheckError = retval

    end function CheckError

    ! -------------------------------------------------------------------------
    !> This is a one-time init function. It is not required for the kernel
    !! extraction and is therefore empty.
    subroutine extract_PSyDataInit()
        implicit none
    end subroutine extract_PSyDataInit

    ! -------------------------------------------------------------------------
    !> This is a one-time shutdown function. It is not required for the kernel
    !! extraction and is therefore empty.
    subroutine extract_PSyDataShutdown()
        implicit none
    end subroutine extract_PSyDataShutdown

    ! -------------------------------------------------------------------------
    !> This subroutine declares a double precision field as defined in
    !! dl_esm_info (r2d_field). A corresponding variable definition is added
    !! to the NetCDF file, and the variable id is stored in the var_id field.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine DeclareFieldDouble(this, name, value)

        use netcdf
        use field_mod, only : r2d_field

        implicit none

        class(extract_PsyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(r2d_field), intent(in) :: value
        integer :: x_dimid, y_dimid, retval
        integer, dimension(2) :: dimids

        ! Map to a simple 2d-array:
        call this%DeclareArray2dDouble(name, value%data)

    end subroutine DeclareFieldDouble

    ! -------------------------------------------------------------------------
    !> This subroutine writes the value of a dl_esm_field (r2d_field)
    !! to the NetCDF file. It takes the variable id from the corresponding
    !! declaration.
    !! @param[in,out] this The instance of the extract_PsyDataType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine WriteFieldDouble(this, name, value)

        use netcdf
        use field_mod, only : r2d_field

        implicit none

        class(extract_PsyDataType), intent(inout), target :: this
        character(*), intent(in) :: name
        type(r2d_field), intent(in) :: value
        integer :: retval

        ! Map the field to a simple 2d-array
        call this%WriteArray2dDouble(name, value%data)

    end subroutine WriteFieldDouble

end module extract_psy_data_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2019, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: A. R. Porter, STFC Daresbury Lab.

module another_mod
  use kind_params_mod, only: go_wp

contains

  subroutine another_kern(i, j, fld)
    !> A kernel that accesses a variable from another module
    use data_mod, only: gravity
    integer, intent(in) :: i, j
    real(go_wp), dimension(:,:) :: fld
    fld(i,j) = i*gravity
  end subroutine another_kern
  
end module another_mod

! -----------------------------------------------------------------------------
!
! Original code Governed by the CeCILL licence (http://www.cecill.info)
!
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Code modifications Copyright (c) 2019-2020, Science and Technology Facilities
! Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author R. W. Ford, STFC Daresbury Lab

! Code extracted from the tra_adv benchmark, with a SIGN intrinsic
! replaced with equivalent code and the resultant expression
! simplified. Literals have also had the Fortran double precision
! specification (e.g. 0.d0) removed.
program test_ifs

  integer, parameter :: jpi=10, jpj=10, jpk=10
  real, dimension(jpi,jpj,jpk) :: zwx, zslpx
  real :: tmpx
  integer :: ji, jj, jk
  
  DO jk = 1, jpk-1
     DO jj = 2, jpj
        DO ji = 2, jpi
           tmpx = zwx(ji,jj,jk) * zwx(ji-1,jj,jk)
           if (tmpx .ge. 0.0d0) then
              zslpx(ji,jj,jk) = 0.5 * ( zwx(ji,jj,jk) + zwx(ji-1,jj,jk) )
           else
              zslpx(ji,jj,jk) = 0.0
           end if
        END DO
     END DO
  END DO

end program

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2018-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: A. R. Porter and S. Siso, STFC Daresbury Lab

program alg
  use kind_params_mod, only: go_wp
  use parallel_mod
  use grid_mod
  use field_mod, only: r2d_field, GO_T_POINTS
  use gocean_mod, only: gocean_initialise
  use inc_field_mod, only: inc_field
  implicit none
  integer :: my_rank
  integer :: istp, ierr, this_step
  integer :: jpiglo, jpjglo
  integer, parameter :: nsteps = 10
  
  integer, allocatable, dimension(:,:) :: tmask
  type(r2d_field) :: fld1
  type(grid_type), target :: grid1
  integer :: nx, ny
  
  ! Dimensions of our domain
  jpiglo = 50
  jpjglo = 50

  call gocean_initialise()

  ! Create our grid
  grid1 = grid_type(GO_ARAKAWA_C,                                   &
                    (/GO_BC_PERIODIC, GO_BC_PERIODIC, GO_BC_NONE/), &
                    GO_OFFSET_SW)

  !> Generate a domain decomposition
  call grid1%decompose(jpiglo, jpjglo)
  my_rank = get_rank()

  ! Set-up the T mask for the local domain. This defines the model domain.
  allocate(tmask(grid1%subdomain%global%nx, &
                 grid1%subdomain%global%ny), stat=ierr)
  if(ierr /= 0)then
     stop 'Failed to allocate T mask'
  end if

  tmask(:,:) = 0

  ! Having specified the T points mask, we can set up mesh parameters
  call grid_init(grid1, 1000.0_go_wp, 1000.0_go_wp, tmask)
  
  ! Create fields on this grid
  fld1 = r2d_field(grid1, GO_T_POINTS)

  fld1%data(:,:) = 0.0_go_wp

  nx = fld1%whole%nx
  ny = fld1%whole%ny
  do istp = 1, nsteps
     this_step = istp ! Workaround the fact that PSyclone declares all arguments
                      ! to the PSy-layer as INOUT and we can't do that for a
                      ! loop variable
     call invoke( inc_field(fld1, nx, ny, this_step) )
  end do

  ! Print the nsteps and a field datapoint when the simulation finishes
  write (*,*) "nsteps = ", nsteps, "field(2,2) = ", fld1%data(2,2)

end program alg

!-----------------------------------------------------------------------------
! (C) Crown copyright 2019 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------
! LICENCE is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE
! -----------------------------------------------------------------------------
!
! BSD 3-Clause License
!
! Modifications copyright (c) 2019-2021, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Modified A. R. Porter, STFC Daresbury Lab
! Modified I. Kavcic, Met Office

!> @brief Perform the restriction operation from a fine grid field to a coarse
!!        grid field
!> @details Restrict the fine grid field over a number of cells into a single
!!          coarse grid field. The fine grid cells are considered to be
!!          contained in a coarse grid cell. Values are assumed to
!!          be pointwise scalar values so no area weighting is used
module restrict_kernel_mod

use constants_mod,           only: i_def, r_def
use kernel_mod,              only: kernel_type
use argument_mod,            only: arg_type,                  &
                                   GH_FIELD, GH_REAL,         &
                                   CELL_COLUMN,               &
                                   GH_READ, GH_WRITE,         &
                                   ANY_DISCONTINUOUS_SPACE_1, &
                                   ANY_DISCONTINUOUS_SPACE_2, &
                                   GH_COARSE, GH_FINE

implicit none

private

type, public, extends(kernel_type) :: restrict_kernel_type
   private
   type(arg_type) :: meta_args(2) = (/                                   &
        arg_type(GH_FIELD, GH_REAL, GH_WRITE, ANY_DISCONTINUOUS_SPACE_1, &
                                              mesh_arg=GH_COARSE),       &
        arg_type(GH_FIELD, GH_REAL, GH_READ,  ANY_DISCONTINUOUS_SPACE_2, &
                                              mesh_arg=GH_FINE)          &
        /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: restrict_kernel_code
end type restrict_kernel_type

public :: restrict_kernel_code

contains

  !> @brief Subroutine to perform the restriction operation
  !> @param[in] nlayers Number of layers in a model column
  !> @param[in] cell_map Map of which fine grid cells lie in the coarse grid
  !!                     cell
  !> @param[in] ncell_f_per_c_x Number of fine cells per coarse cell in x-direction
  !> @param[in] ncell_f_per_c_y Number of fine cells per coarse cell in y-direction
  !> @param[in] ncell_f  Number of cells in the fine grid
  !> @param[in,out] coarse Coarse grid field to compute
  !> @param[in] fine Fine grid field to restrict
  !> @param[in] undf_c Total number of degrees of freedom on the coarse grid
  !> @param[in] dofmap_c Cell dofmap on the coarse grid
  !> @param[in] ndf Number of degrees of freedom per cell on both the coarse and
  !!                fine grid
  !> @param[in] undf_f Total number of degrees of freedom on the fine grid
  !> @param[in] dofmap_f Cell dofmap on the fine grid
  subroutine restrict_kernel_code(nlayers,         &
                                  cell_map,        &
                                  ncell_f_per_c_x, &
                                  ncell_f_per_c_y, &
                                  ncell_f,         &
                                  coarse,          &
                                  fine,            &
                                  undf_c,          &
                                  dofmap_c,        &
                                  ndf,             &
                                  undf_f,          &
                                  dofmap_f)

    implicit none

    integer(kind=i_def), intent(in) :: nlayers
    integer(kind=i_def), intent(in) :: ncell_f_per_c_x
    integer(kind=i_def), intent(in) :: ncell_f_per_c_y
    integer(kind=i_def), dimension(ncell_f_per_c_x, ncell_f_per_c_y), intent(in) :: cell_map
    integer(kind=i_def), intent(in) :: ncell_f
    integer(kind=i_def), intent(in) :: ndf
    integer(kind=i_def), dimension(ndf, ncell_f), intent(in) :: dofmap_f
    integer(kind=i_def), dimension(ndf), intent(in) :: dofmap_c
    integer(kind=i_def), intent(in) :: undf_f, undf_c
    real(kind=r_def), dimension(undf_c), intent(inout) :: coarse
    real(kind=r_def), dimension(undf_f), intent(in) :: fine

    integer(kind=i_def) :: df, k, lp_x, lp_y
    real(kind=r_def) :: denom

    denom = 1.0_r_def/real(ncell_f_per_c_x*ncell_f_per_c_y, kind=r_def)

    do k = 0, nlayers-1
      do df = 1, ndf
        coarse(dofmap_c(df) + k ) = 0.0_r_def
        do lp_y = 1, ncell_f_per_c_y
          do lp_x = 1, ncell_f_per_c_x
            coarse(dofmap_c(df) + k ) = coarse(dofmap_c(df) + k ) + &
                                        fine(dofmap_f(df,cell_map(lp_x,lp_y))+k)*denom
          end do
        end do
      end do
    end do

  end subroutine restrict_kernel_code

end module restrict_kernel_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
! LICENCE.original is available from the Met Office Science Repository Service:
! https://code.metoffice.gov.uk/trac/lfric/browser/LFRic/trunk/LICENCE.original
! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Modifications copyright (c) 2017-2020, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
!------------------------------------------------------------------------------
! Modified by I. Kavcic, Met Office

module oned_conservative_flux_alg_mod

  use constants_mod,                     only: r_def, i_def
  use field_mod,                         only: field_type
  use function_space_mod,                only: function_space_type
  use function_space_collection_mod,     only: function_space_collection
  use quadrature_mod,                    only: quadrature_type, GAUSSIAN
  use fs_continuity_mod,                 only: W0, W3
  use finite_element_config_mod,         only: element_order
  use subgrid_config_mod,                only: transport_stencil_length,       &
                                               rho_stencil_length

  implicit none

  private

  contains

  subroutine oned_conservative_flux_alg( direction,    &
                                         u,            &
                                         dep_pts,      &
                                         rho_in,       &
                                         mass_flux,    &
                                         mesh_id)

    use subgrid_coeffs_kernel_mod, only : subgrid_coeffs_kernel_type
    use conservative_flux_kernel_mod, only : conservative_flux_kernel_type

    implicit none

    integer(i_def),      intent(in)     :: direction
    type(field_type),    intent(in)     :: u
    type(field_type),    intent(in)     :: dep_pts
    type(field_type),    intent(in)     :: rho_in
    type(field_type),    intent(in)     :: mass_flux
    integer(i_def),      intent(in)     :: mesh_id

    type( field_type ) :: a0, a1, a2

    type(function_space_type), pointer :: rho_fs   => null()

    rho_fs => function_space_collection%get_fs( mesh_id, element_order,      &
                                              rho_in%which_function_space() )

    a0 = field_type( vector_space = rho_fs )
    a1 = field_type( vector_space = rho_fs )
    a2 = field_type( vector_space = rho_fs )

    call invoke(                                                                 &
                                                                                 &
        subgrid_coeffs_kernel_type(a0,a1,a2,rho_in,rho_stencil_length),          &
                                                                                 &
        conservative_flux_kernel_type(mass_flux,dep_pts,u,                       &
                                      rho_in,transport_stencil_length,direction, &
                                      a0,transport_stencil_length,direction,     &
                                      a1,transport_stencil_length,direction,     &
                                      a2,transport_stencil_length,direction)     &
               )

  end subroutine oned_conservative_flux_alg

end module oned_conservative_flux_alg_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2019-2022, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author A. R. Porter, STFC Daresbury Lab
! Modified I. Kavcic, Met Office
! Modified N. Nobre, STFC Daresbury Lab

module profile_psy_data_mod

  use iso_c_binding, only : C_CHAR, C_INT, C_INT16_T, C_INT64_T, C_PTR, &
       C_NULL_CHAR, C_LOC

  implicit none

  private

  !> The derived type passed to us from the profiled application. Required for
  !! consistency with the PSyclone Profiling interface and used here to
  !! store the colour assigned to a region and to prevent repeated string
  !! operations.
  type, public :: profile_PSyDataType
     !> Whether or not we've seen this region before
     logical :: initialised = .false.
     !> The colour assigned to this region
     integer :: colour_index = 1
     !> Name assigned to the region
     character(kind=C_CHAR, len=256) :: name = ""
  contains
      ! The profiling API uses only the two following calls:
      procedure :: PreStart
      procedure :: PostEnd
  end type profile_PSyDataType

  ! The colour index of the last region created.
  integer, save :: last_colour = 0

  !> The number of colours in the list.
  integer, parameter :: NUM_COLOURS = 7

  !> List of colours to use for different regions.
  integer :: col(NUM_COLOURS) = [ int(Z'0000ff00'), int(Z'000000ff'), int(Z'00ffff00'), &
                                  int(Z'00ff00ff'), int(Z'0000ffff'), int(Z'00ff0000'), &
                                  int(Z'00ffffff')]

  !> Holds the name of the region being created
  character(kind=C_CHAR, len=256), target :: tempName

  !> Struct passed into nvtxRangePushEx
  type, bind(C):: nvtxEventAttributes
     integer(C_INT16_T):: version=1
     integer(C_INT16_T):: size=48
     integer(C_INT):: category=0
     integer(C_INT):: colorType=1   !> NVTX_COLOR_ARGB = 1
     integer(C_INT):: color
     integer(C_INT):: payloadType=0 !> NVTX_PAYLOAD_UNKNOWN = 0
     integer(C_INT):: reserved0
     integer(C_INT64_T):: payload   !> union uint,int,double
     integer(C_INT):: messageType=1 !> NVTX_MESSAGE_TYPE_ASCII = 1
     type(C_PTR):: message          !> ASCII char
  end type nvtxEventAttributes

  interface nvtxRangePush
     ! Push range with custom label and standard colour
     subroutine nvtxRangePushA(name) bind(C, name='nvtxRangePushA')
       use iso_c_binding
       ! Have to use length of 1 because routine is BIND(C)
       character(kind=C_CHAR, len=1) :: name
     end subroutine nvtxRangePushA

     ! Push range with custom label and custom colour
     subroutine nvtxRangePushEx(event) bind(C, name='nvtxRangePushEx')
       use iso_c_binding
       import :: nvtxEventAttributes
       type(nvtxEventAttributes) :: event
     end subroutine nvtxRangePushEx
  end interface nvtxRangePush

  interface nvtxRangePop
     subroutine nvtxRangePop() bind(C, name='nvtxRangePop')
     end subroutine nvtxRangePop
  end interface nvtxRangePop

  ! Requires that the application be linked with CUDA (-Mcuda flag to
  ! PGI)
  interface cudaProfilerStart
     subroutine cudaProfilerStart() bind(C, name='cudaProfilerStart')
     end subroutine cudaProfilerStart
  end interface cudaProfilerStart

  ! Requires that the application be linked with CUDA (-Mcuda flag to
  ! PGI)
  interface cudaProfilerStop
     subroutine cudaProfilerStop() bind(C, name='cudaProfilerStop')
     end subroutine cudaProfilerStop
  end interface cudaProfilerStop

  ! Only the routines making up the PSyclone profiling API are public
  public profile_PSyDataInit, profile_PSyDataShutdown, &
       profile_PSyDataStart, profile_PSyDataStop

contains

  !> An optional initialisation subroutine. This is not used for the NVTX
  !! library.
  subroutine profile_PSyDataInit()
    implicit none
    return
  end subroutine profile_PSyDataInit

  !> Enables profiling (if it is not already enabled). May be manually added
  !! to source code in order to limit the amount of profiling performed at
  !! run time. Requires that the application be linked with CUDA (-Mcuda flag
  !! to PGI).
  subroutine profile_PSyDataStart()
    implicit none
    call cudaProfilerStart()
  end subroutine profile_PSyDataStart

  !> Turns off profiling. All subsequent calls to the profiling API
  !! will have no effect. Use in combination with profile_PSyDataStart() to
  !! limit the amount of profiling performed at runtime. Requires that the
  !! application be linked with CUDA (-Mcuda flag to PGI).
  subroutine profile_PSyDataStop()
    implicit none
    call cudaProfilerStop()
  end subroutine profile_PSyDataStop

  !> Starts a profiling area. The module and region name can be used to create
  !! a unique name for each region.
  !! Parameters:
  !! @param[in,out] this This PSyData instance.
  !! @param[in] module_name Name of the module in which the region is
  !! @param[in] region_name Name of the region (could be name of an invoke, or
  !!            subroutine name).
  !! @param[in] num_pre_vars The number of variables that are declared and
  !!            written before the instrumented region.
  !! @param[in] num_post_vars The number of variables that are also declared
  !!            before an instrumented region of code, but are written after
  !!            this region.
  subroutine PreStart(this, module_name, region_name, num_pre_vars, &
                      num_post_vars)

    implicit none

    class(profile_PSyDataType), target, intent(inout) :: this
    character(len=*), intent(in) :: module_name, region_name
    integer, intent(in) :: num_pre_vars, num_post_vars
    ! Locals
    type(nvtxEventAttributes) :: event

    if (.not. this%initialised) then
       ! This is the first time we've seen this region. Construct and
       ! save its name to save on future string operations.
       this%initialised = .true.

       ! Round-robin the colour of each region created.
       if (last_colour < NUM_COLOURS) then
          last_colour = last_colour + 1
       else
          last_colour = 1
       end if
       this%colour_index = last_colour

       this%name = trim(module_name)//":"//trim(region_name) &
                           &   //C_NULL_CHAR
    end if

    event%color = col(this%colour_index)

    event%message = c_loc(this%name)

    call nvtxRangePushEx(event)

  end subroutine PreStart

  !> Ends a profiling area.
  !! @param[in,out] this: Persistent data, not used in this case.
  subroutine PostEnd(this)

    implicit none

    class(profile_PSyDataType), target :: this

    call nvtxRangePop()

  end subroutine PostEnd

  !> The finalise function would normally print the results. However, this
  !> is unnecessary for the NVTX library so we do nothing.
  subroutine profile_PSyDataShutdown()
    implicit none
    return
  end subroutine profile_PSyDataShutdown

end module profile_psy_data_mod

program main_init
  use extract_psy_data_mod, only : extract_PsyDataType
  use init_field_mod, only : init_field_code
  integer :: i
  integer :: j
  integer :: a_fld_whole_ystart
  integer :: a_fld_whole_ystop
  integer :: a_fld_whole_xstart
  integer :: a_fld_whole_xstop
  real*8, allocatable, dimension(:,:) :: a_fld
  integer :: b_fld_whole_ystart
  integer :: b_fld_whole_ystop
  integer :: b_fld_whole_xstart
  integer :: b_fld_whole_xstop
  real*8, allocatable, dimension(:,:) :: b_fld
  integer :: c_fld_whole_ystart
  integer :: c_fld_whole_ystop
  integer :: c_fld_whole_xstart
  integer :: c_fld_whole_xstop
  real*8, allocatable, dimension(:,:) :: c_fld
  integer :: d_fld_whole_ystart
  integer :: d_fld_whole_ystop
  integer :: d_fld_whole_xstart
  integer :: d_fld_whole_xstop
  real*8, allocatable, dimension(:,:) :: d_fld
  type(extract_PsyDataType) :: extract_psy_data
  real*8, allocatable, dimension(:,:) :: a_fld_post
  real*8, allocatable, dimension(:,:) :: b_fld_post
  real*8, allocatable, dimension(:,:) :: c_fld_post
  real*8, allocatable, dimension(:,:) :: d_fld_post
  integer :: i_post
  integer :: j_post

  call extract_psy_data%OpenRead('main', 'init')
  call extract_psy_data%ReadVariable('a_fld_post', a_fld_post)
  ALLOCATE(a_fld(SIZE(a_fld_post, 1), SIZE(a_fld_post, 2)))
  a_fld = 0
  call extract_psy_data%ReadVariable('a_fld%whole%xstart', a_fld_whole_xstart)
  call extract_psy_data%ReadVariable('a_fld%whole%xstop', a_fld_whole_xstop)
  call extract_psy_data%ReadVariable('a_fld%whole%ystart', a_fld_whole_ystart)
  call extract_psy_data%ReadVariable('a_fld%whole%ystop', a_fld_whole_ystop)
  call extract_psy_data%ReadVariable('b_fld_post', b_fld_post)
  ALLOCATE(b_fld(SIZE(b_fld_post, 1), SIZE(b_fld_post, 2)))
  b_fld = 0
  call extract_psy_data%ReadVariable('b_fld%whole%xstart', b_fld_whole_xstart)
  call extract_psy_data%ReadVariable('b_fld%whole%xstop', b_fld_whole_xstop)
  call extract_psy_data%ReadVariable('b_fld%whole%ystart', b_fld_whole_ystart)
  call extract_psy_data%ReadVariable('b_fld%whole%ystop', b_fld_whole_ystop)
  call extract_psy_data%ReadVariable('c_fld_post', c_fld_post)
  ALLOCATE(c_fld(SIZE(c_fld_post, 1), SIZE(c_fld_post, 2)))
  c_fld = 0
  call extract_psy_data%ReadVariable('c_fld%whole%xstart', c_fld_whole_xstart)
  call extract_psy_data%ReadVariable('c_fld%whole%xstop', c_fld_whole_xstop)
  call extract_psy_data%ReadVariable('c_fld%whole%ystart', c_fld_whole_ystart)
  call extract_psy_data%ReadVariable('c_fld%whole%ystop', c_fld_whole_ystop)
  call extract_psy_data%ReadVariable('d_fld_post', d_fld_post)
  ALLOCATE(d_fld(SIZE(d_fld_post, 1), SIZE(d_fld_post, 2)))
  d_fld = 0
  call extract_psy_data%ReadVariable('d_fld%whole%xstart', d_fld_whole_xstart)
  call extract_psy_data%ReadVariable('d_fld%whole%xstop', d_fld_whole_xstop)
  call extract_psy_data%ReadVariable('d_fld%whole%ystart', d_fld_whole_ystart)
  call extract_psy_data%ReadVariable('d_fld%whole%ystop', d_fld_whole_ystop)
  call extract_psy_data%ReadVariable('i_post', i_post)
  i = 0
  call extract_psy_data%ReadVariable('j_post', j_post)
  j = 0
  do j = a_fld_whole_ystart, a_fld_whole_ystop, 1
    do i = a_fld_whole_xstart, a_fld_whole_xstop, 1
      call init_field_code(i, j, a_fld, 1.0)
    enddo
  enddo
  do j = b_fld_whole_ystart, b_fld_whole_ystop, 1
    do i = b_fld_whole_xstart, b_fld_whole_xstop, 1
      call init_field_code(i, j, b_fld, 2.0)
    enddo
  enddo
  do j = c_fld_whole_ystart, c_fld_whole_ystop, 1
    do i = c_fld_whole_xstart, c_fld_whole_xstop, 1
      call init_field_code(i, j, c_fld, 3.0)
    enddo
  enddo
  do j = d_fld_whole_ystart, d_fld_whole_ystop, 1
    do i = d_fld_whole_xstart, d_fld_whole_xstop, 1
      call init_field_code(i, j, d_fld, 4.0)
    enddo
  enddo
  if (ALL(a_fld - a_fld_post == 0.0)) then
    PRINT *, "a_fld correct"
  else
    PRINT *, "a_fld incorrect. Values are:"
    PRINT *, a_fld
    PRINT *, "a_fld values should be:"
    PRINT *, a_fld_post
  end if
  if (ALL(b_fld - b_fld_post == 0.0)) then
    PRINT *, "b_fld correct"
  else
    PRINT *, "b_fld incorrect. Values are:"
    PRINT *, b_fld
    PRINT *, "b_fld values should be:"
    PRINT *, b_fld_post
  end if
  if (ALL(c_fld - c_fld_post == 0.0)) then
    PRINT *, "c_fld correct"
  else
    PRINT *, "c_fld incorrect. Values are:"
    PRINT *, c_fld
    PRINT *, "c_fld values should be:"
    PRINT *, c_fld_post
  end if
  if (ALL(d_fld - d_fld_post == 0.0)) then
    PRINT *, "d_fld correct"
  else
    PRINT *, "d_fld incorrect. Values are:"
    PRINT *, d_fld
    PRINT *, "d_fld values should be:"
    PRINT *, d_fld_post
  end if
  if (i == i_post) then
    PRINT *, "i correct"
  else
    PRINT *, "i incorrect. Values are:"
    PRINT *, i
    PRINT *, "i values should be:"
    PRINT *, i_post
  end if
  if (j == j_post) then
    PRINT *, "j correct"
  else
    PRINT *, "j incorrect. Values are:"
    PRINT *, j
    PRINT *, "j values should be:"
    PRINT *, j_post
  end if

end program main_init

module compute_vnew_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod
  use field_mod
  implicit none

  private

  public invoke_compute_vnew
  public compute_vnew, compute_vnew_code

  TYPE, EXTENDS(kernel_type) :: compute_vnew
     TYPE(go_arg), DIMENSION(7) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_CV, GO_POINTWISE),        & ! vnew
             go_arg(GO_READ,  GO_CV, GO_POINTWISE),        & ! vold
             go_arg(GO_READ,  GO_CF, GO_STENCIL(000,011,000)),        & ! z
             go_arg(GO_READ,  GO_CU, GO_STENCIL(000,011,011)),        & ! cu
             go_arg(GO_READ,  GO_CT, GO_STENCIL(000,010,010)),        & ! h
             go_arg(GO_READ,  GO_R_SCALAR, GO_POINTWISE),  & ! tdt
             go_arg(GO_READ,  GO_GRID_DY_CONST)         & ! dy
           /)
     !> This kernel operates on fields that live on an
     !! orthogonal, regular grid.
     integer :: GRID_TYPE = GO_ORTHOGONAL_REGULAR

     !> We only have one value per grid point and that means
     !! we have a single DOF per grid point.
     INTEGER :: ITERATES_OVER = GO_INTERNAL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  CONTAINS
    procedure, nopass :: code => compute_vnew_code
  END TYPE compute_vnew

CONTAINS

  !===================================================

  subroutine invoke_compute_vnew(vnew, vold, z, cu, h, tdt)
    implicit none
    type(r2d_field), intent(inout) :: vnew
    type(r2d_field), intent(in)    :: vold, z, cu, h
    real(go_wp), intent(in) :: tdt
    ! Locals
    integer :: I, J
    real(go_wp) :: dy

    ! Note that we do not loop over the full extent of the field.
    ! Fields are allocated with extents (M+1,N+1).
    ! Presumably the extra row and column are needed for periodic BCs.
    ! We are updating a quantity on CU.
    ! This loop writes to vnew(1:M,2:N+1) so this looks like
    ! (using x to indicate a location that is written):
    !
    ! i=1   i=M
    !  x  x  x  o 
    !  x  x  x  o   j=N
    !  x  x  x  o
    !  o  o  o  o   j=1

    ! Original code looked like:
    !
    ! DO J=1,N
    !   DO I=1,M
    !     VNEW(I,J+1) = VOLD(I,J+1)-TDTS8*(Z(I+1,J+1)+Z(I,J+1)) & 
    !         *(CU(I+1,J+1)+CU(I,J+1)+CU(I,J)+CU(I+1,J))        & 
    !         -TDTSDY*(H(I,J+1)-H(I,J))
    !   END DO
    ! END DO

    ! vnew(i,j) depends upon:
    !   vold(i,j)                                : CV
    !   z(i+1,j), z(i,j)                         : CF
    !    => lateral CF neighbours of the CV pt being updated
    !   cu(i,j), cu(i+1,j),cu(i,j-1),cu(i+1,j-1) : CU
    !    => all CU neighbours of the CV pt being updated 
    !   h(i,j),   h(i,j-1)                       : CT
    !    =>  vertical CT neighbours of the CV pt being updated

    !   x-------x-------fi+1j+1
    !   |       |       |
    !   |       |       |
    !   uij-----Tij-----ui+1j
    !   |       |       |
    !   |       |       |
    !   fij-----vij-----fi+1j
    !   |       |       |
    !   |       |       |
    !   uij-1- -Tij-1---ui+1j-1
    !

    dy = vnew%grid%dy

    DO J=vnew%internal%ystart, vnew%internal%ystop, 1
       DO I=vnew%internal%xstart, vnew%internal%xstop, 1

          CALL compute_vnew_code(i, j, &
                                 vnew%data, vold%data, &
                                 z%data, cu%data, h%data, tdt, dy)
       END DO
    END DO

  END SUBROUTINE invoke_compute_vnew

  !===================================================

  subroutine compute_vnew_code(i, j, &
                               vnew, vold, z, cu, h, tdt, dy)
    implicit none
    integer,  intent(in) :: I, J
    real(go_wp), intent(in) :: dy
    REAL(go_wp), intent(out), DIMENSION(:,:) :: vnew
    REAL(go_wp), intent(in),  DIMENSION(:,:) :: vold, z, cu, h
    REAL(go_wp), intent(in) :: tdt
    ! Locals
    REAL(go_wp) :: tdts8, tdtsdy

    !> These quantities are computed here because tdt is not
    !! constant. (It is == dt for first time step, 2xdt for
    !! all remaining time steps.)
    tdts8 = tdt/8.0d0
    tdtsdy = tdt/dy

    VNEW(I,J) = VOLD(I,J)- &
                TDTS8*(Z(I+1,J)+Z(I,J)) & 
                *(CU(I+1,J)+CU(I,J)+CU(I,J-1)+CU(I+1,J-1)) & 
                 -TDTSDY*(H(I,J)-H(I,J-1))

  END SUBROUTINE compute_vnew_code

END MODULE compute_vnew_mod

! ================================================== !
! THIS FILE IS CREATED FROM THE JINJA TEMPLATE FILE  !
! DO NOT MODIFY DIRECTLY                             !
! ================================================== !





! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office

!> This module implements a PSyData-based verification that floating point
!! input and output parameters are not NAN and not infinite.
!!

module nan_test_base_mod

    use, intrinsic :: iso_fortran_env, only : int64, int32,   &
                                              real32, real64, &
                                              stderr => Error_Unit
    use psy_data_base_mod, only : PSyDataBaseType, &
        nan_test_PSyDataShutdown, &
        nan_test_PSyDataInit, is_enabled, &
        nan_test_PSyDataStart, nan_test_PSyDataStop

    implicit none

    type, extends(PSyDataBaseType), public :: NANTestBaseType

    contains

        ! The various procedures used

        procedure :: ProvideScalarReal
        procedure :: ProvideArray1dReal
        procedure :: ProvideArray2dReal
        procedure :: ProvideArray3dReal
        procedure :: ProvideArray4dReal
        procedure :: ProvideScalarInt
        procedure :: ProvideArray1dInt
        procedure :: ProvideArray2dInt
        procedure :: ProvideArray3dInt
        procedure :: ProvideArray4dInt
        procedure :: ProvideScalarDouble
        procedure :: ProvideArray1dDouble
        procedure :: ProvideArray2dDouble
        procedure :: ProvideArray3dDouble
        procedure :: ProvideArray4dDouble

        !> The generic interface for providing the value of variables:
        generic, public :: ProvideVariable => &
            ProvideScalarReal, &
            ProvideArray1dReal, &
            ProvideArray2dReal, &
            ProvideArray3dReal, &
            ProvideArray4dReal, &
            ProvideScalarInt, &
            ProvideArray1dInt, &
            ProvideArray2dInt, &
            ProvideArray3dInt, &
            ProvideArray4dInt, &
            ProvideScalarDouble, &
            ProvideArray1dDouble, &
            ProvideArray2dDouble, &
            ProvideArray3dDouble, &
            ProvideArray4dDouble

    end type NANTestBaseType

contains

    ! =========================================================================
    ! Jinja created code.
    ! =========================================================================


    ! =========================================================================
    ! Implementation for all real(kind=real32) types
    ! =========================================================================
    ! -------------------------------------------------------------------------
    !> This subroutine checks if a floating point value is NAN or infinite
    !! using the IEEE_IS_FINIT function (and does nothing for integer types).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarReal(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in)                      :: name
        real(kind=real32), intent(in)                          :: value

        if (.not. is_enabled) return

        if (IEEE_SUPPORT_DATATYPE(value)) then
            if (.not. IEEE_IS_FINITE(value)) then
                write(stderr, '(8G0)') "PSyData: Variable ", name," has invalid value ", &
                                 value, " in module '", trim(this%module_name), &
                                 "' region '", trim(this%region_name),"'."
            endif
        endif

        call this%PSyDataBaseType%ProvideScalarReal(name, value)

    end subroutine ProvideScalarReal



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray1dReal(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), dimension(:), intent(in) :: value

        integer :: i1

        if (.not. is_enabled) return
        if (IEEE_SUPPORT_DATATYPE(value)) then
            do i1=1, size(value, 1)
               if (.not. IEEE_IS_FINITE(value(i1))) then
                   write(stderr, '(5G0,1(G0,X),5G0)') "PSyData: Variable ", &
                                    name," has the invalid value ", &
                                    value(i1), " at index/indices ", i1, &
                                    "in module '", trim(this%module_name), &
                                    "' region '", trim(this%region_name),"'."
               endif
            enddo
        endif

        call this%PSyDataBaseType%ProvideArray1dReal(name, value)

    end subroutine ProvideArray1dReal



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dReal(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), dimension(:,:), intent(in) :: value

        integer :: i1, i2

        if (.not. is_enabled) return
        if (IEEE_SUPPORT_DATATYPE(value)) then
            do i2=1, size(value, 2)
               do i1=1, size(value, 1)
                  if (.not. IEEE_IS_FINITE(value(i1, i2))) then
                      write(stderr, '(5G0,2(G0,X),5G0)') "PSyData: Variable ", &
                                       name," has the invalid value ", &
                                       value(i1, i2), " at index/indices ", i1, i2, &
                                       "in module '", trim(this%module_name), &
                                       "' region '", trim(this%region_name),"'."
                  endif
               enddo
            enddo
        endif

        call this%PSyDataBaseType%ProvideArray2dReal(name, value)

    end subroutine ProvideArray2dReal



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray3dReal(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), dimension(:,:,:), intent(in) :: value

        integer :: i1, i2, i3

        if (.not. is_enabled) return
        if (IEEE_SUPPORT_DATATYPE(value)) then
            do i3=1, size(value, 3)
               do i2=1, size(value, 2)
                  do i1=1, size(value, 1)
                     if (.not. IEEE_IS_FINITE(value(i1, i2, i3))) then
                         write(stderr, '(5G0,3(G0,X),5G0)') "PSyData: Variable ", &
                                          name," has the invalid value ", &
                                          value(i1, i2, i3), " at index/indices ", i1, i2, i3, &
                                          "in module '", trim(this%module_name), &
                                          "' region '", trim(this%region_name),"'."
                     endif
                  enddo
               enddo
            enddo
        endif

        call this%PSyDataBaseType%ProvideArray3dReal(name, value)

    end subroutine ProvideArray3dReal



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray4dReal(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real32), dimension(:,:,:,:), intent(in) :: value

        integer :: i1, i2, i3, i4

        if (.not. is_enabled) return
        if (IEEE_SUPPORT_DATATYPE(value)) then
            do i4=1, size(value, 4)
               do i3=1, size(value, 3)
                  do i2=1, size(value, 2)
                     do i1=1, size(value, 1)
                        if (.not. IEEE_IS_FINITE(value(i1, i2, i3, i4))) then
                            write(stderr, '(5G0,4(G0,X),5G0)') "PSyData: Variable ", &
                                             name," has the invalid value ", &
                                             value(i1, i2, i3, i4), " at index/indices ", i1, i2, i3, i4, &
                                             "in module '", trim(this%module_name), &
                                             "' region '", trim(this%region_name),"'."
                        endif
                     enddo
                  enddo
               enddo
            enddo
        endif

        call this%PSyDataBaseType%ProvideArray4dReal(name, value)

    end subroutine ProvideArray4dReal


    ! =========================================================================
    ! Implementation for all integer(kind=int32) types
    ! =========================================================================
    ! -------------------------------------------------------------------------
    !> This subroutine checks if a floating point value is NAN or infinite
    !! using the IEEE_IS_FINIT function (and does nothing for integer types).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarInt(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in)                      :: name
        integer(kind=int32), intent(in)                          :: value

        ! Variables of type integer(kind=int32) do not have NANs
        ! So nothing to do here.

        call this%PSyDataBaseType%ProvideScalarInt(name, value)

    end subroutine ProvideScalarInt



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray1dInt(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), dimension(:), intent(in) :: value

        ! Variables of type integer(kind=int32) do not have NANs
        ! So nothing to do here.

        call this%PSyDataBaseType%ProvideArray1dInt(name, value)

    end subroutine ProvideArray1dInt



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dInt(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), dimension(:,:), intent(in) :: value

        ! Variables of type integer(kind=int32) do not have NANs
        ! So nothing to do here.

        call this%PSyDataBaseType%ProvideArray2dInt(name, value)

    end subroutine ProvideArray2dInt



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray3dInt(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), dimension(:,:,:), intent(in) :: value

        ! Variables of type integer(kind=int32) do not have NANs
        ! So nothing to do here.

        call this%PSyDataBaseType%ProvideArray3dInt(name, value)

    end subroutine ProvideArray3dInt



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray4dInt(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        integer(kind=int32), dimension(:,:,:,:), intent(in) :: value

        ! Variables of type integer(kind=int32) do not have NANs
        ! So nothing to do here.

        call this%PSyDataBaseType%ProvideArray4dInt(name, value)

    end subroutine ProvideArray4dInt


    ! =========================================================================
    ! Implementation for all real(kind=real64) types
    ! =========================================================================
    ! -------------------------------------------------------------------------
    !> This subroutine checks if a floating point value is NAN or infinite
    !! using the IEEE_IS_FINIT function (and does nothing for integer types).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideScalarDouble(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in)                      :: name
        real(kind=real64), intent(in)                          :: value

        if (.not. is_enabled) return

        if (IEEE_SUPPORT_DATATYPE(value)) then
            if (.not. IEEE_IS_FINITE(value)) then
                write(stderr, '(8G0)') "PSyData: Variable ", name," has invalid value ", &
                                 value, " in module '", trim(this%module_name), &
                                 "' region '", trim(this%region_name),"'."
            endif
        endif

        call this%PSyDataBaseType%ProvideScalarDouble(name, value)

    end subroutine ProvideScalarDouble



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray1dDouble(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), dimension(:), intent(in) :: value

        integer :: i1

        if (.not. is_enabled) return
        if (IEEE_SUPPORT_DATATYPE(value)) then
            do i1=1, size(value, 1)
               if (.not. IEEE_IS_FINITE(value(i1))) then
                   write(stderr, '(5G0,1(G0,X),5G0)') "PSyData: Variable ", &
                                    name," has the invalid value ", &
                                    value(i1), " at index/indices ", i1, &
                                    "in module '", trim(this%module_name), &
                                    "' region '", trim(this%region_name),"'."
               endif
            enddo
        endif

        call this%PSyDataBaseType%ProvideArray1dDouble(name, value)

    end subroutine ProvideArray1dDouble



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray2dDouble(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), dimension(:,:), intent(in) :: value

        integer :: i1, i2

        if (.not. is_enabled) return
        if (IEEE_SUPPORT_DATATYPE(value)) then
            do i2=1, size(value, 2)
               do i1=1, size(value, 1)
                  if (.not. IEEE_IS_FINITE(value(i1, i2))) then
                      write(stderr, '(5G0,2(G0,X),5G0)') "PSyData: Variable ", &
                                       name," has the invalid value ", &
                                       value(i1, i2), " at index/indices ", i1, i2, &
                                       "in module '", trim(this%module_name), &
                                       "' region '", trim(this%region_name),"'."
                  endif
               enddo
            enddo
        endif

        call this%PSyDataBaseType%ProvideArray2dDouble(name, value)

    end subroutine ProvideArray2dDouble



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray3dDouble(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), dimension(:,:,:), intent(in) :: value

        integer :: i1, i2, i3

        if (.not. is_enabled) return
        if (IEEE_SUPPORT_DATATYPE(value)) then
            do i3=1, size(value, 3)
               do i2=1, size(value, 2)
                  do i1=1, size(value, 1)
                     if (.not. IEEE_IS_FINITE(value(i1, i2, i3))) then
                         write(stderr, '(5G0,3(G0,X),5G0)') "PSyData: Variable ", &
                                          name," has the invalid value ", &
                                          value(i1, i2, i3), " at index/indices ", i1, i2, i3, &
                                          "in module '", trim(this%module_name), &
                                          "' region '", trim(this%region_name),"'."
                     endif
                  enddo
               enddo
            enddo
        endif

        call this%PSyDataBaseType%ProvideArray3dDouble(name, value)

    end subroutine ProvideArray3dDouble



    ! -------------------------------------------------------------------------
    !> This method checks if an array contains NAN or infinite IEEE values (it
    !! does nothing in case that the array is an integer type).
    !! @param[in,out] this The instance of the NANTestBaseType.
    !! @param[in] name The name of the variable (string).
    !! @param[in] value The value of the variable.
    subroutine ProvideArray4dDouble(this, name, value)

        use, intrinsic :: ieee_arithmetic

        implicit none

        class(NANTestBaseType), intent(inout), target :: this
        character(*), intent(in) :: name
        real(kind=real64), dimension(:,:,:,:), intent(in) :: value

        integer :: i1, i2, i3, i4

        if (.not. is_enabled) return
        if (IEEE_SUPPORT_DATATYPE(value)) then
            do i4=1, size(value, 4)
               do i3=1, size(value, 3)
                  do i2=1, size(value, 2)
                     do i1=1, size(value, 1)
                        if (.not. IEEE_IS_FINITE(value(i1, i2, i3, i4))) then
                            write(stderr, '(5G0,4(G0,X),5G0)') "PSyData: Variable ", &
                                             name," has the invalid value ", &
                                             value(i1, i2, i3, i4), " at index/indices ", i1, i2, i3, i4, &
                                             "in module '", trim(this%module_name), &
                                             "' region '", trim(this%region_name),"'."
                        endif
                     enddo
                  enddo
               enddo
            enddo
        endif

        call this%PSyDataBaseType%ProvideArray4dDouble(name, value)

    end subroutine ProvideArray4dDouble


    ! -------------------------------------------------------------------------

end module nan_test_base_mod

   !!=====================================================================================
   !! ***  traadv kernel extracted from the NEMO software (http://www.nemo-ocean.eu ) ***
   !! ***          governed by the CeCILL licence (http://www.cecill.info)            ***
   !!                                                   
   !! ***                             IS-ENES2 - CMCC/STFC                            ***
   !!=====================================================================================
PROGRAM tra_adv
   USE iso_c_binding, only: C_INT64_T
   ! The below should be e.g. wp = KIND(1.0d0) but PSyclone does not support
   ! the KIND intrinsic yet: TODO #585.
   INTEGER, PARAMETER :: wp = 8
   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) :: t3sn, t3ns, t3ew, t3we
   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)   :: tsn 
   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)   :: pun, pvn, pwn
   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)   :: mydomain, zslpx, zslpy, zwx, zwy, umask, vmask, tmask, zind
   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)     :: ztfreez, rnfmsk, upsmsk
   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:)       :: rnfmsk_z
   REAL(wp) :: zice, zu, z0u, zzwx, zv, z0v, zzwy, ztra, zbtr, zdt, zalpha
   REAL(wp) :: r
   REAL(wp) :: zw, z0w
   INTEGER  :: jpi, jpj, jpk, ji, jj, jk, jt
   ! TODO #588 it would be more natural to do INTEGER*8 here but PSyclone does
   ! not yet support such syntax.
   INTEGER(KIND=C_INT64_T) :: it
   CHARACTER(len=10) :: env

   CALL get_environment_variable("JPI", env)
   READ ( env, '(i10)' ) jpi
   CALL get_environment_variable("JPJ", env)
   READ ( env, '(i10)' ) jpj
   CALL get_environment_variable("JPK", env)
   READ ( env, '(i10)' ) jpk
   CALL get_environment_variable("IT", env)
   READ ( env, '(i10)' ) it

   ! Initialisation

   ALLOCATE( mydomain (jpi,jpj,jpk))
   ALLOCATE( zwx (jpi,jpj,jpk))
   ALLOCATE( zwy (jpi,jpj,jpk))
   ALLOCATE( zslpx (jpi,jpj,jpk))
   ALLOCATE( zslpy (jpi,jpj,jpk))
   ALLOCATE( pun (jpi,jpj,jpk))
   ALLOCATE( pvn (jpi,jpj,jpk))
   ALLOCATE( pwn (jpi,jpj,jpk))
   ALLOCATE( umask (jpi,jpj,jpk))
   ALLOCATE( vmask (jpi,jpj,jpk))
   ALLOCATE( tmask (jpi,jpj,jpk))
   ALLOCATE( zind (jpi,jpj,jpk))
   ALLOCATE( ztfreez (jpi,jpj))
   ALLOCATE( rnfmsk (jpi,jpj))
   ALLOCATE( upsmsk (jpi,jpj))
   ALLOCATE( rnfmsk_z (jpk))
   ALLOCATE( tsn(jpi,jpj,jpk))

! arrays initialization

   r = jpi*jpj*jpk

   ! the following three lines can be uncommented to randomize arrays initialization
   !call random_seed()
   !call random_number(r)
   !r = r*jpi*jpj*jpk

   DO jk = 1, jpk
      DO jj = 1, jpj
          DO ji = 1, jpi
              umask(ji,jj,jk) = ji*jj*jk/r
              mydomain(ji,jj,jk) =ji*jj*jk/r
              pun(ji,jj,jk) =ji*jj*jk/r
              pvn(ji,jj,jk) =ji*jj*jk/r
              pwn(ji,jj,jk) =ji*jj*jk/r
              vmask(ji,jj,jk)= ji*jj*jk/r
              tsn(ji,jj,jk)= ji*jj*jk/r
              tmask(ji,jj,jk)= ji*jj*jk/r
          END DO
      END DO
   END DO

   r = jpi*jpj
   DO jj=1, jpj
      DO ji=1, jpi
         ztfreez(ji,jj) = ji*jj/r
         upsmsk(ji,jj) = ji*jj/r
         rnfmsk(ji,jj) = ji*jj/r
      END DO
   END DO

   DO jk=1, jpk
      rnfmsk_z(jk)=jk/jpk
   END DO

!***********************
!* Start of the symphony
!***********************
   DO jt = 1, it
      DO jk = 1, jpk
         DO jj = 1, jpj
            DO ji = 1, jpi
               IF( tsn(ji,jj,jk) <= ztfreez(ji,jj) + 0.1d0 ) THEN   ;   zice = 1.d0
               ELSE                                                 ;   zice = 0.d0
               ENDIF
               zind(ji,jj,jk) = MAX (   &
                   rnfmsk(ji,jj) * rnfmsk_z(jk),      & 
                   upsmsk(ji,jj)               ,      &
                   zice                               &
                   &                  ) * tmask(ji,jj,jk)
                   zind(ji,jj,jk) = 1 - zind(ji,jj,jk)
            END DO
         END DO
      END DO

      zwx(:,:,jpk) = 0.e0   ;   zwy(:,:,jpk) = 0.e0

      DO jk = 1, jpk-1
         DO jj = 1, jpj-1
            DO ji = 1, jpi-1
               zwx(ji,jj,jk) = umask(ji,jj,jk) * ( mydomain(ji+1,jj,jk) - mydomain(ji,jj,jk) )
               zwy(ji,jj,jk) = vmask(ji,jj,jk) * ( mydomain(ji,jj+1,jk) - mydomain(ji,jj,jk) )
            END DO
         END DO
      END DO

      zslpx(:,:,jpk) = 0.e0   ;   zslpy(:,:,jpk) = 0.e0 

      DO jk = 1, jpk-1
         DO jj = 2, jpj
            DO ji = 2, jpi 
               zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji-1,jj  ,jk) )   &
               &            * ( 0.25d0 + SIGN( 0.25d0, zwx(ji,jj,jk) * zwx(ji-1,jj  ,jk) ) )
               zslpy(ji,jj,jk) =                    ( zwy(ji,jj,jk) + zwy(ji  ,jj-1,jk) )   &
               &            * ( 0.25d0 + SIGN( 0.25d0, zwy(ji,jj,jk) * zwy(ji  ,jj-1,jk) ) )
            END DO
         END DO
      END DO

      DO jk = 1, jpk-1    
         DO jj = 2, jpj
            DO ji = 2, jpi
               zslpx(ji,jj,jk) = SIGN( 1.d0, zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
               &                                                2.d0*ABS( zwx  (ji-1,jj,jk) ),   &
               &                                                2.d0*ABS( zwx  (ji  ,jj,jk) ) )
               zslpy(ji,jj,jk) = SIGN( 1.d0, zslpy(ji,jj,jk) ) * MIN(    ABS( zslpy(ji,jj  ,jk) ),   &
               &                                                2.d0*ABS( zwy  (ji,jj-1,jk) ),   &
               &                                                2.d0*ABS( zwy  (ji,jj  ,jk) ) )
            END DO
         END DO
      END DO 

      DO jk = 1, jpk-1
         zdt  = 1
         DO jj = 2, jpj-1
            DO ji = 2, jpi-1
               z0u = SIGN( 0.5d0, pun(ji,jj,jk) )
               zalpha = 0.5d0 - z0u
               zu  = z0u - 0.5d0 * pun(ji,jj,jk) * zdt

               zzwx = mydomain(ji+1,jj,jk) + zind(ji,jj,jk) * (zu * zslpx(ji+1,jj,jk))
               zzwy = mydomain(ji  ,jj,jk) + zind(ji,jj,jk) * (zu * zslpx(ji  ,jj,jk))

               zwx(ji,jj,jk) = pun(ji,jj,jk) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
                
               z0v = SIGN( 0.5d0, pvn(ji,jj,jk) )
               zalpha = 0.5d0 - z0v
               zv  = z0v - 0.5d0 * pvn(ji,jj,jk) * zdt

               zzwx = mydomain(ji,jj+1,jk) + zind(ji,jj,jk) * (zv * zslpy(ji,jj+1,jk))
               zzwy = mydomain(ji,jj  ,jk) + zind(ji,jj,jk) * (zv * zslpy(ji,jj  ,jk))

               zwy(ji,jj,jk) = pvn(ji,jj,jk) * ( zalpha * zzwx + (1.d0-zalpha) * zzwy )
            END DO
         END DO
      END DO

      DO jk = 1, jpk-1
         DO jj = 2, jpj-1     
            DO ji = 2, jpi-1
               zbtr = 1.
               ztra = - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
               &               + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  ) )
               mydomain(ji,jj,jk) = mydomain(ji,jj,jk) + ztra
            END DO
         END DO
      END DO

      zwx (:,:, 1 ) = 0.e0    ;    zwx (:,:,jpk) = 0.e0

      DO jk = 2, jpk-1   
         zwx(:,:,jk) = tmask(:,:,jk) * ( mydomain(:,:,jk-1) - mydomain(:,:,jk) )
      END DO

      zslpx(:,:,1) = 0.e0

      DO jk = 2, jpk-1    
         DO jj = 1, jpj
            DO ji = 1, jpi
               zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji,jj,jk+1) )   &
               &            * ( 0.25d0 + SIGN( 0.25d0, zwx(ji,jj,jk) * zwx(ji,jj,jk+1) ) )
            END DO
         END DO
      END DO

      DO jk = 2, jpk-1     
         DO jj = 1, jpj
            DO ji = 1, jpi
               zslpx(ji,jj,jk) = SIGN( 1.d0, zslpx(ji,jj,jk) ) * MIN( ABS( zslpx(ji,jj,jk  ) ), &
               &                                               2.d0*ABS( zwx  (ji,jj,jk+1) ),   &
               &                                               2.d0*ABS( zwx  (ji,jj,jk  ) )  )
            END DO
         END DO
      END DO

      zwx(:,:, 1 ) = pwn(:,:,1) * mydomain(:,:,1)

      zdt  = 1
      zbtr = 1.
      DO jk = 1, jpk-1
         DO jj = 2, jpj-1     
            DO ji = 2, jpi-1
               z0w = SIGN( 0.5d0, pwn(ji,jj,jk+1) )
               zalpha = 0.5d0 + z0w
               zw  = z0w - 0.5d0 * pwn(ji,jj,jk+1) * zdt * zbtr

               zzwx = mydomain(ji,jj,jk+1) + zind(ji,jj,jk) * (zw * zslpx(ji,jj,jk+1))
               zzwy = mydomain(ji,jj,jk  ) + zind(ji,jj,jk) * (zw * zslpx(ji,jj,jk  ))

               zwx(ji,jj,jk+1) = pwn(ji,jj,jk+1) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
            END DO
         END DO
      END DO

      zbtr = 1.
      DO jk = 1, jpk-1
         DO jj = 2, jpj-1     
            DO ji = 2, jpi-1
               ztra = - zbtr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )
               mydomain(ji,jj,jk) = ztra
            END DO
         END DO
      END DO
   END DO

   OPEN(unit = 4, file = 'output.dat', form='formatted')
  
   DO jk = 1, jpk-1
      DO jj = 2, jpj-1
         DO ji = 2, jpi-1
            write(4,*) mydomain(ji,jj,jk)
         END DO
      END DO
   END DO

   CLOSE(4)

   DEALLOCATE( mydomain )
   DEALLOCATE( zwx )
   DEALLOCATE( zwy )
   DEALLOCATE( zslpx )
   DEALLOCATE( zslpy )
   DEALLOCATE( pun )
   DEALLOCATE( pvn )
   DEALLOCATE( pwn )
   DEALLOCATE( umask)
   DEALLOCATE( vmask)
   DEALLOCATE( tmask)
   DEALLOCATE( zind )
   DEALLOCATE( ztfreez )
   DEALLOCATE( rnfmsk)
   DEALLOCATE( upsmsk)
   DEALLOCATE( rnfmsk_z)
   DEALLOCATE( tsn)

END PROGRAM tra_adv

module time_smooth_mod
  use kind_params_mod
  use grid_mod
  use field_mod
  use kernel_mod
  use argument_mod
  IMPLICIT none

  PRIVATE

  PUBLIC time_smooth_init, invoke_time_smooth
  PUBLIC time_smooth, time_smooth_code

  !> Parameter for time smoothing
  REAL(go_wp), save :: alpha

  !> The time smoothing operates in time rather than space
  !! and therefore takes three fields defined on any one
  !! of the four grid point types (T, U, V or Q).
  !! Presumably FE should be FD for us and maybe CELLS 
  !! should be COLUMNS?
  TYPE, EXTENDS(kernel_type) :: time_smooth
     TYPE(go_arg), DIMENSION(3) :: meta_args = &
          (/ go_arg(GO_READ, GO_EVERY, GO_POINTWISE),     &
             go_arg(GO_READ, GO_EVERY, GO_POINTWISE),     &
             go_arg(GO_READWRITE , GO_EVERY, GO_POINTWISE)      &
           /)

     !> This kernel writes only to internal points of the
     !! simulation domain.
     INTEGER :: ITERATES_OVER = GO_INTERNAL_PTS
  
     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel is independent of this choice (because it
     !! acts in time rather than space).
     integer :: index_offset = GO_OFFSET_ANY

  CONTAINS
    procedure, nopass :: code => time_smooth_code
  END type time_smooth

CONTAINS

  !===================================================

  !> Initialise the time-smoothing module. Sets parameter
  !! alpha that is used in the time-smooth kernel.
  SUBROUTINE time_smooth_init(alpha_tmp)
    IMPLICIT none
    REAL(go_wp), INTENT(in) :: alpha_tmp

    alpha = alpha_tmp

  END SUBROUTINE time_smooth_init

  !===================================================

  !> Manual implementation of code to invoke the time-smoothing
  !! kernel
  subroutine invoke_time_smooth(field, field_new, field_old)
    implicit none
    type(r2d_field), intent(in)    :: field
    type(r2d_field), intent(in)    :: field_new
    type(r2d_field), intent(inout) :: field_old
    ! Locals
    integer :: i, j
    integer :: idim1, idim2
    
    ! Here we will query what should be field objects to get at
    ! raw data.
    idim1 = SIZE(field%data, 1)
    idim2 = SIZE(field%data, 2)

    ! Loop over 'columns'
    DO J=1,idim2
      DO I=1,idim1
         CALL time_smooth_code(i, j, &
                               field%data, field_new%data, field_old%data)
      END DO
    END DO

  end subroutine invoke_time_smooth

  !===================================================

  !> Kernel to smooth supplied field in time
  SUBROUTINE time_smooth_code(i, j, field, field_new, field_old)
    IMPLICIT none
    INTEGER,  INTENT(in)                    :: i, j
    REAL(go_wp), INTENT(in),    DIMENSION(:,:) :: field
    REAL(go_wp), INTENT(in),    DIMENSION(:,:) :: field_new
    REAL(go_wp), INTENT(inout), DIMENSION(:,:) :: field_old

    field_old(i,j) = field(i,j) + &
         alpha*(field_new(i,j) - 2.0d0*field(i,j) + field_old(i,j))

  END SUBROUTINE time_smooth_code

END MODULE time_smooth_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2020, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: J. Henrichs, Bureau of Meteorology

!> This module contains a simple 'update' kernel that
!! overwrites a read-only declared field and a scalar
!! read-only value. This is done by computing the address
!! differences between an array and the value to be
!! overwritten, then using out-of-bounds array accesses
!! to change the values of parameters that are `intent(in)`.
!! Be warned, very hacky code to trigger the problem!
!! If array-bounds-checking is enabled these accesses will
!! be flagged.

module update_field_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod, only: GO_OFFSET_SW
  implicit none

  type, extends(kernel_type) :: update_field
     type(go_arg), dimension(8) :: meta_args =             &
          (/ go_arg(GO_READWRITE, GO_CT,       GO_POINTWISE),  & ! field
             go_arg(GO_READ,      GO_CT,       GO_POINTWISE),  & ! field
             go_arg(GO_READ,      GO_CT,       GO_POINTWISE),  & ! field
             go_arg(GO_READ,      GO_CT,       GO_POINTWISE),  & ! field
             go_arg(GO_READWRITE, GO_R_SCALAR, GO_POINTWISE),  & ! scalar
             go_arg(GO_WRITE,     GO_R_SCALAR, GO_POINTWISE),  & ! scalar
             go_arg(GO_READ,      GO_R_SCALAR, GO_POINTWISE),  & ! scalar
             go_Arg(GO_READ,      GO_GRID_DX_CONST)                  &
           /)
     !> This kernel writes only to internal points of the
     !! simulation domain.
     integer :: ITERATES_OVER = GO_ALL_PTS

     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => update_field_code
  end type update_field

contains

  subroutine update_field_code(i, j, a_f, b_f, c_f, d_f, x, y, z, grid_dx)
    integer, intent(in) :: i, j
    real(go_wp), dimension(:,:), intent(inout) :: a_f
    real(go_wp), dimension(:,:), intent(in) :: b_f, c_f, d_f
    real(go_wp), intent(inout) :: x
    real(go_wp), intent(out)   :: y
    real(go_wp), intent(in)    :: z, grid_dx
    integer(kind=8) :: offset

    ! VERY NAUGHTY CODE AHEAD - there be dragon!!
    ! We modify the values of some read-only fields by using offsets
    ! in a write-able field. This will abort if the code is compiled
    ! with array bound check of course.

    ! First, modify z:
    offset = ( loc(z) - loc(a_f(1,1)) ) / sizeof(z)
    a_f(1+offset, 1) = 123.0

    ! Then modify b(1,1)
    offset = ( loc(b_f(1,1)) - loc(a_f(1,1)) ) / sizeof(z)
    a_f(1+offset, 1) = 123.0

  end subroutine update_field_code

end module update_field_mod

!-----------------------------------------------------------------------------
! (C) Crown copyright 2021 Met Office. All rights reserved.
! The file LICENCE, distributed with this code, contains details of the terms
! under which the code may be used.
!-----------------------------------------------------------------------------
!
!> @brief Tangent Linear to the kinetic gradient component of
!>        the rhs of the momentum equation.
!> @details The nonlinear model is:
!>          \f[ \nabla(1/2*u.u) \f]
!>          The tangent linear is:
!>          \f[ \nabla(u . ls_u) \f] where u is the perturbation and
!>          ls_u is the linearisation state.
module tl_kinetic_energy_gradient_kernel_mod

  use argument_mod,      only : arg_type, func_type,       &
                                GH_FIELD, GH_REAL,         &
                                GH_READ, GH_INC,           &
                                ANY_SPACE_9,               &
                                ANY_DISCONTINUOUS_SPACE_3, &
                                GH_BASIS, GH_DIFF_BASIS,   &
                                CELL_COLUMN, GH_QUADRATURE_XYoZ
  use constants_mod,     only : r_def, i_def
  use fs_continuity_mod, only : W2
  use kernel_mod,        only : kernel_type

  implicit none

  private

  !---------------------------------------------------------------------------
  ! Public types
  !---------------------------------------------------------------------------
!> The type declaration for the kernel. Contains the metadata needed by the Psy layer
  type, public, extends(kernel_type) :: tl_kinetic_energy_gradient_kernel_type
    private
    type(arg_type) :: meta_args(5) = (/                                   &
        arg_type(GH_FIELD,   GH_REAL, GH_INC,  W2),                       &
        arg_type(GH_FIELD,   GH_REAL, GH_READ, W2),                       &
        arg_type(GH_FIELD,   GH_REAL, GH_READ, W2),                       &
        arg_type(GH_FIELD*3, GH_REAL, GH_READ, ANY_SPACE_9),              &
        arg_type(GH_FIELD,   GH_REAL, GH_READ, ANY_DISCONTINUOUS_SPACE_3) &
        /)
    type(func_type) :: meta_funcs(2) = (/                 &
        func_type(W2,           GH_BASIS, GH_DIFF_BASIS), &
        func_type(ANY_SPACE_9,  GH_BASIS, GH_DIFF_BASIS)  &
        /)
    integer :: operates_on = CELL_COLUMN
    integer :: gh_shape = GH_QUADRATURE_XYoZ
  contains
    procedure, nopass :: tl_kinetic_energy_gradient_code
  end type

  !---------------------------------------------------------------------------
  ! Contained functions/subroutines
  !---------------------------------------------------------------------------
  public :: tl_kinetic_energy_gradient_code

contains

!> @brief Computes the tangent linear for the kinetic energy gradient.
!! @param[in]    nlayers   Number of layers
!! @param[in,out] r_u      ACTIVE  Change in right hand side of momentum eqn
!! @param[in]    u         ACTIVE  Change in velocity
!! @param[in]    ls_u      Linearisation state velocity
!! @param[in]    chi_1     Physical x coordinate in chi
!! @param[in]    chi_2     Physical y coordinate in chi
!! @param[in]    chi_3     Physical z coordinate in chi
!! @param[in]    panel_id  Field giving the ID for mesh panels.
!! @param[in]    ndf_w2    Number of degrees of freedom per cell for w2
!! @param[in]    undf_w2   Number unique of degrees of freedom  for w2
!! @param[in]    map_w2    Dofmap for the cell at the base of the column for w2
!! @param[in]    w2_basis  Basis functions evaluated at quadrature points
!! @param[in]    w2_diff_basis Differential of basis functions at quadrature pts
!! @param[in]    ndf_chi   Number of degrees of freedom per cell for chi
!! @param[in]    undf_chi  Number unique of degrees of freedom  for chi
!! @param[in]    map_chi   Dofmap for the cell at the base of the column for chi
!! @param[in]    chi_basis Wchi basis functions at quadrature pts
!! @param[in]    chi_diff_basis Differential of basis functions at quad pts
!! @param[in]    ndf_pid   Number of degrees of freedom per cell for panel_id
!! @param[in]    undf_pid  Number of unique degrees of freedom for panel_id
!! @param[in]    map_pid   Dofmap for cell at base of the column for panel_id
!! @param[in]    nqp_h     Number of quadrature points in the horizontal
!! @param[in]    nqp_v     Number of quadrature points in the vertical
!! @param[in]    wqp_h     Horizontal quadrature weights
!! @param[in]    wqp_v     Vertical quadrature weights
subroutine tl_kinetic_energy_gradient_code(nlayers,       &
                                           r_u,           &
                                           u,             &
                                           ls_u,          &
                                           chi_1,         &
                                           chi_2,         &
                                           chi_3,         &
                                           panel_id,      &
                                           ndf_w2,        &
                                           undf_w2,       &
                                           map_w2,        &
                                           w2_basis,      &
                                           w2_diff_basis, &
                                           ndf_chi,       &
                                           undf_chi,      &
                                           map_chi,       &
                                           chi_basis,     &
                                           chi_diff_basis,&
                                           ndf_pid,       &
                                           undf_pid,      &
                                           map_pid,       &
                                           nqp_h,         &
                                           nqp_v,         &
                                           wqp_h,         &
                                           wqp_v          &
                                           )

  use coordinate_jacobian_mod,  only: coordinate_jacobian

  implicit none

  ! Arguments
  integer(kind=i_def), intent(in) :: nlayers, nqp_h, nqp_v
  integer(kind=i_def), intent(in) :: ndf_chi, ndf_w2, ndf_pid
  integer(kind=i_def), intent(in) :: undf_chi, undf_w2, undf_pid
  integer(kind=i_def), dimension(ndf_chi), intent(in) :: map_chi
  integer(kind=i_def), dimension(ndf_w2),  intent(in) :: map_w2
  integer(kind=i_def), dimension(ndf_pid), intent(in) :: map_pid

  real(kind=r_def), dimension(3,ndf_w2,nqp_h,nqp_v), intent(in) :: w2_basis
  real(kind=r_def), dimension(1,ndf_w2,nqp_h,nqp_v), intent(in) :: w2_diff_basis

  real(kind=r_def), dimension(1,ndf_chi,nqp_h,nqp_v), intent(in) :: chi_basis
  real(kind=r_def), dimension(3,ndf_chi,nqp_h,nqp_v), intent(in) :: chi_diff_basis

  real(kind=r_def), dimension(undf_w2),  intent(inout) :: r_u
  real(kind=r_def), dimension(undf_w2),  intent(in)    :: u
  real(kind=r_def), dimension(undf_w2),  intent(in)    :: ls_u
  real(kind=r_def), dimension(undf_chi), intent(in)    :: chi_1, chi_2, chi_3
  real(kind=r_def), dimension(undf_pid), intent(in)    :: panel_id

  real(kind=r_def), dimension(nqp_h), intent(in)      ::  wqp_h
  real(kind=r_def), dimension(nqp_v), intent(in)      ::  wqp_v

  !Internal variables
  integer               :: df, k, loc, ipanel
  integer               :: qp1, qp2

  real(kind=r_def), dimension(ndf_chi)         :: chi_1_e, chi_2_e, chi_3_e
  real(kind=r_def), dimension(nqp_h,nqp_v)     :: dj
  real(kind=r_def), dimension(3,3,nqp_h,nqp_v) :: jac
  real(kind=r_def), dimension(ndf_w2)          :: ru_e, u_e, ls_u_e

  real(kind=r_def) :: ls_u_at_quad(3), u_at_quad(3)
  real(kind=r_def) :: ke_at_quad, dv

  ipanel = int(panel_id(map_pid(1)), i_def)

  do k = 0, nlayers-1

    ! Constants
    do df = 1, ndf_chi
      loc = map_chi(df) + k
      chi_1_e(df) = chi_1( loc )
      chi_2_e(df) = chi_2( loc )
      chi_3_e(df) = chi_3( loc )
    end do
    call coordinate_jacobian(ndf_chi, nqp_h, nqp_v, chi_1_e, chi_2_e, chi_3_e,  &
                             ipanel, chi_basis, chi_diff_basis, jac, dj)

    ! Linearisation state - values at dofs
    do df = 1, ndf_w2
      ls_u_e(df) = ls_u( map_w2(df) + k )
    end do

    ! Perturbation - values at dofs
    do df = 1, ndf_w2
      u_e(df) = u( map_w2(df) + k )
    end do

    do df = 1, ndf_w2
      ru_e(df) = 0.0_r_def
    end do
    do qp2 = 1, nqp_v
      do qp1 = 1, nqp_h

        ! Linearisation state - values at quadrature points
        ls_u_at_quad(:) = 0.0_r_def
        do df = 1, ndf_w2
          ls_u_at_quad(:) = ls_u_at_quad(:) &
                          + ls_u_e(df) * w2_basis(:,df,qp1,qp2)
        end do

        ! Perturbation - values at quadrature points
        u_at_quad(:) = 0.0_r_def
        do df = 1, ndf_w2
          u_at_quad(:) = u_at_quad(:) &
                       + u_e(df) * w2_basis(:,df,qp1,qp2)
        end do

        ! Calculation
        ke_at_quad = dot_product( &
                     matmul( jac(:,:,qp1,qp2), ls_u_at_quad ), &
                     matmul( jac(:,:,qp1,qp2), u_at_quad ) )   &
                     / ( dj(qp1,qp2)**2 )

        do df = 1, ndf_w2
          dv = w2_diff_basis(1,df,qp1,qp2)
          ru_e(df) = ru_e(df) +  wqp_h(qp1) * wqp_v(qp2) * &
                                 dv * ke_at_quad
        end do

      end do ! qp1
    end do   ! qp2

    ! Calculation
    do df = 1, ndf_w2
      r_u( map_w2(df) + k ) =  r_u( map_w2(df) + k ) + ru_e(df)
    end do

  end do ! k

end subroutine tl_kinetic_energy_gradient_code

end module tl_kinetic_energy_gradient_kernel_mod

module infrastructure_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod
  use field_mod
  implicit none

  !> This module is for kernels that implement what will one
  !! day be infrastructure calls. For the moment we provide
  !! these in normal kernel form so that they can be included
  !! in a standard invoke().

  type, extends(kernel_type) :: copy
     type(go_arg), dimension(2) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_EVERY, GO_POINTWISE),     & ! output fld
             go_arg(GO_READ,  GO_EVERY, GO_POINTWISE)      & ! input fld
           /)
     !> This kernel copies a whole field
     integer :: ITERATES_OVER = GO_ALL_PTS

     !> This kernel doesn't care about grids and offsets
     integer :: index_offset = GO_OFFSET_ANY

  contains
    procedure, nopass :: code => field_copy_code
  end type copy

contains

  !===================================================

  subroutine field_copy_code(ji, jj,                     &
                             output, input)
    implicit none
    integer,                  intent(in)  :: ji, jj
    real(go_wp), dimension(:,:), intent(in)  :: input
    real(go_wp), dimension(:,:), intent(out) :: output

    output(ji,jj) = input(ji,jj)

  end subroutine field_copy_code

end module infrastructure_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2019, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: A. R. Porter, STFC Daresbury Lab.
! Modified: S. Siso, STFC Daresbury Laboratory

module kern_use_var_mod
  use argument_mod
  use kernel_mod
  use kind_params_mod
  use grid_mod
  implicit none

  type, extends(kernel_type) :: kern_use_var
     type(go_arg), dimension(1) :: meta_args =              &
          (/ go_arg(GO_READWRITE, GO_CT, GO_POINTWISE) /)
     !> This kernel writes only to internal points of the
     !! simulation domain.
     integer :: ITERATES_OVER = GO_INTERNAL_PTS

     integer :: index_offset = GO_OFFSET_SW

  contains
    procedure, nopass :: code => kern_use_var_code
  end type kern_use_var

contains

  subroutine kern_use_var_code(i, j, fld)
    use data_mod, only: gravity
    integer, intent(in) :: i, j
    real(go_wp), dimension(:,:), intent(inout) :: fld

    fld(i,j) = gravity * fld(i,j)

  end subroutine kern_use_var_code
  
end module kern_use_var_mod

!-----------------------------------------------------------------------------
! Copyright (c) 2017,  Met Office, on behalf of HMSO and Queen's Printer
! For further details please refer to the file LICENCE.original which you
! should have received as part of this distribution.
!-----------------------------------------------------------------------------
!
!-------------------------------------------------------------------------------

module transpose_matrix_vector_kernel_mod

use argument_mod,            only : arg_type,                 &
                                    GH_FIELD, GH_OPERATOR,    &
                                    GH_REAL, GH_READ, GH_INC, &
                                    ANY_SPACE_1, ANY_SPACE_2, &
                                    CELL_COLUMN
use constants_mod,           only : r_def, i_def
use kernel_mod,              only : kernel_type

implicit none

private

!-------------------------------------------------------------------------------
! Public types
!-------------------------------------------------------------------------------

type, public, extends(kernel_type) :: transpose_matrix_vector_kernel_type
  private
  type(arg_type) :: meta_args(3) = (/                                    &
       arg_type(GH_FIELD,    GH_REAL, GH_INC,  ANY_SPACE_1),             &
       arg_type(GH_FIELD,    GH_REAL, GH_READ, ANY_SPACE_2),             &
       arg_type(GH_OPERATOR, GH_REAL, GH_READ, ANY_SPACE_2, ANY_SPACE_1) &
       /)
  integer :: operates_on = CELL_COLUMN
contains
  procedure, nopass :: transpose_matrix_vector_code
end type

!-------------------------------------------------------------------------------
! Contained functions/subroutines
!-------------------------------------------------------------------------------
public :: transpose_matrix_vector_code

contains

!> @brief Computes lhs = matrix^T*x where matrix^T is the transpose of the matrix
!! @param[in] cell Horizontal cell index
!! @param[in] nlayers Number of layers
!! @param[in,out] lhs Output lhs (A^T*x)
!! @param[in] x Input data
!! @param[in] ncell_3d Total number of cells
!! @param[in] matrix Matrix values
!! @param[in] ndf1 Number of degrees of freedom per cell for the output field
!! @param[in] undf1 Unique number of degrees of freedom  for the output field
!! @param[in] map1 Dofmap for the cell at the base of the column for the output field
!! @param[in] ndf2 Number of degrees of freedom per cell for the input field
!! @param[in] undf2 Unique number of degrees of freedom for the input field
!! @param[in] map2 Dofmap for the cell at the base of the column for the input field
subroutine transpose_matrix_vector_code(cell,              &
                                        nlayers,           &
                                        lhs, x,            &
                                        ncell_3d,          &
                                        matrix,            &
                                        ndf1, undf1, map1, &
                                        ndf2, undf2, map2)

  implicit none

  ! Arguments
  integer(kind=i_def),                  intent(in)    :: cell, nlayers, ncell_3d
  integer(kind=i_def),                  intent(in)    :: undf1, ndf1
  integer(kind=i_def),                  intent(in)    :: undf2, ndf2
  integer(kind=i_def), dimension(ndf1), intent(in)    :: map1
  integer(kind=i_def), dimension(ndf2), intent(in)    :: map2
  real(kind=r_def),    dimension(undf2),              intent(in)    :: x
  real(kind=r_def),    dimension(undf1),              intent(inout) :: lhs
  real(kind=r_def),    dimension(ndf2,ndf1,ncell_3d), intent(in)    :: matrix
  real(kind=r_def),    dimension(ndf1,ndf2)           :: transposed_matrix

  ! Internal variables
  integer(kind=i_def)               :: df, k, ik
  real(kind=r_def), dimension(ndf2) :: x_e
  real(kind=r_def), dimension(ndf1) :: lhs_e
  integer :: i,j

  do k = 0, nlayers-1
    do df = 1, ndf2
      x_e(df) = x(map2(df)+k)
    end do
    ik = (cell-1)*nlayers + k + 1
    ! NB: Later versions of the GNU compiler (>= 9.0) appear to have problems
    ! with lhs_e = matmul(transposed(matrix(:,:,ik)),x_e), so to avoid these
    ! issues the local transpose matrix multiplication is performed in two
    ! stages.
    !transposed_matrix(:,:) = transpose(matrix(:,:,ik))
    do j = 1, ndf2
      do i = 1, ndf1
        transposed_matrix(i,j) = matrix(j,i,ik)
      end do
    end do
    lhs_e = matmul(transposed_matrix,x_e)
    do df = 1,ndf1
       lhs(map1(df)+k) = lhs(map1(df)+k) + lhs_e(df)
    end do
  end do

end subroutine transpose_matrix_vector_code

end module transpose_matrix_vector_kernel_mod

  MODULE psy_test
    USE field_mod
    USE kind_params_mod
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(a_fld, b_fld, c_fld, d_fld)
      USE profile_psy_data_mod, ONLY: profile_PSyDataType
      USE init_field_mod, ONLY: init_field_code
      TYPE(r2d_field), intent(inout) :: a_fld
      TYPE(r2d_field), intent(inout) :: b_fld
      TYPE(r2d_field), intent(inout) :: c_fld
      TYPE(r2d_field), intent(inout) :: d_fld
      INTEGER j
      INTEGER i
      TYPE(profile_PSyDataType), save, target :: profile_psy_data

      CALL profile_psy_data % PreStart("invoke_0", "r0", 0, 0)
      DO j = a_fld%whole%ystart, a_fld%whole%ystop, 1
        DO i = a_fld%whole%xstart, a_fld%whole%xstop, 1
          CALL init_field_code(i, j, a_fld%data, 1.0)
        END DO
      END DO
      DO j = b_fld%whole%ystart, b_fld%whole%ystop, 1
        DO i = b_fld%whole%xstart, b_fld%whole%xstop, 1
          CALL init_field_code(i, j, b_fld%data, 2.0)
        END DO
      END DO
      DO j = c_fld%whole%ystart, c_fld%whole%ystop, 1
        DO i = c_fld%whole%xstart, c_fld%whole%xstop, 1
          CALL init_field_code(i, j, c_fld%data, 3.0)
        END DO
      END DO
      DO j = d_fld%whole%ystart, d_fld%whole%ystop, 1
        DO i = d_fld%whole%xstart, d_fld%whole%xstop, 1
          CALL init_field_code(i, j, d_fld%data, 4.0)
        END DO
      END DO
      CALL profile_psy_data % PostEnd

    END SUBROUTINE invoke_0
    SUBROUTINE invoke_1_update_field(a_fld, b_fld, c_fld, d_fld)
      USE profile_psy_data_mod, ONLY: profile_PSyDataType
      USE update_field_mod, ONLY: update_field_code
      TYPE(r2d_field), intent(inout) :: a_fld
      TYPE(r2d_field), intent(inout) :: b_fld
      TYPE(r2d_field), intent(inout) :: c_fld
      TYPE(r2d_field), intent(inout) :: d_fld
      INTEGER j
      INTEGER i
      TYPE(profile_PSyDataType), save, target :: profile_psy_data

      CALL profile_psy_data % PreStart("invoke_1_update_field", "r0", 0, 0)
      DO j = a_fld%whole%ystart, a_fld%whole%ystop, 1
        DO i = a_fld%whole%xstart, a_fld%whole%xstop, 1
          CALL update_field_code(i, j, a_fld%data, b_fld%data, c_fld%data, d_fld%data)
        END DO
      END DO
      CALL profile_psy_data % PostEnd

    END SUBROUTINE invoke_1_update_field
  END MODULE psy_test

  MODULE psy_test
    USE field_mod
    USE kind_params_mod
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_0(a_fld, b_fld, c_fld, d_fld)
      USE read_only_verify_psy_data_mod, ONLY: read_only_verify_PSyDataType
      USE init_field_mod, ONLY: init_field_code
      TYPE(r2d_field), intent(inout) :: a_fld
      TYPE(r2d_field), intent(inout) :: b_fld
      TYPE(r2d_field), intent(inout) :: c_fld
      TYPE(r2d_field), intent(inout) :: d_fld
      INTEGER j
      INTEGER i
      TYPE(read_only_verify_PSyDataType), save, target :: read_only_verify_psy_data

      CALL read_only_verify_psy_data % PreStart("main", "init", 20, 20)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%grid%gphiu", a_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%whole%ystart", b_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%whole%ystop", b_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%whole%xstart", b_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%whole%xstop", b_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%grid%gphiu", b_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%whole%ystart", c_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%whole%ystop", c_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%whole%xstart", c_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%whole%xstop", c_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%grid%gphiu", c_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%whole%ystart", d_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%whole%ystop", d_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%whole%xstart", d_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%whole%xstop", d_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%grid%gphiu", d_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%grid%gphiu", a_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%whole%ystart", b_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%whole%ystop", b_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%whole%xstart", b_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%whole%xstop", b_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%grid%gphiu", b_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%whole%ystart", c_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%whole%ystop", c_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%whole%xstart", c_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%whole%xstop", c_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld%grid%gphiu", c_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%whole%ystart", d_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%whole%ystop", d_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%whole%xstart", d_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%whole%xstop", d_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld%grid%gphiu", d_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreEndDeclaration
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%grid%gphiu", a_fld % grid % gphiu)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%whole%ystart", b_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%whole%ystop", b_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%whole%xstart", b_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%whole%xstop", b_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%grid%gphiu", b_fld % grid % gphiu)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%whole%ystart", c_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%whole%ystop", c_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%whole%xstart", c_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%whole%xstop", c_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%grid%gphiu", c_fld % grid % gphiu)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%whole%ystart", d_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%whole%ystop", d_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%whole%xstart", d_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%whole%xstop", d_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%grid%gphiu", d_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PreEnd
      DO j = a_fld%whole%ystart, a_fld%whole%ystop, 1
        DO i = a_fld%whole%xstart, a_fld%whole%xstop, 1
          CALL init_field_code(i, j, a_fld%data, 1.0, a_fld%grid%gphiu)
        END DO
      END DO
      DO j = b_fld%whole%ystart, b_fld%whole%ystop, 1
        DO i = b_fld%whole%xstart, b_fld%whole%xstop, 1
          CALL init_field_code(i, j, b_fld%data, 2.0, b_fld%grid%gphiu)
        END DO
      END DO
      DO j = c_fld%whole%ystart, c_fld%whole%ystop, 1
        DO i = c_fld%whole%xstart, c_fld%whole%xstop, 1
          CALL init_field_code(i, j, c_fld%data, 3.0, c_fld%grid%gphiu)
        END DO
      END DO
      DO j = d_fld%whole%ystart, d_fld%whole%ystop, 1
        DO i = d_fld%whole%xstart, d_fld%whole%xstop, 1
          CALL init_field_code(i, j, d_fld%data, 4.0, d_fld%grid%gphiu)
        END DO
      END DO
      CALL read_only_verify_psy_data % PostStart
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%grid%gphiu", a_fld % grid % gphiu)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%whole%ystart", b_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%whole%ystop", b_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%whole%xstart", b_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%whole%xstop", b_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%grid%gphiu", b_fld % grid % gphiu)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%whole%ystart", c_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%whole%ystop", c_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%whole%xstart", c_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%whole%xstop", c_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld%grid%gphiu", c_fld % grid % gphiu)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%whole%ystart", d_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%whole%ystop", d_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%whole%xstart", d_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%whole%xstop", d_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld%grid%gphiu", d_fld % grid % gphiu)
      CALL read_only_verify_psy_data % PostEnd

    END SUBROUTINE invoke_0
    SUBROUTINE invoke_1_update_field(a_fld, b_fld, c_fld, d_fld, x, y, z)
      USE read_only_verify_psy_data_mod, ONLY: read_only_verify_PSyDataType
      USE update_field_mod, ONLY: update_field_code
      TYPE(r2d_field), intent(inout) :: a_fld
      TYPE(r2d_field), intent(inout) :: b_fld
      TYPE(r2d_field), intent(inout) :: c_fld
      TYPE(r2d_field), intent(inout) :: d_fld
      REAL(KIND=go_wp), intent(inout) :: x
      REAL(KIND=go_wp), intent(inout) :: y
      REAL(KIND=go_wp), intent(inout) :: z
      INTEGER j
      INTEGER i
      TYPE(read_only_verify_PSyDataType), save, target :: read_only_verify_psy_data

      CALL read_only_verify_psy_data % PreStart("main", "update", 9, 9)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld", b_fld)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld", c_fld)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld", d_fld)
      CALL read_only_verify_psy_data % PreDeclareVariable("z", z)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%grid%dx", b_fld % grid % dx)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL read_only_verify_psy_data % PreDeclareVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld", b_fld)
      CALL read_only_verify_psy_data % PreDeclareVariable("c_fld", c_fld)
      CALL read_only_verify_psy_data % PreDeclareVariable("d_fld", d_fld)
      CALL read_only_verify_psy_data % PreDeclareVariable("z", z)
      CALL read_only_verify_psy_data % PreDeclareVariable("b_fld%grid%dx", b_fld % grid % dx)
      CALL read_only_verify_psy_data % PreEndDeclaration
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld", b_fld)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld", c_fld)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld", d_fld)
      CALL read_only_verify_psy_data % ProvideVariable("z", z)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%grid%dx", b_fld % grid % dx)
      CALL read_only_verify_psy_data % PreEnd
      DO j = a_fld%whole%ystart, a_fld%whole%ystop, 1
        DO i = a_fld%whole%xstart, a_fld%whole%xstop, 1
          CALL update_field_code(i, j, a_fld%data, b_fld%data, c_fld%data, d_fld%data, x, y, z, b_fld%grid%dx)
        END DO
      END DO
      CALL read_only_verify_psy_data % PostStart
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%ystart", a_fld % whole % ystart)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%ystop", a_fld % whole % ystop)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%xstart", a_fld % whole % xstart)
      CALL read_only_verify_psy_data % ProvideVariable("a_fld%whole%xstop", a_fld % whole % xstop)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld", b_fld)
      CALL read_only_verify_psy_data % ProvideVariable("c_fld", c_fld)
      CALL read_only_verify_psy_data % ProvideVariable("d_fld", d_fld)
      CALL read_only_verify_psy_data % ProvideVariable("z", z)
      CALL read_only_verify_psy_data % ProvideVariable("b_fld%grid%dx", b_fld % grid % dx)
      CALL read_only_verify_psy_data % PostEnd

    END SUBROUTINE invoke_1_update_field
  END MODULE psy_test

program main_update
  use extract_psy_data_mod, only : extract_PsyDataType
  use update_field_mod, only : update_field_code
  integer :: i
  integer :: j
  real*8 :: x
  real*8 :: y
  real*8 :: z
  integer :: a_fld_whole_ystart
  integer :: a_fld_whole_ystop
  integer :: a_fld_whole_xstart
  integer :: a_fld_whole_xstop
  real*8, allocatable, dimension(:,:) :: a_fld
  real*8, allocatable, dimension(:,:) :: b_fld
  real*8, allocatable, dimension(:,:) :: c_fld
  real*8, allocatable, dimension(:,:) :: d_fld
  real*8 :: b_fld_grid_dx
  type(extract_PsyDataType) :: extract_psy_data
  real*8, allocatable, dimension(:,:) :: a_fld_post
  integer :: i_post
  integer :: j_post
  real*8 :: x_post
  real*8 :: y_post

  call extract_psy_data%OpenRead('main', 'update')
  call extract_psy_data%ReadVariable('a_fld', a_fld)
  call extract_psy_data%ReadVariable('a_fld_post', a_fld_post)
  call extract_psy_data%ReadVariable('a_fld%whole%xstart', a_fld_whole_xstart)
  call extract_psy_data%ReadVariable('a_fld%whole%xstop', a_fld_whole_xstop)
  call extract_psy_data%ReadVariable('a_fld%whole%ystart', a_fld_whole_ystart)
  call extract_psy_data%ReadVariable('a_fld%whole%ystop', a_fld_whole_ystop)
  call extract_psy_data%ReadVariable('b_fld', b_fld)
  call extract_psy_data%ReadVariable('b_fld%grid%dx', b_fld_grid_dx)
  call extract_psy_data%ReadVariable('c_fld', c_fld)
  call extract_psy_data%ReadVariable('d_fld', d_fld)
  call extract_psy_data%ReadVariable('i_post', i_post)
  i = 0
  call extract_psy_data%ReadVariable('j_post', j_post)
  j = 0
  call extract_psy_data%ReadVariable('x', x)
  call extract_psy_data%ReadVariable('x_post', x_post)
  call extract_psy_data%ReadVariable('y_post', y_post)
  y = 0
  call extract_psy_data%ReadVariable('z', z)
  do j = a_fld_whole_ystart, a_fld_whole_ystop, 1
    do i = a_fld_whole_xstart, a_fld_whole_xstop, 1
      call update_field_code(i, j, a_fld, b_fld, c_fld, d_fld, x, y, z, b_fld_grid_dx)
    enddo
  enddo
  if (ALL(a_fld - a_fld_post == 0.0)) then
    PRINT *, "a_fld correct"
  else
    PRINT *, "a_fld incorrect. Values are:"
    PRINT *, a_fld
    PRINT *, "a_fld values should be:"
    PRINT *, a_fld_post
  end if
  if (i == i_post) then
    PRINT *, "i correct"
  else
    PRINT *, "i incorrect. Values are:"
    PRINT *, i
    PRINT *, "i values should be:"
    PRINT *, i_post
  end if
  if (j == j_post) then
    PRINT *, "j correct"
  else
    PRINT *, "j incorrect. Values are:"
    PRINT *, j
    PRINT *, "j values should be:"
    PRINT *, j_post
  end if
  if (x == x_post) then
    PRINT *, "x correct"
  else
    PRINT *, "x incorrect. Values are:"
    PRINT *, x
    PRINT *, "x values should be:"
    PRINT *, x_post
  end if
  if (y == y_post) then
    PRINT *, "y correct"
  else
    PRINT *, "y incorrect. Values are:"
    PRINT *, y
    PRINT *, "y values should be:"
    PRINT *, y_post
  end if

end program main_update

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2022, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author: R. W. Ford, STFC Daresbury Laboratory

! Example mixed precision kernel supporting 32- and 64- bit
! implementations.

module mixed_kernel_mod

  use argument_mod,      only : arg_type,                         &
                                GH_FIELD, GH_OPERATOR, GH_SCALAR, &
                                GH_REAL, GH_READ, GH_READWRITE,   &
                                CELL_COLUMN
  use fs_continuity_mod, only : W3, W0
  use constants_mod,     only : r_def, i_def
  use kernel_mod,        only : kernel_type

  implicit none

  type, extends(kernel_type) :: mixed_kernel_type
     type(arg_type), dimension(3) :: meta_args =               &
          (/ arg_type(gh_scalar,   gh_real, gh_read),          &
             arg_type(gh_field,    gh_real, gh_readwrite, w3), &
             arg_type(gh_operator, gh_real, gh_read, w0, w0)   &
          /)
     integer :: operates_on = cell_column
  end type mixed_kernel_type

  private
  public :: mixed_kernel_code

  interface mixed_kernel_code
     module procedure mixed_kernel_code_32
     module procedure mixed_kernel_code_64
  end interface mixed_kernel_code

contains

  subroutine mixed_kernel_code_32(cell, nlayers, rscalar, field_w3, op_ncell_3d, op,  &
                           ndf_w3, undf_w3, map_w3, ndf_w0)
    USE constants_mod, ONLY: i_def
    IMPLICIT NONE
    INTEGER(KIND=i_def), intent(in) :: nlayers
    INTEGER(KIND=i_def), intent(in) :: ndf_w3
    INTEGER(KIND=i_def), intent(in), dimension(ndf_w3) :: map_w3
    INTEGER(KIND=i_def), intent(in) :: undf_w3, ndf_w0
    REAL*4,              intent(in) :: rscalar
    REAL*4,              intent(inout), dimension(undf_w3) :: field_w3
    INTEGER(KIND=i_def), intent(in) :: cell
    INTEGER(KIND=i_def), intent(in) :: op_ncell_3d
    REAL*4,              intent(in), dimension(ndf_w0,ndf_w0,op_ncell_3d) :: op
    print *, "32-bit example called"
  end subroutine mixed_kernel_code_32

  subroutine mixed_kernel_code_64(cell, nlayers, rscalar, field_w3, op_ncell_3d, op,  &
                           ndf_w3, undf_w3, map_w3, ndf_w0)
    USE constants_mod, ONLY: i_def
    IMPLICIT NONE
    INTEGER(KIND=i_def), intent(in) :: nlayers
    INTEGER(KIND=i_def), intent(in) :: ndf_w3
    INTEGER(KIND=i_def), intent(in), dimension(ndf_w3) :: map_w3
    INTEGER(KIND=i_def), intent(in) :: undf_w3, ndf_w0
    REAL*8,              intent(in) :: rscalar
    REAL*8,              intent(inout), dimension(undf_w3) :: field_w3
    INTEGER(KIND=i_def), intent(in) :: cell
    INTEGER(KIND=i_def), intent(in) :: op_ncell_3d
    REAL*8,              intent(in), dimension(ndf_w0,ndf_w0,op_ncell_3d) :: op
    print *, "64-bit example called"
  end subroutine mixed_kernel_code_64

end module mixed_kernel_mod

module dg_matrix_vector_kernel_0_mod
  use argument_mod, only : any_discontinuous_space_1, any_space_1, arg_type, cell_column, gh_field, gh_operator, gh_read, gh_real, &
&gh_write
  use constants_mod, only : i_def, r_def
  use kernel_mod, only : kernel_type
  implicit none
  type, public, extends(kernel_type) :: dg_matrix_vector_kernel_type
  PRIVATE
  TYPE(arg_type) :: meta_args(3) = (/arg_type(gh_field, gh_real, gh_readwrite, any_discontinuous_space_1), arg_type(gh_field, &
&gh_real, gh_read, any_space_1), arg_type(gh_operator, gh_real, gh_read, any_discontinuous_space_1, any_space_1)/)
  INTEGER :: operates_on = cell_column
  CONTAINS
  PROCEDURE, NOPASS :: dg_matrix_vector_kernel_0_code
END TYPE dg_matrix_vector_kernel_type
  private

  public :: dg_matrix_vector_kernel_0_code

  contains
  subroutine dg_matrix_vector_kernel_0_code(cell, nlayers_dummy, lhs, x, ncell_3d, matrix, ndf1, undf1, map1, ndf2, undf2, map2)
    integer, parameter :: nlayers = 20
    integer(kind=i_def), intent(in) :: cell
    integer(kind=i_def), intent(in) :: ncell_3d
    integer(kind=i_def), intent(in) :: undf1
    integer(kind=i_def), intent(in) :: ndf1
    integer(kind=i_def), intent(in) :: undf2
    integer(kind=i_def), intent(in) :: ndf2
    integer(kind=i_def), dimension(ndf1), intent(in) :: map1
    integer(kind=i_def), dimension(ndf2), intent(in) :: map2
    real(kind=r_def), dimension(undf2), intent(in) :: x
    real(kind=r_def), dimension(undf1), intent(inout) :: lhs
    real(kind=r_def), dimension(ndf1,ndf2,ncell_3d), intent(in) :: matrix
    integer(kind=i_def), intent(in) :: nlayers_dummy
    integer(kind=i_def) :: df
    integer(kind=i_def) :: k
    integer(kind=i_def) :: ik
    real(kind=r_def), dimension(ndf2) :: x_e
    real(kind=r_def), dimension(ndf1) :: lhs_e

    do k = 0, nlayers - 1, 1
      do df = 1, ndf2, 1
        x_e(df) = x(map2(df) + k)
      enddo
      ik = (cell - 1) * nlayers + k + 1
      lhs_e = MATMUL(matrix(:,:,ik), x_e)
      do df = 1, ndf1, 1
        lhs(map1(df) + k) = lhs_e(df)
      enddo
    enddo

  end subroutine dg_matrix_vector_kernel_0_code

end module dg_matrix_vector_kernel_0_mod

!> \brief Compute the potential vorticity, z
!! \detail Given the current pressure and velocity fields,
!! computes the potential voriticity.
module compute_z_mod
  use kind_params_mod
  use kernel_mod
  use argument_mod
  use grid_mod
  use field_mod
  implicit none

  private

  public invoke_compute_z
  public compute_z, compute_z_code

  type, extends(kernel_type) :: compute_z
     type(go_arg), dimension(6) :: meta_args =    &
          (/ go_arg(GO_WRITE, GO_CF, GO_POINTWISE),        & ! z
             go_arg(GO_READ,  GO_CT, GO_STENCIL(000,110,110)),        & ! p
             go_arg(GO_READ,  GO_CU, GO_STENCIL(000,010,010)),        & ! u
             go_arg(GO_READ,  GO_CV, GO_STENCIL(000,110,000)),        & ! v
             go_arg(GO_READ,  GO_GRID_DX_CONST),           & ! dx
             go_arg(GO_READ,  GO_GRID_DY_CONST)            & ! dy
           /)
     !> This kernel operates on fields that live on an
     !! orthogonal, regular grid.
     integer :: GRID_TYPE = GO_ORTHOGONAL_REGULAR

     !> This kernel writes only to internal points of the
     !! simulation domain.
     integer :: ITERATES_OVER = GO_INTERNAL_PTS
  
     !> Although the staggering of variables used in an Arakawa
     !! C grid is well defined, the way in which they are indexed is
     !! an implementation choice. This can be thought of as choosing
     !! which grid-point types have the same (i,j) index as a T
     !! point. This kernel assumes that the U,V and F points that
     !! share the same index as a given T point are those immediately
     !! to the South and West of it.
     integer :: index_offset = GO_OFFSET_SW

   contains
     procedure, nopass :: code => compute_z_code
  end type compute_z

contains

  !===================================================

  !> Manual implementation of the code needed to invoke
  !! compute_z_code().
  subroutine invoke_compute_z(zfld, pfld, ufld, vfld)
    implicit none
    type(r2d_field), intent(inout) :: zfld
    type(r2d_field), intent(in)    :: pfld, ufld, vfld
    ! Locals
    integer :: I, J
    real(go_wp) :: dx, dy

    dx = zfld%grid%dx
    dy = zfld%grid%dy

    do J=zfld%internal%ystart, zfld%internal%ystop, 1
       do I=zfld%internal%xstart, zfld%internal%xstop, 1

          call compute_z_code(i, j,      &
                              zfld%data, &
                              pfld%data, &
                              ufld%data, &
                              vfld%data, &
                              dx, dy)

       end do
    end do

  end subroutine invoke_compute_z

  !===================================================

  !> Compute the potential vorticity on the grid point (i,j)
  subroutine compute_z_code(i, j, z, p, u, v, dx, dy)
    implicit none
    integer,  intent(in) :: I, J
    real(go_wp), intent(in) :: dx, dy
    real(go_wp), intent(inout), dimension(:,:) :: z
    real(go_wp), intent(in),  dimension(:,:) :: p, u, v

    ! Original code looked like:
    ! DO J=1,N
    !    DO I=1,M
    !       Z(I+1,J+1) =(FSDX*(V(I+1,J+1)-V(I,J+1))-FSDY*(U(I+1,J+1) & 
    !                    -U(I+1,J)))/(P(I,J)+P(I+1,J)+P(I+1,J+1)+P(I,J+1))

    Z(I,J) =( (4.0d0/dx)*( V(I,J)-V(I-1,J))-    &
              (4.0d0/dy)*( U(I,J)-U(I,J-1)) ) / &
            (P(I-1,J-1)+P(I,J-1)+ P(I,J)+P(I-1,J))

  end subroutine compute_z_code

end module compute_z_mod

program adj_test
  use tl_kinetic_energy_gradient_kernel_mod, only : tl_kinetic_energy_gradient_code
  use tl_kinetic_energy_gradient_kernel_mod_adj, only : tl_kinetic_energy_gradient_code_adj
  use constants_mod, only : i_def, r_def
  integer, parameter :: array_extent = 20
  integer(kind=i_def), parameter :: ndf_chi = array_extent
  integer(kind=i_def), parameter :: nqp_v = array_extent
  integer(kind=i_def), parameter :: ndf_w2 = array_extent
  integer(kind=i_def), parameter :: undf_pid = array_extent
  integer(kind=i_def), parameter :: ndf_pid = array_extent
  integer(kind=i_def), parameter :: undf_w2 = array_extent
  integer(kind=i_def), parameter :: undf_chi = array_extent
  integer(kind=i_def), parameter :: nqp_h = array_extent
  real(kind=r_def), parameter :: overall_tolerance = 1500.0_r_def
  real(kind=r_def) :: inner1
  real(kind=r_def) :: inner2
  integer(kind=i_def) :: nlayers
  integer(kind=i_def) :: nlayers_input
  real(kind=r_def), dimension(undf_w2) :: r_u
  real(kind=r_def), dimension(undf_w2) :: r_u_input
  real(kind=r_def), dimension(undf_w2) :: u
  real(kind=r_def), dimension(undf_w2) :: u_input
  real(kind=r_def), dimension(undf_w2) :: ls_u
  real(kind=r_def), dimension(undf_w2) :: ls_u_input
  real(kind=r_def), dimension(undf_chi) :: chi_1
  real(kind=r_def), dimension(undf_chi) :: chi_1_input
  real(kind=r_def), dimension(undf_chi) :: chi_2
  real(kind=r_def), dimension(undf_chi) :: chi_2_input
  real(kind=r_def), dimension(undf_chi) :: chi_3
  real(kind=r_def), dimension(undf_chi) :: chi_3_input
  real(kind=r_def), dimension(undf_pid) :: panel_id
  real(kind=r_def), dimension(undf_pid) :: panel_id_input
  integer(kind=i_def), dimension(ndf_w2) :: map_w2
  integer(kind=i_def), dimension(ndf_w2) :: map_w2_input
  real(kind=r_def), dimension(3,ndf_w2,nqp_h,nqp_v) :: w2_basis
  real(kind=r_def), dimension(3,ndf_w2,nqp_h,nqp_v) :: w2_basis_input
  real(kind=r_def), dimension(1,ndf_w2,nqp_h,nqp_v) :: w2_diff_basis
  real(kind=r_def), dimension(1,ndf_w2,nqp_h,nqp_v) :: w2_diff_basis_input
  integer(kind=i_def), dimension(ndf_chi) :: map_chi
  integer(kind=i_def), dimension(ndf_chi) :: map_chi_input
  real(kind=r_def), dimension(1,ndf_chi,nqp_h,nqp_v) :: chi_basis
  real(kind=r_def), dimension(1,ndf_chi,nqp_h,nqp_v) :: chi_basis_input
  real(kind=r_def), dimension(3,ndf_chi,nqp_h,nqp_v) :: chi_diff_basis
  real(kind=r_def), dimension(3,ndf_chi,nqp_h,nqp_v) :: chi_diff_basis_input
  integer(kind=i_def), dimension(ndf_pid) :: map_pid
  integer(kind=i_def), dimension(ndf_pid) :: map_pid_input
  real(kind=r_def), dimension(nqp_h) :: wqp_h
  real(kind=r_def), dimension(nqp_h) :: wqp_h_input
  real(kind=r_def), dimension(nqp_v) :: wqp_v
  real(kind=r_def), dimension(nqp_v) :: wqp_v_input
  real(kind=r_def) :: MachineTol
  real(kind=r_def) :: relative_diff

  ! Initialise the kernel arguments and keep copies of them
  CALL random_number(nlayers)
  nlayers_input = nlayers
  CALL random_number(r_u)
  r_u_input = r_u
  CALL random_number(u)
  u_input = u
  CALL random_number(ls_u)
  ls_u_input = ls_u
  CALL random_number(chi_1)
  chi_1_input = chi_1
  CALL random_number(chi_2)
  chi_2_input = chi_2
  CALL random_number(chi_3)
  chi_3_input = chi_3
  CALL random_number(panel_id)
  panel_id_input = panel_id
  CALL random_number(map_w2)
  map_w2_input = map_w2
  CALL random_number(w2_basis)
  w2_basis_input = w2_basis
  CALL random_number(w2_diff_basis)
  w2_diff_basis_input = w2_diff_basis
  CALL random_number(map_chi)
  map_chi_input = map_chi
  CALL random_number(chi_basis)
  chi_basis_input = chi_basis
  CALL random_number(chi_diff_basis)
  chi_diff_basis_input = chi_diff_basis
  CALL random_number(map_pid)
  map_pid_input = map_pid
  CALL random_number(wqp_h)
  wqp_h_input = wqp_h
  CALL random_number(wqp_v)
  wqp_v_input = wqp_v
  ! Call the tangent-linear kernel
  call tl_kinetic_energy_gradient_code(nlayers, r_u, u, ls_u, chi_1, chi_2, chi_3, panel_id, ndf_w2, undf_w2, map_w2, w2_basis, w2_diff_basis, ndf_chi, undf_chi, map_chi, chi_basis, chi_diff_basis, ndf_pid, undf_pid, map_pid, nqp_h, nqp_v, wqp_h, wqp_v)
  ! Compute the inner product of the results of the tangent-linear kernel
  inner1 = 0.0_r_def
  inner1 = inner1 + nlayers * nlayers
  inner1 = inner1 + DOT_PRODUCT(r_u, r_u)
  inner1 = inner1 + DOT_PRODUCT(u, u)
  inner1 = inner1 + DOT_PRODUCT(ls_u, ls_u)
  inner1 = inner1 + DOT_PRODUCT(chi_1, chi_1)
  inner1 = inner1 + DOT_PRODUCT(chi_2, chi_2)
  inner1 = inner1 + DOT_PRODUCT(chi_3, chi_3)
  inner1 = inner1 + DOT_PRODUCT(panel_id, panel_id)
  inner1 = inner1 + DOT_PRODUCT(map_w2, map_w2)
  inner1 = inner1 + SUM(w2_basis(:,:,:,:) * w2_basis(:,:,:,:))
  inner1 = inner1 + SUM(w2_diff_basis(:,:,:,:) * w2_diff_basis(:,:,:,:))
  inner1 = inner1 + DOT_PRODUCT(map_chi, map_chi)
  inner1 = inner1 + SUM(chi_basis(:,:,:,:) * chi_basis(:,:,:,:))
  inner1 = inner1 + SUM(chi_diff_basis(:,:,:,:) * chi_diff_basis(:,:,:,:))
  inner1 = inner1 + DOT_PRODUCT(map_pid, map_pid)
  inner1 = inner1 + DOT_PRODUCT(wqp_h, wqp_h)
  inner1 = inner1 + DOT_PRODUCT(wqp_v, wqp_v)
  ! Call the adjoint of the kernel
  call tl_kinetic_energy_gradient_code_adj(nlayers, r_u, u, ls_u, chi_1, chi_2, chi_3, panel_id, ndf_w2, undf_w2, map_w2, w2_basis, w2_diff_basis, ndf_chi, undf_chi, map_chi, chi_basis, chi_diff_basis, ndf_pid, undf_pid, map_pid, nqp_h, nqp_v, wqp_h, wqp_v)
  ! Compute inner product of results of adjoint kernel with the original inputs to the tangent-linear kernel
  inner2 = 0.0_r_def
  inner2 = inner2 + nlayers * nlayers_input
  inner2 = inner2 + DOT_PRODUCT(r_u, r_u_input)
  inner2 = inner2 + DOT_PRODUCT(u, u_input)
  inner2 = inner2 + DOT_PRODUCT(ls_u, ls_u_input)
  inner2 = inner2 + DOT_PRODUCT(chi_1, chi_1_input)
  inner2 = inner2 + DOT_PRODUCT(chi_2, chi_2_input)
  inner2 = inner2 + DOT_PRODUCT(chi_3, chi_3_input)
  inner2 = inner2 + DOT_PRODUCT(panel_id, panel_id_input)
  inner2 = inner2 + DOT_PRODUCT(map_w2, map_w2_input)
  inner2 = inner2 + SUM(w2_basis(:,:,:,:) * w2_basis_input(:,:,:,:))
  inner2 = inner2 + SUM(w2_diff_basis(:,:,:,:) * w2_diff_basis_input(:,:,:,:))
  inner2 = inner2 + DOT_PRODUCT(map_chi, map_chi_input)
  inner2 = inner2 + SUM(chi_basis(:,:,:,:) * chi_basis_input(:,:,:,:))
  inner2 = inner2 + SUM(chi_diff_basis(:,:,:,:) * chi_diff_basis_input(:,:,:,:))
  inner2 = inner2 + DOT_PRODUCT(map_pid, map_pid_input)
  inner2 = inner2 + DOT_PRODUCT(wqp_h, wqp_h_input)
  inner2 = inner2 + DOT_PRODUCT(wqp_v, wqp_v_input)
  ! Test the inner-product values for equality, allowing for the precision of the active variables
  MachineTol = SPACING(MAX(ABS(inner1), ABS(inner2)))
  relative_diff = ABS(inner1 - inner2) / MachineTol
  if (relative_diff < overall_tolerance) then
    WRITE(*, *) 'Test of adjoint of ''tl_kinetic_energy_gradient_code'' PASSED: ', inner1, inner2, relative_diff
  else
    WRITE(*, *) 'Test of adjoint of ''tl_kinetic_energy_gradient_code'' FAILED: ', inner1, inner2, relative_diff
  end if

end program adj_test

  MODULE main_psy
    USE constants_mod, ONLY: r_def, i_def
    USE field_mod, ONLY: field_type, field_proxy_type
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE invoke_initialise_fields(field1, field2)
      TYPE(field_type), intent(in) :: field1, field2
      INTEGER df
      INTEGER(KIND=i_def) loop1_start, loop1_stop
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      TYPE(field_proxy_type) field1_proxy, field2_proxy
      INTEGER(KIND=i_def) undf_aspc1_field1, undf_aspc1_field2
      !
      ! Initialise field and/or operator proxies
      !
      field1_proxy = field1%get_proxy()
      field2_proxy = field2%get_proxy()
      !
      ! Initialise number of DoFs for aspc1_field1
      !
      undf_aspc1_field1 = field1_proxy%vspace%get_undf()
      !
      ! Initialise number of DoFs for aspc1_field2
      !
      undf_aspc1_field2 = field2_proxy%vspace%get_undf()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = undf_aspc1_field1
      loop1_start = 1
      loop1_stop = undf_aspc1_field2
      !
      ! Call our kernels
      !
      DO df=loop0_start,loop0_stop
        field1_proxy%data(df) = 0.0_r_def
      END DO
      DO df=loop1_start,loop1_stop
        field2_proxy%data(df) = 1.0_r_def
      END DO
      !
    END SUBROUTINE invoke_initialise_fields
    SUBROUTINE invoke_testkern_w0(field1, field2)
      USE testkern_w0_kernel_mod, ONLY: testkern_w0_code
      USE extract_psy_data_mod, ONLY: extract_PSyDataType
      TYPE(field_type), intent(in) :: field1, field2
      INTEGER(KIND=i_def) cell
      TYPE(extract_PSyDataType), target, save :: extract_psy_data
      INTEGER(KIND=i_def) loop0_start, loop0_stop
      INTEGER(KIND=i_def) nlayers
      TYPE(field_proxy_type) field1_proxy, field2_proxy
      INTEGER(KIND=i_def), pointer :: map_w0(:,:) => null()
      INTEGER(KIND=i_def) ndf_w0, undf_w0
      !
      ! Initialise field and/or operator proxies
      !
      field1_proxy = field1%get_proxy()
      field2_proxy = field2%get_proxy()
      !
      ! Initialise number of layers
      !
      nlayers = field1_proxy%vspace%get_nlayers()
      !
      ! Look-up dofmaps for each function space
      !
      map_w0 => field1_proxy%vspace%get_whole_dofmap()
      !
      ! Initialise number of DoFs for w0
      !
      ndf_w0 = field1_proxy%vspace%get_ndf()
      undf_w0 = field1_proxy%vspace%get_undf()
      !
      ! Set-up all of the loop bounds
      !
      loop0_start = 1
      loop0_stop = field1_proxy%vspace%get_ncell()
      !
      ! Call our kernels
      !
      !
      ! ExtractStart
      !
      CALL extract_psy_data%PreStart("main", "update", 8, 2)
      CALL extract_psy_data%PreDeclareVariable("field1", field1)
      CALL extract_psy_data%PreDeclareVariable("field2", field2)
      CALL extract_psy_data%PreDeclareVariable("loop0_start", loop0_start)
      CALL extract_psy_data%PreDeclareVariable("loop0_stop", loop0_stop)
      CALL extract_psy_data%PreDeclareVariable("map_w0", map_w0)
      CALL extract_psy_data%PreDeclareVariable("ndf_w0", ndf_w0)
      CALL extract_psy_data%PreDeclareVariable("nlayers", nlayers)
      CALL extract_psy_data%PreDeclareVariable("undf_w0", undf_w0)
      CALL extract_psy_data%PreDeclareVariable("cell_post", cell)
      CALL extract_psy_data%PreDeclareVariable("field1_post", field1)
      CALL extract_psy_data%PreEndDeclaration
      CALL extract_psy_data%ProvideVariable("field1", field1)
      CALL extract_psy_data%ProvideVariable("field2", field2)
      CALL extract_psy_data%ProvideVariable("loop0_start", loop0_start)
      CALL extract_psy_data%ProvideVariable("loop0_stop", loop0_stop)
      CALL extract_psy_data%ProvideVariable("map_w0", map_w0)
      CALL extract_psy_data%ProvideVariable("ndf_w0", ndf_w0)
      CALL extract_psy_data%ProvideVariable("nlayers", nlayers)
      CALL extract_psy_data%ProvideVariable("undf_w0", undf_w0)
      CALL extract_psy_data%PreEnd
      DO cell=loop0_start,loop0_stop
        !
        CALL testkern_w0_code(nlayers, field1_proxy%data, field2_proxy%data, ndf_w0, undf_w0, map_w0(:,cell))
      END DO
      CALL extract_psy_data%PostStart
      CALL extract_psy_data%ProvideVariable("cell_post", cell)
      CALL extract_psy_data%ProvideVariable("field1_post", field1)
      CALL extract_psy_data%PostEnd
      !
      ! ExtractEnd
      !
      !
    END SUBROUTINE invoke_testkern_w0
  END MODULE main_psy

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2018-2021, Science and Technology Facilities Council.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author J. Henrichs, Bureau of Meteorology
! Modified I. Kavcic, Met Office


!> A very simple stand-alone profiling library for PSyclone's
!> profiling API.
module profile_psy_data_mod

  use psy_data_base_mod, only : PSyDataBaseType, profile_PSyDataStart, &
                                profile_PSyDataStop, is_enabled

  implicit none

  !> The datatype to store information about a region.
  type, extends(PSyDataBaseType) :: profile_PSyDataType
     !> Counts how often this region was executed.
     integer                   :: count
     !> Time at whith PreStart was called.
     real(kind=4)              :: start
     !> Overall time spent in this subroutine, i.e. sum
     !> of each individual call.
     real(kind=4)              :: sum_time
     !> Shortest measured time of this region.
     real(kind=4)              :: min_time
     !> Sum Longest measured time of this region.
     real(kind=4)              :: max_time
     !> Inidicates if this structure has been initialised.
     logical                   :: initialised = .false.
  contains
      ! The profiling API uses only the two following calls:
      procedure :: PreStart
      procedure :: PostEnd
  end type profile_PSyDataType

  ! --------------------------------------------------------
  !> In order to store an array of pointers, Fortran requires
  !> a new type *sigh*
  type PSyDataTypePointer
     !> The actual pointer to the data in the user's program.
     type(profile_PSyDataType), pointer :: p
  end  type PSyDataTypePointer
  ! --------------------------------------------------------

  !> Maximum number of regions supported. Additional regions
  !> will be silently ignored.
  integer, parameter :: MAX_DATA = 100

  !> This keeps track of all user data areas.
  type(PSyDataTypePointer), dimension(MAX_DATA) :: all_data

  !> How many entries in all_data have been used
  integer :: used_entries

  !> Keeps track if profile_PSyDataInit has been called.
  logical :: has_been_initialised = .false.

contains

  ! ---------------------------------------------------------------------------
  !> The initialisation subroutine. It is not called directly from
  !> any PSyclone created code, so the user has to manually insert a
  !> call to this subroutine. But the simple timing library will
  !> actually call this function itself if it has not been called previously.
  subroutine profile_PSyDataInit()

    use psy_data_base_mod, only : base_PSyDataInit => profile_PsyDataInit

    implicit none

    call base_PSyDataInit()
    used_entries         = 0
    has_been_initialised = .true.

  end subroutine profile_PSyDataInit

  ! ---------------------------------------------------------------------------
  !> Starts a profiling area. The module and region name can be used to create
  !> a unique name for each region.
  !! Parameters:
  !! @param[in,out] this This PSyData instance.
  !! @param[in] module_name Name of the module in which the region is
  !! @param[in] region_name Name of the region (could be name of an invoke, or
  !!            subroutine name).
  !! @param[in] num_pre_vars The number of variables that are declared and
  !!            written before the instrumented region.
  !! @param[in] num_post_vars The number of variables that are also declared
  !!            before an instrumented region of code, but are written after
  !!            this region.

  subroutine PreStart(this, module_name, region_name, num_pre_vars, &
                      num_post_vars)
    implicit none

    class(profile_PSyDataType), intent(inout), target :: this
    character(len=*), intent(in) :: module_name, region_name
    integer                      :: count, count_rate
    integer, intent(in)          :: num_pre_vars, num_post_vars

    if ( .not. has_been_initialised ) then
       call profile_PSyDataInit()
    endif

    if (.not. is_enabled) return

    call this%PSyDataBaseType%PreStart(module_name, region_name, &
                                       num_pre_vars, num_post_vars)
    ! Note that the actual initialisation of "this"
    ! happens in PostEnd, which is when min_time, sum_time and
    ! max_time are properly initialised
    call system_clock(count, count_rate)
    this%start  = real(count) / count_rate

  end subroutine PreStart

  ! ---------------------------------------------------------------------------
  !> Ends a profiling area. It takes a PSyDataType type that corresponds to
  !> to the PreStart call.
  !> @param[in,out] this: This PSyData instance.
  subroutine PostEnd(this)

    implicit none

    class(profile_PSyDataType), intent(inout), target :: this

    integer :: count, count_rate
    real(kind=4) :: now, duration

    if (.not. is_enabled) return
    call system_clock(count, count_rate)
    now = real(count) / count_rate
    duration = now - this%start

    ! Now initialise the data
    if (.not. this%initialised) then
       this%sum_time    = duration
       this%min_time    = this%sum_time
       this%max_time    = this%sum_time
       this%count       = 1
       this%initialised = .true.

       if (used_entries < MAX_DATA) then
          ! Save a pointer to the profiling data
          used_entries = used_entries + 1
          all_data(used_entries)%p => this
       endif
    else
       this%sum_time = this%sum_time + duration
       if (duration < this%min_time ) this%min_time = duration
       if (duration > this%max_time ) this%max_time = duration
       this%count = this%count + 1
    endif

    call this%PSyDataBaseType%PostEnd()

  end subroutine PostEnd

  ! ---------------------------------------------------------------------------
  !> The finalise function prints the results. This subroutine must be called,
  !> otherwise no results will be printed.
  subroutine profile_PSyDataShutdown()

    use psy_data_base_mod, only : base_PSyDataShutdown => profile_PsyDataShutdown

    implicit none

    integer                    :: i
    integer                    :: max_len, this_len
    type(profile_PSyDataType), pointer :: p
    character                  :: tab = char(9)
    character(:), allocatable  :: heading
    character(:), allocatable  :: spaces

    call base_PSyDataShutdown()
    heading = "module::region"
    ! Determine maximum header length to get proper alignment
    max_len = len(heading)
    do i=1, used_entries
       p => all_data(i)%p    ! To abbreviate code a bit
       if (len(trim(p%module_name)) + len(trim(p%region_name)) > max_len) then
          max_len = len(trim(p%module_name)) + len(trim(p%region_name))
       endif
    enddo

    ! Allow for "::" and one additional space:
    max_len = max_len + 3

    allocate(character(len=max_len) :: spaces)
    do i=1, max_len
       spaces(i:i) = " "
    enddo

    write(*,*)
    write(*,*) "==========================================="
    write(*,*) heading, spaces(1:max_len - len(heading)),                          &
               tab, tab, "count", tab, tab, "sum", tab, tab, tab, "min", tab, tab, &
               "average", tab, tab, tab, "max"
    do i = 1, used_entries
       p => all_data(i)%p    ! To abbreviate code a bit
       this_len = len(trim(p%module_name)) + len(trim(p%region_name))+3
       write(*,*) trim(p%module_name),"::",trim(p%region_name), &
                  spaces(1:max_len-this_len),                   &
                  p%count, tab, p%sum_time, tab,                &
                  p%min_time, tab, p%sum_time/p%count, tab, p%max_time
    end do
    write(*,*) "==========================================="

  end subroutine profile_PSyDataShutdown

end module profile_psy_data_mod

All PSyclone development is coordinated through GitHub Issues and Pull Requests.

Before creating a new Issue, please check that the feature or problem you are considering
is not already discussed in the [User Guide](https://psyclone.readthedocs.io/en/latest) or
[Developers' Guide](https://psyclone-dev.readthedocs.io/en/latest) or covered by the
existing list of [Issues](https://github.com/stfc/PSyclone/issues). If in doubt, please
create a new Issue and give it the `question` label to mark it for attention.

If this is the first time you have performed PSyclone development work then you will
probably want to read the [Getting Going](https://psyclone.readthedocs.io/en/stable/getting_going.html)
section of the User Guide and the [Working with PSyclone from GitHub](https://psyclone-dev.readthedocs.io/en/stable/working_practises.html)
section of the Developers' Guide. You may also find the [Reference Guide](https://psyclone-ref.readthedocs.io/en/latest/index.html)
useful for understanding the overall code structure.

When creating a new Issue, please give it a descriptive title, possibly including the key
component of PSyclone involved in square brackets, e.g. "[PSyIR] Add support for some
arkane Fortran feature". In the description please provide a summary of the problem or the
feature that the Issue is intended to tackle.

During development work please use the Issue to make notes of any design decisions or
problems encountered. Please also tag all commit messages with the Issue number e.g.:

    git commit -m "#111 make an amazing change" some/modified/file.py
    
so that all related commits will show up in the Issue.

PSyclone is written in Python which brings with it a host of benefits. However, Python is
also very flexible and with great flexibility comes great responsibility. The PSyclone
project therefore has fairly strict coding and documentation standards in order to
ensure the robustness and maintainability of the code base. The coding standards are
summarised on the [code-review page](https://github.com/stfc/PSyclone/wiki/CodeReview)
of the GitHub PSyclone wiki. Similarly, the requirements for in-code documentation are
also on the [wiki](https://github.com/stfc/PSyclone/wiki/InterfaceMarkup).
